(in-package :pvs)

(defmethod copy ((obj ir-actual-info) &rest initargs)
  (with-slots (ir-actual-type-defn ir-actual-fun-defn)
    obj
    (make-instance 'ir-actual-info :ir-actual-type-defn
                   (let* ((get1
                           (getf initargs 'ir-actual-type-defn
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :ir-actual-type-defn
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         ir-actual-type-defn
                       getfv))
                   :ir-actual-fun-defn
                   (let* ((get1
                           (getf initargs 'ir-actual-fun-defn
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :ir-actual-fun-defn
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         ir-actual-fun-defn
                       getfv)))))

(defmethod store-object* ((obj ir-actual-info))
  (with-slots (ir-actual-type-defn ir-actual-fun-defn)
    obj
    (reserve-space 3 (push-word (store-obj 'ir-actual-info))
                   (push-word (store-obj ir-actual-type-defn))
                   (push-word (store-obj ir-actual-fun-defn)))))

(defmethod update-fetched ((obj ir-actual-info))
  (with-slots (ir-actual-type-defn ir-actual-fun-defn)
    obj
    (setf ir-actual-type-defn (fetch-obj (stored-word 1)))
    (setf ir-actual-fun-defn (fetch-obj (stored-word 2)))))

(defmethod restore-object* ((obj ir-actual-info))
  (with-slots (ir-actual-type-defn ir-actual-fun-defn)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-actual-type-defn
        (let ((*restore-object-parent-slot* 'ir-actual-type-defn))
          (restore-object* ir-actual-type-defn)))
      (when ir-actual-fun-defn
        (let ((*restore-object-parent-slot* 'ir-actual-fun-defn))
          (restore-object* ir-actual-fun-defn)))
      obj)))

(defmethod copy ((obj c-closure-info) &rest initargs)
  (with-slots (ir-lambda-expr tname tdecl tdefn fdefn mdefn hdefn
                              new-info release-info copy-info)
    obj
    (make-instance 'c-closure-info :ir-lambda-expr
                   (let* ((get1
                           (getf initargs 'ir-lambda-expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-lambda-expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-lambda-expr getfv))
                   :tname
                   (let* ((get1 (getf initargs 'tname '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tname '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tname getfv))
                   :tdecl
                   (let* ((get1 (getf initargs 'tdecl '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tdecl '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tdecl getfv))
                   :tdefn
                   (let* ((get1 (getf initargs 'tdefn '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tdefn '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tdefn getfv))
                   :fdefn
                   (let* ((get1 (getf initargs 'fdefn '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :fdefn '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) fdefn getfv))
                   :mdefn
                   (let* ((get1 (getf initargs 'mdefn '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mdefn '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mdefn getfv))
                   :hdefn
                   (let* ((get1 (getf initargs 'hdefn '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :hdefn '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) hdefn getfv))
                   :new-info
                   (let* ((get1 (getf initargs 'new-info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :new-info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) new-info getfv))
                   :release-info
                   (let* ((get1 (getf initargs 'release-info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :release-info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) release-info getfv))
                   :copy-info
                   (let* ((get1 (getf initargs 'copy-info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :copy-info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) copy-info getfv)))))

(defmethod store-object* ((obj c-closure-info))
  (with-slots (ir-lambda-expr tname tdecl tdefn fdefn mdefn hdefn
                              new-info release-info copy-info)
    obj
    (reserve-space 11 (push-word (store-obj 'c-closure-info))
                   (push-word (store-obj ir-lambda-expr))
                   (push-word (store-obj tname))
                   (push-word (store-obj tdecl))
                   (push-word (store-obj tdefn))
                   (push-word (store-obj fdefn))
                   (push-word (store-obj mdefn))
                   (push-word (store-obj hdefn))
                   (push-word (store-obj new-info))
                   (push-word (store-obj release-info))
                   (push-word (store-obj copy-info)))))

(defmethod update-fetched ((obj c-closure-info))
  (with-slots (ir-lambda-expr tname tdecl tdefn fdefn mdefn hdefn
                              new-info release-info copy-info)
    obj
    (setf ir-lambda-expr (fetch-obj (stored-word 1)))
    (setf tname (fetch-obj (stored-word 2)))
    (setf tdecl (fetch-obj (stored-word 3)))
    (setf tdefn (fetch-obj (stored-word 4)))
    (setf fdefn (fetch-obj (stored-word 5)))
    (setf mdefn (fetch-obj (stored-word 6)))
    (setf hdefn (fetch-obj (stored-word 7)))
    (setf new-info (fetch-obj (stored-word 8)))
    (setf release-info (fetch-obj (stored-word 9)))
    (setf copy-info (fetch-obj (stored-word 10)))))

(defmethod restore-object* ((obj c-closure-info))
  (with-slots (ir-lambda-expr tname tdecl tdefn fdefn mdefn hdefn
                              new-info release-info copy-info)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-lambda-expr
        (let ((*restore-object-parent-slot* 'ir-lambda-expr))
          (restore-object* ir-lambda-expr)))
      (when tname
        (let ((*restore-object-parent-slot* 'tname))
          (restore-object* tname)))
      (when tdecl
        (let ((*restore-object-parent-slot* 'tdecl))
          (restore-object* tdecl)))
      (when tdefn
        (let ((*restore-object-parent-slot* 'tdefn))
          (restore-object* tdefn)))
      (when fdefn
        (let ((*restore-object-parent-slot* 'fdefn))
          (restore-object* fdefn)))
      (when mdefn
        (let ((*restore-object-parent-slot* 'mdefn))
          (restore-object* mdefn)))
      (when hdefn
        (let ((*restore-object-parent-slot* 'hdefn))
          (restore-object* hdefn)))
      (when new-info
        (let ((*restore-object-parent-slot* 'new-info))
          (restore-object* new-info)))
      (when release-info
        (let ((*restore-object-parent-slot* 'release-info))
          (restore-object* release-info)))
      (when copy-info
        (let ((*restore-object-parent-slot* 'copy-info))
          (restore-object* copy-info)))
      obj)))

(defmethod copy ((obj c-type-info) &rest initargs)
  (with-slots (ir-texpr tname tdefn act-defn new-info release-info
                        copy-info equal-info update-info)
    obj
    (make-instance 'c-type-info :ir-texpr
                   (let* ((get1 (getf initargs 'ir-texpr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-texpr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-texpr getfv))
                   :tname
                   (let* ((get1 (getf initargs 'tname '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tname '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tname getfv))
                   :tdefn
                   (let* ((get1 (getf initargs 'tdefn '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tdefn '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tdefn getfv))
                   :act-defn
                   (let* ((get1 (getf initargs 'act-defn '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :act-defn '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) act-defn getfv))
                   :new-info
                   (let* ((get1 (getf initargs 'new-info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :new-info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) new-info getfv))
                   :release-info
                   (let* ((get1 (getf initargs 'release-info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :release-info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) release-info getfv))
                   :copy-info
                   (let* ((get1 (getf initargs 'copy-info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :copy-info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) copy-info getfv))
                   :equal-info
                   (let* ((get1 (getf initargs 'equal-info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :equal-info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) equal-info getfv))
                   :update-info
                   (let* ((get1 (getf initargs 'update-info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :update-info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) update-info getfv)))))

(defmethod store-object* ((obj c-type-info))
  (with-slots (ir-texpr tname tdefn act-defn new-info release-info
                        copy-info equal-info update-info)
    obj
    (reserve-space 10 (push-word (store-obj 'c-type-info))
                   (push-word (store-obj ir-texpr))
                   (push-word (store-obj tname))
                   (push-word (store-obj tdefn))
                   (push-word (store-obj act-defn))
                   (push-word (store-obj new-info))
                   (push-word (store-obj release-info))
                   (push-word (store-obj copy-info))
                   (push-word (store-obj equal-info))
                   (push-word (store-obj update-info)))))

(defmethod update-fetched ((obj c-type-info))
  (with-slots (ir-texpr tname tdefn act-defn new-info release-info
                        copy-info equal-info update-info)
    obj
    (setf ir-texpr (fetch-obj (stored-word 1)))
    (setf tname (fetch-obj (stored-word 2)))
    (setf tdefn (fetch-obj (stored-word 3)))
    (setf act-defn (fetch-obj (stored-word 4)))
    (setf new-info (fetch-obj (stored-word 5)))
    (setf release-info (fetch-obj (stored-word 6)))
    (setf copy-info (fetch-obj (stored-word 7)))
    (setf equal-info (fetch-obj (stored-word 8)))
    (setf update-info (fetch-obj (stored-word 9)))))

(defmethod restore-object* ((obj c-type-info))
  (with-slots (ir-texpr tname tdefn act-defn new-info release-info
                        copy-info equal-info update-info)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-texpr
        (let ((*restore-object-parent-slot* 'ir-texpr))
          (restore-object* ir-texpr)))
      (when tname
        (let ((*restore-object-parent-slot* 'tname))
          (restore-object* tname)))
      (when tdefn
        (let ((*restore-object-parent-slot* 'tdefn))
          (restore-object* tdefn)))
      (when act-defn
        (let ((*restore-object-parent-slot* 'act-defn))
          (restore-object* act-defn)))
      (when new-info
        (let ((*restore-object-parent-slot* 'new-info))
          (restore-object* new-info)))
      (when release-info
        (let ((*restore-object-parent-slot* 'release-info))
          (restore-object* release-info)))
      (when copy-info
        (let ((*restore-object-parent-slot* 'copy-info))
          (restore-object* copy-info)))
      (when equal-info
        (let ((*restore-object-parent-slot* 'equal-info))
          (restore-object* equal-info)))
      (when update-info
        (let ((*restore-object-parent-slot* 'update-info))
          (restore-object* update-info)))
      obj)))

(defmethod copy ((obj closure-c-type-info) &rest initargs)
  (with-slots (ir-texpr tname tdefn act-defn tdecl ftable-type-defn
                        release-info hash-entry-type-defn
                        hash-type-defn copy-info lookup-info
                        dupdate-info update-info)
    obj
    (make-instance 'closure-c-type-info :ir-texpr
                   (let* ((get1 (getf initargs 'ir-texpr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-texpr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-texpr getfv))
                   :tname
                   (let* ((get1 (getf initargs 'tname '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tname '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tname getfv))
                   :tdefn
                   (let* ((get1 (getf initargs 'tdefn '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tdefn '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tdefn getfv))
                   :act-defn
                   (let* ((get1 (getf initargs 'act-defn '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :act-defn '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) act-defn getfv))
                   :tdecl
                   (let* ((get1 (getf initargs 'tdecl '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tdecl '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tdecl getfv))
                   :ftable-type-defn
                   (let* ((get1
                           (getf initargs 'ftable-type-defn '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :ftable-type-defn
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ftable-type-defn getfv))
                   :release-info
                   (let* ((get1 (getf initargs 'release-info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :release-info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) release-info getfv))
                   :hash-entry-type-defn
                   (let* ((get1
                           (getf initargs 'hash-entry-type-defn
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :hash-entry-type-defn
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         hash-entry-type-defn
                       getfv))
                   :hash-type-defn
                   (let* ((get1
                           (getf initargs 'hash-type-defn '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :hash-type-defn '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) hash-type-defn getfv))
                   :copy-info
                   (let* ((get1 (getf initargs 'copy-info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :copy-info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) copy-info getfv))
                   :lookup-info
                   (let* ((get1 (getf initargs 'lookup-info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :lookup-info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) lookup-info getfv))
                   :dupdate-info
                   (let* ((get1 (getf initargs 'dupdate-info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dupdate-info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dupdate-info getfv))
                   :update-info
                   (let* ((get1 (getf initargs 'update-info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :update-info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) update-info getfv)))))

(defmethod store-object* ((obj closure-c-type-info))
  (with-slots (ir-texpr tname tdefn act-defn tdecl ftable-type-defn
                        release-info hash-entry-type-defn
                        hash-type-defn copy-info lookup-info
                        dupdate-info update-info)
    obj
    (reserve-space 14 (push-word (store-obj 'closure-c-type-info))
                   (push-word (store-obj ir-texpr))
                   (push-word (store-obj tname))
                   (push-word (store-obj tdefn))
                   (push-word (store-obj act-defn))
                   (push-word (store-obj tdecl))
                   (push-word (store-obj ftable-type-defn))
                   (push-word (store-obj release-info))
                   (push-word (store-obj hash-entry-type-defn))
                   (push-word (store-obj hash-type-defn))
                   (push-word (store-obj copy-info))
                   (push-word (store-obj lookup-info))
                   (push-word (store-obj dupdate-info))
                   (push-word (store-obj update-info)))))

(defmethod update-fetched ((obj closure-c-type-info))
  (with-slots (ir-texpr tname tdefn act-defn tdecl ftable-type-defn
                        release-info hash-entry-type-defn
                        hash-type-defn copy-info lookup-info
                        dupdate-info update-info)
    obj
    (setf ir-texpr (fetch-obj (stored-word 1)))
    (setf tname (fetch-obj (stored-word 2)))
    (setf tdefn (fetch-obj (stored-word 3)))
    (setf act-defn (fetch-obj (stored-word 4)))
    (setf tdecl (fetch-obj (stored-word 5)))
    (setf ftable-type-defn (fetch-obj (stored-word 6)))
    (setf release-info (fetch-obj (stored-word 7)))
    (setf hash-entry-type-defn (fetch-obj (stored-word 8)))
    (setf hash-type-defn (fetch-obj (stored-word 9)))
    (setf copy-info (fetch-obj (stored-word 10)))
    (setf lookup-info (fetch-obj (stored-word 11)))
    (setf dupdate-info (fetch-obj (stored-word 12)))
    (setf update-info (fetch-obj (stored-word 13)))))

(defmethod restore-object* ((obj closure-c-type-info))
  (with-slots (ir-texpr tname tdefn act-defn tdecl ftable-type-defn
                        release-info hash-entry-type-defn
                        hash-type-defn copy-info lookup-info
                        dupdate-info update-info)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-texpr
        (let ((*restore-object-parent-slot* 'ir-texpr))
          (restore-object* ir-texpr)))
      (when tname
        (let ((*restore-object-parent-slot* 'tname))
          (restore-object* tname)))
      (when tdefn
        (let ((*restore-object-parent-slot* 'tdefn))
          (restore-object* tdefn)))
      (when act-defn
        (let ((*restore-object-parent-slot* 'act-defn))
          (restore-object* act-defn)))
      (when tdecl
        (let ((*restore-object-parent-slot* 'tdecl))
          (restore-object* tdecl)))
      (when ftable-type-defn
        (let ((*restore-object-parent-slot* 'ftable-type-defn))
          (restore-object* ftable-type-defn)))
      (when release-info
        (let ((*restore-object-parent-slot* 'release-info))
          (restore-object* release-info)))
      (when hash-entry-type-defn
        (let ((*restore-object-parent-slot* 'hash-entry-type-defn))
          (restore-object* hash-entry-type-defn)))
      (when hash-type-defn
        (let ((*restore-object-parent-slot* 'hash-type-defn))
          (restore-object* hash-type-defn)))
      (when copy-info
        (let ((*restore-object-parent-slot* 'copy-info))
          (restore-object* copy-info)))
      (when lookup-info
        (let ((*restore-object-parent-slot* 'lookup-info))
          (restore-object* lookup-info)))
      (when dupdate-info
        (let ((*restore-object-parent-slot* 'dupdate-info))
          (restore-object* dupdate-info)))
      (when update-info
        (let ((*restore-object-parent-slot* 'update-info))
          (restore-object* update-info)))
      obj)))

(defmethod copy ((obj simple-c-type-info) &rest initargs)
  (with-slots (ir-texpr tname tdefn act-defn)
    obj
    (make-instance 'simple-c-type-info :ir-texpr
                   (let* ((get1 (getf initargs 'ir-texpr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-texpr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-texpr getfv))
                   :tname
                   (let* ((get1 (getf initargs 'tname '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tname '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tname getfv))
                   :tdefn
                   (let* ((get1 (getf initargs 'tdefn '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tdefn '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tdefn getfv))
                   :act-defn
                   (let* ((get1 (getf initargs 'act-defn '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :act-defn '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) act-defn getfv)))))

(defmethod store-object* ((obj simple-c-type-info))
  (with-slots (ir-texpr tname tdefn act-defn)
    obj
    (reserve-space 5 (push-word (store-obj 'simple-c-type-info))
                   (push-word (store-obj ir-texpr))
                   (push-word (store-obj tname))
                   (push-word (store-obj tdefn))
                   (push-word (store-obj act-defn)))))

(defmethod update-fetched ((obj simple-c-type-info))
  (with-slots (ir-texpr tname tdefn act-defn)
    obj
    (setf ir-texpr (fetch-obj (stored-word 1)))
    (setf tname (fetch-obj (stored-word 2)))
    (setf tdefn (fetch-obj (stored-word 3)))
    (setf act-defn (fetch-obj (stored-word 4)))))

(defmethod restore-object* ((obj simple-c-type-info))
  (with-slots (ir-texpr tname tdefn act-defn)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-texpr
        (let ((*restore-object-parent-slot* 'ir-texpr))
          (restore-object* ir-texpr)))
      (when tname
        (let ((*restore-object-parent-slot* 'tname))
          (restore-object* tname)))
      (when tdefn
        (let ((*restore-object-parent-slot* 'tdefn))
          (restore-object* tdefn)))
      (when act-defn
        (let ((*restore-object-parent-slot* 'act-defn))
          (restore-object* act-defn)))
      obj)))

(defmethod copy ((obj c-defn-info) &rest initargs)
  (with-slots (op-name op-arg-types op-return-type op-header op-defn)
    obj
    (make-instance 'c-defn-info :op-name
                   (let* ((get1 (getf initargs 'op-name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :op-name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) op-name getfv))
                   :op-arg-types
                   (let* ((get1 (getf initargs 'op-arg-types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :op-arg-types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) op-arg-types getfv))
                   :op-return-type
                   (let* ((get1
                           (getf initargs 'op-return-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :op-return-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) op-return-type getfv))
                   :op-header
                   (let* ((get1 (getf initargs 'op-header '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :op-header '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) op-header getfv))
                   :op-defn
                   (let* ((get1 (getf initargs 'op-defn '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :op-defn '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) op-defn getfv)))))

(defmethod store-object* ((obj c-defn-info))
  (with-slots (op-name op-arg-types op-return-type op-header op-defn)
    obj
    (reserve-space 6 (push-word (store-obj 'c-defn-info))
                   (push-word (store-obj op-name))
                   (push-word (store-obj op-arg-types))
                   (push-word (store-obj op-return-type))
                   (push-word (store-obj op-header))
                   (push-word (store-obj op-defn)))))

(defmethod update-fetched ((obj c-defn-info))
  (with-slots (op-name op-arg-types op-return-type op-header op-defn)
    obj
    (setf op-name (fetch-obj (stored-word 1)))
    (setf op-arg-types (fetch-obj (stored-word 2)))
    (setf op-return-type (fetch-obj (stored-word 3)))
    (setf op-header (fetch-obj (stored-word 4)))
    (setf op-defn (fetch-obj (stored-word 5)))))

(defmethod restore-object* ((obj c-defn-info))
  (with-slots (op-name op-arg-types op-return-type op-header op-defn)
    obj
    (let ((*restore-object-parent* obj))
      (when op-name
        (let ((*restore-object-parent-slot* 'op-name))
          (restore-object* op-name)))
      (when op-arg-types
        (let ((*restore-object-parent-slot* 'op-arg-types))
          (restore-object* op-arg-types)))
      (when op-return-type
        (let ((*restore-object-parent-slot* 'op-return-type))
          (restore-object* op-return-type)))
      (when op-header
        (let ((*restore-object-parent-slot* 'op-header))
          (restore-object* op-header)))
      (when op-defn
        (let ((*restore-object-parent-slot* 'op-defn))
          (restore-object* op-defn)))
      obj)))

(defmethod copy ((obj for-instr) &rest initargs)
  (with-slots (for-index for-body)
    obj
    (make-instance 'for-instr :for-index
                   (let* ((get1 (getf initargs 'for-index '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :for-index '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) for-index getfv))
                   :for-body
                   (let* ((get1 (getf initargs 'for-body '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :for-body '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) for-body getfv)))))

(defmethod store-object* ((obj for-instr))
  (with-slots (for-index for-body)
    obj
    (reserve-space 3 (push-word (store-obj 'for-instr))
                   (push-word (store-obj for-index))
                   (push-word (store-obj for-body)))))

(defmethod update-fetched ((obj for-instr))
  (with-slots (for-index for-body)
    obj
    (setf for-index (fetch-obj (stored-word 1)))
    (setf for-body (fetch-obj (stored-word 2)))))

(defmethod restore-object* ((obj for-instr))
  (with-slots (for-index for-body)
    obj
    (let ((*restore-object-parent* obj))
      (when for-index
        (let ((*restore-object-parent-slot* 'for-index))
          (restore-object* for-index)))
      (when for-body
        (let ((*restore-object-parent-slot* 'for-body))
          (restore-object* for-body)))
      obj)))

(defmethod copy ((obj if-instr) &rest initargs)
  (with-slots (if-cond then-instr else-instr)
    obj
    (make-instance 'if-instr :if-cond
                   (let* ((get1 (getf initargs 'if-cond '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :if-cond '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) if-cond getfv))
                   :then-instr
                   (let* ((get1 (getf initargs 'then-instr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :then-instr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) then-instr getfv))
                   :else-instr
                   (let* ((get1 (getf initargs 'else-instr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :else-instr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) else-instr getfv)))))

(defmethod store-object* ((obj if-instr))
  (with-slots (if-cond then-instr else-instr)
    obj
    (reserve-space 4 (push-word (store-obj 'if-instr))
                   (push-word (store-obj if-cond))
                   (push-word (store-obj then-instr))
                   (push-word (store-obj else-instr)))))

(defmethod update-fetched ((obj if-instr))
  (with-slots (if-cond then-instr else-instr)
    obj
    (setf if-cond (fetch-obj (stored-word 1)))
    (setf then-instr (fetch-obj (stored-word 2)))
    (setf else-instr (fetch-obj (stored-word 3)))))

(defmethod restore-object* ((obj if-instr))
  (with-slots (if-cond then-instr else-instr)
    obj
    (let ((*restore-object-parent* obj))
      (when if-cond
        (let ((*restore-object-parent-slot* 'if-cond))
          (restore-object* if-cond)))
      (when then-instr
        (let ((*restore-object-parent-slot* 'then-instr))
          (restore-object* then-instr)))
      (when else-instr
        (let ((*restore-object-parent-slot* 'else-instr))
          (restore-object* else-instr)))
      obj)))

(defmethod copy ((obj ir-release) &rest initargs)
  (with-slots (ir-freevars pre-ir-vars post-ir-vars ir-body)
    obj
    (make-instance 'ir-release :ir-freevars
                   (let* ((get1 (getf initargs 'ir-freevars '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-freevars '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-freevars getfv))
                   :pre-ir-vars
                   (let* ((get1 (getf initargs 'pre-ir-vars '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :pre-ir-vars '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) pre-ir-vars getfv))
                   :post-ir-vars
                   (let* ((get1 (getf initargs 'post-ir-vars '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :post-ir-vars '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) post-ir-vars getfv))
                   :ir-body
                   (let* ((get1 (getf initargs 'ir-body '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-body '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-body getfv)))))

(defmethod store-object* ((obj ir-release))
  (with-slots (pre-ir-vars post-ir-vars ir-body)
    obj
    (reserve-space 4 (push-word (store-obj 'ir-release))
                   (push-word (store-obj pre-ir-vars))
                   (push-word (store-obj post-ir-vars))
                   (push-word (store-obj ir-body)))))

(defmethod update-fetched ((obj ir-release))
  (with-slots (pre-ir-vars post-ir-vars ir-body ir-freevars)
    obj
    (setf pre-ir-vars (fetch-obj (stored-word 1)))
    (setf post-ir-vars (fetch-obj (stored-word 2)))
    (setf ir-body (fetch-obj (stored-word 3)))
    (setf ir-freevars 'unbound)))

(defmethod restore-object* ((obj ir-release))
  (with-slots (pre-ir-vars post-ir-vars ir-body)
    obj
    (let ((*restore-object-parent* obj))
      (when pre-ir-vars
        (let ((*restore-object-parent-slot* 'pre-ir-vars))
          (restore-object* pre-ir-vars)))
      (when post-ir-vars
        (let ((*restore-object-parent-slot* 'post-ir-vars))
          (restore-object* post-ir-vars)))
      (when ir-body
        (let ((*restore-object-parent-slot* 'ir-body))
          (restore-object* ir-body)))
      obj)))

(defmethod copy ((obj ir-last) &rest initargs)
  (with-slots (ir-freevars ir-var)
    obj
    (make-instance 'ir-last :ir-freevars
                   (let* ((get1 (getf initargs 'ir-freevars '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-freevars '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-freevars getfv))
                   :ir-var
                   (let* ((get1 (getf initargs 'ir-var '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-var '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-var getfv)))))

(defmethod store-object* ((obj ir-last))
  (with-slots (ir-var)
    obj
    (reserve-space 2 (push-word (store-obj 'ir-last))
                   (push-word (store-obj ir-var)))))

(defmethod update-fetched ((obj ir-last))
  (with-slots (ir-var ir-freevars)
    obj
    (setf ir-var (fetch-obj (stored-word 1)))
    (setf ir-freevars 'unbound)))

(defmethod restore-object* ((obj ir-last))
  (with-slots (ir-var)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-var
        (let ((*restore-object-parent-slot* 'ir-var))
          (restore-object* ir-var)))
      obj)))

(defmethod copy ((obj ir-formal-const-defn) &rest initargs)
  (with-slots (ir-function-name ir-args ir-return-type ir-defn)
    obj
    (make-instance 'ir-formal-const-defn :ir-function-name
                   (let* ((get1
                           (getf initargs 'ir-function-name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :ir-function-name
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-function-name getfv))
                   :ir-args
                   (let* ((get1 (getf initargs 'ir-args '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-args '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-args getfv))
                   :ir-return-type
                   (let* ((get1
                           (getf initargs 'ir-return-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-return-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-return-type getfv))
                   :ir-defn
                   (let* ((get1 (getf initargs 'ir-defn '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-defn '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-defn getfv)))))

(defmethod store-object* ((obj ir-formal-const-defn))
  (with-slots (ir-function-name ir-args ir-return-type ir-defn)
    obj
    (reserve-space 5 (push-word (store-obj 'ir-formal-const-defn))
                   (push-word (store-obj ir-function-name))
                   (push-word (store-obj ir-args))
                   (push-word (store-obj ir-return-type))
                   (push-word (store-obj ir-defn)))))

(defmethod update-fetched ((obj ir-formal-const-defn))
  (with-slots (ir-function-name ir-args ir-return-type ir-defn)
    obj
    (setf ir-function-name (fetch-obj (stored-word 1)))
    (setf ir-args (fetch-obj (stored-word 2)))
    (setf ir-return-type (fetch-obj (stored-word 3)))
    (setf ir-defn (fetch-obj (stored-word 4)))))

(defmethod restore-object* ((obj ir-formal-const-defn))
  (with-slots (ir-function-name ir-args ir-return-type ir-defn)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-function-name
        (let ((*restore-object-parent-slot* 'ir-function-name))
          (restore-object* ir-function-name)))
      (when ir-args
        (let ((*restore-object-parent-slot* 'ir-args))
          (restore-object* ir-args)))
      (when ir-return-type
        (let ((*restore-object-parent-slot* 'ir-return-type))
          (restore-object* ir-return-type)))
      (when ir-defn
        (let ((*restore-object-parent-slot* 'ir-defn))
          (restore-object* ir-defn)))
      obj)))

(defmethod copy ((obj ir-accessor-defn) &rest initargs)
  (with-slots (ir-function-name ir-args ir-return-type ir-defn
                                ir-update-defn)
    obj
    (make-instance 'ir-accessor-defn :ir-function-name
                   (let* ((get1
                           (getf initargs 'ir-function-name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :ir-function-name
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-function-name getfv))
                   :ir-args
                   (let* ((get1 (getf initargs 'ir-args '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-args '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-args getfv))
                   :ir-return-type
                   (let* ((get1
                           (getf initargs 'ir-return-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-return-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-return-type getfv))
                   :ir-defn
                   (let* ((get1 (getf initargs 'ir-defn '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-defn '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-defn getfv))
                   :ir-update-defn
                   (let* ((get1
                           (getf initargs 'ir-update-defn '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-update-defn '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-update-defn getfv)))))

(defmethod store-object* ((obj ir-accessor-defn))
  (with-slots (ir-function-name ir-args ir-return-type ir-defn
                                ir-update-defn)
    obj
    (reserve-space 6 (push-word (store-obj 'ir-accessor-defn))
                   (push-word (store-obj ir-function-name))
                   (push-word (store-obj ir-args))
                   (push-word (store-obj ir-return-type))
                   (push-word (store-obj ir-defn))
                   (push-word (store-obj ir-update-defn)))))

(defmethod update-fetched ((obj ir-accessor-defn))
  (with-slots (ir-function-name ir-args ir-return-type ir-defn
                                ir-update-defn)
    obj
    (setf ir-function-name (fetch-obj (stored-word 1)))
    (setf ir-args (fetch-obj (stored-word 2)))
    (setf ir-return-type (fetch-obj (stored-word 3)))
    (setf ir-defn (fetch-obj (stored-word 4)))
    (setf ir-update-defn (fetch-obj (stored-word 5)))))

(defmethod restore-object* ((obj ir-accessor-defn))
  (with-slots (ir-function-name ir-args ir-return-type ir-defn
                                ir-update-defn)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-function-name
        (let ((*restore-object-parent-slot* 'ir-function-name))
          (restore-object* ir-function-name)))
      (when ir-args
        (let ((*restore-object-parent-slot* 'ir-args))
          (restore-object* ir-args)))
      (when ir-return-type
        (let ((*restore-object-parent-slot* 'ir-return-type))
          (restore-object* ir-return-type)))
      (when ir-defn
        (let ((*restore-object-parent-slot* 'ir-defn))
          (restore-object* ir-defn)))
      (when ir-update-defn
        (let ((*restore-object-parent-slot* 'ir-update-defn))
          (restore-object* ir-update-defn)))
      obj)))

(defmethod copy ((obj ir-constructor-defn) &rest initargs)
  (with-slots (ir-function-name ir-args ir-return-type ir-defn
                                ir-constructor-type)
    obj
    (make-instance 'ir-constructor-defn :ir-function-name
                   (let* ((get1
                           (getf initargs 'ir-function-name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :ir-function-name
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-function-name getfv))
                   :ir-args
                   (let* ((get1 (getf initargs 'ir-args '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-args '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-args getfv))
                   :ir-return-type
                   (let* ((get1
                           (getf initargs 'ir-return-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-return-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-return-type getfv))
                   :ir-defn
                   (let* ((get1 (getf initargs 'ir-defn '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-defn '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-defn getfv))
                   :ir-constructor-type
                   (let* ((get1
                           (getf initargs 'ir-constructor-type
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :ir-constructor-type
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         ir-constructor-type
                       getfv)))))

(defmethod store-object* ((obj ir-constructor-defn))
  (with-slots (ir-function-name ir-args ir-return-type ir-defn
                                ir-constructor-type)
    obj
    (reserve-space 6 (push-word (store-obj 'ir-constructor-defn))
                   (push-word (store-obj ir-function-name))
                   (push-word (store-obj ir-args))
                   (push-word (store-obj ir-return-type))
                   (push-word (store-obj ir-defn))
                   (push-word (store-obj ir-constructor-type)))))

(defmethod update-fetched ((obj ir-constructor-defn))
  (with-slots (ir-function-name ir-args ir-return-type ir-defn
                                ir-constructor-type)
    obj
    (setf ir-function-name (fetch-obj (stored-word 1)))
    (setf ir-args (fetch-obj (stored-word 2)))
    (setf ir-return-type (fetch-obj (stored-word 3)))
    (setf ir-defn (fetch-obj (stored-word 4)))
    (setf ir-constructor-type (fetch-obj (stored-word 5)))))

(defmethod restore-object* ((obj ir-constructor-defn))
  (with-slots (ir-function-name ir-args ir-return-type ir-defn
                                ir-constructor-type)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-function-name
        (let ((*restore-object-parent-slot* 'ir-function-name))
          (restore-object* ir-function-name)))
      (when ir-args
        (let ((*restore-object-parent-slot* 'ir-args))
          (restore-object* ir-args)))
      (when ir-return-type
        (let ((*restore-object-parent-slot* 'ir-return-type))
          (restore-object* ir-return-type)))
      (when ir-defn
        (let ((*restore-object-parent-slot* 'ir-defn))
          (restore-object* ir-defn)))
      (when ir-constructor-type
        (let ((*restore-object-parent-slot* 'ir-constructor-type))
          (restore-object* ir-constructor-type)))
      obj)))

(defmethod copy ((obj ir-defn) &rest initargs)
  (with-slots (ir-function-name ir-args ir-return-type ir-defn)
    obj
    (make-instance 'ir-defn :ir-function-name
                   (let* ((get1
                           (getf initargs 'ir-function-name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :ir-function-name
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-function-name getfv))
                   :ir-args
                   (let* ((get1 (getf initargs 'ir-args '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-args '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-args getfv))
                   :ir-return-type
                   (let* ((get1
                           (getf initargs 'ir-return-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-return-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-return-type getfv))
                   :ir-defn
                   (let* ((get1 (getf initargs 'ir-defn '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-defn '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-defn getfv)))))

(defmethod store-object* ((obj ir-defn))
  (with-slots (ir-function-name ir-args ir-return-type ir-defn)
    obj
    (reserve-space 5 (push-word (store-obj 'ir-defn))
                   (push-word (store-obj ir-function-name))
                   (push-word (store-obj ir-args))
                   (push-word (store-obj ir-return-type))
                   (push-word (store-obj ir-defn)))))

(defmethod update-fetched ((obj ir-defn))
  (with-slots (ir-function-name ir-args ir-return-type ir-defn)
    obj
    (setf ir-function-name (fetch-obj (stored-word 1)))
    (setf ir-args (fetch-obj (stored-word 2)))
    (setf ir-return-type (fetch-obj (stored-word 3)))
    (setf ir-defn (fetch-obj (stored-word 4)))))

(defmethod restore-object* ((obj ir-defn))
  (with-slots (ir-function-name ir-args ir-return-type ir-defn)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-function-name
        (let ((*restore-object-parent-slot* 'ir-function-name))
          (restore-object* ir-function-name)))
      (when ir-args
        (let ((*restore-object-parent-slot* 'ir-args))
          (restore-object* ir-args)))
      (when ir-return-type
        (let ((*restore-object-parent-slot* 'ir-return-type))
          (restore-object* ir-return-type)))
      (when ir-defn
        (let ((*restore-object-parent-slot* 'ir-defn))
          (restore-object* ir-defn)))
      obj)))

(defmethod copy ((obj formal-const-eval-info) &rest initargs)
  (with-slots (ir cdefn c-type-info-table internal external)
    obj
    (make-instance 'formal-const-eval-info :ir
                   (let* ((get1 (getf initargs 'ir '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir getfv))
                   :cdefn
                   (let* ((get1 (getf initargs 'cdefn '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :cdefn '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) cdefn getfv))
                   :c-type-info-table
                   (let* ((get1
                           (getf initargs 'c-type-info-table '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :c-type-info-table
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) c-type-info-table getfv))
                   :internal
                   (let* ((get1 (getf initargs 'internal '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :internal '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) internal getfv))
                   :external
                   (let* ((get1 (getf initargs 'external '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :external '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) external getfv)))))

(defmethod store-object* ((obj formal-const-eval-info))
  (with-slots (ir cdefn c-type-info-table internal external)
    obj
    (reserve-space 6 (push-word (store-obj 'formal-const-eval-info))
                   (push-word (store-obj ir))
                   (push-word (store-obj cdefn))
                   (push-word (store-obj c-type-info-table))
                   (push-word (store-obj internal))
                   (push-word (store-obj external)))))

(defmethod update-fetched ((obj formal-const-eval-info))
  (with-slots (ir cdefn c-type-info-table internal external)
    obj
    (setf ir (fetch-obj (stored-word 1)))
    (setf cdefn (fetch-obj (stored-word 2)))
    (setf c-type-info-table (fetch-obj (stored-word 3)))
    (setf internal (fetch-obj (stored-word 4)))
    (setf external (fetch-obj (stored-word 5)))))

(defmethod restore-object* ((obj formal-const-eval-info))
  (with-slots (ir cdefn c-type-info-table internal external)
    obj
    (let ((*restore-object-parent* obj))
      (when ir
        (let ((*restore-object-parent-slot* 'ir))
          (restore-object* ir)))
      (when cdefn
        (let ((*restore-object-parent-slot* 'cdefn))
          (restore-object* cdefn)))
      (when c-type-info-table
        (let ((*restore-object-parent-slot* 'c-type-info-table))
          (restore-object* c-type-info-table)))
      (when internal
        (let ((*restore-object-parent-slot* 'internal))
          (restore-object* internal)))
      (when external
        (let ((*restore-object-parent-slot* 'external))
          (restore-object* external)))
      obj)))

(defmethod copy ((obj accessor-eval-info) &rest initargs)
  (with-slots (ir cdefn c-type-info-table internal external
                  update-cdefn)
    obj
    (make-instance 'accessor-eval-info :ir
                   (let* ((get1 (getf initargs 'ir '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir getfv))
                   :cdefn
                   (let* ((get1 (getf initargs 'cdefn '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :cdefn '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) cdefn getfv))
                   :c-type-info-table
                   (let* ((get1
                           (getf initargs 'c-type-info-table '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :c-type-info-table
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) c-type-info-table getfv))
                   :internal
                   (let* ((get1 (getf initargs 'internal '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :internal '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) internal getfv))
                   :external
                   (let* ((get1 (getf initargs 'external '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :external '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) external getfv))
                   :update-cdefn
                   (let* ((get1 (getf initargs 'update-cdefn '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :update-cdefn '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) update-cdefn getfv)))))

(defmethod store-object* ((obj accessor-eval-info))
  (with-slots (ir cdefn c-type-info-table internal external
                  update-cdefn)
    obj
    (reserve-space 7 (push-word (store-obj 'accessor-eval-info))
                   (push-word (store-obj ir))
                   (push-word (store-obj cdefn))
                   (push-word (store-obj c-type-info-table))
                   (push-word (store-obj internal))
                   (push-word (store-obj external))
                   (push-word (store-obj update-cdefn)))))

(defmethod update-fetched ((obj accessor-eval-info))
  (with-slots (ir cdefn c-type-info-table internal external
                  update-cdefn)
    obj
    (setf ir (fetch-obj (stored-word 1)))
    (setf cdefn (fetch-obj (stored-word 2)))
    (setf c-type-info-table (fetch-obj (stored-word 3)))
    (setf internal (fetch-obj (stored-word 4)))
    (setf external (fetch-obj (stored-word 5)))
    (setf update-cdefn (fetch-obj (stored-word 6)))))

(defmethod restore-object* ((obj accessor-eval-info))
  (with-slots (ir cdefn c-type-info-table internal external
                  update-cdefn)
    obj
    (let ((*restore-object-parent* obj))
      (when ir
        (let ((*restore-object-parent-slot* 'ir))
          (restore-object* ir)))
      (when cdefn
        (let ((*restore-object-parent-slot* 'cdefn))
          (restore-object* cdefn)))
      (when c-type-info-table
        (let ((*restore-object-parent-slot* 'c-type-info-table))
          (restore-object* c-type-info-table)))
      (when internal
        (let ((*restore-object-parent-slot* 'internal))
          (restore-object* internal)))
      (when external
        (let ((*restore-object-parent-slot* 'external))
          (restore-object* external)))
      (when update-cdefn
        (let ((*restore-object-parent-slot* 'update-cdefn))
          (restore-object* update-cdefn)))
      obj)))

(defmethod copy ((obj constructor-eval-info) &rest initargs)
  (with-slots (ir cdefn c-type-info-table internal external ctype)
    obj
    (make-instance 'constructor-eval-info :ir
                   (let* ((get1 (getf initargs 'ir '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir getfv))
                   :cdefn
                   (let* ((get1 (getf initargs 'cdefn '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :cdefn '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) cdefn getfv))
                   :c-type-info-table
                   (let* ((get1
                           (getf initargs 'c-type-info-table '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :c-type-info-table
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) c-type-info-table getfv))
                   :internal
                   (let* ((get1 (getf initargs 'internal '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :internal '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) internal getfv))
                   :external
                   (let* ((get1 (getf initargs 'external '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :external '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) external getfv))
                   :ctype
                   (let* ((get1 (getf initargs 'ctype '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ctype '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ctype getfv)))))

(defmethod store-object* ((obj constructor-eval-info))
  (with-slots (ir cdefn c-type-info-table internal external ctype)
    obj
    (reserve-space 7 (push-word (store-obj 'constructor-eval-info))
                   (push-word (store-obj ir))
                   (push-word (store-obj cdefn))
                   (push-word (store-obj c-type-info-table))
                   (push-word (store-obj internal))
                   (push-word (store-obj external))
                   (push-word (store-obj ctype)))))

(defmethod update-fetched ((obj constructor-eval-info))
  (with-slots (ir cdefn c-type-info-table internal external ctype)
    obj
    (setf ir (fetch-obj (stored-word 1)))
    (setf cdefn (fetch-obj (stored-word 2)))
    (setf c-type-info-table (fetch-obj (stored-word 3)))
    (setf internal (fetch-obj (stored-word 4)))
    (setf external (fetch-obj (stored-word 5)))
    (setf ctype (fetch-obj (stored-word 6)))))

(defmethod restore-object* ((obj constructor-eval-info))
  (with-slots (ir cdefn c-type-info-table internal external ctype)
    obj
    (let ((*restore-object-parent* obj))
      (when ir
        (let ((*restore-object-parent-slot* 'ir))
          (restore-object* ir)))
      (when cdefn
        (let ((*restore-object-parent-slot* 'cdefn))
          (restore-object* cdefn)))
      (when c-type-info-table
        (let ((*restore-object-parent-slot* 'c-type-info-table))
          (restore-object* c-type-info-table)))
      (when internal
        (let ((*restore-object-parent-slot* 'internal))
          (restore-object* internal)))
      (when external
        (let ((*restore-object-parent-slot* 'external))
          (restore-object* external)))
      (when ctype
        (let ((*restore-object-parent-slot* 'ctype))
          (restore-object* ctype)))
      obj)))

(defmethod copy ((obj ir-arraytype) &rest initargs)
  (with-slots (size elemtype)
    obj
    (make-instance 'ir-arraytype :size
                   (let* ((get1 (getf initargs 'size '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :size '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) size getfv))
                   :elemtype
                   (let* ((get1 (getf initargs 'elemtype '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :elemtype '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) elemtype getfv)))))

(defmethod store-object* ((obj ir-arraytype))
  (with-slots (size elemtype)
    obj
    (reserve-space 3 (push-word (store-obj 'ir-arraytype))
                   (push-word (store-obj size))
                   (push-word (store-obj elemtype)))))

(defmethod update-fetched ((obj ir-arraytype))
  (with-slots (size elemtype)
    obj
    (setf size (fetch-obj (stored-word 1)))
    (setf elemtype (fetch-obj (stored-word 2)))))

(defmethod restore-object* ((obj ir-arraytype))
  (with-slots (size elemtype)
    obj
    (let ((*restore-object-parent* obj))
      (when size
        (let ((*restore-object-parent-slot* 'size))
          (restore-object* size)))
      (when elemtype
        (let ((*restore-object-parent-slot* 'elemtype))
          (restore-object* elemtype)))
      obj)))

(defmethod copy ((obj ir-adt) &rest initargs)
  (with-slots (ir-adt-name ir-adt-constructors)
    obj
    (make-instance 'ir-adt :ir-adt-name
                   (let* ((get1 (getf initargs 'ir-adt-name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-adt-name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-adt-name getfv))
                   :ir-adt-constructors
                   (let* ((get1
                           (getf initargs 'ir-adt-constructors
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :ir-adt-constructors
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         ir-adt-constructors
                       getfv)))))

(defmethod store-object* ((obj ir-adt))
  (with-slots (ir-adt-name ir-adt-constructors)
    obj
    (reserve-space 3 (push-word (store-obj 'ir-adt))
                   (push-word (store-obj ir-adt-name))
                   (push-word (store-obj ir-adt-constructors)))))

(defmethod update-fetched ((obj ir-adt))
  (with-slots (ir-adt-name ir-adt-constructors)
    obj
    (setf ir-adt-name (fetch-obj (stored-word 1)))
    (setf ir-adt-constructors (fetch-obj (stored-word 2)))))

(defmethod restore-object* ((obj ir-adt))
  (with-slots (ir-adt-name ir-adt-constructors)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-adt-name
        (let ((*restore-object-parent-slot* 'ir-adt-name))
          (restore-object* ir-adt-name)))
      (when ir-adt-constructors
        (let ((*restore-object-parent-slot* 'ir-adt-constructors))
          (restore-object* ir-adt-constructors)))
      obj)))

(defmethod copy ((obj ir-adt-accessor) &rest initargs)
  (with-slots (ir-adt-accessor-id ir-adt-accessor-type)
    obj
    (make-instance 'ir-adt-accessor :ir-adt-accessor-id
                   (let* ((get1
                           (getf initargs 'ir-adt-accessor-id
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :ir-adt-accessor-id
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-adt-accessor-id getfv))
                   :ir-adt-accessor-type
                   (let* ((get1
                           (getf initargs 'ir-adt-accessor-type
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :ir-adt-accessor-type
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         ir-adt-accessor-type
                       getfv)))))

(defmethod store-object* ((obj ir-adt-accessor))
  (with-slots (ir-adt-accessor-id ir-adt-accessor-type)
    obj
    (reserve-space 3 (push-word (store-obj 'ir-adt-accessor))
                   (push-word (store-obj ir-adt-accessor-id))
                   (push-word (store-obj ir-adt-accessor-type)))))

(defmethod update-fetched ((obj ir-adt-accessor))
  (with-slots (ir-adt-accessor-id ir-adt-accessor-type)
    obj
    (setf ir-adt-accessor-id (fetch-obj (stored-word 1)))
    (setf ir-adt-accessor-type (fetch-obj (stored-word 2)))))

(defmethod restore-object* ((obj ir-adt-accessor))
  (with-slots (ir-adt-accessor-id ir-adt-accessor-type)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-adt-accessor-id
        (let ((*restore-object-parent-slot* 'ir-adt-accessor-id))
          (restore-object* ir-adt-accessor-id)))
      (when ir-adt-accessor-type
        (let ((*restore-object-parent-slot* 'ir-adt-accessor-type))
          (restore-object* ir-adt-accessor-type)))
      obj)))

(defmethod copy ((obj ir-adt-constructor) &rest initargs)
  (with-slots (ir-adt-constructor-id ir-adt-constructor-index
                ir-adt-accessors)
    obj
    (make-instance 'ir-adt-constructor :ir-adt-constructor-id
                   (let* ((get1
                           (getf initargs 'ir-adt-constructor-id
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :ir-adt-constructor-id
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         ir-adt-constructor-id
                       getfv))
                   :ir-adt-constructor-index
                   (let* ((get1
                           (getf initargs 'ir-adt-constructor-index
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :ir-adt-constructor-index
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         ir-adt-constructor-index
                       getfv))
                   :ir-adt-accessors
                   (let* ((get1
                           (getf initargs 'ir-adt-accessors '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :ir-adt-accessors
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-adt-accessors getfv)))))

(defmethod store-object* ((obj ir-adt-constructor))
  (with-slots (ir-adt-constructor-id ir-adt-constructor-index
                ir-adt-accessors)
    obj
    (reserve-space 4 (push-word (store-obj 'ir-adt-constructor))
                   (push-word (store-obj ir-adt-constructor-id))
                   (push-word (store-obj ir-adt-constructor-index))
                   (push-word (store-obj ir-adt-accessors)))))

(defmethod update-fetched ((obj ir-adt-constructor))
  (with-slots (ir-adt-constructor-id ir-adt-constructor-index
                ir-adt-accessors)
    obj
    (setf ir-adt-constructor-id (fetch-obj (stored-word 1)))
    (setf ir-adt-constructor-index (fetch-obj (stored-word 2)))
    (setf ir-adt-accessors (fetch-obj (stored-word 3)))))

(defmethod restore-object* ((obj ir-adt-constructor))
  (with-slots (ir-adt-constructor-id ir-adt-constructor-index
                ir-adt-accessors)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-adt-constructor-id
        (let ((*restore-object-parent-slot* 'ir-adt-constructor-id))
          (restore-object* ir-adt-constructor-id)))
      (when ir-adt-constructor-index
        (let ((*restore-object-parent-slot* 'ir-adt-constructor-index))
          (restore-object* ir-adt-constructor-index)))
      (when ir-adt-accessors
        (let ((*restore-object-parent-slot* 'ir-adt-accessors))
          (restore-object* ir-adt-accessors)))
      obj)))

(defmethod copy ((obj ir-subrange) &rest initargs)
  (with-slots (ir-low ir-high ir-low-expr ir-high-expr)
    obj
    (make-instance 'ir-subrange :ir-low
                   (let* ((get1 (getf initargs 'ir-low '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-low '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-low getfv))
                   :ir-high
                   (let* ((get1 (getf initargs 'ir-high '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-high '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-high getfv))
                   :ir-low-expr
                   (let* ((get1 (getf initargs 'ir-low-expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-low-expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-low-expr getfv))
                   :ir-high-expr
                   (let* ((get1 (getf initargs 'ir-high-expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-high-expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-high-expr getfv)))))

(defmethod store-object* ((obj ir-subrange))
  (with-slots (ir-low ir-high ir-low-expr ir-high-expr)
    obj
    (reserve-space 5 (push-word (store-obj 'ir-subrange))
                   (push-word (store-obj ir-low))
                   (push-word (store-obj ir-high))
                   (push-word (store-obj ir-low-expr))
                   (push-word (store-obj ir-high-expr)))))

(defmethod update-fetched ((obj ir-subrange))
  (with-slots (ir-low ir-high ir-low-expr ir-high-expr)
    obj
    (setf ir-low (fetch-obj (stored-word 1)))
    (setf ir-high (fetch-obj (stored-word 2)))
    (setf ir-low-expr (fetch-obj (stored-word 3)))
    (setf ir-high-expr (fetch-obj (stored-word 4)))))

(defmethod restore-object* ((obj ir-subrange))
  (with-slots (ir-low ir-high ir-low-expr ir-high-expr)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-low
        (let ((*restore-object-parent-slot* 'ir-low))
          (restore-object* ir-low)))
      (when ir-high
        (let ((*restore-object-parent-slot* 'ir-high))
          (restore-object* ir-high)))
      (when ir-low-expr
        (let ((*restore-object-parent-slot* 'ir-low-expr))
          (restore-object* ir-low-expr)))
      (when ir-high-expr
        (let ((*restore-object-parent-slot* 'ir-high-expr))
          (restore-object* ir-high-expr)))
      obj)))

(defmethod copy ((obj ir-funtype) &rest initargs)
  (with-slots (ir-domain ir-range)
    obj
    (make-instance 'ir-funtype :ir-domain
                   (let* ((get1 (getf initargs 'ir-domain '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-domain '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-domain getfv))
                   :ir-range
                   (let* ((get1 (getf initargs 'ir-range '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-range '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-range getfv)))))

(defmethod store-object* ((obj ir-funtype))
  (with-slots (ir-domain ir-range)
    obj
    (reserve-space 3 (push-word (store-obj 'ir-funtype))
                   (push-word (store-obj ir-domain))
                   (push-word (store-obj ir-range)))))

(defmethod update-fetched ((obj ir-funtype))
  (with-slots (ir-domain ir-range)
    obj
    (setf ir-domain (fetch-obj (stored-word 1)))
    (setf ir-range (fetch-obj (stored-word 2)))))

(defmethod restore-object* ((obj ir-funtype))
  (with-slots (ir-domain ir-range)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-domain
        (let ((*restore-object-parent-slot* 'ir-domain))
          (restore-object* ir-domain)))
      (when ir-range
        (let ((*restore-object-parent-slot* 'ir-range))
          (restore-object* ir-range)))
      obj)))

(defmethod copy ((obj ir-fieldtype) &rest initargs)
  (with-slots (ir-id ir-ftype)
    obj
    (make-instance 'ir-fieldtype :ir-id
                   (let* ((get1 (getf initargs 'ir-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-id getfv))
                   :ir-ftype
                   (let* ((get1 (getf initargs 'ir-ftype '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-ftype '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-ftype getfv)))))

(defmethod store-object* ((obj ir-fieldtype))
  (with-slots (ir-id ir-ftype)
    obj
    (reserve-space 3 (push-word (store-obj 'ir-fieldtype))
                   (push-word (store-obj ir-id))
                   (push-word (store-obj ir-ftype)))))

(defmethod update-fetched ((obj ir-fieldtype))
  (with-slots (ir-id ir-ftype)
    obj
    (setf ir-id (fetch-obj (stored-word 1)))
    (setf ir-ftype (fetch-obj (stored-word 2)))))

(defmethod restore-object* ((obj ir-fieldtype))
  (with-slots (ir-id ir-ftype)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-id
        (let ((*restore-object-parent-slot* 'ir-id))
          (restore-object* ir-id)))
      (when ir-ftype
        (let ((*restore-object-parent-slot* 'ir-ftype))
          (restore-object* ir-ftype)))
      obj)))

(defmethod copy ((obj ir-adt-constructor-recordtype) &rest initargs)
  (with-slots (ir-field-types ir-adt-name)
    obj
    (make-instance 'ir-adt-constructor-recordtype :ir-field-types
                   (let* ((get1
                           (getf initargs 'ir-field-types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-field-types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-field-types getfv))
                   :ir-adt-name
                   (let* ((get1 (getf initargs 'ir-adt-name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-adt-name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-adt-name getfv)))))

(defmethod store-object* ((obj ir-adt-constructor-recordtype))
  (with-slots (ir-field-types ir-adt-name)
    obj
    (reserve-space 3
                   (push-word (store-obj 'ir-adt-constructor-recordtype))
                   (push-word (store-obj ir-field-types))
                   (push-word (store-obj ir-adt-name)))))

(defmethod update-fetched ((obj ir-adt-constructor-recordtype))
  (with-slots (ir-field-types ir-adt-name)
    obj
    (setf ir-field-types (fetch-obj (stored-word 1)))
    (setf ir-adt-name (fetch-obj (stored-word 2)))))

(defmethod restore-object* ((obj ir-adt-constructor-recordtype))
  (with-slots (ir-field-types ir-adt-name)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-field-types
        (let ((*restore-object-parent-slot* 'ir-field-types))
          (restore-object* ir-field-types)))
      (when ir-adt-name
        (let ((*restore-object-parent-slot* 'ir-adt-name))
          (restore-object* ir-adt-name)))
      obj)))

(defmethod copy ((obj ir-adt-recordtype) &rest initargs)
  (with-slots (ir-field-types ir-constructors)
    obj
    (make-instance 'ir-adt-recordtype :ir-field-types
                   (let* ((get1
                           (getf initargs 'ir-field-types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-field-types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-field-types getfv))
                   :ir-constructors
                   (let* ((get1
                           (getf initargs 'ir-constructors '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :ir-constructors
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-constructors getfv)))))

(defmethod store-object* ((obj ir-adt-recordtype))
  (with-slots (ir-field-types ir-constructors)
    obj
    (reserve-space 3 (push-word (store-obj 'ir-adt-recordtype))
                   (push-word (store-obj ir-field-types))
                   (push-word (store-obj ir-constructors)))))

(defmethod update-fetched ((obj ir-adt-recordtype))
  (with-slots (ir-field-types ir-constructors)
    obj
    (setf ir-field-types (fetch-obj (stored-word 1)))
    (setf ir-constructors (fetch-obj (stored-word 2)))))

(defmethod restore-object* ((obj ir-adt-recordtype))
  (with-slots (ir-field-types ir-constructors)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-field-types
        (let ((*restore-object-parent-slot* 'ir-field-types))
          (restore-object* ir-field-types)))
      (when ir-constructors
        (let ((*restore-object-parent-slot* 'ir-constructors))
          (restore-object* ir-constructors)))
      obj)))

(defmethod copy ((obj ir-tupletype) &rest initargs)
  (with-slots (ir-field-types)
    obj
    (make-instance 'ir-tupletype :ir-field-types
                   (let* ((get1
                           (getf initargs 'ir-field-types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-field-types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-field-types getfv)))))

(defmethod store-object* ((obj ir-tupletype))
  (with-slots (ir-field-types)
    obj
    (reserve-space 2 (push-word (store-obj 'ir-tupletype))
                   (push-word (store-obj ir-field-types)))))

(defmethod update-fetched ((obj ir-tupletype))
  (with-slots (ir-field-types)
    obj
    (setf ir-field-types (fetch-obj (stored-word 1)))))

(defmethod restore-object* ((obj ir-tupletype))
  (with-slots (ir-field-types)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-field-types
        (let ((*restore-object-parent-slot* 'ir-field-types))
          (restore-object* ir-field-types)))
      obj)))

(defmethod copy ((obj ir-recordtype) &rest initargs)
  (with-slots (ir-field-types)
    obj
    (make-instance 'ir-recordtype :ir-field-types
                   (let* ((get1
                           (getf initargs 'ir-field-types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-field-types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-field-types getfv)))))

(defmethod store-object* ((obj ir-recordtype))
  (with-slots (ir-field-types)
    obj
    (reserve-space 2 (push-word (store-obj 'ir-recordtype))
                   (push-word (store-obj ir-field-types)))))

(defmethod update-fetched ((obj ir-recordtype))
  (with-slots (ir-field-types)
    obj
    (setf ir-field-types (fetch-obj (stored-word 1)))))

(defmethod restore-object* ((obj ir-recordtype))
  (with-slots (ir-field-types)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-field-types
        (let ((*restore-object-parent-slot* 'ir-field-types))
          (restore-object* ir-field-types)))
      obj)))

(defmethod copy ((obj ir-formal-typename) &rest initargs)
  (with-slots (ir-type-id ir-type-defn)
    obj
    (make-instance 'ir-formal-typename :ir-type-id
                   (let* ((get1 (getf initargs 'ir-type-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-type-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-type-id getfv))
                   :ir-type-defn
                   (let* ((get1 (getf initargs 'ir-type-defn '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-type-defn '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-type-defn getfv)))))

(defmethod store-object* ((obj ir-formal-typename))
  (with-slots (ir-type-id ir-type-defn)
    obj
    (reserve-space 3 (push-word (store-obj 'ir-formal-typename))
                   (push-word (store-obj ir-type-id))
                   (push-word (store-obj ir-type-defn)))))

(defmethod update-fetched ((obj ir-formal-typename))
  (with-slots (ir-type-id ir-type-defn)
    obj
    (setf ir-type-id (fetch-obj (stored-word 1)))
    (setf ir-type-defn (fetch-obj (stored-word 2)))))

(defmethod restore-object* ((obj ir-formal-typename))
  (with-slots (ir-type-id ir-type-defn)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-type-id
        (let ((*restore-object-parent-slot* 'ir-type-id))
          (restore-object* ir-type-id)))
      (when ir-type-defn
        (let ((*restore-object-parent-slot* 'ir-type-defn))
          (restore-object* ir-type-defn)))
      obj)))

(defmethod copy ((obj ir-typename) &rest initargs)
  (with-slots (ir-type-id ir-type-defn)
    obj
    (make-instance 'ir-typename :ir-type-id
                   (let* ((get1 (getf initargs 'ir-type-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-type-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-type-id getfv))
                   :ir-type-defn
                   (let* ((get1 (getf initargs 'ir-type-defn '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-type-defn '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-type-defn getfv)))))

(defmethod store-object* ((obj ir-typename))
  (with-slots (ir-type-id ir-type-defn)
    obj
    (reserve-space 3 (push-word (store-obj 'ir-typename))
                   (push-word (store-obj ir-type-id))
                   (push-word (store-obj ir-type-defn)))))

(defmethod update-fetched ((obj ir-typename))
  (with-slots (ir-type-id ir-type-defn)
    obj
    (setf ir-type-id (fetch-obj (stored-word 1)))
    (setf ir-type-defn (fetch-obj (stored-word 2)))))

(defmethod restore-object* ((obj ir-typename))
  (with-slots (ir-type-id ir-type-defn)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-type-id
        (let ((*restore-object-parent-slot* 'ir-type-id))
          (restore-object* ir-type-id)))
      (when ir-type-defn
        (let ((*restore-object-parent-slot* 'ir-type-defn))
          (restore-object* ir-type-defn)))
      obj)))

(defmethod copy ((obj ir-actuals) &rest initargs)
  (with-slots (ir-actuals-list)
    obj
    (make-instance 'ir-actuals :ir-actuals-list
                   (let* ((get1
                           (getf initargs 'ir-actuals-list '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :ir-actuals-list
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-actuals-list getfv)))))

(defmethod store-object* ((obj ir-actuals))
  (with-slots (ir-actuals-list)
    obj
    (reserve-space 2 (push-word (store-obj 'ir-actuals))
                   (push-word (store-obj ir-actuals-list)))))

(defmethod update-fetched ((obj ir-actuals))
  (with-slots (ir-actuals-list)
    obj
    (setf ir-actuals-list (fetch-obj (stored-word 1)))))

(defmethod restore-object* ((obj ir-actuals))
  (with-slots (ir-actuals-list)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-actuals-list
        (let ((*restore-object-parent-slot* 'ir-actuals-list))
          (restore-object* ir-actuals-list)))
      obj)))

(defmethod copy ((obj ir-type-actual) &rest initargs)
  (with-slots (ir-actual-type)
    obj
    (make-instance 'ir-type-actual :ir-actual-type
                   (let* ((get1
                           (getf initargs 'ir-actual-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-actual-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-actual-type getfv)))))

(defmethod store-object* ((obj ir-type-actual))
  (with-slots (ir-actual-type)
    obj
    (reserve-space 2 (push-word (store-obj 'ir-type-actual))
                   (push-word (store-obj ir-actual-type)))))

(defmethod update-fetched ((obj ir-type-actual))
  (with-slots (ir-actual-type)
    obj
    (setf ir-actual-type (fetch-obj (stored-word 1)))))

(defmethod restore-object* ((obj ir-type-actual))
  (with-slots (ir-actual-type)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-actual-type
        (let ((*restore-object-parent-slot* 'ir-actual-type))
          (restore-object* ir-actual-type)))
      obj)))

(defmethod copy ((obj ir-const-actual) &rest initargs)
  (with-slots (ir-freevars ir-actual-expr)
    obj
    (make-instance 'ir-const-actual :ir-freevars
                   (let* ((get1 (getf initargs 'ir-freevars '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-freevars '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-freevars getfv))
                   :ir-actual-expr
                   (let* ((get1
                           (getf initargs 'ir-actual-expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-actual-expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-actual-expr getfv)))))

(defmethod store-object* ((obj ir-const-actual))
  (with-slots (ir-actual-expr)
    obj
    (reserve-space 2 (push-word (store-obj 'ir-const-actual))
                   (push-word (store-obj ir-actual-expr)))))

(defmethod update-fetched ((obj ir-const-actual))
  (with-slots (ir-actual-expr ir-freevars)
    obj
    (setf ir-actual-expr (fetch-obj (stored-word 1)))
    (setf ir-freevars 'unbound)))

(defmethod restore-object* ((obj ir-const-actual))
  (with-slots (ir-actual-expr)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-actual-expr
        (let ((*restore-object-parent-slot* 'ir-actual-expr))
          (restore-object* ir-actual-expr)))
      obj)))

(defmethod copy ((obj ir-get) &rest initargs)
  (with-slots (ir-freevars ir-record ir-field)
    obj
    (make-instance 'ir-get :ir-freevars
                   (let* ((get1 (getf initargs 'ir-freevars '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-freevars '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-freevars getfv))
                   :ir-record
                   (let* ((get1 (getf initargs 'ir-record '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-record '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-record getfv))
                   :ir-field
                   (let* ((get1 (getf initargs 'ir-field '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-field '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-field getfv)))))

(defmethod store-object* ((obj ir-get))
  (with-slots (ir-record ir-field)
    obj
    (reserve-space 3 (push-word (store-obj 'ir-get))
                   (push-word (store-obj ir-record))
                   (push-word (store-obj ir-field)))))

(defmethod update-fetched ((obj ir-get))
  (with-slots (ir-record ir-field ir-freevars)
    obj
    (setf ir-record (fetch-obj (stored-word 1)))
    (setf ir-field (fetch-obj (stored-word 2)))
    (setf ir-freevars 'unbound)))

(defmethod restore-object* ((obj ir-get))
  (with-slots (ir-record ir-field)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-record
        (let ((*restore-object-parent-slot* 'ir-record))
          (restore-object* ir-record)))
      (when ir-field
        (let ((*restore-object-parent-slot* 'ir-field))
          (restore-object* ir-field)))
      obj)))

(defmethod copy ((obj ir-new) &rest initargs)
  (with-slots (ir-freevars ir-size ir-etype)
    obj
    (make-instance 'ir-new :ir-freevars
                   (let* ((get1 (getf initargs 'ir-freevars '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-freevars '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-freevars getfv))
                   :ir-size
                   (let* ((get1 (getf initargs 'ir-size '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-size '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-size getfv))
                   :ir-etype
                   (let* ((get1 (getf initargs 'ir-etype '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-etype '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-etype getfv)))))

(defmethod store-object* ((obj ir-new))
  (with-slots (ir-size ir-etype)
    obj
    (reserve-space 3 (push-word (store-obj 'ir-new))
                   (push-word (store-obj ir-size))
                   (push-word (store-obj ir-etype)))))

(defmethod update-fetched ((obj ir-new))
  (with-slots (ir-size ir-etype ir-freevars)
    obj
    (setf ir-size (fetch-obj (stored-word 1)))
    (setf ir-etype (fetch-obj (stored-word 2)))
    (setf ir-freevars 'unbound)))

(defmethod restore-object* ((obj ir-new))
  (with-slots (ir-size ir-etype)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-size
        (let ((*restore-object-parent-slot* 'ir-size))
          (restore-object* ir-size)))
      (when ir-etype
        (let ((*restore-object-parent-slot* 'ir-etype))
          (restore-object* ir-etype)))
      obj)))

(defmethod copy ((obj ir-constructor-update) &rest initargs)
  (with-slots (ir-freevars ir-target ir-lhs ir-rhs)
    obj
    (make-instance 'ir-constructor-update :ir-freevars
                   (let* ((get1 (getf initargs 'ir-freevars '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-freevars '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-freevars getfv))
                   :ir-target
                   (let* ((get1 (getf initargs 'ir-target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-target getfv))
                   :ir-lhs
                   (let* ((get1 (getf initargs 'ir-lhs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-lhs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-lhs getfv))
                   :ir-rhs
                   (let* ((get1 (getf initargs 'ir-rhs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-rhs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-rhs getfv)))))

(defmethod store-object* ((obj ir-constructor-update))
  (with-slots (ir-target ir-lhs ir-rhs)
    obj
    (reserve-space 4 (push-word (store-obj 'ir-constructor-update))
                   (push-word (store-obj ir-target))
                   (push-word (store-obj ir-lhs))
                   (push-word (store-obj ir-rhs)))))

(defmethod update-fetched ((obj ir-constructor-update))
  (with-slots (ir-target ir-lhs ir-rhs ir-freevars)
    obj
    (setf ir-target (fetch-obj (stored-word 1)))
    (setf ir-lhs (fetch-obj (stored-word 2)))
    (setf ir-rhs (fetch-obj (stored-word 3)))
    (setf ir-freevars 'unbound)))

(defmethod restore-object* ((obj ir-constructor-update))
  (with-slots (ir-target ir-lhs ir-rhs)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-target
        (let ((*restore-object-parent-slot* 'ir-target))
          (restore-object* ir-target)))
      (when ir-lhs
        (let ((*restore-object-parent-slot* 'ir-lhs))
          (restore-object* ir-lhs)))
      (when ir-rhs
        (let ((*restore-object-parent-slot* 'ir-rhs))
          (restore-object* ir-rhs)))
      obj)))

(defmethod copy ((obj ir-const-formal) &rest initargs)
  (with-slots (ir-freevars ir-name ir-vtype ir-pvsid)
    obj
    (make-instance 'ir-const-formal :ir-freevars
                   (let* ((get1 (getf initargs 'ir-freevars '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-freevars '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-freevars getfv))
                   :ir-name
                   (let* ((get1 (getf initargs 'ir-name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-name getfv))
                   :ir-vtype
                   (let* ((get1 (getf initargs 'ir-vtype '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-vtype '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-vtype getfv))
                   :ir-pvsid
                   (let* ((get1 (getf initargs 'ir-pvsid '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-pvsid '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-pvsid getfv)))))

(defmethod store-object* ((obj ir-const-formal))
  (with-slots (ir-name ir-vtype ir-pvsid)
    obj
    (reserve-space 4 (push-word (store-obj 'ir-const-formal))
                   (push-word (store-obj ir-name))
                   (push-word (store-obj ir-vtype))
                   (push-word (store-obj ir-pvsid)))))

(defmethod update-fetched ((obj ir-const-formal))
  (with-slots (ir-name ir-vtype ir-pvsid ir-freevars)
    obj
    (setf ir-name (fetch-obj (stored-word 1)))
    (setf ir-vtype (fetch-obj (stored-word 2)))
    (setf ir-pvsid (fetch-obj (stored-word 3)))
    (setf ir-freevars 'unbound)))

(defmethod restore-object* ((obj ir-const-formal))
  (with-slots (ir-name ir-vtype ir-pvsid)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-name
        (let ((*restore-object-parent-slot* 'ir-name))
          (restore-object* ir-name)))
      (when ir-vtype
        (let ((*restore-object-parent-slot* 'ir-vtype))
          (restore-object* ir-vtype)))
      (when ir-pvsid
        (let ((*restore-object-parent-slot* 'ir-pvsid))
          (restore-object* ir-pvsid)))
      obj)))

(defmethod copy ((obj ir-update) &rest initargs)
  (with-slots (ir-freevars ir-target ir-lhs ir-rhs)
    obj
    (make-instance 'ir-update :ir-freevars
                   (let* ((get1 (getf initargs 'ir-freevars '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-freevars '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-freevars getfv))
                   :ir-target
                   (let* ((get1 (getf initargs 'ir-target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-target getfv))
                   :ir-lhs
                   (let* ((get1 (getf initargs 'ir-lhs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-lhs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-lhs getfv))
                   :ir-rhs
                   (let* ((get1 (getf initargs 'ir-rhs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-rhs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-rhs getfv)))))

(defmethod store-object* ((obj ir-update))
  (with-slots (ir-target ir-lhs ir-rhs)
    obj
    (reserve-space 4 (push-word (store-obj 'ir-update))
                   (push-word (store-obj ir-target))
                   (push-word (store-obj ir-lhs))
                   (push-word (store-obj ir-rhs)))))

(defmethod update-fetched ((obj ir-update))
  (with-slots (ir-target ir-lhs ir-rhs ir-freevars)
    obj
    (setf ir-target (fetch-obj (stored-word 1)))
    (setf ir-lhs (fetch-obj (stored-word 2)))
    (setf ir-rhs (fetch-obj (stored-word 3)))
    (setf ir-freevars 'unbound)))

(defmethod restore-object* ((obj ir-update))
  (with-slots (ir-target ir-lhs ir-rhs)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-target
        (let ((*restore-object-parent-slot* 'ir-target))
          (restore-object* ir-target)))
      (when ir-lhs
        (let ((*restore-object-parent-slot* 'ir-lhs))
          (restore-object* ir-lhs)))
      (when ir-rhs
        (let ((*restore-object-parent-slot* 'ir-rhs))
          (restore-object* ir-rhs)))
      obj)))

(defmethod copy ((obj ir-lookup) &rest initargs)
  (with-slots (ir-freevars ir-array ir-index)
    obj
    (make-instance 'ir-lookup :ir-freevars
                   (let* ((get1 (getf initargs 'ir-freevars '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-freevars '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-freevars getfv))
                   :ir-array
                   (let* ((get1 (getf initargs 'ir-array '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-array '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-array getfv))
                   :ir-index
                   (let* ((get1 (getf initargs 'ir-index '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-index '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-index getfv)))))

(defmethod store-object* ((obj ir-lookup))
  (with-slots (ir-array ir-index)
    obj
    (reserve-space 3 (push-word (store-obj 'ir-lookup))
                   (push-word (store-obj ir-array))
                   (push-word (store-obj ir-index)))))

(defmethod update-fetched ((obj ir-lookup))
  (with-slots (ir-array ir-index ir-freevars)
    obj
    (setf ir-array (fetch-obj (stored-word 1)))
    (setf ir-index (fetch-obj (stored-word 2)))
    (setf ir-freevars 'unbound)))

(defmethod restore-object* ((obj ir-lookup))
  (with-slots (ir-array ir-index)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-array
        (let ((*restore-object-parent-slot* 'ir-array))
          (restore-object* ir-array)))
      (when ir-index
        (let ((*restore-object-parent-slot* 'ir-index))
          (restore-object* ir-index)))
      obj)))

(defmethod copy ((obj ir-nil) &rest initargs)
  (with-slots (ir-freevars)
    obj
    (make-instance 'ir-nil :ir-freevars
                   (let* ((get1 (getf initargs 'ir-freevars '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-freevars '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-freevars getfv)))))

(defmethod store-object* ((obj ir-nil))
  (with-slots nil
    obj
    (reserve-space 1 (push-word (store-obj 'ir-nil)))))

(defmethod update-fetched ((obj ir-nil))
  (with-slots (ir-freevars) obj (setf ir-freevars 'unbound)))

(defmethod restore-object* ((obj ir-nil))
  (with-slots nil obj (let ((*restore-object-parent* obj)) obj)))

(defmethod copy ((obj ir-selection) &rest initargs)
  (with-slots (ir-freevars ir-svalue ir-sbranch)
    obj
    (make-instance 'ir-selection :ir-freevars
                   (let* ((get1 (getf initargs 'ir-freevars '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-freevars '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-freevars getfv))
                   :ir-svalue
                   (let* ((get1 (getf initargs 'ir-svalue '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-svalue '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-svalue getfv))
                   :ir-sbranch
                   (let* ((get1 (getf initargs 'ir-sbranch '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-sbranch '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-sbranch getfv)))))

(defmethod store-object* ((obj ir-selection))
  (with-slots (ir-svalue ir-sbranch)
    obj
    (reserve-space 3 (push-word (store-obj 'ir-selection))
                   (push-word (store-obj ir-svalue))
                   (push-word (store-obj ir-sbranch)))))

(defmethod update-fetched ((obj ir-selection))
  (with-slots (ir-svalue ir-sbranch ir-freevars)
    obj
    (setf ir-svalue (fetch-obj (stored-word 1)))
    (setf ir-sbranch (fetch-obj (stored-word 2)))
    (setf ir-freevars 'unbound)))

(defmethod restore-object* ((obj ir-selection))
  (with-slots (ir-svalue ir-sbranch)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-svalue
        (let ((*restore-object-parent-slot* 'ir-svalue))
          (restore-object* ir-svalue)))
      (when ir-sbranch
        (let ((*restore-object-parent-slot* 'ir-sbranch))
          (restore-object* ir-sbranch)))
      obj)))

(defmethod copy ((obj ir-offset) &rest initargs)
  (with-slots (ir-freevars expr offset)
    obj
    (make-instance 'ir-offset :ir-freevars
                   (let* ((get1 (getf initargs 'ir-freevars '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-freevars '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-freevars getfv))
                   :expr
                   (let* ((get1 (getf initargs 'expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expr getfv))
                   :offset
                   (let* ((get1 (getf initargs 'offset '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :offset '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) offset getfv)))))

(defmethod store-object* ((obj ir-offset))
  (with-slots (expr offset)
    obj
    (reserve-space 3 (push-word (store-obj 'ir-offset))
                   (push-word (store-obj expr))
                   (push-word (store-obj offset)))))

(defmethod update-fetched ((obj ir-offset))
  (with-slots (expr offset ir-freevars)
    obj
    (setf expr (fetch-obj (stored-word 1)))
    (setf offset (fetch-obj (stored-word 2)))
    (setf ir-freevars 'unbound)))

(defmethod restore-object* ((obj ir-offset))
  (with-slots (expr offset)
    obj
    (let ((*restore-object-parent* obj))
      (when expr
        (let ((*restore-object-parent-slot* 'expr))
          (restore-object* expr)))
      (when offset
        (let ((*restore-object-parent-slot* 'offset))
          (restore-object* offset)))
      obj)))

(defmethod copy ((obj ir-ift) &rest initargs)
  (with-slots (ir-freevars ir-condition ir-then ir-else)
    obj
    (make-instance 'ir-ift :ir-freevars
                   (let* ((get1 (getf initargs 'ir-freevars '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-freevars '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-freevars getfv))
                   :ir-condition
                   (let* ((get1 (getf initargs 'ir-condition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-condition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-condition getfv))
                   :ir-then
                   (let* ((get1 (getf initargs 'ir-then '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-then '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-then getfv))
                   :ir-else
                   (let* ((get1 (getf initargs 'ir-else '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-else '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-else getfv)))))

(defmethod store-object* ((obj ir-ift))
  (with-slots (ir-condition ir-then ir-else)
    obj
    (reserve-space 4 (push-word (store-obj 'ir-ift))
                   (push-word (store-obj ir-condition))
                   (push-word (store-obj ir-then))
                   (push-word (store-obj ir-else)))))

(defmethod update-fetched ((obj ir-ift))
  (with-slots (ir-condition ir-then ir-else ir-freevars)
    obj
    (setf ir-condition (fetch-obj (stored-word 1)))
    (setf ir-then (fetch-obj (stored-word 2)))
    (setf ir-else (fetch-obj (stored-word 3)))
    (setf ir-freevars 'unbound)))

(defmethod restore-object* ((obj ir-ift))
  (with-slots (ir-condition ir-then ir-else)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-condition
        (let ((*restore-object-parent-slot* 'ir-condition))
          (restore-object* ir-condition)))
      (when ir-then
        (let ((*restore-object-parent-slot* 'ir-then))
          (restore-object* ir-then)))
      (when ir-else
        (let ((*restore-object-parent-slot* 'ir-else))
          (restore-object* ir-else)))
      obj)))

(defmethod copy ((obj ir-lambda) &rest initargs)
  (with-slots (ir-freevars ir-vartypes ir-lastvars ir-rangetype
                           ir-body)
    obj
    (make-instance 'ir-lambda :ir-freevars
                   (let* ((get1 (getf initargs 'ir-freevars '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-freevars '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-freevars getfv))
                   :ir-vartypes
                   (let* ((get1 (getf initargs 'ir-vartypes '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-vartypes '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-vartypes getfv))
                   :ir-lastvars
                   (let* ((get1 (getf initargs 'ir-lastvars '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-lastvars '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-lastvars getfv))
                   :ir-rangetype
                   (let* ((get1 (getf initargs 'ir-rangetype '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-rangetype '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-rangetype getfv))
                   :ir-body
                   (let* ((get1 (getf initargs 'ir-body '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-body '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-body getfv)))))

(defmethod store-object* ((obj ir-lambda))
  (with-slots (ir-vartypes ir-lastvars ir-rangetype ir-body)
    obj
    (reserve-space 5 (push-word (store-obj 'ir-lambda))
                   (push-word (store-obj ir-vartypes))
                   (push-word (store-obj ir-lastvars))
                   (push-word (store-obj ir-rangetype))
                   (push-word (store-obj ir-body)))))

(defmethod update-fetched ((obj ir-lambda))
  (with-slots (ir-vartypes ir-lastvars ir-rangetype ir-body
                           ir-freevars)
    obj
    (setf ir-vartypes (fetch-obj (stored-word 1)))
    (setf ir-lastvars (fetch-obj (stored-word 2)))
    (setf ir-rangetype (fetch-obj (stored-word 3)))
    (setf ir-body (fetch-obj (stored-word 4)))
    (setf ir-freevars 'unbound)))

(defmethod restore-object* ((obj ir-lambda))
  (with-slots (ir-vartypes ir-lastvars ir-rangetype ir-body)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-vartypes
        (let ((*restore-object-parent-slot* 'ir-vartypes))
          (restore-object* ir-vartypes)))
      (when ir-lastvars
        (let ((*restore-object-parent-slot* 'ir-lastvars))
          (restore-object* ir-lastvars)))
      (when ir-rangetype
        (let ((*restore-object-parent-slot* 'ir-rangetype))
          (restore-object* ir-rangetype)))
      (when ir-body
        (let ((*restore-object-parent-slot* 'ir-body))
          (restore-object* ir-body)))
      obj)))

(defmethod copy ((obj ir-field) &rest initargs)
  (with-slots (ir-freevars ir-fieldname ir-value)
    obj
    (make-instance 'ir-field :ir-freevars
                   (let* ((get1 (getf initargs 'ir-freevars '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-freevars '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-freevars getfv))
                   :ir-fieldname
                   (let* ((get1 (getf initargs 'ir-fieldname '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-fieldname '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-fieldname getfv))
                   :ir-value
                   (let* ((get1 (getf initargs 'ir-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-value getfv)))))

(defmethod store-object* ((obj ir-field))
  (with-slots (ir-fieldname ir-value)
    obj
    (reserve-space 3 (push-word (store-obj 'ir-field))
                   (push-word (store-obj ir-fieldname))
                   (push-word (store-obj ir-value)))))

(defmethod update-fetched ((obj ir-field))
  (with-slots (ir-fieldname ir-value ir-freevars)
    obj
    (setf ir-fieldname (fetch-obj (stored-word 1)))
    (setf ir-value (fetch-obj (stored-word 2)))
    (setf ir-freevars 'unbound)))

(defmethod restore-object* ((obj ir-field))
  (with-slots (ir-fieldname ir-value)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-fieldname
        (let ((*restore-object-parent-slot* 'ir-fieldname))
          (restore-object* ir-fieldname)))
      (when ir-value
        (let ((*restore-object-parent-slot* 'ir-value))
          (restore-object* ir-value)))
      obj)))

(defmethod copy ((obj ir-record) &rest initargs)
  (with-slots (ir-freevars ir-fields ir-recordtype)
    obj
    (make-instance 'ir-record :ir-freevars
                   (let* ((get1 (getf initargs 'ir-freevars '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-freevars '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-freevars getfv))
                   :ir-fields
                   (let* ((get1 (getf initargs 'ir-fields '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-fields '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-fields getfv))
                   :ir-recordtype
                   (let* ((get1
                           (getf initargs 'ir-recordtype '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-recordtype '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-recordtype getfv)))))

(defmethod store-object* ((obj ir-record))
  (with-slots (ir-fields ir-recordtype)
    obj
    (reserve-space 3 (push-word (store-obj 'ir-record))
                   (push-word (store-obj ir-fields))
                   (push-word (store-obj ir-recordtype)))))

(defmethod update-fetched ((obj ir-record))
  (with-slots (ir-fields ir-recordtype ir-freevars)
    obj
    (setf ir-fields (fetch-obj (stored-word 1)))
    (setf ir-recordtype (fetch-obj (stored-word 2)))
    (setf ir-freevars 'unbound)))

(defmethod restore-object* ((obj ir-record))
  (with-slots (ir-fields ir-recordtype)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-fields
        (let ((*restore-object-parent-slot* 'ir-fields))
          (restore-object* ir-fields)))
      (when ir-recordtype
        (let ((*restore-object-parent-slot* 'ir-recordtype))
          (restore-object* ir-recordtype)))
      obj)))

(defmethod copy ((obj ir-lett) &rest initargs)
  (with-slots (ir-freevars ir-vartype ir-bind-expr ir-body
                           ir-bind-type)
    obj
    (make-instance 'ir-lett :ir-freevars
                   (let* ((get1 (getf initargs 'ir-freevars '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-freevars '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-freevars getfv))
                   :ir-vartype
                   (let* ((get1 (getf initargs 'ir-vartype '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-vartype '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-vartype getfv))
                   :ir-bind-expr
                   (let* ((get1 (getf initargs 'ir-bind-expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-bind-expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-bind-expr getfv))
                   :ir-body
                   (let* ((get1 (getf initargs 'ir-body '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-body '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-body getfv))
                   :ir-bind-type
                   (let* ((get1 (getf initargs 'ir-bind-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-bind-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-bind-type getfv)))))

(defmethod store-object* ((obj ir-lett))
  (with-slots (ir-vartype ir-bind-expr ir-body ir-bind-type)
    obj
    (reserve-space 5 (push-word (store-obj 'ir-lett))
                   (push-word (store-obj ir-vartype))
                   (push-word (store-obj ir-bind-expr))
                   (push-word (store-obj ir-body))
                   (push-word (store-obj ir-bind-type)))))

(defmethod update-fetched ((obj ir-lett))
  (with-slots (ir-vartype ir-bind-expr ir-body ir-bind-type
                          ir-freevars)
    obj
    (setf ir-vartype (fetch-obj (stored-word 1)))
    (setf ir-bind-expr (fetch-obj (stored-word 2)))
    (setf ir-body (fetch-obj (stored-word 3)))
    (setf ir-bind-type (fetch-obj (stored-word 4)))
    (setf ir-freevars 'unbound)))

(defmethod restore-object* ((obj ir-lett))
  (with-slots (ir-vartype ir-bind-expr ir-body ir-bind-type)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-vartype
        (let ((*restore-object-parent-slot* 'ir-vartype))
          (restore-object* ir-vartype)))
      (when ir-bind-expr
        (let ((*restore-object-parent-slot* 'ir-bind-expr))
          (restore-object* ir-bind-expr)))
      (when ir-body
        (let ((*restore-object-parent-slot* 'ir-body))
          (restore-object* ir-body)))
      (when ir-bind-type
        (let ((*restore-object-parent-slot* 'ir-bind-type))
          (restore-object* ir-bind-type)))
      obj)))

(defmethod copy ((obj ir-let) &rest initargs)
  (with-slots (ir-freevars ir-vartype ir-bind-expr ir-body)
    obj
    (make-instance 'ir-let :ir-freevars
                   (let* ((get1 (getf initargs 'ir-freevars '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-freevars '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-freevars getfv))
                   :ir-vartype
                   (let* ((get1 (getf initargs 'ir-vartype '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-vartype '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-vartype getfv))
                   :ir-bind-expr
                   (let* ((get1 (getf initargs 'ir-bind-expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-bind-expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-bind-expr getfv))
                   :ir-body
                   (let* ((get1 (getf initargs 'ir-body '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-body '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-body getfv)))))

(defmethod store-object* ((obj ir-let))
  (with-slots (ir-vartype ir-bind-expr ir-body)
    obj
    (reserve-space 4 (push-word (store-obj 'ir-let))
                   (push-word (store-obj ir-vartype))
                   (push-word (store-obj ir-bind-expr))
                   (push-word (store-obj ir-body)))))

(defmethod update-fetched ((obj ir-let))
  (with-slots (ir-vartype ir-bind-expr ir-body ir-freevars)
    obj
    (setf ir-vartype (fetch-obj (stored-word 1)))
    (setf ir-bind-expr (fetch-obj (stored-word 2)))
    (setf ir-body (fetch-obj (stored-word 3)))
    (setf ir-freevars 'unbound)))

(defmethod restore-object* ((obj ir-let))
  (with-slots (ir-vartype ir-bind-expr ir-body)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-vartype
        (let ((*restore-object-parent-slot* 'ir-vartype))
          (restore-object* ir-vartype)))
      (when ir-bind-expr
        (let ((*restore-object-parent-slot* 'ir-bind-expr))
          (restore-object* ir-bind-expr)))
      (when ir-body
        (let ((*restore-object-parent-slot* 'ir-body))
          (restore-object* ir-body)))
      obj)))

(defmethod copy ((obj ir-apply) &rest initargs)
  (with-slots (ir-freevars ir-func ir-params ir-args ir-atype)
    obj
    (make-instance 'ir-apply :ir-freevars
                   (let* ((get1 (getf initargs 'ir-freevars '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-freevars '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-freevars getfv))
                   :ir-func
                   (let* ((get1 (getf initargs 'ir-func '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-func '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-func getfv))
                   :ir-params
                   (let* ((get1 (getf initargs 'ir-params '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-params '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-params getfv))
                   :ir-args
                   (let* ((get1 (getf initargs 'ir-args '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-args '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-args getfv))
                   :ir-atype
                   (let* ((get1 (getf initargs 'ir-atype '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-atype '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-atype getfv)))))

(defmethod store-object* ((obj ir-apply))
  (with-slots (ir-func ir-params ir-args ir-atype)
    obj
    (reserve-space 5 (push-word (store-obj 'ir-apply))
                   (push-word (store-obj ir-func))
                   (push-word (store-obj ir-params))
                   (push-word (store-obj ir-args))
                   (push-word (store-obj ir-atype)))))

(defmethod update-fetched ((obj ir-apply))
  (with-slots (ir-func ir-params ir-args ir-atype ir-freevars)
    obj
    (setf ir-func (fetch-obj (stored-word 1)))
    (setf ir-params (fetch-obj (stored-word 2)))
    (setf ir-args (fetch-obj (stored-word 3)))
    (setf ir-atype (fetch-obj (stored-word 4)))
    (setf ir-freevars 'unbound)))

(defmethod restore-object* ((obj ir-apply))
  (with-slots (ir-func ir-params ir-args ir-atype)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-func
        (let ((*restore-object-parent-slot* 'ir-func))
          (restore-object* ir-func)))
      (when ir-params
        (let ((*restore-object-parent-slot* 'ir-params))
          (restore-object* ir-params)))
      (when ir-args
        (let ((*restore-object-parent-slot* 'ir-args))
          (restore-object* ir-args)))
      (when ir-atype
        (let ((*restore-object-parent-slot* 'ir-atype))
          (restore-object* ir-atype)))
      obj)))

(defmethod copy ((obj ir-primitive-function) &rest initargs)
  (with-slots (ir-freevars ir-fname declaration)
    obj
    (make-instance 'ir-primitive-function :ir-freevars
                   (let* ((get1 (getf initargs 'ir-freevars '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-freevars '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-freevars getfv))
                   :ir-fname
                   (let* ((get1 (getf initargs 'ir-fname '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-fname '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-fname getfv))
                   :declaration
                   (let* ((get1 (getf initargs 'declaration '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declaration '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declaration getfv)))))

(defmethod store-object* ((obj ir-primitive-function))
  (with-slots (ir-fname declaration)
    obj
    (reserve-space 3 (push-word (store-obj 'ir-primitive-function))
                   (push-word (store-obj ir-fname))
                   (push-word (store-obj declaration)))))

(defmethod update-fetched ((obj ir-primitive-function))
  (with-slots (ir-fname declaration ir-freevars)
    obj
    (setf ir-fname (fetch-obj (stored-word 1)))
    (setf declaration (fetch-obj (stored-word 2)))
    (setf ir-freevars 'unbound)))

(defmethod restore-object* ((obj ir-primitive-function))
  (with-slots (ir-fname declaration)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-fname
        (let ((*restore-object-parent-slot* 'ir-fname))
          (restore-object* ir-fname)))
      (when declaration
        (let ((*restore-object-parent-slot* 'declaration))
          (restore-object* declaration)))
      obj)))

(defmethod copy ((obj ir-function) &rest initargs)
  (with-slots (ir-freevars ir-fname declaration)
    obj
    (make-instance 'ir-function :ir-freevars
                   (let* ((get1 (getf initargs 'ir-freevars '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-freevars '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-freevars getfv))
                   :ir-fname
                   (let* ((get1 (getf initargs 'ir-fname '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-fname '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-fname getfv))
                   :declaration
                   (let* ((get1 (getf initargs 'declaration '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declaration '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declaration getfv)))))

(defmethod store-object* ((obj ir-function))
  (with-slots (ir-fname declaration)
    obj
    (reserve-space 3 (push-word (store-obj 'ir-function))
                   (push-word (store-obj ir-fname))
                   (push-word (store-obj declaration)))))

(defmethod update-fetched ((obj ir-function))
  (with-slots (ir-fname declaration ir-freevars)
    obj
    (setf ir-fname (fetch-obj (stored-word 1)))
    (setf declaration (fetch-obj (stored-word 2)))
    (setf ir-freevars 'unbound)))

(defmethod restore-object* ((obj ir-function))
  (with-slots (ir-fname declaration)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-fname
        (let ((*restore-object-parent-slot* 'ir-fname))
          (restore-object* ir-fname)))
      (when declaration
        (let ((*restore-object-parent-slot* 'declaration))
          (restore-object* declaration)))
      obj)))

(defmethod copy ((obj ir-variable) &rest initargs)
  (with-slots (ir-freevars ir-name ir-vtype ir-pvsid)
    obj
    (make-instance 'ir-variable :ir-freevars
                   (let* ((get1 (getf initargs 'ir-freevars '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-freevars '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-freevars getfv))
                   :ir-name
                   (let* ((get1 (getf initargs 'ir-name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-name getfv))
                   :ir-vtype
                   (let* ((get1 (getf initargs 'ir-vtype '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-vtype '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-vtype getfv))
                   :ir-pvsid
                   (let* ((get1 (getf initargs 'ir-pvsid '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-pvsid '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-pvsid getfv)))))

(defmethod store-object* ((obj ir-variable))
  (with-slots (ir-name ir-vtype ir-pvsid)
    obj
    (reserve-space 4 (push-word (store-obj 'ir-variable))
                   (push-word (store-obj ir-name))
                   (push-word (store-obj ir-vtype))
                   (push-word (store-obj ir-pvsid)))))

(defmethod update-fetched ((obj ir-variable))
  (with-slots (ir-name ir-vtype ir-pvsid ir-freevars)
    obj
    (setf ir-name (fetch-obj (stored-word 1)))
    (setf ir-vtype (fetch-obj (stored-word 2)))
    (setf ir-pvsid (fetch-obj (stored-word 3)))
    (setf ir-freevars 'unbound)))

(defmethod restore-object* ((obj ir-variable))
  (with-slots (ir-name ir-vtype ir-pvsid)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-name
        (let ((*restore-object-parent-slot* 'ir-name))
          (restore-object* ir-name)))
      (when ir-vtype
        (let ((*restore-object-parent-slot* 'ir-vtype))
          (restore-object* ir-vtype)))
      (when ir-pvsid
        (let ((*restore-object-parent-slot* 'ir-pvsid))
          (restore-object* ir-pvsid)))
      obj)))

(defmethod copy ((obj ir-bool) &rest initargs)
  (with-slots (ir-freevars ir-boolval)
    obj
    (make-instance 'ir-bool :ir-freevars
                   (let* ((get1 (getf initargs 'ir-freevars '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-freevars '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-freevars getfv))
                   :ir-boolval
                   (let* ((get1 (getf initargs 'ir-boolval '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-boolval '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-boolval getfv)))))

(defmethod store-object* ((obj ir-bool))
  (with-slots (ir-boolval)
    obj
    (reserve-space 2 (push-word (store-obj 'ir-bool))
                   (push-word (store-obj ir-boolval)))))

(defmethod update-fetched ((obj ir-bool))
  (with-slots (ir-boolval ir-freevars)
    obj
    (setf ir-boolval (fetch-obj (stored-word 1)))
    (setf ir-freevars 'unbound)))

(defmethod restore-object* ((obj ir-bool))
  (with-slots (ir-boolval)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-boolval
        (let ((*restore-object-parent-slot* 'ir-boolval))
          (restore-object* ir-boolval)))
      obj)))

(defmethod copy ((obj ir-double) &rest initargs)
  (with-slots (ir-freevars ir-mantissa ir-exponent)
    obj
    (make-instance 'ir-double :ir-freevars
                   (let* ((get1 (getf initargs 'ir-freevars '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-freevars '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-freevars getfv))
                   :ir-mantissa
                   (let* ((get1 (getf initargs 'ir-mantissa '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-mantissa '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-mantissa getfv))
                   :ir-exponent
                   (let* ((get1 (getf initargs 'ir-exponent '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-exponent '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-exponent getfv)))))

(defmethod store-object* ((obj ir-double))
  (with-slots (ir-mantissa ir-exponent)
    obj
    (reserve-space 3 (push-word (store-obj 'ir-double))
                   (push-word (store-obj ir-mantissa))
                   (push-word (store-obj ir-exponent)))))

(defmethod update-fetched ((obj ir-double))
  (with-slots (ir-mantissa ir-exponent ir-freevars)
    obj
    (setf ir-mantissa (fetch-obj (stored-word 1)))
    (setf ir-exponent (fetch-obj (stored-word 2)))
    (setf ir-freevars 'unbound)))

(defmethod restore-object* ((obj ir-double))
  (with-slots (ir-mantissa ir-exponent)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-mantissa
        (let ((*restore-object-parent-slot* 'ir-mantissa))
          (restore-object* ir-mantissa)))
      (when ir-exponent
        (let ((*restore-object-parent-slot* 'ir-exponent))
          (restore-object* ir-exponent)))
      obj)))

(defmethod copy ((obj ir-float) &rest initargs)
  (with-slots (ir-freevars ir-float-mantissa ir-float-exponent)
    obj
    (make-instance 'ir-float :ir-freevars
                   (let* ((get1 (getf initargs 'ir-freevars '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-freevars '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-freevars getfv))
                   :ir-float-mantissa
                   (let* ((get1
                           (getf initargs 'ir-float-mantissa '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :ir-float-mantissa
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-float-mantissa getfv))
                   :ir-float-exponent
                   (let* ((get1
                           (getf initargs 'ir-float-exponent '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :ir-float-exponent
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         ir-float-exponent
                       getfv)))))

(defmethod store-object* ((obj ir-float))
  (with-slots (ir-float-mantissa ir-float-exponent)
    obj
    (reserve-space 3 (push-word (store-obj 'ir-float))
                   (push-word (store-obj ir-float-mantissa))
                   (push-word (store-obj ir-float-exponent)))))

(defmethod update-fetched ((obj ir-float))
  (with-slots (ir-float-mantissa ir-float-exponent ir-freevars)
    obj
    (setf ir-float-mantissa (fetch-obj (stored-word 1)))
    (setf ir-float-exponent (fetch-obj (stored-word 2)))
    (setf ir-freevars 'unbound)))

(defmethod restore-object* ((obj ir-float))
  (with-slots (ir-float-mantissa ir-float-exponent)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-float-mantissa
        (let ((*restore-object-parent-slot* 'ir-float-mantissa))
          (restore-object* ir-float-mantissa)))
      (when ir-float-exponent
        (let ((*restore-object-parent-slot* 'ir-float-exponent))
          (restore-object* ir-float-exponent)))
      obj)))

(defmethod copy ((obj ir-integer) &rest initargs)
  (with-slots (ir-freevars ir-intval)
    obj
    (make-instance 'ir-integer :ir-freevars
                   (let* ((get1 (getf initargs 'ir-freevars '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-freevars '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-freevars getfv))
                   :ir-intval
                   (let* ((get1 (getf initargs 'ir-intval '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-intval '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-intval getfv)))))

(defmethod store-object* ((obj ir-integer))
  (with-slots (ir-intval)
    obj
    (reserve-space 2 (push-word (store-obj 'ir-integer))
                   (push-word (store-obj ir-intval)))))

(defmethod update-fetched ((obj ir-integer))
  (with-slots (ir-intval ir-freevars)
    obj
    (setf ir-intval (fetch-obj (stored-word 1)))
    (setf ir-freevars 'unbound)))

(defmethod restore-object* ((obj ir-integer))
  (with-slots (ir-intval)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-intval
        (let ((*restore-object-parent-slot* 'ir-intval))
          (restore-object* ir-intval)))
      obj)))

(defmethod copy ((obj ir-type) &rest initargs)
  (with-slots nil obj (make-instance 'ir-type)))

(defmethod store-object* ((obj ir-type))
  (with-slots nil
    obj
    (reserve-space 1 (push-word (store-obj 'ir-type)))))

(defmethod update-fetched ((obj ir-type)) (with-slots nil obj))

(defmethod restore-object* ((obj ir-type))
  (with-slots nil obj (let ((*restore-object-parent* obj)) obj)))

(defmethod copy ((obj ir-expr) &rest initargs)
  (with-slots (ir-freevars)
    obj
    (make-instance 'ir-expr :ir-freevars
                   (let* ((get1 (getf initargs 'ir-freevars '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-freevars '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-freevars getfv)))))

(defmethod store-object* ((obj ir-expr))
  (with-slots nil
    obj
    (reserve-space 1 (push-word (store-obj 'ir-expr)))))

(defmethod update-fetched ((obj ir-expr))
  (with-slots (ir-freevars) obj (setf ir-freevars 'unbound)))

(defmethod restore-object* ((obj ir-expr))
  (with-slots nil obj (let ((*restore-object-parent* obj)) obj)))

(defmethod copy ((obj Cflags) &rest initargs)
  (with-slots (bang dupl arg treated)
    obj
    (make-instance 'Cflags :bang
                   (let* ((get1 (getf initargs 'bang '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :bang '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) bang getfv))
                   :dupl
                   (let* ((get1 (getf initargs 'dupl '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dupl '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dupl getfv))
                   :arg
                   (let* ((get1 (getf initargs 'arg '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :arg '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) arg getfv))
                   :treated
                   (let* ((get1 (getf initargs 'treated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :treated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) treated getfv)))))

(defmethod store-object* ((obj Cflags))
  (with-slots (bang dupl arg treated)
    obj
    (reserve-space 5 (push-word (store-obj 'Cflags))
                   (push-word (store-obj bang))
                   (push-word (store-obj dupl))
                   (push-word (store-obj arg))
                   (push-word (store-obj treated)))))

(defmethod update-fetched ((obj Cflags))
  (with-slots (bang dupl arg treated)
    obj
    (setf bang (fetch-obj (stored-word 1)))
    (setf dupl (fetch-obj (stored-word 2)))
    (setf arg (fetch-obj (stored-word 3)))
    (setf treated (fetch-obj (stored-word 4)))))

(defmethod restore-object* ((obj Cflags))
  (with-slots (bang dupl arg treated)
    obj
    (let ((*restore-object-parent* obj))
      (when bang
        (let ((*restore-object-parent-slot* 'bang))
          (restore-object* bang)))
      (when dupl
        (let ((*restore-object-parent-slot* 'dupl))
          (restore-object* dupl)))
      (when arg
        (let ((*restore-object-parent-slot* 'arg))
          (restore-object* arg)))
      (when treated
        (let ((*restore-object-parent-slot* 'treated))
          (restore-object* treated)))
      obj)))

(defmethod copy ((obj Cfun-decl) &rest initargs)
  (with-slots (id type-out args all-vars flags body bang-return?)
    obj
    (make-instance 'Cfun-decl :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :type-out
                   (let* ((get1 (getf initargs 'type-out '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-out '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-out getfv))
                   :args
                   (let* ((get1 (getf initargs 'args '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :args '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) args getfv))
                   :all-vars
                   (let* ((get1 (getf initargs 'all-vars '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :all-vars '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) all-vars getfv))
                   :flags
                   (let* ((get1 (getf initargs 'flags '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :flags '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) flags getfv))
                   :body
                   (let* ((get1 (getf initargs 'body '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :body '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) body getfv))
                   :bang-return?
                   (let* ((get1 (getf initargs 'bang-return? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :bang-return? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) bang-return? getfv)))))

(defmethod store-object* ((obj Cfun-decl))
  (with-slots (id type-out args all-vars flags body bang-return?)
    obj
    (reserve-space 8 (push-word (store-obj 'Cfun-decl))
                   (push-word (store-obj id))
                   (push-word (store-obj type-out))
                   (push-word (store-obj args))
                   (push-word (store-obj all-vars))
                   (push-word (store-obj flags))
                   (push-word (store-obj body))
                   (push-word (store-obj bang-return?)))))

(defmethod update-fetched ((obj Cfun-decl))
  (with-slots (id type-out args all-vars flags body bang-return?)
    obj
    (setf id (fetch-obj (stored-word 1)))
    (setf type-out (fetch-obj (stored-word 2)))
    (setf args (fetch-obj (stored-word 3)))
    (setf all-vars (fetch-obj (stored-word 4)))
    (setf flags (fetch-obj (stored-word 5)))
    (setf body (fetch-obj (stored-word 6)))
    (setf bang-return? (fetch-obj (stored-word 7)))))

(defmethod restore-object* ((obj Cfun-decl))
  (with-slots (id type-out args all-vars flags body bang-return?)
    obj
    (let ((*restore-object-parent* obj))
      (when id
        (let ((*restore-object-parent-slot* 'id))
          (restore-object* id)))
      (when type-out
        (let ((*restore-object-parent-slot* 'type-out))
          (restore-object* type-out)))
      (when args
        (let ((*restore-object-parent-slot* 'args))
          (restore-object* args)))
      (when all-vars
        (let ((*restore-object-parent-slot* 'all-vars))
          (restore-object* all-vars)))
      (when flags
        (let ((*restore-object-parent-slot* 'flags))
          (restore-object* flags)))
      (when body
        (let ((*restore-object-parent-slot* 'body))
          (restore-object* body)))
      (when bang-return?
        (let ((*restore-object-parent-slot* 'bang-return?))
          (restore-object* bang-return?)))
      obj)))

(defmethod copy ((obj Cfun) &rest initargs)
  (with-slots (name spec-op destr)
    obj
    (make-instance 'Cfun :name
                   (let* ((get1 (getf initargs 'name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) name getfv))
                   :spec-op
                   (let* ((get1 (getf initargs 'spec-op '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :spec-op '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) spec-op getfv))
                   :destr
                   (let* ((get1 (getf initargs 'destr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :destr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) destr getfv)))))

(defmethod store-object* ((obj Cfun))
  (with-slots (name spec-op destr)
    obj
    (reserve-space 4 (push-word (store-obj 'Cfun))
                   (push-word (store-obj name))
                   (push-word (store-obj spec-op))
                   (push-word (store-obj destr)))))

(defmethod update-fetched ((obj Cfun))
  (with-slots (name spec-op destr)
    obj
    (setf name (fetch-obj (stored-word 1)))
    (setf spec-op (fetch-obj (stored-word 2)))
    (setf destr (fetch-obj (stored-word 3)))))

(defmethod restore-object* ((obj Cfun))
  (with-slots (name spec-op destr)
    obj
    (let ((*restore-object-parent* obj))
      (when name
        (let ((*restore-object-parent-slot* 'name))
          (restore-object* name)))
      (when spec-op
        (let ((*restore-object-parent-slot* 'spec-op))
          (restore-object* spec-op)))
      (when destr
        (let ((*restore-object-parent-slot* 'destr))
          (restore-object* destr)))
      obj)))

(defmethod copy ((obj Ccopy) &rest initargs)
  (with-slots (varA varB safe)
    obj
    (make-instance 'Ccopy :varA
                   (let* ((get1 (getf initargs 'varA '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :varA '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) varA getfv))
                   :varB
                   (let* ((get1 (getf initargs 'varB '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :varB '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) varB getfv))
                   :safe
                   (let* ((get1 (getf initargs 'safe '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :safe '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) safe getfv)))))

(defmethod store-object* ((obj Ccopy))
  (with-slots (varA varB safe)
    obj
    (reserve-space 4 (push-word (store-obj 'Ccopy))
                   (push-word (store-obj varA))
                   (push-word (store-obj varB))
                   (push-word (store-obj safe)))))

(defmethod update-fetched ((obj Ccopy))
  (with-slots (varA varB safe)
    obj
    (setf varA (fetch-obj (stored-word 1)))
    (setf varB (fetch-obj (stored-word 2)))
    (setf safe (fetch-obj (stored-word 3)))))

(defmethod restore-object* ((obj Ccopy))
  (with-slots (varA varB safe)
    obj
    (let ((*restore-object-parent* obj))
      (when varA
        (let ((*restore-object-parent-slot* 'varA))
          (restore-object* varA)))
      (when varB
        (let ((*restore-object-parent-slot* 'varB))
          (restore-object* varB)))
      (when safe
        (let ((*restore-object-parent-slot* 'safe))
          (restore-object* safe)))
      obj)))

(defmethod copy ((obj Creturn) &rest initargs)
  (with-slots (var)
    obj
    (make-instance 'Creturn :var
                   (let* ((get1 (getf initargs 'var '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :var '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) var getfv)))))

(defmethod store-object* ((obj Creturn))
  (with-slots (var)
    obj
    (reserve-space 2 (push-word (store-obj 'Creturn))
                   (push-word (store-obj var)))))

(defmethod update-fetched ((obj Creturn))
  (with-slots (var) obj (setf var (fetch-obj (stored-word 1)))))

(defmethod restore-object* ((obj Creturn))
  (with-slots (var)
    obj
    (let ((*restore-object-parent* obj))
      (when var
        (let ((*restore-object-parent-slot* 'var))
          (restore-object* var)))
      obj)))

(defmethod copy ((obj Crecord-init) &rest initargs)
  (with-slots (var)
    obj
    (make-instance 'Crecord-init :var
                   (let* ((get1 (getf initargs 'var '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :var '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) var getfv)))))

(defmethod store-object* ((obj Crecord-init))
  (with-slots (var)
    obj
    (reserve-space 2 (push-word (store-obj 'Crecord-init))
                   (push-word (store-obj var)))))

(defmethod update-fetched ((obj Crecord-init))
  (with-slots (var) obj (setf var (fetch-obj (stored-word 1)))))

(defmethod restore-object* ((obj Crecord-init))
  (with-slots (var)
    obj
    (let ((*restore-object-parent* obj))
      (when var
        (let ((*restore-object-parent-slot* 'var))
          (restore-object* var)))
      obj)))

(defmethod copy ((obj Carray-init) &rest initargs)
  (with-slots (var body i)
    obj
    (make-instance 'Carray-init :var
                   (let* ((get1 (getf initargs 'var '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :var '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) var getfv))
                   :body
                   (let* ((get1 (getf initargs 'body '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :body '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) body getfv))
                   :i
                   (let* ((get1 (getf initargs 'i '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :i '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) i getfv)))))

(defmethod store-object* ((obj Carray-init))
  (with-slots (var body i)
    obj
    (reserve-space 4 (push-word (store-obj 'Carray-init))
                   (push-word (store-obj var))
                   (push-word (store-obj body))
                   (push-word (store-obj i)))))

(defmethod update-fetched ((obj Carray-init))
  (with-slots (var body i)
    obj
    (setf var (fetch-obj (stored-word 1)))
    (setf body (fetch-obj (stored-word 2)))
    (setf i (fetch-obj (stored-word 3)))))

(defmethod restore-object* ((obj Carray-init))
  (with-slots (var body i)
    obj
    (let ((*restore-object-parent* obj))
      (when var
        (let ((*restore-object-parent-slot* 'var))
          (restore-object* var)))
      (when body
        (let ((*restore-object-parent-slot* 'body))
          (restore-object* body)))
      (when i
        (let ((*restore-object-parent-slot* 'i)) (restore-object* i)))
      obj)))

(defmethod copy ((obj Cif) &rest initargs)
  (with-slots (var cond-part then-part else-part)
    obj
    (make-instance 'Cif :var
                   (let* ((get1 (getf initargs 'var '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :var '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) var getfv))
                   :cond-part
                   (let* ((get1 (getf initargs 'cond-part '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :cond-part '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) cond-part getfv))
                   :then-part
                   (let* ((get1 (getf initargs 'then-part '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :then-part '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) then-part getfv))
                   :else-part
                   (let* ((get1 (getf initargs 'else-part '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :else-part '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) else-part getfv)))))

(defmethod store-object* ((obj Cif))
  (with-slots (var cond-part then-part else-part)
    obj
    (reserve-space 5 (push-word (store-obj 'Cif))
                   (push-word (store-obj var))
                   (push-word (store-obj cond-part))
                   (push-word (store-obj then-part))
                   (push-word (store-obj else-part)))))

(defmethod update-fetched ((obj Cif))
  (with-slots (var cond-part then-part else-part)
    obj
    (setf var (fetch-obj (stored-word 1)))
    (setf cond-part (fetch-obj (stored-word 2)))
    (setf then-part (fetch-obj (stored-word 3)))
    (setf else-part (fetch-obj (stored-word 4)))))

(defmethod restore-object* ((obj Cif))
  (with-slots (var cond-part then-part else-part)
    obj
    (let ((*restore-object-parent* obj))
      (when var
        (let ((*restore-object-parent-slot* 'var))
          (restore-object* var)))
      (when cond-part
        (let ((*restore-object-parent-slot* 'cond-part))
          (restore-object* cond-part)))
      (when then-part
        (let ((*restore-object-parent-slot* 'then-part))
          (restore-object* then-part)))
      (when else-part
        (let ((*restore-object-parent-slot* 'else-part))
          (restore-object* else-part)))
      obj)))

(defmethod copy ((obj Cfuncall-mp) &rest initargs)
  (with-slots (Cfunc)
    obj
    (make-instance 'Cfuncall-mp :Cfunc
                   (let* ((get1 (getf initargs 'Cfunc '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :Cfunc '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) Cfunc getfv)))))

(defmethod store-object* ((obj Cfuncall-mp))
  (with-slots (Cfunc)
    obj
    (reserve-space 2 (push-word (store-obj 'Cfuncall-mp))
                   (push-word (store-obj Cfunc)))))

(defmethod update-fetched ((obj Cfuncall-mp))
  (with-slots (Cfunc) obj (setf Cfunc (fetch-obj (stored-word 1)))))

(defmethod restore-object* ((obj Cfuncall-mp))
  (with-slots (Cfunc)
    obj
    (let ((*restore-object-parent* obj))
      (when Cfunc
        (let ((*restore-object-parent-slot* 'Cfunc))
          (restore-object* Cfunc)))
      obj)))

(defmethod copy ((obj Cset) &rest initargs)
  (with-slots (var expr)
    obj
    (make-instance 'Cset :var
                   (let* ((get1 (getf initargs 'var '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :var '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) var getfv))
                   :expr
                   (let* ((get1 (getf initargs 'expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expr getfv)))))

(defmethod store-object* ((obj Cset))
  (with-slots (var expr)
    obj
    (reserve-space 3 (push-word (store-obj 'Cset))
                   (push-word (store-obj var))
                   (push-word (store-obj expr)))))

(defmethod update-fetched ((obj Cset))
  (with-slots (var expr)
    obj
    (setf var (fetch-obj (stored-word 1)))
    (setf expr (fetch-obj (stored-word 2)))))

(defmethod restore-object* ((obj Cset))
  (with-slots (var expr)
    obj
    (let ((*restore-object-parent* obj))
      (when var
        (let ((*restore-object-parent-slot* 'var))
          (restore-object* var)))
      (when expr
        (let ((*restore-object-parent-slot* 'expr))
          (restore-object* expr)))
      obj)))

(defmethod copy ((obj Cfree) &rest initargs)
  (with-slots (var)
    obj
    (make-instance 'Cfree :var
                   (let* ((get1 (getf initargs 'var '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :var '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) var getfv)))))

(defmethod store-object* ((obj Cfree))
  (with-slots (var)
    obj
    (reserve-space 2 (push-word (store-obj 'Cfree))
                   (push-word (store-obj var)))))

(defmethod update-fetched ((obj Cfree))
  (with-slots (var) obj (setf var (fetch-obj (stored-word 1)))))

(defmethod restore-object* ((obj Cfree))
  (with-slots (var)
    obj
    (let ((*restore-object-parent* obj))
      (when var
        (let ((*restore-object-parent-slot* 'var))
          (restore-object* var)))
      obj)))

(defmethod copy ((obj Cdecl) &rest initargs)
  (with-slots (var)
    obj
    (make-instance 'Cdecl :var
                   (let* ((get1 (getf initargs 'var '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :var '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) var getfv)))))

(defmethod store-object* ((obj Cdecl))
  (with-slots (var)
    obj
    (reserve-space 2 (push-word (store-obj 'Cdecl))
                   (push-word (store-obj var)))))

(defmethod update-fetched ((obj Cdecl))
  (with-slots (var) obj (setf var (fetch-obj (stored-word 1)))))

(defmethod restore-object* ((obj Cdecl))
  (with-slots (var)
    obj
    (let ((*restore-object-parent* obj))
      (when var
        (let ((*restore-object-parent-slot* 'var))
          (restore-object* var)))
      obj)))

(defmethod copy ((obj Cinstr) &rest initargs)
  (with-slots nil obj (make-instance 'Cinstr)))

(defmethod store-object* ((obj Cinstr))
  (with-slots nil
    obj
    (reserve-space 1 (push-word (store-obj 'Cinstr)))))

(defmethod update-fetched ((obj Cinstr)) (with-slots nil obj))

(defmethod restore-object* ((obj Cinstr))
  (with-slots nil obj (let ((*restore-object-parent* obj)) obj)))

(defmethod copy ((obj Cfuncall) &rest initargs)
  (with-slots (fun args type)
    obj
    (make-instance 'Cfuncall :fun
                   (let* ((get1 (getf initargs 'fun '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :fun '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) fun getfv))
                   :args
                   (let* ((get1 (getf initargs 'args '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :args '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) args getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv)))))

(defmethod store-object* ((obj Cfuncall))
  (with-slots (fun args type)
    obj
    (reserve-space 4 (push-word (store-obj 'Cfuncall))
                   (push-word (store-obj fun))
                   (push-word (store-obj args))
                   (push-word (store-obj type)))))

(defmethod update-fetched ((obj Cfuncall))
  (with-slots (fun args type)
    obj
    (setf fun (fetch-obj (stored-word 1)))
    (setf args (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))))

(defmethod restore-object* ((obj Cfuncall))
  (with-slots (fun args type)
    obj
    (let ((*restore-object-parent* obj))
      (when fun
        (let ((*restore-object-parent-slot* 'fun))
          (restore-object* fun)))
      (when args
        (let ((*restore-object-parent-slot* 'args))
          (restore-object* args)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      obj)))

(defmethod copy ((obj Carray-get) &rest initargs)
  (with-slots (var arg type)
    obj
    (make-instance 'Carray-get :var
                   (let* ((get1 (getf initargs 'var '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :var '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) var getfv))
                   :arg
                   (let* ((get1 (getf initargs 'arg '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :arg '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) arg getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv)))))

(defmethod store-object* ((obj Carray-get))
  (with-slots (var arg type)
    obj
    (reserve-space 4 (push-word (store-obj 'Carray-get))
                   (push-word (store-obj var))
                   (push-word (store-obj arg))
                   (push-word (store-obj type)))))

(defmethod update-fetched ((obj Carray-get))
  (with-slots (var arg type)
    obj
    (setf var (fetch-obj (stored-word 1)))
    (setf arg (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))))

(defmethod restore-object* ((obj Carray-get))
  (with-slots (var arg type)
    obj
    (let ((*restore-object-parent* obj))
      (when var
        (let ((*restore-object-parent-slot* 'var))
          (restore-object* var)))
      (when arg
        (let ((*restore-object-parent-slot* 'arg))
          (restore-object* arg)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      obj)))

(defmethod copy ((obj Crecord-get) &rest initargs)
  (with-slots (var arg type)
    obj
    (make-instance 'Crecord-get :var
                   (let* ((get1 (getf initargs 'var '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :var '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) var getfv))
                   :arg
                   (let* ((get1 (getf initargs 'arg '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :arg '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) arg getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv)))))

(defmethod store-object* ((obj Crecord-get))
  (with-slots (var arg type)
    obj
    (reserve-space 4 (push-word (store-obj 'Crecord-get))
                   (push-word (store-obj var))
                   (push-word (store-obj arg))
                   (push-word (store-obj type)))))

(defmethod update-fetched ((obj Crecord-get))
  (with-slots (var arg type)
    obj
    (setf var (fetch-obj (stored-word 1)))
    (setf arg (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))))

(defmethod restore-object* ((obj Crecord-get))
  (with-slots (var arg type)
    obj
    (let ((*restore-object-parent* obj))
      (when var
        (let ((*restore-object-parent-slot* 'var))
          (restore-object* var)))
      (when arg
        (let ((*restore-object-parent-slot* 'arg))
          (restore-object* arg)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      obj)))

(defmethod copy ((obj C-var) &rest initargs)
  (with-slots (type name safe)
    obj
    (make-instance 'C-var :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :name
                   (let* ((get1 (getf initargs 'name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) name getfv))
                   :safe
                   (let* ((get1 (getf initargs 'safe '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :safe '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) safe getfv)))))

(defmethod store-object* ((obj C-var))
  (with-slots (type name safe)
    obj
    (reserve-space 4 (push-word (store-obj 'C-var))
                   (push-word (store-obj type))
                   (push-word (store-obj name))
                   (push-word (store-obj safe)))))

(defmethod update-fetched ((obj C-var))
  (with-slots (type name safe)
    obj
    (setf type (fetch-obj (stored-word 1)))
    (setf name (fetch-obj (stored-word 2)))
    (setf safe (fetch-obj (stored-word 3)))))

(defmethod restore-object* ((obj C-var))
  (with-slots (type name safe)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when name
        (let ((*restore-object-parent-slot* 'name))
          (restore-object* name)))
      (when safe
        (let ((*restore-object-parent-slot* 'safe))
          (restore-object* safe)))
      obj)))

(defmethod copy ((obj Ccode) &rest initargs)
  (with-slots nil obj (make-instance 'Ccode)))

(defmethod store-object* ((obj Ccode))
  (with-slots nil obj (reserve-space 1 (push-word (store-obj 'Ccode)))))

(defmethod update-fetched ((obj Ccode)) (with-slots nil obj))

(defmethod restore-object* ((obj Ccode))
  (with-slots nil obj (let ((*restore-object-parent* obj)) obj)))

(defmethod copy ((obj C-expr) &rest initargs)
  (with-slots (var instr destr)
    obj
    (make-instance 'C-expr :var
                   (let* ((get1 (getf initargs 'var '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :var '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) var getfv))
                   :instr
                   (let* ((get1 (getf initargs 'instr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :instr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) instr getfv))
                   :destr
                   (let* ((get1 (getf initargs 'destr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :destr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) destr getfv)))))

(defmethod store-object* ((obj C-expr))
  (with-slots (var instr destr)
    obj
    (reserve-space 4 (push-word (store-obj 'C-expr))
                   (push-word (store-obj var))
                   (push-word (store-obj instr))
                   (push-word (store-obj destr)))))

(defmethod update-fetched ((obj C-expr))
  (with-slots (var instr destr)
    obj
    (setf var (fetch-obj (stored-word 1)))
    (setf instr (fetch-obj (stored-word 2)))
    (setf destr (fetch-obj (stored-word 3)))))

(defmethod restore-object* ((obj C-expr))
  (with-slots (var instr destr)
    obj
    (let ((*restore-object-parent* obj))
      (when var
        (let ((*restore-object-parent-slot* 'var))
          (restore-object* var)))
      (when instr
        (let ((*restore-object-parent-slot* 'instr))
          (restore-object* instr)))
      (when destr
        (let ((*restore-object-parent-slot* 'destr))
          (restore-object* destr)))
      obj)))

(defmethod copy ((obj C-named-type) &rest initargs)
  (with-slots (bang name)
    obj
    (make-instance 'C-named-type :bang
                   (let* ((get1 (getf initargs 'bang '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :bang '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) bang getfv))
                   :name
                   (let* ((get1 (getf initargs 'name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) name getfv)))))

(defmethod store-object* ((obj C-named-type))
  (with-slots (bang name)
    obj
    (reserve-space 3 (push-word (store-obj 'C-named-type))
                   (push-word (store-obj bang))
                   (push-word (store-obj name)))))

(defmethod update-fetched ((obj C-named-type))
  (with-slots (bang name)
    obj
    (setf bang (fetch-obj (stored-word 1)))
    (setf name (fetch-obj (stored-word 2)))))

(defmethod restore-object* ((obj C-named-type))
  (with-slots (bang name)
    obj
    (let ((*restore-object-parent* obj))
      (when bang
        (let ((*restore-object-parent-slot* 'bang))
          (restore-object* bang)))
      (when name
        (let ((*restore-object-parent-slot* 'name))
          (restore-object* name)))
      obj)))

(defmethod copy ((obj C-closure) &rest initargs)
  (with-slots (bang)
    obj
    (make-instance 'C-closure :bang
                   (let* ((get1 (getf initargs 'bang '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :bang '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) bang getfv)))))

(defmethod store-object* ((obj C-closure))
  (with-slots (bang)
    obj
    (reserve-space 2 (push-word (store-obj 'C-closure))
                   (push-word (store-obj bang)))))

(defmethod update-fetched ((obj C-closure))
  (with-slots (bang) obj (setf bang (fetch-obj (stored-word 1)))))

(defmethod restore-object* ((obj C-closure))
  (with-slots (bang)
    obj
    (let ((*restore-object-parent* obj))
      (when bang
        (let ((*restore-object-parent-slot* 'bang))
          (restore-object* bang)))
      obj)))

(defmethod copy ((obj C-struct) &rest initargs)
  (with-slots (bang name args)
    obj
    (make-instance 'C-struct :bang
                   (let* ((get1 (getf initargs 'bang '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :bang '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) bang getfv))
                   :name
                   (let* ((get1 (getf initargs 'name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) name getfv))
                   :args
                   (let* ((get1 (getf initargs 'args '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :args '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) args getfv)))))

(defmethod store-object* ((obj C-struct))
  (with-slots (bang name args)
    obj
    (reserve-space 4 (push-word (store-obj 'C-struct))
                   (push-word (store-obj bang))
                   (push-word (store-obj name))
                   (push-word (store-obj args)))))

(defmethod update-fetched ((obj C-struct))
  (with-slots (bang name args)
    obj
    (setf bang (fetch-obj (stored-word 1)))
    (setf name (fetch-obj (stored-word 2)))
    (setf args (fetch-obj (stored-word 3)))))

(defmethod restore-object* ((obj C-struct))
  (with-slots (bang name args)
    obj
    (let ((*restore-object-parent* obj))
      (when bang
        (let ((*restore-object-parent-slot* 'bang))
          (restore-object* bang)))
      (when name
        (let ((*restore-object-parent-slot* 'name))
          (restore-object* name)))
      (when args
        (let ((*restore-object-parent-slot* 'args))
          (restore-object* args)))
      obj)))

(defmethod copy ((obj C-array) &rest initargs)
  (with-slots (bang target size)
    obj
    (make-instance 'C-array :bang
                   (let* ((get1 (getf initargs 'bang '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :bang '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) bang getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :size
                   (let* ((get1 (getf initargs 'size '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :size '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) size getfv)))))

(defmethod store-object* ((obj C-array))
  (with-slots (bang target size)
    obj
    (reserve-space 4 (push-word (store-obj 'C-array))
                   (push-word (store-obj bang))
                   (push-word (store-obj target))
                   (push-word (store-obj size)))))

(defmethod update-fetched ((obj C-array))
  (with-slots (bang target size)
    obj
    (setf bang (fetch-obj (stored-word 1)))
    (setf target (fetch-obj (stored-word 2)))
    (setf size (fetch-obj (stored-word 3)))))

(defmethod restore-object* ((obj C-array))
  (with-slots (bang target size)
    obj
    (let ((*restore-object-parent* obj))
      (when bang
        (let ((*restore-object-parent-slot* 'bang))
          (restore-object* bang)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when size
        (let ((*restore-object-parent-slot* 'size))
          (restore-object* size)))
      obj)))

(defmethod copy ((obj C-mpq) &rest initargs)
  (with-slots nil obj (make-instance 'C-mpq)))

(defmethod store-object* ((obj C-mpq))
  (with-slots nil obj (reserve-space 1 (push-word (store-obj 'C-mpq)))))

(defmethod update-fetched ((obj C-mpq)) (with-slots nil obj))

(defmethod restore-object* ((obj C-mpq))
  (with-slots nil obj (let ((*restore-object-parent* obj)) obj)))

(defmethod copy ((obj C-mpz) &rest initargs)
  (with-slots (range)
    obj
    (make-instance 'C-mpz :range
                   (let* ((get1 (getf initargs 'range '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :range '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) range getfv)))))

(defmethod store-object* ((obj C-mpz))
  (with-slots (range)
    obj
    (reserve-space 2 (push-word (store-obj 'C-mpz))
                   (push-word (store-obj range)))))

(defmethod update-fetched ((obj C-mpz))
  (with-slots (range) obj (setf range (fetch-obj (stored-word 1)))))

(defmethod restore-object* ((obj C-mpz))
  (with-slots (range)
    obj
    (let ((*restore-object-parent* obj))
      (when range
        (let ((*restore-object-parent-slot* 'range))
          (restore-object* range)))
      obj)))

(defmethod copy ((obj C-uli) &rest initargs)
  (with-slots (range)
    obj
    (make-instance 'C-uli :range
                   (let* ((get1 (getf initargs 'range '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :range '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) range getfv)))))

(defmethod store-object* ((obj C-uli))
  (with-slots (range)
    obj
    (reserve-space 2 (push-word (store-obj 'C-uli))
                   (push-word (store-obj range)))))

(defmethod update-fetched ((obj C-uli))
  (with-slots (range) obj (setf range (fetch-obj (stored-word 1)))))

(defmethod restore-object* ((obj C-uli))
  (with-slots (range)
    obj
    (let ((*restore-object-parent* obj))
      (when range
        (let ((*restore-object-parent-slot* 'range))
          (restore-object* range)))
      obj)))

(defmethod copy ((obj C-int) &rest initargs)
  (with-slots (range)
    obj
    (make-instance 'C-int :range
                   (let* ((get1 (getf initargs 'range '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :range '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) range getfv)))))

(defmethod store-object* ((obj C-int))
  (with-slots (range)
    obj
    (reserve-space 2 (push-word (store-obj 'C-int))
                   (push-word (store-obj range)))))

(defmethod update-fetched ((obj C-int))
  (with-slots (range) obj (setf range (fetch-obj (stored-word 1)))))

(defmethod restore-object* ((obj C-int))
  (with-slots (range)
    obj
    (let ((*restore-object-parent* obj))
      (when range
        (let ((*restore-object-parent-slot* 'range))
          (restore-object* range)))
      obj)))

(defmethod copy ((obj C-integer) &rest initargs)
  (with-slots (range)
    obj
    (make-instance 'C-integer :range
                   (let* ((get1 (getf initargs 'range '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :range '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) range getfv)))))

(defmethod store-object* ((obj C-integer))
  (with-slots (range)
    obj
    (reserve-space 2 (push-word (store-obj 'C-integer))
                   (push-word (store-obj range)))))

(defmethod update-fetched ((obj C-integer))
  (with-slots (range) obj (setf range (fetch-obj (stored-word 1)))))

(defmethod restore-object* ((obj C-integer))
  (with-slots (range)
    obj
    (let ((*restore-object-parent* obj))
      (when range
        (let ((*restore-object-parent-slot* 'range))
          (restore-object* range)))
      obj)))

(defmethod copy ((obj C-number) &rest initargs)
  (with-slots nil obj (make-instance 'C-number)))

(defmethod store-object* ((obj C-number))
  (with-slots nil
    obj
    (reserve-space 1 (push-word (store-obj 'C-number)))))

(defmethod update-fetched ((obj C-number)) (with-slots nil obj))

(defmethod restore-object* ((obj C-number))
  (with-slots nil obj (let ((*restore-object-parent* obj)) obj)))

(defmethod copy ((obj C-gmp) &rest initargs)
  (with-slots nil obj (make-instance 'C-gmp)))

(defmethod store-object* ((obj C-gmp))
  (with-slots nil obj (reserve-space 1 (push-word (store-obj 'C-gmp)))))

(defmethod update-fetched ((obj C-gmp)) (with-slots nil obj))

(defmethod restore-object* ((obj C-gmp))
  (with-slots nil obj (let ((*restore-object-parent* obj)) obj)))

(defmethod copy ((obj C-pointer) &rest initargs)
  (with-slots (bang)
    obj
    (make-instance 'C-pointer :bang
                   (let* ((get1 (getf initargs 'bang '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :bang '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) bang getfv)))))

(defmethod store-object* ((obj C-pointer))
  (with-slots (bang)
    obj
    (reserve-space 2 (push-word (store-obj 'C-pointer))
                   (push-word (store-obj bang)))))

(defmethod update-fetched ((obj C-pointer))
  (with-slots (bang) obj (setf bang (fetch-obj (stored-word 1)))))

(defmethod restore-object* ((obj C-pointer))
  (with-slots (bang)
    obj
    (let ((*restore-object-parent* obj))
      (when bang
        (let ((*restore-object-parent-slot* 'bang))
          (restore-object* bang)))
      obj)))

(defmethod copy ((obj C-base) &rest initargs)
  (with-slots nil obj (make-instance 'C-base)))

(defmethod store-object* ((obj C-base))
  (with-slots nil
    obj
    (reserve-space 1 (push-word (store-obj 'C-base)))))

(defmethod update-fetched ((obj C-base)) (with-slots nil obj))

(defmethod restore-object* ((obj C-base))
  (with-slots nil obj (let ((*restore-object-parent* obj)) obj)))

(defmethod copy ((obj C-type) &rest initargs)
  (with-slots nil obj (make-instance 'C-type)))

(defmethod store-object* ((obj C-type))
  (with-slots nil
    obj
    (reserve-space 1 (push-word (store-obj 'C-type)))))

(defmethod update-fetched ((obj C-type)) (with-slots nil obj))

(defmethod restore-object* ((obj C-type))
  (with-slots nil obj (let ((*restore-object-parent* obj)) obj)))

(defmethod copy ((obj C-range) &rest initargs)
  (with-slots (inf sup)
    obj
    (make-instance 'C-range :inf
                   (let* ((get1 (getf initargs 'inf '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :inf '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) inf getfv))
                   :sup
                   (let* ((get1 (getf initargs 'sup '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :sup '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) sup getfv)))))

(defmethod store-object* ((obj C-range))
  (with-slots (inf sup)
    obj
    (reserve-space 3 (push-word (store-obj 'C-range))
                   (push-word (store-obj inf))
                   (push-word (store-obj sup)))))

(defmethod update-fetched ((obj C-range))
  (with-slots (inf sup)
    obj
    (setf inf (fetch-obj (stored-word 1)))
    (setf sup (fetch-obj (stored-word 2)))))

(defmethod restore-object* ((obj C-range))
  (with-slots (inf sup)
    obj
    (let ((*restore-object-parent* obj))
      (when inf
        (let ((*restore-object-parent-slot* 'inf))
          (restore-object* inf)))
      (when sup
        (let ((*restore-object-parent-slot* 'sup))
          (restore-object* sup)))
      obj)))

(defmethod copy ((obj skolem-const-decl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type declared-type-string type definition
                     def-axiom positive-types eval-info)
    obj
    (make-instance 'skolem-const-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :def-axiom
                   (let* ((get1 (getf initargs 'def-axiom '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :def-axiom '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) def-axiom getfv))
                   :positive-types
                   (let* ((get1
                           (getf initargs 'positive-types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :positive-types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) positive-types getfv))
                   :eval-info
                   (let* ((get1 (getf initargs 'eval-info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :eval-info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) eval-info getfv)))))

(defmethod store-object* ((obj skolem-const-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type definition def-axiom
                     positive-types)
    obj
    (reserve-space 21 (push-word (store-obj 'skolem-const-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj definition))
                   (push-word (store-obj def-axiom))
                   (push-word (store-obj positive-types)))))

(defmethod update-fetched ((obj skolem-const-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type definition def-axiom
                     positive-types pvs-sxhash-value tcc-form
                     declared-type-string eval-info)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf declared-type (fetch-obj (stored-word 16)))
    (setf type (fetch-obj (stored-word 17)))
    (setf definition (fetch-obj (stored-word 18)))
    (setf def-axiom (fetch-obj (stored-word 19)))
    (setf positive-types (fetch-obj (stored-word 20)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf declared-type-string nil)
    (setf eval-info nil)))

(defmethod restore-object* ((obj skolem-const-decl))
  (with-slots (unique-id decl-formals formals declared-type type
                         definition def-axiom positive-types)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      (when def-axiom
        (let ((*restore-object-parent-slot* 'def-axiom))
          (restore-object* def-axiom)))
      (when positive-types
        (let ((*restore-object-parent-slot* 'positive-types))
          (restore-object* positive-types)))
      obj)))

(defmethod copy ((obj justification) &rest initargs)
  (with-slots (label rule subgoals xrule comment)
    obj
    (make-instance 'justification :label
                   (let* ((get1 (getf initargs 'label '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :label '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) label getfv))
                   :rule
                   (let* ((get1 (getf initargs 'rule '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :rule '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) rule getfv))
                   :subgoals
                   (let* ((get1 (getf initargs 'subgoals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :subgoals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) subgoals getfv))
                   :xrule
                   (let* ((get1 (getf initargs 'xrule '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :xrule '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) xrule getfv))
                   :comment
                   (let* ((get1 (getf initargs 'comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :comment '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) comment getfv)))))

(defmethod store-object* ((obj justification))
  (with-slots (label rule subgoals xrule comment)
    obj
    (reserve-space 6 (push-word (store-obj 'justification))
                   (push-word (store-obj label))
                   (push-word (store-obj rule))
                   (push-word (store-obj subgoals))
                   (push-word (store-obj xrule))
                   (push-word (store-obj comment)))))

(defmethod update-fetched ((obj justification))
  (with-slots (label rule subgoals xrule comment)
    obj
    (setf label (fetch-obj (stored-word 1)))
    (setf rule (fetch-obj (stored-word 2)))
    (setf subgoals (fetch-obj (stored-word 3)))
    (setf xrule (fetch-obj (stored-word 4)))
    (setf comment (fetch-obj (stored-word 5)))))

(defmethod restore-object* ((obj justification))
  (with-slots (label rule subgoals xrule comment)
    obj
    (let ((*restore-object-parent* obj))
      (when label
        (let ((*restore-object-parent-slot* 'label))
          (restore-object* label)))
      (when rule
        (let ((*restore-object-parent-slot* 'rule))
          (restore-object* rule)))
      (when subgoals
        (let ((*restore-object-parent-slot* 'subgoals))
          (restore-object* subgoals)))
      (when xrule
        (let ((*restore-object-parent-slot* 'xrule))
          (restore-object* xrule)))
      (when comment
        (let ((*restore-object-parent-slot* 'comment))
          (restore-object* comment)))
      obj)))

(defmethod copy ((obj strategy-entry) &rest initargs)
  (with-slots (name required-args optional-args docstring strategy-fun)
    obj
    (make-instance 'strategy-entry :name
                   (let* ((get1 (getf initargs 'name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) name getfv))
                   :required-args
                   (let* ((get1
                           (getf initargs 'required-args '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :required-args '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) required-args getfv))
                   :optional-args
                   (let* ((get1
                           (getf initargs 'optional-args '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :optional-args '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) optional-args getfv))
                   :docstring
                   (let* ((get1 (getf initargs 'docstring '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :docstring '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) docstring getfv))
                   :strategy-fun
                   (let* ((get1 (getf initargs 'strategy-fun '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :strategy-fun '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) strategy-fun getfv)))))

(defmethod store-object* ((obj strategy-entry))
  (with-slots (name required-args optional-args docstring strategy-fun)
    obj
    (reserve-space 6 (push-word (store-obj 'strategy-entry))
                   (push-word (store-obj name))
                   (push-word (store-obj required-args))
                   (push-word (store-obj optional-args))
                   (push-word (store-obj docstring))
                   (push-word (store-obj strategy-fun)))))

(defmethod update-fetched ((obj strategy-entry))
  (with-slots (name required-args optional-args docstring strategy-fun)
    obj
    (setf name (fetch-obj (stored-word 1)))
    (setf required-args (fetch-obj (stored-word 2)))
    (setf optional-args (fetch-obj (stored-word 3)))
    (setf docstring (fetch-obj (stored-word 4)))
    (setf strategy-fun (fetch-obj (stored-word 5)))))

(defmethod restore-object* ((obj strategy-entry))
  (with-slots (name required-args optional-args docstring strategy-fun)
    obj
    (let ((*restore-object-parent* obj))
      (when name
        (let ((*restore-object-parent-slot* 'name))
          (restore-object* name)))
      (when required-args
        (let ((*restore-object-parent-slot* 'required-args))
          (restore-object* required-args)))
      (when optional-args
        (let ((*restore-object-parent-slot* 'optional-args))
          (restore-object* optional-args)))
      (when docstring
        (let ((*restore-object-parent-slot* 'docstring))
          (restore-object* docstring)))
      (when strategy-fun
        (let ((*restore-object-parent-slot* 'strategy-fun))
          (restore-object* strategy-fun)))
      obj)))

(defmethod copy ((obj rulefun-entry) &rest initargs)
  (with-slots (name required-args optional-args docstring rulefun)
    obj
    (make-instance 'rulefun-entry :name
                   (let* ((get1 (getf initargs 'name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) name getfv))
                   :required-args
                   (let* ((get1
                           (getf initargs 'required-args '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :required-args '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) required-args getfv))
                   :optional-args
                   (let* ((get1
                           (getf initargs 'optional-args '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :optional-args '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) optional-args getfv))
                   :docstring
                   (let* ((get1 (getf initargs 'docstring '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :docstring '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) docstring getfv))
                   :rulefun
                   (let* ((get1 (getf initargs 'rulefun '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :rulefun '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) rulefun getfv)))))

(defmethod store-object* ((obj rulefun-entry))
  (with-slots (name required-args optional-args docstring rulefun)
    obj
    (reserve-space 6 (push-word (store-obj 'rulefun-entry))
                   (push-word (store-obj name))
                   (push-word (store-obj required-args))
                   (push-word (store-obj optional-args))
                   (push-word (store-obj docstring))
                   (push-word (store-obj rulefun)))))

(defmethod update-fetched ((obj rulefun-entry))
  (with-slots (name required-args optional-args docstring rulefun)
    obj
    (setf name (fetch-obj (stored-word 1)))
    (setf required-args (fetch-obj (stored-word 2)))
    (setf optional-args (fetch-obj (stored-word 3)))
    (setf docstring (fetch-obj (stored-word 4)))
    (setf rulefun (fetch-obj (stored-word 5)))))

(defmethod restore-object* ((obj rulefun-entry))
  (with-slots (name required-args optional-args docstring rulefun)
    obj
    (let ((*restore-object-parent* obj))
      (when name
        (let ((*restore-object-parent-slot* 'name))
          (restore-object* name)))
      (when required-args
        (let ((*restore-object-parent-slot* 'required-args))
          (restore-object* required-args)))
      (when optional-args
        (let ((*restore-object-parent-slot* 'optional-args))
          (restore-object* optional-args)))
      (when docstring
        (let ((*restore-object-parent-slot* 'docstring))
          (restore-object* docstring)))
      (when rulefun
        (let ((*restore-object-parent-slot* 'rulefun))
          (restore-object* rulefun)))
      obj)))

(defmethod copy ((obj strategy-instance) &rest initargs)
  (with-slots (strategy-fun strategy-input)
    obj
    (make-instance 'strategy-instance :strategy-fun
                   (let* ((get1 (getf initargs 'strategy-fun '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :strategy-fun '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) strategy-fun getfv))
                   :strategy-input
                   (let* ((get1
                           (getf initargs 'strategy-input '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :strategy-input '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) strategy-input getfv)))))

(defmethod store-object* ((obj strategy-instance))
  (with-slots (strategy-fun strategy-input)
    obj
    (reserve-space 3 (push-word (store-obj 'strategy-instance))
                   (push-word (store-obj strategy-fun))
                   (push-word (store-obj strategy-input)))))

(defmethod update-fetched ((obj strategy-instance))
  (with-slots (strategy-fun strategy-input)
    obj
    (setf strategy-fun (fetch-obj (stored-word 1)))
    (setf strategy-input (fetch-obj (stored-word 2)))))

(defmethod restore-object* ((obj strategy-instance))
  (with-slots (strategy-fun strategy-input)
    obj
    (let ((*restore-object-parent* obj))
      (when strategy-fun
        (let ((*restore-object-parent-slot* 'strategy-fun))
          (restore-object* strategy-fun)))
      (when strategy-input
        (let ((*restore-object-parent-slot* 'strategy-input))
          (restore-object* strategy-input)))
      obj)))

(defmethod copy ((obj defhelper-entry) &rest initargs)
  (with-slots (name source-formals source-defn formals defn docstring
                    format-string)
    obj
    (make-instance 'defhelper-entry :name
                   (let* ((get1 (getf initargs 'name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) name getfv))
                   :source-formals
                   (let* ((get1
                           (getf initargs 'source-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :source-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) source-formals getfv))
                   :source-defn
                   (let* ((get1 (getf initargs 'source-defn '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :source-defn '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) source-defn getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :defn
                   (let* ((get1 (getf initargs 'defn '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :defn '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) defn getfv))
                   :docstring
                   (let* ((get1 (getf initargs 'docstring '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :docstring '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) docstring getfv))
                   :format-string
                   (let* ((get1
                           (getf initargs 'format-string '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :format-string '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) format-string getfv)))))

(defmethod store-object* ((obj defhelper-entry))
  (with-slots (name source-formals source-defn formals defn docstring
                    format-string)
    obj
    (reserve-space 8 (push-word (store-obj 'defhelper-entry))
                   (push-word (store-obj name))
                   (push-word (store-obj source-formals))
                   (push-word (store-obj source-defn))
                   (push-word (store-obj formals))
                   (push-word (store-obj defn))
                   (push-word (store-obj docstring))
                   (push-word (store-obj format-string)))))

(defmethod update-fetched ((obj defhelper-entry))
  (with-slots (name source-formals source-defn formals defn docstring
                    format-string)
    obj
    (setf name (fetch-obj (stored-word 1)))
    (setf source-formals (fetch-obj (stored-word 2)))
    (setf source-defn (fetch-obj (stored-word 3)))
    (setf formals (fetch-obj (stored-word 4)))
    (setf defn (fetch-obj (stored-word 5)))
    (setf docstring (fetch-obj (stored-word 6)))
    (setf format-string (fetch-obj (stored-word 7)))))

(defmethod restore-object* ((obj defhelper-entry))
  (with-slots (name source-formals source-defn formals defn docstring
                    format-string)
    obj
    (let ((*restore-object-parent* obj))
      (when name
        (let ((*restore-object-parent-slot* 'name))
          (restore-object* name)))
      (when source-formals
        (let ((*restore-object-parent-slot* 'source-formals))
          (restore-object* source-formals)))
      (when source-defn
        (let ((*restore-object-parent-slot* 'source-defn))
          (restore-object* source-defn)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when defn
        (let ((*restore-object-parent-slot* 'defn))
          (restore-object* defn)))
      (when docstring
        (let ((*restore-object-parent-slot* 'docstring))
          (restore-object* docstring)))
      (when format-string
        (let ((*restore-object-parent-slot* 'format-string))
          (restore-object* format-string)))
      obj)))

(defmethod copy ((obj defstep-entry) &rest initargs)
  (with-slots (name source-formals source-defn formals defn docstring
                    format-string)
    obj
    (make-instance 'defstep-entry :name
                   (let* ((get1 (getf initargs 'name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) name getfv))
                   :source-formals
                   (let* ((get1
                           (getf initargs 'source-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :source-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) source-formals getfv))
                   :source-defn
                   (let* ((get1 (getf initargs 'source-defn '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :source-defn '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) source-defn getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :defn
                   (let* ((get1 (getf initargs 'defn '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :defn '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) defn getfv))
                   :docstring
                   (let* ((get1 (getf initargs 'docstring '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :docstring '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) docstring getfv))
                   :format-string
                   (let* ((get1
                           (getf initargs 'format-string '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :format-string '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) format-string getfv)))))

(defmethod store-object* ((obj defstep-entry))
  (with-slots (name source-formals source-defn formals defn docstring
                    format-string)
    obj
    (reserve-space 8 (push-word (store-obj 'defstep-entry))
                   (push-word (store-obj name))
                   (push-word (store-obj source-formals))
                   (push-word (store-obj source-defn))
                   (push-word (store-obj formals))
                   (push-word (store-obj defn))
                   (push-word (store-obj docstring))
                   (push-word (store-obj format-string)))))

(defmethod update-fetched ((obj defstep-entry))
  (with-slots (name source-formals source-defn formals defn docstring
                    format-string)
    obj
    (setf name (fetch-obj (stored-word 1)))
    (setf source-formals (fetch-obj (stored-word 2)))
    (setf source-defn (fetch-obj (stored-word 3)))
    (setf formals (fetch-obj (stored-word 4)))
    (setf defn (fetch-obj (stored-word 5)))
    (setf docstring (fetch-obj (stored-word 6)))
    (setf format-string (fetch-obj (stored-word 7)))))

(defmethod restore-object* ((obj defstep-entry))
  (with-slots (name source-formals source-defn formals defn docstring
                    format-string)
    obj
    (let ((*restore-object-parent* obj))
      (when name
        (let ((*restore-object-parent-slot* 'name))
          (restore-object* name)))
      (when source-formals
        (let ((*restore-object-parent-slot* 'source-formals))
          (restore-object* source-formals)))
      (when source-defn
        (let ((*restore-object-parent-slot* 'source-defn))
          (restore-object* source-defn)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when defn
        (let ((*restore-object-parent-slot* 'defn))
          (restore-object* defn)))
      (when docstring
        (let ((*restore-object-parent-slot* 'docstring))
          (restore-object* docstring)))
      (when format-string
        (let ((*restore-object-parent-slot* 'format-string))
          (restore-object* format-string)))
      obj)))

(defmethod copy ((obj defrule-entry) &rest initargs)
  (with-slots (name source-formals source-defn formals defn docstring
                    format-string)
    obj
    (make-instance 'defrule-entry :name
                   (let* ((get1 (getf initargs 'name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) name getfv))
                   :source-formals
                   (let* ((get1
                           (getf initargs 'source-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :source-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) source-formals getfv))
                   :source-defn
                   (let* ((get1 (getf initargs 'source-defn '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :source-defn '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) source-defn getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :defn
                   (let* ((get1 (getf initargs 'defn '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :defn '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) defn getfv))
                   :docstring
                   (let* ((get1 (getf initargs 'docstring '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :docstring '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) docstring getfv))
                   :format-string
                   (let* ((get1
                           (getf initargs 'format-string '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :format-string '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) format-string getfv)))))

(defmethod store-object* ((obj defrule-entry))
  (with-slots (name source-formals source-defn formals defn docstring
                    format-string)
    obj
    (reserve-space 8 (push-word (store-obj 'defrule-entry))
                   (push-word (store-obj name))
                   (push-word (store-obj source-formals))
                   (push-word (store-obj source-defn))
                   (push-word (store-obj formals))
                   (push-word (store-obj defn))
                   (push-word (store-obj docstring))
                   (push-word (store-obj format-string)))))

(defmethod update-fetched ((obj defrule-entry))
  (with-slots (name source-formals source-defn formals defn docstring
                    format-string)
    obj
    (setf name (fetch-obj (stored-word 1)))
    (setf source-formals (fetch-obj (stored-word 2)))
    (setf source-defn (fetch-obj (stored-word 3)))
    (setf formals (fetch-obj (stored-word 4)))
    (setf defn (fetch-obj (stored-word 5)))
    (setf docstring (fetch-obj (stored-word 6)))
    (setf format-string (fetch-obj (stored-word 7)))))

(defmethod restore-object* ((obj defrule-entry))
  (with-slots (name source-formals source-defn formals defn docstring
                    format-string)
    obj
    (let ((*restore-object-parent* obj))
      (when name
        (let ((*restore-object-parent-slot* 'name))
          (restore-object* name)))
      (when source-formals
        (let ((*restore-object-parent-slot* 'source-formals))
          (restore-object* source-formals)))
      (when source-defn
        (let ((*restore-object-parent-slot* 'source-defn))
          (restore-object* source-defn)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when defn
        (let ((*restore-object-parent-slot* 'defn))
          (restore-object* defn)))
      (when docstring
        (let ((*restore-object-parent-slot* 'docstring))
          (restore-object* docstring)))
      (when format-string
        (let ((*restore-object-parent-slot* 'format-string))
          (restore-object* format-string)))
      obj)))

(defmethod copy ((obj rule-instance) &rest initargs)
  (with-slots (rule rule-input rule-format)
    obj
    (make-instance 'rule-instance :rule
                   (let* ((get1 (getf initargs 'rule '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :rule '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) rule getfv))
                   :rule-input
                   (let* ((get1 (getf initargs 'rule-input '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :rule-input '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) rule-input getfv))
                   :rule-format
                   (let* ((get1 (getf initargs 'rule-format '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :rule-format '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) rule-format getfv)))))

(defmethod store-object* ((obj rule-instance))
  (with-slots (rule-input rule-format)
    obj
    (reserve-space 3 (push-word (store-obj 'rule-instance))
                   (push-word (store-obj rule-input))
                   (push-word (store-obj rule-format)))))

(defmethod update-fetched ((obj rule-instance))
  (with-slots (rule-input rule-format rule)
    obj
    (setf rule-input (fetch-obj (stored-word 1)))
    (setf rule-format (fetch-obj (stored-word 2)))
    (setf rule nil)))

(defmethod restore-object* ((obj rule-instance))
  (with-slots (rule-input rule-format)
    obj
    (let ((*restore-object-parent* obj))
      (when rule-input
        (let ((*restore-object-parent-slot* 'rule-input))
          (restore-object* rule-input)))
      (when rule-format
        (let ((*restore-object-parent-slot* 'rule-format))
          (restore-object* rule-format)))
      obj)))

(defmethod copy ((obj rule-entry) &rest initargs)
  (with-slots (name required-args optional-args docstring rule-function
                    format-string)
    obj
    (make-instance 'rule-entry :name
                   (let* ((get1 (getf initargs 'name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) name getfv))
                   :required-args
                   (let* ((get1
                           (getf initargs 'required-args '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :required-args '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) required-args getfv))
                   :optional-args
                   (let* ((get1
                           (getf initargs 'optional-args '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :optional-args '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) optional-args getfv))
                   :docstring
                   (let* ((get1 (getf initargs 'docstring '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :docstring '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) docstring getfv))
                   :rule-function
                   (let* ((get1
                           (getf initargs 'rule-function '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :rule-function '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) rule-function getfv))
                   :format-string
                   (let* ((get1
                           (getf initargs 'format-string '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :format-string '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) format-string getfv)))))

(defmethod store-object* ((obj rule-entry))
  (with-slots (name required-args optional-args docstring rule-function
                    format-string)
    obj
    (reserve-space 7 (push-word (store-obj 'rule-entry))
                   (push-word (store-obj name))
                   (push-word (store-obj required-args))
                   (push-word (store-obj optional-args))
                   (push-word (store-obj docstring))
                   (push-word (store-obj rule-function))
                   (push-word (store-obj format-string)))))

(defmethod update-fetched ((obj rule-entry))
  (with-slots (name required-args optional-args docstring rule-function
                    format-string)
    obj
    (setf name (fetch-obj (stored-word 1)))
    (setf required-args (fetch-obj (stored-word 2)))
    (setf optional-args (fetch-obj (stored-word 3)))
    (setf docstring (fetch-obj (stored-word 4)))
    (setf rule-function (fetch-obj (stored-word 5)))
    (setf format-string (fetch-obj (stored-word 6)))))

(defmethod restore-object* ((obj rule-entry))
  (with-slots (name required-args optional-args docstring rule-function
                    format-string)
    obj
    (let ((*restore-object-parent* obj))
      (when name
        (let ((*restore-object-parent-slot* 'name))
          (restore-object* name)))
      (when required-args
        (let ((*restore-object-parent-slot* 'required-args))
          (restore-object* required-args)))
      (when optional-args
        (let ((*restore-object-parent-slot* 'optional-args))
          (restore-object* optional-args)))
      (when docstring
        (let ((*restore-object-parent-slot* 'docstring))
          (restore-object* docstring)))
      (when rule-function
        (let ((*restore-object-parent-slot* 'rule-function))
          (restore-object* rule-function)))
      (when format-string
        (let ((*restore-object-parent-slot* 'format-string))
          (restore-object* format-string)))
      obj)))

(defmethod copy ((obj entry) &rest initargs)
  (with-slots (name required-args optional-args docstring)
    obj
    (make-instance 'entry :name
                   (let* ((get1 (getf initargs 'name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) name getfv))
                   :required-args
                   (let* ((get1
                           (getf initargs 'required-args '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :required-args '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) required-args getfv))
                   :optional-args
                   (let* ((get1
                           (getf initargs 'optional-args '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :optional-args '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) optional-args getfv))
                   :docstring
                   (let* ((get1 (getf initargs 'docstring '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :docstring '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) docstring getfv)))))

(defmethod store-object* ((obj entry))
  (with-slots (name required-args optional-args docstring)
    obj
    (reserve-space 5 (push-word (store-obj 'entry))
                   (push-word (store-obj name))
                   (push-word (store-obj required-args))
                   (push-word (store-obj optional-args))
                   (push-word (store-obj docstring)))))

(defmethod update-fetched ((obj entry))
  (with-slots (name required-args optional-args docstring)
    obj
    (setf name (fetch-obj (stored-word 1)))
    (setf required-args (fetch-obj (stored-word 2)))
    (setf optional-args (fetch-obj (stored-word 3)))
    (setf docstring (fetch-obj (stored-word 4)))))

(defmethod restore-object* ((obj entry))
  (with-slots (name required-args optional-args docstring)
    obj
    (let ((*restore-object-parent* obj))
      (when name
        (let ((*restore-object-parent-slot* 'name))
          (restore-object* name)))
      (when required-args
        (let ((*restore-object-parent-slot* 'required-args))
          (restore-object* required-args)))
      (when optional-args
        (let ((*restore-object-parent-slot* 'optional-args))
          (restore-object* optional-args)))
      (when docstring
        (let ((*restore-object-parent-slot* 'docstring))
          (restore-object* docstring)))
      obj)))

(defmethod copy ((obj rulemacro) &rest initargs)
  (with-slots (rule-list)
    obj
    (make-instance 'rulemacro :rule-list
                   (let* ((get1 (getf initargs 'rule-list '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :rule-list '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) rule-list getfv)))))

(defmethod store-object* ((obj rulemacro))
  (with-slots (rule-list)
    obj
    (reserve-space 2 (push-word (store-obj 'rulemacro))
                   (push-word (store-obj rule-list)))))

(defmethod update-fetched ((obj rulemacro))
  (with-slots (rule-list)
    obj
    (setf rule-list (fetch-obj (stored-word 1)))))

(defmethod restore-object* ((obj rulemacro))
  (with-slots (rule-list)
    obj
    (let ((*restore-object-parent* obj))
      (when rule-list
        (let ((*restore-object-parent-slot* 'rule-list))
          (restore-object* rule-list)))
      obj)))

(defmethod copy ((obj strategy) &rest initargs)
  (with-slots (topstep subgoal-strategy failure-strategy)
    obj
    (make-instance 'strategy :topstep
                   (let* ((get1 (getf initargs 'topstep '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :topstep '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) topstep getfv))
                   :subgoal-strategy
                   (let* ((get1
                           (getf initargs 'subgoal-strategy '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :subgoal-strategy
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) subgoal-strategy getfv))
                   :failure-strategy
                   (let* ((get1
                           (getf initargs 'failure-strategy '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :failure-strategy
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) failure-strategy getfv)))))

(defmethod store-object* ((obj strategy))
  (with-slots (topstep subgoal-strategy failure-strategy)
    obj
    (reserve-space 4 (push-word (store-obj 'strategy))
                   (push-word (store-obj topstep))
                   (push-word (store-obj subgoal-strategy))
                   (push-word (store-obj failure-strategy)))))

(defmethod update-fetched ((obj strategy))
  (with-slots (topstep subgoal-strategy failure-strategy)
    obj
    (setf topstep (fetch-obj (stored-word 1)))
    (setf subgoal-strategy (fetch-obj (stored-word 2)))
    (setf failure-strategy (fetch-obj (stored-word 3)))))

(defmethod restore-object* ((obj strategy))
  (with-slots (topstep subgoal-strategy failure-strategy)
    obj
    (let ((*restore-object-parent* obj))
      (when topstep
        (let ((*restore-object-parent-slot* 'topstep))
          (restore-object* topstep)))
      (when subgoal-strategy
        (let ((*restore-object-parent-slot* 'subgoal-strategy))
          (restore-object* subgoal-strategy)))
      (when failure-strategy
        (let ((*restore-object-parent-slot* 'failure-strategy))
          (restore-object* failure-strategy)))
      obj)))

(defmethod copy ((obj strat-proofstate) &rest initargs)
  (with-slots (label current-goal current-rule dp-state done-subgoals
                     pending-subgoals current-subgoal
                     remaining-subgoals status-flag subgoalnum
                     justification current-input parsed-input printout
                     comment strategy context parent-proofstate
                     proof-dependent-decls dependent-decls
                     current-auto-rewrites tcc-hash subtype-hash
                     rewrite-hash typepred-hash current-xrule)
    obj
    (make-instance 'strat-proofstate :label
                   (let* ((get1 (getf initargs 'label '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :label '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) label getfv))
                   :current-goal
                   (let* ((get1 (getf initargs 'current-goal '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :current-goal '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) current-goal getfv))
                   :current-rule
                   (let* ((get1 (getf initargs 'current-rule '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :current-rule '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) current-rule getfv))
                   :dp-state
                   (let* ((get1 (getf initargs 'dp-state '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dp-state '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dp-state getfv))
                   :done-subgoals
                   (let* ((get1
                           (getf initargs 'done-subgoals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :done-subgoals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) done-subgoals getfv))
                   :pending-subgoals
                   (let* ((get1
                           (getf initargs 'pending-subgoals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pending-subgoals
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) pending-subgoals getfv))
                   :current-subgoal
                   (let* ((get1
                           (getf initargs 'current-subgoal '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :current-subgoal
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) current-subgoal getfv))
                   :remaining-subgoals
                   (let* ((get1
                           (getf initargs 'remaining-subgoals
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :remaining-subgoals
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) remaining-subgoals getfv))
                   :status-flag
                   (let* ((get1 (getf initargs 'status-flag '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :status-flag '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) status-flag getfv))
                   :subgoalnum
                   (let* ((get1 (getf initargs 'subgoalnum '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :subgoalnum '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) subgoalnum getfv))
                   :justification
                   (let* ((get1
                           (getf initargs 'justification '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :justification '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) justification getfv))
                   :current-input
                   (let* ((get1
                           (getf initargs 'current-input '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :current-input '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) current-input getfv))
                   :parsed-input
                   (let* ((get1 (getf initargs 'parsed-input '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parsed-input '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parsed-input getfv))
                   :printout
                   (let* ((get1 (getf initargs 'printout '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :printout '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) printout getfv))
                   :comment
                   (let* ((get1 (getf initargs 'comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :comment '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) comment getfv))
                   :strategy
                   (let* ((get1 (getf initargs 'strategy '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :strategy '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) strategy getfv))
                   :context
                   (let* ((get1 (getf initargs 'context '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :context '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) context getfv))
                   :parent-proofstate
                   (let* ((get1
                           (getf initargs 'parent-proofstate '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :parent-proofstate
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parent-proofstate getfv))
                   :proof-dependent-decls
                   (let* ((get1
                           (getf initargs 'proof-dependent-decls
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :proof-dependent-decls
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         proof-dependent-decls
                       getfv))
                   :dependent-decls
                   (let* ((get1
                           (getf initargs 'dependent-decls '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :dependent-decls
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dependent-decls getfv))
                   :current-auto-rewrites
                   (let* ((get1
                           (getf initargs 'current-auto-rewrites
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :current-auto-rewrites
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         current-auto-rewrites
                       getfv))
                   :tcc-hash
                   (let* ((get1 (getf initargs 'tcc-hash '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-hash '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-hash getfv))
                   :subtype-hash
                   (let* ((get1 (getf initargs 'subtype-hash '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :subtype-hash '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) subtype-hash getfv))
                   :rewrite-hash
                   (let* ((get1 (getf initargs 'rewrite-hash '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :rewrite-hash '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) rewrite-hash getfv))
                   :typepred-hash
                   (let* ((get1
                           (getf initargs 'typepred-hash '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typepred-hash '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typepred-hash getfv))
                   :current-xrule
                   (let* ((get1
                           (getf initargs 'current-xrule '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :current-xrule '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) current-xrule getfv)))))

(defmethod store-object* ((obj strat-proofstate))
  (with-slots (label current-goal current-rule dp-state done-subgoals
                     pending-subgoals current-subgoal
                     remaining-subgoals status-flag subgoalnum
                     justification current-input parsed-input printout
                     comment strategy context parent-proofstate
                     proof-dependent-decls dependent-decls
                     current-auto-rewrites tcc-hash subtype-hash
                     rewrite-hash typepred-hash current-xrule)
    obj
    (reserve-space 27 (push-word (store-obj 'strat-proofstate))
                   (push-word (store-obj label))
                   (push-word (store-obj current-goal))
                   (push-word (store-obj current-rule))
                   (push-word (store-obj dp-state))
                   (push-word (store-obj done-subgoals))
                   (push-word (store-obj pending-subgoals))
                   (push-word (store-obj current-subgoal))
                   (push-word (store-obj remaining-subgoals))
                   (push-word (store-obj status-flag))
                   (push-word (store-obj subgoalnum))
                   (push-word (store-obj justification))
                   (push-word (store-obj current-input))
                   (push-word (store-obj parsed-input))
                   (push-word (store-obj printout))
                   (push-word (store-obj comment))
                   (push-word (store-obj strategy))
                   (push-word (store-obj context))
                   (push-word (store-obj parent-proofstate))
                   (push-word (store-obj proof-dependent-decls))
                   (push-word (store-obj dependent-decls))
                   (push-word (store-obj current-auto-rewrites))
                   (push-word (store-obj tcc-hash))
                   (push-word (store-obj subtype-hash))
                   (push-word (store-obj rewrite-hash))
                   (push-word (store-obj typepred-hash))
                   (push-word (store-obj current-xrule)))))

(defmethod update-fetched ((obj strat-proofstate))
  (with-slots (label current-goal current-rule dp-state done-subgoals
                     pending-subgoals current-subgoal
                     remaining-subgoals status-flag subgoalnum
                     justification current-input parsed-input printout
                     comment strategy context parent-proofstate
                     proof-dependent-decls dependent-decls
                     current-auto-rewrites tcc-hash subtype-hash
                     rewrite-hash typepred-hash current-xrule)
    obj
    (setf label (fetch-obj (stored-word 1)))
    (setf current-goal (fetch-obj (stored-word 2)))
    (setf current-rule (fetch-obj (stored-word 3)))
    (setf dp-state (fetch-obj (stored-word 4)))
    (setf done-subgoals (fetch-obj (stored-word 5)))
    (setf pending-subgoals (fetch-obj (stored-word 6)))
    (setf current-subgoal (fetch-obj (stored-word 7)))
    (setf remaining-subgoals (fetch-obj (stored-word 8)))
    (setf status-flag (fetch-obj (stored-word 9)))
    (setf subgoalnum (fetch-obj (stored-word 10)))
    (setf justification (fetch-obj (stored-word 11)))
    (setf current-input (fetch-obj (stored-word 12)))
    (setf parsed-input (fetch-obj (stored-word 13)))
    (setf printout (fetch-obj (stored-word 14)))
    (setf comment (fetch-obj (stored-word 15)))
    (setf strategy (fetch-obj (stored-word 16)))
    (setf context (fetch-obj (stored-word 17)))
    (setf parent-proofstate (fetch-obj (stored-word 18)))
    (setf proof-dependent-decls (fetch-obj (stored-word 19)))
    (setf dependent-decls (fetch-obj (stored-word 20)))
    (setf current-auto-rewrites (fetch-obj (stored-word 21)))
    (setf tcc-hash (fetch-obj (stored-word 22)))
    (setf subtype-hash (fetch-obj (stored-word 23)))
    (setf rewrite-hash (fetch-obj (stored-word 24)))
    (setf typepred-hash (fetch-obj (stored-word 25)))
    (setf current-xrule (fetch-obj (stored-word 26)))))

(defmethod restore-object* ((obj strat-proofstate))
  (with-slots (label current-goal current-rule dp-state done-subgoals
                     pending-subgoals current-subgoal
                     remaining-subgoals status-flag subgoalnum
                     justification current-input parsed-input printout
                     comment strategy context parent-proofstate
                     proof-dependent-decls dependent-decls
                     current-auto-rewrites tcc-hash subtype-hash
                     rewrite-hash typepred-hash current-xrule)
    obj
    (let ((*restore-object-parent* obj))
      (when label
        (let ((*restore-object-parent-slot* 'label))
          (restore-object* label)))
      (when current-goal
        (let ((*restore-object-parent-slot* 'current-goal))
          (restore-object* current-goal)))
      (when current-rule
        (let ((*restore-object-parent-slot* 'current-rule))
          (restore-object* current-rule)))
      (when dp-state
        (let ((*restore-object-parent-slot* 'dp-state))
          (restore-object* dp-state)))
      (when done-subgoals
        (let ((*restore-object-parent-slot* 'done-subgoals))
          (restore-object* done-subgoals)))
      (when pending-subgoals
        (let ((*restore-object-parent-slot* 'pending-subgoals))
          (restore-object* pending-subgoals)))
      (when current-subgoal
        (let ((*restore-object-parent-slot* 'current-subgoal))
          (restore-object* current-subgoal)))
      (when remaining-subgoals
        (let ((*restore-object-parent-slot* 'remaining-subgoals))
          (restore-object* remaining-subgoals)))
      (when status-flag
        (let ((*restore-object-parent-slot* 'status-flag))
          (restore-object* status-flag)))
      (when subgoalnum
        (let ((*restore-object-parent-slot* 'subgoalnum))
          (restore-object* subgoalnum)))
      (when justification
        (let ((*restore-object-parent-slot* 'justification))
          (restore-object* justification)))
      (when current-input
        (let ((*restore-object-parent-slot* 'current-input))
          (restore-object* current-input)))
      (when parsed-input
        (let ((*restore-object-parent-slot* 'parsed-input))
          (restore-object* parsed-input)))
      (when printout
        (let ((*restore-object-parent-slot* 'printout))
          (restore-object* printout)))
      (when comment
        (let ((*restore-object-parent-slot* 'comment))
          (restore-object* comment)))
      (when strategy
        (let ((*restore-object-parent-slot* 'strategy))
          (restore-object* strategy)))
      (when context
        (let ((*restore-object-parent-slot* 'context))
          (restore-object* context)))
      (when parent-proofstate
        (let ((*restore-object-parent-slot* 'parent-proofstate))
          (restore-object* parent-proofstate)))
      (when proof-dependent-decls
        (let ((*restore-object-parent-slot* 'proof-dependent-decls))
          (restore-object* proof-dependent-decls)))
      (when dependent-decls
        (let ((*restore-object-parent-slot* 'dependent-decls))
          (restore-object* dependent-decls)))
      (when current-auto-rewrites
        (let ((*restore-object-parent-slot* 'current-auto-rewrites))
          (restore-object* current-auto-rewrites)))
      (when tcc-hash
        (let ((*restore-object-parent-slot* 'tcc-hash))
          (restore-object* tcc-hash)))
      (when subtype-hash
        (let ((*restore-object-parent-slot* 'subtype-hash))
          (restore-object* subtype-hash)))
      (when rewrite-hash
        (let ((*restore-object-parent-slot* 'rewrite-hash))
          (restore-object* rewrite-hash)))
      (when typepred-hash
        (let ((*restore-object-parent-slot* 'typepred-hash))
          (restore-object* typepred-hash)))
      (when current-xrule
        (let ((*restore-object-parent-slot* 'current-xrule))
          (restore-object* current-xrule)))
      obj)))

(defmethod copy ((obj top-proofstate) &rest initargs)
  (with-slots (label current-goal current-rule dp-state done-subgoals
                     pending-subgoals current-subgoal
                     remaining-subgoals status-flag subgoalnum
                     justification current-input parsed-input printout
                     comment strategy context parent-proofstate
                     proof-dependent-decls dependent-decls
                     current-auto-rewrites tcc-hash subtype-hash
                     rewrite-hash typepred-hash current-xrule
                     in-justification declaration)
    obj
    (make-instance 'top-proofstate :label
                   (let* ((get1 (getf initargs 'label '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :label '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) label getfv))
                   :current-goal
                   (let* ((get1 (getf initargs 'current-goal '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :current-goal '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) current-goal getfv))
                   :current-rule
                   (let* ((get1 (getf initargs 'current-rule '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :current-rule '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) current-rule getfv))
                   :dp-state
                   (let* ((get1 (getf initargs 'dp-state '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dp-state '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dp-state getfv))
                   :done-subgoals
                   (let* ((get1
                           (getf initargs 'done-subgoals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :done-subgoals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) done-subgoals getfv))
                   :pending-subgoals
                   (let* ((get1
                           (getf initargs 'pending-subgoals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pending-subgoals
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) pending-subgoals getfv))
                   :current-subgoal
                   (let* ((get1
                           (getf initargs 'current-subgoal '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :current-subgoal
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) current-subgoal getfv))
                   :remaining-subgoals
                   (let* ((get1
                           (getf initargs 'remaining-subgoals
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :remaining-subgoals
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) remaining-subgoals getfv))
                   :status-flag
                   (let* ((get1 (getf initargs 'status-flag '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :status-flag '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) status-flag getfv))
                   :subgoalnum
                   (let* ((get1 (getf initargs 'subgoalnum '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :subgoalnum '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) subgoalnum getfv))
                   :justification
                   (let* ((get1
                           (getf initargs 'justification '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :justification '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) justification getfv))
                   :current-input
                   (let* ((get1
                           (getf initargs 'current-input '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :current-input '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) current-input getfv))
                   :parsed-input
                   (let* ((get1 (getf initargs 'parsed-input '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parsed-input '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parsed-input getfv))
                   :printout
                   (let* ((get1 (getf initargs 'printout '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :printout '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) printout getfv))
                   :comment
                   (let* ((get1 (getf initargs 'comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :comment '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) comment getfv))
                   :strategy
                   (let* ((get1 (getf initargs 'strategy '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :strategy '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) strategy getfv))
                   :context
                   (let* ((get1 (getf initargs 'context '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :context '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) context getfv))
                   :parent-proofstate
                   (let* ((get1
                           (getf initargs 'parent-proofstate '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :parent-proofstate
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parent-proofstate getfv))
                   :proof-dependent-decls
                   (let* ((get1
                           (getf initargs 'proof-dependent-decls
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :proof-dependent-decls
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         proof-dependent-decls
                       getfv))
                   :dependent-decls
                   (let* ((get1
                           (getf initargs 'dependent-decls '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :dependent-decls
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dependent-decls getfv))
                   :current-auto-rewrites
                   (let* ((get1
                           (getf initargs 'current-auto-rewrites
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :current-auto-rewrites
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         current-auto-rewrites
                       getfv))
                   :tcc-hash
                   (let* ((get1 (getf initargs 'tcc-hash '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-hash '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-hash getfv))
                   :subtype-hash
                   (let* ((get1 (getf initargs 'subtype-hash '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :subtype-hash '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) subtype-hash getfv))
                   :rewrite-hash
                   (let* ((get1 (getf initargs 'rewrite-hash '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :rewrite-hash '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) rewrite-hash getfv))
                   :typepred-hash
                   (let* ((get1
                           (getf initargs 'typepred-hash '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typepred-hash '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typepred-hash getfv))
                   :current-xrule
                   (let* ((get1
                           (getf initargs 'current-xrule '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :current-xrule '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) current-xrule getfv))
                   :in-justification
                   (let* ((get1
                           (getf initargs 'in-justification '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :in-justification
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) in-justification getfv))
                   :declaration
                   (let* ((get1 (getf initargs 'declaration '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declaration '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declaration getfv)))))

(defmethod store-object* ((obj top-proofstate))
  (with-slots (label current-goal current-rule dp-state done-subgoals
                     pending-subgoals current-subgoal
                     remaining-subgoals status-flag subgoalnum
                     justification current-input parsed-input printout
                     comment strategy context parent-proofstate
                     proof-dependent-decls dependent-decls
                     current-auto-rewrites tcc-hash subtype-hash
                     rewrite-hash typepred-hash current-xrule
                     in-justification declaration)
    obj
    (reserve-space 29 (push-word (store-obj 'top-proofstate))
                   (push-word (store-obj label))
                   (push-word (store-obj current-goal))
                   (push-word (store-obj current-rule))
                   (push-word (store-obj dp-state))
                   (push-word (store-obj done-subgoals))
                   (push-word (store-obj pending-subgoals))
                   (push-word (store-obj current-subgoal))
                   (push-word (store-obj remaining-subgoals))
                   (push-word (store-obj status-flag))
                   (push-word (store-obj subgoalnum))
                   (push-word (store-obj justification))
                   (push-word (store-obj current-input))
                   (push-word (store-obj parsed-input))
                   (push-word (store-obj printout))
                   (push-word (store-obj comment))
                   (push-word (store-obj strategy))
                   (push-word (store-obj context))
                   (push-word (store-obj parent-proofstate))
                   (push-word (store-obj proof-dependent-decls))
                   (push-word (store-obj dependent-decls))
                   (push-word (store-obj current-auto-rewrites))
                   (push-word (store-obj tcc-hash))
                   (push-word (store-obj subtype-hash))
                   (push-word (store-obj rewrite-hash))
                   (push-word (store-obj typepred-hash))
                   (push-word (store-obj current-xrule))
                   (push-word (store-obj in-justification))
                   (push-word (store-obj declaration)))))

(defmethod update-fetched ((obj top-proofstate))
  (with-slots (label current-goal current-rule dp-state done-subgoals
                     pending-subgoals current-subgoal
                     remaining-subgoals status-flag subgoalnum
                     justification current-input parsed-input printout
                     comment strategy context parent-proofstate
                     proof-dependent-decls dependent-decls
                     current-auto-rewrites tcc-hash subtype-hash
                     rewrite-hash typepred-hash current-xrule
                     in-justification declaration)
    obj
    (setf label (fetch-obj (stored-word 1)))
    (setf current-goal (fetch-obj (stored-word 2)))
    (setf current-rule (fetch-obj (stored-word 3)))
    (setf dp-state (fetch-obj (stored-word 4)))
    (setf done-subgoals (fetch-obj (stored-word 5)))
    (setf pending-subgoals (fetch-obj (stored-word 6)))
    (setf current-subgoal (fetch-obj (stored-word 7)))
    (setf remaining-subgoals (fetch-obj (stored-word 8)))
    (setf status-flag (fetch-obj (stored-word 9)))
    (setf subgoalnum (fetch-obj (stored-word 10)))
    (setf justification (fetch-obj (stored-word 11)))
    (setf current-input (fetch-obj (stored-word 12)))
    (setf parsed-input (fetch-obj (stored-word 13)))
    (setf printout (fetch-obj (stored-word 14)))
    (setf comment (fetch-obj (stored-word 15)))
    (setf strategy (fetch-obj (stored-word 16)))
    (setf context (fetch-obj (stored-word 17)))
    (setf parent-proofstate (fetch-obj (stored-word 18)))
    (setf proof-dependent-decls (fetch-obj (stored-word 19)))
    (setf dependent-decls (fetch-obj (stored-word 20)))
    (setf current-auto-rewrites (fetch-obj (stored-word 21)))
    (setf tcc-hash (fetch-obj (stored-word 22)))
    (setf subtype-hash (fetch-obj (stored-word 23)))
    (setf rewrite-hash (fetch-obj (stored-word 24)))
    (setf typepred-hash (fetch-obj (stored-word 25)))
    (setf current-xrule (fetch-obj (stored-word 26)))
    (setf in-justification (fetch-obj (stored-word 27)))
    (setf declaration (fetch-obj (stored-word 28)))))

(defmethod restore-object* ((obj top-proofstate))
  (with-slots (label current-goal current-rule dp-state done-subgoals
                     pending-subgoals current-subgoal
                     remaining-subgoals status-flag subgoalnum
                     justification current-input parsed-input printout
                     comment strategy context parent-proofstate
                     proof-dependent-decls dependent-decls
                     current-auto-rewrites tcc-hash subtype-hash
                     rewrite-hash typepred-hash current-xrule
                     in-justification declaration)
    obj
    (let ((*restore-object-parent* obj))
      (when label
        (let ((*restore-object-parent-slot* 'label))
          (restore-object* label)))
      (when current-goal
        (let ((*restore-object-parent-slot* 'current-goal))
          (restore-object* current-goal)))
      (when current-rule
        (let ((*restore-object-parent-slot* 'current-rule))
          (restore-object* current-rule)))
      (when dp-state
        (let ((*restore-object-parent-slot* 'dp-state))
          (restore-object* dp-state)))
      (when done-subgoals
        (let ((*restore-object-parent-slot* 'done-subgoals))
          (restore-object* done-subgoals)))
      (when pending-subgoals
        (let ((*restore-object-parent-slot* 'pending-subgoals))
          (restore-object* pending-subgoals)))
      (when current-subgoal
        (let ((*restore-object-parent-slot* 'current-subgoal))
          (restore-object* current-subgoal)))
      (when remaining-subgoals
        (let ((*restore-object-parent-slot* 'remaining-subgoals))
          (restore-object* remaining-subgoals)))
      (when status-flag
        (let ((*restore-object-parent-slot* 'status-flag))
          (restore-object* status-flag)))
      (when subgoalnum
        (let ((*restore-object-parent-slot* 'subgoalnum))
          (restore-object* subgoalnum)))
      (when justification
        (let ((*restore-object-parent-slot* 'justification))
          (restore-object* justification)))
      (when current-input
        (let ((*restore-object-parent-slot* 'current-input))
          (restore-object* current-input)))
      (when parsed-input
        (let ((*restore-object-parent-slot* 'parsed-input))
          (restore-object* parsed-input)))
      (when printout
        (let ((*restore-object-parent-slot* 'printout))
          (restore-object* printout)))
      (when comment
        (let ((*restore-object-parent-slot* 'comment))
          (restore-object* comment)))
      (when strategy
        (let ((*restore-object-parent-slot* 'strategy))
          (restore-object* strategy)))
      (when context
        (let ((*restore-object-parent-slot* 'context))
          (restore-object* context)))
      (when parent-proofstate
        (let ((*restore-object-parent-slot* 'parent-proofstate))
          (restore-object* parent-proofstate)))
      (when proof-dependent-decls
        (let ((*restore-object-parent-slot* 'proof-dependent-decls))
          (restore-object* proof-dependent-decls)))
      (when dependent-decls
        (let ((*restore-object-parent-slot* 'dependent-decls))
          (restore-object* dependent-decls)))
      (when current-auto-rewrites
        (let ((*restore-object-parent-slot* 'current-auto-rewrites))
          (restore-object* current-auto-rewrites)))
      (when tcc-hash
        (let ((*restore-object-parent-slot* 'tcc-hash))
          (restore-object* tcc-hash)))
      (when subtype-hash
        (let ((*restore-object-parent-slot* 'subtype-hash))
          (restore-object* subtype-hash)))
      (when rewrite-hash
        (let ((*restore-object-parent-slot* 'rewrite-hash))
          (restore-object* rewrite-hash)))
      (when typepred-hash
        (let ((*restore-object-parent-slot* 'typepred-hash))
          (restore-object* typepred-hash)))
      (when current-xrule
        (let ((*restore-object-parent-slot* 'current-xrule))
          (restore-object* current-xrule)))
      (when in-justification
        (let ((*restore-object-parent-slot* 'in-justification))
          (restore-object* in-justification)))
      (when declaration
        (let ((*restore-object-parent-slot* 'declaration))
          (restore-object* declaration)))
      obj)))

(defmethod copy ((obj auto-rewrites-info) &rest initargs)
  (with-slots (%fills current-auto-rewrites slot. rewrites
                      all-rewrites-names auto-rewrites-names
                      auto-rewrites!-names macro-names)
    obj
    (make-instance 'auto-rewrites-info :%fills
                   (let* ((get1 (getf initargs '%fills '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :%fills '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) %fills getfv))
                   :current-auto-rewrites
                   (let* ((get1
                           (getf initargs 'current-auto-rewrites
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :current-auto-rewrites
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         current-auto-rewrites
                       getfv))
                   :slot.
                   (let* ((get1 (getf initargs 'slot. '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :slot. '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) slot. getfv))
                   :rewrites
                   (let* ((get1 (getf initargs 'rewrites '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :rewrites '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) rewrites getfv))
                   :all-rewrites-names
                   (let* ((get1
                           (getf initargs 'all-rewrites-names
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-rewrites-names
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) all-rewrites-names getfv))
                   :auto-rewrites-names
                   (let* ((get1
                           (getf initargs 'auto-rewrites-names
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :auto-rewrites-names
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         auto-rewrites-names
                       getfv))
                   :auto-rewrites!-names
                   (let* ((get1
                           (getf initargs 'auto-rewrites!-names
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :auto-rewrites!-names
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         auto-rewrites!-names
                       getfv))
                   :macro-names
                   (let* ((get1 (getf initargs 'macro-names '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :macro-names '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) macro-names getfv)))))

(defmethod store-object* ((obj auto-rewrites-info))
  (with-slots (%fills current-auto-rewrites slot. rewrites
                      all-rewrites-names auto-rewrites-names
                      auto-rewrites!-names macro-names)
    obj
    (reserve-space 9 (push-word (store-obj 'auto-rewrites-info))
                   (push-word (store-obj %fills))
                   (push-word (store-obj current-auto-rewrites))
                   (push-word (store-obj slot.))
                   (push-word (store-obj rewrites))
                   (push-word (store-obj all-rewrites-names))
                   (push-word (store-obj auto-rewrites-names))
                   (push-word (store-obj auto-rewrites!-names))
                   (push-word (store-obj macro-names)))))

(defmethod update-fetched ((obj auto-rewrites-info))
  (with-slots (%fills current-auto-rewrites slot. rewrites
                      all-rewrites-names auto-rewrites-names
                      auto-rewrites!-names macro-names)
    obj
    (setf %fills (fetch-obj (stored-word 1)))
    (setf current-auto-rewrites (fetch-obj (stored-word 2)))
    (setf slot. (fetch-obj (stored-word 3)))
    (setf rewrites (fetch-obj (stored-word 4)))
    (setf all-rewrites-names (fetch-obj (stored-word 5)))
    (setf auto-rewrites-names (fetch-obj (stored-word 6)))
    (setf auto-rewrites!-names (fetch-obj (stored-word 7)))
    (setf macro-names (fetch-obj (stored-word 8)))))

(defmethod restore-object* ((obj auto-rewrites-info))
  (with-slots (%fills current-auto-rewrites slot. rewrites
                      all-rewrites-names auto-rewrites-names
                      auto-rewrites!-names macro-names)
    obj
    (let ((*restore-object-parent* obj))
      (when %fills
        (let ((*restore-object-parent-slot* '%fills))
          (restore-object* %fills)))
      (when current-auto-rewrites
        (let ((*restore-object-parent-slot* 'current-auto-rewrites))
          (restore-object* current-auto-rewrites)))
      (when slot.
        (let ((*restore-object-parent-slot* 'slot.))
          (restore-object* slot.)))
      (when rewrites
        (let ((*restore-object-parent-slot* 'rewrites))
          (restore-object* rewrites)))
      (when all-rewrites-names
        (let ((*restore-object-parent-slot* 'all-rewrites-names))
          (restore-object* all-rewrites-names)))
      (when auto-rewrites-names
        (let ((*restore-object-parent-slot* 'auto-rewrites-names))
          (restore-object* auto-rewrites-names)))
      (when auto-rewrites!-names
        (let ((*restore-object-parent-slot* 'auto-rewrites!-names))
          (restore-object* auto-rewrites!-names)))
      (when macro-names
        (let ((*restore-object-parent-slot* 'macro-names))
          (restore-object* macro-names)))
      obj)))

(defmethod copy ((obj rewrite) &rest initargs)
  (with-slots (lhs rhs hyp res)
    obj
    (make-instance 'rewrite :lhs
                   (let* ((get1 (getf initargs 'lhs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :lhs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) lhs getfv))
                   :rhs
                   (let* ((get1 (getf initargs 'rhs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :rhs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) rhs getfv))
                   :hyp
                   (let* ((get1 (getf initargs 'hyp '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :hyp '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) hyp getfv))
                   :res
                   (let* ((get1 (getf initargs 'res '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :res '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) res getfv)))))

(defmethod store-object* ((obj rewrite))
  (with-slots (lhs rhs hyp res)
    obj
    (reserve-space 5 (push-word (store-obj 'rewrite))
                   (push-word (store-obj lhs))
                   (push-word (store-obj rhs))
                   (push-word (store-obj hyp))
                   (push-word (store-obj res)))))

(defmethod update-fetched ((obj rewrite))
  (with-slots (lhs rhs hyp res)
    obj
    (setf lhs (fetch-obj (stored-word 1)))
    (setf rhs (fetch-obj (stored-word 2)))
    (setf hyp (fetch-obj (stored-word 3)))
    (setf res (fetch-obj (stored-word 4)))))

(defmethod restore-object* ((obj rewrite))
  (with-slots (lhs rhs hyp res)
    obj
    (let ((*restore-object-parent* obj))
      (when lhs
        (let ((*restore-object-parent-slot* 'lhs))
          (restore-object* lhs)))
      (when rhs
        (let ((*restore-object-parent-slot* 'rhs))
          (restore-object* rhs)))
      (when hyp
        (let ((*restore-object-parent-slot* 'hyp))
          (restore-object* hyp)))
      (when res
        (let ((*restore-object-parent-slot* 'res))
          (restore-object* res)))
      obj)))

(defmethod copy ((obj tcc-proofstate) &rest initargs)
  (with-slots (label current-goal current-rule dp-state done-subgoals
                     pending-subgoals current-subgoal
                     remaining-subgoals status-flag subgoalnum
                     justification current-input parsed-input printout
                     comment strategy context parent-proofstate
                     proof-dependent-decls dependent-decls
                     current-auto-rewrites tcc-hash subtype-hash
                     rewrite-hash typepred-hash current-xrule)
    obj
    (make-instance 'tcc-proofstate :label
                   (let* ((get1 (getf initargs 'label '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :label '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) label getfv))
                   :current-goal
                   (let* ((get1 (getf initargs 'current-goal '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :current-goal '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) current-goal getfv))
                   :current-rule
                   (let* ((get1 (getf initargs 'current-rule '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :current-rule '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) current-rule getfv))
                   :dp-state
                   (let* ((get1 (getf initargs 'dp-state '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dp-state '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dp-state getfv))
                   :done-subgoals
                   (let* ((get1
                           (getf initargs 'done-subgoals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :done-subgoals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) done-subgoals getfv))
                   :pending-subgoals
                   (let* ((get1
                           (getf initargs 'pending-subgoals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pending-subgoals
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) pending-subgoals getfv))
                   :current-subgoal
                   (let* ((get1
                           (getf initargs 'current-subgoal '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :current-subgoal
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) current-subgoal getfv))
                   :remaining-subgoals
                   (let* ((get1
                           (getf initargs 'remaining-subgoals
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :remaining-subgoals
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) remaining-subgoals getfv))
                   :status-flag
                   (let* ((get1 (getf initargs 'status-flag '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :status-flag '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) status-flag getfv))
                   :subgoalnum
                   (let* ((get1 (getf initargs 'subgoalnum '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :subgoalnum '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) subgoalnum getfv))
                   :justification
                   (let* ((get1
                           (getf initargs 'justification '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :justification '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) justification getfv))
                   :current-input
                   (let* ((get1
                           (getf initargs 'current-input '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :current-input '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) current-input getfv))
                   :parsed-input
                   (let* ((get1 (getf initargs 'parsed-input '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parsed-input '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parsed-input getfv))
                   :printout
                   (let* ((get1 (getf initargs 'printout '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :printout '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) printout getfv))
                   :comment
                   (let* ((get1 (getf initargs 'comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :comment '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) comment getfv))
                   :strategy
                   (let* ((get1 (getf initargs 'strategy '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :strategy '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) strategy getfv))
                   :context
                   (let* ((get1 (getf initargs 'context '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :context '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) context getfv))
                   :parent-proofstate
                   (let* ((get1
                           (getf initargs 'parent-proofstate '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :parent-proofstate
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parent-proofstate getfv))
                   :proof-dependent-decls
                   (let* ((get1
                           (getf initargs 'proof-dependent-decls
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :proof-dependent-decls
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         proof-dependent-decls
                       getfv))
                   :dependent-decls
                   (let* ((get1
                           (getf initargs 'dependent-decls '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :dependent-decls
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dependent-decls getfv))
                   :current-auto-rewrites
                   (let* ((get1
                           (getf initargs 'current-auto-rewrites
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :current-auto-rewrites
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         current-auto-rewrites
                       getfv))
                   :tcc-hash
                   (let* ((get1 (getf initargs 'tcc-hash '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-hash '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-hash getfv))
                   :subtype-hash
                   (let* ((get1 (getf initargs 'subtype-hash '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :subtype-hash '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) subtype-hash getfv))
                   :rewrite-hash
                   (let* ((get1 (getf initargs 'rewrite-hash '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :rewrite-hash '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) rewrite-hash getfv))
                   :typepred-hash
                   (let* ((get1
                           (getf initargs 'typepred-hash '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typepred-hash '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typepred-hash getfv))
                   :current-xrule
                   (let* ((get1
                           (getf initargs 'current-xrule '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :current-xrule '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) current-xrule getfv)))))

(defmethod store-object* ((obj tcc-proofstate))
  (with-slots (label current-goal current-rule dp-state done-subgoals
                     pending-subgoals current-subgoal
                     remaining-subgoals status-flag subgoalnum
                     justification current-input parsed-input printout
                     comment strategy context parent-proofstate
                     proof-dependent-decls dependent-decls
                     current-auto-rewrites tcc-hash subtype-hash
                     rewrite-hash typepred-hash current-xrule)
    obj
    (reserve-space 27 (push-word (store-obj 'tcc-proofstate))
                   (push-word (store-obj label))
                   (push-word (store-obj current-goal))
                   (push-word (store-obj current-rule))
                   (push-word (store-obj dp-state))
                   (push-word (store-obj done-subgoals))
                   (push-word (store-obj pending-subgoals))
                   (push-word (store-obj current-subgoal))
                   (push-word (store-obj remaining-subgoals))
                   (push-word (store-obj status-flag))
                   (push-word (store-obj subgoalnum))
                   (push-word (store-obj justification))
                   (push-word (store-obj current-input))
                   (push-word (store-obj parsed-input))
                   (push-word (store-obj printout))
                   (push-word (store-obj comment))
                   (push-word (store-obj strategy))
                   (push-word (store-obj context))
                   (push-word (store-obj parent-proofstate))
                   (push-word (store-obj proof-dependent-decls))
                   (push-word (store-obj dependent-decls))
                   (push-word (store-obj current-auto-rewrites))
                   (push-word (store-obj tcc-hash))
                   (push-word (store-obj subtype-hash))
                   (push-word (store-obj rewrite-hash))
                   (push-word (store-obj typepred-hash))
                   (push-word (store-obj current-xrule)))))

(defmethod update-fetched ((obj tcc-proofstate))
  (with-slots (label current-goal current-rule dp-state done-subgoals
                     pending-subgoals current-subgoal
                     remaining-subgoals status-flag subgoalnum
                     justification current-input parsed-input printout
                     comment strategy context parent-proofstate
                     proof-dependent-decls dependent-decls
                     current-auto-rewrites tcc-hash subtype-hash
                     rewrite-hash typepred-hash current-xrule)
    obj
    (setf label (fetch-obj (stored-word 1)))
    (setf current-goal (fetch-obj (stored-word 2)))
    (setf current-rule (fetch-obj (stored-word 3)))
    (setf dp-state (fetch-obj (stored-word 4)))
    (setf done-subgoals (fetch-obj (stored-word 5)))
    (setf pending-subgoals (fetch-obj (stored-word 6)))
    (setf current-subgoal (fetch-obj (stored-word 7)))
    (setf remaining-subgoals (fetch-obj (stored-word 8)))
    (setf status-flag (fetch-obj (stored-word 9)))
    (setf subgoalnum (fetch-obj (stored-word 10)))
    (setf justification (fetch-obj (stored-word 11)))
    (setf current-input (fetch-obj (stored-word 12)))
    (setf parsed-input (fetch-obj (stored-word 13)))
    (setf printout (fetch-obj (stored-word 14)))
    (setf comment (fetch-obj (stored-word 15)))
    (setf strategy (fetch-obj (stored-word 16)))
    (setf context (fetch-obj (stored-word 17)))
    (setf parent-proofstate (fetch-obj (stored-word 18)))
    (setf proof-dependent-decls (fetch-obj (stored-word 19)))
    (setf dependent-decls (fetch-obj (stored-word 20)))
    (setf current-auto-rewrites (fetch-obj (stored-word 21)))
    (setf tcc-hash (fetch-obj (stored-word 22)))
    (setf subtype-hash (fetch-obj (stored-word 23)))
    (setf rewrite-hash (fetch-obj (stored-word 24)))
    (setf typepred-hash (fetch-obj (stored-word 25)))
    (setf current-xrule (fetch-obj (stored-word 26)))))

(defmethod restore-object* ((obj tcc-proofstate))
  (with-slots (label current-goal current-rule dp-state done-subgoals
                     pending-subgoals current-subgoal
                     remaining-subgoals status-flag subgoalnum
                     justification current-input parsed-input printout
                     comment strategy context parent-proofstate
                     proof-dependent-decls dependent-decls
                     current-auto-rewrites tcc-hash subtype-hash
                     rewrite-hash typepred-hash current-xrule)
    obj
    (let ((*restore-object-parent* obj))
      (when label
        (let ((*restore-object-parent-slot* 'label))
          (restore-object* label)))
      (when current-goal
        (let ((*restore-object-parent-slot* 'current-goal))
          (restore-object* current-goal)))
      (when current-rule
        (let ((*restore-object-parent-slot* 'current-rule))
          (restore-object* current-rule)))
      (when dp-state
        (let ((*restore-object-parent-slot* 'dp-state))
          (restore-object* dp-state)))
      (when done-subgoals
        (let ((*restore-object-parent-slot* 'done-subgoals))
          (restore-object* done-subgoals)))
      (when pending-subgoals
        (let ((*restore-object-parent-slot* 'pending-subgoals))
          (restore-object* pending-subgoals)))
      (when current-subgoal
        (let ((*restore-object-parent-slot* 'current-subgoal))
          (restore-object* current-subgoal)))
      (when remaining-subgoals
        (let ((*restore-object-parent-slot* 'remaining-subgoals))
          (restore-object* remaining-subgoals)))
      (when status-flag
        (let ((*restore-object-parent-slot* 'status-flag))
          (restore-object* status-flag)))
      (when subgoalnum
        (let ((*restore-object-parent-slot* 'subgoalnum))
          (restore-object* subgoalnum)))
      (when justification
        (let ((*restore-object-parent-slot* 'justification))
          (restore-object* justification)))
      (when current-input
        (let ((*restore-object-parent-slot* 'current-input))
          (restore-object* current-input)))
      (when parsed-input
        (let ((*restore-object-parent-slot* 'parsed-input))
          (restore-object* parsed-input)))
      (when printout
        (let ((*restore-object-parent-slot* 'printout))
          (restore-object* printout)))
      (when comment
        (let ((*restore-object-parent-slot* 'comment))
          (restore-object* comment)))
      (when strategy
        (let ((*restore-object-parent-slot* 'strategy))
          (restore-object* strategy)))
      (when context
        (let ((*restore-object-parent-slot* 'context))
          (restore-object* context)))
      (when parent-proofstate
        (let ((*restore-object-parent-slot* 'parent-proofstate))
          (restore-object* parent-proofstate)))
      (when proof-dependent-decls
        (let ((*restore-object-parent-slot* 'proof-dependent-decls))
          (restore-object* proof-dependent-decls)))
      (when dependent-decls
        (let ((*restore-object-parent-slot* 'dependent-decls))
          (restore-object* dependent-decls)))
      (when current-auto-rewrites
        (let ((*restore-object-parent-slot* 'current-auto-rewrites))
          (restore-object* current-auto-rewrites)))
      (when tcc-hash
        (let ((*restore-object-parent-slot* 'tcc-hash))
          (restore-object* tcc-hash)))
      (when subtype-hash
        (let ((*restore-object-parent-slot* 'subtype-hash))
          (restore-object* subtype-hash)))
      (when rewrite-hash
        (let ((*restore-object-parent-slot* 'rewrite-hash))
          (restore-object* rewrite-hash)))
      (when typepred-hash
        (let ((*restore-object-parent-slot* 'typepred-hash))
          (restore-object* typepred-hash)))
      (when current-xrule
        (let ((*restore-object-parent-slot* 'current-xrule))
          (restore-object* current-xrule)))
      obj)))

(defmethod copy ((obj tcc-sequent) &rest initargs)
  (with-slots (s-forms hidden-s-forms info tcc expr type reason kind)
    obj
    (make-instance 'tcc-sequent :s-forms
                   (let* ((get1 (getf initargs 's-forms '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :s-forms '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) s-forms getfv))
                   :p-sforms
                   (let* ((get1 (getf initargs 'p-sforms '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :p-sforms '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :n-sforms
                   (let* ((get1 (getf initargs 'n-sforms '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :n-sforms '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :hidden-s-forms
                   (let* ((get1
                           (getf initargs 'hidden-s-forms '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :hidden-s-forms '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) hidden-s-forms getfv))
                   :info
                   (let* ((get1 (getf initargs 'info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) info getfv))
                   :tcc
                   (let* ((get1 (getf initargs 'tcc '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc getfv))
                   :expr
                   (let* ((get1 (getf initargs 'expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expr getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :reason
                   (let* ((get1 (getf initargs 'reason '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :reason '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) reason getfv))
                   :kind
                   (let* ((get1 (getf initargs 'kind '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :kind '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) kind getfv)))))

(defmethod store-object* ((obj tcc-sequent))
  (with-slots (s-forms p-sforms n-sforms hidden-s-forms info tcc expr
                       type reason kind)
    obj
    (reserve-space 11 (push-word (store-obj 'tcc-sequent))
                   (push-word (store-obj s-forms))
                   (push-word (store-obj p-sforms))
                   (push-word (store-obj n-sforms))
                   (push-word (store-obj hidden-s-forms))
                   (push-word (store-obj info))
                   (push-word (store-obj tcc))
                   (push-word (store-obj expr))
                   (push-word (store-obj type))
                   (push-word (store-obj reason))
                   (push-word (store-obj kind)))))

(defmethod update-fetched ((obj tcc-sequent))
  (with-slots (s-forms p-sforms n-sforms hidden-s-forms info tcc expr
                       type reason kind)
    obj
    (setf s-forms (fetch-obj (stored-word 1)))
    (setf p-sforms (fetch-obj (stored-word 2)))
    (setf n-sforms (fetch-obj (stored-word 3)))
    (setf hidden-s-forms (fetch-obj (stored-word 4)))
    (setf info (fetch-obj (stored-word 5)))
    (setf tcc (fetch-obj (stored-word 6)))
    (setf expr (fetch-obj (stored-word 7)))
    (setf type (fetch-obj (stored-word 8)))
    (setf reason (fetch-obj (stored-word 9)))
    (setf kind (fetch-obj (stored-word 10)))))

(defmethod restore-object* ((obj tcc-sequent))
  (with-slots (s-forms p-sforms n-sforms hidden-s-forms info tcc expr
                       type reason kind)
    obj
    (let ((*restore-object-parent* obj))
      (when s-forms
        (let ((*restore-object-parent-slot* 's-forms))
          (restore-object* s-forms)))
      (when p-sforms
        (let ((*restore-object-parent-slot* 'p-sforms))
          (restore-object* p-sforms)))
      (when n-sforms
        (let ((*restore-object-parent-slot* 'n-sforms))
          (restore-object* n-sforms)))
      (when hidden-s-forms
        (let ((*restore-object-parent-slot* 'hidden-s-forms))
          (restore-object* hidden-s-forms)))
      (when info
        (let ((*restore-object-parent-slot* 'info))
          (restore-object* info)))
      (when tcc
        (let ((*restore-object-parent-slot* 'tcc))
          (restore-object* tcc)))
      (when expr
        (let ((*restore-object-parent-slot* 'expr))
          (restore-object* expr)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when reason
        (let ((*restore-object-parent-slot* 'reason))
          (restore-object* reason)))
      (when kind
        (let ((*restore-object-parent-slot* 'kind))
          (restore-object* kind)))
      obj)))

(defmethod copy ((obj apply-proofstate) &rest initargs)
  (with-slots (label current-goal current-rule dp-state done-subgoals
                     pending-subgoals current-subgoal
                     remaining-subgoals status-flag subgoalnum
                     justification current-input parsed-input printout
                     comment strategy context parent-proofstate
                     proof-dependent-decls dependent-decls
                     current-auto-rewrites tcc-hash subtype-hash
                     rewrite-hash typepred-hash current-xrule
                     apply-parent-proofstate)
    obj
    (make-instance 'apply-proofstate :label
                   (let* ((get1 (getf initargs 'label '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :label '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) label getfv))
                   :current-goal
                   (let* ((get1 (getf initargs 'current-goal '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :current-goal '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) current-goal getfv))
                   :current-rule
                   (let* ((get1 (getf initargs 'current-rule '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :current-rule '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) current-rule getfv))
                   :dp-state
                   (let* ((get1 (getf initargs 'dp-state '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dp-state '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dp-state getfv))
                   :done-subgoals
                   (let* ((get1
                           (getf initargs 'done-subgoals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :done-subgoals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) done-subgoals getfv))
                   :pending-subgoals
                   (let* ((get1
                           (getf initargs 'pending-subgoals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pending-subgoals
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) pending-subgoals getfv))
                   :current-subgoal
                   (let* ((get1
                           (getf initargs 'current-subgoal '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :current-subgoal
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) current-subgoal getfv))
                   :remaining-subgoals
                   (let* ((get1
                           (getf initargs 'remaining-subgoals
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :remaining-subgoals
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) remaining-subgoals getfv))
                   :status-flag
                   (let* ((get1 (getf initargs 'status-flag '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :status-flag '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) status-flag getfv))
                   :subgoalnum
                   (let* ((get1 (getf initargs 'subgoalnum '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :subgoalnum '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) subgoalnum getfv))
                   :justification
                   (let* ((get1
                           (getf initargs 'justification '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :justification '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) justification getfv))
                   :current-input
                   (let* ((get1
                           (getf initargs 'current-input '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :current-input '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) current-input getfv))
                   :parsed-input
                   (let* ((get1 (getf initargs 'parsed-input '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parsed-input '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parsed-input getfv))
                   :printout
                   (let* ((get1 (getf initargs 'printout '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :printout '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) printout getfv))
                   :comment
                   (let* ((get1 (getf initargs 'comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :comment '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) comment getfv))
                   :strategy
                   (let* ((get1 (getf initargs 'strategy '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :strategy '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) strategy getfv))
                   :context
                   (let* ((get1 (getf initargs 'context '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :context '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) context getfv))
                   :parent-proofstate
                   (let* ((get1
                           (getf initargs 'parent-proofstate '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :parent-proofstate
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parent-proofstate getfv))
                   :proof-dependent-decls
                   (let* ((get1
                           (getf initargs 'proof-dependent-decls
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :proof-dependent-decls
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         proof-dependent-decls
                       getfv))
                   :dependent-decls
                   (let* ((get1
                           (getf initargs 'dependent-decls '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :dependent-decls
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dependent-decls getfv))
                   :current-auto-rewrites
                   (let* ((get1
                           (getf initargs 'current-auto-rewrites
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :current-auto-rewrites
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         current-auto-rewrites
                       getfv))
                   :tcc-hash
                   (let* ((get1 (getf initargs 'tcc-hash '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-hash '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-hash getfv))
                   :subtype-hash
                   (let* ((get1 (getf initargs 'subtype-hash '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :subtype-hash '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) subtype-hash getfv))
                   :rewrite-hash
                   (let* ((get1 (getf initargs 'rewrite-hash '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :rewrite-hash '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) rewrite-hash getfv))
                   :typepred-hash
                   (let* ((get1
                           (getf initargs 'typepred-hash '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typepred-hash '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typepred-hash getfv))
                   :current-xrule
                   (let* ((get1
                           (getf initargs 'current-xrule '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :current-xrule '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) current-xrule getfv))
                   :apply-parent-proofstate
                   (let* ((get1
                           (getf initargs 'apply-parent-proofstate
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :apply-parent-proofstate
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         apply-parent-proofstate
                       getfv)))))

(defmethod store-object* ((obj apply-proofstate))
  (with-slots (label current-goal current-rule dp-state done-subgoals
                     pending-subgoals current-subgoal
                     remaining-subgoals status-flag subgoalnum
                     justification current-input parsed-input printout
                     comment strategy context parent-proofstate
                     proof-dependent-decls dependent-decls
                     current-auto-rewrites tcc-hash subtype-hash
                     rewrite-hash typepred-hash current-xrule
                     apply-parent-proofstate)
    obj
    (reserve-space 28 (push-word (store-obj 'apply-proofstate))
                   (push-word (store-obj label))
                   (push-word (store-obj current-goal))
                   (push-word (store-obj current-rule))
                   (push-word (store-obj dp-state))
                   (push-word (store-obj done-subgoals))
                   (push-word (store-obj pending-subgoals))
                   (push-word (store-obj current-subgoal))
                   (push-word (store-obj remaining-subgoals))
                   (push-word (store-obj status-flag))
                   (push-word (store-obj subgoalnum))
                   (push-word (store-obj justification))
                   (push-word (store-obj current-input))
                   (push-word (store-obj parsed-input))
                   (push-word (store-obj printout))
                   (push-word (store-obj comment))
                   (push-word (store-obj strategy))
                   (push-word (store-obj context))
                   (push-word (store-obj parent-proofstate))
                   (push-word (store-obj proof-dependent-decls))
                   (push-word (store-obj dependent-decls))
                   (push-word (store-obj current-auto-rewrites))
                   (push-word (store-obj tcc-hash))
                   (push-word (store-obj subtype-hash))
                   (push-word (store-obj rewrite-hash))
                   (push-word (store-obj typepred-hash))
                   (push-word (store-obj current-xrule))
                   (push-word (store-obj apply-parent-proofstate)))))

(defmethod update-fetched ((obj apply-proofstate))
  (with-slots (label current-goal current-rule dp-state done-subgoals
                     pending-subgoals current-subgoal
                     remaining-subgoals status-flag subgoalnum
                     justification current-input parsed-input printout
                     comment strategy context parent-proofstate
                     proof-dependent-decls dependent-decls
                     current-auto-rewrites tcc-hash subtype-hash
                     rewrite-hash typepred-hash current-xrule
                     apply-parent-proofstate)
    obj
    (setf label (fetch-obj (stored-word 1)))
    (setf current-goal (fetch-obj (stored-word 2)))
    (setf current-rule (fetch-obj (stored-word 3)))
    (setf dp-state (fetch-obj (stored-word 4)))
    (setf done-subgoals (fetch-obj (stored-word 5)))
    (setf pending-subgoals (fetch-obj (stored-word 6)))
    (setf current-subgoal (fetch-obj (stored-word 7)))
    (setf remaining-subgoals (fetch-obj (stored-word 8)))
    (setf status-flag (fetch-obj (stored-word 9)))
    (setf subgoalnum (fetch-obj (stored-word 10)))
    (setf justification (fetch-obj (stored-word 11)))
    (setf current-input (fetch-obj (stored-word 12)))
    (setf parsed-input (fetch-obj (stored-word 13)))
    (setf printout (fetch-obj (stored-word 14)))
    (setf comment (fetch-obj (stored-word 15)))
    (setf strategy (fetch-obj (stored-word 16)))
    (setf context (fetch-obj (stored-word 17)))
    (setf parent-proofstate (fetch-obj (stored-word 18)))
    (setf proof-dependent-decls (fetch-obj (stored-word 19)))
    (setf dependent-decls (fetch-obj (stored-word 20)))
    (setf current-auto-rewrites (fetch-obj (stored-word 21)))
    (setf tcc-hash (fetch-obj (stored-word 22)))
    (setf subtype-hash (fetch-obj (stored-word 23)))
    (setf rewrite-hash (fetch-obj (stored-word 24)))
    (setf typepred-hash (fetch-obj (stored-word 25)))
    (setf current-xrule (fetch-obj (stored-word 26)))
    (setf apply-parent-proofstate (fetch-obj (stored-word 27)))))

(defmethod restore-object* ((obj apply-proofstate))
  (with-slots (label current-goal current-rule dp-state done-subgoals
                     pending-subgoals current-subgoal
                     remaining-subgoals status-flag subgoalnum
                     justification current-input parsed-input printout
                     comment strategy context parent-proofstate
                     proof-dependent-decls dependent-decls
                     current-auto-rewrites tcc-hash subtype-hash
                     rewrite-hash typepred-hash current-xrule
                     apply-parent-proofstate)
    obj
    (let ((*restore-object-parent* obj))
      (when label
        (let ((*restore-object-parent-slot* 'label))
          (restore-object* label)))
      (when current-goal
        (let ((*restore-object-parent-slot* 'current-goal))
          (restore-object* current-goal)))
      (when current-rule
        (let ((*restore-object-parent-slot* 'current-rule))
          (restore-object* current-rule)))
      (when dp-state
        (let ((*restore-object-parent-slot* 'dp-state))
          (restore-object* dp-state)))
      (when done-subgoals
        (let ((*restore-object-parent-slot* 'done-subgoals))
          (restore-object* done-subgoals)))
      (when pending-subgoals
        (let ((*restore-object-parent-slot* 'pending-subgoals))
          (restore-object* pending-subgoals)))
      (when current-subgoal
        (let ((*restore-object-parent-slot* 'current-subgoal))
          (restore-object* current-subgoal)))
      (when remaining-subgoals
        (let ((*restore-object-parent-slot* 'remaining-subgoals))
          (restore-object* remaining-subgoals)))
      (when status-flag
        (let ((*restore-object-parent-slot* 'status-flag))
          (restore-object* status-flag)))
      (when subgoalnum
        (let ((*restore-object-parent-slot* 'subgoalnum))
          (restore-object* subgoalnum)))
      (when justification
        (let ((*restore-object-parent-slot* 'justification))
          (restore-object* justification)))
      (when current-input
        (let ((*restore-object-parent-slot* 'current-input))
          (restore-object* current-input)))
      (when parsed-input
        (let ((*restore-object-parent-slot* 'parsed-input))
          (restore-object* parsed-input)))
      (when printout
        (let ((*restore-object-parent-slot* 'printout))
          (restore-object* printout)))
      (when comment
        (let ((*restore-object-parent-slot* 'comment))
          (restore-object* comment)))
      (when strategy
        (let ((*restore-object-parent-slot* 'strategy))
          (restore-object* strategy)))
      (when context
        (let ((*restore-object-parent-slot* 'context))
          (restore-object* context)))
      (when parent-proofstate
        (let ((*restore-object-parent-slot* 'parent-proofstate))
          (restore-object* parent-proofstate)))
      (when proof-dependent-decls
        (let ((*restore-object-parent-slot* 'proof-dependent-decls))
          (restore-object* proof-dependent-decls)))
      (when dependent-decls
        (let ((*restore-object-parent-slot* 'dependent-decls))
          (restore-object* dependent-decls)))
      (when current-auto-rewrites
        (let ((*restore-object-parent-slot* 'current-auto-rewrites))
          (restore-object* current-auto-rewrites)))
      (when tcc-hash
        (let ((*restore-object-parent-slot* 'tcc-hash))
          (restore-object* tcc-hash)))
      (when subtype-hash
        (let ((*restore-object-parent-slot* 'subtype-hash))
          (restore-object* subtype-hash)))
      (when rewrite-hash
        (let ((*restore-object-parent-slot* 'rewrite-hash))
          (restore-object* rewrite-hash)))
      (when typepred-hash
        (let ((*restore-object-parent-slot* 'typepred-hash))
          (restore-object* typepred-hash)))
      (when current-xrule
        (let ((*restore-object-parent-slot* 'current-xrule))
          (restore-object* current-xrule)))
      (when apply-parent-proofstate
        (let ((*restore-object-parent-slot* 'apply-parent-proofstate))
          (restore-object* apply-parent-proofstate)))
      obj)))

(defmethod copy ((obj proofstate) &rest initargs)
  (with-slots (label current-goal current-rule dp-state done-subgoals
                     pending-subgoals current-subgoal
                     remaining-subgoals status-flag subgoalnum
                     justification current-input parsed-input printout
                     comment strategy context parent-proofstate
                     proof-dependent-decls dependent-decls
                     current-auto-rewrites tcc-hash subtype-hash
                     rewrite-hash typepred-hash current-xrule)
    obj
    (make-instance 'proofstate :label
                   (let* ((get1 (getf initargs 'label '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :label '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) label getfv))
                   :current-goal
                   (let* ((get1 (getf initargs 'current-goal '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :current-goal '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) current-goal getfv))
                   :current-rule
                   (let* ((get1 (getf initargs 'current-rule '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :current-rule '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) current-rule getfv))
                   :dp-state
                   (let* ((get1 (getf initargs 'dp-state '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dp-state '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dp-state getfv))
                   :done-subgoals
                   (let* ((get1
                           (getf initargs 'done-subgoals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :done-subgoals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) done-subgoals getfv))
                   :pending-subgoals
                   (let* ((get1
                           (getf initargs 'pending-subgoals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pending-subgoals
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) pending-subgoals getfv))
                   :current-subgoal
                   (let* ((get1
                           (getf initargs 'current-subgoal '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :current-subgoal
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) current-subgoal getfv))
                   :remaining-subgoals
                   (let* ((get1
                           (getf initargs 'remaining-subgoals
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :remaining-subgoals
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) remaining-subgoals getfv))
                   :status-flag
                   (let* ((get1 (getf initargs 'status-flag '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :status-flag '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) status-flag getfv))
                   :subgoalnum
                   (let* ((get1 (getf initargs 'subgoalnum '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :subgoalnum '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) subgoalnum getfv))
                   :justification
                   (let* ((get1
                           (getf initargs 'justification '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :justification '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) justification getfv))
                   :current-input
                   (let* ((get1
                           (getf initargs 'current-input '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :current-input '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) current-input getfv))
                   :parsed-input
                   (let* ((get1 (getf initargs 'parsed-input '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parsed-input '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parsed-input getfv))
                   :printout
                   (let* ((get1 (getf initargs 'printout '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :printout '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) printout getfv))
                   :comment
                   (let* ((get1 (getf initargs 'comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :comment '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) comment getfv))
                   :strategy
                   (let* ((get1 (getf initargs 'strategy '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :strategy '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) strategy getfv))
                   :context
                   (let* ((get1 (getf initargs 'context '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :context '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) context getfv))
                   :parent-proofstate
                   (let* ((get1
                           (getf initargs 'parent-proofstate '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :parent-proofstate
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parent-proofstate getfv))
                   :proof-dependent-decls
                   (let* ((get1
                           (getf initargs 'proof-dependent-decls
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :proof-dependent-decls
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         proof-dependent-decls
                       getfv))
                   :dependent-decls
                   (let* ((get1
                           (getf initargs 'dependent-decls '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :dependent-decls
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dependent-decls getfv))
                   :current-auto-rewrites
                   (let* ((get1
                           (getf initargs 'current-auto-rewrites
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :current-auto-rewrites
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         current-auto-rewrites
                       getfv))
                   :tcc-hash
                   (let* ((get1 (getf initargs 'tcc-hash '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-hash '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-hash getfv))
                   :subtype-hash
                   (let* ((get1 (getf initargs 'subtype-hash '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :subtype-hash '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) subtype-hash getfv))
                   :rewrite-hash
                   (let* ((get1 (getf initargs 'rewrite-hash '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :rewrite-hash '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) rewrite-hash getfv))
                   :typepred-hash
                   (let* ((get1
                           (getf initargs 'typepred-hash '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typepred-hash '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typepred-hash getfv))
                   :current-xrule
                   (let* ((get1
                           (getf initargs 'current-xrule '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :current-xrule '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) current-xrule getfv)))))

(defmethod store-object* ((obj proofstate))
  (with-slots (label current-goal current-rule dp-state done-subgoals
                     pending-subgoals current-subgoal
                     remaining-subgoals status-flag subgoalnum
                     justification current-input parsed-input printout
                     comment strategy context parent-proofstate
                     proof-dependent-decls dependent-decls
                     current-auto-rewrites tcc-hash subtype-hash
                     rewrite-hash typepred-hash current-xrule)
    obj
    (reserve-space 27 (push-word (store-obj 'proofstate))
                   (push-word (store-obj label))
                   (push-word (store-obj current-goal))
                   (push-word (store-obj current-rule))
                   (push-word (store-obj dp-state))
                   (push-word (store-obj done-subgoals))
                   (push-word (store-obj pending-subgoals))
                   (push-word (store-obj current-subgoal))
                   (push-word (store-obj remaining-subgoals))
                   (push-word (store-obj status-flag))
                   (push-word (store-obj subgoalnum))
                   (push-word (store-obj justification))
                   (push-word (store-obj current-input))
                   (push-word (store-obj parsed-input))
                   (push-word (store-obj printout))
                   (push-word (store-obj comment))
                   (push-word (store-obj strategy))
                   (push-word (store-obj context))
                   (push-word (store-obj parent-proofstate))
                   (push-word (store-obj proof-dependent-decls))
                   (push-word (store-obj dependent-decls))
                   (push-word (store-obj current-auto-rewrites))
                   (push-word (store-obj tcc-hash))
                   (push-word (store-obj subtype-hash))
                   (push-word (store-obj rewrite-hash))
                   (push-word (store-obj typepred-hash))
                   (push-word (store-obj current-xrule)))))

(defmethod update-fetched ((obj proofstate))
  (with-slots (label current-goal current-rule dp-state done-subgoals
                     pending-subgoals current-subgoal
                     remaining-subgoals status-flag subgoalnum
                     justification current-input parsed-input printout
                     comment strategy context parent-proofstate
                     proof-dependent-decls dependent-decls
                     current-auto-rewrites tcc-hash subtype-hash
                     rewrite-hash typepred-hash current-xrule)
    obj
    (setf label (fetch-obj (stored-word 1)))
    (setf current-goal (fetch-obj (stored-word 2)))
    (setf current-rule (fetch-obj (stored-word 3)))
    (setf dp-state (fetch-obj (stored-word 4)))
    (setf done-subgoals (fetch-obj (stored-word 5)))
    (setf pending-subgoals (fetch-obj (stored-word 6)))
    (setf current-subgoal (fetch-obj (stored-word 7)))
    (setf remaining-subgoals (fetch-obj (stored-word 8)))
    (setf status-flag (fetch-obj (stored-word 9)))
    (setf subgoalnum (fetch-obj (stored-word 10)))
    (setf justification (fetch-obj (stored-word 11)))
    (setf current-input (fetch-obj (stored-word 12)))
    (setf parsed-input (fetch-obj (stored-word 13)))
    (setf printout (fetch-obj (stored-word 14)))
    (setf comment (fetch-obj (stored-word 15)))
    (setf strategy (fetch-obj (stored-word 16)))
    (setf context (fetch-obj (stored-word 17)))
    (setf parent-proofstate (fetch-obj (stored-word 18)))
    (setf proof-dependent-decls (fetch-obj (stored-word 19)))
    (setf dependent-decls (fetch-obj (stored-word 20)))
    (setf current-auto-rewrites (fetch-obj (stored-word 21)))
    (setf tcc-hash (fetch-obj (stored-word 22)))
    (setf subtype-hash (fetch-obj (stored-word 23)))
    (setf rewrite-hash (fetch-obj (stored-word 24)))
    (setf typepred-hash (fetch-obj (stored-word 25)))
    (setf current-xrule (fetch-obj (stored-word 26)))))

(defmethod restore-object* ((obj proofstate))
  (with-slots (label current-goal current-rule dp-state done-subgoals
                     pending-subgoals current-subgoal
                     remaining-subgoals status-flag subgoalnum
                     justification current-input parsed-input printout
                     comment strategy context parent-proofstate
                     proof-dependent-decls dependent-decls
                     current-auto-rewrites tcc-hash subtype-hash
                     rewrite-hash typepred-hash current-xrule)
    obj
    (let ((*restore-object-parent* obj))
      (when label
        (let ((*restore-object-parent-slot* 'label))
          (restore-object* label)))
      (when current-goal
        (let ((*restore-object-parent-slot* 'current-goal))
          (restore-object* current-goal)))
      (when current-rule
        (let ((*restore-object-parent-slot* 'current-rule))
          (restore-object* current-rule)))
      (when dp-state
        (let ((*restore-object-parent-slot* 'dp-state))
          (restore-object* dp-state)))
      (when done-subgoals
        (let ((*restore-object-parent-slot* 'done-subgoals))
          (restore-object* done-subgoals)))
      (when pending-subgoals
        (let ((*restore-object-parent-slot* 'pending-subgoals))
          (restore-object* pending-subgoals)))
      (when current-subgoal
        (let ((*restore-object-parent-slot* 'current-subgoal))
          (restore-object* current-subgoal)))
      (when remaining-subgoals
        (let ((*restore-object-parent-slot* 'remaining-subgoals))
          (restore-object* remaining-subgoals)))
      (when status-flag
        (let ((*restore-object-parent-slot* 'status-flag))
          (restore-object* status-flag)))
      (when subgoalnum
        (let ((*restore-object-parent-slot* 'subgoalnum))
          (restore-object* subgoalnum)))
      (when justification
        (let ((*restore-object-parent-slot* 'justification))
          (restore-object* justification)))
      (when current-input
        (let ((*restore-object-parent-slot* 'current-input))
          (restore-object* current-input)))
      (when parsed-input
        (let ((*restore-object-parent-slot* 'parsed-input))
          (restore-object* parsed-input)))
      (when printout
        (let ((*restore-object-parent-slot* 'printout))
          (restore-object* printout)))
      (when comment
        (let ((*restore-object-parent-slot* 'comment))
          (restore-object* comment)))
      (when strategy
        (let ((*restore-object-parent-slot* 'strategy))
          (restore-object* strategy)))
      (when context
        (let ((*restore-object-parent-slot* 'context))
          (restore-object* context)))
      (when parent-proofstate
        (let ((*restore-object-parent-slot* 'parent-proofstate))
          (restore-object* parent-proofstate)))
      (when proof-dependent-decls
        (let ((*restore-object-parent-slot* 'proof-dependent-decls))
          (restore-object* proof-dependent-decls)))
      (when dependent-decls
        (let ((*restore-object-parent-slot* 'dependent-decls))
          (restore-object* dependent-decls)))
      (when current-auto-rewrites
        (let ((*restore-object-parent-slot* 'current-auto-rewrites))
          (restore-object* current-auto-rewrites)))
      (when tcc-hash
        (let ((*restore-object-parent-slot* 'tcc-hash))
          (restore-object* tcc-hash)))
      (when subtype-hash
        (let ((*restore-object-parent-slot* 'subtype-hash))
          (restore-object* subtype-hash)))
      (when rewrite-hash
        (let ((*restore-object-parent-slot* 'rewrite-hash))
          (restore-object* rewrite-hash)))
      (when typepred-hash
        (let ((*restore-object-parent-slot* 'typepred-hash))
          (restore-object* typepred-hash)))
      (when current-xrule
        (let ((*restore-object-parent-slot* 'current-xrule))
          (restore-object* current-xrule)))
      obj)))

(defmethod copy ((obj dpinfo) &rest initargs)
  (with-slots (dpinfo-sigalist dpinfo-findalist dpinfo-usealist)
    obj
    (make-instance 'dpinfo :dpinfo-sigalist
                   (let* ((get1
                           (getf initargs 'dpinfo-sigalist '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :dpinfo-sigalist
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dpinfo-sigalist getfv))
                   :dpinfo-findalist
                   (let* ((get1
                           (getf initargs 'dpinfo-findalist '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :dpinfo-findalist
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dpinfo-findalist getfv))
                   :dpinfo-usealist
                   (let* ((get1
                           (getf initargs 'dpinfo-usealist '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :dpinfo-usealist
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dpinfo-usealist getfv)))))

(defmethod store-object* ((obj dpinfo))
  (with-slots (dpinfo-sigalist dpinfo-findalist dpinfo-usealist)
    obj
    (reserve-space 4 (push-word (store-obj 'dpinfo))
                   (push-word (store-obj dpinfo-sigalist))
                   (push-word (store-obj dpinfo-findalist))
                   (push-word (store-obj dpinfo-usealist)))))

(defmethod update-fetched ((obj dpinfo))
  (with-slots (dpinfo-sigalist dpinfo-findalist dpinfo-usealist)
    obj
    (setf dpinfo-sigalist (fetch-obj (stored-word 1)))
    (setf dpinfo-findalist (fetch-obj (stored-word 2)))
    (setf dpinfo-usealist (fetch-obj (stored-word 3)))))

(defmethod restore-object* ((obj dpinfo))
  (with-slots (dpinfo-sigalist dpinfo-findalist dpinfo-usealist)
    obj
    (let ((*restore-object-parent* obj))
      (when dpinfo-sigalist
        (let ((*restore-object-parent-slot* 'dpinfo-sigalist))
          (restore-object* dpinfo-sigalist)))
      (when dpinfo-findalist
        (let ((*restore-object-parent-slot* 'dpinfo-findalist))
          (restore-object* dpinfo-findalist)))
      (when dpinfo-usealist
        (let ((*restore-object-parent-slot* 'dpinfo-usealist))
          (restore-object* dpinfo-usealist)))
      obj)))

(defmethod copy ((obj sequent) &rest initargs)
  (with-slots (s-forms hidden-s-forms info)
    obj
    (make-instance 'sequent :s-forms
                   (let* ((get1 (getf initargs 's-forms '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :s-forms '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) s-forms getfv))
                   :p-sforms
                   (let* ((get1 (getf initargs 'p-sforms '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :p-sforms '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :n-sforms
                   (let* ((get1 (getf initargs 'n-sforms '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :n-sforms '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :hidden-s-forms
                   (let* ((get1
                           (getf initargs 'hidden-s-forms '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :hidden-s-forms '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) hidden-s-forms getfv))
                   :info
                   (let* ((get1 (getf initargs 'info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) info getfv)))))

(defmethod store-object* ((obj sequent))
  (with-slots (s-forms p-sforms n-sforms hidden-s-forms info)
    obj
    (reserve-space 6 (push-word (store-obj 'sequent))
                   (push-word (store-obj s-forms))
                   (push-word (store-obj p-sforms))
                   (push-word (store-obj n-sforms))
                   (push-word (store-obj hidden-s-forms))
                   (push-word (store-obj info)))))

(defmethod update-fetched ((obj sequent))
  (with-slots (s-forms p-sforms n-sforms hidden-s-forms info)
    obj
    (setf s-forms (fetch-obj (stored-word 1)))
    (setf p-sforms (fetch-obj (stored-word 2)))
    (setf n-sforms (fetch-obj (stored-word 3)))
    (setf hidden-s-forms (fetch-obj (stored-word 4)))
    (setf info (fetch-obj (stored-word 5)))))

(defmethod restore-object* ((obj sequent))
  (with-slots (s-forms p-sforms n-sforms hidden-s-forms info)
    obj
    (let ((*restore-object-parent* obj))
      (when s-forms
        (let ((*restore-object-parent-slot* 's-forms))
          (restore-object* s-forms)))
      (when p-sforms
        (let ((*restore-object-parent-slot* 'p-sforms))
          (restore-object* p-sforms)))
      (when n-sforms
        (let ((*restore-object-parent-slot* 'n-sforms))
          (restore-object* n-sforms)))
      (when hidden-s-forms
        (let ((*restore-object-parent-slot* 'hidden-s-forms))
          (restore-object* hidden-s-forms)))
      (when info
        (let ((*restore-object-parent-slot* 'info))
          (restore-object* info)))
      obj)))

(defmethod copy ((obj s-formula) &rest initargs)
  (with-slots (formula label asserted?)
    obj
    (make-instance 's-formula :formula
                   (let* ((get1 (getf initargs 'formula '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formula '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formula getfv))
                   :label
                   (let* ((get1 (getf initargs 'label '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :label '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) label getfv))
                   :new?
                   (let* ((get1 (getf initargs 'new? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :new? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :asserted?
                   (let* ((get1 (getf initargs 'asserted? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :asserted? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) asserted? getfv))
                   :view
                   (let* ((get1 (getf initargs 'view '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :view '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv)))))

(defmethod store-object* ((obj s-formula))
  (with-slots (formula label new? asserted? view)
    obj
    (reserve-space 6 (push-word (store-obj 's-formula))
                   (push-word (store-obj formula))
                   (push-word (store-obj label))
                   (push-word (store-obj new?))
                   (push-word (store-obj asserted?))
                   (push-word (store-obj view)))))

(defmethod update-fetched ((obj s-formula))
  (with-slots (formula label new? asserted? view)
    obj
    (setf formula (fetch-obj (stored-word 1)))
    (setf label (fetch-obj (stored-word 2)))
    (setf new? (fetch-obj (stored-word 3)))
    (setf asserted? (fetch-obj (stored-word 4)))
    (setf view (fetch-obj (stored-word 5)))))

(defmethod restore-object* ((obj s-formula))
  (with-slots (formula label new? asserted? view)
    obj
    (let ((*restore-object-parent* obj))
      (when formula
        (let ((*restore-object-parent-slot* 'formula))
          (restore-object* formula)))
      (when label
        (let ((*restore-object-parent-slot* 'label))
          (restore-object* label)))
      (when new?
        (let ((*restore-object-parent-slot* 'new?))
          (restore-object* new?)))
      (when asserted?
        (let ((*restore-object-parent-slot* 'asserted?))
          (restore-object* asserted?)))
      (when view
        (let ((*restore-object-parent-slot* 'view))
          (restore-object* view)))
      obj)))

(defmethod copy ((obj workspace-session) &rest initargs)
  (with-slots (path pvs-files pvs-theories prelude-libs prelude-context
                    lisp-files subdir-alist pvs-context
                    pvs-context-changed strat-file-dates)
    obj
    (make-instance 'workspace-session :path
                   (let* ((get1 (getf initargs 'path '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :path '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) path getfv))
                   :pvs-files
                   (let* ((get1 (getf initargs 'pvs-files '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :pvs-files '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) pvs-files getfv))
                   :pvs-theories
                   (let* ((get1 (getf initargs 'pvs-theories '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :pvs-theories '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) pvs-theories getfv))
                   :prelude-libs
                   (let* ((get1 (getf initargs 'prelude-libs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :prelude-libs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) prelude-libs getfv))
                   :prelude-context
                   (let* ((get1
                           (getf initargs 'prelude-context '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :prelude-context
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) prelude-context getfv))
                   :lisp-files
                   (let* ((get1 (getf initargs 'lisp-files '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :lisp-files '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) lisp-files getfv))
                   :subdir-alist
                   (let* ((get1 (getf initargs 'subdir-alist '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :subdir-alist '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) subdir-alist getfv))
                   :pvs-context
                   (let* ((get1 (getf initargs 'pvs-context '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :pvs-context '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) pvs-context getfv))
                   :pvs-context-changed
                   (let* ((get1
                           (getf initargs 'pvs-context-changed
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-context-changed
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         pvs-context-changed
                       getfv))
                   :strat-file-dates
                   (let* ((get1
                           (getf initargs 'strat-file-dates '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :strat-file-dates
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) strat-file-dates getfv))
                   :all-subst-mod-params-caches
                   (let* ((get1
                           (getf initargs 'all-subst-mod-params-caches
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-subst-mod-params-caches
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         (make-pvs-hash-table :strong-eq? t)
                       getfv)))))

(defmethod store-object* ((obj workspace-session))
  (with-slots (path pvs-files pvs-theories prelude-libs prelude-context
                    lisp-files subdir-alist pvs-context
                    pvs-context-changed strat-file-dates)
    obj
    (reserve-space 11 (push-word (store-obj 'workspace-session))
                   (push-word (store-obj path))
                   (push-word (store-obj pvs-files))
                   (push-word (store-obj pvs-theories))
                   (push-word (store-obj prelude-libs))
                   (push-word (store-obj prelude-context))
                   (push-word (store-obj lisp-files))
                   (push-word (store-obj subdir-alist))
                   (push-word (store-obj pvs-context))
                   (push-word (store-obj pvs-context-changed))
                   (push-word (store-obj strat-file-dates)))))

(defmethod update-fetched ((obj workspace-session))
  (with-slots (path pvs-files pvs-theories prelude-libs prelude-context
                    lisp-files subdir-alist pvs-context
                    pvs-context-changed strat-file-dates
                    all-subst-mod-params-caches)
    obj
    (setf path (fetch-obj (stored-word 1)))
    (setf pvs-files (fetch-obj (stored-word 2)))
    (setf pvs-theories (fetch-obj (stored-word 3)))
    (setf prelude-libs (fetch-obj (stored-word 4)))
    (setf prelude-context (fetch-obj (stored-word 5)))
    (setf lisp-files (fetch-obj (stored-word 6)))
    (setf subdir-alist (fetch-obj (stored-word 7)))
    (setf pvs-context (fetch-obj (stored-word 8)))
    (setf pvs-context-changed (fetch-obj (stored-word 9)))
    (setf strat-file-dates (fetch-obj (stored-word 10)))
    (setf all-subst-mod-params-caches nil)))

(defmethod restore-object* ((obj workspace-session))
  (with-slots (path pvs-files pvs-theories prelude-libs prelude-context
                    lisp-files subdir-alist pvs-context
                    pvs-context-changed strat-file-dates)
    obj
    (let ((*restore-object-parent* obj))
      (when path
        (let ((*restore-object-parent-slot* 'path))
          (restore-object* path)))
      (when pvs-files
        (let ((*restore-object-parent-slot* 'pvs-files))
          (restore-object* pvs-files)))
      (when pvs-theories
        (let ((*restore-object-parent-slot* 'pvs-theories))
          (restore-object* pvs-theories)))
      (when prelude-libs
        (let ((*restore-object-parent-slot* 'prelude-libs))
          (restore-object* prelude-libs)))
      (when prelude-context
        (let ((*restore-object-parent-slot* 'prelude-context))
          (restore-object* prelude-context)))
      (when lisp-files
        (let ((*restore-object-parent-slot* 'lisp-files))
          (restore-object* lisp-files)))
      (when subdir-alist
        (let ((*restore-object-parent-slot* 'subdir-alist))
          (restore-object* subdir-alist)))
      (when pvs-context
        (let ((*restore-object-parent-slot* 'pvs-context))
          (restore-object* pvs-context)))
      (when pvs-context-changed
        (let ((*restore-object-parent-slot* 'pvs-context-changed))
          (restore-object* pvs-context-changed)))
      (when strat-file-dates
        (let ((*restore-object-parent-slot* 'strat-file-dates))
          (restore-object* strat-file-dates)))
      obj)))

(defmethod copy ((obj decl-reference) &rest initargs)
  (with-slots (id class type theory-id library)
    obj
    (make-instance 'decl-reference :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :class
                   (let* ((get1 (getf initargs 'class '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :class '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) class getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :theory-id
                   (let* ((get1 (getf initargs 'theory-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :theory-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) theory-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv)))))

(defmethod store-object* ((obj decl-reference))
  (with-slots (id class type theory-id library)
    obj
    (reserve-space 6 (push-word (store-obj 'decl-reference))
                   (push-word (store-obj id))
                   (push-word (store-obj class))
                   (push-word (store-obj type))
                   (push-word (store-obj theory-id))
                   (push-word (store-obj library)))))

(defmethod update-fetched ((obj decl-reference))
  (with-slots (id class type theory-id library)
    obj
    (setf id (fetch-obj (stored-word 1)))
    (setf class (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf theory-id (fetch-obj (stored-word 4)))
    (setf library (fetch-obj (stored-word 5)))))

(defmethod restore-object* ((obj decl-reference))
  (with-slots (id class type theory-id library)
    obj
    (let ((*restore-object-parent* obj))
      (when id
        (let ((*restore-object-parent-slot* 'id))
          (restore-object* id)))
      (when class
        (let ((*restore-object-parent-slot* 'class))
          (restore-object* class)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when theory-id
        (let ((*restore-object-parent-slot* 'theory-id))
          (restore-object* theory-id)))
      (when library
        (let ((*restore-object-parent-slot* 'library))
          (restore-object* library)))
      obj)))

(defmethod copy ((obj tcc-proof-info) &rest initargs)
  (with-slots (id description create-date run-date script status
                  refers-to real-time run-time interactive?
                  decision-procedure-used origin)
    obj
    (make-instance 'tcc-proof-info :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :description
                   (let* ((get1 (getf initargs 'description '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :description '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) description getfv))
                   :create-date
                   (let* ((get1 (getf initargs 'create-date '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :create-date '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) create-date getfv))
                   :run-date
                   (let* ((get1 (getf initargs 'run-date '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :run-date '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) run-date getfv))
                   :script
                   (let* ((get1 (getf initargs 'script '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :script '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) script getfv))
                   :status
                   (let* ((get1 (getf initargs 'status '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :status '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) status getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :real-time
                   (let* ((get1 (getf initargs 'real-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :real-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) real-time getfv))
                   :run-time
                   (let* ((get1 (getf initargs 'run-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :run-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) run-time getfv))
                   :interactive?
                   (let* ((get1 (getf initargs 'interactive? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :interactive? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) interactive? getfv))
                   :decision-procedure-used
                   (let* ((get1
                           (getf initargs 'decision-procedure-used
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :decision-procedure-used
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         decision-procedure-used
                       getfv))
                   :origin
                   (let* ((get1 (getf initargs 'origin '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :origin '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) origin getfv)))))

(defmethod store-object* ((obj tcc-proof-info))
  (with-slots (id description create-date run-date script status
                  refers-to real-time run-time interactive?
                  decision-procedure-used origin)
    obj
    (reserve-space 13 (push-word (store-obj 'tcc-proof-info))
                   (push-word (store-obj id))
                   (push-word (store-obj description))
                   (push-word (store-obj create-date))
                   (push-word (store-obj run-date))
                   (push-word (store-obj script))
                   (push-word (store-obj status))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj real-time))
                   (push-word (store-obj run-time))
                   (push-word (store-obj interactive?))
                   (push-word (store-obj decision-procedure-used))
                   (push-word (store-obj origin)))))

(defmethod update-fetched ((obj tcc-proof-info))
  (with-slots (id description create-date run-date script status
                  refers-to real-time run-time interactive?
                  decision-procedure-used origin)
    obj
    (setf id (fetch-obj (stored-word 1)))
    (setf description (fetch-obj (stored-word 2)))
    (setf create-date (fetch-obj (stored-word 3)))
    (setf run-date (fetch-obj (stored-word 4)))
    (setf script (fetch-obj (stored-word 5)))
    (setf status (fetch-obj (stored-word 6)))
    (setf refers-to (fetch-obj (stored-word 7)))
    (setf real-time (fetch-obj (stored-word 8)))
    (setf run-time (fetch-obj (stored-word 9)))
    (setf interactive? (fetch-obj (stored-word 10)))
    (setf decision-procedure-used (fetch-obj (stored-word 11)))
    (setf origin (fetch-obj (stored-word 12)))))

(defmethod restore-object* ((obj tcc-proof-info))
  (with-slots (id description create-date run-date script status
                  refers-to real-time run-time interactive?
                  decision-procedure-used origin)
    obj
    (let ((*restore-object-parent* obj))
      (when id
        (let ((*restore-object-parent-slot* 'id))
          (restore-object* id)))
      (when description
        (let ((*restore-object-parent-slot* 'description))
          (restore-object* description)))
      (when create-date
        (let ((*restore-object-parent-slot* 'create-date))
          (restore-object* create-date)))
      (when run-date
        (let ((*restore-object-parent-slot* 'run-date))
          (restore-object* run-date)))
      (when script
        (let ((*restore-object-parent-slot* 'script))
          (restore-object* script)))
      (when status
        (let ((*restore-object-parent-slot* 'status))
          (restore-object* status)))
      (when refers-to
        (let ((*restore-object-parent-slot* 'refers-to))
          (restore-object* refers-to)))
      (when real-time
        (let ((*restore-object-parent-slot* 'real-time))
          (restore-object* real-time)))
      (when run-time
        (let ((*restore-object-parent-slot* 'run-time))
          (restore-object* run-time)))
      (when interactive?
        (let ((*restore-object-parent-slot* 'interactive?))
          (restore-object* interactive?)))
      (when decision-procedure-used
        (let ((*restore-object-parent-slot* 'decision-procedure-used))
          (restore-object* decision-procedure-used)))
      (when origin
        (let ((*restore-object-parent-slot* 'origin))
          (restore-object* origin)))
      obj)))

(defmethod copy ((obj tcc-origin) &rest initargs)
  (with-slots (root kind expr type)
    obj
    (make-instance 'tcc-origin :root
                   (let* ((get1 (getf initargs 'root '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :root '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) root getfv))
                   :kind
                   (let* ((get1 (getf initargs 'kind '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :kind '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) kind getfv))
                   :expr
                   (let* ((get1 (getf initargs 'expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expr getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv)))))

(defmethod store-object* ((obj tcc-origin))
  (with-slots (root kind expr type)
    obj
    (reserve-space 5 (push-word (store-obj 'tcc-origin))
                   (push-word (store-obj root))
                   (push-word (store-obj kind))
                   (push-word (store-obj expr))
                   (push-word (store-obj type)))))

(defmethod update-fetched ((obj tcc-origin))
  (with-slots (root kind expr type)
    obj
    (setf root (fetch-obj (stored-word 1)))
    (setf kind (fetch-obj (stored-word 2)))
    (setf expr (fetch-obj (stored-word 3)))
    (setf type (fetch-obj (stored-word 4)))))

(defmethod restore-object* ((obj tcc-origin))
  (with-slots (root kind expr type)
    obj
    (let ((*restore-object-parent* obj))
      (when root
        (let ((*restore-object-parent-slot* 'root))
          (restore-object* root)))
      (when kind
        (let ((*restore-object-parent-slot* 'kind))
          (restore-object* kind)))
      (when expr
        (let ((*restore-object-parent-slot* 'expr))
          (restore-object* expr)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      obj)))

(defmethod copy ((obj proof-info) &rest initargs)
  (with-slots (id description create-date run-date script status
                  refers-to real-time run-time interactive?
                  decision-procedure-used)
    obj
    (make-instance 'proof-info :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :description
                   (let* ((get1 (getf initargs 'description '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :description '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) description getfv))
                   :create-date
                   (let* ((get1 (getf initargs 'create-date '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :create-date '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) create-date getfv))
                   :run-date
                   (let* ((get1 (getf initargs 'run-date '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :run-date '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) run-date getfv))
                   :script
                   (let* ((get1 (getf initargs 'script '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :script '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) script getfv))
                   :status
                   (let* ((get1 (getf initargs 'status '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :status '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) status getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :real-time
                   (let* ((get1 (getf initargs 'real-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :real-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) real-time getfv))
                   :run-time
                   (let* ((get1 (getf initargs 'run-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :run-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) run-time getfv))
                   :interactive?
                   (let* ((get1 (getf initargs 'interactive? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :interactive? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) interactive? getfv))
                   :decision-procedure-used
                   (let* ((get1
                           (getf initargs 'decision-procedure-used
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :decision-procedure-used
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         decision-procedure-used
                       getfv)))))

(defmethod store-object* ((obj proof-info))
  (with-slots (id description create-date run-date script status
                  refers-to real-time run-time interactive?
                  decision-procedure-used)
    obj
    (reserve-space 12 (push-word (store-obj 'proof-info))
                   (push-word (store-obj id))
                   (push-word (store-obj description))
                   (push-word (store-obj create-date))
                   (push-word (store-obj run-date))
                   (push-word (store-obj script))
                   (push-word (store-obj status))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj real-time))
                   (push-word (store-obj run-time))
                   (push-word (store-obj interactive?))
                   (push-word (store-obj decision-procedure-used)))))

(defmethod update-fetched ((obj proof-info))
  (with-slots (id description create-date run-date script status
                  refers-to real-time run-time interactive?
                  decision-procedure-used)
    obj
    (setf id (fetch-obj (stored-word 1)))
    (setf description (fetch-obj (stored-word 2)))
    (setf create-date (fetch-obj (stored-word 3)))
    (setf run-date (fetch-obj (stored-word 4)))
    (setf script (fetch-obj (stored-word 5)))
    (setf status (fetch-obj (stored-word 6)))
    (setf refers-to (fetch-obj (stored-word 7)))
    (setf real-time (fetch-obj (stored-word 8)))
    (setf run-time (fetch-obj (stored-word 9)))
    (setf interactive? (fetch-obj (stored-word 10)))
    (setf decision-procedure-used (fetch-obj (stored-word 11)))))

(defmethod restore-object* ((obj proof-info))
  (with-slots (id description create-date run-date script status
                  refers-to real-time run-time interactive?
                  decision-procedure-used)
    obj
    (let ((*restore-object-parent* obj))
      (when id
        (let ((*restore-object-parent-slot* 'id))
          (restore-object* id)))
      (when description
        (let ((*restore-object-parent-slot* 'description))
          (restore-object* description)))
      (when create-date
        (let ((*restore-object-parent-slot* 'create-date))
          (restore-object* create-date)))
      (when run-date
        (let ((*restore-object-parent-slot* 'run-date))
          (restore-object* run-date)))
      (when script
        (let ((*restore-object-parent-slot* 'script))
          (restore-object* script)))
      (when status
        (let ((*restore-object-parent-slot* 'status))
          (restore-object* status)))
      (when refers-to
        (let ((*restore-object-parent-slot* 'refers-to))
          (restore-object* refers-to)))
      (when real-time
        (let ((*restore-object-parent-slot* 'real-time))
          (restore-object* real-time)))
      (when run-time
        (let ((*restore-object-parent-slot* 'run-time))
          (restore-object* run-time)))
      (when interactive?
        (let ((*restore-object-parent-slot* 'interactive?))
          (restore-object* interactive?)))
      (when decision-procedure-used
        (let ((*restore-object-parent-slot* 'decision-procedure-used))
          (restore-object* decision-procedure-used)))
      obj)))

(defmethod copy ((obj destructive-eval-defn) &rest initargs)
  (with-slots (name definition output-vars side-effects)
    obj
    (make-instance 'destructive-eval-defn :name
                   (let* ((get1 (getf initargs 'name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) name getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :output-vars
                   (let* ((get1 (getf initargs 'output-vars '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :output-vars '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) output-vars getfv))
                   :side-effects
                   (let* ((get1 (getf initargs 'side-effects '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :side-effects '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) side-effects getfv)))))

(defmethod store-object* ((obj destructive-eval-defn))
  (with-slots (name definition output-vars side-effects)
    obj
    (reserve-space 5 (push-word (store-obj 'destructive-eval-defn))
                   (push-word (store-obj name))
                   (push-word (store-obj definition))
                   (push-word (store-obj output-vars))
                   (push-word (store-obj side-effects)))))

(defmethod update-fetched ((obj destructive-eval-defn))
  (with-slots (name definition output-vars side-effects)
    obj
    (setf name (fetch-obj (stored-word 1)))
    (setf definition (fetch-obj (stored-word 2)))
    (setf output-vars (fetch-obj (stored-word 3)))
    (setf side-effects (fetch-obj (stored-word 4)))))

(defmethod restore-object* ((obj destructive-eval-defn))
  (with-slots (name definition output-vars side-effects)
    obj
    (let ((*restore-object-parent* obj))
      (when name
        (let ((*restore-object-parent-slot* 'name))
          (restore-object* name)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      (when output-vars
        (let ((*restore-object-parent-slot* 'output-vars))
          (restore-object* output-vars)))
      (when side-effects
        (let ((*restore-object-parent-slot* 'side-effects))
          (restore-object* side-effects)))
      obj)))

(defmethod copy ((obj eval-type-info) &rest initargs)
  (with-slots (ir-type-name c-type-info c-type-info-table)
    obj
    (make-instance 'eval-type-info :ir-type-name
                   (let* ((get1 (getf initargs 'ir-type-name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-type-name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-type-name getfv))
                   :c-type-info
                   (let* ((get1 (getf initargs 'c-type-info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :c-type-info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) c-type-info getfv))
                   :c-type-info-table
                   (let* ((get1
                           (getf initargs 'c-type-info-table '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :c-type-info-table
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         c-type-info-table
                       getfv)))))

(defmethod store-object* ((obj eval-type-info))
  (with-slots (ir-type-name c-type-info c-type-info-table)
    obj
    (reserve-space 4 (push-word (store-obj 'eval-type-info))
                   (push-word (store-obj ir-type-name))
                   (push-word (store-obj c-type-info))
                   (push-word (store-obj c-type-info-table)))))

(defmethod update-fetched ((obj eval-type-info))
  (with-slots (ir-type-name c-type-info c-type-info-table)
    obj
    (setf ir-type-name (fetch-obj (stored-word 1)))
    (setf c-type-info (fetch-obj (stored-word 2)))
    (setf c-type-info-table (fetch-obj (stored-word 3)))))

(defmethod restore-object* ((obj eval-type-info))
  (with-slots (ir-type-name c-type-info c-type-info-table)
    obj
    (let ((*restore-object-parent* obj))
      (when ir-type-name
        (let ((*restore-object-parent-slot* 'ir-type-name))
          (restore-object* ir-type-name)))
      (when c-type-info
        (let ((*restore-object-parent-slot* 'c-type-info))
          (restore-object* c-type-info)))
      (when c-type-info-table
        (let ((*restore-object-parent-slot* 'c-type-info-table))
          (restore-object* c-type-info-table)))
      obj)))

(defmethod copy ((obj eval-info) &rest initargs)
  (with-slots (ir cdefn c-type-info-table internal external)
    obj
    (make-instance 'eval-info :ir
                   (let* ((get1 (getf initargs 'ir '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir getfv))
                   :cdefn
                   (let* ((get1 (getf initargs 'cdefn '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :cdefn '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) cdefn getfv))
                   :c-type-info-table
                   (let* ((get1
                           (getf initargs 'c-type-info-table '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :c-type-info-table
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) c-type-info-table getfv))
                   :internal
                   (let* ((get1 (getf initargs 'internal '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :internal '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) internal getfv))
                   :external
                   (let* ((get1 (getf initargs 'external '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :external '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) external getfv)))))

(defmethod store-object* ((obj eval-info))
  (with-slots (ir cdefn c-type-info-table internal external)
    obj
    (reserve-space 6 (push-word (store-obj 'eval-info))
                   (push-word (store-obj ir))
                   (push-word (store-obj cdefn))
                   (push-word (store-obj c-type-info-table))
                   (push-word (store-obj internal))
                   (push-word (store-obj external)))))

(defmethod update-fetched ((obj eval-info))
  (with-slots (ir cdefn c-type-info-table internal external)
    obj
    (setf ir (fetch-obj (stored-word 1)))
    (setf cdefn (fetch-obj (stored-word 2)))
    (setf c-type-info-table (fetch-obj (stored-word 3)))
    (setf internal (fetch-obj (stored-word 4)))
    (setf external (fetch-obj (stored-word 5)))))

(defmethod restore-object* ((obj eval-info))
  (with-slots (ir cdefn c-type-info-table internal external)
    obj
    (let ((*restore-object-parent* obj))
      (when ir
        (let ((*restore-object-parent-slot* 'ir))
          (restore-object* ir)))
      (when cdefn
        (let ((*restore-object-parent-slot* 'cdefn))
          (restore-object* cdefn)))
      (when c-type-info-table
        (let ((*restore-object-parent-slot* 'c-type-info-table))
          (restore-object* c-type-info-table)))
      (when internal
        (let ((*restore-object-parent-slot* 'internal))
          (restore-object* internal)))
      (when external
        (let ((*restore-object-parent-slot* 'external))
          (restore-object* external)))
      obj)))

(defmethod copy ((obj eval-defn) &rest initargs)
  (with-slots (name definition output-vars)
    obj
    (make-instance 'eval-defn :name
                   (let* ((get1 (getf initargs 'name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) name getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :output-vars
                   (let* ((get1 (getf initargs 'output-vars '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :output-vars '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) output-vars getfv)))))

(defmethod store-object* ((obj eval-defn))
  (with-slots (name definition output-vars)
    obj
    (reserve-space 4 (push-word (store-obj 'eval-defn))
                   (push-word (store-obj name))
                   (push-word (store-obj definition))
                   (push-word (store-obj output-vars)))))

(defmethod update-fetched ((obj eval-defn))
  (with-slots (name definition output-vars)
    obj
    (setf name (fetch-obj (stored-word 1)))
    (setf definition (fetch-obj (stored-word 2)))
    (setf output-vars (fetch-obj (stored-word 3)))))

(defmethod restore-object* ((obj eval-defn))
  (with-slots (name definition output-vars)
    obj
    (let ((*restore-object-parent* obj))
      (when name
        (let ((*restore-object-parent-slot* 'name))
          (restore-object* name)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      (when output-vars
        (let ((*restore-object-parent-slot* 'output-vars))
          (restore-object* output-vars)))
      obj)))

(defmethod copy ((obj eval-defn-info) &rest initargs)
  (with-slots (unary multiary destructive)
    obj
    (make-instance 'eval-defn-info :unary
                   (let* ((get1 (getf initargs 'unary '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unary '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unary getfv))
                   :multiary
                   (let* ((get1 (getf initargs 'multiary '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :multiary '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) multiary getfv))
                   :destructive
                   (let* ((get1 (getf initargs 'destructive '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :destructive '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) destructive getfv)))))

(defmethod store-object* ((obj eval-defn-info))
  (with-slots (unary multiary destructive)
    obj
    (reserve-space 4 (push-word (store-obj 'eval-defn-info))
                   (push-word (store-obj unary))
                   (push-word (store-obj multiary))
                   (push-word (store-obj destructive)))))

(defmethod update-fetched ((obj eval-defn-info))
  (with-slots (unary multiary destructive)
    obj
    (setf unary (fetch-obj (stored-word 1)))
    (setf multiary (fetch-obj (stored-word 2)))
    (setf destructive (fetch-obj (stored-word 3)))))

(defmethod restore-object* ((obj eval-defn-info))
  (with-slots (unary multiary destructive)
    obj
    (let ((*restore-object-parent* obj))
      (when unary
        (let ((*restore-object-parent-slot* 'unary))
          (restore-object* unary)))
      (when multiary
        (let ((*restore-object-parent-slot* 'multiary))
          (restore-object* multiary)))
      (when destructive
        (let ((*restore-object-parent-slot* 'destructive))
          (restore-object* destructive)))
      obj)))

(defmethod copy ((obj store-print-type) &rest initargs)
  (with-slots (print-type nonempty? type)
    obj
    (make-instance 'store-print-type :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv)))))

(defmethod store-object* ((obj store-print-type))
  (with-slots (print-type nonempty?)
    obj
    (reserve-space 3 (push-word (store-obj 'store-print-type))
                   (push-word (store-obj print-type))
                   (push-word (store-obj nonempty?)))))

(defmethod update-fetched ((obj store-print-type))
  (with-slots (print-type nonempty? type)
    obj
    (setf print-type (fetch-obj (stored-word 1)))
    (setf nonempty? (fetch-obj (stored-word 2)))
    (setf type nil)))

(defmethod restore-object* ((obj store-print-type))
  (with-slots (nonempty? print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when nonempty?
        (let ((*restore-object-parent-slot* 'nonempty?))
          (restore-object* nonempty?)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj exists-type) &rest initargs)
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     bindings type)
    obj
    (make-instance 'exists-type :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv))
                   :bindings
                   (let* ((get1 (getf initargs 'bindings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :bindings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) bindings getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv)))))

(defmethod store-object* ((obj exists-type))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     bindings type)
    obj
    (reserve-space 9 (push-word (store-obj 'exists-type))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?))
                   (push-word (store-obj bindings))
                   (push-word (store-obj type)))))

(defmethod update-fetched ((obj exists-type))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     bindings type pvs-sxhash-value free-variables
                     free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf print-type (fetch-obj (stored-word 3)))
    (setf ghost? (fetch-obj (stored-word 4)))
    (setf from-conversion (fetch-obj (stored-word 5)))
    (setf nonempty? (fetch-obj (stored-word 6)))
    (setf bindings (fetch-obj (stored-word 7)))
    (setf type (fetch-obj (stored-word 8)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj exists-type))
  (with-slots (ghost? from-conversion bindings type print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when bindings
        (let ((*restore-object-parent-slot* 'bindings))
          (restore-object* bindings)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj forall-type) &rest initargs)
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     bindings type)
    obj
    (make-instance 'forall-type :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv))
                   :bindings
                   (let* ((get1 (getf initargs 'bindings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :bindings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) bindings getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv)))))

(defmethod store-object* ((obj forall-type))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     bindings type)
    obj
    (reserve-space 9 (push-word (store-obj 'forall-type))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?))
                   (push-word (store-obj bindings))
                   (push-word (store-obj type)))))

(defmethod update-fetched ((obj forall-type))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     bindings type pvs-sxhash-value free-variables
                     free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf print-type (fetch-obj (stored-word 3)))
    (setf ghost? (fetch-obj (stored-word 4)))
    (setf from-conversion (fetch-obj (stored-word 5)))
    (setf nonempty? (fetch-obj (stored-word 6)))
    (setf bindings (fetch-obj (stored-word 7)))
    (setf type (fetch-obj (stored-word 8)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj forall-type))
  (with-slots (ghost? from-conversion bindings type print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when bindings
        (let ((*restore-object-parent-slot* 'bindings))
          (restore-object* bindings)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj quant-type) &rest initargs)
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     bindings type)
    obj
    (make-instance 'quant-type :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv))
                   :bindings
                   (let* ((get1 (getf initargs 'bindings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :bindings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) bindings getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv)))))

(defmethod store-object* ((obj quant-type))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     bindings type)
    obj
    (reserve-space 9 (push-word (store-obj 'quant-type))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?))
                   (push-word (store-obj bindings))
                   (push-word (store-obj type)))))

(defmethod update-fetched ((obj quant-type))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     bindings type pvs-sxhash-value free-variables
                     free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf print-type (fetch-obj (stored-word 3)))
    (setf ghost? (fetch-obj (stored-word 4)))
    (setf from-conversion (fetch-obj (stored-word 5)))
    (setf nonempty? (fetch-obj (stored-word 6)))
    (setf bindings (fetch-obj (stored-word 7)))
    (setf type (fetch-obj (stored-word 8)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj quant-type))
  (with-slots (ghost? from-conversion bindings type print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when bindings
        (let ((*restore-object-parent-slot* 'bindings))
          (restore-object* bindings)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj binding-type) &rest initargs)
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     bindings type)
    obj
    (make-instance 'binding-type :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv))
                   :bindings
                   (let* ((get1 (getf initargs 'bindings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :bindings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) bindings getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv)))))

(defmethod store-object* ((obj binding-type))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     bindings type)
    obj
    (reserve-space 9 (push-word (store-obj 'binding-type))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?))
                   (push-word (store-obj bindings))
                   (push-word (store-obj type)))))

(defmethod update-fetched ((obj binding-type))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     bindings type pvs-sxhash-value free-variables
                     free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf print-type (fetch-obj (stored-word 3)))
    (setf ghost? (fetch-obj (stored-word 4)))
    (setf from-conversion (fetch-obj (stored-word 5)))
    (setf nonempty? (fetch-obj (stored-word 6)))
    (setf bindings (fetch-obj (stored-word 7)))
    (setf type (fetch-obj (stored-word 8)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj binding-type))
  (with-slots (ghost? from-conversion bindings type print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when bindings
        (let ((*restore-object-parent-slot* 'bindings))
          (restore-object* bindings)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj type-extension) &rest initargs)
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     type extension)
    obj
    (make-instance 'type-extension :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :extension
                   (let* ((get1 (getf initargs 'extension '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :extension '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) extension getfv)))))

(defmethod store-object* ((obj type-extension))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     type extension)
    obj
    (reserve-space 9 (push-word (store-obj 'type-extension))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?))
                   (push-word (store-obj type))
                   (push-word (store-obj extension)))))

(defmethod update-fetched ((obj type-extension))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     type extension pvs-sxhash-value free-variables
                     free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf print-type (fetch-obj (stored-word 3)))
    (setf ghost? (fetch-obj (stored-word 4)))
    (setf from-conversion (fetch-obj (stored-word 5)))
    (setf nonempty? (fetch-obj (stored-word 6)))
    (setf type (fetch-obj (stored-word 7)))
    (setf extension (fetch-obj (stored-word 8)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj type-extension))
  (with-slots (ghost? from-conversion type extension print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when extension
        (let ((*restore-object-parent-slot* 'extension))
          (restore-object* extension)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj struct-sub-recordtype) &rest initargs)
  (with-slots (fields dependent? place parens print-type ghost?
                      from-conversion nonempty? generated-by type)
    obj
    (make-instance 'struct-sub-recordtype :fields
                   (let* ((get1 (getf initargs 'fields '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :fields '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) fields getfv))
                   :dependent?
                   (let* ((get1 (getf initargs 'dependent? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dependent? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dependent? getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv)))))

(defmethod store-object* ((obj struct-sub-recordtype))
  (with-slots (fields dependent? place parens print-type ghost?
                      from-conversion nonempty? generated-by type)
    obj
    (reserve-space 11 (push-word (store-obj 'struct-sub-recordtype))
                   (push-word (store-obj fields))
                   (push-word (store-obj dependent?))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj type)))))

(defmethod update-fetched ((obj struct-sub-recordtype))
  (with-slots (fields dependent? place parens print-type ghost?
                      from-conversion nonempty? generated-by type
                      pvs-sxhash-value free-variables free-parameters)
    obj
    (setf fields (fetch-obj (stored-word 1)))
    (setf dependent? (fetch-obj (stored-word 2)))
    (setf place (fetch-obj (stored-word 3)))
    (setf parens (fetch-obj (stored-word 4)))
    (setf print-type (fetch-obj (stored-word 5)))
    (setf ghost? (fetch-obj (stored-word 6)))
    (setf from-conversion (fetch-obj (stored-word 7)))
    (setf nonempty? (fetch-obj (stored-word 8)))
    (setf generated-by (fetch-obj (stored-word 9)))
    (setf type (fetch-obj (stored-word 10)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj struct-sub-recordtype))
  (with-slots (fields ghost? from-conversion generated-by type
                      print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when fields
        (let ((*restore-object-parent-slot* 'fields))
          (restore-object* fields)))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when generated-by
        (let ((*restore-object-parent-slot* 'generated-by))
          (restore-object* generated-by)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj recordtype) &rest initargs)
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     fields dependent?)
    obj
    (make-instance 'recordtype :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv))
                   :fields
                   (let* ((get1 (getf initargs 'fields '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :fields '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) fields getfv))
                   :dependent?
                   (let* ((get1 (getf initargs 'dependent? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dependent? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dependent? getfv)))))

(defmethod store-object* ((obj recordtype))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     fields dependent?)
    obj
    (reserve-space 9 (push-word (store-obj 'recordtype))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?))
                   (push-word (store-obj fields))
                   (push-word (store-obj dependent?)))))

(defmethod update-fetched ((obj recordtype))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     fields dependent? pvs-sxhash-value free-variables
                     free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf print-type (fetch-obj (stored-word 3)))
    (setf ghost? (fetch-obj (stored-word 4)))
    (setf from-conversion (fetch-obj (stored-word 5)))
    (setf nonempty? (fetch-obj (stored-word 6)))
    (setf fields (fetch-obj (stored-word 7)))
    (setf dependent? (fetch-obj (stored-word 8)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj recordtype))
  (with-slots (ghost? from-conversion fields print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when fields
        (let ((*restore-object-parent-slot* 'fields))
          (restore-object* fields)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj record-or-struct-subtype) &rest initargs)
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     fields dependent?)
    obj
    (make-instance 'record-or-struct-subtype :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv))
                   :fields
                   (let* ((get1 (getf initargs 'fields '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :fields '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) fields getfv))
                   :dependent?
                   (let* ((get1 (getf initargs 'dependent? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dependent? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dependent? getfv)))))

(defmethod store-object* ((obj record-or-struct-subtype))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     fields dependent?)
    obj
    (reserve-space 9 (push-word (store-obj 'record-or-struct-subtype))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?))
                   (push-word (store-obj fields))
                   (push-word (store-obj dependent?)))))

(defmethod update-fetched ((obj record-or-struct-subtype))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     fields dependent? pvs-sxhash-value free-variables
                     free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf print-type (fetch-obj (stored-word 3)))
    (setf ghost? (fetch-obj (stored-word 4)))
    (setf from-conversion (fetch-obj (stored-word 5)))
    (setf nonempty? (fetch-obj (stored-word 6)))
    (setf fields (fetch-obj (stored-word 7)))
    (setf dependent? (fetch-obj (stored-word 8)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj record-or-struct-subtype))
  (with-slots (ghost? from-conversion fields print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when fields
        (let ((*restore-object-parent-slot* 'fields))
          (restore-object* fields)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj dep-domain-tupletype) &rest initargs)
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     types generated? var-bindings)
    obj
    (make-instance 'dep-domain-tupletype :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv))
                   :types
                   (let* ((get1 (getf initargs 'types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) types getfv))
                   :generated?
                   (let* ((get1 (getf initargs 'generated? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated? getfv))
                   :var-bindings
                   (let* ((get1 (getf initargs 'var-bindings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :var-bindings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) var-bindings getfv)))))

(defmethod store-object* ((obj dep-domain-tupletype))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     types generated? var-bindings)
    obj
    (reserve-space 10 (push-word (store-obj 'dep-domain-tupletype))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?))
                   (push-word (store-obj types))
                   (push-word (store-obj generated?))
                   (push-word (store-obj var-bindings)))))

(defmethod update-fetched ((obj dep-domain-tupletype))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     types generated? var-bindings pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf print-type (fetch-obj (stored-word 3)))
    (setf ghost? (fetch-obj (stored-word 4)))
    (setf from-conversion (fetch-obj (stored-word 5)))
    (setf nonempty? (fetch-obj (stored-word 6)))
    (setf types (fetch-obj (stored-word 7)))
    (setf generated? (fetch-obj (stored-word 8)))
    (setf var-bindings (fetch-obj (stored-word 9)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj dep-domain-tupletype))
  (with-slots (ghost? from-conversion types var-bindings print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when types
        (let ((*restore-object-parent-slot* 'types))
          (restore-object* types)))
      (when var-bindings
        (let ((*restore-object-parent-slot* 'var-bindings))
          (restore-object* var-bindings)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj domain-tupletype) &rest initargs)
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     types generated?)
    obj
    (make-instance 'domain-tupletype :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv))
                   :types
                   (let* ((get1 (getf initargs 'types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) types getfv))
                   :generated?
                   (let* ((get1 (getf initargs 'generated? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated? getfv)))))

(defmethod store-object* ((obj domain-tupletype))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     types generated?)
    obj
    (reserve-space 9 (push-word (store-obj 'domain-tupletype))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?))
                   (push-word (store-obj types))
                   (push-word (store-obj generated?)))))

(defmethod update-fetched ((obj domain-tupletype))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     types generated? pvs-sxhash-value free-variables
                     free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf print-type (fetch-obj (stored-word 3)))
    (setf ghost? (fetch-obj (stored-word 4)))
    (setf from-conversion (fetch-obj (stored-word 5)))
    (setf nonempty? (fetch-obj (stored-word 6)))
    (setf types (fetch-obj (stored-word 7)))
    (setf generated? (fetch-obj (stored-word 8)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj domain-tupletype))
  (with-slots (ghost? from-conversion types print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when types
        (let ((*restore-object-parent-slot* 'types))
          (restore-object* types)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj cotupletype) &rest initargs)
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     types generated?)
    obj
    (make-instance 'cotupletype :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv))
                   :types
                   (let* ((get1 (getf initargs 'types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) types getfv))
                   :generated?
                   (let* ((get1 (getf initargs 'generated? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated? getfv)))))

(defmethod store-object* ((obj cotupletype))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     types generated?)
    obj
    (reserve-space 9 (push-word (store-obj 'cotupletype))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?))
                   (push-word (store-obj types))
                   (push-word (store-obj generated?)))))

(defmethod update-fetched ((obj cotupletype))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     types generated? pvs-sxhash-value free-variables
                     free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf print-type (fetch-obj (stored-word 3)))
    (setf ghost? (fetch-obj (stored-word 4)))
    (setf from-conversion (fetch-obj (stored-word 5)))
    (setf nonempty? (fetch-obj (stored-word 6)))
    (setf types (fetch-obj (stored-word 7)))
    (setf generated? (fetch-obj (stored-word 8)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj cotupletype))
  (with-slots (ghost? from-conversion types print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when types
        (let ((*restore-object-parent-slot* 'types))
          (restore-object* types)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj struct-sub-tupletype) &rest initargs)
  (with-slots (types generated? place parens print-type ghost?
                     from-conversion nonempty? generated-by type)
    obj
    (make-instance 'struct-sub-tupletype :types
                   (let* ((get1 (getf initargs 'types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) types getfv))
                   :generated?
                   (let* ((get1 (getf initargs 'generated? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated? getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv)))))

(defmethod store-object* ((obj struct-sub-tupletype))
  (with-slots (types generated? place parens print-type ghost?
                     from-conversion nonempty? generated-by type)
    obj
    (reserve-space 11 (push-word (store-obj 'struct-sub-tupletype))
                   (push-word (store-obj types))
                   (push-word (store-obj generated?))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj type)))))

(defmethod update-fetched ((obj struct-sub-tupletype))
  (with-slots (types generated? place parens print-type ghost?
                     from-conversion nonempty? generated-by type
                     pvs-sxhash-value free-variables free-parameters)
    obj
    (setf types (fetch-obj (stored-word 1)))
    (setf generated? (fetch-obj (stored-word 2)))
    (setf place (fetch-obj (stored-word 3)))
    (setf parens (fetch-obj (stored-word 4)))
    (setf print-type (fetch-obj (stored-word 5)))
    (setf ghost? (fetch-obj (stored-word 6)))
    (setf from-conversion (fetch-obj (stored-word 7)))
    (setf nonempty? (fetch-obj (stored-word 8)))
    (setf generated-by (fetch-obj (stored-word 9)))
    (setf type (fetch-obj (stored-word 10)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj struct-sub-tupletype))
  (with-slots (types ghost? from-conversion generated-by type
                     print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when types
        (let ((*restore-object-parent-slot* 'types))
          (restore-object* types)))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when generated-by
        (let ((*restore-object-parent-slot* 'generated-by))
          (restore-object* generated-by)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj tupletype) &rest initargs)
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     types generated?)
    obj
    (make-instance 'tupletype :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv))
                   :types
                   (let* ((get1 (getf initargs 'types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) types getfv))
                   :generated?
                   (let* ((get1 (getf initargs 'generated? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated? getfv)))))

(defmethod store-object* ((obj tupletype))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     types generated?)
    obj
    (reserve-space 9 (push-word (store-obj 'tupletype))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?))
                   (push-word (store-obj types))
                   (push-word (store-obj generated?)))))

(defmethod update-fetched ((obj tupletype))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     types generated? pvs-sxhash-value free-variables
                     free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf print-type (fetch-obj (stored-word 3)))
    (setf ghost? (fetch-obj (stored-word 4)))
    (setf from-conversion (fetch-obj (stored-word 5)))
    (setf nonempty? (fetch-obj (stored-word 6)))
    (setf types (fetch-obj (stored-word 7)))
    (setf generated? (fetch-obj (stored-word 8)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj tupletype))
  (with-slots (ghost? from-conversion types print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when types
        (let ((*restore-object-parent-slot* 'types))
          (restore-object* types)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj tuple-or-struct-subtype) &rest initargs)
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     types generated?)
    obj
    (make-instance 'tuple-or-struct-subtype :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv))
                   :types
                   (let* ((get1 (getf initargs 'types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) types getfv))
                   :generated?
                   (let* ((get1 (getf initargs 'generated? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated? getfv)))))

(defmethod store-object* ((obj tuple-or-struct-subtype))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     types generated?)
    obj
    (reserve-space 9 (push-word (store-obj 'tuple-or-struct-subtype))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?))
                   (push-word (store-obj types))
                   (push-word (store-obj generated?)))))

(defmethod update-fetched ((obj tuple-or-struct-subtype))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     types generated? pvs-sxhash-value free-variables
                     free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf print-type (fetch-obj (stored-word 3)))
    (setf ghost? (fetch-obj (stored-word 4)))
    (setf from-conversion (fetch-obj (stored-word 5)))
    (setf nonempty? (fetch-obj (stored-word 6)))
    (setf types (fetch-obj (stored-word 7)))
    (setf generated? (fetch-obj (stored-word 8)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj tuple-or-struct-subtype))
  (with-slots (ghost? from-conversion types print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when types
        (let ((*restore-object-parent-slot* 'types))
          (restore-object* types)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj arraytype) &rest initargs)
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     domain range)
    obj
    (make-instance 'arraytype :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv))
                   :domain
                   (let* ((get1 (getf initargs 'domain '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :domain '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) domain getfv))
                   :range
                   (let* ((get1 (getf initargs 'range '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :range '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) range getfv)))))

(defmethod store-object* ((obj arraytype))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     domain range)
    obj
    (reserve-space 9 (push-word (store-obj 'arraytype))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?))
                   (push-word (store-obj domain))
                   (push-word (store-obj range)))))

(defmethod update-fetched ((obj arraytype))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     domain range pvs-sxhash-value free-variables
                     free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf print-type (fetch-obj (stored-word 3)))
    (setf ghost? (fetch-obj (stored-word 4)))
    (setf from-conversion (fetch-obj (stored-word 5)))
    (setf nonempty? (fetch-obj (stored-word 6)))
    (setf domain (fetch-obj (stored-word 7)))
    (setf range (fetch-obj (stored-word 8)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj arraytype))
  (with-slots (ghost? from-conversion domain range print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when domain
        (let ((*restore-object-parent-slot* 'domain))
          (restore-object* domain)))
      (when range
        (let ((*restore-object-parent-slot* 'range))
          (restore-object* range)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj functiontype) &rest initargs)
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     domain range)
    obj
    (make-instance 'functiontype :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv))
                   :domain
                   (let* ((get1 (getf initargs 'domain '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :domain '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) domain getfv))
                   :range
                   (let* ((get1 (getf initargs 'range '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :range '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) range getfv)))))

(defmethod store-object* ((obj functiontype))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     domain range)
    obj
    (reserve-space 9 (push-word (store-obj 'functiontype))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?))
                   (push-word (store-obj domain))
                   (push-word (store-obj range)))))

(defmethod update-fetched ((obj functiontype))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     domain range pvs-sxhash-value free-variables
                     free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf print-type (fetch-obj (stored-word 3)))
    (setf ghost? (fetch-obj (stored-word 4)))
    (setf from-conversion (fetch-obj (stored-word 5)))
    (setf nonempty? (fetch-obj (stored-word 6)))
    (setf domain (fetch-obj (stored-word 7)))
    (setf range (fetch-obj (stored-word 8)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj functiontype))
  (with-slots (ghost? from-conversion domain range print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when domain
        (let ((*restore-object-parent-slot* 'domain))
          (restore-object* domain)))
      (when range
        (let ((*restore-object-parent-slot* 'range))
          (restore-object* range)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj struct-subtype) &rest initargs)
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     generated-by)
    obj
    (make-instance 'struct-subtype :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv)))))

(defmethod store-object* ((obj struct-subtype))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     generated-by)
    obj
    (reserve-space 8 (push-word (store-obj 'struct-subtype))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?))
                   (push-word (store-obj generated-by)))))

(defmethod update-fetched ((obj struct-subtype))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     generated-by pvs-sxhash-value free-variables
                     free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf print-type (fetch-obj (stored-word 3)))
    (setf ghost? (fetch-obj (stored-word 4)))
    (setf from-conversion (fetch-obj (stored-word 5)))
    (setf nonempty? (fetch-obj (stored-word 6)))
    (setf generated-by (fetch-obj (stored-word 7)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj struct-subtype))
  (with-slots (ghost? from-conversion generated-by print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when generated-by
        (let ((*restore-object-parent-slot* 'generated-by))
          (restore-object* generated-by)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj funtype) &rest initargs)
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     domain range)
    obj
    (make-instance 'funtype :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv))
                   :domain
                   (let* ((get1 (getf initargs 'domain '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :domain '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) domain getfv))
                   :range
                   (let* ((get1 (getf initargs 'range '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :range '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) range getfv)))))

(defmethod store-object* ((obj funtype))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     domain range)
    obj
    (reserve-space 9 (push-word (store-obj 'funtype))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?))
                   (push-word (store-obj domain))
                   (push-word (store-obj range)))))

(defmethod update-fetched ((obj funtype))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     domain range pvs-sxhash-value free-variables
                     free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf print-type (fetch-obj (stored-word 3)))
    (setf ghost? (fetch-obj (stored-word 4)))
    (setf from-conversion (fetch-obj (stored-word 5)))
    (setf nonempty? (fetch-obj (stored-word 6)))
    (setf domain (fetch-obj (stored-word 7)))
    (setf range (fetch-obj (stored-word 8)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj funtype))
  (with-slots (ghost? from-conversion domain range print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when domain
        (let ((*restore-object-parent-slot* 'domain))
          (restore-object* domain)))
      (when range
        (let ((*restore-object-parent-slot* 'range))
          (restore-object* range)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj expr-as-type) &rest initargs)
  (with-slots (expr place parens print-type ghost? from-conversion
                    nonempty? supertype predicate)
    obj
    (make-instance 'expr-as-type :expr
                   (let* ((get1 (getf initargs 'expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expr getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv))
                   :supertype
                   (let* ((get1 (getf initargs 'supertype '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :supertype '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) supertype getfv))
                   :top-type
                   (let* ((get1 (getf initargs 'top-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :top-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :predicate
                   (let* ((get1 (getf initargs 'predicate '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :predicate '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) predicate getfv))
                   :subtype-conjuncts
                   (let* ((get1
                           (getf initargs 'subtype-conjuncts '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :subtype-conjuncts
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv)))))

(defmethod store-object* ((obj expr-as-type))
  (with-slots (expr place parens print-type ghost? from-conversion
                    nonempty? supertype predicate subtype-conjuncts)
    obj
    (reserve-space 11 (push-word (store-obj 'expr-as-type))
                   (push-word (store-obj expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?))
                   (push-word (store-obj supertype))
                   (push-word (store-obj predicate))
                   (push-word (store-obj subtype-conjuncts)))))

(defmethod update-fetched ((obj expr-as-type))
  (with-slots (expr place parens print-type ghost? from-conversion
                    nonempty? supertype predicate subtype-conjuncts
                    pvs-sxhash-value free-variables free-parameters
                    top-type)
    obj
    (setf expr (fetch-obj (stored-word 1)))
    (setf place (fetch-obj (stored-word 2)))
    (setf parens (fetch-obj (stored-word 3)))
    (setf print-type (fetch-obj (stored-word 4)))
    (setf ghost? (fetch-obj (stored-word 5)))
    (setf from-conversion (fetch-obj (stored-word 6)))
    (setf nonempty? (fetch-obj (stored-word 7)))
    (setf supertype (fetch-obj (stored-word 8)))
    (setf predicate (fetch-obj (stored-word 9)))
    (setf subtype-conjuncts (fetch-obj (stored-word 10)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)
    (setf top-type nil)))

(defmethod restore-object* ((obj expr-as-type))
  (with-slots (expr ghost? from-conversion supertype predicate
                    subtype-conjuncts print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when expr
        (let ((*restore-object-parent-slot* 'expr))
          (restore-object* expr)))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when supertype
        (let ((*restore-object-parent-slot* 'supertype))
          (restore-object* supertype)))
      (when predicate
        (let ((*restore-object-parent-slot* 'predicate))
          (restore-object* predicate)))
      (when subtype-conjuncts
        (let ((*restore-object-parent-slot* 'subtype-conjuncts))
          (restore-object* subtype-conjuncts)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj simple-expr-as-type) &rest initargs)
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     expr)
    obj
    (make-instance 'simple-expr-as-type :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv))
                   :expr
                   (let* ((get1 (getf initargs 'expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expr getfv)))))

(defmethod store-object* ((obj simple-expr-as-type))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     expr)
    obj
    (reserve-space 8 (push-word (store-obj 'simple-expr-as-type))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?))
                   (push-word (store-obj expr)))))

(defmethod update-fetched ((obj simple-expr-as-type))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     expr pvs-sxhash-value free-variables
                     free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf print-type (fetch-obj (stored-word 3)))
    (setf ghost? (fetch-obj (stored-word 4)))
    (setf from-conversion (fetch-obj (stored-word 5)))
    (setf nonempty? (fetch-obj (stored-word 6)))
    (setf expr (fetch-obj (stored-word 7)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj simple-expr-as-type))
  (with-slots (ghost? from-conversion expr print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when expr
        (let ((*restore-object-parent-slot* 'expr))
          (restore-object* expr)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj nsetsubtype) &rest initargs)
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     supertype predicate formals formula)
    obj
    (make-instance 'nsetsubtype :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv))
                   :supertype
                   (let* ((get1 (getf initargs 'supertype '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :supertype '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) supertype getfv))
                   :top-type
                   (let* ((get1 (getf initargs 'top-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :top-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :predicate
                   (let* ((get1 (getf initargs 'predicate '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :predicate '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) predicate getfv))
                   :subtype-conjuncts
                   (let* ((get1
                           (getf initargs 'subtype-conjuncts '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :subtype-conjuncts
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :formula
                   (let* ((get1 (getf initargs 'formula '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formula '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formula getfv)))))

(defmethod store-object* ((obj nsetsubtype))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     supertype predicate subtype-conjuncts formals
                     formula)
    obj
    (reserve-space 12 (push-word (store-obj 'nsetsubtype))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?))
                   (push-word (store-obj supertype))
                   (push-word (store-obj predicate))
                   (push-word (store-obj subtype-conjuncts))
                   (push-word (store-obj formals))
                   (push-word (store-obj formula)))))

(defmethod update-fetched ((obj nsetsubtype))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     supertype predicate subtype-conjuncts formals
                     formula pvs-sxhash-value free-variables
                     free-parameters top-type)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf print-type (fetch-obj (stored-word 3)))
    (setf ghost? (fetch-obj (stored-word 4)))
    (setf from-conversion (fetch-obj (stored-word 5)))
    (setf nonempty? (fetch-obj (stored-word 6)))
    (setf supertype (fetch-obj (stored-word 7)))
    (setf predicate (fetch-obj (stored-word 8)))
    (setf subtype-conjuncts (fetch-obj (stored-word 9)))
    (setf formals (fetch-obj (stored-word 10)))
    (setf formula (fetch-obj (stored-word 11)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)
    (setf top-type nil)))

(defmethod restore-object* ((obj nsetsubtype))
  (with-slots (ghost? from-conversion supertype predicate
                      subtype-conjuncts formals formula print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when supertype
        (let ((*restore-object-parent-slot* 'supertype))
          (restore-object* supertype)))
      (when predicate
        (let ((*restore-object-parent-slot* 'predicate))
          (restore-object* predicate)))
      (when subtype-conjuncts
        (let ((*restore-object-parent-slot* 'subtype-conjuncts))
          (restore-object* subtype-conjuncts)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when formula
        (let ((*restore-object-parent-slot* 'formula))
          (restore-object* formula)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj setsubtype) &rest initargs)
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     supertype predicate formals formula)
    obj
    (make-instance 'setsubtype :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv))
                   :supertype
                   (let* ((get1 (getf initargs 'supertype '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :supertype '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) supertype getfv))
                   :top-type
                   (let* ((get1 (getf initargs 'top-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :top-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :predicate
                   (let* ((get1 (getf initargs 'predicate '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :predicate '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) predicate getfv))
                   :subtype-conjuncts
                   (let* ((get1
                           (getf initargs 'subtype-conjuncts '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :subtype-conjuncts
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :formula
                   (let* ((get1 (getf initargs 'formula '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formula '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formula getfv)))))

(defmethod store-object* ((obj setsubtype))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     supertype predicate subtype-conjuncts formals
                     formula)
    obj
    (reserve-space 12 (push-word (store-obj 'setsubtype))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?))
                   (push-word (store-obj supertype))
                   (push-word (store-obj predicate))
                   (push-word (store-obj subtype-conjuncts))
                   (push-word (store-obj formals))
                   (push-word (store-obj formula)))))

(defmethod update-fetched ((obj setsubtype))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     supertype predicate subtype-conjuncts formals
                     formula pvs-sxhash-value free-variables
                     free-parameters top-type)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf print-type (fetch-obj (stored-word 3)))
    (setf ghost? (fetch-obj (stored-word 4)))
    (setf from-conversion (fetch-obj (stored-word 5)))
    (setf nonempty? (fetch-obj (stored-word 6)))
    (setf supertype (fetch-obj (stored-word 7)))
    (setf predicate (fetch-obj (stored-word 8)))
    (setf subtype-conjuncts (fetch-obj (stored-word 9)))
    (setf formals (fetch-obj (stored-word 10)))
    (setf formula (fetch-obj (stored-word 11)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)
    (setf top-type nil)))

(defmethod restore-object* ((obj setsubtype))
  (with-slots (ghost? from-conversion supertype predicate
                      subtype-conjuncts formals formula print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when supertype
        (let ((*restore-object-parent-slot* 'supertype))
          (restore-object* supertype)))
      (when predicate
        (let ((*restore-object-parent-slot* 'predicate))
          (restore-object* predicate)))
      (when subtype-conjuncts
        (let ((*restore-object-parent-slot* 'subtype-conjuncts))
          (restore-object* subtype-conjuncts)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when formula
        (let ((*restore-object-parent-slot* 'formula))
          (restore-object* formula)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj datatype-subtype) &rest initargs)
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     supertype predicate declared-type)
    obj
    (make-instance 'datatype-subtype :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv))
                   :supertype
                   (let* ((get1 (getf initargs 'supertype '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :supertype '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) supertype getfv))
                   :top-type
                   (let* ((get1 (getf initargs 'top-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :top-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :predicate
                   (let* ((get1 (getf initargs 'predicate '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :predicate '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) predicate getfv))
                   :subtype-conjuncts
                   (let* ((get1
                           (getf initargs 'subtype-conjuncts '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :subtype-conjuncts
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv)))))

(defmethod store-object* ((obj datatype-subtype))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     supertype predicate subtype-conjuncts
                     declared-type)
    obj
    (reserve-space 11 (push-word (store-obj 'datatype-subtype))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?))
                   (push-word (store-obj supertype))
                   (push-word (store-obj predicate))
                   (push-word (store-obj subtype-conjuncts))
                   (push-word (store-obj declared-type)))))

(defmethod update-fetched ((obj datatype-subtype))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     supertype predicate subtype-conjuncts
                     declared-type pvs-sxhash-value free-variables
                     free-parameters top-type)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf print-type (fetch-obj (stored-word 3)))
    (setf ghost? (fetch-obj (stored-word 4)))
    (setf from-conversion (fetch-obj (stored-word 5)))
    (setf nonempty? (fetch-obj (stored-word 6)))
    (setf supertype (fetch-obj (stored-word 7)))
    (setf predicate (fetch-obj (stored-word 8)))
    (setf subtype-conjuncts (fetch-obj (stored-word 9)))
    (setf declared-type (fetch-obj (stored-word 10)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)
    (setf top-type nil)))

(defmethod restore-object* ((obj datatype-subtype))
  (with-slots (ghost? from-conversion supertype predicate
                      subtype-conjuncts declared-type print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when supertype
        (let ((*restore-object-parent-slot* 'supertype))
          (restore-object* supertype)))
      (when predicate
        (let ((*restore-object-parent-slot* 'predicate))
          (restore-object* predicate)))
      (when subtype-conjuncts
        (let ((*restore-object-parent-slot* 'subtype-conjuncts))
          (restore-object* subtype-conjuncts)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj subtype) &rest initargs)
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     supertype predicate)
    obj
    (make-instance 'subtype :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv))
                   :supertype
                   (let* ((get1 (getf initargs 'supertype '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :supertype '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) supertype getfv))
                   :top-type
                   (let* ((get1 (getf initargs 'top-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :top-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :predicate
                   (let* ((get1 (getf initargs 'predicate '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :predicate '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) predicate getfv))
                   :subtype-conjuncts
                   (let* ((get1
                           (getf initargs 'subtype-conjuncts '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :subtype-conjuncts
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv)))))

(defmethod store-object* ((obj subtype))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     supertype predicate subtype-conjuncts)
    obj
    (reserve-space 10 (push-word (store-obj 'subtype))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?))
                   (push-word (store-obj supertype))
                   (push-word (store-obj predicate))
                   (push-word (store-obj subtype-conjuncts)))))

(defmethod update-fetched ((obj subtype))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     supertype predicate subtype-conjuncts
                     pvs-sxhash-value free-variables free-parameters
                     top-type)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf print-type (fetch-obj (stored-word 3)))
    (setf ghost? (fetch-obj (stored-word 4)))
    (setf from-conversion (fetch-obj (stored-word 5)))
    (setf nonempty? (fetch-obj (stored-word 6)))
    (setf supertype (fetch-obj (stored-word 7)))
    (setf predicate (fetch-obj (stored-word 8)))
    (setf subtype-conjuncts (fetch-obj (stored-word 9)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)
    (setf top-type nil)))

(defmethod restore-object* ((obj subtype))
  (with-slots (ghost? from-conversion supertype predicate
                      subtype-conjuncts print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when supertype
        (let ((*restore-object-parent-slot* 'supertype))
          (restore-object* supertype)))
      (when predicate
        (let ((*restore-object-parent-slot* 'predicate))
          (restore-object* predicate)))
      (when subtype-conjuncts
        (let ((*restore-object-parent-slot* 'subtype-conjuncts))
          (restore-object* subtype-conjuncts)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj out-type-variable) &rest initargs)
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place parens
                      print-type ghost? from-conversion nonempty?
                      index)
    obj
    (make-instance 'out-type-variable :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv))
                   :index
                   (let* ((get1 (getf initargs 'index '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :index '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) index getfv)))))

(defmethod store-object* ((obj out-type-variable))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place parens
                      print-type ghost? from-conversion nonempty?
                      index)
    obj
    (reserve-space 18 (push-word (store-obj 'out-type-variable))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?))
                   (push-word (store-obj index)))))

(defmethod update-fetched ((obj out-type-variable))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place parens
                      print-type ghost? from-conversion nonempty? index
                      pvs-sxhash-value free-variables free-parameters)
    obj
    (setf mod-id (fetch-obj (stored-word 1)))
    (setf library (fetch-obj (stored-word 2)))
    (setf actuals (fetch-obj (stored-word 3)))
    (setf dactuals (fetch-obj (stored-word 4)))
    (setf acts-there? (fetch-obj (stored-word 5)))
    (setf dacts-there? (fetch-obj (stored-word 6)))
    (setf id (fetch-obj (stored-word 7)))
    (setf mappings (fetch-obj (stored-word 8)))
    (setf target (fetch-obj (stored-word 9)))
    (setf resolutions (fetch-obj (stored-word 10)))
    (setf place (fetch-obj (stored-word 11)))
    (setf parens (fetch-obj (stored-word 12)))
    (setf print-type (fetch-obj (stored-word 13)))
    (setf ghost? (fetch-obj (stored-word 14)))
    (setf from-conversion (fetch-obj (stored-word 15)))
    (setf nonempty? (fetch-obj (stored-word 16)))
    (setf index (fetch-obj (stored-word 17)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj out-type-variable))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions ghost? from-conversion
                       print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj cotup-type-variable) &rest initargs)
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place parens
                      print-type ghost? from-conversion nonempty?
                      out-type-var)
    obj
    (make-instance 'cotup-type-variable :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv))
                   :out-type-var
                   (let* ((get1 (getf initargs 'out-type-var '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :out-type-var '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) out-type-var getfv)))))

(defmethod store-object* ((obj cotup-type-variable))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place parens
                      print-type ghost? from-conversion nonempty?
                      out-type-var)
    obj
    (reserve-space 18 (push-word (store-obj 'cotup-type-variable))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?))
                   (push-word (store-obj out-type-var)))))

(defmethod update-fetched ((obj cotup-type-variable))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place parens
                      print-type ghost? from-conversion nonempty?
                      out-type-var pvs-sxhash-value free-variables
                      free-parameters)
    obj
    (setf mod-id (fetch-obj (stored-word 1)))
    (setf library (fetch-obj (stored-word 2)))
    (setf actuals (fetch-obj (stored-word 3)))
    (setf dactuals (fetch-obj (stored-word 4)))
    (setf acts-there? (fetch-obj (stored-word 5)))
    (setf dacts-there? (fetch-obj (stored-word 6)))
    (setf id (fetch-obj (stored-word 7)))
    (setf mappings (fetch-obj (stored-word 8)))
    (setf target (fetch-obj (stored-word 9)))
    (setf resolutions (fetch-obj (stored-word 10)))
    (setf place (fetch-obj (stored-word 11)))
    (setf parens (fetch-obj (stored-word 12)))
    (setf print-type (fetch-obj (stored-word 13)))
    (setf ghost? (fetch-obj (stored-word 14)))
    (setf from-conversion (fetch-obj (stored-word 15)))
    (setf nonempty? (fetch-obj (stored-word 16)))
    (setf out-type-var (fetch-obj (stored-word 17)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj cotup-type-variable))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions ghost? from-conversion
                       out-type-var print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when out-type-var
        (let ((*restore-object-parent-slot* 'out-type-var))
          (restore-object* out-type-var)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj field-type-variable) &rest initargs)
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place parens
                      print-type ghost? from-conversion nonempty?
                      field-id)
    obj
    (make-instance 'field-type-variable :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv))
                   :field-id
                   (let* ((get1 (getf initargs 'field-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :field-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) field-id getfv)))))

(defmethod store-object* ((obj field-type-variable))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place parens
                      print-type ghost? from-conversion nonempty?
                      field-id)
    obj
    (reserve-space 18 (push-word (store-obj 'field-type-variable))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?))
                   (push-word (store-obj field-id)))))

(defmethod update-fetched ((obj field-type-variable))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place parens
                      print-type ghost? from-conversion nonempty?
                      field-id pvs-sxhash-value free-variables
                      free-parameters)
    obj
    (setf mod-id (fetch-obj (stored-word 1)))
    (setf library (fetch-obj (stored-word 2)))
    (setf actuals (fetch-obj (stored-word 3)))
    (setf dactuals (fetch-obj (stored-word 4)))
    (setf acts-there? (fetch-obj (stored-word 5)))
    (setf dacts-there? (fetch-obj (stored-word 6)))
    (setf id (fetch-obj (stored-word 7)))
    (setf mappings (fetch-obj (stored-word 8)))
    (setf target (fetch-obj (stored-word 9)))
    (setf resolutions (fetch-obj (stored-word 10)))
    (setf place (fetch-obj (stored-word 11)))
    (setf parens (fetch-obj (stored-word 12)))
    (setf print-type (fetch-obj (stored-word 13)))
    (setf ghost? (fetch-obj (stored-word 14)))
    (setf from-conversion (fetch-obj (stored-word 15)))
    (setf nonempty? (fetch-obj (stored-word 16)))
    (setf field-id (fetch-obj (stored-word 17)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj field-type-variable))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions ghost? from-conversion
                       print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj rec-type-variable) &rest initargs)
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place parens
                      print-type ghost? from-conversion nonempty?
                      field-type-var)
    obj
    (make-instance 'rec-type-variable :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv))
                   :field-type-var
                   (let* ((get1
                           (getf initargs 'field-type-var '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :field-type-var '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) field-type-var getfv)))))

(defmethod store-object* ((obj rec-type-variable))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place parens
                      print-type ghost? from-conversion nonempty?
                      field-type-var)
    obj
    (reserve-space 18 (push-word (store-obj 'rec-type-variable))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?))
                   (push-word (store-obj field-type-var)))))

(defmethod update-fetched ((obj rec-type-variable))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place parens
                      print-type ghost? from-conversion nonempty?
                      field-type-var pvs-sxhash-value free-variables
                      free-parameters)
    obj
    (setf mod-id (fetch-obj (stored-word 1)))
    (setf library (fetch-obj (stored-word 2)))
    (setf actuals (fetch-obj (stored-word 3)))
    (setf dactuals (fetch-obj (stored-word 4)))
    (setf acts-there? (fetch-obj (stored-word 5)))
    (setf dacts-there? (fetch-obj (stored-word 6)))
    (setf id (fetch-obj (stored-word 7)))
    (setf mappings (fetch-obj (stored-word 8)))
    (setf target (fetch-obj (stored-word 9)))
    (setf resolutions (fetch-obj (stored-word 10)))
    (setf place (fetch-obj (stored-word 11)))
    (setf parens (fetch-obj (stored-word 12)))
    (setf print-type (fetch-obj (stored-word 13)))
    (setf ghost? (fetch-obj (stored-word 14)))
    (setf from-conversion (fetch-obj (stored-word 15)))
    (setf nonempty? (fetch-obj (stored-word 16)))
    (setf field-type-var (fetch-obj (stored-word 17)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj rec-type-variable))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions ghost? from-conversion
                       field-type-var print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when field-type-var
        (let ((*restore-object-parent-slot* 'field-type-var))
          (restore-object* field-type-var)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj proj-type-variable) &rest initargs)
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place parens
                      print-type ghost? from-conversion nonempty?
                      index)
    obj
    (make-instance 'proj-type-variable :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv))
                   :index
                   (let* ((get1 (getf initargs 'index '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :index '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) index getfv)))))

(defmethod store-object* ((obj proj-type-variable))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place parens
                      print-type ghost? from-conversion nonempty?
                      index)
    obj
    (reserve-space 18 (push-word (store-obj 'proj-type-variable))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?))
                   (push-word (store-obj index)))))

(defmethod update-fetched ((obj proj-type-variable))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place parens
                      print-type ghost? from-conversion nonempty? index
                      pvs-sxhash-value free-variables free-parameters)
    obj
    (setf mod-id (fetch-obj (stored-word 1)))
    (setf library (fetch-obj (stored-word 2)))
    (setf actuals (fetch-obj (stored-word 3)))
    (setf dactuals (fetch-obj (stored-word 4)))
    (setf acts-there? (fetch-obj (stored-word 5)))
    (setf dacts-there? (fetch-obj (stored-word 6)))
    (setf id (fetch-obj (stored-word 7)))
    (setf mappings (fetch-obj (stored-word 8)))
    (setf target (fetch-obj (stored-word 9)))
    (setf resolutions (fetch-obj (stored-word 10)))
    (setf place (fetch-obj (stored-word 11)))
    (setf parens (fetch-obj (stored-word 12)))
    (setf print-type (fetch-obj (stored-word 13)))
    (setf ghost? (fetch-obj (stored-word 14)))
    (setf from-conversion (fetch-obj (stored-word 15)))
    (setf nonempty? (fetch-obj (stored-word 16)))
    (setf index (fetch-obj (stored-word 17)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj proj-type-variable))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions ghost? from-conversion
                       print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj tup-type-variable) &rest initargs)
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place parens
                      print-type ghost? from-conversion nonempty?
                      proj-type-var)
    obj
    (make-instance 'tup-type-variable :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv))
                   :proj-type-var
                   (let* ((get1
                           (getf initargs 'proj-type-var '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :proj-type-var '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) proj-type-var getfv)))))

(defmethod store-object* ((obj tup-type-variable))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place parens
                      print-type ghost? from-conversion nonempty?
                      proj-type-var)
    obj
    (reserve-space 18 (push-word (store-obj 'tup-type-variable))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?))
                   (push-word (store-obj proj-type-var)))))

(defmethod update-fetched ((obj tup-type-variable))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place parens
                      print-type ghost? from-conversion nonempty?
                      proj-type-var pvs-sxhash-value free-variables
                      free-parameters)
    obj
    (setf mod-id (fetch-obj (stored-word 1)))
    (setf library (fetch-obj (stored-word 2)))
    (setf actuals (fetch-obj (stored-word 3)))
    (setf dactuals (fetch-obj (stored-word 4)))
    (setf acts-there? (fetch-obj (stored-word 5)))
    (setf dacts-there? (fetch-obj (stored-word 6)))
    (setf id (fetch-obj (stored-word 7)))
    (setf mappings (fetch-obj (stored-word 8)))
    (setf target (fetch-obj (stored-word 9)))
    (setf resolutions (fetch-obj (stored-word 10)))
    (setf place (fetch-obj (stored-word 11)))
    (setf parens (fetch-obj (stored-word 12)))
    (setf print-type (fetch-obj (stored-word 13)))
    (setf ghost? (fetch-obj (stored-word 14)))
    (setf from-conversion (fetch-obj (stored-word 15)))
    (setf nonempty? (fetch-obj (stored-word 16)))
    (setf proj-type-var (fetch-obj (stored-word 17)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj tup-type-variable))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions ghost? from-conversion
                       proj-type-var print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when proj-type-var
        (let ((*restore-object-parent-slot* 'proj-type-var))
          (restore-object* proj-type-var)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj type-var) &rest initargs)
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place parens
                      print-type ghost? from-conversion nonempty?)
    obj
    (make-instance 'type-var :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv)))))

(defmethod store-object* ((obj type-var))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place parens
                      print-type ghost? from-conversion nonempty?)
    obj
    (reserve-space 17 (push-word (store-obj 'type-var))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?)))))

(defmethod update-fetched ((obj type-var))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place parens
                      print-type ghost? from-conversion nonempty?
                      pvs-sxhash-value free-variables free-parameters)
    obj
    (setf mod-id (fetch-obj (stored-word 1)))
    (setf library (fetch-obj (stored-word 2)))
    (setf actuals (fetch-obj (stored-word 3)))
    (setf dactuals (fetch-obj (stored-word 4)))
    (setf acts-there? (fetch-obj (stored-word 5)))
    (setf dacts-there? (fetch-obj (stored-word 6)))
    (setf id (fetch-obj (stored-word 7)))
    (setf mappings (fetch-obj (stored-word 8)))
    (setf target (fetch-obj (stored-word 9)))
    (setf resolutions (fetch-obj (stored-word 10)))
    (setf place (fetch-obj (stored-word 11)))
    (setf parens (fetch-obj (stored-word 12)))
    (setf print-type (fetch-obj (stored-word 13)))
    (setf ghost? (fetch-obj (stored-word 14)))
    (setf from-conversion (fetch-obj (stored-word 15)))
    (setf nonempty? (fetch-obj (stored-word 16)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj type-var))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions ghost? from-conversion
                       print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj type-application) &rest initargs)
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     type parameters)
    obj
    (make-instance 'type-application :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :parameters
                   (let* ((get1 (getf initargs 'parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parameters '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parameters getfv)))))

(defmethod store-object* ((obj type-application))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     type parameters)
    obj
    (reserve-space 9 (push-word (store-obj 'type-application))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?))
                   (push-word (store-obj type))
                   (push-word (store-obj parameters)))))

(defmethod update-fetched ((obj type-application))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     type parameters pvs-sxhash-value free-variables
                     free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf print-type (fetch-obj (stored-word 3)))
    (setf ghost? (fetch-obj (stored-word 4)))
    (setf from-conversion (fetch-obj (stored-word 5)))
    (setf nonempty? (fetch-obj (stored-word 6)))
    (setf type (fetch-obj (stored-word 7)))
    (setf parameters (fetch-obj (stored-word 8)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj type-application))
  (with-slots (ghost? from-conversion type parameters print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when parameters
        (let ((*restore-object-parent-slot* 'parameters))
          (restore-object* parameters)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj adt-type-name) &rest initargs)
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place parens
                      print-type ghost? from-conversion nonempty? adt
                      single-constructor? struct-name)
    obj
    (make-instance 'adt-type-name :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv))
                   :adt
                   (let* ((get1 (getf initargs 'adt '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt getfv))
                   :single-constructor?
                   (let* ((get1
                           (getf initargs 'single-constructor?
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :single-constructor?
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         single-constructor?
                       getfv))
                   :recognizer-names
                   (let* ((get1
                           (getf initargs 'recognizer-names '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :recognizer-names
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :struct-name
                   (let* ((get1 (getf initargs 'struct-name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :struct-name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) struct-name getfv)))))

(defmethod store-object* ((obj adt-type-name))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place parens
                      print-type ghost? from-conversion nonempty? adt
                      single-constructor? struct-name)
    obj
    (reserve-space 20 (push-word (store-obj 'adt-type-name))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?))
                   (push-word (store-obj adt))
                   (push-word (store-obj single-constructor?))
                   (push-word (store-obj struct-name)))))

(defmethod update-fetched ((obj adt-type-name))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place parens
                      print-type ghost? from-conversion nonempty? adt
                      single-constructor? struct-name pvs-sxhash-value
                      free-variables free-parameters recognizer-names)
    obj
    (setf mod-id (fetch-obj (stored-word 1)))
    (setf library (fetch-obj (stored-word 2)))
    (setf actuals (fetch-obj (stored-word 3)))
    (setf dactuals (fetch-obj (stored-word 4)))
    (setf acts-there? (fetch-obj (stored-word 5)))
    (setf dacts-there? (fetch-obj (stored-word 6)))
    (setf id (fetch-obj (stored-word 7)))
    (setf mappings (fetch-obj (stored-word 8)))
    (setf target (fetch-obj (stored-word 9)))
    (setf resolutions (fetch-obj (stored-word 10)))
    (setf place (fetch-obj (stored-word 11)))
    (setf parens (fetch-obj (stored-word 12)))
    (setf print-type (fetch-obj (stored-word 13)))
    (setf ghost? (fetch-obj (stored-word 14)))
    (setf from-conversion (fetch-obj (stored-word 15)))
    (setf nonempty? (fetch-obj (stored-word 16)))
    (setf adt (fetch-obj (stored-word 17)))
    (setf single-constructor? (fetch-obj (stored-word 18)))
    (setf struct-name (fetch-obj (stored-word 19)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)
    (setf recognizer-names nil)))

(defmethod restore-object* ((obj adt-type-name))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions ghost? from-conversion adt
                       single-constructor? struct-name print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when adt
        (let ((*restore-object-parent-slot* 'adt))
          (restore-object* adt)))
      (when single-constructor?
        (let ((*restore-object-parent-slot* 'single-constructor?))
          (restore-object* single-constructor?)))
      (when struct-name
        (let ((*restore-object-parent-slot* 'struct-name))
          (restore-object* struct-name)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj uninterpreted-type-name) &rest initargs)
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place parens
                      print-type ghost? from-conversion nonempty?)
    obj
    (make-instance 'uninterpreted-type-name :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv)))))

(defmethod store-object* ((obj uninterpreted-type-name))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place parens
                      print-type ghost? from-conversion nonempty?)
    obj
    (reserve-space 17 (push-word (store-obj 'uninterpreted-type-name))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?)))))

(defmethod update-fetched ((obj uninterpreted-type-name))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place parens
                      print-type ghost? from-conversion nonempty?
                      pvs-sxhash-value free-variables free-parameters)
    obj
    (setf mod-id (fetch-obj (stored-word 1)))
    (setf library (fetch-obj (stored-word 2)))
    (setf actuals (fetch-obj (stored-word 3)))
    (setf dactuals (fetch-obj (stored-word 4)))
    (setf acts-there? (fetch-obj (stored-word 5)))
    (setf dacts-there? (fetch-obj (stored-word 6)))
    (setf id (fetch-obj (stored-word 7)))
    (setf mappings (fetch-obj (stored-word 8)))
    (setf target (fetch-obj (stored-word 9)))
    (setf resolutions (fetch-obj (stored-word 10)))
    (setf place (fetch-obj (stored-word 11)))
    (setf parens (fetch-obj (stored-word 12)))
    (setf print-type (fetch-obj (stored-word 13)))
    (setf ghost? (fetch-obj (stored-word 14)))
    (setf from-conversion (fetch-obj (stored-word 15)))
    (setf nonempty? (fetch-obj (stored-word 16)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj uninterpreted-type-name))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions ghost? from-conversion
                       print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj type-name) &rest initargs)
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place parens
                      print-type ghost? from-conversion nonempty?)
    obj
    (make-instance 'type-name :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv)))))

(defmethod store-object* ((obj type-name))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place parens
                      print-type ghost? from-conversion nonempty?)
    obj
    (reserve-space 17 (push-word (store-obj 'type-name))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?)))))

(defmethod update-fetched ((obj type-name))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place parens
                      print-type ghost? from-conversion nonempty?
                      pvs-sxhash-value free-variables free-parameters)
    obj
    (setf mod-id (fetch-obj (stored-word 1)))
    (setf library (fetch-obj (stored-word 2)))
    (setf actuals (fetch-obj (stored-word 3)))
    (setf dactuals (fetch-obj (stored-word 4)))
    (setf acts-there? (fetch-obj (stored-word 5)))
    (setf dacts-there? (fetch-obj (stored-word 6)))
    (setf id (fetch-obj (stored-word 7)))
    (setf mappings (fetch-obj (stored-word 8)))
    (setf target (fetch-obj (stored-word 9)))
    (setf resolutions (fetch-obj (stored-word 10)))
    (setf place (fetch-obj (stored-word 11)))
    (setf parens (fetch-obj (stored-word 12)))
    (setf print-type (fetch-obj (stored-word 13)))
    (setf ghost? (fetch-obj (stored-word 14)))
    (setf from-conversion (fetch-obj (stored-word 15)))
    (setf nonempty? (fetch-obj (stored-word 16)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj type-name))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions ghost? from-conversion
                       print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj enumtype) &rest initargs)
  (with-slots (unique-id place id formals formals-sans-usings
                         theory-formal-decls assuming filename
                         context-path status generated-by tcc-comments
                         info warnings conversion-messages
                         all-declarations all-imported-theories
                         all-imported-names theory-mappings importings
                         constructors adt-type-name positive-types
                         adt-theory adt-map-theory adt-reduce-theory
                         generated-file-date semi decl-formals module
                         generated typechecked?)
    obj
    (make-instance 'enumtype :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :formals-sans-usings
                   (let* ((get1
                           (getf initargs 'formals-sans-usings
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :formals-sans-usings
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         formals-sans-usings
                       getfv))
                   :theory-formal-decls
                   (let* ((get1
                           (getf initargs 'theory-formal-decls
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :theory-formal-decls
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         theory-formal-decls
                       getfv))
                   :assuming
                   (let* ((get1 (getf initargs 'assuming '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :assuming '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) assuming getfv))
                   :filename
                   (let* ((get1 (getf initargs 'filename '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :filename '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) filename getfv))
                   :context-path
                   (let* ((get1 (getf initargs 'context-path '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :context-path '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) context-path getfv))
                   :status
                   (let* ((get1 (getf initargs 'status '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :status '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) status getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :tcc-comments
                   (let* ((get1 (getf initargs 'tcc-comments '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-comments '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-comments getfv))
                   :info
                   (let* ((get1 (getf initargs 'info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) info getfv))
                   :warnings
                   (let* ((get1 (getf initargs 'warnings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :warnings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) warnings getfv))
                   :conversion-messages
                   (let* ((get1
                           (getf initargs 'conversion-messages
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :conversion-messages
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         conversion-messages
                       getfv))
                   :all-declarations
                   (let* ((get1
                           (getf initargs 'all-declarations '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-declarations
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) all-declarations getfv))
                   :all-imported-theories
                   (let* ((get1
                           (getf initargs 'all-imported-theories
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-imported-theories
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         all-imported-theories
                       getfv))
                   :all-imported-names
                   (let* ((get1
                           (getf initargs 'all-imported-names
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-imported-names
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) all-imported-names getfv))
                   :theory-mappings
                   (let* ((get1
                           (getf initargs 'theory-mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :theory-mappings
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) theory-mappings getfv))
                   :importings
                   (let* ((get1 (getf initargs 'importings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :importings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) importings getfv))
                   :constructors
                   (let* ((get1 (getf initargs 'constructors '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :constructors '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) constructors getfv))
                   :adt-type-name
                   (let* ((get1
                           (getf initargs 'adt-type-name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-type-name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-type-name getfv))
                   :positive-types
                   (let* ((get1
                           (getf initargs 'positive-types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :positive-types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) positive-types getfv))
                   :adt-theory
                   (let* ((get1 (getf initargs 'adt-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-theory '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-theory getfv))
                   :adt-map-theory
                   (let* ((get1
                           (getf initargs 'adt-map-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-map-theory '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-map-theory getfv))
                   :adt-reduce-theory
                   (let* ((get1
                           (getf initargs 'adt-reduce-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :adt-reduce-theory
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-reduce-theory getfv))
                   :generated-file-date
                   (let* ((get1
                           (getf initargs 'generated-file-date
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :generated-file-date
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         generated-file-date
                       getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv)))))

(defmethod store-object* ((obj enumtype))
  (with-slots (unique-id place id formals theory-formal-decls assuming
                         filename context-path status generated-by
                         tcc-comments info warnings conversion-messages
                         theory-mappings importings constructors
                         adt-type-name positive-types adt-theory
                         adt-map-theory adt-reduce-theory
                         generated-file-date semi decl-formals module
                         generated typechecked?)
    obj
    (reserve-space 29 (push-word (store-obj 'enumtype))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj place))
                   (push-word (store-obj id))
                   (push-word (store-obj formals))
                   (push-word (store-obj theory-formal-decls))
                   (push-word (store-obj assuming))
                   (push-word (store-obj filename))
                   (push-word (store-obj context-path))
                   (push-word (store-obj status))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj tcc-comments))
                   (push-word (store-obj info))
                   (push-word (store-obj warnings))
                   (push-word (store-obj conversion-messages))
                   (push-word (store-obj theory-mappings))
                   (push-word (store-obj importings))
                   (push-word (store-obj constructors))
                   (push-word (store-obj adt-type-name))
                   (push-word (store-obj positive-types))
                   (push-word (store-obj adt-theory))
                   (push-word (store-obj adt-map-theory))
                   (push-word (store-obj adt-reduce-theory))
                   (push-word (store-obj generated-file-date))
                   (push-word (store-obj semi))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj module))
                   (push-word (store-obj generated))
                   (push-word (store-obj typechecked?)))))

(defmethod update-fetched ((obj enumtype))
  (with-slots (unique-id place id formals theory-formal-decls assuming
                         filename context-path status generated-by
                         tcc-comments info warnings conversion-messages
                         theory-mappings importings constructors
                         adt-type-name positive-types adt-theory
                         adt-map-theory adt-reduce-theory
                         generated-file-date semi decl-formals module
                         generated typechecked? pvs-sxhash-value
                         formals-sans-usings all-declarations
                         all-imported-theories all-imported-names)
    obj
    (setf unique-id (fetch-obj (stored-word 1)))
    (setf place (fetch-obj (stored-word 2)))
    (setf id (fetch-obj (stored-word 3)))
    (setf formals (fetch-obj (stored-word 4)))
    (setf theory-formal-decls (fetch-obj (stored-word 5)))
    (setf assuming (fetch-obj (stored-word 6)))
    (setf filename (fetch-obj (stored-word 7)))
    (setf context-path (fetch-obj (stored-word 8)))
    (setf status (fetch-obj (stored-word 9)))
    (setf generated-by (fetch-obj (stored-word 10)))
    (setf tcc-comments (fetch-obj (stored-word 11)))
    (setf info (fetch-obj (stored-word 12)))
    (setf warnings (fetch-obj (stored-word 13)))
    (setf conversion-messages (fetch-obj (stored-word 14)))
    (setf theory-mappings (fetch-obj (stored-word 15)))
    (setf importings (fetch-obj (stored-word 16)))
    (setf constructors (fetch-obj (stored-word 17)))
    (setf adt-type-name (fetch-obj (stored-word 18)))
    (setf positive-types (fetch-obj (stored-word 19)))
    (setf adt-theory (fetch-obj (stored-word 20)))
    (setf adt-map-theory (fetch-obj (stored-word 21)))
    (setf adt-reduce-theory (fetch-obj (stored-word 22)))
    (setf generated-file-date (fetch-obj (stored-word 23)))
    (setf semi (fetch-obj (stored-word 24)))
    (setf decl-formals (fetch-obj (stored-word 25)))
    (setf module (fetch-obj (stored-word 26)))
    (setf generated (fetch-obj (stored-word 27)))
    (setf typechecked? (fetch-obj (stored-word 28)))
    (setf pvs-sxhash-value nil)
    (setf formals-sans-usings nil)
    (setf all-declarations nil)
    (setf all-imported-theories 'unbound)
    (setf all-imported-names 'unbound)))

(defmethod restore-object* ((obj enumtype))
  (with-slots (unique-id formals theory-formal-decls assuming
                         theory-mappings importings constructors
                         decl-formals module)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when theory-formal-decls
        (let ((*restore-object-parent-slot* 'theory-formal-decls))
          (restore-object* theory-formal-decls)))
      (when assuming
        (let ((*restore-object-parent-slot* 'assuming))
          (restore-object* assuming)))
      (when theory-mappings
        (let ((*restore-object-parent-slot* 'theory-mappings))
          (restore-object* theory-mappings)))
      (when importings
        (let ((*restore-object-parent-slot* 'importings))
          (restore-object* importings)))
      (when constructors
        (let ((*restore-object-parent-slot* 'constructors))
          (restore-object* constructors)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when module
        (let ((*restore-object-parent-slot* 'module))
          (restore-object* module)))
      obj)))

(defmethod copy ((obj type-expr) &rest initargs)
  (with-slots (place parens print-type ghost? from-conversion
                     nonempty?)
    obj
    (make-instance 'type-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv)))))

(defmethod store-object* ((obj type-expr))
  (with-slots (place parens print-type ghost? from-conversion
                     nonempty?)
    obj
    (reserve-space 7 (push-word (store-obj 'type-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?)))))

(defmethod update-fetched ((obj type-expr))
  (with-slots (place parens print-type ghost? from-conversion nonempty?
                     pvs-sxhash-value free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf print-type (fetch-obj (stored-word 3)))
    (setf ghost? (fetch-obj (stored-word 4)))
    (setf from-conversion (fetch-obj (stored-word 5)))
    (setf nonempty? (fetch-obj (stored-word 6)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj type-expr))
  (with-slots (ghost? from-conversion print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj macro-fnum-rewrite) &rest initargs)
  (with-slots (place fnum)
    obj
    (make-instance 'macro-fnum-rewrite :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :fnum
                   (let* ((get1 (getf initargs 'fnum '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :fnum '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) fnum getfv)))))

(defmethod store-object* ((obj macro-fnum-rewrite))
  (with-slots (place fnum)
    obj
    (reserve-space 3 (push-word (store-obj 'macro-fnum-rewrite))
                   (push-word (store-obj place))
                   (push-word (store-obj fnum)))))

(defmethod update-fetched ((obj macro-fnum-rewrite))
  (with-slots (place fnum pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf fnum (fetch-obj (stored-word 2)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj macro-fnum-rewrite))
  (with-slots (fnum)
    obj
    (let ((*restore-object-parent* obj))
      (when fnum
        (let ((*restore-object-parent-slot* 'fnum))
          (restore-object* fnum)))
      obj)))

(defmethod copy ((obj eager-fnum-rewrite) &rest initargs)
  (with-slots (place fnum)
    obj
    (make-instance 'eager-fnum-rewrite :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :fnum
                   (let* ((get1 (getf initargs 'fnum '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :fnum '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) fnum getfv)))))

(defmethod store-object* ((obj eager-fnum-rewrite))
  (with-slots (place fnum)
    obj
    (reserve-space 3 (push-word (store-obj 'eager-fnum-rewrite))
                   (push-word (store-obj place))
                   (push-word (store-obj fnum)))))

(defmethod update-fetched ((obj eager-fnum-rewrite))
  (with-slots (place fnum pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf fnum (fetch-obj (stored-word 2)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj eager-fnum-rewrite))
  (with-slots (fnum)
    obj
    (let ((*restore-object-parent* obj))
      (when fnum
        (let ((*restore-object-parent-slot* 'fnum))
          (restore-object* fnum)))
      obj)))

(defmethod copy ((obj lazy-fnum-rewrite) &rest initargs)
  (with-slots (place fnum)
    obj
    (make-instance 'lazy-fnum-rewrite :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :fnum
                   (let* ((get1 (getf initargs 'fnum '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :fnum '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) fnum getfv)))))

(defmethod store-object* ((obj lazy-fnum-rewrite))
  (with-slots (place fnum)
    obj
    (reserve-space 3 (push-word (store-obj 'lazy-fnum-rewrite))
                   (push-word (store-obj place))
                   (push-word (store-obj fnum)))))

(defmethod update-fetched ((obj lazy-fnum-rewrite))
  (with-slots (place fnum pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf fnum (fetch-obj (stored-word 2)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj lazy-fnum-rewrite))
  (with-slots (fnum)
    obj
    (let ((*restore-object-parent* obj))
      (when fnum
        (let ((*restore-object-parent-slot* 'fnum))
          (restore-object* fnum)))
      obj)))

(defmethod copy ((obj fnum-rewrite) &rest initargs)
  (with-slots (place fnum)
    obj
    (make-instance 'fnum-rewrite :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :fnum
                   (let* ((get1 (getf initargs 'fnum '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :fnum '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) fnum getfv)))))

(defmethod store-object* ((obj fnum-rewrite))
  (with-slots (place fnum)
    obj
    (reserve-space 3 (push-word (store-obj 'fnum-rewrite))
                   (push-word (store-obj place))
                   (push-word (store-obj fnum)))))

(defmethod update-fetched ((obj fnum-rewrite))
  (with-slots (place fnum pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf fnum (fetch-obj (stored-word 2)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj fnum-rewrite))
  (with-slots (fnum)
    obj
    (let ((*restore-object-parent* obj))
      (when fnum
        (let ((*restore-object-parent-slot* 'fnum))
          (restore-object* fnum)))
      obj)))

(defmethod copy ((obj macro-formula-rewrite-name) &rest initargs)
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place spelling)
    obj
    (make-instance 'macro-formula-rewrite-name :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :spelling
                   (let* ((get1 (getf initargs 'spelling '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :spelling '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) spelling getfv)))))

(defmethod store-object* ((obj macro-formula-rewrite-name))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place spelling)
    obj
    (reserve-space 13
                   (push-word (store-obj 'macro-formula-rewrite-name))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj place))
                   (push-word (store-obj spelling)))))

(defmethod update-fetched ((obj macro-formula-rewrite-name))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place spelling
                      pvs-sxhash-value)
    obj
    (setf mod-id (fetch-obj (stored-word 1)))
    (setf library (fetch-obj (stored-word 2)))
    (setf actuals (fetch-obj (stored-word 3)))
    (setf dactuals (fetch-obj (stored-word 4)))
    (setf acts-there? (fetch-obj (stored-word 5)))
    (setf dacts-there? (fetch-obj (stored-word 6)))
    (setf id (fetch-obj (stored-word 7)))
    (setf mappings (fetch-obj (stored-word 8)))
    (setf target (fetch-obj (stored-word 9)))
    (setf resolutions (fetch-obj (stored-word 10)))
    (setf place (fetch-obj (stored-word 11)))
    (setf spelling (fetch-obj (stored-word 12)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj macro-formula-rewrite-name))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      obj)))

(defmethod copy ((obj macro-constant-rewrite-name) &rest initargs)
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place
                      declared-type type)
    obj
    (make-instance 'macro-constant-rewrite-name :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv)))))

(defmethod store-object* ((obj macro-constant-rewrite-name))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place
                      declared-type type)
    obj
    (reserve-space 14
                   (push-word (store-obj 'macro-constant-rewrite-name))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj place))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type)))))

(defmethod update-fetched ((obj macro-constant-rewrite-name))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place
                      declared-type type pvs-sxhash-value)
    obj
    (setf mod-id (fetch-obj (stored-word 1)))
    (setf library (fetch-obj (stored-word 2)))
    (setf actuals (fetch-obj (stored-word 3)))
    (setf dactuals (fetch-obj (stored-word 4)))
    (setf acts-there? (fetch-obj (stored-word 5)))
    (setf dacts-there? (fetch-obj (stored-word 6)))
    (setf id (fetch-obj (stored-word 7)))
    (setf mappings (fetch-obj (stored-word 8)))
    (setf target (fetch-obj (stored-word 9)))
    (setf resolutions (fetch-obj (stored-word 10)))
    (setf place (fetch-obj (stored-word 11)))
    (setf declared-type (fetch-obj (stored-word 12)))
    (setf type (fetch-obj (stored-word 13)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj macro-constant-rewrite-name))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions declared-type type)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      obj)))

(defmethod copy ((obj eager-formula-rewrite-name) &rest initargs)
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place spelling)
    obj
    (make-instance 'eager-formula-rewrite-name :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :spelling
                   (let* ((get1 (getf initargs 'spelling '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :spelling '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) spelling getfv)))))

(defmethod store-object* ((obj eager-formula-rewrite-name))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place spelling)
    obj
    (reserve-space 13
                   (push-word (store-obj 'eager-formula-rewrite-name))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj place))
                   (push-word (store-obj spelling)))))

(defmethod update-fetched ((obj eager-formula-rewrite-name))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place spelling
                      pvs-sxhash-value)
    obj
    (setf mod-id (fetch-obj (stored-word 1)))
    (setf library (fetch-obj (stored-word 2)))
    (setf actuals (fetch-obj (stored-word 3)))
    (setf dactuals (fetch-obj (stored-word 4)))
    (setf acts-there? (fetch-obj (stored-word 5)))
    (setf dacts-there? (fetch-obj (stored-word 6)))
    (setf id (fetch-obj (stored-word 7)))
    (setf mappings (fetch-obj (stored-word 8)))
    (setf target (fetch-obj (stored-word 9)))
    (setf resolutions (fetch-obj (stored-word 10)))
    (setf place (fetch-obj (stored-word 11)))
    (setf spelling (fetch-obj (stored-word 12)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj eager-formula-rewrite-name))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      obj)))

(defmethod copy ((obj eager-constant-rewrite-name) &rest initargs)
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place
                      declared-type type)
    obj
    (make-instance 'eager-constant-rewrite-name :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv)))))

(defmethod store-object* ((obj eager-constant-rewrite-name))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place
                      declared-type type)
    obj
    (reserve-space 14
                   (push-word (store-obj 'eager-constant-rewrite-name))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj place))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type)))))

(defmethod update-fetched ((obj eager-constant-rewrite-name))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place
                      declared-type type pvs-sxhash-value)
    obj
    (setf mod-id (fetch-obj (stored-word 1)))
    (setf library (fetch-obj (stored-word 2)))
    (setf actuals (fetch-obj (stored-word 3)))
    (setf dactuals (fetch-obj (stored-word 4)))
    (setf acts-there? (fetch-obj (stored-word 5)))
    (setf dacts-there? (fetch-obj (stored-word 6)))
    (setf id (fetch-obj (stored-word 7)))
    (setf mappings (fetch-obj (stored-word 8)))
    (setf target (fetch-obj (stored-word 9)))
    (setf resolutions (fetch-obj (stored-word 10)))
    (setf place (fetch-obj (stored-word 11)))
    (setf declared-type (fetch-obj (stored-word 12)))
    (setf type (fetch-obj (stored-word 13)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj eager-constant-rewrite-name))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions declared-type type)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      obj)))

(defmethod copy ((obj lazy-formula-rewrite-name) &rest initargs)
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place spelling)
    obj
    (make-instance 'lazy-formula-rewrite-name :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :spelling
                   (let* ((get1 (getf initargs 'spelling '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :spelling '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) spelling getfv)))))

(defmethod store-object* ((obj lazy-formula-rewrite-name))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place spelling)
    obj
    (reserve-space 13
                   (push-word (store-obj 'lazy-formula-rewrite-name))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj place))
                   (push-word (store-obj spelling)))))

(defmethod update-fetched ((obj lazy-formula-rewrite-name))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place spelling
                      pvs-sxhash-value)
    obj
    (setf mod-id (fetch-obj (stored-word 1)))
    (setf library (fetch-obj (stored-word 2)))
    (setf actuals (fetch-obj (stored-word 3)))
    (setf dactuals (fetch-obj (stored-word 4)))
    (setf acts-there? (fetch-obj (stored-word 5)))
    (setf dacts-there? (fetch-obj (stored-word 6)))
    (setf id (fetch-obj (stored-word 7)))
    (setf mappings (fetch-obj (stored-word 8)))
    (setf target (fetch-obj (stored-word 9)))
    (setf resolutions (fetch-obj (stored-word 10)))
    (setf place (fetch-obj (stored-word 11)))
    (setf spelling (fetch-obj (stored-word 12)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj lazy-formula-rewrite-name))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      obj)))

(defmethod copy ((obj lazy-constant-rewrite-name) &rest initargs)
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place
                      declared-type type)
    obj
    (make-instance 'lazy-constant-rewrite-name :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv)))))

(defmethod store-object* ((obj lazy-constant-rewrite-name))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place
                      declared-type type)
    obj
    (reserve-space 14
                   (push-word (store-obj 'lazy-constant-rewrite-name))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj place))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type)))))

(defmethod update-fetched ((obj lazy-constant-rewrite-name))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place
                      declared-type type pvs-sxhash-value)
    obj
    (setf mod-id (fetch-obj (stored-word 1)))
    (setf library (fetch-obj (stored-word 2)))
    (setf actuals (fetch-obj (stored-word 3)))
    (setf dactuals (fetch-obj (stored-word 4)))
    (setf acts-there? (fetch-obj (stored-word 5)))
    (setf dacts-there? (fetch-obj (stored-word 6)))
    (setf id (fetch-obj (stored-word 7)))
    (setf mappings (fetch-obj (stored-word 8)))
    (setf target (fetch-obj (stored-word 9)))
    (setf resolutions (fetch-obj (stored-word 10)))
    (setf place (fetch-obj (stored-word 11)))
    (setf declared-type (fetch-obj (stored-word 12)))
    (setf type (fetch-obj (stored-word 13)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj lazy-constant-rewrite-name))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions declared-type type)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      obj)))

(defmethod copy ((obj macro-rewrite-name) &rest initargs)
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place)
    obj
    (make-instance 'macro-rewrite-name :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv)))))

(defmethod store-object* ((obj macro-rewrite-name))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place)
    obj
    (reserve-space 12 (push-word (store-obj 'macro-rewrite-name))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj place)))))

(defmethod update-fetched ((obj macro-rewrite-name))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place
                      pvs-sxhash-value)
    obj
    (setf mod-id (fetch-obj (stored-word 1)))
    (setf library (fetch-obj (stored-word 2)))
    (setf actuals (fetch-obj (stored-word 3)))
    (setf dactuals (fetch-obj (stored-word 4)))
    (setf acts-there? (fetch-obj (stored-word 5)))
    (setf dacts-there? (fetch-obj (stored-word 6)))
    (setf id (fetch-obj (stored-word 7)))
    (setf mappings (fetch-obj (stored-word 8)))
    (setf target (fetch-obj (stored-word 9)))
    (setf resolutions (fetch-obj (stored-word 10)))
    (setf place (fetch-obj (stored-word 11)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj macro-rewrite-name))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      obj)))

(defmethod copy ((obj eager-rewrite-name) &rest initargs)
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place)
    obj
    (make-instance 'eager-rewrite-name :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv)))))

(defmethod store-object* ((obj eager-rewrite-name))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place)
    obj
    (reserve-space 12 (push-word (store-obj 'eager-rewrite-name))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj place)))))

(defmethod update-fetched ((obj eager-rewrite-name))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place
                      pvs-sxhash-value)
    obj
    (setf mod-id (fetch-obj (stored-word 1)))
    (setf library (fetch-obj (stored-word 2)))
    (setf actuals (fetch-obj (stored-word 3)))
    (setf dactuals (fetch-obj (stored-word 4)))
    (setf acts-there? (fetch-obj (stored-word 5)))
    (setf dacts-there? (fetch-obj (stored-word 6)))
    (setf id (fetch-obj (stored-word 7)))
    (setf mappings (fetch-obj (stored-word 8)))
    (setf target (fetch-obj (stored-word 9)))
    (setf resolutions (fetch-obj (stored-word 10)))
    (setf place (fetch-obj (stored-word 11)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj eager-rewrite-name))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      obj)))

(defmethod copy ((obj lazy-rewrite-name) &rest initargs)
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place)
    obj
    (make-instance 'lazy-rewrite-name :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv)))))

(defmethod store-object* ((obj lazy-rewrite-name))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place)
    obj
    (reserve-space 12 (push-word (store-obj 'lazy-rewrite-name))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj place)))))

(defmethod update-fetched ((obj lazy-rewrite-name))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place
                      pvs-sxhash-value)
    obj
    (setf mod-id (fetch-obj (stored-word 1)))
    (setf library (fetch-obj (stored-word 2)))
    (setf actuals (fetch-obj (stored-word 3)))
    (setf dactuals (fetch-obj (stored-word 4)))
    (setf acts-there? (fetch-obj (stored-word 5)))
    (setf dacts-there? (fetch-obj (stored-word 6)))
    (setf id (fetch-obj (stored-word 7)))
    (setf mappings (fetch-obj (stored-word 8)))
    (setf target (fetch-obj (stored-word 9)))
    (setf resolutions (fetch-obj (stored-word 10)))
    (setf place (fetch-obj (stored-word 11)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj lazy-rewrite-name))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      obj)))

(defmethod copy ((obj formula-rewrite-name) &rest initargs)
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place spelling)
    obj
    (make-instance 'formula-rewrite-name :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :spelling
                   (let* ((get1 (getf initargs 'spelling '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :spelling '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) spelling getfv)))))

(defmethod store-object* ((obj formula-rewrite-name))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place spelling)
    obj
    (reserve-space 13 (push-word (store-obj 'formula-rewrite-name))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj place))
                   (push-word (store-obj spelling)))))

(defmethod update-fetched ((obj formula-rewrite-name))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place spelling
                      pvs-sxhash-value)
    obj
    (setf mod-id (fetch-obj (stored-word 1)))
    (setf library (fetch-obj (stored-word 2)))
    (setf actuals (fetch-obj (stored-word 3)))
    (setf dactuals (fetch-obj (stored-word 4)))
    (setf acts-there? (fetch-obj (stored-word 5)))
    (setf dacts-there? (fetch-obj (stored-word 6)))
    (setf id (fetch-obj (stored-word 7)))
    (setf mappings (fetch-obj (stored-word 8)))
    (setf target (fetch-obj (stored-word 9)))
    (setf resolutions (fetch-obj (stored-word 10)))
    (setf place (fetch-obj (stored-word 11)))
    (setf spelling (fetch-obj (stored-word 12)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj formula-rewrite-name))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      obj)))

(defmethod copy ((obj constant-rewrite-name) &rest initargs)
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place
                      declared-type type)
    obj
    (make-instance 'constant-rewrite-name :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv)))))

(defmethod store-object* ((obj constant-rewrite-name))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place
                      declared-type type)
    obj
    (reserve-space 14 (push-word (store-obj 'constant-rewrite-name))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj place))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type)))))

(defmethod update-fetched ((obj constant-rewrite-name))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place
                      declared-type type pvs-sxhash-value)
    obj
    (setf mod-id (fetch-obj (stored-word 1)))
    (setf library (fetch-obj (stored-word 2)))
    (setf actuals (fetch-obj (stored-word 3)))
    (setf dactuals (fetch-obj (stored-word 4)))
    (setf acts-there? (fetch-obj (stored-word 5)))
    (setf dacts-there? (fetch-obj (stored-word 6)))
    (setf id (fetch-obj (stored-word 7)))
    (setf mappings (fetch-obj (stored-word 8)))
    (setf target (fetch-obj (stored-word 9)))
    (setf resolutions (fetch-obj (stored-word 10)))
    (setf place (fetch-obj (stored-word 11)))
    (setf declared-type (fetch-obj (stored-word 12)))
    (setf type (fetch-obj (stored-word 13)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj constant-rewrite-name))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions declared-type type)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      obj)))

(defmethod copy ((obj macro-rewrite) &rest initargs)
  (with-slots (place)
    obj
    (make-instance 'macro-rewrite :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv)))))

(defmethod store-object* ((obj macro-rewrite))
  (with-slots (place)
    obj
    (reserve-space 2 (push-word (store-obj 'macro-rewrite))
                   (push-word (store-obj place)))))

(defmethod update-fetched ((obj macro-rewrite))
  (with-slots (place pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj macro-rewrite))
  (with-slots nil obj (let ((*restore-object-parent* obj)) obj)))

(defmethod copy ((obj eager-rewrite) &rest initargs)
  (with-slots (place)
    obj
    (make-instance 'eager-rewrite :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv)))))

(defmethod store-object* ((obj eager-rewrite))
  (with-slots (place)
    obj
    (reserve-space 2 (push-word (store-obj 'eager-rewrite))
                   (push-word (store-obj place)))))

(defmethod update-fetched ((obj eager-rewrite))
  (with-slots (place pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj eager-rewrite))
  (with-slots nil obj (let ((*restore-object-parent* obj)) obj)))

(defmethod copy ((obj lazy-rewrite) &rest initargs)
  (with-slots (place)
    obj
    (make-instance 'lazy-rewrite :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv)))))

(defmethod store-object* ((obj lazy-rewrite))
  (with-slots (place)
    obj
    (reserve-space 2 (push-word (store-obj 'lazy-rewrite))
                   (push-word (store-obj place)))))

(defmethod update-fetched ((obj lazy-rewrite))
  (with-slots (place pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj lazy-rewrite))
  (with-slots nil obj (let ((*restore-object-parent* obj)) obj)))

(defmethod copy ((obj rewrite-name) &rest initargs)
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place)
    obj
    (make-instance 'rewrite-name :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv)))))

(defmethod store-object* ((obj rewrite-name))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place)
    obj
    (reserve-space 12 (push-word (store-obj 'rewrite-name))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj place)))))

(defmethod update-fetched ((obj rewrite-name))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      id mappings target resolutions place
                      pvs-sxhash-value)
    obj
    (setf mod-id (fetch-obj (stored-word 1)))
    (setf library (fetch-obj (stored-word 2)))
    (setf actuals (fetch-obj (stored-word 3)))
    (setf dactuals (fetch-obj (stored-word 4)))
    (setf acts-there? (fetch-obj (stored-word 5)))
    (setf dacts-there? (fetch-obj (stored-word 6)))
    (setf id (fetch-obj (stored-word 7)))
    (setf mappings (fetch-obj (stored-word 8)))
    (setf target (fetch-obj (stored-word 9)))
    (setf resolutions (fetch-obj (stored-word 10)))
    (setf place (fetch-obj (stored-word 11)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj rewrite-name))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      obj)))

(defmethod copy ((obj rewrite-elt) &rest initargs)
  (with-slots (place)
    obj
    (make-instance 'rewrite-elt :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv)))))

(defmethod store-object* ((obj rewrite-elt))
  (with-slots (place)
    obj
    (reserve-space 2 (push-word (store-obj 'rewrite-elt))
                   (push-word (store-obj place)))))

(defmethod update-fetched ((obj rewrite-elt))
  (with-slots (place pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj rewrite-elt))
  (with-slots nil obj (let ((*restore-object-parent* obj)) obj)))

(defmethod copy ((obj auto-rewrite-minus-decl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     rewrite-names)
    obj
    (make-instance 'auto-rewrite-minus-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :rewrite-names
                   (let* ((get1
                           (getf initargs 'rewrite-names '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :rewrite-names '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) rewrite-names getfv)))))

(defmethod store-object* ((obj auto-rewrite-minus-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     rewrite-names)
    obj
    (reserve-space 17 (push-word (store-obj 'auto-rewrite-minus-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj rewrite-names)))))

(defmethod update-fetched ((obj auto-rewrite-minus-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     rewrite-names pvs-sxhash-value tcc-form)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf rewrite-names (fetch-obj (stored-word 16)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)))

(defmethod restore-object* ((obj auto-rewrite-minus-decl))
  (with-slots (unique-id decl-formals formals rewrite-names)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when rewrite-names
        (let ((*restore-object-parent-slot* 'rewrite-names))
          (restore-object* rewrite-names)))
      obj)))

(defmethod copy ((obj auto-rewrite-plus-decl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     rewrite-names)
    obj
    (make-instance 'auto-rewrite-plus-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :rewrite-names
                   (let* ((get1
                           (getf initargs 'rewrite-names '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :rewrite-names '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) rewrite-names getfv)))))

(defmethod store-object* ((obj auto-rewrite-plus-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     rewrite-names)
    obj
    (reserve-space 17 (push-word (store-obj 'auto-rewrite-plus-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj rewrite-names)))))

(defmethod update-fetched ((obj auto-rewrite-plus-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     rewrite-names pvs-sxhash-value tcc-form)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf rewrite-names (fetch-obj (stored-word 16)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)))

(defmethod restore-object* ((obj auto-rewrite-plus-decl))
  (with-slots (unique-id decl-formals formals rewrite-names)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when rewrite-names
        (let ((*restore-object-parent-slot* 'rewrite-names))
          (restore-object* rewrite-names)))
      obj)))

(defmethod copy ((obj auto-rewrite-decl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     rewrite-names)
    obj
    (make-instance 'auto-rewrite-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :rewrite-names
                   (let* ((get1
                           (getf initargs 'rewrite-names '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :rewrite-names '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) rewrite-names getfv)))))

(defmethod store-object* ((obj auto-rewrite-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     rewrite-names)
    obj
    (reserve-space 17 (push-word (store-obj 'auto-rewrite-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj rewrite-names)))))

(defmethod update-fetched ((obj auto-rewrite-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     rewrite-names pvs-sxhash-value tcc-form)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf rewrite-names (fetch-obj (stored-word 16)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)))

(defmethod restore-object* ((obj auto-rewrite-decl))
  (with-slots (unique-id decl-formals formals rewrite-names)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when rewrite-names
        (let ((*restore-object-parent-slot* 'rewrite-names))
          (restore-object* rewrite-names)))
      obj)))

(defmethod copy ((obj conversionminus-decl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     k-combinator? expr)
    obj
    (make-instance 'conversionminus-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :k-combinator?
                   (let* ((get1
                           (getf initargs 'k-combinator? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :k-combinator? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) k-combinator? getfv))
                   :expr
                   (let* ((get1 (getf initargs 'expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expr getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameter-theories
                   (let* ((get1
                           (getf initargs 'free-parameter-theories
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameter-theories
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv)))))

(defmethod store-object* ((obj conversionminus-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     k-combinator? expr)
    obj
    (reserve-space 18 (push-word (store-obj 'conversionminus-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj k-combinator?))
                   (push-word (store-obj expr)))))

(defmethod update-fetched ((obj conversionminus-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     k-combinator? expr pvs-sxhash-value tcc-form
                     free-parameters free-parameter-theories)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf k-combinator? (fetch-obj (stored-word 16)))
    (setf expr (fetch-obj (stored-word 17)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf free-parameters 'unbound)
    (setf free-parameter-theories 'unbound)))

(defmethod restore-object* ((obj conversionminus-decl))
  (with-slots (unique-id decl-formals formals expr)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when expr
        (let ((*restore-object-parent-slot* 'expr))
          (restore-object* expr)))
      obj)))

(defmethod copy ((obj conversionplus-decl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     k-combinator? expr)
    obj
    (make-instance 'conversionplus-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :k-combinator?
                   (let* ((get1
                           (getf initargs 'k-combinator? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :k-combinator? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) k-combinator? getfv))
                   :expr
                   (let* ((get1 (getf initargs 'expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expr getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameter-theories
                   (let* ((get1
                           (getf initargs 'free-parameter-theories
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameter-theories
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv)))))

(defmethod store-object* ((obj conversionplus-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     k-combinator? expr)
    obj
    (reserve-space 18 (push-word (store-obj 'conversionplus-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj k-combinator?))
                   (push-word (store-obj expr)))))

(defmethod update-fetched ((obj conversionplus-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     k-combinator? expr pvs-sxhash-value tcc-form
                     free-parameters free-parameter-theories)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf k-combinator? (fetch-obj (stored-word 16)))
    (setf expr (fetch-obj (stored-word 17)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf free-parameters 'unbound)
    (setf free-parameter-theories 'unbound)))

(defmethod restore-object* ((obj conversionplus-decl))
  (with-slots (unique-id decl-formals formals expr)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when expr
        (let ((*restore-object-parent-slot* 'expr))
          (restore-object* expr)))
      obj)))

(defmethod copy ((obj conversion-decl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     k-combinator? expr)
    obj
    (make-instance 'conversion-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :k-combinator?
                   (let* ((get1
                           (getf initargs 'k-combinator? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :k-combinator? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) k-combinator? getfv))
                   :expr
                   (let* ((get1 (getf initargs 'expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expr getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameter-theories
                   (let* ((get1
                           (getf initargs 'free-parameter-theories
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameter-theories
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv)))))

(defmethod store-object* ((obj conversion-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     k-combinator? expr)
    obj
    (reserve-space 18 (push-word (store-obj 'conversion-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj k-combinator?))
                   (push-word (store-obj expr)))))

(defmethod update-fetched ((obj conversion-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     k-combinator? expr pvs-sxhash-value tcc-form
                     free-parameters free-parameter-theories)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf k-combinator? (fetch-obj (stored-word 16)))
    (setf expr (fetch-obj (stored-word 17)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf free-parameters 'unbound)
    (setf free-parameter-theories 'unbound)))

(defmethod restore-object* ((obj conversion-decl))
  (with-slots (unique-id decl-formals formals expr)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when expr
        (let ((*restore-object-parent-slot* 'expr))
          (restore-object* expr)))
      obj)))

(defmethod copy ((obj rec-application-judgement) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals module
                     refers-to chain? typechecked? visible? generated
                     generated-by semi typecheck-time declared-type
                     declared-type-string type name formals
                     judgement-type rewrite-formula)
    obj
    (make-instance 'rec-application-judgement :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameter-theories
                   (let* ((get1
                           (getf initargs 'free-parameter-theories
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameter-theories
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :name
                   (let* ((get1 (getf initargs 'name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) name getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :judgement-type
                   (let* ((get1
                           (getf initargs 'judgement-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :judgement-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) judgement-type getfv))
                   :rewrite-formula
                   (let* ((get1
                           (getf initargs 'rewrite-formula '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :rewrite-formula
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) rewrite-formula getfv)))))

(defmethod store-object* ((obj rec-application-judgement))
  (with-slots (place unique-id newline-comment id decl-formals module
                     refers-to chain? typechecked? visible? generated
                     generated-by semi typecheck-time declared-type
                     type name formals judgement-type rewrite-formula)
    obj
    (reserve-space 21
                   (push-word (store-obj 'rec-application-judgement))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj name))
                   (push-word (store-obj formals))
                   (push-word (store-obj judgement-type))
                   (push-word (store-obj rewrite-formula)))))

(defmethod update-fetched ((obj rec-application-judgement))
  (with-slots (place unique-id newline-comment id decl-formals module
                     refers-to chain? typechecked? visible? generated
                     generated-by semi typecheck-time declared-type
                     type name formals judgement-type rewrite-formula
                     pvs-sxhash-value tcc-form declared-type-string
                     free-parameters free-parameter-theories)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf module (fetch-obj (stored-word 6)))
    (setf refers-to (fetch-obj (stored-word 7)))
    (setf chain? (fetch-obj (stored-word 8)))
    (setf typechecked? (fetch-obj (stored-word 9)))
    (setf visible? (fetch-obj (stored-word 10)))
    (setf generated (fetch-obj (stored-word 11)))
    (setf generated-by (fetch-obj (stored-word 12)))
    (setf semi (fetch-obj (stored-word 13)))
    (setf typecheck-time (fetch-obj (stored-word 14)))
    (setf declared-type (fetch-obj (stored-word 15)))
    (setf type (fetch-obj (stored-word 16)))
    (setf name (fetch-obj (stored-word 17)))
    (setf formals (fetch-obj (stored-word 18)))
    (setf judgement-type (fetch-obj (stored-word 19)))
    (setf rewrite-formula (fetch-obj (stored-word 20)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf declared-type-string nil)
    (setf free-parameters 'unbound)
    (setf free-parameter-theories 'unbound)))

(defmethod restore-object* ((obj rec-application-judgement))
  (with-slots (unique-id decl-formals declared-type type name formals
                         judgement-type rewrite-formula)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when name
        (let ((*restore-object-parent-slot* 'name))
          (restore-object* name)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when judgement-type
        (let ((*restore-object-parent-slot* 'judgement-type))
          (restore-object* judgement-type)))
      (when rewrite-formula
        (let ((*restore-object-parent-slot* 'rewrite-formula))
          (restore-object* rewrite-formula)))
      obj)))

(defmethod copy ((obj expr-judgement) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type declared-type-string type expr
                     closed-form judgement-type)
    obj
    (make-instance 'expr-judgement :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameter-theories
                   (let* ((get1
                           (getf initargs 'free-parameter-theories
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameter-theories
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :expr
                   (let* ((get1 (getf initargs 'expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expr getfv))
                   :closed-form
                   (let* ((get1 (getf initargs 'closed-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :closed-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) closed-form getfv))
                   :judgement-type
                   (let* ((get1
                           (getf initargs 'judgement-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :judgement-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) judgement-type getfv)))))

(defmethod store-object* ((obj expr-judgement))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type expr closed-form
                     judgement-type)
    obj
    (reserve-space 21 (push-word (store-obj 'expr-judgement))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj expr))
                   (push-word (store-obj closed-form))
                   (push-word (store-obj judgement-type)))))

(defmethod update-fetched ((obj expr-judgement))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type expr closed-form judgement-type
                     pvs-sxhash-value tcc-form declared-type-string
                     free-parameters free-parameter-theories)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf declared-type (fetch-obj (stored-word 16)))
    (setf type (fetch-obj (stored-word 17)))
    (setf expr (fetch-obj (stored-word 18)))
    (setf closed-form (fetch-obj (stored-word 19)))
    (setf judgement-type (fetch-obj (stored-word 20)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf declared-type-string nil)
    (setf free-parameters 'unbound)
    (setf free-parameter-theories 'unbound)))

(defmethod restore-object* ((obj expr-judgement))
  (with-slots (unique-id decl-formals formals declared-type type expr
                         closed-form judgement-type)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when expr
        (let ((*restore-object-parent-slot* 'expr))
          (restore-object* expr)))
      (when closed-form
        (let ((*restore-object-parent-slot* 'closed-form))
          (restore-object* closed-form)))
      (when judgement-type
        (let ((*restore-object-parent-slot* 'judgement-type))
          (restore-object* judgement-type)))
      obj)))

(defmethod copy ((obj application-judgement) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals module
                     refers-to chain? typechecked? visible? generated
                     generated-by semi typecheck-time declared-type
                     declared-type-string type name formals
                     judgement-type)
    obj
    (make-instance 'application-judgement :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameter-theories
                   (let* ((get1
                           (getf initargs 'free-parameter-theories
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameter-theories
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :name
                   (let* ((get1 (getf initargs 'name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) name getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :judgement-type
                   (let* ((get1
                           (getf initargs 'judgement-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :judgement-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) judgement-type getfv)))))

(defmethod store-object* ((obj application-judgement))
  (with-slots (place unique-id newline-comment id decl-formals module
                     refers-to chain? typechecked? visible? generated
                     generated-by semi typecheck-time declared-type
                     type name formals judgement-type)
    obj
    (reserve-space 20 (push-word (store-obj 'application-judgement))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj name))
                   (push-word (store-obj formals))
                   (push-word (store-obj judgement-type)))))

(defmethod update-fetched ((obj application-judgement))
  (with-slots (place unique-id newline-comment id decl-formals module
                     refers-to chain? typechecked? visible? generated
                     generated-by semi typecheck-time declared-type
                     type name formals judgement-type pvs-sxhash-value
                     tcc-form declared-type-string free-parameters
                     free-parameter-theories)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf module (fetch-obj (stored-word 6)))
    (setf refers-to (fetch-obj (stored-word 7)))
    (setf chain? (fetch-obj (stored-word 8)))
    (setf typechecked? (fetch-obj (stored-word 9)))
    (setf visible? (fetch-obj (stored-word 10)))
    (setf generated (fetch-obj (stored-word 11)))
    (setf generated-by (fetch-obj (stored-word 12)))
    (setf semi (fetch-obj (stored-word 13)))
    (setf typecheck-time (fetch-obj (stored-word 14)))
    (setf declared-type (fetch-obj (stored-word 15)))
    (setf type (fetch-obj (stored-word 16)))
    (setf name (fetch-obj (stored-word 17)))
    (setf formals (fetch-obj (stored-word 18)))
    (setf judgement-type (fetch-obj (stored-word 19)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf declared-type-string nil)
    (setf free-parameters 'unbound)
    (setf free-parameter-theories 'unbound)))

(defmethod restore-object* ((obj application-judgement))
  (with-slots (unique-id decl-formals declared-type type name formals
                         judgement-type)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when name
        (let ((*restore-object-parent-slot* 'name))
          (restore-object* name)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when judgement-type
        (let ((*restore-object-parent-slot* 'judgement-type))
          (restore-object* judgement-type)))
      obj)))

(defmethod copy ((obj name-judgement) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type declared-type-string type name)
    obj
    (make-instance 'name-judgement :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameter-theories
                   (let* ((get1
                           (getf initargs 'free-parameter-theories
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameter-theories
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :name
                   (let* ((get1 (getf initargs 'name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) name getfv)))))

(defmethod store-object* ((obj name-judgement))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type name)
    obj
    (reserve-space 19 (push-word (store-obj 'name-judgement))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj name)))))

(defmethod update-fetched ((obj name-judgement))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type name pvs-sxhash-value tcc-form
                     declared-type-string free-parameters
                     free-parameter-theories)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf declared-type (fetch-obj (stored-word 16)))
    (setf type (fetch-obj (stored-word 17)))
    (setf name (fetch-obj (stored-word 18)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf declared-type-string nil)
    (setf free-parameters 'unbound)
    (setf free-parameter-theories 'unbound)))

(defmethod restore-object* ((obj name-judgement))
  (with-slots (unique-id decl-formals formals declared-type type name)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when name
        (let ((*restore-object-parent-slot* 'name))
          (restore-object* name)))
      obj)))

(defmethod copy ((obj number-judgement) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type declared-type-string type
                     number-expr)
    obj
    (make-instance 'number-judgement :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameter-theories
                   (let* ((get1
                           (getf initargs 'free-parameter-theories
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameter-theories
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :number-expr
                   (let* ((get1 (getf initargs 'number-expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :number-expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) number-expr getfv)))))

(defmethod store-object* ((obj number-judgement))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type number-expr)
    obj
    (reserve-space 19 (push-word (store-obj 'number-judgement))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj number-expr)))))

(defmethod update-fetched ((obj number-judgement))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type number-expr pvs-sxhash-value
                     tcc-form declared-type-string free-parameters
                     free-parameter-theories)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf declared-type (fetch-obj (stored-word 16)))
    (setf type (fetch-obj (stored-word 17)))
    (setf number-expr (fetch-obj (stored-word 18)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf declared-type-string nil)
    (setf free-parameters 'unbound)
    (setf free-parameter-theories 'unbound)))

(defmethod restore-object* ((obj number-judgement))
  (with-slots (unique-id decl-formals formals declared-type type
                         number-expr)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when number-expr
        (let ((*restore-object-parent-slot* 'number-expr))
          (restore-object* number-expr)))
      obj)))

(defmethod copy ((obj subtype-judgement) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type declared-type-string type
                     declared-subtype subtype)
    obj
    (make-instance 'subtype-judgement :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameter-theories
                   (let* ((get1
                           (getf initargs 'free-parameter-theories
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameter-theories
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :declared-subtype
                   (let* ((get1
                           (getf initargs 'declared-subtype '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-subtype
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-subtype getfv))
                   :subtype
                   (let* ((get1 (getf initargs 'subtype '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :subtype '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) subtype getfv)))))

(defmethod store-object* ((obj subtype-judgement))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type declared-subtype subtype)
    obj
    (reserve-space 20 (push-word (store-obj 'subtype-judgement))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj declared-subtype))
                   (push-word (store-obj subtype)))))

(defmethod update-fetched ((obj subtype-judgement))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type declared-subtype subtype
                     pvs-sxhash-value tcc-form declared-type-string
                     free-parameters free-parameter-theories)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf declared-type (fetch-obj (stored-word 16)))
    (setf type (fetch-obj (stored-word 17)))
    (setf declared-subtype (fetch-obj (stored-word 18)))
    (setf subtype (fetch-obj (stored-word 19)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf declared-type-string nil)
    (setf free-parameters 'unbound)
    (setf free-parameter-theories 'unbound)))

(defmethod restore-object* ((obj subtype-judgement))
  (with-slots (unique-id decl-formals formals declared-type type
                         declared-subtype subtype)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when declared-subtype
        (let ((*restore-object-parent-slot* 'declared-subtype))
          (restore-object* declared-subtype)))
      (when subtype
        (let ((*restore-object-parent-slot* 'subtype))
          (restore-object* subtype)))
      obj)))

(defmethod copy ((obj judgement) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type declared-type-string type)
    obj
    (make-instance 'judgement :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameter-theories
                   (let* ((get1
                           (getf initargs 'free-parameter-theories
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameter-theories
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv)))))

(defmethod store-object* ((obj judgement))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type)
    obj
    (reserve-space 18 (push-word (store-obj 'judgement))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type)))))

(defmethod update-fetched ((obj judgement))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type pvs-sxhash-value tcc-form
                     declared-type-string free-parameters
                     free-parameter-theories)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf declared-type (fetch-obj (stored-word 16)))
    (setf type (fetch-obj (stored-word 17)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf declared-type-string nil)
    (setf free-parameters 'unbound)
    (setf free-parameter-theories 'unbound)))

(defmethod restore-object* ((obj judgement))
  (with-slots (unique-id decl-formals formals declared-type type)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      obj)))

(defmethod copy ((obj monotonicity-tcc) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition closed-definition kind
                     default-proof proofs origin tcc-disjuncts
                     importing-instance)
    obj
    (make-instance 'monotonicity-tcc :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :spelling
                   (let* ((get1 (getf initargs 'spelling '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :spelling '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) spelling getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :closed-definition
                   (let* ((get1
                           (getf initargs 'closed-definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :closed-definition
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) closed-definition getfv))
                   :kind
                   (let* ((get1 (getf initargs 'kind '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :kind '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) kind getfv))
                   :default-proof
                   (let* ((get1
                           (getf initargs 'default-proof '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :default-proof '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) default-proof getfv))
                   :proofs
                   (let* ((get1 (getf initargs 'proofs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :proofs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) proofs getfv))
                   :origin
                   (let* ((get1 (getf initargs 'origin '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :origin '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) origin getfv))
                   :tcc-disjuncts
                   (let* ((get1
                           (getf initargs 'tcc-disjuncts '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-disjuncts '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-disjuncts getfv))
                   :importing-instance
                   (let* ((get1
                           (getf initargs 'importing-instance
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :importing-instance
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         importing-instance
                       getfv)))))

(defmethod store-object* ((obj monotonicity-tcc))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs
                     origin tcc-disjuncts importing-instance)
    obj
    (reserve-space 24 (push-word (store-obj 'monotonicity-tcc))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj spelling))
                   (push-word (store-obj definition))
                   (push-word (store-obj kind))
                   (push-word (store-obj default-proof))
                   (push-word (store-obj proofs))
                   (push-word (store-obj origin))
                   (push-word (store-obj tcc-disjuncts))
                   (push-word (store-obj importing-instance)))))

(defmethod update-fetched ((obj monotonicity-tcc))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs
                     origin tcc-disjuncts importing-instance
                     pvs-sxhash-value tcc-form closed-definition)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf spelling (fetch-obj (stored-word 16)))
    (setf definition (fetch-obj (stored-word 17)))
    (setf kind (fetch-obj (stored-word 18)))
    (setf default-proof (fetch-obj (stored-word 19)))
    (setf proofs (fetch-obj (stored-word 20)))
    (setf origin (fetch-obj (stored-word 21)))
    (setf tcc-disjuncts (fetch-obj (stored-word 22)))
    (setf importing-instance (fetch-obj (stored-word 23)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf closed-definition nil)))

(defmethod restore-object* ((obj monotonicity-tcc))
  (with-slots (unique-id decl-formals formals definition origin
                         importing-instance)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      (when origin
        (let ((*restore-object-parent-slot* 'origin))
          (restore-object* origin)))
      (when importing-instance
        (let ((*restore-object-parent-slot* 'importing-instance))
          (restore-object* importing-instance)))
      obj)))

(defmethod copy ((obj cond-coverage-tcc) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition closed-definition kind
                     default-proof proofs origin tcc-disjuncts
                     importing-instance)
    obj
    (make-instance 'cond-coverage-tcc :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :spelling
                   (let* ((get1 (getf initargs 'spelling '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :spelling '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) spelling getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :closed-definition
                   (let* ((get1
                           (getf initargs 'closed-definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :closed-definition
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) closed-definition getfv))
                   :kind
                   (let* ((get1 (getf initargs 'kind '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :kind '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) kind getfv))
                   :default-proof
                   (let* ((get1
                           (getf initargs 'default-proof '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :default-proof '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) default-proof getfv))
                   :proofs
                   (let* ((get1 (getf initargs 'proofs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :proofs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) proofs getfv))
                   :origin
                   (let* ((get1 (getf initargs 'origin '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :origin '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) origin getfv))
                   :tcc-disjuncts
                   (let* ((get1
                           (getf initargs 'tcc-disjuncts '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-disjuncts '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-disjuncts getfv))
                   :importing-instance
                   (let* ((get1
                           (getf initargs 'importing-instance
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :importing-instance
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         importing-instance
                       getfv)))))

(defmethod store-object* ((obj cond-coverage-tcc))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs
                     origin tcc-disjuncts importing-instance)
    obj
    (reserve-space 24 (push-word (store-obj 'cond-coverage-tcc))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj spelling))
                   (push-word (store-obj definition))
                   (push-word (store-obj kind))
                   (push-word (store-obj default-proof))
                   (push-word (store-obj proofs))
                   (push-word (store-obj origin))
                   (push-word (store-obj tcc-disjuncts))
                   (push-word (store-obj importing-instance)))))

(defmethod update-fetched ((obj cond-coverage-tcc))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs
                     origin tcc-disjuncts importing-instance
                     pvs-sxhash-value tcc-form closed-definition)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf spelling (fetch-obj (stored-word 16)))
    (setf definition (fetch-obj (stored-word 17)))
    (setf kind (fetch-obj (stored-word 18)))
    (setf default-proof (fetch-obj (stored-word 19)))
    (setf proofs (fetch-obj (stored-word 20)))
    (setf origin (fetch-obj (stored-word 21)))
    (setf tcc-disjuncts (fetch-obj (stored-word 22)))
    (setf importing-instance (fetch-obj (stored-word 23)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf closed-definition nil)))

(defmethod restore-object* ((obj cond-coverage-tcc))
  (with-slots (unique-id decl-formals formals definition origin
                         importing-instance)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      (when origin
        (let ((*restore-object-parent-slot* 'origin))
          (restore-object* origin)))
      (when importing-instance
        (let ((*restore-object-parent-slot* 'importing-instance))
          (restore-object* importing-instance)))
      obj)))

(defmethod copy ((obj cond-disjoint-tcc) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition closed-definition kind
                     default-proof proofs origin tcc-disjuncts
                     importing-instance)
    obj
    (make-instance 'cond-disjoint-tcc :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :spelling
                   (let* ((get1 (getf initargs 'spelling '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :spelling '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) spelling getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :closed-definition
                   (let* ((get1
                           (getf initargs 'closed-definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :closed-definition
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) closed-definition getfv))
                   :kind
                   (let* ((get1 (getf initargs 'kind '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :kind '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) kind getfv))
                   :default-proof
                   (let* ((get1
                           (getf initargs 'default-proof '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :default-proof '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) default-proof getfv))
                   :proofs
                   (let* ((get1 (getf initargs 'proofs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :proofs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) proofs getfv))
                   :origin
                   (let* ((get1 (getf initargs 'origin '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :origin '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) origin getfv))
                   :tcc-disjuncts
                   (let* ((get1
                           (getf initargs 'tcc-disjuncts '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-disjuncts '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-disjuncts getfv))
                   :importing-instance
                   (let* ((get1
                           (getf initargs 'importing-instance
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :importing-instance
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         importing-instance
                       getfv)))))

(defmethod store-object* ((obj cond-disjoint-tcc))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs
                     origin tcc-disjuncts importing-instance)
    obj
    (reserve-space 24 (push-word (store-obj 'cond-disjoint-tcc))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj spelling))
                   (push-word (store-obj definition))
                   (push-word (store-obj kind))
                   (push-word (store-obj default-proof))
                   (push-word (store-obj proofs))
                   (push-word (store-obj origin))
                   (push-word (store-obj tcc-disjuncts))
                   (push-word (store-obj importing-instance)))))

(defmethod update-fetched ((obj cond-disjoint-tcc))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs
                     origin tcc-disjuncts importing-instance
                     pvs-sxhash-value tcc-form closed-definition)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf spelling (fetch-obj (stored-word 16)))
    (setf definition (fetch-obj (stored-word 17)))
    (setf kind (fetch-obj (stored-word 18)))
    (setf default-proof (fetch-obj (stored-word 19)))
    (setf proofs (fetch-obj (stored-word 20)))
    (setf origin (fetch-obj (stored-word 21)))
    (setf tcc-disjuncts (fetch-obj (stored-word 22)))
    (setf importing-instance (fetch-obj (stored-word 23)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf closed-definition nil)))

(defmethod restore-object* ((obj cond-disjoint-tcc))
  (with-slots (unique-id decl-formals formals definition origin
                         importing-instance)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      (when origin
        (let ((*restore-object-parent-slot* 'origin))
          (restore-object* origin)))
      (when importing-instance
        (let ((*restore-object-parent-slot* 'importing-instance))
          (restore-object* importing-instance)))
      obj)))

(defmethod copy ((obj same-name-tcc) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition closed-definition kind
                     default-proof proofs origin tcc-disjuncts
                     importing-instance)
    obj
    (make-instance 'same-name-tcc :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :spelling
                   (let* ((get1 (getf initargs 'spelling '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :spelling '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) spelling getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :closed-definition
                   (let* ((get1
                           (getf initargs 'closed-definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :closed-definition
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) closed-definition getfv))
                   :kind
                   (let* ((get1 (getf initargs 'kind '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :kind '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) kind getfv))
                   :default-proof
                   (let* ((get1
                           (getf initargs 'default-proof '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :default-proof '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) default-proof getfv))
                   :proofs
                   (let* ((get1 (getf initargs 'proofs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :proofs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) proofs getfv))
                   :origin
                   (let* ((get1 (getf initargs 'origin '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :origin '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) origin getfv))
                   :tcc-disjuncts
                   (let* ((get1
                           (getf initargs 'tcc-disjuncts '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-disjuncts '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-disjuncts getfv))
                   :importing-instance
                   (let* ((get1
                           (getf initargs 'importing-instance
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :importing-instance
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         importing-instance
                       getfv)))))

(defmethod store-object* ((obj same-name-tcc))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs
                     origin tcc-disjuncts importing-instance)
    obj
    (reserve-space 24 (push-word (store-obj 'same-name-tcc))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj spelling))
                   (push-word (store-obj definition))
                   (push-word (store-obj kind))
                   (push-word (store-obj default-proof))
                   (push-word (store-obj proofs))
                   (push-word (store-obj origin))
                   (push-word (store-obj tcc-disjuncts))
                   (push-word (store-obj importing-instance)))))

(defmethod update-fetched ((obj same-name-tcc))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs
                     origin tcc-disjuncts importing-instance
                     pvs-sxhash-value tcc-form closed-definition)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf spelling (fetch-obj (stored-word 16)))
    (setf definition (fetch-obj (stored-word 17)))
    (setf kind (fetch-obj (stored-word 18)))
    (setf default-proof (fetch-obj (stored-word 19)))
    (setf proofs (fetch-obj (stored-word 20)))
    (setf origin (fetch-obj (stored-word 21)))
    (setf tcc-disjuncts (fetch-obj (stored-word 22)))
    (setf importing-instance (fetch-obj (stored-word 23)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf closed-definition nil)))

(defmethod restore-object* ((obj same-name-tcc))
  (with-slots (unique-id decl-formals formals definition origin
                         importing-instance)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      (when origin
        (let ((*restore-object-parent-slot* 'origin))
          (restore-object* origin)))
      (when importing-instance
        (let ((*restore-object-parent-slot* 'importing-instance))
          (restore-object* importing-instance)))
      obj)))

(defmethod copy ((obj well-founded-tcc) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition closed-definition kind
                     default-proof proofs origin tcc-disjuncts
                     importing-instance)
    obj
    (make-instance 'well-founded-tcc :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :spelling
                   (let* ((get1 (getf initargs 'spelling '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :spelling '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) spelling getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :closed-definition
                   (let* ((get1
                           (getf initargs 'closed-definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :closed-definition
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) closed-definition getfv))
                   :kind
                   (let* ((get1 (getf initargs 'kind '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :kind '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) kind getfv))
                   :default-proof
                   (let* ((get1
                           (getf initargs 'default-proof '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :default-proof '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) default-proof getfv))
                   :proofs
                   (let* ((get1 (getf initargs 'proofs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :proofs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) proofs getfv))
                   :origin
                   (let* ((get1 (getf initargs 'origin '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :origin '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) origin getfv))
                   :tcc-disjuncts
                   (let* ((get1
                           (getf initargs 'tcc-disjuncts '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-disjuncts '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-disjuncts getfv))
                   :importing-instance
                   (let* ((get1
                           (getf initargs 'importing-instance
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :importing-instance
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         importing-instance
                       getfv)))))

(defmethod store-object* ((obj well-founded-tcc))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs
                     origin tcc-disjuncts importing-instance)
    obj
    (reserve-space 24 (push-word (store-obj 'well-founded-tcc))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj spelling))
                   (push-word (store-obj definition))
                   (push-word (store-obj kind))
                   (push-word (store-obj default-proof))
                   (push-word (store-obj proofs))
                   (push-word (store-obj origin))
                   (push-word (store-obj tcc-disjuncts))
                   (push-word (store-obj importing-instance)))))

(defmethod update-fetched ((obj well-founded-tcc))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs
                     origin tcc-disjuncts importing-instance
                     pvs-sxhash-value tcc-form closed-definition)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf spelling (fetch-obj (stored-word 16)))
    (setf definition (fetch-obj (stored-word 17)))
    (setf kind (fetch-obj (stored-word 18)))
    (setf default-proof (fetch-obj (stored-word 19)))
    (setf proofs (fetch-obj (stored-word 20)))
    (setf origin (fetch-obj (stored-word 21)))
    (setf tcc-disjuncts (fetch-obj (stored-word 22)))
    (setf importing-instance (fetch-obj (stored-word 23)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf closed-definition nil)))

(defmethod restore-object* ((obj well-founded-tcc))
  (with-slots (unique-id decl-formals formals definition origin
                         importing-instance)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      (when origin
        (let ((*restore-object-parent-slot* 'origin))
          (restore-object* origin)))
      (when importing-instance
        (let ((*restore-object-parent-slot* 'importing-instance))
          (restore-object* importing-instance)))
      obj)))

(defmethod copy ((obj cases-tcc) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition closed-definition kind
                     default-proof proofs origin tcc-disjuncts
                     importing-instance)
    obj
    (make-instance 'cases-tcc :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :spelling
                   (let* ((get1 (getf initargs 'spelling '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :spelling '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) spelling getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :closed-definition
                   (let* ((get1
                           (getf initargs 'closed-definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :closed-definition
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) closed-definition getfv))
                   :kind
                   (let* ((get1 (getf initargs 'kind '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :kind '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) kind getfv))
                   :default-proof
                   (let* ((get1
                           (getf initargs 'default-proof '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :default-proof '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) default-proof getfv))
                   :proofs
                   (let* ((get1 (getf initargs 'proofs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :proofs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) proofs getfv))
                   :origin
                   (let* ((get1 (getf initargs 'origin '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :origin '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) origin getfv))
                   :tcc-disjuncts
                   (let* ((get1
                           (getf initargs 'tcc-disjuncts '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-disjuncts '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-disjuncts getfv))
                   :importing-instance
                   (let* ((get1
                           (getf initargs 'importing-instance
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :importing-instance
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         importing-instance
                       getfv)))))

(defmethod store-object* ((obj cases-tcc))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs
                     origin tcc-disjuncts importing-instance)
    obj
    (reserve-space 24 (push-word (store-obj 'cases-tcc))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj spelling))
                   (push-word (store-obj definition))
                   (push-word (store-obj kind))
                   (push-word (store-obj default-proof))
                   (push-word (store-obj proofs))
                   (push-word (store-obj origin))
                   (push-word (store-obj tcc-disjuncts))
                   (push-word (store-obj importing-instance)))))

(defmethod update-fetched ((obj cases-tcc))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs
                     origin tcc-disjuncts importing-instance
                     pvs-sxhash-value tcc-form closed-definition)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf spelling (fetch-obj (stored-word 16)))
    (setf definition (fetch-obj (stored-word 17)))
    (setf kind (fetch-obj (stored-word 18)))
    (setf default-proof (fetch-obj (stored-word 19)))
    (setf proofs (fetch-obj (stored-word 20)))
    (setf origin (fetch-obj (stored-word 21)))
    (setf tcc-disjuncts (fetch-obj (stored-word 22)))
    (setf importing-instance (fetch-obj (stored-word 23)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf closed-definition nil)))

(defmethod restore-object* ((obj cases-tcc))
  (with-slots (unique-id decl-formals formals definition origin
                         importing-instance)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      (when origin
        (let ((*restore-object-parent-slot* 'origin))
          (restore-object* origin)))
      (when importing-instance
        (let ((*restore-object-parent-slot* 'importing-instance))
          (restore-object* importing-instance)))
      obj)))

(defmethod copy ((obj mapped-eq-def-tcc) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition closed-definition kind
                     default-proof proofs origin tcc-disjuncts
                     importing-instance)
    obj
    (make-instance 'mapped-eq-def-tcc :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :spelling
                   (let* ((get1 (getf initargs 'spelling '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :spelling '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) spelling getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :closed-definition
                   (let* ((get1
                           (getf initargs 'closed-definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :closed-definition
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) closed-definition getfv))
                   :kind
                   (let* ((get1 (getf initargs 'kind '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :kind '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) kind getfv))
                   :default-proof
                   (let* ((get1
                           (getf initargs 'default-proof '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :default-proof '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) default-proof getfv))
                   :proofs
                   (let* ((get1 (getf initargs 'proofs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :proofs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) proofs getfv))
                   :origin
                   (let* ((get1 (getf initargs 'origin '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :origin '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) origin getfv))
                   :tcc-disjuncts
                   (let* ((get1
                           (getf initargs 'tcc-disjuncts '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-disjuncts '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-disjuncts getfv))
                   :importing-instance
                   (let* ((get1
                           (getf initargs 'importing-instance
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :importing-instance
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         importing-instance
                       getfv)))))

(defmethod store-object* ((obj mapped-eq-def-tcc))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs
                     origin tcc-disjuncts importing-instance)
    obj
    (reserve-space 24 (push-word (store-obj 'mapped-eq-def-tcc))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj spelling))
                   (push-word (store-obj definition))
                   (push-word (store-obj kind))
                   (push-word (store-obj default-proof))
                   (push-word (store-obj proofs))
                   (push-word (store-obj origin))
                   (push-word (store-obj tcc-disjuncts))
                   (push-word (store-obj importing-instance)))))

(defmethod update-fetched ((obj mapped-eq-def-tcc))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs
                     origin tcc-disjuncts importing-instance
                     pvs-sxhash-value tcc-form closed-definition)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf spelling (fetch-obj (stored-word 16)))
    (setf definition (fetch-obj (stored-word 17)))
    (setf kind (fetch-obj (stored-word 18)))
    (setf default-proof (fetch-obj (stored-word 19)))
    (setf proofs (fetch-obj (stored-word 20)))
    (setf origin (fetch-obj (stored-word 21)))
    (setf tcc-disjuncts (fetch-obj (stored-word 22)))
    (setf importing-instance (fetch-obj (stored-word 23)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf closed-definition nil)))

(defmethod restore-object* ((obj mapped-eq-def-tcc))
  (with-slots (unique-id decl-formals formals definition origin
                         importing-instance)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      (when origin
        (let ((*restore-object-parent-slot* 'origin))
          (restore-object* origin)))
      (when importing-instance
        (let ((*restore-object-parent-slot* 'importing-instance))
          (restore-object* importing-instance)))
      obj)))

(defmethod copy ((obj mapped-axiom-tcc) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition closed-definition kind
                     default-proof proofs origin tcc-disjuncts
                     importing-instance theory-instance
                     generating-axiom)
    obj
    (make-instance 'mapped-axiom-tcc :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :spelling
                   (let* ((get1 (getf initargs 'spelling '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :spelling '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) spelling getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :closed-definition
                   (let* ((get1
                           (getf initargs 'closed-definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :closed-definition
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) closed-definition getfv))
                   :kind
                   (let* ((get1 (getf initargs 'kind '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :kind '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) kind getfv))
                   :default-proof
                   (let* ((get1
                           (getf initargs 'default-proof '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :default-proof '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) default-proof getfv))
                   :proofs
                   (let* ((get1 (getf initargs 'proofs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :proofs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) proofs getfv))
                   :origin
                   (let* ((get1 (getf initargs 'origin '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :origin '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) origin getfv))
                   :tcc-disjuncts
                   (let* ((get1
                           (getf initargs 'tcc-disjuncts '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-disjuncts '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-disjuncts getfv))
                   :importing-instance
                   (let* ((get1
                           (getf initargs 'importing-instance
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :importing-instance
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) importing-instance getfv))
                   :theory-instance
                   (let* ((get1
                           (getf initargs 'theory-instance '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :theory-instance
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) theory-instance getfv))
                   :generating-axiom
                   (let* ((get1
                           (getf initargs 'generating-axiom '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :generating-axiom
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generating-axiom getfv)))))

(defmethod store-object* ((obj mapped-axiom-tcc))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs
                     origin tcc-disjuncts importing-instance
                     theory-instance generating-axiom)
    obj
    (reserve-space 26 (push-word (store-obj 'mapped-axiom-tcc))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj spelling))
                   (push-word (store-obj definition))
                   (push-word (store-obj kind))
                   (push-word (store-obj default-proof))
                   (push-word (store-obj proofs))
                   (push-word (store-obj origin))
                   (push-word (store-obj tcc-disjuncts))
                   (push-word (store-obj importing-instance))
                   (push-word (store-obj theory-instance))
                   (push-word (store-obj generating-axiom)))))

(defmethod update-fetched ((obj mapped-axiom-tcc))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs
                     origin tcc-disjuncts importing-instance
                     theory-instance generating-axiom pvs-sxhash-value
                     tcc-form closed-definition)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf spelling (fetch-obj (stored-word 16)))
    (setf definition (fetch-obj (stored-word 17)))
    (setf kind (fetch-obj (stored-word 18)))
    (setf default-proof (fetch-obj (stored-word 19)))
    (setf proofs (fetch-obj (stored-word 20)))
    (setf origin (fetch-obj (stored-word 21)))
    (setf tcc-disjuncts (fetch-obj (stored-word 22)))
    (setf importing-instance (fetch-obj (stored-word 23)))
    (setf theory-instance (fetch-obj (stored-word 24)))
    (setf generating-axiom (fetch-obj (stored-word 25)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf closed-definition nil)))

(defmethod restore-object* ((obj mapped-axiom-tcc))
  (with-slots (unique-id decl-formals formals definition origin
                         importing-instance theory-instance)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      (when origin
        (let ((*restore-object-parent-slot* 'origin))
          (restore-object* origin)))
      (when importing-instance
        (let ((*restore-object-parent-slot* 'importing-instance))
          (restore-object* importing-instance)))
      (when theory-instance
        (let ((*restore-object-parent-slot* 'theory-instance))
          (restore-object* theory-instance)))
      obj)))

(defmethod copy ((obj assuming-tcc) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition closed-definition kind
                     default-proof proofs origin tcc-disjuncts
                     importing-instance theory-instance
                     generating-assumption)
    obj
    (make-instance 'assuming-tcc :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :spelling
                   (let* ((get1 (getf initargs 'spelling '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :spelling '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) spelling getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :closed-definition
                   (let* ((get1
                           (getf initargs 'closed-definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :closed-definition
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) closed-definition getfv))
                   :kind
                   (let* ((get1 (getf initargs 'kind '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :kind '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) kind getfv))
                   :default-proof
                   (let* ((get1
                           (getf initargs 'default-proof '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :default-proof '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) default-proof getfv))
                   :proofs
                   (let* ((get1 (getf initargs 'proofs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :proofs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) proofs getfv))
                   :origin
                   (let* ((get1 (getf initargs 'origin '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :origin '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) origin getfv))
                   :tcc-disjuncts
                   (let* ((get1
                           (getf initargs 'tcc-disjuncts '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-disjuncts '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-disjuncts getfv))
                   :importing-instance
                   (let* ((get1
                           (getf initargs 'importing-instance
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :importing-instance
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) importing-instance getfv))
                   :theory-instance
                   (let* ((get1
                           (getf initargs 'theory-instance '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :theory-instance
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) theory-instance getfv))
                   :generating-assumption
                   (let* ((get1
                           (getf initargs 'generating-assumption
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :generating-assumption
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         generating-assumption
                       getfv)))))

(defmethod store-object* ((obj assuming-tcc))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs
                     origin tcc-disjuncts importing-instance
                     theory-instance generating-assumption)
    obj
    (reserve-space 26 (push-word (store-obj 'assuming-tcc))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj spelling))
                   (push-word (store-obj definition))
                   (push-word (store-obj kind))
                   (push-word (store-obj default-proof))
                   (push-word (store-obj proofs))
                   (push-word (store-obj origin))
                   (push-word (store-obj tcc-disjuncts))
                   (push-word (store-obj importing-instance))
                   (push-word (store-obj theory-instance))
                   (push-word (store-obj generating-assumption)))))

(defmethod update-fetched ((obj assuming-tcc))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs
                     origin tcc-disjuncts importing-instance
                     theory-instance generating-assumption
                     pvs-sxhash-value tcc-form closed-definition)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf spelling (fetch-obj (stored-word 16)))
    (setf definition (fetch-obj (stored-word 17)))
    (setf kind (fetch-obj (stored-word 18)))
    (setf default-proof (fetch-obj (stored-word 19)))
    (setf proofs (fetch-obj (stored-word 20)))
    (setf origin (fetch-obj (stored-word 21)))
    (setf tcc-disjuncts (fetch-obj (stored-word 22)))
    (setf importing-instance (fetch-obj (stored-word 23)))
    (setf theory-instance (fetch-obj (stored-word 24)))
    (setf generating-assumption (fetch-obj (stored-word 25)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf closed-definition nil)))

(defmethod restore-object* ((obj assuming-tcc))
  (with-slots (unique-id decl-formals formals definition origin
                         importing-instance theory-instance)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      (when origin
        (let ((*restore-object-parent-slot* 'origin))
          (restore-object* origin)))
      (when importing-instance
        (let ((*restore-object-parent-slot* 'importing-instance))
          (restore-object* importing-instance)))
      (when theory-instance
        (let ((*restore-object-parent-slot* 'theory-instance))
          (restore-object* theory-instance)))
      obj)))

(defmethod copy ((obj existence-tcc) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition closed-definition kind
                     default-proof proofs origin tcc-disjuncts
                     importing-instance type)
    obj
    (make-instance 'existence-tcc :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :spelling
                   (let* ((get1 (getf initargs 'spelling '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :spelling '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) spelling getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :closed-definition
                   (let* ((get1
                           (getf initargs 'closed-definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :closed-definition
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) closed-definition getfv))
                   :kind
                   (let* ((get1 (getf initargs 'kind '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :kind '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) kind getfv))
                   :default-proof
                   (let* ((get1
                           (getf initargs 'default-proof '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :default-proof '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) default-proof getfv))
                   :proofs
                   (let* ((get1 (getf initargs 'proofs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :proofs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) proofs getfv))
                   :origin
                   (let* ((get1 (getf initargs 'origin '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :origin '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) origin getfv))
                   :tcc-disjuncts
                   (let* ((get1
                           (getf initargs 'tcc-disjuncts '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-disjuncts '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-disjuncts getfv))
                   :importing-instance
                   (let* ((get1
                           (getf initargs 'importing-instance
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :importing-instance
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) importing-instance getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv)))))

(defmethod store-object* ((obj existence-tcc))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs
                     origin tcc-disjuncts importing-instance type)
    obj
    (reserve-space 25 (push-word (store-obj 'existence-tcc))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj spelling))
                   (push-word (store-obj definition))
                   (push-word (store-obj kind))
                   (push-word (store-obj default-proof))
                   (push-word (store-obj proofs))
                   (push-word (store-obj origin))
                   (push-word (store-obj tcc-disjuncts))
                   (push-word (store-obj importing-instance))
                   (push-word (store-obj type)))))

(defmethod update-fetched ((obj existence-tcc))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs
                     origin tcc-disjuncts importing-instance type
                     pvs-sxhash-value tcc-form closed-definition)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf spelling (fetch-obj (stored-word 16)))
    (setf definition (fetch-obj (stored-word 17)))
    (setf kind (fetch-obj (stored-word 18)))
    (setf default-proof (fetch-obj (stored-word 19)))
    (setf proofs (fetch-obj (stored-word 20)))
    (setf origin (fetch-obj (stored-word 21)))
    (setf tcc-disjuncts (fetch-obj (stored-word 22)))
    (setf importing-instance (fetch-obj (stored-word 23)))
    (setf type (fetch-obj (stored-word 24)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf closed-definition nil)))

(defmethod restore-object* ((obj existence-tcc))
  (with-slots (unique-id decl-formals formals definition origin
                         importing-instance type)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      (when origin
        (let ((*restore-object-parent-slot* 'origin))
          (restore-object* origin)))
      (when importing-instance
        (let ((*restore-object-parent-slot* 'importing-instance))
          (restore-object* importing-instance)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      obj)))

(defmethod copy ((obj recursive-judgement-axiom) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition closed-definition kind
                     default-proof proofs)
    obj
    (make-instance 'recursive-judgement-axiom :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :spelling
                   (let* ((get1 (getf initargs 'spelling '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :spelling '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) spelling getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :closed-definition
                   (let* ((get1
                           (getf initargs 'closed-definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :closed-definition
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) closed-definition getfv))
                   :kind
                   (let* ((get1 (getf initargs 'kind '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :kind '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) kind getfv))
                   :default-proof
                   (let* ((get1
                           (getf initargs 'default-proof '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :default-proof '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) default-proof getfv))
                   :proofs
                   (let* ((get1 (getf initargs 'proofs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :proofs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) proofs getfv)))))

(defmethod store-object* ((obj recursive-judgement-axiom))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs)
    obj
    (reserve-space 21
                   (push-word (store-obj 'recursive-judgement-axiom))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj spelling))
                   (push-word (store-obj definition))
                   (push-word (store-obj kind))
                   (push-word (store-obj default-proof))
                   (push-word (store-obj proofs)))))

(defmethod update-fetched ((obj recursive-judgement-axiom))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs
                     pvs-sxhash-value tcc-form closed-definition)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf spelling (fetch-obj (stored-word 16)))
    (setf definition (fetch-obj (stored-word 17)))
    (setf kind (fetch-obj (stored-word 18)))
    (setf default-proof (fetch-obj (stored-word 19)))
    (setf proofs (fetch-obj (stored-word 20)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf closed-definition nil)))

(defmethod restore-object* ((obj recursive-judgement-axiom))
  (with-slots (unique-id decl-formals formals definition)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      obj)))

(defmethod copy ((obj recursive-judgement-tcc) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition closed-definition kind
                     default-proof proofs origin tcc-disjuncts
                     importing-instance)
    obj
    (make-instance 'recursive-judgement-tcc :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :spelling
                   (let* ((get1 (getf initargs 'spelling '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :spelling '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) spelling getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :closed-definition
                   (let* ((get1
                           (getf initargs 'closed-definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :closed-definition
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) closed-definition getfv))
                   :kind
                   (let* ((get1 (getf initargs 'kind '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :kind '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) kind getfv))
                   :default-proof
                   (let* ((get1
                           (getf initargs 'default-proof '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :default-proof '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) default-proof getfv))
                   :proofs
                   (let* ((get1 (getf initargs 'proofs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :proofs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) proofs getfv))
                   :origin
                   (let* ((get1 (getf initargs 'origin '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :origin '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) origin getfv))
                   :tcc-disjuncts
                   (let* ((get1
                           (getf initargs 'tcc-disjuncts '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-disjuncts '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-disjuncts getfv))
                   :importing-instance
                   (let* ((get1
                           (getf initargs 'importing-instance
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :importing-instance
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         importing-instance
                       getfv)))))

(defmethod store-object* ((obj recursive-judgement-tcc))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs
                     origin tcc-disjuncts importing-instance)
    obj
    (reserve-space 24 (push-word (store-obj 'recursive-judgement-tcc))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj spelling))
                   (push-word (store-obj definition))
                   (push-word (store-obj kind))
                   (push-word (store-obj default-proof))
                   (push-word (store-obj proofs))
                   (push-word (store-obj origin))
                   (push-word (store-obj tcc-disjuncts))
                   (push-word (store-obj importing-instance)))))

(defmethod update-fetched ((obj recursive-judgement-tcc))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs
                     origin tcc-disjuncts importing-instance
                     pvs-sxhash-value tcc-form closed-definition)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf spelling (fetch-obj (stored-word 16)))
    (setf definition (fetch-obj (stored-word 17)))
    (setf kind (fetch-obj (stored-word 18)))
    (setf default-proof (fetch-obj (stored-word 19)))
    (setf proofs (fetch-obj (stored-word 20)))
    (setf origin (fetch-obj (stored-word 21)))
    (setf tcc-disjuncts (fetch-obj (stored-word 22)))
    (setf importing-instance (fetch-obj (stored-word 23)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf closed-definition nil)))

(defmethod restore-object* ((obj recursive-judgement-tcc))
  (with-slots (unique-id decl-formals formals definition origin
                         importing-instance)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      (when origin
        (let ((*restore-object-parent-slot* 'origin))
          (restore-object* origin)))
      (when importing-instance
        (let ((*restore-object-parent-slot* 'importing-instance))
          (restore-object* importing-instance)))
      obj)))

(defmethod copy ((obj judgement-tcc) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition closed-definition kind
                     default-proof proofs origin tcc-disjuncts
                     importing-instance)
    obj
    (make-instance 'judgement-tcc :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :spelling
                   (let* ((get1 (getf initargs 'spelling '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :spelling '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) spelling getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :closed-definition
                   (let* ((get1
                           (getf initargs 'closed-definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :closed-definition
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) closed-definition getfv))
                   :kind
                   (let* ((get1 (getf initargs 'kind '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :kind '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) kind getfv))
                   :default-proof
                   (let* ((get1
                           (getf initargs 'default-proof '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :default-proof '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) default-proof getfv))
                   :proofs
                   (let* ((get1 (getf initargs 'proofs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :proofs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) proofs getfv))
                   :origin
                   (let* ((get1 (getf initargs 'origin '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :origin '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) origin getfv))
                   :tcc-disjuncts
                   (let* ((get1
                           (getf initargs 'tcc-disjuncts '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-disjuncts '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-disjuncts getfv))
                   :importing-instance
                   (let* ((get1
                           (getf initargs 'importing-instance
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :importing-instance
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         importing-instance
                       getfv)))))

(defmethod store-object* ((obj judgement-tcc))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs
                     origin tcc-disjuncts importing-instance)
    obj
    (reserve-space 24 (push-word (store-obj 'judgement-tcc))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj spelling))
                   (push-word (store-obj definition))
                   (push-word (store-obj kind))
                   (push-word (store-obj default-proof))
                   (push-word (store-obj proofs))
                   (push-word (store-obj origin))
                   (push-word (store-obj tcc-disjuncts))
                   (push-word (store-obj importing-instance)))))

(defmethod update-fetched ((obj judgement-tcc))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs
                     origin tcc-disjuncts importing-instance
                     pvs-sxhash-value tcc-form closed-definition)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf spelling (fetch-obj (stored-word 16)))
    (setf definition (fetch-obj (stored-word 17)))
    (setf kind (fetch-obj (stored-word 18)))
    (setf default-proof (fetch-obj (stored-word 19)))
    (setf proofs (fetch-obj (stored-word 20)))
    (setf origin (fetch-obj (stored-word 21)))
    (setf tcc-disjuncts (fetch-obj (stored-word 22)))
    (setf importing-instance (fetch-obj (stored-word 23)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf closed-definition nil)))

(defmethod restore-object* ((obj judgement-tcc))
  (with-slots (unique-id decl-formals formals definition origin
                         importing-instance)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      (when origin
        (let ((*restore-object-parent-slot* 'origin))
          (restore-object* origin)))
      (when importing-instance
        (let ((*restore-object-parent-slot* 'importing-instance))
          (restore-object* importing-instance)))
      obj)))

(defmethod copy ((obj termination-tcc) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition closed-definition kind
                     default-proof proofs origin tcc-disjuncts
                     importing-instance)
    obj
    (make-instance 'termination-tcc :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :spelling
                   (let* ((get1 (getf initargs 'spelling '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :spelling '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) spelling getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :closed-definition
                   (let* ((get1
                           (getf initargs 'closed-definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :closed-definition
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) closed-definition getfv))
                   :kind
                   (let* ((get1 (getf initargs 'kind '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :kind '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) kind getfv))
                   :default-proof
                   (let* ((get1
                           (getf initargs 'default-proof '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :default-proof '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) default-proof getfv))
                   :proofs
                   (let* ((get1 (getf initargs 'proofs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :proofs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) proofs getfv))
                   :origin
                   (let* ((get1 (getf initargs 'origin '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :origin '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) origin getfv))
                   :tcc-disjuncts
                   (let* ((get1
                           (getf initargs 'tcc-disjuncts '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-disjuncts '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-disjuncts getfv))
                   :importing-instance
                   (let* ((get1
                           (getf initargs 'importing-instance
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :importing-instance
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         importing-instance
                       getfv)))))

(defmethod store-object* ((obj termination-tcc))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs
                     origin tcc-disjuncts importing-instance)
    obj
    (reserve-space 24 (push-word (store-obj 'termination-tcc))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj spelling))
                   (push-word (store-obj definition))
                   (push-word (store-obj kind))
                   (push-word (store-obj default-proof))
                   (push-word (store-obj proofs))
                   (push-word (store-obj origin))
                   (push-word (store-obj tcc-disjuncts))
                   (push-word (store-obj importing-instance)))))

(defmethod update-fetched ((obj termination-tcc))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs
                     origin tcc-disjuncts importing-instance
                     pvs-sxhash-value tcc-form closed-definition)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf spelling (fetch-obj (stored-word 16)))
    (setf definition (fetch-obj (stored-word 17)))
    (setf kind (fetch-obj (stored-word 18)))
    (setf default-proof (fetch-obj (stored-word 19)))
    (setf proofs (fetch-obj (stored-word 20)))
    (setf origin (fetch-obj (stored-word 21)))
    (setf tcc-disjuncts (fetch-obj (stored-word 22)))
    (setf importing-instance (fetch-obj (stored-word 23)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf closed-definition nil)))

(defmethod restore-object* ((obj termination-tcc))
  (with-slots (unique-id decl-formals formals definition origin
                         importing-instance)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      (when origin
        (let ((*restore-object-parent-slot* 'origin))
          (restore-object* origin)))
      (when importing-instance
        (let ((*restore-object-parent-slot* 'importing-instance))
          (restore-object* importing-instance)))
      obj)))

(defmethod copy ((obj subtype-tcc) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition closed-definition kind
                     default-proof proofs origin tcc-disjuncts
                     importing-instance)
    obj
    (make-instance 'subtype-tcc :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :spelling
                   (let* ((get1 (getf initargs 'spelling '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :spelling '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) spelling getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :closed-definition
                   (let* ((get1
                           (getf initargs 'closed-definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :closed-definition
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) closed-definition getfv))
                   :kind
                   (let* ((get1 (getf initargs 'kind '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :kind '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) kind getfv))
                   :default-proof
                   (let* ((get1
                           (getf initargs 'default-proof '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :default-proof '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) default-proof getfv))
                   :proofs
                   (let* ((get1 (getf initargs 'proofs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :proofs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) proofs getfv))
                   :origin
                   (let* ((get1 (getf initargs 'origin '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :origin '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) origin getfv))
                   :tcc-disjuncts
                   (let* ((get1
                           (getf initargs 'tcc-disjuncts '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-disjuncts '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-disjuncts getfv))
                   :importing-instance
                   (let* ((get1
                           (getf initargs 'importing-instance
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :importing-instance
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         importing-instance
                       getfv)))))

(defmethod store-object* ((obj subtype-tcc))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs
                     origin tcc-disjuncts importing-instance)
    obj
    (reserve-space 24 (push-word (store-obj 'subtype-tcc))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj spelling))
                   (push-word (store-obj definition))
                   (push-word (store-obj kind))
                   (push-word (store-obj default-proof))
                   (push-word (store-obj proofs))
                   (push-word (store-obj origin))
                   (push-word (store-obj tcc-disjuncts))
                   (push-word (store-obj importing-instance)))))

(defmethod update-fetched ((obj subtype-tcc))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs
                     origin tcc-disjuncts importing-instance
                     pvs-sxhash-value tcc-form closed-definition)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf spelling (fetch-obj (stored-word 16)))
    (setf definition (fetch-obj (stored-word 17)))
    (setf kind (fetch-obj (stored-word 18)))
    (setf default-proof (fetch-obj (stored-word 19)))
    (setf proofs (fetch-obj (stored-word 20)))
    (setf origin (fetch-obj (stored-word 21)))
    (setf tcc-disjuncts (fetch-obj (stored-word 22)))
    (setf importing-instance (fetch-obj (stored-word 23)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf closed-definition nil)))

(defmethod restore-object* ((obj subtype-tcc))
  (with-slots (unique-id decl-formals formals definition origin
                         importing-instance)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      (when origin
        (let ((*restore-object-parent-slot* 'origin))
          (restore-object* origin)))
      (when importing-instance
        (let ((*restore-object-parent-slot* 'importing-instance))
          (restore-object* importing-instance)))
      obj)))

(defmethod copy ((obj mapped-tcc-decl) &rest initargs)
  (with-slots (from-formula place unique-id newline-comment id
                            decl-formals formals module refers-to
                            chain? typechecked? visible? generated
                            generated-by semi typecheck-time spelling
                            definition closed-definition kind
                            default-proof proofs origin tcc-disjuncts
                            importing-instance)
    obj
    (make-instance 'mapped-tcc-decl :from-formula
                   (let* ((get1 (getf initargs 'from-formula '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :from-formula '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-formula getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :spelling
                   (let* ((get1 (getf initargs 'spelling '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :spelling '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) spelling getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :closed-definition
                   (let* ((get1
                           (getf initargs 'closed-definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :closed-definition
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) closed-definition getfv))
                   :kind
                   (let* ((get1 (getf initargs 'kind '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :kind '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) kind getfv))
                   :default-proof
                   (let* ((get1
                           (getf initargs 'default-proof '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :default-proof '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) default-proof getfv))
                   :proofs
                   (let* ((get1 (getf initargs 'proofs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :proofs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) proofs getfv))
                   :origin
                   (let* ((get1 (getf initargs 'origin '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :origin '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) origin getfv))
                   :tcc-disjuncts
                   (let* ((get1
                           (getf initargs 'tcc-disjuncts '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-disjuncts '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-disjuncts getfv))
                   :importing-instance
                   (let* ((get1
                           (getf initargs 'importing-instance
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :importing-instance
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         importing-instance
                       getfv)))))

(defmethod store-object* ((obj mapped-tcc-decl))
  (with-slots (from-formula place unique-id newline-comment id
                            decl-formals formals module refers-to
                            chain? typechecked? visible? generated
                            generated-by semi typecheck-time spelling
                            definition kind default-proof proofs origin
                            tcc-disjuncts importing-instance)
    obj
    (reserve-space 25 (push-word (store-obj 'mapped-tcc-decl))
                   (push-word (store-obj from-formula))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj spelling))
                   (push-word (store-obj definition))
                   (push-word (store-obj kind))
                   (push-word (store-obj default-proof))
                   (push-word (store-obj proofs))
                   (push-word (store-obj origin))
                   (push-word (store-obj tcc-disjuncts))
                   (push-word (store-obj importing-instance)))))

(defmethod update-fetched ((obj mapped-tcc-decl))
  (with-slots (from-formula place unique-id newline-comment id
                            decl-formals formals module refers-to
                            chain? typechecked? visible? generated
                            generated-by semi typecheck-time spelling
                            definition kind default-proof proofs origin
                            tcc-disjuncts importing-instance
                            pvs-sxhash-value tcc-form
                            closed-definition)
    obj
    (setf from-formula (fetch-obj (stored-word 1)))
    (setf place (fetch-obj (stored-word 2)))
    (setf unique-id (fetch-obj (stored-word 3)))
    (setf newline-comment (fetch-obj (stored-word 4)))
    (setf id (fetch-obj (stored-word 5)))
    (setf decl-formals (fetch-obj (stored-word 6)))
    (setf formals (fetch-obj (stored-word 7)))
    (setf module (fetch-obj (stored-word 8)))
    (setf refers-to (fetch-obj (stored-word 9)))
    (setf chain? (fetch-obj (stored-word 10)))
    (setf typechecked? (fetch-obj (stored-word 11)))
    (setf visible? (fetch-obj (stored-word 12)))
    (setf generated (fetch-obj (stored-word 13)))
    (setf generated-by (fetch-obj (stored-word 14)))
    (setf semi (fetch-obj (stored-word 15)))
    (setf typecheck-time (fetch-obj (stored-word 16)))
    (setf spelling (fetch-obj (stored-word 17)))
    (setf definition (fetch-obj (stored-word 18)))
    (setf kind (fetch-obj (stored-word 19)))
    (setf default-proof (fetch-obj (stored-word 20)))
    (setf proofs (fetch-obj (stored-word 21)))
    (setf origin (fetch-obj (stored-word 22)))
    (setf tcc-disjuncts (fetch-obj (stored-word 23)))
    (setf importing-instance (fetch-obj (stored-word 24)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf closed-definition nil)))

(defmethod restore-object* ((obj mapped-tcc-decl))
  (with-slots (from-formula unique-id decl-formals formals definition
                            origin importing-instance)
    obj
    (let ((*restore-object-parent* obj))
      (when from-formula
        (let ((*restore-object-parent-slot* 'from-formula))
          (restore-object* from-formula)))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      (when origin
        (let ((*restore-object-parent-slot* 'origin))
          (restore-object* origin)))
      (when importing-instance
        (let ((*restore-object-parent-slot* 'importing-instance))
          (restore-object* importing-instance)))
      obj)))

(defmethod copy ((obj mapped-assuming-decl) &rest initargs)
  (with-slots (from-formula place unique-id newline-comment id
                            decl-formals formals module refers-to
                            chain? typechecked? visible? generated
                            generated-by semi typecheck-time spelling
                            definition closed-definition kind
                            default-proof proofs original-definition)
    obj
    (make-instance 'mapped-assuming-decl :from-formula
                   (let* ((get1 (getf initargs 'from-formula '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :from-formula '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-formula getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :spelling
                   (let* ((get1 (getf initargs 'spelling '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :spelling '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) spelling getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :closed-definition
                   (let* ((get1
                           (getf initargs 'closed-definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :closed-definition
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) closed-definition getfv))
                   :kind
                   (let* ((get1 (getf initargs 'kind '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :kind '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) kind getfv))
                   :default-proof
                   (let* ((get1
                           (getf initargs 'default-proof '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :default-proof '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) default-proof getfv))
                   :proofs
                   (let* ((get1 (getf initargs 'proofs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :proofs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) proofs getfv))
                   :original-definition
                   (let* ((get1
                           (getf initargs 'original-definition
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :original-definition
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         original-definition
                       getfv)))))

(defmethod store-object* ((obj mapped-assuming-decl))
  (with-slots (from-formula place unique-id newline-comment id
                            decl-formals formals module refers-to
                            chain? typechecked? visible? generated
                            generated-by semi typecheck-time spelling
                            definition kind default-proof proofs
                            original-definition)
    obj
    (reserve-space 23 (push-word (store-obj 'mapped-assuming-decl))
                   (push-word (store-obj from-formula))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj spelling))
                   (push-word (store-obj definition))
                   (push-word (store-obj kind))
                   (push-word (store-obj default-proof))
                   (push-word (store-obj proofs))
                   (push-word (store-obj original-definition)))))

(defmethod update-fetched ((obj mapped-assuming-decl))
  (with-slots (from-formula place unique-id newline-comment id
                            decl-formals formals module refers-to
                            chain? typechecked? visible? generated
                            generated-by semi typecheck-time spelling
                            definition kind default-proof proofs
                            original-definition pvs-sxhash-value
                            tcc-form closed-definition)
    obj
    (setf from-formula (fetch-obj (stored-word 1)))
    (setf place (fetch-obj (stored-word 2)))
    (setf unique-id (fetch-obj (stored-word 3)))
    (setf newline-comment (fetch-obj (stored-word 4)))
    (setf id (fetch-obj (stored-word 5)))
    (setf decl-formals (fetch-obj (stored-word 6)))
    (setf formals (fetch-obj (stored-word 7)))
    (setf module (fetch-obj (stored-word 8)))
    (setf refers-to (fetch-obj (stored-word 9)))
    (setf chain? (fetch-obj (stored-word 10)))
    (setf typechecked? (fetch-obj (stored-word 11)))
    (setf visible? (fetch-obj (stored-word 12)))
    (setf generated (fetch-obj (stored-word 13)))
    (setf generated-by (fetch-obj (stored-word 14)))
    (setf semi (fetch-obj (stored-word 15)))
    (setf typecheck-time (fetch-obj (stored-word 16)))
    (setf spelling (fetch-obj (stored-word 17)))
    (setf definition (fetch-obj (stored-word 18)))
    (setf kind (fetch-obj (stored-word 19)))
    (setf default-proof (fetch-obj (stored-word 20)))
    (setf proofs (fetch-obj (stored-word 21)))
    (setf original-definition (fetch-obj (stored-word 22)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf closed-definition nil)))

(defmethod restore-object* ((obj mapped-assuming-decl))
  (with-slots (from-formula unique-id decl-formals formals definition
                            original-definition)
    obj
    (let ((*restore-object-parent* obj))
      (when from-formula
        (let ((*restore-object-parent-slot* 'from-formula))
          (restore-object* from-formula)))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      (when original-definition
        (let ((*restore-object-parent-slot* 'original-definition))
          (restore-object* original-definition)))
      obj)))

(defmethod copy ((obj mapped-formula-decl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition closed-definition kind
                     default-proof proofs from-formula)
    obj
    (make-instance 'mapped-formula-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :spelling
                   (let* ((get1 (getf initargs 'spelling '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :spelling '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) spelling getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :closed-definition
                   (let* ((get1
                           (getf initargs 'closed-definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :closed-definition
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) closed-definition getfv))
                   :kind
                   (let* ((get1 (getf initargs 'kind '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :kind '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) kind getfv))
                   :default-proof
                   (let* ((get1
                           (getf initargs 'default-proof '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :default-proof '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) default-proof getfv))
                   :proofs
                   (let* ((get1 (getf initargs 'proofs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :proofs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) proofs getfv))
                   :from-formula
                   (let* ((get1 (getf initargs 'from-formula '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :from-formula '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-formula getfv)))))

(defmethod store-object* ((obj mapped-formula-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs
                     from-formula)
    obj
    (reserve-space 22 (push-word (store-obj 'mapped-formula-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj spelling))
                   (push-word (store-obj definition))
                   (push-word (store-obj kind))
                   (push-word (store-obj default-proof))
                   (push-word (store-obj proofs))
                   (push-word (store-obj from-formula)))))

(defmethod update-fetched ((obj mapped-formula-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs
                     from-formula pvs-sxhash-value tcc-form
                     closed-definition)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf spelling (fetch-obj (stored-word 16)))
    (setf definition (fetch-obj (stored-word 17)))
    (setf kind (fetch-obj (stored-word 18)))
    (setf default-proof (fetch-obj (stored-word 19)))
    (setf proofs (fetch-obj (stored-word 20)))
    (setf from-formula (fetch-obj (stored-word 21)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf closed-definition nil)))

(defmethod restore-object* ((obj mapped-formula-decl))
  (with-slots (unique-id decl-formals formals definition from-formula)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      (when from-formula
        (let ((*restore-object-parent-slot* 'from-formula))
          (restore-object* from-formula)))
      obj)))

(defmethod copy ((obj tcc-decl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition closed-definition kind
                     default-proof proofs origin tcc-disjuncts
                     importing-instance)
    obj
    (make-instance 'tcc-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :spelling
                   (let* ((get1 (getf initargs 'spelling '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :spelling '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) spelling getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :closed-definition
                   (let* ((get1
                           (getf initargs 'closed-definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :closed-definition
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) closed-definition getfv))
                   :kind
                   (let* ((get1 (getf initargs 'kind '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :kind '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) kind getfv))
                   :default-proof
                   (let* ((get1
                           (getf initargs 'default-proof '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :default-proof '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) default-proof getfv))
                   :proofs
                   (let* ((get1 (getf initargs 'proofs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :proofs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) proofs getfv))
                   :origin
                   (let* ((get1 (getf initargs 'origin '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :origin '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) origin getfv))
                   :tcc-disjuncts
                   (let* ((get1
                           (getf initargs 'tcc-disjuncts '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-disjuncts '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-disjuncts getfv))
                   :importing-instance
                   (let* ((get1
                           (getf initargs 'importing-instance
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :importing-instance
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         importing-instance
                       getfv)))))

(defmethod store-object* ((obj tcc-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs
                     origin tcc-disjuncts importing-instance)
    obj
    (reserve-space 24 (push-word (store-obj 'tcc-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj spelling))
                   (push-word (store-obj definition))
                   (push-word (store-obj kind))
                   (push-word (store-obj default-proof))
                   (push-word (store-obj proofs))
                   (push-word (store-obj origin))
                   (push-word (store-obj tcc-disjuncts))
                   (push-word (store-obj importing-instance)))))

(defmethod update-fetched ((obj tcc-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs
                     origin tcc-disjuncts importing-instance
                     pvs-sxhash-value tcc-form closed-definition)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf spelling (fetch-obj (stored-word 16)))
    (setf definition (fetch-obj (stored-word 17)))
    (setf kind (fetch-obj (stored-word 18)))
    (setf default-proof (fetch-obj (stored-word 19)))
    (setf proofs (fetch-obj (stored-word 20)))
    (setf origin (fetch-obj (stored-word 21)))
    (setf tcc-disjuncts (fetch-obj (stored-word 22)))
    (setf importing-instance (fetch-obj (stored-word 23)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf closed-definition nil)))

(defmethod restore-object* ((obj tcc-decl))
  (with-slots (unique-id decl-formals formals definition origin
                         importing-instance)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      (when origin
        (let ((*restore-object-parent-slot* 'origin))
          (restore-object* origin)))
      (when importing-instance
        (let ((*restore-object-parent-slot* 'importing-instance))
          (restore-object* importing-instance)))
      obj)))

(defmethod copy ((obj assuming-decl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition closed-definition kind
                     default-proof proofs original-definition)
    obj
    (make-instance 'assuming-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :spelling
                   (let* ((get1 (getf initargs 'spelling '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :spelling '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) spelling getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :closed-definition
                   (let* ((get1
                           (getf initargs 'closed-definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :closed-definition
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) closed-definition getfv))
                   :kind
                   (let* ((get1 (getf initargs 'kind '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :kind '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) kind getfv))
                   :default-proof
                   (let* ((get1
                           (getf initargs 'default-proof '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :default-proof '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) default-proof getfv))
                   :proofs
                   (let* ((get1 (getf initargs 'proofs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :proofs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) proofs getfv))
                   :original-definition
                   (let* ((get1
                           (getf initargs 'original-definition
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :original-definition
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         original-definition
                       getfv)))))

(defmethod store-object* ((obj assuming-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs
                     original-definition)
    obj
    (reserve-space 22 (push-word (store-obj 'assuming-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj spelling))
                   (push-word (store-obj definition))
                   (push-word (store-obj kind))
                   (push-word (store-obj default-proof))
                   (push-word (store-obj proofs))
                   (push-word (store-obj original-definition)))))

(defmethod update-fetched ((obj assuming-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs
                     original-definition pvs-sxhash-value tcc-form
                     closed-definition)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf spelling (fetch-obj (stored-word 16)))
    (setf definition (fetch-obj (stored-word 17)))
    (setf kind (fetch-obj (stored-word 18)))
    (setf default-proof (fetch-obj (stored-word 19)))
    (setf proofs (fetch-obj (stored-word 20)))
    (setf original-definition (fetch-obj (stored-word 21)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf closed-definition nil)))

(defmethod restore-object* ((obj assuming-decl))
  (with-slots (unique-id decl-formals formals definition
                         original-definition)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      (when original-definition
        (let ((*restore-object-parent-slot* 'original-definition))
          (restore-object* original-definition)))
      obj)))

(defmethod copy ((obj formula-decl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition closed-definition kind
                     default-proof proofs)
    obj
    (make-instance 'formula-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :spelling
                   (let* ((get1 (getf initargs 'spelling '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :spelling '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) spelling getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :closed-definition
                   (let* ((get1
                           (getf initargs 'closed-definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :closed-definition
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) closed-definition getfv))
                   :kind
                   (let* ((get1 (getf initargs 'kind '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :kind '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) kind getfv))
                   :default-proof
                   (let* ((get1
                           (getf initargs 'default-proof '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :default-proof '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) default-proof getfv))
                   :proofs
                   (let* ((get1 (getf initargs 'proofs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :proofs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) proofs getfv)))))

(defmethod store-object* ((obj formula-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs)
    obj
    (reserve-space 21 (push-word (store-obj 'formula-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj spelling))
                   (push-word (store-obj definition))
                   (push-word (store-obj kind))
                   (push-word (store-obj default-proof))
                   (push-word (store-obj proofs)))))

(defmethod update-fetched ((obj formula-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     spelling definition kind default-proof proofs
                     pvs-sxhash-value tcc-form closed-definition)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf spelling (fetch-obj (stored-word 16)))
    (setf definition (fetch-obj (stored-word 17)))
    (setf kind (fetch-obj (stored-word 18)))
    (setf default-proof (fetch-obj (stored-word 19)))
    (setf proofs (fetch-obj (stored-word 20)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf closed-definition nil)))

(defmethod restore-object* ((obj formula-decl))
  (with-slots (unique-id decl-formals formals definition)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      obj)))

(defmethod copy ((obj coinductive-decl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type declared-type-string type definition
                     def-axiom positive-types eval-info)
    obj
    (make-instance 'coinductive-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :def-axiom
                   (let* ((get1 (getf initargs 'def-axiom '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :def-axiom '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) def-axiom getfv))
                   :positive-types
                   (let* ((get1
                           (getf initargs 'positive-types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :positive-types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) positive-types getfv))
                   :eval-info
                   (let* ((get1 (getf initargs 'eval-info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :eval-info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) eval-info getfv)))))

(defmethod store-object* ((obj coinductive-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type definition def-axiom
                     positive-types)
    obj
    (reserve-space 21 (push-word (store-obj 'coinductive-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj definition))
                   (push-word (store-obj def-axiom))
                   (push-word (store-obj positive-types)))))

(defmethod update-fetched ((obj coinductive-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type definition def-axiom
                     positive-types pvs-sxhash-value tcc-form
                     declared-type-string eval-info)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf declared-type (fetch-obj (stored-word 16)))
    (setf type (fetch-obj (stored-word 17)))
    (setf definition (fetch-obj (stored-word 18)))
    (setf def-axiom (fetch-obj (stored-word 19)))
    (setf positive-types (fetch-obj (stored-word 20)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf declared-type-string nil)
    (setf eval-info nil)))

(defmethod restore-object* ((obj coinductive-decl))
  (with-slots (unique-id decl-formals formals declared-type type
                         definition def-axiom positive-types)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      (when def-axiom
        (let ((*restore-object-parent-slot* 'def-axiom))
          (restore-object* def-axiom)))
      (when positive-types
        (let ((*restore-object-parent-slot* 'positive-types))
          (restore-object* positive-types)))
      obj)))

(defmethod copy ((obj corecursive-decl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type declared-type-string type definition
                     def-axiom positive-types eval-info)
    obj
    (make-instance 'corecursive-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :def-axiom
                   (let* ((get1 (getf initargs 'def-axiom '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :def-axiom '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) def-axiom getfv))
                   :positive-types
                   (let* ((get1
                           (getf initargs 'positive-types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :positive-types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) positive-types getfv))
                   :eval-info
                   (let* ((get1 (getf initargs 'eval-info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :eval-info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) eval-info getfv)))))

(defmethod store-object* ((obj corecursive-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type definition def-axiom
                     positive-types)
    obj
    (reserve-space 21 (push-word (store-obj 'corecursive-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj definition))
                   (push-word (store-obj def-axiom))
                   (push-word (store-obj positive-types)))))

(defmethod update-fetched ((obj corecursive-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type definition def-axiom
                     positive-types pvs-sxhash-value tcc-form
                     declared-type-string eval-info)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf declared-type (fetch-obj (stored-word 16)))
    (setf type (fetch-obj (stored-word 17)))
    (setf definition (fetch-obj (stored-word 18)))
    (setf def-axiom (fetch-obj (stored-word 19)))
    (setf positive-types (fetch-obj (stored-word 20)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf declared-type-string nil)
    (setf eval-info nil)))

(defmethod restore-object* ((obj corecursive-decl))
  (with-slots (unique-id decl-formals formals declared-type type
                         definition def-axiom positive-types)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      (when def-axiom
        (let ((*restore-object-parent-slot* 'def-axiom))
          (restore-object* def-axiom)))
      (when positive-types
        (let ((*restore-object-parent-slot* 'positive-types))
          (restore-object* positive-types)))
      obj)))

(defmethod copy ((obj adt-def-decl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type declared-type-string type definition
                     def-axiom positive-types eval-info
                     declared-measure ordering measure measure-depth
                     recursive-signature)
    obj
    (make-instance 'adt-def-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :def-axiom
                   (let* ((get1 (getf initargs 'def-axiom '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :def-axiom '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) def-axiom getfv))
                   :positive-types
                   (let* ((get1
                           (getf initargs 'positive-types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :positive-types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) positive-types getfv))
                   :eval-info
                   (let* ((get1 (getf initargs 'eval-info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :eval-info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) eval-info getfv))
                   :declared-measure
                   (let* ((get1
                           (getf initargs 'declared-measure '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-measure
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-measure getfv))
                   :ordering
                   (let* ((get1 (getf initargs 'ordering '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ordering '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ordering getfv))
                   :measure
                   (let* ((get1 (getf initargs 'measure '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :measure '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) measure getfv))
                   :measure-depth
                   (let* ((get1
                           (getf initargs 'measure-depth '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :measure-depth '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) measure-depth getfv))
                   :recursive-signature
                   (let* ((get1
                           (getf initargs 'recursive-signature
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :recursive-signature
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         recursive-signature
                       getfv)))))

(defmethod store-object* ((obj adt-def-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type definition def-axiom
                     positive-types declared-measure ordering measure
                     measure-depth recursive-signature)
    obj
    (reserve-space 26 (push-word (store-obj 'adt-def-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj definition))
                   (push-word (store-obj def-axiom))
                   (push-word (store-obj positive-types))
                   (push-word (store-obj declared-measure))
                   (push-word (store-obj ordering))
                   (push-word (store-obj measure))
                   (push-word (store-obj measure-depth))
                   (push-word (store-obj recursive-signature)))))

(defmethod update-fetched ((obj adt-def-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type definition def-axiom
                     positive-types declared-measure ordering measure
                     measure-depth recursive-signature pvs-sxhash-value
                     tcc-form declared-type-string eval-info)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf declared-type (fetch-obj (stored-word 16)))
    (setf type (fetch-obj (stored-word 17)))
    (setf definition (fetch-obj (stored-word 18)))
    (setf def-axiom (fetch-obj (stored-word 19)))
    (setf positive-types (fetch-obj (stored-word 20)))
    (setf declared-measure (fetch-obj (stored-word 21)))
    (setf ordering (fetch-obj (stored-word 22)))
    (setf measure (fetch-obj (stored-word 23)))
    (setf measure-depth (fetch-obj (stored-word 24)))
    (setf recursive-signature (fetch-obj (stored-word 25)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf declared-type-string nil)
    (setf eval-info nil)))

(defmethod restore-object* ((obj adt-def-decl))
  (with-slots (unique-id decl-formals formals declared-type type
                         definition def-axiom positive-types
                         declared-measure ordering measure
                         recursive-signature)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      (when def-axiom
        (let ((*restore-object-parent-slot* 'def-axiom))
          (restore-object* def-axiom)))
      (when positive-types
        (let ((*restore-object-parent-slot* 'positive-types))
          (restore-object* positive-types)))
      (when declared-measure
        (let ((*restore-object-parent-slot* 'declared-measure))
          (restore-object* declared-measure)))
      (when ordering
        (let ((*restore-object-parent-slot* 'ordering))
          (restore-object* ordering)))
      (when measure
        (let ((*restore-object-parent-slot* 'measure))
          (restore-object* measure)))
      (when recursive-signature
        (let ((*restore-object-parent-slot* 'recursive-signature))
          (restore-object* recursive-signature)))
      obj)))

(defmethod copy ((obj inductive-decl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type declared-type-string type definition
                     def-axiom positive-types eval-info)
    obj
    (make-instance 'inductive-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :def-axiom
                   (let* ((get1 (getf initargs 'def-axiom '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :def-axiom '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) def-axiom getfv))
                   :positive-types
                   (let* ((get1
                           (getf initargs 'positive-types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :positive-types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) positive-types getfv))
                   :eval-info
                   (let* ((get1 (getf initargs 'eval-info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :eval-info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) eval-info getfv)))))

(defmethod store-object* ((obj inductive-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type definition def-axiom
                     positive-types)
    obj
    (reserve-space 21 (push-word (store-obj 'inductive-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj definition))
                   (push-word (store-obj def-axiom))
                   (push-word (store-obj positive-types)))))

(defmethod update-fetched ((obj inductive-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type definition def-axiom
                     positive-types pvs-sxhash-value tcc-form
                     declared-type-string eval-info)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf declared-type (fetch-obj (stored-word 16)))
    (setf type (fetch-obj (stored-word 17)))
    (setf definition (fetch-obj (stored-word 18)))
    (setf def-axiom (fetch-obj (stored-word 19)))
    (setf positive-types (fetch-obj (stored-word 20)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf declared-type-string nil)
    (setf eval-info nil)))

(defmethod restore-object* ((obj inductive-decl))
  (with-slots (unique-id decl-formals formals declared-type type
                         definition def-axiom positive-types)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      (when def-axiom
        (let ((*restore-object-parent-slot* 'def-axiom))
          (restore-object* def-axiom)))
      (when positive-types
        (let ((*restore-object-parent-slot* 'positive-types))
          (restore-object* positive-types)))
      obj)))

(defmethod copy ((obj fixpoint-decl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type declared-type-string type definition
                     def-axiom positive-types eval-info)
    obj
    (make-instance 'fixpoint-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :def-axiom
                   (let* ((get1 (getf initargs 'def-axiom '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :def-axiom '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) def-axiom getfv))
                   :positive-types
                   (let* ((get1
                           (getf initargs 'positive-types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :positive-types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) positive-types getfv))
                   :eval-info
                   (let* ((get1 (getf initargs 'eval-info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :eval-info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) eval-info getfv)))))

(defmethod store-object* ((obj fixpoint-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type definition def-axiom
                     positive-types)
    obj
    (reserve-space 21 (push-word (store-obj 'fixpoint-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj definition))
                   (push-word (store-obj def-axiom))
                   (push-word (store-obj positive-types)))))

(defmethod update-fetched ((obj fixpoint-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type definition def-axiom
                     positive-types pvs-sxhash-value tcc-form
                     declared-type-string eval-info)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf declared-type (fetch-obj (stored-word 16)))
    (setf type (fetch-obj (stored-word 17)))
    (setf definition (fetch-obj (stored-word 18)))
    (setf def-axiom (fetch-obj (stored-word 19)))
    (setf positive-types (fetch-obj (stored-word 20)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf declared-type-string nil)
    (setf eval-info nil)))

(defmethod restore-object* ((obj fixpoint-decl))
  (with-slots (unique-id decl-formals formals declared-type type
                         definition def-axiom positive-types)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      (when def-axiom
        (let ((*restore-object-parent-slot* 'def-axiom))
          (restore-object* def-axiom)))
      (when positive-types
        (let ((*restore-object-parent-slot* 'positive-types))
          (restore-object* positive-types)))
      obj)))

(defmethod copy ((obj def-decl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type declared-type-string type definition
                     def-axiom positive-types eval-info
                     declared-measure ordering measure measure-depth
                     recursive-signature)
    obj
    (make-instance 'def-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :def-axiom
                   (let* ((get1 (getf initargs 'def-axiom '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :def-axiom '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) def-axiom getfv))
                   :positive-types
                   (let* ((get1
                           (getf initargs 'positive-types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :positive-types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) positive-types getfv))
                   :eval-info
                   (let* ((get1 (getf initargs 'eval-info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :eval-info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) eval-info getfv))
                   :declared-measure
                   (let* ((get1
                           (getf initargs 'declared-measure '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-measure
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-measure getfv))
                   :ordering
                   (let* ((get1 (getf initargs 'ordering '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ordering '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ordering getfv))
                   :measure
                   (let* ((get1 (getf initargs 'measure '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :measure '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) measure getfv))
                   :measure-depth
                   (let* ((get1
                           (getf initargs 'measure-depth '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :measure-depth '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) measure-depth getfv))
                   :recursive-signature
                   (let* ((get1
                           (getf initargs 'recursive-signature
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :recursive-signature
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         recursive-signature
                       getfv)))))

(defmethod store-object* ((obj def-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type definition def-axiom
                     positive-types declared-measure ordering measure
                     measure-depth recursive-signature)
    obj
    (reserve-space 26 (push-word (store-obj 'def-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj definition))
                   (push-word (store-obj def-axiom))
                   (push-word (store-obj positive-types))
                   (push-word (store-obj declared-measure))
                   (push-word (store-obj ordering))
                   (push-word (store-obj measure))
                   (push-word (store-obj measure-depth))
                   (push-word (store-obj recursive-signature)))))

(defmethod update-fetched ((obj def-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type definition def-axiom
                     positive-types declared-measure ordering measure
                     measure-depth recursive-signature pvs-sxhash-value
                     tcc-form declared-type-string eval-info)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf declared-type (fetch-obj (stored-word 16)))
    (setf type (fetch-obj (stored-word 17)))
    (setf definition (fetch-obj (stored-word 18)))
    (setf def-axiom (fetch-obj (stored-word 19)))
    (setf positive-types (fetch-obj (stored-word 20)))
    (setf declared-measure (fetch-obj (stored-word 21)))
    (setf ordering (fetch-obj (stored-word 22)))
    (setf measure (fetch-obj (stored-word 23)))
    (setf measure-depth (fetch-obj (stored-word 24)))
    (setf recursive-signature (fetch-obj (stored-word 25)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf declared-type-string nil)
    (setf eval-info nil)))

(defmethod restore-object* ((obj def-decl))
  (with-slots (unique-id decl-formals formals declared-type type
                         definition def-axiom positive-types
                         declared-measure ordering measure
                         recursive-signature)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      (when def-axiom
        (let ((*restore-object-parent-slot* 'def-axiom))
          (restore-object* def-axiom)))
      (when positive-types
        (let ((*restore-object-parent-slot* 'positive-types))
          (restore-object* positive-types)))
      (when declared-measure
        (let ((*restore-object-parent-slot* 'declared-measure))
          (restore-object* declared-measure)))
      (when ordering
        (let ((*restore-object-parent-slot* 'ordering))
          (restore-object* ordering)))
      (when measure
        (let ((*restore-object-parent-slot* 'measure))
          (restore-object* measure)))
      (when recursive-signature
        (let ((*restore-object-parent-slot* 'recursive-signature))
          (restore-object* recursive-signature)))
      obj)))

(defmethod copy ((obj shared-adt-accessor-decl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type declared-type-string type definition
                     def-axiom positive-types eval-info constructors)
    obj
    (make-instance 'shared-adt-accessor-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :def-axiom
                   (let* ((get1 (getf initargs 'def-axiom '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :def-axiom '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) def-axiom getfv))
                   :positive-types
                   (let* ((get1
                           (getf initargs 'positive-types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :positive-types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) positive-types getfv))
                   :eval-info
                   (let* ((get1 (getf initargs 'eval-info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :eval-info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) eval-info getfv))
                   :constructors
                   (let* ((get1 (getf initargs 'constructors '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :constructors '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) constructors getfv)))))

(defmethod store-object* ((obj shared-adt-accessor-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type definition def-axiom
                     positive-types constructors)
    obj
    (reserve-space 22 (push-word (store-obj 'shared-adt-accessor-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj definition))
                   (push-word (store-obj def-axiom))
                   (push-word (store-obj positive-types))
                   (push-word (store-obj constructors)))))

(defmethod update-fetched ((obj shared-adt-accessor-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type definition def-axiom
                     positive-types constructors pvs-sxhash-value
                     tcc-form declared-type-string eval-info)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf declared-type (fetch-obj (stored-word 16)))
    (setf type (fetch-obj (stored-word 17)))
    (setf definition (fetch-obj (stored-word 18)))
    (setf def-axiom (fetch-obj (stored-word 19)))
    (setf positive-types (fetch-obj (stored-word 20)))
    (setf constructors (fetch-obj (stored-word 21)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf declared-type-string nil)
    (setf eval-info nil)))

(defmethod restore-object* ((obj shared-adt-accessor-decl))
  (with-slots (unique-id decl-formals formals declared-type type
                         definition def-axiom positive-types
                         constructors)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      (when def-axiom
        (let ((*restore-object-parent-slot* 'def-axiom))
          (restore-object* def-axiom)))
      (when positive-types
        (let ((*restore-object-parent-slot* 'positive-types))
          (restore-object* positive-types)))
      (when constructors
        (let ((*restore-object-parent-slot* 'constructors))
          (restore-object* constructors)))
      obj)))

(defmethod copy ((obj adt-accessor-decl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type declared-type-string type definition
                     def-axiom positive-types eval-info)
    obj
    (make-instance 'adt-accessor-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :def-axiom
                   (let* ((get1 (getf initargs 'def-axiom '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :def-axiom '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) def-axiom getfv))
                   :positive-types
                   (let* ((get1
                           (getf initargs 'positive-types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :positive-types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) positive-types getfv))
                   :eval-info
                   (let* ((get1 (getf initargs 'eval-info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :eval-info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) eval-info getfv)))))

(defmethod store-object* ((obj adt-accessor-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type definition def-axiom
                     positive-types)
    obj
    (reserve-space 21 (push-word (store-obj 'adt-accessor-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj definition))
                   (push-word (store-obj def-axiom))
                   (push-word (store-obj positive-types)))))

(defmethod update-fetched ((obj adt-accessor-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type definition def-axiom
                     positive-types pvs-sxhash-value tcc-form
                     declared-type-string eval-info)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf declared-type (fetch-obj (stored-word 16)))
    (setf type (fetch-obj (stored-word 17)))
    (setf definition (fetch-obj (stored-word 18)))
    (setf def-axiom (fetch-obj (stored-word 19)))
    (setf positive-types (fetch-obj (stored-word 20)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf declared-type-string nil)
    (setf eval-info nil)))

(defmethod restore-object* ((obj adt-accessor-decl))
  (with-slots (unique-id decl-formals formals declared-type type
                         definition def-axiom positive-types)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      (when def-axiom
        (let ((*restore-object-parent-slot* 'def-axiom))
          (restore-object* def-axiom)))
      (when positive-types
        (let ((*restore-object-parent-slot* 'positive-types))
          (restore-object* positive-types)))
      obj)))

(defmethod copy ((obj adt-recognizer-decl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type declared-type-string type definition
                     def-axiom positive-types eval-info ordnum)
    obj
    (make-instance 'adt-recognizer-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :def-axiom
                   (let* ((get1 (getf initargs 'def-axiom '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :def-axiom '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) def-axiom getfv))
                   :positive-types
                   (let* ((get1
                           (getf initargs 'positive-types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :positive-types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) positive-types getfv))
                   :eval-info
                   (let* ((get1 (getf initargs 'eval-info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :eval-info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) eval-info getfv))
                   :ordnum
                   (let* ((get1 (getf initargs 'ordnum '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ordnum '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ordnum getfv)))))

(defmethod store-object* ((obj adt-recognizer-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type definition def-axiom
                     positive-types ordnum)
    obj
    (reserve-space 22 (push-word (store-obj 'adt-recognizer-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj definition))
                   (push-word (store-obj def-axiom))
                   (push-word (store-obj positive-types))
                   (push-word (store-obj ordnum)))))

(defmethod update-fetched ((obj adt-recognizer-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type definition def-axiom
                     positive-types ordnum pvs-sxhash-value tcc-form
                     declared-type-string eval-info)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf declared-type (fetch-obj (stored-word 16)))
    (setf type (fetch-obj (stored-word 17)))
    (setf definition (fetch-obj (stored-word 18)))
    (setf def-axiom (fetch-obj (stored-word 19)))
    (setf positive-types (fetch-obj (stored-word 20)))
    (setf ordnum (fetch-obj (stored-word 21)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf declared-type-string nil)
    (setf eval-info nil)))

(defmethod restore-object* ((obj adt-recognizer-decl))
  (with-slots (unique-id decl-formals formals declared-type type
                         definition def-axiom positive-types)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      (when def-axiom
        (let ((*restore-object-parent-slot* 'def-axiom))
          (restore-object* def-axiom)))
      (when positive-types
        (let ((*restore-object-parent-slot* 'positive-types))
          (restore-object* positive-types)))
      obj)))

(defmethod copy ((obj adt-constructor-decl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type declared-type-string type definition
                     def-axiom positive-types eval-info ordnum)
    obj
    (make-instance 'adt-constructor-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :def-axiom
                   (let* ((get1 (getf initargs 'def-axiom '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :def-axiom '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) def-axiom getfv))
                   :positive-types
                   (let* ((get1
                           (getf initargs 'positive-types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :positive-types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) positive-types getfv))
                   :eval-info
                   (let* ((get1 (getf initargs 'eval-info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :eval-info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) eval-info getfv))
                   :ordnum
                   (let* ((get1 (getf initargs 'ordnum '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ordnum '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ordnum getfv)))))

(defmethod store-object* ((obj adt-constructor-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type definition def-axiom
                     positive-types ordnum)
    obj
    (reserve-space 22 (push-word (store-obj 'adt-constructor-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj definition))
                   (push-word (store-obj def-axiom))
                   (push-word (store-obj positive-types))
                   (push-word (store-obj ordnum)))))

(defmethod update-fetched ((obj adt-constructor-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type definition def-axiom
                     positive-types ordnum pvs-sxhash-value tcc-form
                     declared-type-string eval-info)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf declared-type (fetch-obj (stored-word 16)))
    (setf type (fetch-obj (stored-word 17)))
    (setf definition (fetch-obj (stored-word 18)))
    (setf def-axiom (fetch-obj (stored-word 19)))
    (setf positive-types (fetch-obj (stored-word 20)))
    (setf ordnum (fetch-obj (stored-word 21)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf declared-type-string nil)
    (setf eval-info nil)))

(defmethod restore-object* ((obj adt-constructor-decl))
  (with-slots (unique-id decl-formals formals declared-type type
                         definition def-axiom positive-types)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      (when def-axiom
        (let ((*restore-object-parent-slot* 'def-axiom))
          (restore-object* def-axiom)))
      (when positive-types
        (let ((*restore-object-parent-slot* 'positive-types))
          (restore-object* positive-types)))
      obj)))

(defmethod copy ((obj mapped-const-decl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type declared-type-string type definition
                     def-axiom positive-types eval-info)
    obj
    (make-instance 'mapped-const-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :def-axiom
                   (let* ((get1 (getf initargs 'def-axiom '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :def-axiom '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) def-axiom getfv))
                   :positive-types
                   (let* ((get1
                           (getf initargs 'positive-types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :positive-types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) positive-types getfv))
                   :eval-info
                   (let* ((get1 (getf initargs 'eval-info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :eval-info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) eval-info getfv)))))

(defmethod store-object* ((obj mapped-const-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type definition def-axiom
                     positive-types)
    obj
    (reserve-space 21 (push-word (store-obj 'mapped-const-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj definition))
                   (push-word (store-obj def-axiom))
                   (push-word (store-obj positive-types)))))

(defmethod update-fetched ((obj mapped-const-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type definition def-axiom
                     positive-types pvs-sxhash-value tcc-form
                     declared-type-string eval-info)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf declared-type (fetch-obj (stored-word 16)))
    (setf type (fetch-obj (stored-word 17)))
    (setf definition (fetch-obj (stored-word 18)))
    (setf def-axiom (fetch-obj (stored-word 19)))
    (setf positive-types (fetch-obj (stored-word 20)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf declared-type-string nil)
    (setf eval-info nil)))

(defmethod restore-object* ((obj mapped-const-decl))
  (with-slots (unique-id decl-formals formals declared-type type
                         definition def-axiom positive-types)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      (when def-axiom
        (let ((*restore-object-parent-slot* 'def-axiom))
          (restore-object* def-axiom)))
      (when positive-types
        (let ((*restore-object-parent-slot* 'positive-types))
          (restore-object* positive-types)))
      obj)))

(defmethod copy ((obj macro-decl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type declared-type-string type definition
                     def-axiom positive-types eval-info)
    obj
    (make-instance 'macro-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :def-axiom
                   (let* ((get1 (getf initargs 'def-axiom '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :def-axiom '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) def-axiom getfv))
                   :positive-types
                   (let* ((get1
                           (getf initargs 'positive-types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :positive-types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) positive-types getfv))
                   :eval-info
                   (let* ((get1 (getf initargs 'eval-info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :eval-info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) eval-info getfv)))))

(defmethod store-object* ((obj macro-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type definition def-axiom
                     positive-types)
    obj
    (reserve-space 21 (push-word (store-obj 'macro-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj definition))
                   (push-word (store-obj def-axiom))
                   (push-word (store-obj positive-types)))))

(defmethod update-fetched ((obj macro-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type definition def-axiom
                     positive-types pvs-sxhash-value tcc-form
                     declared-type-string eval-info)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf declared-type (fetch-obj (stored-word 16)))
    (setf type (fetch-obj (stored-word 17)))
    (setf definition (fetch-obj (stored-word 18)))
    (setf def-axiom (fetch-obj (stored-word 19)))
    (setf positive-types (fetch-obj (stored-word 20)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf declared-type-string nil)
    (setf eval-info nil)))

(defmethod restore-object* ((obj macro-decl))
  (with-slots (unique-id decl-formals formals declared-type type
                         definition def-axiom positive-types)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      (when def-axiom
        (let ((*restore-object-parent-slot* 'def-axiom))
          (restore-object* def-axiom)))
      (when positive-types
        (let ((*restore-object-parent-slot* 'positive-types))
          (restore-object* positive-types)))
      obj)))

(defmethod copy ((obj const-decl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type declared-type-string type definition
                     def-axiom positive-types eval-info)
    obj
    (make-instance 'const-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :definition
                   (let* ((get1 (getf initargs 'definition '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :definition '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) definition getfv))
                   :def-axiom
                   (let* ((get1 (getf initargs 'def-axiom '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :def-axiom '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) def-axiom getfv))
                   :positive-types
                   (let* ((get1
                           (getf initargs 'positive-types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :positive-types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) positive-types getfv))
                   :eval-info
                   (let* ((get1 (getf initargs 'eval-info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :eval-info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) eval-info getfv)))))

(defmethod store-object* ((obj const-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type definition def-axiom
                     positive-types)
    obj
    (reserve-space 21 (push-word (store-obj 'const-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj definition))
                   (push-word (store-obj def-axiom))
                   (push-word (store-obj positive-types)))))

(defmethod update-fetched ((obj const-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type definition def-axiom
                     positive-types pvs-sxhash-value tcc-form
                     declared-type-string eval-info)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf declared-type (fetch-obj (stored-word 16)))
    (setf type (fetch-obj (stored-word 17)))
    (setf definition (fetch-obj (stored-word 18)))
    (setf def-axiom (fetch-obj (stored-word 19)))
    (setf positive-types (fetch-obj (stored-word 20)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf declared-type-string nil)
    (setf eval-info nil)))

(defmethod restore-object* ((obj const-decl))
  (with-slots (unique-id decl-formals formals declared-type type
                         definition def-axiom positive-types)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when definition
        (let ((*restore-object-parent-slot* 'definition))
          (restore-object* definition)))
      (when def-axiom
        (let ((*restore-object-parent-slot* 'def-axiom))
          (restore-object* def-axiom)))
      (when positive-types
        (let ((*restore-object-parent-slot* 'positive-types))
          (restore-object* positive-types)))
      obj)))

(defmethod copy ((obj var-decl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type declared-type-string type)
    obj
    (make-instance 'var-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv)))))

(defmethod store-object* ((obj var-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type)
    obj
    (reserve-space 18 (push-word (store-obj 'var-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type)))))

(defmethod update-fetched ((obj var-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type pvs-sxhash-value tcc-form
                     declared-type-string)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf declared-type (fetch-obj (stored-word 16)))
    (setf type (fetch-obj (stored-word 17)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf declared-type-string nil)))

(defmethod restore-object* ((obj var-decl))
  (with-slots (unique-id decl-formals formals declared-type type)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      obj)))

(defmethod copy ((obj mapped-theory-abbreviation-decl) &rest initargs)
  (with-slots (saved-context place unique-id newline-comment id
                             decl-formals formals module refers-to
                             chain? typechecked? visible? generated
                             generated-by semi typecheck-time
                             theory-name)
    obj
    (make-instance 'mapped-theory-abbreviation-decl :saved-context
                   (let* ((get1
                           (getf initargs 'saved-context '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :saved-context '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) saved-context getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :theory-name
                   (let* ((get1 (getf initargs 'theory-name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :theory-name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) theory-name getfv)))))

(defmethod store-object* ((obj mapped-theory-abbreviation-decl))
  (with-slots (saved-context place unique-id newline-comment id
                             decl-formals formals module refers-to
                             chain? typechecked? visible? generated
                             generated-by semi typecheck-time
                             theory-name)
    obj
    (reserve-space 18
                   (push-word (store-obj 'mapped-theory-abbreviation-decl))
                   (push-word (store-obj saved-context))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj theory-name)))))

(defmethod update-fetched ((obj mapped-theory-abbreviation-decl))
  (with-slots (saved-context place unique-id newline-comment id
                             decl-formals formals module refers-to
                             chain? typechecked? visible? generated
                             generated-by semi typecheck-time
                             theory-name pvs-sxhash-value tcc-form)
    obj
    (setf saved-context (fetch-obj (stored-word 1)))
    (setf place (fetch-obj (stored-word 2)))
    (setf unique-id (fetch-obj (stored-word 3)))
    (setf newline-comment (fetch-obj (stored-word 4)))
    (setf id (fetch-obj (stored-word 5)))
    (setf decl-formals (fetch-obj (stored-word 6)))
    (setf formals (fetch-obj (stored-word 7)))
    (setf module (fetch-obj (stored-word 8)))
    (setf refers-to (fetch-obj (stored-word 9)))
    (setf chain? (fetch-obj (stored-word 10)))
    (setf typechecked? (fetch-obj (stored-word 11)))
    (setf visible? (fetch-obj (stored-word 12)))
    (setf generated (fetch-obj (stored-word 13)))
    (setf generated-by (fetch-obj (stored-word 14)))
    (setf semi (fetch-obj (stored-word 15)))
    (setf typecheck-time (fetch-obj (stored-word 16)))
    (setf theory-name (fetch-obj (stored-word 17)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)))

(defmethod restore-object* ((obj mapped-theory-abbreviation-decl))
  (with-slots (saved-context unique-id decl-formals formals
                             theory-name)
    obj
    (let ((*restore-object-parent* obj))
      (when saved-context
        (let ((*restore-object-parent-slot* 'saved-context))
          (restore-object* saved-context)))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when theory-name
        (let ((*restore-object-parent-slot* 'theory-name))
          (restore-object* theory-name)))
      obj)))

(defmethod copy ((obj theory-abbreviation-decl) &rest initargs)
  (with-slots (saved-context place unique-id newline-comment id
                             decl-formals formals module refers-to
                             chain? typechecked? visible? generated
                             generated-by semi typecheck-time
                             theory-name)
    obj
    (make-instance 'theory-abbreviation-decl :saved-context
                   (let* ((get1
                           (getf initargs 'saved-context '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :saved-context '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) saved-context getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :theory-name
                   (let* ((get1 (getf initargs 'theory-name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :theory-name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) theory-name getfv)))))

(defmethod store-object* ((obj theory-abbreviation-decl))
  (with-slots (saved-context place unique-id newline-comment id
                             decl-formals formals module refers-to
                             chain? typechecked? visible? generated
                             generated-by semi typecheck-time
                             theory-name)
    obj
    (reserve-space 18 (push-word (store-obj 'theory-abbreviation-decl))
                   (push-word (store-obj saved-context))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj theory-name)))))

(defmethod update-fetched ((obj theory-abbreviation-decl))
  (with-slots (saved-context place unique-id newline-comment id
                             decl-formals formals module refers-to
                             chain? typechecked? visible? generated
                             generated-by semi typecheck-time
                             theory-name pvs-sxhash-value tcc-form)
    obj
    (setf saved-context (fetch-obj (stored-word 1)))
    (setf place (fetch-obj (stored-word 2)))
    (setf unique-id (fetch-obj (stored-word 3)))
    (setf newline-comment (fetch-obj (stored-word 4)))
    (setf id (fetch-obj (stored-word 5)))
    (setf decl-formals (fetch-obj (stored-word 6)))
    (setf formals (fetch-obj (stored-word 7)))
    (setf module (fetch-obj (stored-word 8)))
    (setf refers-to (fetch-obj (stored-word 9)))
    (setf chain? (fetch-obj (stored-word 10)))
    (setf typechecked? (fetch-obj (stored-word 11)))
    (setf visible? (fetch-obj (stored-word 12)))
    (setf generated (fetch-obj (stored-word 13)))
    (setf generated-by (fetch-obj (stored-word 14)))
    (setf semi (fetch-obj (stored-word 15)))
    (setf typecheck-time (fetch-obj (stored-word 16)))
    (setf theory-name (fetch-obj (stored-word 17)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)))

(defmethod restore-object* ((obj theory-abbreviation-decl))
  (with-slots (saved-context unique-id decl-formals formals
                             theory-name)
    obj
    (let ((*restore-object-parent* obj))
      (when saved-context
        (let ((*restore-object-parent-slot* 'saved-context))
          (restore-object* saved-context)))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when theory-name
        (let ((*restore-object-parent-slot* 'theory-name))
          (restore-object* theory-name)))
      obj)))

(defmethod copy ((obj mapped-mod-decl) &rest initargs)
  (with-slots (saved-context place unique-id newline-comment id
                             decl-formals formals module refers-to
                             chain? typechecked? visible? generated
                             generated-by semi typecheck-time modname
                             theory-mappings other-mappings)
    obj
    (make-instance 'mapped-mod-decl :saved-context
                   (let* ((get1
                           (getf initargs 'saved-context '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :saved-context '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) saved-context getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :modname
                   (let* ((get1 (getf initargs 'modname '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :modname '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) modname getfv))
                   :theory-mappings
                   (let* ((get1
                           (getf initargs 'theory-mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :theory-mappings
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) theory-mappings getfv))
                   :other-mappings
                   (let* ((get1
                           (getf initargs 'other-mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :other-mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) other-mappings getfv)))))

(defmethod store-object* ((obj mapped-mod-decl))
  (with-slots (saved-context place unique-id newline-comment id
                             decl-formals formals module refers-to
                             chain? typechecked? visible? generated
                             generated-by semi typecheck-time modname
                             theory-mappings other-mappings)
    obj
    (reserve-space 20 (push-word (store-obj 'mapped-mod-decl))
                   (push-word (store-obj saved-context))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj modname))
                   (push-word (store-obj theory-mappings))
                   (push-word (store-obj other-mappings)))))

(defmethod update-fetched ((obj mapped-mod-decl))
  (with-slots (saved-context place unique-id newline-comment id
                             decl-formals formals module refers-to
                             chain? typechecked? visible? generated
                             generated-by semi typecheck-time modname
                             theory-mappings other-mappings
                             pvs-sxhash-value tcc-form)
    obj
    (setf saved-context (fetch-obj (stored-word 1)))
    (setf place (fetch-obj (stored-word 2)))
    (setf unique-id (fetch-obj (stored-word 3)))
    (setf newline-comment (fetch-obj (stored-word 4)))
    (setf id (fetch-obj (stored-word 5)))
    (setf decl-formals (fetch-obj (stored-word 6)))
    (setf formals (fetch-obj (stored-word 7)))
    (setf module (fetch-obj (stored-word 8)))
    (setf refers-to (fetch-obj (stored-word 9)))
    (setf chain? (fetch-obj (stored-word 10)))
    (setf typechecked? (fetch-obj (stored-word 11)))
    (setf visible? (fetch-obj (stored-word 12)))
    (setf generated (fetch-obj (stored-word 13)))
    (setf generated-by (fetch-obj (stored-word 14)))
    (setf semi (fetch-obj (stored-word 15)))
    (setf typecheck-time (fetch-obj (stored-word 16)))
    (setf modname (fetch-obj (stored-word 17)))
    (setf theory-mappings (fetch-obj (stored-word 18)))
    (setf other-mappings (fetch-obj (stored-word 19)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)))

(defmethod restore-object* ((obj mapped-mod-decl))
  (with-slots (saved-context unique-id decl-formals formals modname
                             theory-mappings other-mappings)
    obj
    (let ((*restore-object-parent* obj))
      (when saved-context
        (let ((*restore-object-parent-slot* 'saved-context))
          (restore-object* saved-context)))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when modname
        (let ((*restore-object-parent-slot* 'modname))
          (restore-object* modname)))
      (when theory-mappings
        (let ((*restore-object-parent-slot* 'theory-mappings))
          (restore-object* theory-mappings)))
      (when other-mappings
        (let ((*restore-object-parent-slot* 'other-mappings))
          (restore-object* other-mappings)))
      obj)))

(defmethod copy ((obj mod-decl) &rest initargs)
  (with-slots (saved-context place unique-id newline-comment id
                             decl-formals formals module refers-to
                             chain? typechecked? visible? generated
                             generated-by semi typecheck-time modname
                             theory-mappings other-mappings)
    obj
    (make-instance 'mod-decl :saved-context
                   (let* ((get1
                           (getf initargs 'saved-context '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :saved-context '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) saved-context getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :modname
                   (let* ((get1 (getf initargs 'modname '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :modname '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) modname getfv))
                   :theory-mappings
                   (let* ((get1
                           (getf initargs 'theory-mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :theory-mappings
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) theory-mappings getfv))
                   :other-mappings
                   (let* ((get1
                           (getf initargs 'other-mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :other-mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) other-mappings getfv)))))

(defmethod store-object* ((obj mod-decl))
  (with-slots (saved-context place unique-id newline-comment id
                             decl-formals formals module refers-to
                             chain? typechecked? visible? generated
                             generated-by semi typecheck-time modname
                             theory-mappings other-mappings)
    obj
    (reserve-space 20 (push-word (store-obj 'mod-decl))
                   (push-word (store-obj saved-context))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj modname))
                   (push-word (store-obj theory-mappings))
                   (push-word (store-obj other-mappings)))))

(defmethod update-fetched ((obj mod-decl))
  (with-slots (saved-context place unique-id newline-comment id
                             decl-formals formals module refers-to
                             chain? typechecked? visible? generated
                             generated-by semi typecheck-time modname
                             theory-mappings other-mappings
                             pvs-sxhash-value tcc-form)
    obj
    (setf saved-context (fetch-obj (stored-word 1)))
    (setf place (fetch-obj (stored-word 2)))
    (setf unique-id (fetch-obj (stored-word 3)))
    (setf newline-comment (fetch-obj (stored-word 4)))
    (setf id (fetch-obj (stored-word 5)))
    (setf decl-formals (fetch-obj (stored-word 6)))
    (setf formals (fetch-obj (stored-word 7)))
    (setf module (fetch-obj (stored-word 8)))
    (setf refers-to (fetch-obj (stored-word 9)))
    (setf chain? (fetch-obj (stored-word 10)))
    (setf typechecked? (fetch-obj (stored-word 11)))
    (setf visible? (fetch-obj (stored-word 12)))
    (setf generated (fetch-obj (stored-word 13)))
    (setf generated-by (fetch-obj (stored-word 14)))
    (setf semi (fetch-obj (stored-word 15)))
    (setf typecheck-time (fetch-obj (stored-word 16)))
    (setf modname (fetch-obj (stored-word 17)))
    (setf theory-mappings (fetch-obj (stored-word 18)))
    (setf other-mappings (fetch-obj (stored-word 19)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)))

(defmethod restore-object* ((obj mod-decl))
  (with-slots (saved-context unique-id decl-formals formals modname
                             theory-mappings other-mappings)
    obj
    (let ((*restore-object-parent* obj))
      (when saved-context
        (let ((*restore-object-parent-slot* 'saved-context))
          (restore-object* saved-context)))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when modname
        (let ((*restore-object-parent-slot* 'modname))
          (restore-object* modname)))
      (when theory-mappings
        (let ((*restore-object-parent-slot* 'theory-mappings))
          (restore-object* theory-mappings)))
      (when other-mappings
        (let ((*restore-object-parent-slot* 'other-mappings))
          (restore-object* other-mappings)))
      obj)))

(defmethod copy ((obj lib-eq-decl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     lib-string lib-ref)
    obj
    (make-instance 'lib-eq-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :lib-string
                   (let* ((get1 (getf initargs 'lib-string '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :lib-string '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) lib-string getfv))
                   :lib-ref
                   (let* ((get1 (getf initargs 'lib-ref '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :lib-ref '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) lib-ref getfv)))))

(defmethod store-object* ((obj lib-eq-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     lib-string lib-ref)
    obj
    (reserve-space 18 (push-word (store-obj 'lib-eq-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj lib-string))
                   (push-word (store-obj lib-ref)))))

(defmethod update-fetched ((obj lib-eq-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     lib-string lib-ref pvs-sxhash-value tcc-form)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf lib-string (fetch-obj (stored-word 16)))
    (setf lib-ref (fetch-obj (stored-word 17)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)))

(defmethod restore-object* ((obj lib-eq-decl))
  (with-slots (unique-id decl-formals formals)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      obj)))

(defmethod copy ((obj lib-decl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     lib-string lib-ref)
    obj
    (make-instance 'lib-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :lib-string
                   (let* ((get1 (getf initargs 'lib-string '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :lib-string '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) lib-string getfv))
                   :lib-ref
                   (let* ((get1 (getf initargs 'lib-ref '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :lib-ref '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) lib-ref getfv)))))

(defmethod store-object* ((obj lib-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     lib-string lib-ref)
    obj
    (reserve-space 18 (push-word (store-obj 'lib-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj lib-string))
                   (push-word (store-obj lib-ref)))))

(defmethod update-fetched ((obj lib-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     lib-string lib-ref pvs-sxhash-value tcc-form)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf lib-string (fetch-obj (stored-word 16)))
    (setf lib-ref (fetch-obj (stored-word 17)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)))

(defmethod restore-object* ((obj lib-decl))
  (with-slots (unique-id decl-formals formals)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      obj)))

(defmethod copy ((obj adtdecl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type declared-type-string type bind-decl
                     accessor-decl)
    obj
    (make-instance 'adtdecl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :bind-decl
                   (let* ((get1 (getf initargs 'bind-decl '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :bind-decl '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) bind-decl getfv))
                   :accessor-decl
                   (let* ((get1
                           (getf initargs 'accessor-decl '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :accessor-decl '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) accessor-decl getfv)))))

(defmethod store-object* ((obj adtdecl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type bind-decl accessor-decl)
    obj
    (reserve-space 20 (push-word (store-obj 'adtdecl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj bind-decl))
                   (push-word (store-obj accessor-decl)))))

(defmethod update-fetched ((obj adtdecl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type bind-decl accessor-decl
                     pvs-sxhash-value tcc-form declared-type-string)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf declared-type (fetch-obj (stored-word 16)))
    (setf type (fetch-obj (stored-word 17)))
    (setf bind-decl (fetch-obj (stored-word 18)))
    (setf accessor-decl (fetch-obj (stored-word 19)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf declared-type-string nil)))

(defmethod restore-object* ((obj adtdecl))
  (with-slots (unique-id decl-formals formals declared-type type
                         bind-decl accessor-decl)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when bind-decl
        (let ((*restore-object-parent-slot* 'bind-decl))
          (restore-object* bind-decl)))
      (when accessor-decl
        (let ((*restore-object-parent-slot* 'accessor-decl))
          (restore-object* accessor-decl)))
      obj)))

(defmethod copy ((obj formal-theory-decl) &rest initargs)
  (with-slots (saved-context place unique-id newline-comment id
                             decl-formals formals module refers-to
                             chain? typechecked? visible? generated
                             generated-by semi typecheck-time
                             dependent? theory-name theory-mappings
                             other-mappings)
    obj
    (make-instance 'formal-theory-decl :saved-context
                   (let* ((get1
                           (getf initargs 'saved-context '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :saved-context '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) saved-context getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :dependent?
                   (let* ((get1 (getf initargs 'dependent? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dependent? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dependent? getfv))
                   :theory-name
                   (let* ((get1 (getf initargs 'theory-name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :theory-name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) theory-name getfv))
                   :theory-mappings
                   (let* ((get1
                           (getf initargs 'theory-mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :theory-mappings
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) theory-mappings getfv))
                   :other-mappings
                   (let* ((get1
                           (getf initargs 'other-mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :other-mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) other-mappings getfv)))))

(defmethod store-object* ((obj formal-theory-decl))
  (with-slots (saved-context place unique-id newline-comment id
                             decl-formals formals module refers-to
                             chain? typechecked? visible? generated
                             generated-by semi typecheck-time
                             dependent? theory-name theory-mappings
                             other-mappings)
    obj
    (reserve-space 21 (push-word (store-obj 'formal-theory-decl))
                   (push-word (store-obj saved-context))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj dependent?))
                   (push-word (store-obj theory-name))
                   (push-word (store-obj theory-mappings))
                   (push-word (store-obj other-mappings)))))

(defmethod update-fetched ((obj formal-theory-decl))
  (with-slots (saved-context place unique-id newline-comment id
                             decl-formals formals module refers-to
                             chain? typechecked? visible? generated
                             generated-by semi typecheck-time
                             dependent? theory-name theory-mappings
                             other-mappings pvs-sxhash-value tcc-form)
    obj
    (setf saved-context (fetch-obj (stored-word 1)))
    (setf place (fetch-obj (stored-word 2)))
    (setf unique-id (fetch-obj (stored-word 3)))
    (setf newline-comment (fetch-obj (stored-word 4)))
    (setf id (fetch-obj (stored-word 5)))
    (setf decl-formals (fetch-obj (stored-word 6)))
    (setf formals (fetch-obj (stored-word 7)))
    (setf module (fetch-obj (stored-word 8)))
    (setf refers-to (fetch-obj (stored-word 9)))
    (setf chain? (fetch-obj (stored-word 10)))
    (setf typechecked? (fetch-obj (stored-word 11)))
    (setf visible? (fetch-obj (stored-word 12)))
    (setf generated (fetch-obj (stored-word 13)))
    (setf generated-by (fetch-obj (stored-word 14)))
    (setf semi (fetch-obj (stored-word 15)))
    (setf typecheck-time (fetch-obj (stored-word 16)))
    (setf dependent? (fetch-obj (stored-word 17)))
    (setf theory-name (fetch-obj (stored-word 18)))
    (setf theory-mappings (fetch-obj (stored-word 19)))
    (setf other-mappings (fetch-obj (stored-word 20)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)))

(defmethod restore-object* ((obj formal-theory-decl))
  (with-slots (saved-context unique-id decl-formals formals theory-name
                             theory-mappings other-mappings)
    obj
    (let ((*restore-object-parent* obj))
      (when saved-context
        (let ((*restore-object-parent-slot* 'saved-context))
          (restore-object* saved-context)))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when theory-name
        (let ((*restore-object-parent-slot* 'theory-name))
          (restore-object* theory-name)))
      (when theory-mappings
        (let ((*restore-object-parent-slot* 'theory-mappings))
          (restore-object* theory-mappings)))
      (when other-mappings
        (let ((*restore-object-parent-slot* 'other-mappings))
          (restore-object* other-mappings)))
      obj)))

(defmethod copy ((obj formal-const-decl) &rest initargs)
  (with-slots (declared-type declared-type-string type place unique-id
                             newline-comment id decl-formals formals
                             module refers-to chain? typechecked?
                             visible? generated generated-by semi
                             typecheck-time dependent?
                             possibly-empty-type? eval-info)
    obj
    (make-instance 'formal-const-decl :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :dependent?
                   (let* ((get1 (getf initargs 'dependent? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dependent? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dependent? getfv))
                   :possibly-empty-type?
                   (let* ((get1
                           (getf initargs 'possibly-empty-type?
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :possibly-empty-type?
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         possibly-empty-type?
                       getfv))
                   :eval-info
                   (let* ((get1 (getf initargs 'eval-info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :eval-info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) eval-info getfv)))))

(defmethod store-object* ((obj formal-const-decl))
  (with-slots (declared-type type place unique-id newline-comment id
                             decl-formals formals module refers-to
                             chain? typechecked? visible? generated
                             generated-by semi typecheck-time
                             dependent? possibly-empty-type?)
    obj
    (reserve-space 20 (push-word (store-obj 'formal-const-decl))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj dependent?))
                   (push-word (store-obj possibly-empty-type?)))))

(defmethod update-fetched ((obj formal-const-decl))
  (with-slots (declared-type type place unique-id newline-comment id
                             decl-formals formals module refers-to
                             chain? typechecked? visible? generated
                             generated-by semi typecheck-time
                             dependent? possibly-empty-type?
                             declared-type-string pvs-sxhash-value
                             tcc-form eval-info)
    obj
    (setf declared-type (fetch-obj (stored-word 1)))
    (setf type (fetch-obj (stored-word 2)))
    (setf place (fetch-obj (stored-word 3)))
    (setf unique-id (fetch-obj (stored-word 4)))
    (setf newline-comment (fetch-obj (stored-word 5)))
    (setf id (fetch-obj (stored-word 6)))
    (setf decl-formals (fetch-obj (stored-word 7)))
    (setf formals (fetch-obj (stored-word 8)))
    (setf module (fetch-obj (stored-word 9)))
    (setf refers-to (fetch-obj (stored-word 10)))
    (setf chain? (fetch-obj (stored-word 11)))
    (setf typechecked? (fetch-obj (stored-word 12)))
    (setf visible? (fetch-obj (stored-word 13)))
    (setf generated (fetch-obj (stored-word 14)))
    (setf generated-by (fetch-obj (stored-word 15)))
    (setf semi (fetch-obj (stored-word 16)))
    (setf typecheck-time (fetch-obj (stored-word 17)))
    (setf dependent? (fetch-obj (stored-word 18)))
    (setf possibly-empty-type? (fetch-obj (stored-word 19)))
    (setf declared-type-string nil)
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf eval-info nil)))

(defmethod restore-object* ((obj formal-const-decl))
  (with-slots (declared-type type unique-id decl-formals formals)
    obj
    (let ((*restore-object-parent* obj))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      obj)))

(defmethod copy ((obj decl-formal-nonempty-type-appl) &rest initargs)
  (with-slots (keyword parameters declared-type declared-type-string
                       type type-value ir-type-value place unique-id
                       newline-comment id decl-formals formals module
                       refers-to chain? typechecked? visible? generated
                       generated-by semi typecheck-time dependent?
                       associated-decl)
    obj
    (make-instance 'decl-formal-nonempty-type-appl :keyword
                   (let* ((get1 (getf initargs 'keyword '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :keyword '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) keyword getfv))
                   :parameters
                   (let* ((get1 (getf initargs 'parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parameters '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parameters getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :type-value
                   (let* ((get1 (getf initargs 'type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-value getfv))
                   :ir-type-value
                   (let* ((get1
                           (getf initargs 'ir-type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-type-value getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :dependent?
                   (let* ((get1 (getf initargs 'dependent? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dependent? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dependent? getfv))
                   :associated-decl
                   (let* ((get1
                           (getf initargs 'associated-decl '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :associated-decl
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) associated-decl getfv)))))

(defmethod store-object* ((obj decl-formal-nonempty-type-appl))
  (with-slots (keyword parameters declared-type type type-value place
                       unique-id newline-comment id decl-formals
                       formals module refers-to chain? typechecked?
                       visible? generated generated-by semi
                       typecheck-time dependent? associated-decl
                       type-value)
    obj
    (reserve-space 24
                   (push-word (store-obj 'decl-formal-nonempty-type-appl))
                   (push-word (store-obj keyword))
                   (push-word (store-obj parameters))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj type-value))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj dependent?))
                   (push-word (store-obj associated-decl))
                   (push-word (store-obj (ignore-self-reference-type-values
                                          obj))))))

(defmethod update-fetched ((obj decl-formal-nonempty-type-appl))
  (with-slots (keyword parameters declared-type type type-value place
                       unique-id newline-comment id decl-formals
                       formals module refers-to chain? typechecked?
                       visible? generated generated-by semi
                       typecheck-time dependent? associated-decl
                       type-value declared-type-string ir-type-value
                       pvs-sxhash-value tcc-form)
    obj
    (setf keyword (fetch-obj (stored-word 1)))
    (setf parameters (fetch-obj (stored-word 2)))
    (setf declared-type (fetch-obj (stored-word 3)))
    (setf type (fetch-obj (stored-word 4)))
    (setf type-value (fetch-obj (stored-word 5)))
    (setf place (fetch-obj (stored-word 6)))
    (setf unique-id (fetch-obj (stored-word 7)))
    (setf newline-comment (fetch-obj (stored-word 8)))
    (setf id (fetch-obj (stored-word 9)))
    (setf decl-formals (fetch-obj (stored-word 10)))
    (setf formals (fetch-obj (stored-word 11)))
    (setf module (fetch-obj (stored-word 12)))
    (setf refers-to (fetch-obj (stored-word 13)))
    (setf chain? (fetch-obj (stored-word 14)))
    (setf typechecked? (fetch-obj (stored-word 15)))
    (setf visible? (fetch-obj (stored-word 16)))
    (setf generated (fetch-obj (stored-word 17)))
    (setf generated-by (fetch-obj (stored-word 18)))
    (setf semi (fetch-obj (stored-word 19)))
    (setf typecheck-time (fetch-obj (stored-word 20)))
    (setf dependent? (fetch-obj (stored-word 21)))
    (setf associated-decl (fetch-obj (stored-word 22)))
    (setf type-value (fetch-obj (stored-word 23)))
    (setf declared-type-string nil)
    (setf ir-type-value nil)
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)))

(defmethod restore-object* ((obj decl-formal-nonempty-type-appl))
  (with-slots (parameters declared-type type type-value unique-id
                          decl-formals formals associated-decl)
    obj
    (let ((*restore-object-parent* obj))
      (when parameters
        (let ((*restore-object-parent-slot* 'parameters))
          (restore-object* parameters)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when type-value
        (let ((*restore-object-parent-slot* 'type-value))
          (restore-object* type-value)))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when associated-decl
        (let ((*restore-object-parent-slot* 'associated-decl))
          (restore-object* associated-decl)))
      obj)))

(defmethod copy ((obj formal-nonempty-type-appl-decl) &rest initargs)
  (with-slots (keyword declared-type declared-type-string type
                       type-value ir-type-value place unique-id
                       newline-comment id decl-formals formals module
                       refers-to chain? typechecked? visible? generated
                       generated-by semi typecheck-time dependent?
                       parameters)
    obj
    (make-instance 'formal-nonempty-type-appl-decl :keyword
                   (let* ((get1 (getf initargs 'keyword '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :keyword '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) keyword getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :type-value
                   (let* ((get1 (getf initargs 'type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-value getfv))
                   :ir-type-value
                   (let* ((get1
                           (getf initargs 'ir-type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-type-value getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :dependent?
                   (let* ((get1 (getf initargs 'dependent? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dependent? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dependent? getfv))
                   :parameters
                   (let* ((get1 (getf initargs 'parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parameters '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parameters getfv)))))

(defmethod store-object* ((obj formal-nonempty-type-appl-decl))
  (with-slots (keyword declared-type type type-value place unique-id
                       newline-comment id decl-formals formals module
                       refers-to chain? typechecked? visible? generated
                       generated-by semi typecheck-time dependent?
                       parameters type-value)
    obj
    (reserve-space 23
                   (push-word (store-obj 'formal-nonempty-type-appl-decl))
                   (push-word (store-obj keyword))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj type-value))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj dependent?))
                   (push-word (store-obj parameters))
                   (push-word (store-obj (ignore-self-reference-type-values
                                          obj))))))

(defmethod update-fetched ((obj formal-nonempty-type-appl-decl))
  (with-slots (keyword declared-type type type-value place unique-id
                       newline-comment id decl-formals formals module
                       refers-to chain? typechecked? visible? generated
                       generated-by semi typecheck-time dependent?
                       parameters type-value declared-type-string
                       ir-type-value pvs-sxhash-value tcc-form)
    obj
    (setf keyword (fetch-obj (stored-word 1)))
    (setf declared-type (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf type-value (fetch-obj (stored-word 4)))
    (setf place (fetch-obj (stored-word 5)))
    (setf unique-id (fetch-obj (stored-word 6)))
    (setf newline-comment (fetch-obj (stored-word 7)))
    (setf id (fetch-obj (stored-word 8)))
    (setf decl-formals (fetch-obj (stored-word 9)))
    (setf formals (fetch-obj (stored-word 10)))
    (setf module (fetch-obj (stored-word 11)))
    (setf refers-to (fetch-obj (stored-word 12)))
    (setf chain? (fetch-obj (stored-word 13)))
    (setf typechecked? (fetch-obj (stored-word 14)))
    (setf visible? (fetch-obj (stored-word 15)))
    (setf generated (fetch-obj (stored-word 16)))
    (setf generated-by (fetch-obj (stored-word 17)))
    (setf semi (fetch-obj (stored-word 18)))
    (setf typecheck-time (fetch-obj (stored-word 19)))
    (setf dependent? (fetch-obj (stored-word 20)))
    (setf parameters (fetch-obj (stored-word 21)))
    (setf type-value (fetch-obj (stored-word 22)))
    (setf declared-type-string nil)
    (setf ir-type-value nil)
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)))

(defmethod restore-object* ((obj formal-nonempty-type-appl-decl))
  (with-slots (declared-type type type-value unique-id decl-formals
                             formals parameters)
    obj
    (let ((*restore-object-parent* obj))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when type-value
        (let ((*restore-object-parent-slot* 'type-value))
          (restore-object* type-value)))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when parameters
        (let ((*restore-object-parent-slot* 'parameters))
          (restore-object* parameters)))
      obj)))

(defmethod copy ((obj decl-formal-type-appl) &rest initargs)
  (with-slots (parameters declared-type declared-type-string type
                          type-value ir-type-value place unique-id
                          newline-comment id decl-formals formals
                          module refers-to chain? typechecked? visible?
                          generated generated-by semi typecheck-time
                          dependent? associated-decl)
    obj
    (make-instance 'decl-formal-type-appl :parameters
                   (let* ((get1 (getf initargs 'parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parameters '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parameters getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :type-value
                   (let* ((get1 (getf initargs 'type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-value getfv))
                   :ir-type-value
                   (let* ((get1
                           (getf initargs 'ir-type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-type-value getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :dependent?
                   (let* ((get1 (getf initargs 'dependent? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dependent? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dependent? getfv))
                   :associated-decl
                   (let* ((get1
                           (getf initargs 'associated-decl '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :associated-decl
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) associated-decl getfv)))))

(defmethod store-object* ((obj decl-formal-type-appl))
  (with-slots (parameters declared-type type type-value place unique-id
                          newline-comment id decl-formals formals
                          module refers-to chain? typechecked? visible?
                          generated generated-by semi typecheck-time
                          dependent? associated-decl type-value)
    obj
    (reserve-space 23 (push-word (store-obj 'decl-formal-type-appl))
                   (push-word (store-obj parameters))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj type-value))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj dependent?))
                   (push-word (store-obj associated-decl))
                   (push-word (store-obj (ignore-self-reference-type-values
                                          obj))))))

(defmethod update-fetched ((obj decl-formal-type-appl))
  (with-slots (parameters declared-type type type-value place unique-id
                          newline-comment id decl-formals formals
                          module refers-to chain? typechecked? visible?
                          generated generated-by semi typecheck-time
                          dependent? associated-decl type-value
                          declared-type-string ir-type-value
                          pvs-sxhash-value tcc-form)
    obj
    (setf parameters (fetch-obj (stored-word 1)))
    (setf declared-type (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf type-value (fetch-obj (stored-word 4)))
    (setf place (fetch-obj (stored-word 5)))
    (setf unique-id (fetch-obj (stored-word 6)))
    (setf newline-comment (fetch-obj (stored-word 7)))
    (setf id (fetch-obj (stored-word 8)))
    (setf decl-formals (fetch-obj (stored-word 9)))
    (setf formals (fetch-obj (stored-word 10)))
    (setf module (fetch-obj (stored-word 11)))
    (setf refers-to (fetch-obj (stored-word 12)))
    (setf chain? (fetch-obj (stored-word 13)))
    (setf typechecked? (fetch-obj (stored-word 14)))
    (setf visible? (fetch-obj (stored-word 15)))
    (setf generated (fetch-obj (stored-word 16)))
    (setf generated-by (fetch-obj (stored-word 17)))
    (setf semi (fetch-obj (stored-word 18)))
    (setf typecheck-time (fetch-obj (stored-word 19)))
    (setf dependent? (fetch-obj (stored-word 20)))
    (setf associated-decl (fetch-obj (stored-word 21)))
    (setf type-value (fetch-obj (stored-word 22)))
    (setf declared-type-string nil)
    (setf ir-type-value nil)
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)))

(defmethod restore-object* ((obj decl-formal-type-appl))
  (with-slots (parameters declared-type type type-value unique-id
                          decl-formals formals associated-decl)
    obj
    (let ((*restore-object-parent* obj))
      (when parameters
        (let ((*restore-object-parent-slot* 'parameters))
          (restore-object* parameters)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when type-value
        (let ((*restore-object-parent-slot* 'type-value))
          (restore-object* type-value)))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when associated-decl
        (let ((*restore-object-parent-slot* 'associated-decl))
          (restore-object* associated-decl)))
      obj)))

(defmethod copy ((obj formal-type-appl-decl) &rest initargs)
  (with-slots (declared-type declared-type-string type type-value
                             ir-type-value place unique-id
                             newline-comment id decl-formals formals
                             module refers-to chain? typechecked?
                             visible? generated generated-by semi
                             typecheck-time dependent? parameters)
    obj
    (make-instance 'formal-type-appl-decl :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :type-value
                   (let* ((get1 (getf initargs 'type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-value getfv))
                   :ir-type-value
                   (let* ((get1
                           (getf initargs 'ir-type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-type-value getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :dependent?
                   (let* ((get1 (getf initargs 'dependent? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dependent? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dependent? getfv))
                   :parameters
                   (let* ((get1 (getf initargs 'parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parameters '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parameters getfv)))))

(defmethod store-object* ((obj formal-type-appl-decl))
  (with-slots (declared-type type type-value place unique-id
                             newline-comment id decl-formals formals
                             module refers-to chain? typechecked?
                             visible? generated generated-by semi
                             typecheck-time dependent? parameters
                             type-value)
    obj
    (reserve-space 22 (push-word (store-obj 'formal-type-appl-decl))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj type-value))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj dependent?))
                   (push-word (store-obj parameters))
                   (push-word (store-obj (ignore-self-reference-type-values
                                          obj))))))

(defmethod update-fetched ((obj formal-type-appl-decl))
  (with-slots (declared-type type type-value place unique-id
                             newline-comment id decl-formals formals
                             module refers-to chain? typechecked?
                             visible? generated generated-by semi
                             typecheck-time dependent? parameters
                             type-value declared-type-string
                             ir-type-value pvs-sxhash-value tcc-form)
    obj
    (setf declared-type (fetch-obj (stored-word 1)))
    (setf type (fetch-obj (stored-word 2)))
    (setf type-value (fetch-obj (stored-word 3)))
    (setf place (fetch-obj (stored-word 4)))
    (setf unique-id (fetch-obj (stored-word 5)))
    (setf newline-comment (fetch-obj (stored-word 6)))
    (setf id (fetch-obj (stored-word 7)))
    (setf decl-formals (fetch-obj (stored-word 8)))
    (setf formals (fetch-obj (stored-word 9)))
    (setf module (fetch-obj (stored-word 10)))
    (setf refers-to (fetch-obj (stored-word 11)))
    (setf chain? (fetch-obj (stored-word 12)))
    (setf typechecked? (fetch-obj (stored-word 13)))
    (setf visible? (fetch-obj (stored-word 14)))
    (setf generated (fetch-obj (stored-word 15)))
    (setf generated-by (fetch-obj (stored-word 16)))
    (setf semi (fetch-obj (stored-word 17)))
    (setf typecheck-time (fetch-obj (stored-word 18)))
    (setf dependent? (fetch-obj (stored-word 19)))
    (setf parameters (fetch-obj (stored-word 20)))
    (setf type-value (fetch-obj (stored-word 21)))
    (setf declared-type-string nil)
    (setf ir-type-value nil)
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)))

(defmethod restore-object* ((obj formal-type-appl-decl))
  (with-slots (declared-type type type-value unique-id decl-formals
                             formals parameters)
    obj
    (let ((*restore-object-parent* obj))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when type-value
        (let ((*restore-object-parent-slot* 'type-value))
          (restore-object* type-value)))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when parameters
        (let ((*restore-object-parent-slot* 'parameters))
          (restore-object* parameters)))
      obj)))

(defmethod copy ((obj decl-formal-nonempty-struct-subtype) &rest
                 initargs)
  (with-slots (keyword type-expr contains projection supertype
                       declared-type declared-type-string type
                       type-value ir-type-value place unique-id
                       newline-comment id decl-formals formals module
                       refers-to chain? typechecked? visible? generated
                       generated-by semi typecheck-time dependent?
                       associated-decl)
    obj
    (make-instance 'decl-formal-nonempty-struct-subtype :keyword
                   (let* ((get1 (getf initargs 'keyword '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :keyword '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) keyword getfv))
                   :type-expr
                   (let* ((get1 (getf initargs 'type-expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-expr getfv))
                   :contains
                   (let* ((get1 (getf initargs 'contains '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :contains '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) contains getfv))
                   :projection
                   (let* ((get1 (getf initargs 'projection '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :projection '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) projection getfv))
                   :supertype
                   (let* ((get1 (getf initargs 'supertype '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :supertype '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) supertype getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :type-value
                   (let* ((get1 (getf initargs 'type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-value getfv))
                   :ir-type-value
                   (let* ((get1
                           (getf initargs 'ir-type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-type-value getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :dependent?
                   (let* ((get1 (getf initargs 'dependent? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dependent? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dependent? getfv))
                   :associated-decl
                   (let* ((get1
                           (getf initargs 'associated-decl '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :associated-decl
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) associated-decl getfv)))))

(defmethod store-object* ((obj decl-formal-nonempty-struct-subtype))
  (with-slots (keyword type-expr contains projection supertype
                       declared-type type type-value place unique-id
                       newline-comment id decl-formals formals module
                       refers-to chain? typechecked? visible? generated
                       generated-by semi typecheck-time dependent?
                       associated-decl type-value)
    obj
    (reserve-space 27
                   (push-word (store-obj 'decl-formal-nonempty-struct-subtype))
                   (push-word (store-obj keyword))
                   (push-word (store-obj type-expr))
                   (push-word (store-obj contains))
                   (push-word (store-obj projection))
                   (push-word (store-obj supertype))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj type-value))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj dependent?))
                   (push-word (store-obj associated-decl))
                   (push-word (store-obj (ignore-self-reference-type-values
                                          obj))))))

(defmethod update-fetched ((obj decl-formal-nonempty-struct-subtype))
  (with-slots (keyword type-expr contains projection supertype
                       declared-type type type-value place unique-id
                       newline-comment id decl-formals formals module
                       refers-to chain? typechecked? visible? generated
                       generated-by semi typecheck-time dependent?
                       associated-decl type-value declared-type-string
                       ir-type-value pvs-sxhash-value tcc-form)
    obj
    (setf keyword (fetch-obj (stored-word 1)))
    (setf type-expr (fetch-obj (stored-word 2)))
    (setf contains (fetch-obj (stored-word 3)))
    (setf projection (fetch-obj (stored-word 4)))
    (setf supertype (fetch-obj (stored-word 5)))
    (setf declared-type (fetch-obj (stored-word 6)))
    (setf type (fetch-obj (stored-word 7)))
    (setf type-value (fetch-obj (stored-word 8)))
    (setf place (fetch-obj (stored-word 9)))
    (setf unique-id (fetch-obj (stored-word 10)))
    (setf newline-comment (fetch-obj (stored-word 11)))
    (setf id (fetch-obj (stored-word 12)))
    (setf decl-formals (fetch-obj (stored-word 13)))
    (setf formals (fetch-obj (stored-word 14)))
    (setf module (fetch-obj (stored-word 15)))
    (setf refers-to (fetch-obj (stored-word 16)))
    (setf chain? (fetch-obj (stored-word 17)))
    (setf typechecked? (fetch-obj (stored-word 18)))
    (setf visible? (fetch-obj (stored-word 19)))
    (setf generated (fetch-obj (stored-word 20)))
    (setf generated-by (fetch-obj (stored-word 21)))
    (setf semi (fetch-obj (stored-word 22)))
    (setf typecheck-time (fetch-obj (stored-word 23)))
    (setf dependent? (fetch-obj (stored-word 24)))
    (setf associated-decl (fetch-obj (stored-word 25)))
    (setf type-value (fetch-obj (stored-word 26)))
    (setf declared-type-string nil)
    (setf ir-type-value nil)
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)))

(defmethod restore-object* ((obj decl-formal-nonempty-struct-subtype))
  (with-slots (type-expr contains projection supertype declared-type
                         type type-value unique-id decl-formals formals
                         associated-decl)
    obj
    (let ((*restore-object-parent* obj))
      (when type-expr
        (let ((*restore-object-parent-slot* 'type-expr))
          (restore-object* type-expr)))
      (when contains
        (let ((*restore-object-parent-slot* 'contains))
          (restore-object* contains)))
      (when projection
        (let ((*restore-object-parent-slot* 'projection))
          (restore-object* projection)))
      (when supertype
        (let ((*restore-object-parent-slot* 'supertype))
          (restore-object* supertype)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when type-value
        (let ((*restore-object-parent-slot* 'type-value))
          (restore-object* type-value)))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when associated-decl
        (let ((*restore-object-parent-slot* 'associated-decl))
          (restore-object* associated-decl)))
      obj)))

(defmethod copy ((obj formal-nonempty-struct-subtype-decl) &rest
                 initargs)
  (with-slots (keyword type-expr contains projection supertype
                       declared-type declared-type-string type
                       type-value ir-type-value place unique-id
                       newline-comment id decl-formals formals module
                       refers-to chain? typechecked? visible? generated
                       generated-by semi typecheck-time dependent?)
    obj
    (make-instance 'formal-nonempty-struct-subtype-decl :keyword
                   (let* ((get1 (getf initargs 'keyword '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :keyword '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) keyword getfv))
                   :type-expr
                   (let* ((get1 (getf initargs 'type-expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-expr getfv))
                   :contains
                   (let* ((get1 (getf initargs 'contains '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :contains '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) contains getfv))
                   :projection
                   (let* ((get1 (getf initargs 'projection '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :projection '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) projection getfv))
                   :supertype
                   (let* ((get1 (getf initargs 'supertype '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :supertype '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) supertype getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :type-value
                   (let* ((get1 (getf initargs 'type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-value getfv))
                   :ir-type-value
                   (let* ((get1
                           (getf initargs 'ir-type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-type-value getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :dependent?
                   (let* ((get1 (getf initargs 'dependent? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dependent? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dependent? getfv)))))

(defmethod store-object* ((obj formal-nonempty-struct-subtype-decl))
  (with-slots (keyword type-expr contains projection supertype
                       declared-type type type-value place unique-id
                       newline-comment id decl-formals formals module
                       refers-to chain? typechecked? visible? generated
                       generated-by semi typecheck-time dependent?
                       type-value)
    obj
    (reserve-space 26
                   (push-word (store-obj 'formal-nonempty-struct-subtype-decl))
                   (push-word (store-obj keyword))
                   (push-word (store-obj type-expr))
                   (push-word (store-obj contains))
                   (push-word (store-obj projection))
                   (push-word (store-obj supertype))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj type-value))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj dependent?))
                   (push-word (store-obj (ignore-self-reference-type-values
                                          obj))))))

(defmethod update-fetched ((obj formal-nonempty-struct-subtype-decl))
  (with-slots (keyword type-expr contains projection supertype
                       declared-type type type-value place unique-id
                       newline-comment id decl-formals formals module
                       refers-to chain? typechecked? visible? generated
                       generated-by semi typecheck-time dependent?
                       type-value declared-type-string ir-type-value
                       pvs-sxhash-value tcc-form)
    obj
    (setf keyword (fetch-obj (stored-word 1)))
    (setf type-expr (fetch-obj (stored-word 2)))
    (setf contains (fetch-obj (stored-word 3)))
    (setf projection (fetch-obj (stored-word 4)))
    (setf supertype (fetch-obj (stored-word 5)))
    (setf declared-type (fetch-obj (stored-word 6)))
    (setf type (fetch-obj (stored-word 7)))
    (setf type-value (fetch-obj (stored-word 8)))
    (setf place (fetch-obj (stored-word 9)))
    (setf unique-id (fetch-obj (stored-word 10)))
    (setf newline-comment (fetch-obj (stored-word 11)))
    (setf id (fetch-obj (stored-word 12)))
    (setf decl-formals (fetch-obj (stored-word 13)))
    (setf formals (fetch-obj (stored-word 14)))
    (setf module (fetch-obj (stored-word 15)))
    (setf refers-to (fetch-obj (stored-word 16)))
    (setf chain? (fetch-obj (stored-word 17)))
    (setf typechecked? (fetch-obj (stored-word 18)))
    (setf visible? (fetch-obj (stored-word 19)))
    (setf generated (fetch-obj (stored-word 20)))
    (setf generated-by (fetch-obj (stored-word 21)))
    (setf semi (fetch-obj (stored-word 22)))
    (setf typecheck-time (fetch-obj (stored-word 23)))
    (setf dependent? (fetch-obj (stored-word 24)))
    (setf type-value (fetch-obj (stored-word 25)))
    (setf declared-type-string nil)
    (setf ir-type-value nil)
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)))

(defmethod restore-object* ((obj formal-nonempty-struct-subtype-decl))
  (with-slots (type-expr contains projection supertype declared-type
                         type type-value unique-id decl-formals
                         formals)
    obj
    (let ((*restore-object-parent* obj))
      (when type-expr
        (let ((*restore-object-parent-slot* 'type-expr))
          (restore-object* type-expr)))
      (when contains
        (let ((*restore-object-parent-slot* 'contains))
          (restore-object* contains)))
      (when projection
        (let ((*restore-object-parent-slot* 'projection))
          (restore-object* projection)))
      (when supertype
        (let ((*restore-object-parent-slot* 'supertype))
          (restore-object* supertype)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when type-value
        (let ((*restore-object-parent-slot* 'type-value))
          (restore-object* type-value)))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      obj)))

(defmethod copy ((obj decl-formal-struct-subtype) &rest initargs)
  (with-slots (type-expr contains projection supertype declared-type
                         declared-type-string type type-value
                         ir-type-value place unique-id newline-comment
                         id decl-formals formals module refers-to
                         chain? typechecked? visible? generated
                         generated-by semi typecheck-time dependent?
                         associated-decl)
    obj
    (make-instance 'decl-formal-struct-subtype :type-expr
                   (let* ((get1 (getf initargs 'type-expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-expr getfv))
                   :contains
                   (let* ((get1 (getf initargs 'contains '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :contains '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) contains getfv))
                   :projection
                   (let* ((get1 (getf initargs 'projection '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :projection '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) projection getfv))
                   :supertype
                   (let* ((get1 (getf initargs 'supertype '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :supertype '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) supertype getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :type-value
                   (let* ((get1 (getf initargs 'type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-value getfv))
                   :ir-type-value
                   (let* ((get1
                           (getf initargs 'ir-type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-type-value getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :dependent?
                   (let* ((get1 (getf initargs 'dependent? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dependent? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dependent? getfv))
                   :associated-decl
                   (let* ((get1
                           (getf initargs 'associated-decl '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :associated-decl
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) associated-decl getfv)))))

(defmethod store-object* ((obj decl-formal-struct-subtype))
  (with-slots (type-expr contains projection supertype declared-type
                         type type-value place unique-id
                         newline-comment id decl-formals formals module
                         refers-to chain? typechecked? visible?
                         generated generated-by semi typecheck-time
                         dependent? associated-decl type-value)
    obj
    (reserve-space 26
                   (push-word (store-obj 'decl-formal-struct-subtype))
                   (push-word (store-obj type-expr))
                   (push-word (store-obj contains))
                   (push-word (store-obj projection))
                   (push-word (store-obj supertype))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj type-value))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj dependent?))
                   (push-word (store-obj associated-decl))
                   (push-word (store-obj (ignore-self-reference-type-values
                                          obj))))))

(defmethod update-fetched ((obj decl-formal-struct-subtype))
  (with-slots (type-expr contains projection supertype declared-type
                         type type-value place unique-id
                         newline-comment id decl-formals formals module
                         refers-to chain? typechecked? visible?
                         generated generated-by semi typecheck-time
                         dependent? associated-decl type-value
                         declared-type-string ir-type-value
                         pvs-sxhash-value tcc-form)
    obj
    (setf type-expr (fetch-obj (stored-word 1)))
    (setf contains (fetch-obj (stored-word 2)))
    (setf projection (fetch-obj (stored-word 3)))
    (setf supertype (fetch-obj (stored-word 4)))
    (setf declared-type (fetch-obj (stored-word 5)))
    (setf type (fetch-obj (stored-word 6)))
    (setf type-value (fetch-obj (stored-word 7)))
    (setf place (fetch-obj (stored-word 8)))
    (setf unique-id (fetch-obj (stored-word 9)))
    (setf newline-comment (fetch-obj (stored-word 10)))
    (setf id (fetch-obj (stored-word 11)))
    (setf decl-formals (fetch-obj (stored-word 12)))
    (setf formals (fetch-obj (stored-word 13)))
    (setf module (fetch-obj (stored-word 14)))
    (setf refers-to (fetch-obj (stored-word 15)))
    (setf chain? (fetch-obj (stored-word 16)))
    (setf typechecked? (fetch-obj (stored-word 17)))
    (setf visible? (fetch-obj (stored-word 18)))
    (setf generated (fetch-obj (stored-word 19)))
    (setf generated-by (fetch-obj (stored-word 20)))
    (setf semi (fetch-obj (stored-word 21)))
    (setf typecheck-time (fetch-obj (stored-word 22)))
    (setf dependent? (fetch-obj (stored-word 23)))
    (setf associated-decl (fetch-obj (stored-word 24)))
    (setf type-value (fetch-obj (stored-word 25)))
    (setf declared-type-string nil)
    (setf ir-type-value nil)
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)))

(defmethod restore-object* ((obj decl-formal-struct-subtype))
  (with-slots (type-expr contains projection supertype declared-type
                         type type-value unique-id decl-formals formals
                         associated-decl)
    obj
    (let ((*restore-object-parent* obj))
      (when type-expr
        (let ((*restore-object-parent-slot* 'type-expr))
          (restore-object* type-expr)))
      (when contains
        (let ((*restore-object-parent-slot* 'contains))
          (restore-object* contains)))
      (when projection
        (let ((*restore-object-parent-slot* 'projection))
          (restore-object* projection)))
      (when supertype
        (let ((*restore-object-parent-slot* 'supertype))
          (restore-object* supertype)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when type-value
        (let ((*restore-object-parent-slot* 'type-value))
          (restore-object* type-value)))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when associated-decl
        (let ((*restore-object-parent-slot* 'associated-decl))
          (restore-object* associated-decl)))
      obj)))

(defmethod copy ((obj formal-struct-subtype-decl) &rest initargs)
  (with-slots (type-expr contains projection supertype declared-type
                         declared-type-string type type-value
                         ir-type-value place unique-id newline-comment
                         id decl-formals formals module refers-to
                         chain? typechecked? visible? generated
                         generated-by semi typecheck-time dependent?)
    obj
    (make-instance 'formal-struct-subtype-decl :type-expr
                   (let* ((get1 (getf initargs 'type-expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-expr getfv))
                   :contains
                   (let* ((get1 (getf initargs 'contains '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :contains '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) contains getfv))
                   :projection
                   (let* ((get1 (getf initargs 'projection '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :projection '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) projection getfv))
                   :supertype
                   (let* ((get1 (getf initargs 'supertype '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :supertype '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) supertype getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :type-value
                   (let* ((get1 (getf initargs 'type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-value getfv))
                   :ir-type-value
                   (let* ((get1
                           (getf initargs 'ir-type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-type-value getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :dependent?
                   (let* ((get1 (getf initargs 'dependent? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dependent? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dependent? getfv)))))

(defmethod store-object* ((obj formal-struct-subtype-decl))
  (with-slots (type-expr contains projection supertype declared-type
                         type type-value place unique-id
                         newline-comment id decl-formals formals module
                         refers-to chain? typechecked? visible?
                         generated generated-by semi typecheck-time
                         dependent? type-value)
    obj
    (reserve-space 25
                   (push-word (store-obj 'formal-struct-subtype-decl))
                   (push-word (store-obj type-expr))
                   (push-word (store-obj contains))
                   (push-word (store-obj projection))
                   (push-word (store-obj supertype))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj type-value))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj dependent?))
                   (push-word (store-obj (ignore-self-reference-type-values
                                          obj))))))

(defmethod update-fetched ((obj formal-struct-subtype-decl))
  (with-slots (type-expr contains projection supertype declared-type
                         type type-value place unique-id
                         newline-comment id decl-formals formals module
                         refers-to chain? typechecked? visible?
                         generated generated-by semi typecheck-time
                         dependent? type-value declared-type-string
                         ir-type-value pvs-sxhash-value tcc-form)
    obj
    (setf type-expr (fetch-obj (stored-word 1)))
    (setf contains (fetch-obj (stored-word 2)))
    (setf projection (fetch-obj (stored-word 3)))
    (setf supertype (fetch-obj (stored-word 4)))
    (setf declared-type (fetch-obj (stored-word 5)))
    (setf type (fetch-obj (stored-word 6)))
    (setf type-value (fetch-obj (stored-word 7)))
    (setf place (fetch-obj (stored-word 8)))
    (setf unique-id (fetch-obj (stored-word 9)))
    (setf newline-comment (fetch-obj (stored-word 10)))
    (setf id (fetch-obj (stored-word 11)))
    (setf decl-formals (fetch-obj (stored-word 12)))
    (setf formals (fetch-obj (stored-word 13)))
    (setf module (fetch-obj (stored-word 14)))
    (setf refers-to (fetch-obj (stored-word 15)))
    (setf chain? (fetch-obj (stored-word 16)))
    (setf typechecked? (fetch-obj (stored-word 17)))
    (setf visible? (fetch-obj (stored-word 18)))
    (setf generated (fetch-obj (stored-word 19)))
    (setf generated-by (fetch-obj (stored-word 20)))
    (setf semi (fetch-obj (stored-word 21)))
    (setf typecheck-time (fetch-obj (stored-word 22)))
    (setf dependent? (fetch-obj (stored-word 23)))
    (setf type-value (fetch-obj (stored-word 24)))
    (setf declared-type-string nil)
    (setf ir-type-value nil)
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)))

(defmethod restore-object* ((obj formal-struct-subtype-decl))
  (with-slots (type-expr contains projection supertype declared-type
                         type type-value unique-id decl-formals
                         formals)
    obj
    (let ((*restore-object-parent* obj))
      (when type-expr
        (let ((*restore-object-parent-slot* 'type-expr))
          (restore-object* type-expr)))
      (when contains
        (let ((*restore-object-parent-slot* 'contains))
          (restore-object* contains)))
      (when projection
        (let ((*restore-object-parent-slot* 'projection))
          (restore-object* projection)))
      (when supertype
        (let ((*restore-object-parent-slot* 'supertype))
          (restore-object* supertype)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when type-value
        (let ((*restore-object-parent-slot* 'type-value))
          (restore-object* type-value)))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      obj)))

(defmethod copy ((obj decl-formal-nonempty-subtype) &rest initargs)
  (with-slots (keyword type-expr contains predicate supertype
                       declared-type declared-type-string type
                       type-value ir-type-value place unique-id
                       newline-comment id decl-formals formals module
                       refers-to chain? typechecked? visible? generated
                       generated-by semi typecheck-time dependent?
                       associated-decl)
    obj
    (make-instance 'decl-formal-nonempty-subtype :keyword
                   (let* ((get1 (getf initargs 'keyword '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :keyword '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) keyword getfv))
                   :type-expr
                   (let* ((get1 (getf initargs 'type-expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-expr getfv))
                   :contains
                   (let* ((get1 (getf initargs 'contains '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :contains '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) contains getfv))
                   :predicate
                   (let* ((get1 (getf initargs 'predicate '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :predicate '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) predicate getfv))
                   :supertype
                   (let* ((get1 (getf initargs 'supertype '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :supertype '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) supertype getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :type-value
                   (let* ((get1 (getf initargs 'type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-value getfv))
                   :ir-type-value
                   (let* ((get1
                           (getf initargs 'ir-type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-type-value getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :dependent?
                   (let* ((get1 (getf initargs 'dependent? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dependent? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dependent? getfv))
                   :associated-decl
                   (let* ((get1
                           (getf initargs 'associated-decl '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :associated-decl
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) associated-decl getfv)))))

(defmethod store-object* ((obj decl-formal-nonempty-subtype))
  (with-slots (keyword type-expr contains predicate supertype
                       declared-type type type-value place unique-id
                       newline-comment id decl-formals formals module
                       refers-to chain? typechecked? visible? generated
                       generated-by semi typecheck-time dependent?
                       associated-decl type-value)
    obj
    (reserve-space 27
                   (push-word (store-obj 'decl-formal-nonempty-subtype))
                   (push-word (store-obj keyword))
                   (push-word (store-obj type-expr))
                   (push-word (store-obj contains))
                   (push-word (store-obj predicate))
                   (push-word (store-obj supertype))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj type-value))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj dependent?))
                   (push-word (store-obj associated-decl))
                   (push-word (store-obj (ignore-self-reference-type-values
                                          obj))))))

(defmethod update-fetched ((obj decl-formal-nonempty-subtype))
  (with-slots (keyword type-expr contains predicate supertype
                       declared-type type type-value place unique-id
                       newline-comment id decl-formals formals module
                       refers-to chain? typechecked? visible? generated
                       generated-by semi typecheck-time dependent?
                       associated-decl type-value declared-type-string
                       ir-type-value pvs-sxhash-value tcc-form)
    obj
    (setf keyword (fetch-obj (stored-word 1)))
    (setf type-expr (fetch-obj (stored-word 2)))
    (setf contains (fetch-obj (stored-word 3)))
    (setf predicate (fetch-obj (stored-word 4)))
    (setf supertype (fetch-obj (stored-word 5)))
    (setf declared-type (fetch-obj (stored-word 6)))
    (setf type (fetch-obj (stored-word 7)))
    (setf type-value (fetch-obj (stored-word 8)))
    (setf place (fetch-obj (stored-word 9)))
    (setf unique-id (fetch-obj (stored-word 10)))
    (setf newline-comment (fetch-obj (stored-word 11)))
    (setf id (fetch-obj (stored-word 12)))
    (setf decl-formals (fetch-obj (stored-word 13)))
    (setf formals (fetch-obj (stored-word 14)))
    (setf module (fetch-obj (stored-word 15)))
    (setf refers-to (fetch-obj (stored-word 16)))
    (setf chain? (fetch-obj (stored-word 17)))
    (setf typechecked? (fetch-obj (stored-word 18)))
    (setf visible? (fetch-obj (stored-word 19)))
    (setf generated (fetch-obj (stored-word 20)))
    (setf generated-by (fetch-obj (stored-word 21)))
    (setf semi (fetch-obj (stored-word 22)))
    (setf typecheck-time (fetch-obj (stored-word 23)))
    (setf dependent? (fetch-obj (stored-word 24)))
    (setf associated-decl (fetch-obj (stored-word 25)))
    (setf type-value (fetch-obj (stored-word 26)))
    (setf declared-type-string nil)
    (setf ir-type-value nil)
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)))

(defmethod restore-object* ((obj decl-formal-nonempty-subtype))
  (with-slots (type-expr contains predicate supertype declared-type
                         type type-value unique-id decl-formals formals
                         associated-decl)
    obj
    (let ((*restore-object-parent* obj))
      (when type-expr
        (let ((*restore-object-parent-slot* 'type-expr))
          (restore-object* type-expr)))
      (when contains
        (let ((*restore-object-parent-slot* 'contains))
          (restore-object* contains)))
      (when predicate
        (let ((*restore-object-parent-slot* 'predicate))
          (restore-object* predicate)))
      (when supertype
        (let ((*restore-object-parent-slot* 'supertype))
          (restore-object* supertype)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when type-value
        (let ((*restore-object-parent-slot* 'type-value))
          (restore-object* type-value)))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when associated-decl
        (let ((*restore-object-parent-slot* 'associated-decl))
          (restore-object* associated-decl)))
      obj)))

(defmethod copy ((obj formal-nonempty-subtype-decl) &rest initargs)
  (with-slots (keyword type-expr contains predicate supertype
                       declared-type declared-type-string type
                       type-value ir-type-value place unique-id
                       newline-comment id decl-formals formals module
                       refers-to chain? typechecked? visible? generated
                       generated-by semi typecheck-time dependent?)
    obj
    (make-instance 'formal-nonempty-subtype-decl :keyword
                   (let* ((get1 (getf initargs 'keyword '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :keyword '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) keyword getfv))
                   :type-expr
                   (let* ((get1 (getf initargs 'type-expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-expr getfv))
                   :contains
                   (let* ((get1 (getf initargs 'contains '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :contains '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) contains getfv))
                   :predicate
                   (let* ((get1 (getf initargs 'predicate '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :predicate '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) predicate getfv))
                   :supertype
                   (let* ((get1 (getf initargs 'supertype '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :supertype '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) supertype getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :type-value
                   (let* ((get1 (getf initargs 'type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-value getfv))
                   :ir-type-value
                   (let* ((get1
                           (getf initargs 'ir-type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-type-value getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :dependent?
                   (let* ((get1 (getf initargs 'dependent? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dependent? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dependent? getfv)))))

(defmethod store-object* ((obj formal-nonempty-subtype-decl))
  (with-slots (keyword type-expr contains predicate supertype
                       declared-type type type-value place unique-id
                       newline-comment id decl-formals formals module
                       refers-to chain? typechecked? visible? generated
                       generated-by semi typecheck-time dependent?
                       type-value)
    obj
    (reserve-space 26
                   (push-word (store-obj 'formal-nonempty-subtype-decl))
                   (push-word (store-obj keyword))
                   (push-word (store-obj type-expr))
                   (push-word (store-obj contains))
                   (push-word (store-obj predicate))
                   (push-word (store-obj supertype))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj type-value))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj dependent?))
                   (push-word (store-obj (ignore-self-reference-type-values
                                          obj))))))

(defmethod update-fetched ((obj formal-nonempty-subtype-decl))
  (with-slots (keyword type-expr contains predicate supertype
                       declared-type type type-value place unique-id
                       newline-comment id decl-formals formals module
                       refers-to chain? typechecked? visible? generated
                       generated-by semi typecheck-time dependent?
                       type-value declared-type-string ir-type-value
                       pvs-sxhash-value tcc-form)
    obj
    (setf keyword (fetch-obj (stored-word 1)))
    (setf type-expr (fetch-obj (stored-word 2)))
    (setf contains (fetch-obj (stored-word 3)))
    (setf predicate (fetch-obj (stored-word 4)))
    (setf supertype (fetch-obj (stored-word 5)))
    (setf declared-type (fetch-obj (stored-word 6)))
    (setf type (fetch-obj (stored-word 7)))
    (setf type-value (fetch-obj (stored-word 8)))
    (setf place (fetch-obj (stored-word 9)))
    (setf unique-id (fetch-obj (stored-word 10)))
    (setf newline-comment (fetch-obj (stored-word 11)))
    (setf id (fetch-obj (stored-word 12)))
    (setf decl-formals (fetch-obj (stored-word 13)))
    (setf formals (fetch-obj (stored-word 14)))
    (setf module (fetch-obj (stored-word 15)))
    (setf refers-to (fetch-obj (stored-word 16)))
    (setf chain? (fetch-obj (stored-word 17)))
    (setf typechecked? (fetch-obj (stored-word 18)))
    (setf visible? (fetch-obj (stored-word 19)))
    (setf generated (fetch-obj (stored-word 20)))
    (setf generated-by (fetch-obj (stored-word 21)))
    (setf semi (fetch-obj (stored-word 22)))
    (setf typecheck-time (fetch-obj (stored-word 23)))
    (setf dependent? (fetch-obj (stored-word 24)))
    (setf type-value (fetch-obj (stored-word 25)))
    (setf declared-type-string nil)
    (setf ir-type-value nil)
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)))

(defmethod restore-object* ((obj formal-nonempty-subtype-decl))
  (with-slots (type-expr contains predicate supertype declared-type
                         type type-value unique-id decl-formals
                         formals)
    obj
    (let ((*restore-object-parent* obj))
      (when type-expr
        (let ((*restore-object-parent-slot* 'type-expr))
          (restore-object* type-expr)))
      (when contains
        (let ((*restore-object-parent-slot* 'contains))
          (restore-object* contains)))
      (when predicate
        (let ((*restore-object-parent-slot* 'predicate))
          (restore-object* predicate)))
      (when supertype
        (let ((*restore-object-parent-slot* 'supertype))
          (restore-object* supertype)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when type-value
        (let ((*restore-object-parent-slot* 'type-value))
          (restore-object* type-value)))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      obj)))

(defmethod copy ((obj decl-formal-subtype) &rest initargs)
  (with-slots (type-expr contains predicate supertype declared-type
                         declared-type-string type type-value
                         ir-type-value place unique-id newline-comment
                         id decl-formals formals module refers-to
                         chain? typechecked? visible? generated
                         generated-by semi typecheck-time dependent?
                         associated-decl)
    obj
    (make-instance 'decl-formal-subtype :type-expr
                   (let* ((get1 (getf initargs 'type-expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-expr getfv))
                   :contains
                   (let* ((get1 (getf initargs 'contains '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :contains '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) contains getfv))
                   :predicate
                   (let* ((get1 (getf initargs 'predicate '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :predicate '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) predicate getfv))
                   :supertype
                   (let* ((get1 (getf initargs 'supertype '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :supertype '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) supertype getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :type-value
                   (let* ((get1 (getf initargs 'type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-value getfv))
                   :ir-type-value
                   (let* ((get1
                           (getf initargs 'ir-type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-type-value getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :dependent?
                   (let* ((get1 (getf initargs 'dependent? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dependent? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dependent? getfv))
                   :associated-decl
                   (let* ((get1
                           (getf initargs 'associated-decl '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :associated-decl
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) associated-decl getfv)))))

(defmethod store-object* ((obj decl-formal-subtype))
  (with-slots (type-expr contains predicate supertype declared-type
                         type type-value place unique-id
                         newline-comment id decl-formals formals module
                         refers-to chain? typechecked? visible?
                         generated generated-by semi typecheck-time
                         dependent? associated-decl type-value)
    obj
    (reserve-space 26 (push-word (store-obj 'decl-formal-subtype))
                   (push-word (store-obj type-expr))
                   (push-word (store-obj contains))
                   (push-word (store-obj predicate))
                   (push-word (store-obj supertype))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj type-value))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj dependent?))
                   (push-word (store-obj associated-decl))
                   (push-word (store-obj (ignore-self-reference-type-values
                                          obj))))))

(defmethod update-fetched ((obj decl-formal-subtype))
  (with-slots (type-expr contains predicate supertype declared-type
                         type type-value place unique-id
                         newline-comment id decl-formals formals module
                         refers-to chain? typechecked? visible?
                         generated generated-by semi typecheck-time
                         dependent? associated-decl type-value
                         declared-type-string ir-type-value
                         pvs-sxhash-value tcc-form)
    obj
    (setf type-expr (fetch-obj (stored-word 1)))
    (setf contains (fetch-obj (stored-word 2)))
    (setf predicate (fetch-obj (stored-word 3)))
    (setf supertype (fetch-obj (stored-word 4)))
    (setf declared-type (fetch-obj (stored-word 5)))
    (setf type (fetch-obj (stored-word 6)))
    (setf type-value (fetch-obj (stored-word 7)))
    (setf place (fetch-obj (stored-word 8)))
    (setf unique-id (fetch-obj (stored-word 9)))
    (setf newline-comment (fetch-obj (stored-word 10)))
    (setf id (fetch-obj (stored-word 11)))
    (setf decl-formals (fetch-obj (stored-word 12)))
    (setf formals (fetch-obj (stored-word 13)))
    (setf module (fetch-obj (stored-word 14)))
    (setf refers-to (fetch-obj (stored-word 15)))
    (setf chain? (fetch-obj (stored-word 16)))
    (setf typechecked? (fetch-obj (stored-word 17)))
    (setf visible? (fetch-obj (stored-word 18)))
    (setf generated (fetch-obj (stored-word 19)))
    (setf generated-by (fetch-obj (stored-word 20)))
    (setf semi (fetch-obj (stored-word 21)))
    (setf typecheck-time (fetch-obj (stored-word 22)))
    (setf dependent? (fetch-obj (stored-word 23)))
    (setf associated-decl (fetch-obj (stored-word 24)))
    (setf type-value (fetch-obj (stored-word 25)))
    (setf declared-type-string nil)
    (setf ir-type-value nil)
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)))

(defmethod restore-object* ((obj decl-formal-subtype))
  (with-slots (type-expr contains predicate supertype declared-type
                         type type-value unique-id decl-formals formals
                         associated-decl)
    obj
    (let ((*restore-object-parent* obj))
      (when type-expr
        (let ((*restore-object-parent-slot* 'type-expr))
          (restore-object* type-expr)))
      (when contains
        (let ((*restore-object-parent-slot* 'contains))
          (restore-object* contains)))
      (when predicate
        (let ((*restore-object-parent-slot* 'predicate))
          (restore-object* predicate)))
      (when supertype
        (let ((*restore-object-parent-slot* 'supertype))
          (restore-object* supertype)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when type-value
        (let ((*restore-object-parent-slot* 'type-value))
          (restore-object* type-value)))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when associated-decl
        (let ((*restore-object-parent-slot* 'associated-decl))
          (restore-object* associated-decl)))
      obj)))

(defmethod copy ((obj formal-subtype-decl) &rest initargs)
  (with-slots (type-expr contains predicate supertype declared-type
                         declared-type-string type type-value
                         ir-type-value place unique-id newline-comment
                         id decl-formals formals module refers-to
                         chain? typechecked? visible? generated
                         generated-by semi typecheck-time dependent?)
    obj
    (make-instance 'formal-subtype-decl :type-expr
                   (let* ((get1 (getf initargs 'type-expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-expr getfv))
                   :contains
                   (let* ((get1 (getf initargs 'contains '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :contains '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) contains getfv))
                   :predicate
                   (let* ((get1 (getf initargs 'predicate '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :predicate '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) predicate getfv))
                   :supertype
                   (let* ((get1 (getf initargs 'supertype '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :supertype '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) supertype getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :type-value
                   (let* ((get1 (getf initargs 'type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-value getfv))
                   :ir-type-value
                   (let* ((get1
                           (getf initargs 'ir-type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-type-value getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :dependent?
                   (let* ((get1 (getf initargs 'dependent? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dependent? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dependent? getfv)))))

(defmethod store-object* ((obj formal-subtype-decl))
  (with-slots (type-expr contains predicate supertype declared-type
                         type type-value place unique-id
                         newline-comment id decl-formals formals module
                         refers-to chain? typechecked? visible?
                         generated generated-by semi typecheck-time
                         dependent? type-value)
    obj
    (reserve-space 25 (push-word (store-obj 'formal-subtype-decl))
                   (push-word (store-obj type-expr))
                   (push-word (store-obj contains))
                   (push-word (store-obj predicate))
                   (push-word (store-obj supertype))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj type-value))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj dependent?))
                   (push-word (store-obj (ignore-self-reference-type-values
                                          obj))))))

(defmethod update-fetched ((obj formal-subtype-decl))
  (with-slots (type-expr contains predicate supertype declared-type
                         type type-value place unique-id
                         newline-comment id decl-formals formals module
                         refers-to chain? typechecked? visible?
                         generated generated-by semi typecheck-time
                         dependent? type-value declared-type-string
                         ir-type-value pvs-sxhash-value tcc-form)
    obj
    (setf type-expr (fetch-obj (stored-word 1)))
    (setf contains (fetch-obj (stored-word 2)))
    (setf predicate (fetch-obj (stored-word 3)))
    (setf supertype (fetch-obj (stored-word 4)))
    (setf declared-type (fetch-obj (stored-word 5)))
    (setf type (fetch-obj (stored-word 6)))
    (setf type-value (fetch-obj (stored-word 7)))
    (setf place (fetch-obj (stored-word 8)))
    (setf unique-id (fetch-obj (stored-word 9)))
    (setf newline-comment (fetch-obj (stored-word 10)))
    (setf id (fetch-obj (stored-word 11)))
    (setf decl-formals (fetch-obj (stored-word 12)))
    (setf formals (fetch-obj (stored-word 13)))
    (setf module (fetch-obj (stored-word 14)))
    (setf refers-to (fetch-obj (stored-word 15)))
    (setf chain? (fetch-obj (stored-word 16)))
    (setf typechecked? (fetch-obj (stored-word 17)))
    (setf visible? (fetch-obj (stored-word 18)))
    (setf generated (fetch-obj (stored-word 19)))
    (setf generated-by (fetch-obj (stored-word 20)))
    (setf semi (fetch-obj (stored-word 21)))
    (setf typecheck-time (fetch-obj (stored-word 22)))
    (setf dependent? (fetch-obj (stored-word 23)))
    (setf type-value (fetch-obj (stored-word 24)))
    (setf declared-type-string nil)
    (setf ir-type-value nil)
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)))

(defmethod restore-object* ((obj formal-subtype-decl))
  (with-slots (type-expr contains predicate supertype declared-type
                         type type-value unique-id decl-formals
                         formals)
    obj
    (let ((*restore-object-parent* obj))
      (when type-expr
        (let ((*restore-object-parent-slot* 'type-expr))
          (restore-object* type-expr)))
      (when contains
        (let ((*restore-object-parent-slot* 'contains))
          (restore-object* contains)))
      (when predicate
        (let ((*restore-object-parent-slot* 'predicate))
          (restore-object* predicate)))
      (when supertype
        (let ((*restore-object-parent-slot* 'supertype))
          (restore-object* supertype)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when type-value
        (let ((*restore-object-parent-slot* 'type-value))
          (restore-object* type-value)))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      obj)))

(defmethod copy ((obj decl-formal-nonempty-type) &rest initargs)
  (with-slots (keyword declared-type declared-type-string type
                       type-value ir-type-value place unique-id
                       newline-comment id decl-formals formals module
                       refers-to chain? typechecked? visible? generated
                       generated-by semi typecheck-time dependent?
                       associated-decl)
    obj
    (make-instance 'decl-formal-nonempty-type :keyword
                   (let* ((get1 (getf initargs 'keyword '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :keyword '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) keyword getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :type-value
                   (let* ((get1 (getf initargs 'type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-value getfv))
                   :ir-type-value
                   (let* ((get1
                           (getf initargs 'ir-type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-type-value getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :dependent?
                   (let* ((get1 (getf initargs 'dependent? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dependent? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dependent? getfv))
                   :associated-decl
                   (let* ((get1
                           (getf initargs 'associated-decl '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :associated-decl
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) associated-decl getfv)))))

(defmethod store-object* ((obj decl-formal-nonempty-type))
  (with-slots (keyword declared-type type type-value place unique-id
                       newline-comment id decl-formals formals module
                       refers-to chain? typechecked? visible? generated
                       generated-by semi typecheck-time dependent?
                       associated-decl type-value)
    obj
    (reserve-space 23
                   (push-word (store-obj 'decl-formal-nonempty-type))
                   (push-word (store-obj keyword))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj type-value))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj dependent?))
                   (push-word (store-obj associated-decl))
                   (push-word (store-obj (ignore-self-reference-type-values
                                          obj))))))

(defmethod update-fetched ((obj decl-formal-nonempty-type))
  (with-slots (keyword declared-type type type-value place unique-id
                       newline-comment id decl-formals formals module
                       refers-to chain? typechecked? visible? generated
                       generated-by semi typecheck-time dependent?
                       associated-decl type-value declared-type-string
                       ir-type-value pvs-sxhash-value tcc-form)
    obj
    (setf keyword (fetch-obj (stored-word 1)))
    (setf declared-type (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf type-value (fetch-obj (stored-word 4)))
    (setf place (fetch-obj (stored-word 5)))
    (setf unique-id (fetch-obj (stored-word 6)))
    (setf newline-comment (fetch-obj (stored-word 7)))
    (setf id (fetch-obj (stored-word 8)))
    (setf decl-formals (fetch-obj (stored-word 9)))
    (setf formals (fetch-obj (stored-word 10)))
    (setf module (fetch-obj (stored-word 11)))
    (setf refers-to (fetch-obj (stored-word 12)))
    (setf chain? (fetch-obj (stored-word 13)))
    (setf typechecked? (fetch-obj (stored-word 14)))
    (setf visible? (fetch-obj (stored-word 15)))
    (setf generated (fetch-obj (stored-word 16)))
    (setf generated-by (fetch-obj (stored-word 17)))
    (setf semi (fetch-obj (stored-word 18)))
    (setf typecheck-time (fetch-obj (stored-word 19)))
    (setf dependent? (fetch-obj (stored-word 20)))
    (setf associated-decl (fetch-obj (stored-word 21)))
    (setf type-value (fetch-obj (stored-word 22)))
    (setf declared-type-string nil)
    (setf ir-type-value nil)
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)))

(defmethod restore-object* ((obj decl-formal-nonempty-type))
  (with-slots (declared-type type type-value unique-id decl-formals
                             formals associated-decl)
    obj
    (let ((*restore-object-parent* obj))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when type-value
        (let ((*restore-object-parent-slot* 'type-value))
          (restore-object* type-value)))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when associated-decl
        (let ((*restore-object-parent-slot* 'associated-decl))
          (restore-object* associated-decl)))
      obj)))

(defmethod copy ((obj formal-nonempty-type-decl) &rest initargs)
  (with-slots (keyword declared-type declared-type-string type
                       type-value ir-type-value place unique-id
                       newline-comment id decl-formals formals module
                       refers-to chain? typechecked? visible? generated
                       generated-by semi typecheck-time dependent?)
    obj
    (make-instance 'formal-nonempty-type-decl :keyword
                   (let* ((get1 (getf initargs 'keyword '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :keyword '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) keyword getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :type-value
                   (let* ((get1 (getf initargs 'type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-value getfv))
                   :ir-type-value
                   (let* ((get1
                           (getf initargs 'ir-type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-type-value getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :dependent?
                   (let* ((get1 (getf initargs 'dependent? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dependent? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dependent? getfv)))))

(defmethod store-object* ((obj formal-nonempty-type-decl))
  (with-slots (keyword declared-type type type-value place unique-id
                       newline-comment id decl-formals formals module
                       refers-to chain? typechecked? visible? generated
                       generated-by semi typecheck-time dependent?
                       type-value)
    obj
    (reserve-space 22
                   (push-word (store-obj 'formal-nonempty-type-decl))
                   (push-word (store-obj keyword))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj type-value))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj dependent?))
                   (push-word (store-obj (ignore-self-reference-type-values
                                          obj))))))

(defmethod update-fetched ((obj formal-nonempty-type-decl))
  (with-slots (keyword declared-type type type-value place unique-id
                       newline-comment id decl-formals formals module
                       refers-to chain? typechecked? visible? generated
                       generated-by semi typecheck-time dependent?
                       type-value declared-type-string ir-type-value
                       pvs-sxhash-value tcc-form)
    obj
    (setf keyword (fetch-obj (stored-word 1)))
    (setf declared-type (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf type-value (fetch-obj (stored-word 4)))
    (setf place (fetch-obj (stored-word 5)))
    (setf unique-id (fetch-obj (stored-word 6)))
    (setf newline-comment (fetch-obj (stored-word 7)))
    (setf id (fetch-obj (stored-word 8)))
    (setf decl-formals (fetch-obj (stored-word 9)))
    (setf formals (fetch-obj (stored-word 10)))
    (setf module (fetch-obj (stored-word 11)))
    (setf refers-to (fetch-obj (stored-word 12)))
    (setf chain? (fetch-obj (stored-word 13)))
    (setf typechecked? (fetch-obj (stored-word 14)))
    (setf visible? (fetch-obj (stored-word 15)))
    (setf generated (fetch-obj (stored-word 16)))
    (setf generated-by (fetch-obj (stored-word 17)))
    (setf semi (fetch-obj (stored-word 18)))
    (setf typecheck-time (fetch-obj (stored-word 19)))
    (setf dependent? (fetch-obj (stored-word 20)))
    (setf type-value (fetch-obj (stored-word 21)))
    (setf declared-type-string nil)
    (setf ir-type-value nil)
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)))

(defmethod restore-object* ((obj formal-nonempty-type-decl))
  (with-slots (declared-type type type-value unique-id decl-formals
                             formals)
    obj
    (let ((*restore-object-parent* obj))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when type-value
        (let ((*restore-object-parent-slot* 'type-value))
          (restore-object* type-value)))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      obj)))

(defmethod copy ((obj decl-formal-type) &rest initargs)
  (with-slots (declared-type declared-type-string type type-value
                             ir-type-value place unique-id
                             newline-comment id decl-formals formals
                             module refers-to chain? typechecked?
                             visible? generated generated-by semi
                             typecheck-time dependent? associated-decl)
    obj
    (make-instance 'decl-formal-type :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :type-value
                   (let* ((get1 (getf initargs 'type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-value getfv))
                   :ir-type-value
                   (let* ((get1
                           (getf initargs 'ir-type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-type-value getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :dependent?
                   (let* ((get1 (getf initargs 'dependent? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dependent? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dependent? getfv))
                   :associated-decl
                   (let* ((get1
                           (getf initargs 'associated-decl '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :associated-decl
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) associated-decl getfv)))))

(defmethod store-object* ((obj decl-formal-type))
  (with-slots (declared-type type type-value place unique-id
                             newline-comment id decl-formals formals
                             module refers-to chain? typechecked?
                             visible? generated generated-by semi
                             typecheck-time dependent? associated-decl
                             type-value)
    obj
    (reserve-space 22 (push-word (store-obj 'decl-formal-type))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj type-value))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj dependent?))
                   (push-word (store-obj associated-decl))
                   (push-word (store-obj (ignore-self-reference-type-values
                                          obj))))))

(defmethod update-fetched ((obj decl-formal-type))
  (with-slots (declared-type type type-value place unique-id
                             newline-comment id decl-formals formals
                             module refers-to chain? typechecked?
                             visible? generated generated-by semi
                             typecheck-time dependent? associated-decl
                             type-value declared-type-string
                             ir-type-value pvs-sxhash-value tcc-form)
    obj
    (setf declared-type (fetch-obj (stored-word 1)))
    (setf type (fetch-obj (stored-word 2)))
    (setf type-value (fetch-obj (stored-word 3)))
    (setf place (fetch-obj (stored-word 4)))
    (setf unique-id (fetch-obj (stored-word 5)))
    (setf newline-comment (fetch-obj (stored-word 6)))
    (setf id (fetch-obj (stored-word 7)))
    (setf decl-formals (fetch-obj (stored-word 8)))
    (setf formals (fetch-obj (stored-word 9)))
    (setf module (fetch-obj (stored-word 10)))
    (setf refers-to (fetch-obj (stored-word 11)))
    (setf chain? (fetch-obj (stored-word 12)))
    (setf typechecked? (fetch-obj (stored-word 13)))
    (setf visible? (fetch-obj (stored-word 14)))
    (setf generated (fetch-obj (stored-word 15)))
    (setf generated-by (fetch-obj (stored-word 16)))
    (setf semi (fetch-obj (stored-word 17)))
    (setf typecheck-time (fetch-obj (stored-word 18)))
    (setf dependent? (fetch-obj (stored-word 19)))
    (setf associated-decl (fetch-obj (stored-word 20)))
    (setf type-value (fetch-obj (stored-word 21)))
    (setf declared-type-string nil)
    (setf ir-type-value nil)
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)))

(defmethod restore-object* ((obj decl-formal-type))
  (with-slots (declared-type type type-value unique-id decl-formals
                             formals associated-decl)
    obj
    (let ((*restore-object-parent* obj))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when type-value
        (let ((*restore-object-parent-slot* 'type-value))
          (restore-object* type-value)))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when associated-decl
        (let ((*restore-object-parent-slot* 'associated-decl))
          (restore-object* associated-decl)))
      obj)))

(defmethod copy ((obj formal-type-decl) &rest initargs)
  (with-slots (declared-type declared-type-string type type-value
                             ir-type-value place unique-id
                             newline-comment id decl-formals formals
                             module refers-to chain? typechecked?
                             visible? generated generated-by semi
                             typecheck-time dependent?)
    obj
    (make-instance 'formal-type-decl :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :type-value
                   (let* ((get1 (getf initargs 'type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-value getfv))
                   :ir-type-value
                   (let* ((get1
                           (getf initargs 'ir-type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-type-value getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :dependent?
                   (let* ((get1 (getf initargs 'dependent? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dependent? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dependent? getfv)))))

(defmethod store-object* ((obj formal-type-decl))
  (with-slots (declared-type type type-value place unique-id
                             newline-comment id decl-formals formals
                             module refers-to chain? typechecked?
                             visible? generated generated-by semi
                             typecheck-time dependent? type-value)
    obj
    (reserve-space 21 (push-word (store-obj 'formal-type-decl))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj type-value))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj dependent?))
                   (push-word (store-obj (ignore-self-reference-type-values
                                          obj))))))

(defmethod update-fetched ((obj formal-type-decl))
  (with-slots (declared-type type type-value place unique-id
                             newline-comment id decl-formals formals
                             module refers-to chain? typechecked?
                             visible? generated generated-by semi
                             typecheck-time dependent? type-value
                             declared-type-string ir-type-value
                             pvs-sxhash-value tcc-form)
    obj
    (setf declared-type (fetch-obj (stored-word 1)))
    (setf type (fetch-obj (stored-word 2)))
    (setf type-value (fetch-obj (stored-word 3)))
    (setf place (fetch-obj (stored-word 4)))
    (setf unique-id (fetch-obj (stored-word 5)))
    (setf newline-comment (fetch-obj (stored-word 6)))
    (setf id (fetch-obj (stored-word 7)))
    (setf decl-formals (fetch-obj (stored-word 8)))
    (setf formals (fetch-obj (stored-word 9)))
    (setf module (fetch-obj (stored-word 10)))
    (setf refers-to (fetch-obj (stored-word 11)))
    (setf chain? (fetch-obj (stored-word 12)))
    (setf typechecked? (fetch-obj (stored-word 13)))
    (setf visible? (fetch-obj (stored-word 14)))
    (setf generated (fetch-obj (stored-word 15)))
    (setf generated-by (fetch-obj (stored-word 16)))
    (setf semi (fetch-obj (stored-word 17)))
    (setf typecheck-time (fetch-obj (stored-word 18)))
    (setf dependent? (fetch-obj (stored-word 19)))
    (setf type-value (fetch-obj (stored-word 20)))
    (setf declared-type-string nil)
    (setf ir-type-value nil)
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)))

(defmethod restore-object* ((obj formal-type-decl))
  (with-slots (declared-type type type-value unique-id decl-formals
                             formals)
    obj
    (let ((*restore-object-parent* obj))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when type-value
        (let ((*restore-object-parent-slot* 'type-value))
          (restore-object* type-value)))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      obj)))

(defmethod copy ((obj decl-formal) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     dependent?)
    obj
    (make-instance 'decl-formal :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :dependent?
                   (let* ((get1 (getf initargs 'dependent? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dependent? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dependent? getfv)))))

(defmethod store-object* ((obj decl-formal))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     dependent?)
    obj
    (reserve-space 17 (push-word (store-obj 'decl-formal))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj dependent?)))))

(defmethod update-fetched ((obj decl-formal))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     dependent? pvs-sxhash-value tcc-form)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf dependent? (fetch-obj (stored-word 16)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)))

(defmethod restore-object* ((obj decl-formal))
  (with-slots (unique-id decl-formals formals)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      obj)))

(defmethod copy ((obj formal-decl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     dependent?)
    obj
    (make-instance 'formal-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :dependent?
                   (let* ((get1 (getf initargs 'dependent? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dependent? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dependent? getfv)))))

(defmethod store-object* ((obj formal-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     dependent?)
    obj
    (reserve-space 17 (push-word (store-obj 'formal-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj dependent?)))))

(defmethod update-fetched ((obj formal-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     dependent? pvs-sxhash-value tcc-form)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf dependent? (fetch-obj (stored-word 16)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)))

(defmethod restore-object* ((obj formal-decl))
  (with-slots (unique-id decl-formals formals)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      obj)))

(defmethod copy ((obj theory-reference) &rest initargs)
  (with-slots (saved-context place unique-id newline-comment id
                             decl-formals formals module refers-to
                             chain? typechecked? visible? generated
                             generated-by semi typecheck-time)
    obj
    (make-instance 'theory-reference :saved-context
                   (let* ((get1
                           (getf initargs 'saved-context '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :saved-context '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) saved-context getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv)))))

(defmethod store-object* ((obj theory-reference))
  (with-slots (saved-context place unique-id newline-comment id
                             decl-formals formals module refers-to
                             chain? typechecked? visible? generated
                             generated-by semi typecheck-time)
    obj
    (reserve-space 17 (push-word (store-obj 'theory-reference))
                   (push-word (store-obj saved-context))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time)))))

(defmethod update-fetched ((obj theory-reference))
  (with-slots (saved-context place unique-id newline-comment id
                             decl-formals formals module refers-to
                             chain? typechecked? visible? generated
                             generated-by semi typecheck-time
                             pvs-sxhash-value tcc-form)
    obj
    (setf saved-context (fetch-obj (stored-word 1)))
    (setf place (fetch-obj (stored-word 2)))
    (setf unique-id (fetch-obj (stored-word 3)))
    (setf newline-comment (fetch-obj (stored-word 4)))
    (setf id (fetch-obj (stored-word 5)))
    (setf decl-formals (fetch-obj (stored-word 6)))
    (setf formals (fetch-obj (stored-word 7)))
    (setf module (fetch-obj (stored-word 8)))
    (setf refers-to (fetch-obj (stored-word 9)))
    (setf chain? (fetch-obj (stored-word 10)))
    (setf typechecked? (fetch-obj (stored-word 11)))
    (setf visible? (fetch-obj (stored-word 12)))
    (setf generated (fetch-obj (stored-word 13)))
    (setf generated-by (fetch-obj (stored-word 14)))
    (setf semi (fetch-obj (stored-word 15)))
    (setf typecheck-time (fetch-obj (stored-word 16)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)))

(defmethod restore-object* ((obj theory-reference))
  (with-slots (saved-context unique-id decl-formals formals)
    obj
    (let ((*restore-object-parent* obj))
      (when saved-context
        (let ((*restore-object-parent-slot* 'saved-context))
          (restore-object* saved-context)))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      obj)))

(defmethod copy ((obj units-name) &rest initargs)
  (with-slots (scale dimensionality mod-id library actuals dactuals
                     acts-there? dacts-there? id mappings target
                     resolutions place parens print-type ghost?
                     from-conversion nonempty?)
    obj
    (make-instance 'units-name :scale
                   (let* ((get1 (getf initargs 'scale '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :scale '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) scale getfv))
                   :dimensionality
                   (let* ((get1
                           (getf initargs 'dimensionality '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dimensionality '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dimensionality getfv))
                   :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :print-type
                   (let* ((get1 (getf initargs 'print-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :print-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) print-type getfv))
                   :ghost?
                   (let* ((get1 (getf initargs 'ghost? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ghost? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ghost? getfv))
                   :from-conversion
                   (let* ((get1
                           (getf initargs 'from-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :from-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-conversion getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :nonempty?
                   (let* ((get1 (getf initargs 'nonempty? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty? getfv)))))

(defmethod store-object* ((obj units-name))
  (with-slots (scale dimensionality mod-id library actuals dactuals
                     acts-there? dacts-there? id mappings target
                     resolutions place parens print-type ghost?
                     from-conversion nonempty?)
    obj
    (reserve-space 19 (push-word (store-obj 'units-name))
                   (push-word (store-obj scale))
                   (push-word (store-obj dimensionality))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj print-type))
                   (push-word (store-obj ghost?))
                   (push-word (store-obj from-conversion))
                   (push-word (store-obj nonempty?)))))

(defmethod update-fetched ((obj units-name))
  (with-slots (scale dimensionality mod-id library actuals dactuals
                     acts-there? dacts-there? id mappings target
                     resolutions place parens print-type ghost?
                     from-conversion nonempty? pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf scale (fetch-obj (stored-word 1)))
    (setf dimensionality (fetch-obj (stored-word 2)))
    (setf mod-id (fetch-obj (stored-word 3)))
    (setf library (fetch-obj (stored-word 4)))
    (setf actuals (fetch-obj (stored-word 5)))
    (setf dactuals (fetch-obj (stored-word 6)))
    (setf acts-there? (fetch-obj (stored-word 7)))
    (setf dacts-there? (fetch-obj (stored-word 8)))
    (setf id (fetch-obj (stored-word 9)))
    (setf mappings (fetch-obj (stored-word 10)))
    (setf target (fetch-obj (stored-word 11)))
    (setf resolutions (fetch-obj (stored-word 12)))
    (setf place (fetch-obj (stored-word 13)))
    (setf parens (fetch-obj (stored-word 14)))
    (setf print-type (fetch-obj (stored-word 15)))
    (setf ghost? (fetch-obj (stored-word 16)))
    (setf from-conversion (fetch-obj (stored-word 17)))
    (setf nonempty? (fetch-obj (stored-word 18)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj units-name))
  (with-slots (scale dimensionality actuals dactuals acts-there?
                     dacts-there? mappings target resolutions ghost?
                     from-conversion print-type)
    obj
    (let ((*restore-object-parent* obj))
      (when scale
        (let ((*restore-object-parent-slot* 'scale))
          (restore-object* scale)))
      (when dimensionality
        (let ((*restore-object-parent-slot* 'dimensionality))
          (restore-object* dimensionality)))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      (when ghost?
        (let ((*restore-object-parent-slot* 'ghost?))
          (restore-object* ghost?)))
      (when from-conversion
        (let ((*restore-object-parent-slot* 'from-conversion))
          (restore-object* from-conversion)))
      (when print-type
        (let ((*restore-object-parent-slot* 'print-type))
          (restore-object* print-type)))
      obj)))

(defmethod copy ((obj units-appl) &rest initargs)
  (with-slots (place parens scale dimensionality operator arguments)
    obj
    (make-instance 'units-appl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :scale
                   (let* ((get1 (getf initargs 'scale '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :scale '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) scale getfv))
                   :dimensionality
                   (let* ((get1
                           (getf initargs 'dimensionality '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dimensionality '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dimensionality getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :arguments
                   (let* ((get1 (getf initargs 'arguments '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :arguments '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) arguments getfv)))))

(defmethod store-object* ((obj units-appl))
  (with-slots (place parens scale dimensionality operator arguments)
    obj
    (reserve-space 7 (push-word (store-obj 'units-appl))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj scale))
                   (push-word (store-obj dimensionality))
                   (push-word (store-obj operator))
                   (push-word (store-obj arguments)))))

(defmethod update-fetched ((obj units-appl))
  (with-slots (place parens scale dimensionality operator arguments
                     pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf scale (fetch-obj (stored-word 3)))
    (setf dimensionality (fetch-obj (stored-word 4)))
    (setf operator (fetch-obj (stored-word 5)))
    (setf arguments (fetch-obj (stored-word 6)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj units-appl))
  (with-slots (scale dimensionality operator arguments)
    obj
    (let ((*restore-object-parent* obj))
      (when scale
        (let ((*restore-object-parent-slot* 'scale))
          (restore-object* scale)))
      (when dimensionality
        (let ((*restore-object-parent-slot* 'dimensionality))
          (restore-object* dimensionality)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when arguments
        (let ((*restore-object-parent-slot* 'arguments))
          (restore-object* arguments)))
      obj)))

(defmethod copy ((obj units-expr) &rest initargs)
  (with-slots (place parens scale dimensionality)
    obj
    (make-instance 'units-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :scale
                   (let* ((get1 (getf initargs 'scale '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :scale '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) scale getfv))
                   :dimensionality
                   (let* ((get1
                           (getf initargs 'dimensionality '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dimensionality '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dimensionality getfv)))))

(defmethod store-object* ((obj units-expr))
  (with-slots (place parens scale dimensionality)
    obj
    (reserve-space 5 (push-word (store-obj 'units-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj scale))
                   (push-word (store-obj dimensionality)))))

(defmethod update-fetched ((obj units-expr))
  (with-slots (place parens scale dimensionality pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf scale (fetch-obj (stored-word 3)))
    (setf dimensionality (fetch-obj (stored-word 4)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj units-expr))
  (with-slots (scale dimensionality)
    obj
    (let ((*restore-object-parent* obj))
      (when scale
        (let ((*restore-object-parent-slot* 'scale))
          (restore-object* scale)))
      (when dimensionality
        (let ((*restore-object-parent-slot* 'dimensionality))
          (restore-object* dimensionality)))
      obj)))

(defmethod copy ((obj units-decl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     type-value ir-type-value declared-units offset)
    obj
    (make-instance 'units-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :type-value
                   (let* ((get1 (getf initargs 'type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-value getfv))
                   :ir-type-value
                   (let* ((get1
                           (getf initargs 'ir-type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-type-value getfv))
                   :declared-units
                   (let* ((get1
                           (getf initargs 'declared-units '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-units '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-units getfv))
                   :offset
                   (let* ((get1 (getf initargs 'offset '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :offset '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) offset getfv)))))

(defmethod store-object* ((obj units-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     type-value declared-units offset type-value)
    obj
    (reserve-space 20 (push-word (store-obj 'units-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj type-value))
                   (push-word (store-obj declared-units))
                   (push-word (store-obj offset))
                   (push-word (store-obj (ignore-self-reference-type-values
                                          obj))))))

(defmethod update-fetched ((obj units-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     type-value declared-units offset type-value
                     pvs-sxhash-value tcc-form ir-type-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf type-value (fetch-obj (stored-word 16)))
    (setf declared-units (fetch-obj (stored-word 17)))
    (setf offset (fetch-obj (stored-word 18)))
    (setf type-value (fetch-obj (stored-word 19)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf ir-type-value nil)))

(defmethod restore-object* ((obj units-decl))
  (with-slots (unique-id decl-formals formals type-value declared-units
                         offset)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when type-value
        (let ((*restore-object-parent-slot* 'type-value))
          (restore-object* type-value)))
      (when declared-units
        (let ((*restore-object-parent-slot* 'declared-units))
          (restore-object* declared-units)))
      (when offset
        (let ((*restore-object-parent-slot* 'offset))
          (restore-object* offset)))
      obj)))

(defmethod copy ((obj nonempty-struct-subtype-decl) &rest initargs)
  (with-slots (keyword place unique-id newline-comment id decl-formals
                       formals module refers-to chain? typechecked?
                       visible? generated generated-by semi
                       typecheck-time type-value ir-type-value
                       type-expr contains projection supertype)
    obj
    (make-instance 'nonempty-struct-subtype-decl :keyword
                   (let* ((get1 (getf initargs 'keyword '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :keyword '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) keyword getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :type-value
                   (let* ((get1 (getf initargs 'type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-value getfv))
                   :ir-type-value
                   (let* ((get1
                           (getf initargs 'ir-type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-type-value getfv))
                   :type-expr
                   (let* ((get1 (getf initargs 'type-expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-expr getfv))
                   :contains
                   (let* ((get1 (getf initargs 'contains '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :contains '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) contains getfv))
                   :projection
                   (let* ((get1 (getf initargs 'projection '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :projection '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) projection getfv))
                   :supertype
                   (let* ((get1 (getf initargs 'supertype '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :supertype '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) supertype getfv)))))

(defmethod store-object* ((obj nonempty-struct-subtype-decl))
  (with-slots (keyword place unique-id newline-comment id decl-formals
                       formals module refers-to chain? typechecked?
                       visible? generated generated-by semi
                       typecheck-time type-value type-expr contains
                       projection supertype type-value)
    obj
    (reserve-space 23
                   (push-word (store-obj 'nonempty-struct-subtype-decl))
                   (push-word (store-obj keyword))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj type-value))
                   (push-word (store-obj type-expr))
                   (push-word (store-obj contains))
                   (push-word (store-obj projection))
                   (push-word (store-obj supertype))
                   (push-word (store-obj (ignore-self-reference-type-values
                                          obj))))))

(defmethod update-fetched ((obj nonempty-struct-subtype-decl))
  (with-slots (keyword place unique-id newline-comment id decl-formals
                       formals module refers-to chain? typechecked?
                       visible? generated generated-by semi
                       typecheck-time type-value type-expr contains
                       projection supertype type-value pvs-sxhash-value
                       tcc-form ir-type-value)
    obj
    (setf keyword (fetch-obj (stored-word 1)))
    (setf place (fetch-obj (stored-word 2)))
    (setf unique-id (fetch-obj (stored-word 3)))
    (setf newline-comment (fetch-obj (stored-word 4)))
    (setf id (fetch-obj (stored-word 5)))
    (setf decl-formals (fetch-obj (stored-word 6)))
    (setf formals (fetch-obj (stored-word 7)))
    (setf module (fetch-obj (stored-word 8)))
    (setf refers-to (fetch-obj (stored-word 9)))
    (setf chain? (fetch-obj (stored-word 10)))
    (setf typechecked? (fetch-obj (stored-word 11)))
    (setf visible? (fetch-obj (stored-word 12)))
    (setf generated (fetch-obj (stored-word 13)))
    (setf generated-by (fetch-obj (stored-word 14)))
    (setf semi (fetch-obj (stored-word 15)))
    (setf typecheck-time (fetch-obj (stored-word 16)))
    (setf type-value (fetch-obj (stored-word 17)))
    (setf type-expr (fetch-obj (stored-word 18)))
    (setf contains (fetch-obj (stored-word 19)))
    (setf projection (fetch-obj (stored-word 20)))
    (setf supertype (fetch-obj (stored-word 21)))
    (setf type-value (fetch-obj (stored-word 22)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf ir-type-value nil)))

(defmethod restore-object* ((obj nonempty-struct-subtype-decl))
  (with-slots (unique-id decl-formals formals type-value type-expr
                         contains projection supertype)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when type-value
        (let ((*restore-object-parent-slot* 'type-value))
          (restore-object* type-value)))
      (when type-expr
        (let ((*restore-object-parent-slot* 'type-expr))
          (restore-object* type-expr)))
      (when contains
        (let ((*restore-object-parent-slot* 'contains))
          (restore-object* contains)))
      (when projection
        (let ((*restore-object-parent-slot* 'projection))
          (restore-object* projection)))
      (when supertype
        (let ((*restore-object-parent-slot* 'supertype))
          (restore-object* supertype)))
      obj)))

(defmethod copy ((obj struct-subtype-decl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     type-value ir-type-value type-expr contains
                     projection supertype)
    obj
    (make-instance 'struct-subtype-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :type-value
                   (let* ((get1 (getf initargs 'type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-value getfv))
                   :ir-type-value
                   (let* ((get1
                           (getf initargs 'ir-type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-type-value getfv))
                   :type-expr
                   (let* ((get1 (getf initargs 'type-expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-expr getfv))
                   :contains
                   (let* ((get1 (getf initargs 'contains '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :contains '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) contains getfv))
                   :projection
                   (let* ((get1 (getf initargs 'projection '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :projection '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) projection getfv))
                   :supertype
                   (let* ((get1 (getf initargs 'supertype '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :supertype '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) supertype getfv)))))

(defmethod store-object* ((obj struct-subtype-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     type-value type-expr contains projection supertype
                     type-value)
    obj
    (reserve-space 22 (push-word (store-obj 'struct-subtype-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj type-value))
                   (push-word (store-obj type-expr))
                   (push-word (store-obj contains))
                   (push-word (store-obj projection))
                   (push-word (store-obj supertype))
                   (push-word (store-obj (ignore-self-reference-type-values
                                          obj))))))

(defmethod update-fetched ((obj struct-subtype-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     type-value type-expr contains projection supertype
                     type-value pvs-sxhash-value tcc-form
                     ir-type-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf type-value (fetch-obj (stored-word 16)))
    (setf type-expr (fetch-obj (stored-word 17)))
    (setf contains (fetch-obj (stored-word 18)))
    (setf projection (fetch-obj (stored-word 19)))
    (setf supertype (fetch-obj (stored-word 20)))
    (setf type-value (fetch-obj (stored-word 21)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf ir-type-value nil)))

(defmethod restore-object* ((obj struct-subtype-decl))
  (with-slots (unique-id decl-formals formals type-value type-expr
                         contains projection supertype)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when type-value
        (let ((*restore-object-parent-slot* 'type-value))
          (restore-object* type-value)))
      (when type-expr
        (let ((*restore-object-parent-slot* 'type-expr))
          (restore-object* type-expr)))
      (when contains
        (let ((*restore-object-parent-slot* 'contains))
          (restore-object* contains)))
      (when projection
        (let ((*restore-object-parent-slot* 'projection))
          (restore-object* projection)))
      (when supertype
        (let ((*restore-object-parent-slot* 'supertype))
          (restore-object* supertype)))
      obj)))

(defmethod copy ((obj nonempty-type-from-decl) &rest initargs)
  (with-slots (keyword place unique-id newline-comment id decl-formals
                       formals module refers-to chain? typechecked?
                       visible? generated generated-by semi
                       typecheck-time type-value ir-type-value
                       type-expr contains predicate supertype)
    obj
    (make-instance 'nonempty-type-from-decl :keyword
                   (let* ((get1 (getf initargs 'keyword '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :keyword '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) keyword getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :type-value
                   (let* ((get1 (getf initargs 'type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-value getfv))
                   :ir-type-value
                   (let* ((get1
                           (getf initargs 'ir-type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-type-value getfv))
                   :type-expr
                   (let* ((get1 (getf initargs 'type-expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-expr getfv))
                   :contains
                   (let* ((get1 (getf initargs 'contains '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :contains '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) contains getfv))
                   :predicate
                   (let* ((get1 (getf initargs 'predicate '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :predicate '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) predicate getfv))
                   :supertype
                   (let* ((get1 (getf initargs 'supertype '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :supertype '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) supertype getfv)))))

(defmethod store-object* ((obj nonempty-type-from-decl))
  (with-slots (keyword place unique-id newline-comment id decl-formals
                       formals module refers-to chain? typechecked?
                       visible? generated generated-by semi
                       typecheck-time type-value type-expr contains
                       predicate supertype type-value)
    obj
    (reserve-space 23 (push-word (store-obj 'nonempty-type-from-decl))
                   (push-word (store-obj keyword))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj type-value))
                   (push-word (store-obj type-expr))
                   (push-word (store-obj contains))
                   (push-word (store-obj predicate))
                   (push-word (store-obj supertype))
                   (push-word (store-obj (ignore-self-reference-type-values
                                          obj))))))

(defmethod update-fetched ((obj nonempty-type-from-decl))
  (with-slots (keyword place unique-id newline-comment id decl-formals
                       formals module refers-to chain? typechecked?
                       visible? generated generated-by semi
                       typecheck-time type-value type-expr contains
                       predicate supertype type-value pvs-sxhash-value
                       tcc-form ir-type-value)
    obj
    (setf keyword (fetch-obj (stored-word 1)))
    (setf place (fetch-obj (stored-word 2)))
    (setf unique-id (fetch-obj (stored-word 3)))
    (setf newline-comment (fetch-obj (stored-word 4)))
    (setf id (fetch-obj (stored-word 5)))
    (setf decl-formals (fetch-obj (stored-word 6)))
    (setf formals (fetch-obj (stored-word 7)))
    (setf module (fetch-obj (stored-word 8)))
    (setf refers-to (fetch-obj (stored-word 9)))
    (setf chain? (fetch-obj (stored-word 10)))
    (setf typechecked? (fetch-obj (stored-word 11)))
    (setf visible? (fetch-obj (stored-word 12)))
    (setf generated (fetch-obj (stored-word 13)))
    (setf generated-by (fetch-obj (stored-word 14)))
    (setf semi (fetch-obj (stored-word 15)))
    (setf typecheck-time (fetch-obj (stored-word 16)))
    (setf type-value (fetch-obj (stored-word 17)))
    (setf type-expr (fetch-obj (stored-word 18)))
    (setf contains (fetch-obj (stored-word 19)))
    (setf predicate (fetch-obj (stored-word 20)))
    (setf supertype (fetch-obj (stored-word 21)))
    (setf type-value (fetch-obj (stored-word 22)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf ir-type-value nil)))

(defmethod restore-object* ((obj nonempty-type-from-decl))
  (with-slots (unique-id decl-formals formals type-value type-expr
                         contains predicate supertype)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when type-value
        (let ((*restore-object-parent-slot* 'type-value))
          (restore-object* type-value)))
      (when type-expr
        (let ((*restore-object-parent-slot* 'type-expr))
          (restore-object* type-expr)))
      (when contains
        (let ((*restore-object-parent-slot* 'contains))
          (restore-object* contains)))
      (when predicate
        (let ((*restore-object-parent-slot* 'predicate))
          (restore-object* predicate)))
      (when supertype
        (let ((*restore-object-parent-slot* 'supertype))
          (restore-object* supertype)))
      obj)))

(defmethod copy ((obj type-from-decl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     type-value ir-type-value type-expr contains
                     predicate supertype)
    obj
    (make-instance 'type-from-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :type-value
                   (let* ((get1 (getf initargs 'type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-value getfv))
                   :ir-type-value
                   (let* ((get1
                           (getf initargs 'ir-type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-type-value getfv))
                   :type-expr
                   (let* ((get1 (getf initargs 'type-expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-expr getfv))
                   :contains
                   (let* ((get1 (getf initargs 'contains '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :contains '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) contains getfv))
                   :predicate
                   (let* ((get1 (getf initargs 'predicate '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :predicate '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) predicate getfv))
                   :supertype
                   (let* ((get1 (getf initargs 'supertype '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :supertype '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) supertype getfv)))))

(defmethod store-object* ((obj type-from-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     type-value type-expr contains predicate supertype
                     type-value)
    obj
    (reserve-space 22 (push-word (store-obj 'type-from-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj type-value))
                   (push-word (store-obj type-expr))
                   (push-word (store-obj contains))
                   (push-word (store-obj predicate))
                   (push-word (store-obj supertype))
                   (push-word (store-obj (ignore-self-reference-type-values
                                          obj))))))

(defmethod update-fetched ((obj type-from-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     type-value type-expr contains predicate supertype
                     type-value pvs-sxhash-value tcc-form
                     ir-type-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf type-value (fetch-obj (stored-word 16)))
    (setf type-expr (fetch-obj (stored-word 17)))
    (setf contains (fetch-obj (stored-word 18)))
    (setf predicate (fetch-obj (stored-word 19)))
    (setf supertype (fetch-obj (stored-word 20)))
    (setf type-value (fetch-obj (stored-word 21)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf ir-type-value nil)))

(defmethod restore-object* ((obj type-from-decl))
  (with-slots (unique-id decl-formals formals type-value type-expr
                         contains predicate supertype)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when type-value
        (let ((*restore-object-parent-slot* 'type-value))
          (restore-object* type-value)))
      (when type-expr
        (let ((*restore-object-parent-slot* 'type-expr))
          (restore-object* type-expr)))
      (when contains
        (let ((*restore-object-parent-slot* 'contains))
          (restore-object* contains)))
      (when predicate
        (let ((*restore-object-parent-slot* 'predicate))
          (restore-object* predicate)))
      (when supertype
        (let ((*restore-object-parent-slot* 'supertype))
          (restore-object* supertype)))
      obj)))

(defmethod copy ((obj nonempty-type-eq-decl) &rest initargs)
  (with-slots (keyword place unique-id newline-comment id decl-formals
                       formals module refers-to chain? typechecked?
                       visible? generated generated-by semi
                       typecheck-time type-value ir-type-value
                       type-expr contains)
    obj
    (make-instance 'nonempty-type-eq-decl :keyword
                   (let* ((get1 (getf initargs 'keyword '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :keyword '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) keyword getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :type-value
                   (let* ((get1 (getf initargs 'type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-value getfv))
                   :ir-type-value
                   (let* ((get1
                           (getf initargs 'ir-type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-type-value getfv))
                   :type-expr
                   (let* ((get1 (getf initargs 'type-expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-expr getfv))
                   :contains
                   (let* ((get1 (getf initargs 'contains '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :contains '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) contains getfv)))))

(defmethod store-object* ((obj nonempty-type-eq-decl))
  (with-slots (keyword place unique-id newline-comment id decl-formals
                       formals module refers-to chain? typechecked?
                       visible? generated generated-by semi
                       typecheck-time type-value type-expr contains
                       type-value)
    obj
    (reserve-space 21 (push-word (store-obj 'nonempty-type-eq-decl))
                   (push-word (store-obj keyword))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj type-value))
                   (push-word (store-obj type-expr))
                   (push-word (store-obj contains))
                   (push-word (store-obj (ignore-self-reference-type-values
                                          obj))))))

(defmethod update-fetched ((obj nonempty-type-eq-decl))
  (with-slots (keyword place unique-id newline-comment id decl-formals
                       formals module refers-to chain? typechecked?
                       visible? generated generated-by semi
                       typecheck-time type-value type-expr contains
                       type-value pvs-sxhash-value tcc-form
                       ir-type-value)
    obj
    (setf keyword (fetch-obj (stored-word 1)))
    (setf place (fetch-obj (stored-word 2)))
    (setf unique-id (fetch-obj (stored-word 3)))
    (setf newline-comment (fetch-obj (stored-word 4)))
    (setf id (fetch-obj (stored-word 5)))
    (setf decl-formals (fetch-obj (stored-word 6)))
    (setf formals (fetch-obj (stored-word 7)))
    (setf module (fetch-obj (stored-word 8)))
    (setf refers-to (fetch-obj (stored-word 9)))
    (setf chain? (fetch-obj (stored-word 10)))
    (setf typechecked? (fetch-obj (stored-word 11)))
    (setf visible? (fetch-obj (stored-word 12)))
    (setf generated (fetch-obj (stored-word 13)))
    (setf generated-by (fetch-obj (stored-word 14)))
    (setf semi (fetch-obj (stored-word 15)))
    (setf typecheck-time (fetch-obj (stored-word 16)))
    (setf type-value (fetch-obj (stored-word 17)))
    (setf type-expr (fetch-obj (stored-word 18)))
    (setf contains (fetch-obj (stored-word 19)))
    (setf type-value (fetch-obj (stored-word 20)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf ir-type-value nil)))

(defmethod restore-object* ((obj nonempty-type-eq-decl))
  (with-slots (unique-id decl-formals formals type-value type-expr
                         contains)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when type-value
        (let ((*restore-object-parent-slot* 'type-value))
          (restore-object* type-value)))
      (when type-expr
        (let ((*restore-object-parent-slot* 'type-expr))
          (restore-object* type-expr)))
      (when contains
        (let ((*restore-object-parent-slot* 'contains))
          (restore-object* contains)))
      obj)))

(defmethod copy ((obj mapped-type-decl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     type-value ir-type-value type-expr contains)
    obj
    (make-instance 'mapped-type-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :type-value
                   (let* ((get1 (getf initargs 'type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-value getfv))
                   :ir-type-value
                   (let* ((get1
                           (getf initargs 'ir-type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-type-value getfv))
                   :type-expr
                   (let* ((get1 (getf initargs 'type-expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-expr getfv))
                   :contains
                   (let* ((get1 (getf initargs 'contains '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :contains '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) contains getfv)))))

(defmethod store-object* ((obj mapped-type-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     type-value type-expr contains type-value)
    obj
    (reserve-space 20 (push-word (store-obj 'mapped-type-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj type-value))
                   (push-word (store-obj type-expr))
                   (push-word (store-obj contains))
                   (push-word (store-obj (ignore-self-reference-type-values
                                          obj))))))

(defmethod update-fetched ((obj mapped-type-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     type-value type-expr contains type-value
                     pvs-sxhash-value tcc-form ir-type-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf type-value (fetch-obj (stored-word 16)))
    (setf type-expr (fetch-obj (stored-word 17)))
    (setf contains (fetch-obj (stored-word 18)))
    (setf type-value (fetch-obj (stored-word 19)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf ir-type-value nil)))

(defmethod restore-object* ((obj mapped-type-decl))
  (with-slots (unique-id decl-formals formals type-value type-expr
                         contains)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when type-value
        (let ((*restore-object-parent-slot* 'type-value))
          (restore-object* type-value)))
      (when type-expr
        (let ((*restore-object-parent-slot* 'type-expr))
          (restore-object* type-expr)))
      (when contains
        (let ((*restore-object-parent-slot* 'contains))
          (restore-object* contains)))
      obj)))

(defmethod copy ((obj type-eq-decl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     type-value ir-type-value type-expr contains)
    obj
    (make-instance 'type-eq-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :type-value
                   (let* ((get1 (getf initargs 'type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-value getfv))
                   :ir-type-value
                   (let* ((get1
                           (getf initargs 'ir-type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-type-value getfv))
                   :type-expr
                   (let* ((get1 (getf initargs 'type-expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-expr getfv))
                   :contains
                   (let* ((get1 (getf initargs 'contains '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :contains '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) contains getfv)))))

(defmethod store-object* ((obj type-eq-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     type-value type-expr contains type-value)
    obj
    (reserve-space 20 (push-word (store-obj 'type-eq-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj type-value))
                   (push-word (store-obj type-expr))
                   (push-word (store-obj contains))
                   (push-word (store-obj (ignore-self-reference-type-values
                                          obj))))))

(defmethod update-fetched ((obj type-eq-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     type-value type-expr contains type-value
                     pvs-sxhash-value tcc-form ir-type-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf type-value (fetch-obj (stored-word 16)))
    (setf type-expr (fetch-obj (stored-word 17)))
    (setf contains (fetch-obj (stored-word 18)))
    (setf type-value (fetch-obj (stored-word 19)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf ir-type-value nil)))

(defmethod restore-object* ((obj type-eq-decl))
  (with-slots (unique-id decl-formals formals type-value type-expr
                         contains)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when type-value
        (let ((*restore-object-parent-slot* 'type-value))
          (restore-object* type-value)))
      (when type-expr
        (let ((*restore-object-parent-slot* 'type-expr))
          (restore-object* type-expr)))
      (when contains
        (let ((*restore-object-parent-slot* 'contains))
          (restore-object* contains)))
      obj)))

(defmethod copy ((obj nonempty-type-def-decl) &rest initargs)
  (with-slots (keyword place unique-id newline-comment id decl-formals
                       formals module refers-to chain? typechecked?
                       visible? generated generated-by semi
                       typecheck-time type-value ir-type-value
                       type-expr contains)
    obj
    (make-instance 'nonempty-type-def-decl :keyword
                   (let* ((get1 (getf initargs 'keyword '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :keyword '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) keyword getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :type-value
                   (let* ((get1 (getf initargs 'type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-value getfv))
                   :ir-type-value
                   (let* ((get1
                           (getf initargs 'ir-type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-type-value getfv))
                   :type-expr
                   (let* ((get1 (getf initargs 'type-expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-expr getfv))
                   :contains
                   (let* ((get1 (getf initargs 'contains '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :contains '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) contains getfv)))))

(defmethod store-object* ((obj nonempty-type-def-decl))
  (with-slots (keyword place unique-id newline-comment id decl-formals
                       formals module refers-to chain? typechecked?
                       visible? generated generated-by semi
                       typecheck-time type-value type-expr contains
                       type-value)
    obj
    (reserve-space 21 (push-word (store-obj 'nonempty-type-def-decl))
                   (push-word (store-obj keyword))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj type-value))
                   (push-word (store-obj type-expr))
                   (push-word (store-obj contains))
                   (push-word (store-obj (ignore-self-reference-type-values
                                          obj))))))

(defmethod update-fetched ((obj nonempty-type-def-decl))
  (with-slots (keyword place unique-id newline-comment id decl-formals
                       formals module refers-to chain? typechecked?
                       visible? generated generated-by semi
                       typecheck-time type-value type-expr contains
                       type-value pvs-sxhash-value tcc-form
                       ir-type-value)
    obj
    (setf keyword (fetch-obj (stored-word 1)))
    (setf place (fetch-obj (stored-word 2)))
    (setf unique-id (fetch-obj (stored-word 3)))
    (setf newline-comment (fetch-obj (stored-word 4)))
    (setf id (fetch-obj (stored-word 5)))
    (setf decl-formals (fetch-obj (stored-word 6)))
    (setf formals (fetch-obj (stored-word 7)))
    (setf module (fetch-obj (stored-word 8)))
    (setf refers-to (fetch-obj (stored-word 9)))
    (setf chain? (fetch-obj (stored-word 10)))
    (setf typechecked? (fetch-obj (stored-word 11)))
    (setf visible? (fetch-obj (stored-word 12)))
    (setf generated (fetch-obj (stored-word 13)))
    (setf generated-by (fetch-obj (stored-word 14)))
    (setf semi (fetch-obj (stored-word 15)))
    (setf typecheck-time (fetch-obj (stored-word 16)))
    (setf type-value (fetch-obj (stored-word 17)))
    (setf type-expr (fetch-obj (stored-word 18)))
    (setf contains (fetch-obj (stored-word 19)))
    (setf type-value (fetch-obj (stored-word 20)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf ir-type-value nil)))

(defmethod restore-object* ((obj nonempty-type-def-decl))
  (with-slots (unique-id decl-formals formals type-value type-expr
                         contains)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when type-value
        (let ((*restore-object-parent-slot* 'type-value))
          (restore-object* type-value)))
      (when type-expr
        (let ((*restore-object-parent-slot* 'type-expr))
          (restore-object* type-expr)))
      (when contains
        (let ((*restore-object-parent-slot* 'contains))
          (restore-object* contains)))
      obj)))

(defmethod copy ((obj type-def-decl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     type-value ir-type-value type-expr contains)
    obj
    (make-instance 'type-def-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :type-value
                   (let* ((get1 (getf initargs 'type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-value getfv))
                   :ir-type-value
                   (let* ((get1
                           (getf initargs 'ir-type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-type-value getfv))
                   :type-expr
                   (let* ((get1 (getf initargs 'type-expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-expr getfv))
                   :contains
                   (let* ((get1 (getf initargs 'contains '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :contains '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) contains getfv)))))

(defmethod store-object* ((obj type-def-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     type-value type-expr contains type-value)
    obj
    (reserve-space 20 (push-word (store-obj 'type-def-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj type-value))
                   (push-word (store-obj type-expr))
                   (push-word (store-obj contains))
                   (push-word (store-obj (ignore-self-reference-type-values
                                          obj))))))

(defmethod update-fetched ((obj type-def-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     type-value type-expr contains type-value
                     pvs-sxhash-value tcc-form ir-type-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf type-value (fetch-obj (stored-word 16)))
    (setf type-expr (fetch-obj (stored-word 17)))
    (setf contains (fetch-obj (stored-word 18)))
    (setf type-value (fetch-obj (stored-word 19)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf ir-type-value nil)))

(defmethod restore-object* ((obj type-def-decl))
  (with-slots (unique-id decl-formals formals type-value type-expr
                         contains)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when type-value
        (let ((*restore-object-parent-slot* 'type-value))
          (restore-object* type-value)))
      (when type-expr
        (let ((*restore-object-parent-slot* 'type-expr))
          (restore-object* type-expr)))
      (when contains
        (let ((*restore-object-parent-slot* 'contains))
          (restore-object* contains)))
      obj)))

(defmethod copy ((obj nonempty-type-decl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     type-value ir-type-value keyword)
    obj
    (make-instance 'nonempty-type-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :type-value
                   (let* ((get1 (getf initargs 'type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-value getfv))
                   :ir-type-value
                   (let* ((get1
                           (getf initargs 'ir-type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-type-value getfv))
                   :keyword
                   (let* ((get1 (getf initargs 'keyword '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :keyword '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) keyword getfv)))))

(defmethod store-object* ((obj nonempty-type-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     type-value keyword type-value)
    obj
    (reserve-space 19 (push-word (store-obj 'nonempty-type-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj type-value))
                   (push-word (store-obj keyword))
                   (push-word (store-obj (ignore-self-reference-type-values
                                          obj))))))

(defmethod update-fetched ((obj nonempty-type-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     type-value keyword type-value pvs-sxhash-value
                     tcc-form ir-type-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf type-value (fetch-obj (stored-word 16)))
    (setf keyword (fetch-obj (stored-word 17)))
    (setf type-value (fetch-obj (stored-word 18)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf ir-type-value nil)))

(defmethod restore-object* ((obj nonempty-type-decl))
  (with-slots (unique-id decl-formals formals type-value)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when type-value
        (let ((*restore-object-parent-slot* 'type-value))
          (restore-object* type-value)))
      obj)))

(defmethod copy ((obj type-decl) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     type-value ir-type-value)
    obj
    (make-instance 'type-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :type-value
                   (let* ((get1 (getf initargs 'type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-value getfv))
                   :ir-type-value
                   (let* ((get1
                           (getf initargs 'ir-type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ir-type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ir-type-value getfv)))))

(defmethod store-object* ((obj type-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     type-value type-value)
    obj
    (reserve-space 18 (push-word (store-obj 'type-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj type-value))
                   (push-word (store-obj (ignore-self-reference-type-values
                                          obj))))))

(defmethod update-fetched ((obj type-decl))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     type-value type-value pvs-sxhash-value tcc-form
                     ir-type-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf type-value (fetch-obj (stored-word 16)))
    (setf type-value (fetch-obj (stored-word 17)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf ir-type-value nil)))

(defmethod restore-object* ((obj type-decl))
  (with-slots (unique-id decl-formals formals type-value)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when type-value
        (let ((*restore-object-parent-slot* 'type-value))
          (restore-object* type-value)))
      obj)))

(defmethod copy ((obj typed-declaration) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type declared-type-string type)
    obj
    (make-instance 'typed-declaration :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :declared-type-string
                   (let* ((get1
                           (getf initargs 'declared-type-string
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-type-string
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         declared-type-string
                       getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv)))))

(defmethod store-object* ((obj typed-declaration))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type)
    obj
    (reserve-space 18 (push-word (store-obj 'typed-declaration))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type)))))

(defmethod update-fetched ((obj typed-declaration))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     declared-type type pvs-sxhash-value tcc-form
                     declared-type-string)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf declared-type (fetch-obj (stored-word 16)))
    (setf type (fetch-obj (stored-word 17)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)
    (setf declared-type-string nil)))

(defmethod restore-object* ((obj typed-declaration))
  (with-slots (unique-id decl-formals formals declared-type type)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      obj)))

(defmethod copy ((obj mapped-decl) &rest initargs)
  (with-slots nil obj (make-instance 'mapped-decl)))

(defmethod store-object* ((obj mapped-decl))
  (with-slots nil
    obj
    (reserve-space 1 (push-word (store-obj 'mapped-decl)))))

(defmethod update-fetched ((obj mapped-decl)) (with-slots nil obj))

(defmethod restore-object* ((obj mapped-decl))
  (with-slots nil obj (let ((*restore-object-parent* obj)) obj)))

(defmethod copy ((obj declaration) &rest initargs)
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time)
    obj
    (make-instance 'declaration :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :newline-comment
                   (let* ((get1
                           (getf initargs 'newline-comment '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :newline-comment
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) newline-comment getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv))
                   :visible?
                   (let* ((get1 (getf initargs 'visible? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :visible? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) visible? getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv)))))

(defmethod store-object* ((obj declaration))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time)
    obj
    (reserve-space 16 (push-word (store-obj 'declaration))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj newline-comment))
                   (push-word (store-obj id))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj chain?))
                   (push-word (store-obj typechecked?))
                   (push-word (store-obj visible?))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj semi))
                   (push-word (store-obj typecheck-time)))))

(defmethod update-fetched ((obj declaration))
  (with-slots (place unique-id newline-comment id decl-formals formals
                     module refers-to chain? typechecked? visible?
                     generated generated-by semi typecheck-time
                     pvs-sxhash-value tcc-form)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf newline-comment (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf decl-formals (fetch-obj (stored-word 5)))
    (setf formals (fetch-obj (stored-word 6)))
    (setf module (fetch-obj (stored-word 7)))
    (setf refers-to (fetch-obj (stored-word 8)))
    (setf chain? (fetch-obj (stored-word 9)))
    (setf typechecked? (fetch-obj (stored-word 10)))
    (setf visible? (fetch-obj (stored-word 11)))
    (setf generated (fetch-obj (stored-word 12)))
    (setf generated-by (fetch-obj (stored-word 13)))
    (setf semi (fetch-obj (stored-word 14)))
    (setf typecheck-time (fetch-obj (stored-word 15)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)))

(defmethod restore-object* ((obj declaration))
  (with-slots (unique-id decl-formals formals)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      obj)))

(defmethod copy ((obj importing) &rest initargs)
  (with-slots (place unique-id saved-context theory-name semi chain?
                     refers-to generated generated-by)
    obj
    (make-instance 'importing :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :saved-context
                   (let* ((get1
                           (getf initargs 'saved-context '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :saved-context '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) saved-context getfv))
                   :theory-name
                   (let* ((get1 (getf initargs 'theory-name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :theory-name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) theory-name getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv)))))

(defmethod store-object* ((obj importing))
  (with-slots (place unique-id saved-context theory-name semi chain?
                     refers-to generated generated-by)
    obj
    (reserve-space 10 (push-word (store-obj 'importing))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj saved-context))
                   (push-word (store-obj theory-name))
                   (push-word (store-obj semi))
                   (push-word (store-obj chain?))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj generated))
                   (push-word (store-obj generated-by)))))

(defmethod update-fetched ((obj importing))
  (with-slots (place unique-id saved-context theory-name semi chain?
                     refers-to generated generated-by pvs-sxhash-value
                     tcc-form)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf saved-context (fetch-obj (stored-word 3)))
    (setf theory-name (fetch-obj (stored-word 4)))
    (setf semi (fetch-obj (stored-word 5)))
    (setf chain? (fetch-obj (stored-word 6)))
    (setf refers-to (fetch-obj (stored-word 7)))
    (setf generated (fetch-obj (stored-word 8)))
    (setf generated-by (fetch-obj (stored-word 9)))
    (setf pvs-sxhash-value nil)
    (setf tcc-form nil)))

(defmethod restore-object* ((obj importing))
  (with-slots (unique-id saved-context theory-name)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when saved-context
        (let ((*restore-object-parent-slot* 'saved-context))
          (restore-object* saved-context)))
      (when theory-name
        (let ((*restore-object-parent-slot* 'theory-name))
          (restore-object* theory-name)))
      obj)))

(defmethod copy ((obj importing-entity) &rest initargs)
  (with-slots (place unique-id saved-context)
    obj
    (make-instance 'importing-entity :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :saved-context
                   (let* ((get1
                           (getf initargs 'saved-context '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :saved-context '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) saved-context getfv)))))

(defmethod store-object* ((obj importing-entity))
  (with-slots (place unique-id saved-context)
    obj
    (reserve-space 4 (push-word (store-obj 'importing-entity))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj saved-context)))))

(defmethod update-fetched ((obj importing-entity))
  (with-slots (place unique-id saved-context pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf saved-context (fetch-obj (stored-word 3)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj importing-entity))
  (with-slots (unique-id saved-context)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when saved-context
        (let ((*restore-object-parent-slot* 'saved-context))
          (restore-object* saved-context)))
      obj)))

(defmethod copy ((obj expname) &rest initargs)
  (with-slots (place id kind type)
    obj
    (make-instance 'expname :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :kind
                   (let* ((get1 (getf initargs 'kind '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :kind '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) kind getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv)))))

(defmethod store-object* ((obj expname))
  (with-slots (place id kind type)
    obj
    (reserve-space 5 (push-word (store-obj 'expname))
                   (push-word (store-obj place))
                   (push-word (store-obj id))
                   (push-word (store-obj kind))
                   (push-word (store-obj type)))))

(defmethod update-fetched ((obj expname))
  (with-slots (place id kind type pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf id (fetch-obj (stored-word 2)))
    (setf kind (fetch-obj (stored-word 3)))
    (setf type (fetch-obj (stored-word 4)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj expname))
  (with-slots (type)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      obj)))

(defmethod copy ((obj exporting) &rest initargs)
  (with-slots (place unique-id names but-names kind modules closure)
    obj
    (make-instance 'exporting :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :names
                   (let* ((get1 (getf initargs 'names '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :names '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) names getfv))
                   :but-names
                   (let* ((get1 (getf initargs 'but-names '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :but-names '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) but-names getfv))
                   :kind
                   (let* ((get1 (getf initargs 'kind '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :kind '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) kind getfv))
                   :modules
                   (let* ((get1 (getf initargs 'modules '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :modules '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) modules getfv))
                   :closure
                   (let* ((get1 (getf initargs 'closure '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :closure '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) closure getfv)))))

(defmethod store-object* ((obj exporting))
  (with-slots (place unique-id names but-names kind modules closure)
    obj
    (reserve-space 8 (push-word (store-obj 'exporting))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj names))
                   (push-word (store-obj but-names))
                   (push-word (store-obj kind))
                   (push-word (store-obj modules))
                   (push-word (store-obj closure)))))

(defmethod update-fetched ((obj exporting))
  (with-slots (place unique-id names but-names kind modules closure
                     pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf names (fetch-obj (stored-word 3)))
    (setf but-names (fetch-obj (stored-word 4)))
    (setf kind (fetch-obj (stored-word 5)))
    (setf modules (fetch-obj (stored-word 6)))
    (setf closure (fetch-obj (stored-word 7)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj exporting))
  (with-slots (unique-id names but-names kind modules closure)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when names
        (let ((*restore-object-parent-slot* 'names))
          (restore-object* names)))
      (when but-names
        (let ((*restore-object-parent-slot* 'but-names))
          (restore-object* but-names)))
      (when kind
        (let ((*restore-object-parent-slot* 'kind))
          (restore-object* kind)))
      (when modules
        (let ((*restore-object-parent-slot* 'modules))
          (restore-object* modules)))
      (when closure
        (let ((*restore-object-parent-slot* 'closure))
          (restore-object* closure)))
      obj)))

(defmethod copy ((obj rectype-theory) &rest initargs)
  (with-slots (place id formals formals-sans-usings theory-formal-decls
                     assuming filename context-path status generated-by
                     tcc-comments info warnings conversion-messages
                     all-declarations all-imported-theories
                     all-imported-names theory-mappings theory
                     exporting nonempty-types all-usings
                     immediate-usings instances-used assuming-instances
                     used-by saved-context dependent-known-subtypes
                     macro-expressions macro-subtype-tcc-args-alist
                     tccs-tried? modified-proof? ppe-form tcc-form
                     typecheck-time positive-types single-constructor?)
    obj
    (make-instance 'rectype-theory :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :formals-sans-usings
                   (let* ((get1
                           (getf initargs 'formals-sans-usings
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :formals-sans-usings
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         formals-sans-usings
                       getfv))
                   :theory-formal-decls
                   (let* ((get1
                           (getf initargs 'theory-formal-decls
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :theory-formal-decls
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         theory-formal-decls
                       getfv))
                   :assuming
                   (let* ((get1 (getf initargs 'assuming '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :assuming '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) assuming getfv))
                   :filename
                   (let* ((get1 (getf initargs 'filename '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :filename '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) filename getfv))
                   :context-path
                   (let* ((get1 (getf initargs 'context-path '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :context-path '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) context-path getfv))
                   :status
                   (let* ((get1 (getf initargs 'status '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :status '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) status getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :tcc-comments
                   (let* ((get1 (getf initargs 'tcc-comments '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-comments '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-comments getfv))
                   :info
                   (let* ((get1 (getf initargs 'info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) info getfv))
                   :warnings
                   (let* ((get1 (getf initargs 'warnings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :warnings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) warnings getfv))
                   :conversion-messages
                   (let* ((get1
                           (getf initargs 'conversion-messages
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :conversion-messages
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         conversion-messages
                       getfv))
                   :all-declarations
                   (let* ((get1
                           (getf initargs 'all-declarations '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-declarations
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) all-declarations getfv))
                   :all-imported-theories
                   (let* ((get1
                           (getf initargs 'all-imported-theories
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-imported-theories
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         all-imported-theories
                       getfv))
                   :all-imported-names
                   (let* ((get1
                           (getf initargs 'all-imported-names
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-imported-names
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) all-imported-names getfv))
                   :theory-mappings
                   (let* ((get1
                           (getf initargs 'theory-mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :theory-mappings
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) theory-mappings getfv))
                   :theory
                   (let* ((get1 (getf initargs 'theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :theory '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) theory getfv))
                   :exporting
                   (let* ((get1 (getf initargs 'exporting '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :exporting '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) exporting getfv))
                   :nonempty-types
                   (let* ((get1
                           (getf initargs 'nonempty-types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty-types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty-types getfv))
                   :all-usings
                   (let* ((get1 (getf initargs 'all-usings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :all-usings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) all-usings getfv))
                   :immediate-usings
                   (let* ((get1
                           (getf initargs 'immediate-usings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :immediate-usings
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) immediate-usings getfv))
                   :instances-used
                   (let* ((get1
                           (getf initargs 'instances-used '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :instances-used '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) instances-used getfv))
                   :assuming-instances
                   (let* ((get1
                           (getf initargs 'assuming-instances
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :assuming-instances
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) assuming-instances getfv))
                   :used-by
                   (let* ((get1 (getf initargs 'used-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :used-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) used-by getfv))
                   :saved-context
                   (let* ((get1
                           (getf initargs 'saved-context '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :saved-context '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) saved-context getfv))
                   :dependent-known-subtypes
                   (let* ((get1
                           (getf initargs 'dependent-known-subtypes
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :dependent-known-subtypes
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         dependent-known-subtypes
                       getfv))
                   :macro-expressions
                   (let* ((get1
                           (getf initargs 'macro-expressions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :macro-expressions
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) macro-expressions getfv))
                   :macro-subtype-tcc-args-alist
                   (let* ((get1
                           (getf initargs 'macro-subtype-tcc-args-alist
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :macro-subtype-tcc-args-alist
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         macro-subtype-tcc-args-alist
                       getfv))
                   :tccs-tried?
                   (let* ((get1 (getf initargs 'tccs-tried? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tccs-tried? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tccs-tried? getfv))
                   :modified-proof?
                   (let* ((get1
                           (getf initargs 'modified-proof? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :modified-proof?
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) modified-proof? getfv))
                   :ppe-form
                   (let* ((get1 (getf initargs 'ppe-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ppe-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ppe-form getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-form getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv))
                   :positive-types
                   (let* ((get1
                           (getf initargs 'positive-types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :positive-types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) positive-types getfv))
                   :single-constructor?
                   (let* ((get1
                           (getf initargs 'single-constructor?
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :single-constructor?
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         single-constructor?
                       getfv)))))

(defmethod store-object* ((obj rectype-theory))
  (with-slots (place id formals theory-formal-decls assuming filename
                     context-path status generated-by tcc-comments info
                     warnings conversion-messages theory-mappings
                     theory exporting nonempty-types all-usings
                     immediate-usings instances-used assuming-instances
                     used-by saved-context dependent-known-subtypes
                     macro-expressions macro-subtype-tcc-args-alist
                     tccs-tried? modified-proof? typecheck-time
                     positive-types single-constructor?)
    obj
    (reserve-space 32 (push-word (store-obj 'rectype-theory))
                   (push-word (store-obj place))
                   (push-word (store-obj id))
                   (push-word (store-obj formals))
                   (push-word (store-obj theory-formal-decls))
                   (push-word (store-obj assuming))
                   (push-word (store-obj filename))
                   (push-word (store-obj context-path))
                   (push-word (store-obj status))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj tcc-comments))
                   (push-word (store-obj info))
                   (push-word (store-obj warnings))
                   (push-word (store-obj conversion-messages))
                   (push-word (store-obj theory-mappings))
                   (push-word (store-obj theory))
                   (push-word (store-obj exporting))
                   (push-word (store-obj nonempty-types))
                   (push-word (store-obj all-usings))
                   (push-word (store-obj immediate-usings))
                   (push-word (store-obj instances-used))
                   (push-word (store-obj assuming-instances))
                   (push-word (store-obj used-by))
                   (push-word (store-obj saved-context))
                   (push-word (store-obj dependent-known-subtypes))
                   (push-word (store-obj macro-expressions))
                   (push-word (store-obj macro-subtype-tcc-args-alist))
                   (push-word (store-obj tccs-tried?))
                   (push-word (store-obj modified-proof?))
                   (push-word (store-obj typecheck-time))
                   (push-word (store-obj positive-types))
                   (push-word (store-obj single-constructor?)))))

(defmethod update-fetched ((obj rectype-theory))
  (with-slots (place id formals theory-formal-decls assuming filename
                     context-path status generated-by tcc-comments info
                     warnings conversion-messages theory-mappings
                     theory exporting nonempty-types all-usings
                     immediate-usings instances-used assuming-instances
                     used-by saved-context dependent-known-subtypes
                     macro-expressions macro-subtype-tcc-args-alist
                     tccs-tried? modified-proof? typecheck-time
                     positive-types single-constructor?
                     pvs-sxhash-value formals-sans-usings
                     all-declarations all-imported-theories
                     all-imported-names ppe-form tcc-form)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf id (fetch-obj (stored-word 2)))
    (setf formals (fetch-obj (stored-word 3)))
    (setf theory-formal-decls (fetch-obj (stored-word 4)))
    (setf assuming (fetch-obj (stored-word 5)))
    (setf filename (fetch-obj (stored-word 6)))
    (setf context-path (fetch-obj (stored-word 7)))
    (setf status (fetch-obj (stored-word 8)))
    (setf generated-by (fetch-obj (stored-word 9)))
    (setf tcc-comments (fetch-obj (stored-word 10)))
    (setf info (fetch-obj (stored-word 11)))
    (setf warnings (fetch-obj (stored-word 12)))
    (setf conversion-messages (fetch-obj (stored-word 13)))
    (setf theory-mappings (fetch-obj (stored-word 14)))
    (setf theory (fetch-obj (stored-word 15)))
    (setf exporting (fetch-obj (stored-word 16)))
    (setf nonempty-types (fetch-obj (stored-word 17)))
    (setf all-usings (fetch-obj (stored-word 18)))
    (setf immediate-usings (fetch-obj (stored-word 19)))
    (setf instances-used (fetch-obj (stored-word 20)))
    (setf assuming-instances (fetch-obj (stored-word 21)))
    (setf used-by (fetch-obj (stored-word 22)))
    (setf saved-context (fetch-obj (stored-word 23)))
    (setf dependent-known-subtypes (fetch-obj (stored-word 24)))
    (setf macro-expressions (fetch-obj (stored-word 25)))
    (setf macro-subtype-tcc-args-alist (fetch-obj (stored-word 26)))
    (setf tccs-tried? (fetch-obj (stored-word 27)))
    (setf modified-proof? (fetch-obj (stored-word 28)))
    (setf typecheck-time (fetch-obj (stored-word 29)))
    (setf positive-types (fetch-obj (stored-word 30)))
    (setf single-constructor? (fetch-obj (stored-word 31)))
    (setf pvs-sxhash-value nil)
    (setf formals-sans-usings nil)
    (setf all-declarations nil)
    (setf all-imported-theories 'unbound)
    (setf all-imported-names 'unbound)
    (setf ppe-form nil)
    (setf tcc-form nil)))

(defmethod restore-object* ((obj rectype-theory))
  (with-slots (formals theory-formal-decls assuming theory-mappings
                       theory exporting all-usings immediate-usings
                       instances-used used-by saved-context
                       dependent-known-subtypes positive-types
                       single-constructor?)
    obj
    (let ((*restore-object-parent* obj))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when theory-formal-decls
        (let ((*restore-object-parent-slot* 'theory-formal-decls))
          (restore-object* theory-formal-decls)))
      (when assuming
        (let ((*restore-object-parent-slot* 'assuming))
          (restore-object* assuming)))
      (when theory-mappings
        (let ((*restore-object-parent-slot* 'theory-mappings))
          (restore-object* theory-mappings)))
      (when theory
        (let ((*restore-object-parent-slot* 'theory))
          (restore-object* theory)))
      (when exporting
        (let ((*restore-object-parent-slot* 'exporting))
          (restore-object* exporting)))
      (when all-usings
        (let ((*restore-object-parent-slot* 'all-usings))
          (restore-object* all-usings)))
      (when immediate-usings
        (let ((*restore-object-parent-slot* 'immediate-usings))
          (restore-object* immediate-usings)))
      (when instances-used
        (let ((*restore-object-parent-slot* 'instances-used))
          (restore-object* instances-used)))
      (when used-by
        (let ((*restore-object-parent-slot* 'used-by))
          (restore-object* used-by)))
      (when saved-context
        (let ((*restore-object-parent-slot* 'saved-context))
          (restore-object* saved-context)))
      (when dependent-known-subtypes
        (let ((*restore-object-parent-slot* 'dependent-known-subtypes))
          (restore-object* dependent-known-subtypes)))
      (when positive-types
        (let ((*restore-object-parent-slot* 'positive-types))
          (restore-object* positive-types)))
      (when single-constructor?
        (let ((*restore-object-parent-slot* 'single-constructor?))
          (restore-object* single-constructor?)))
      obj)))

(defmethod copy ((obj module) &rest initargs)
  (with-slots (place id formals formals-sans-usings theory-formal-decls
                     assuming filename context-path status generated-by
                     tcc-comments info warnings conversion-messages
                     all-declarations all-imported-theories
                     all-imported-names theory-mappings theory
                     exporting nonempty-types all-usings
                     immediate-usings instances-used assuming-instances
                     used-by saved-context dependent-known-subtypes
                     macro-expressions macro-subtype-tcc-args-alist
                     tccs-tried? modified-proof? ppe-form tcc-form
                     typecheck-time)
    obj
    (make-instance 'module :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :formals-sans-usings
                   (let* ((get1
                           (getf initargs 'formals-sans-usings
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :formals-sans-usings
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         formals-sans-usings
                       getfv))
                   :theory-formal-decls
                   (let* ((get1
                           (getf initargs 'theory-formal-decls
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :theory-formal-decls
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         theory-formal-decls
                       getfv))
                   :assuming
                   (let* ((get1 (getf initargs 'assuming '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :assuming '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) assuming getfv))
                   :filename
                   (let* ((get1 (getf initargs 'filename '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :filename '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) filename getfv))
                   :context-path
                   (let* ((get1 (getf initargs 'context-path '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :context-path '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) context-path getfv))
                   :status
                   (let* ((get1 (getf initargs 'status '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :status '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) status getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :tcc-comments
                   (let* ((get1 (getf initargs 'tcc-comments '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-comments '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-comments getfv))
                   :info
                   (let* ((get1 (getf initargs 'info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) info getfv))
                   :warnings
                   (let* ((get1 (getf initargs 'warnings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :warnings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) warnings getfv))
                   :conversion-messages
                   (let* ((get1
                           (getf initargs 'conversion-messages
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :conversion-messages
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         conversion-messages
                       getfv))
                   :all-declarations
                   (let* ((get1
                           (getf initargs 'all-declarations '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-declarations
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) all-declarations getfv))
                   :all-imported-theories
                   (let* ((get1
                           (getf initargs 'all-imported-theories
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-imported-theories
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         all-imported-theories
                       getfv))
                   :all-imported-names
                   (let* ((get1
                           (getf initargs 'all-imported-names
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-imported-names
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) all-imported-names getfv))
                   :theory-mappings
                   (let* ((get1
                           (getf initargs 'theory-mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :theory-mappings
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) theory-mappings getfv))
                   :theory
                   (let* ((get1 (getf initargs 'theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :theory '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) theory getfv))
                   :exporting
                   (let* ((get1 (getf initargs 'exporting '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :exporting '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) exporting getfv))
                   :nonempty-types
                   (let* ((get1
                           (getf initargs 'nonempty-types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :nonempty-types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nonempty-types getfv))
                   :all-usings
                   (let* ((get1 (getf initargs 'all-usings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :all-usings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) all-usings getfv))
                   :immediate-usings
                   (let* ((get1
                           (getf initargs 'immediate-usings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :immediate-usings
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) immediate-usings getfv))
                   :instances-used
                   (let* ((get1
                           (getf initargs 'instances-used '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :instances-used '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) instances-used getfv))
                   :assuming-instances
                   (let* ((get1
                           (getf initargs 'assuming-instances
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :assuming-instances
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) assuming-instances getfv))
                   :used-by
                   (let* ((get1 (getf initargs 'used-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :used-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) used-by getfv))
                   :saved-context
                   (let* ((get1
                           (getf initargs 'saved-context '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :saved-context '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) saved-context getfv))
                   :dependent-known-subtypes
                   (let* ((get1
                           (getf initargs 'dependent-known-subtypes
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :dependent-known-subtypes
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         dependent-known-subtypes
                       getfv))
                   :macro-expressions
                   (let* ((get1
                           (getf initargs 'macro-expressions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :macro-expressions
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) macro-expressions getfv))
                   :macro-subtype-tcc-args-alist
                   (let* ((get1
                           (getf initargs 'macro-subtype-tcc-args-alist
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :macro-subtype-tcc-args-alist
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         macro-subtype-tcc-args-alist
                       getfv))
                   :tccs-tried?
                   (let* ((get1 (getf initargs 'tccs-tried? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tccs-tried? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tccs-tried? getfv))
                   :modified-proof?
                   (let* ((get1
                           (getf initargs 'modified-proof? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :modified-proof?
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) modified-proof? getfv))
                   :ppe-form
                   (let* ((get1 (getf initargs 'ppe-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ppe-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ppe-form getfv))
                   :tcc-form
                   (let* ((get1 (getf initargs 'tcc-form '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-form '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-form getfv))
                   :typecheck-time
                   (let* ((get1
                           (getf initargs 'typecheck-time '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typecheck-time '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typecheck-time getfv)))))

(defmethod store-object* ((obj module))
  (with-slots (place id formals theory-formal-decls assuming filename
                     context-path status generated-by tcc-comments info
                     warnings conversion-messages theory-mappings
                     theory exporting nonempty-types all-usings
                     immediate-usings instances-used assuming-instances
                     used-by saved-context dependent-known-subtypes
                     macro-expressions macro-subtype-tcc-args-alist
                     tccs-tried? modified-proof? typecheck-time)
    obj
    (reserve-space 30 (push-word (store-obj 'module))
                   (push-word (store-obj place))
                   (push-word (store-obj id))
                   (push-word (store-obj formals))
                   (push-word (store-obj theory-formal-decls))
                   (push-word (store-obj assuming))
                   (push-word (store-obj filename))
                   (push-word (store-obj context-path))
                   (push-word (store-obj status))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj tcc-comments))
                   (push-word (store-obj info))
                   (push-word (store-obj warnings))
                   (push-word (store-obj conversion-messages))
                   (push-word (store-obj theory-mappings))
                   (push-word (store-obj theory))
                   (push-word (store-obj exporting))
                   (push-word (store-obj nonempty-types))
                   (push-word (store-obj all-usings))
                   (push-word (store-obj immediate-usings))
                   (push-word (store-obj instances-used))
                   (push-word (store-obj assuming-instances))
                   (push-word (store-obj used-by))
                   (push-word (store-obj saved-context))
                   (push-word (store-obj dependent-known-subtypes))
                   (push-word (store-obj macro-expressions))
                   (push-word (store-obj macro-subtype-tcc-args-alist))
                   (push-word (store-obj tccs-tried?))
                   (push-word (store-obj modified-proof?))
                   (push-word (store-obj typecheck-time)))))

(defmethod update-fetched ((obj module))
  (with-slots (place id formals theory-formal-decls assuming filename
                     context-path status generated-by tcc-comments info
                     warnings conversion-messages theory-mappings
                     theory exporting nonempty-types all-usings
                     immediate-usings instances-used assuming-instances
                     used-by saved-context dependent-known-subtypes
                     macro-expressions macro-subtype-tcc-args-alist
                     tccs-tried? modified-proof? typecheck-time
                     pvs-sxhash-value formals-sans-usings
                     all-declarations all-imported-theories
                     all-imported-names ppe-form tcc-form)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf id (fetch-obj (stored-word 2)))
    (setf formals (fetch-obj (stored-word 3)))
    (setf theory-formal-decls (fetch-obj (stored-word 4)))
    (setf assuming (fetch-obj (stored-word 5)))
    (setf filename (fetch-obj (stored-word 6)))
    (setf context-path (fetch-obj (stored-word 7)))
    (setf status (fetch-obj (stored-word 8)))
    (setf generated-by (fetch-obj (stored-word 9)))
    (setf tcc-comments (fetch-obj (stored-word 10)))
    (setf info (fetch-obj (stored-word 11)))
    (setf warnings (fetch-obj (stored-word 12)))
    (setf conversion-messages (fetch-obj (stored-word 13)))
    (setf theory-mappings (fetch-obj (stored-word 14)))
    (setf theory (fetch-obj (stored-word 15)))
    (setf exporting (fetch-obj (stored-word 16)))
    (setf nonempty-types (fetch-obj (stored-word 17)))
    (setf all-usings (fetch-obj (stored-word 18)))
    (setf immediate-usings (fetch-obj (stored-word 19)))
    (setf instances-used (fetch-obj (stored-word 20)))
    (setf assuming-instances (fetch-obj (stored-word 21)))
    (setf used-by (fetch-obj (stored-word 22)))
    (setf saved-context (fetch-obj (stored-word 23)))
    (setf dependent-known-subtypes (fetch-obj (stored-word 24)))
    (setf macro-expressions (fetch-obj (stored-word 25)))
    (setf macro-subtype-tcc-args-alist (fetch-obj (stored-word 26)))
    (setf tccs-tried? (fetch-obj (stored-word 27)))
    (setf modified-proof? (fetch-obj (stored-word 28)))
    (setf typecheck-time (fetch-obj (stored-word 29)))
    (setf pvs-sxhash-value nil)
    (setf formals-sans-usings nil)
    (setf all-declarations nil)
    (setf all-imported-theories 'unbound)
    (setf all-imported-names 'unbound)
    (setf ppe-form nil)
    (setf tcc-form nil)))

(defmethod restore-object* ((obj module))
  (with-slots (formals theory-formal-decls assuming theory-mappings
                       theory exporting all-usings immediate-usings
                       instances-used used-by saved-context
                       dependent-known-subtypes)
    obj
    (let ((*restore-object-parent* obj))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when theory-formal-decls
        (let ((*restore-object-parent-slot* 'theory-formal-decls))
          (restore-object* theory-formal-decls)))
      (when assuming
        (let ((*restore-object-parent-slot* 'assuming))
          (restore-object* assuming)))
      (when theory-mappings
        (let ((*restore-object-parent-slot* 'theory-mappings))
          (restore-object* theory-mappings)))
      (when theory
        (let ((*restore-object-parent-slot* 'theory))
          (restore-object* theory)))
      (when exporting
        (let ((*restore-object-parent-slot* 'exporting))
          (restore-object* exporting)))
      (when all-usings
        (let ((*restore-object-parent-slot* 'all-usings))
          (restore-object* all-usings)))
      (when immediate-usings
        (let ((*restore-object-parent-slot* 'immediate-usings))
          (restore-object* immediate-usings)))
      (when instances-used
        (let ((*restore-object-parent-slot* 'instances-used))
          (restore-object* instances-used)))
      (when used-by
        (let ((*restore-object-parent-slot* 'used-by))
          (restore-object* used-by)))
      (when saved-context
        (let ((*restore-object-parent-slot* 'saved-context))
          (restore-object* saved-context)))
      (when dependent-known-subtypes
        (let ((*restore-object-parent-slot* 'dependent-known-subtypes))
          (restore-object* dependent-known-subtypes)))
      obj)))

(defmethod copy ((obj simple-constructor) &rest initargs)
  (with-slots (place recognizer ordnum generated-by id arguments
                     con-decl rec-decl acc-decls)
    obj
    (make-instance 'simple-constructor :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :recognizer
                   (let* ((get1 (getf initargs 'recognizer '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :recognizer '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) recognizer getfv))
                   :ordnum
                   (let* ((get1 (getf initargs 'ordnum '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ordnum '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ordnum getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :arguments
                   (let* ((get1 (getf initargs 'arguments '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :arguments '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) arguments getfv))
                   :con-decl
                   (let* ((get1 (getf initargs 'con-decl '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :con-decl '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) con-decl getfv))
                   :rec-decl
                   (let* ((get1 (getf initargs 'rec-decl '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :rec-decl '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) rec-decl getfv))
                   :acc-decls
                   (let* ((get1 (getf initargs 'acc-decls '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acc-decls '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acc-decls getfv)))))

(defmethod store-object* ((obj simple-constructor))
  (with-slots (place recognizer ordnum generated-by id arguments
                     con-decl rec-decl acc-decls)
    obj
    (reserve-space 10 (push-word (store-obj 'simple-constructor))
                   (push-word (store-obj place))
                   (push-word (store-obj recognizer))
                   (push-word (store-obj ordnum))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj id))
                   (push-word (store-obj arguments))
                   (push-word (store-obj con-decl))
                   (push-word (store-obj rec-decl))
                   (push-word (store-obj acc-decls)))))

(defmethod update-fetched ((obj simple-constructor))
  (with-slots (place recognizer ordnum generated-by id arguments
                     con-decl rec-decl acc-decls pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf recognizer (fetch-obj (stored-word 2)))
    (setf ordnum (fetch-obj (stored-word 3)))
    (setf generated-by (fetch-obj (stored-word 4)))
    (setf id (fetch-obj (stored-word 5)))
    (setf arguments (fetch-obj (stored-word 6)))
    (setf con-decl (fetch-obj (stored-word 7)))
    (setf rec-decl (fetch-obj (stored-word 8)))
    (setf acc-decls (fetch-obj (stored-word 9)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj simple-constructor))
  (with-slots (recognizer generated-by arguments con-decl rec-decl
                          acc-decls)
    obj
    (let ((*restore-object-parent* obj))
      (when recognizer
        (let ((*restore-object-parent-slot* 'recognizer))
          (restore-object* recognizer)))
      (when generated-by
        (let ((*restore-object-parent-slot* 'generated-by))
          (restore-object* generated-by)))
      (when arguments
        (let ((*restore-object-parent-slot* 'arguments))
          (restore-object* arguments)))
      (when con-decl
        (let ((*restore-object-parent-slot* 'con-decl))
          (restore-object* con-decl)))
      (when rec-decl
        (let ((*restore-object-parent-slot* 'rec-decl))
          (restore-object* rec-decl)))
      (when acc-decls
        (let ((*restore-object-parent-slot* 'acc-decls))
          (restore-object* acc-decls)))
      obj)))

(defmethod copy ((obj constructor-with-subtype) &rest initargs)
  (with-slots (place recognizer ordnum generated-by id arguments
                     con-decl rec-decl acc-decls subtype)
    obj
    (make-instance 'constructor-with-subtype :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :recognizer
                   (let* ((get1 (getf initargs 'recognizer '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :recognizer '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) recognizer getfv))
                   :ordnum
                   (let* ((get1 (getf initargs 'ordnum '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ordnum '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ordnum getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :arguments
                   (let* ((get1 (getf initargs 'arguments '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :arguments '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) arguments getfv))
                   :con-decl
                   (let* ((get1 (getf initargs 'con-decl '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :con-decl '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) con-decl getfv))
                   :rec-decl
                   (let* ((get1 (getf initargs 'rec-decl '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :rec-decl '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) rec-decl getfv))
                   :acc-decls
                   (let* ((get1 (getf initargs 'acc-decls '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acc-decls '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acc-decls getfv))
                   :subtype
                   (let* ((get1 (getf initargs 'subtype '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :subtype '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) subtype getfv)))))

(defmethod store-object* ((obj constructor-with-subtype))
  (with-slots (place recognizer ordnum generated-by id arguments
                     con-decl rec-decl acc-decls subtype)
    obj
    (reserve-space 11 (push-word (store-obj 'constructor-with-subtype))
                   (push-word (store-obj place))
                   (push-word (store-obj recognizer))
                   (push-word (store-obj ordnum))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj id))
                   (push-word (store-obj arguments))
                   (push-word (store-obj con-decl))
                   (push-word (store-obj rec-decl))
                   (push-word (store-obj acc-decls))
                   (push-word (store-obj subtype)))))

(defmethod update-fetched ((obj constructor-with-subtype))
  (with-slots (place recognizer ordnum generated-by id arguments
                     con-decl rec-decl acc-decls subtype
                     pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf recognizer (fetch-obj (stored-word 2)))
    (setf ordnum (fetch-obj (stored-word 3)))
    (setf generated-by (fetch-obj (stored-word 4)))
    (setf id (fetch-obj (stored-word 5)))
    (setf arguments (fetch-obj (stored-word 6)))
    (setf con-decl (fetch-obj (stored-word 7)))
    (setf rec-decl (fetch-obj (stored-word 8)))
    (setf acc-decls (fetch-obj (stored-word 9)))
    (setf subtype (fetch-obj (stored-word 10)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj constructor-with-subtype))
  (with-slots (recognizer generated-by arguments con-decl rec-decl
                          acc-decls subtype)
    obj
    (let ((*restore-object-parent* obj))
      (when recognizer
        (let ((*restore-object-parent-slot* 'recognizer))
          (restore-object* recognizer)))
      (when generated-by
        (let ((*restore-object-parent-slot* 'generated-by))
          (restore-object* generated-by)))
      (when arguments
        (let ((*restore-object-parent-slot* 'arguments))
          (restore-object* arguments)))
      (when con-decl
        (let ((*restore-object-parent-slot* 'con-decl))
          (restore-object* con-decl)))
      (when rec-decl
        (let ((*restore-object-parent-slot* 'rec-decl))
          (restore-object* rec-decl)))
      (when acc-decls
        (let ((*restore-object-parent-slot* 'acc-decls))
          (restore-object* acc-decls)))
      (when subtype
        (let ((*restore-object-parent-slot* 'subtype))
          (restore-object* subtype)))
      obj)))

(defmethod copy ((obj adt-constructor) &rest initargs)
  (with-slots (place recognizer ordnum generated-by)
    obj
    (make-instance 'adt-constructor :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :recognizer
                   (let* ((get1 (getf initargs 'recognizer '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :recognizer '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) recognizer getfv))
                   :ordnum
                   (let* ((get1 (getf initargs 'ordnum '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :ordnum '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) ordnum getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv)))))

(defmethod store-object* ((obj adt-constructor))
  (with-slots (place recognizer ordnum generated-by)
    obj
    (reserve-space 5 (push-word (store-obj 'adt-constructor))
                   (push-word (store-obj place))
                   (push-word (store-obj recognizer))
                   (push-word (store-obj ordnum))
                   (push-word (store-obj generated-by)))))

(defmethod update-fetched ((obj adt-constructor))
  (with-slots (place recognizer ordnum generated-by pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf recognizer (fetch-obj (stored-word 2)))
    (setf ordnum (fetch-obj (stored-word 3)))
    (setf generated-by (fetch-obj (stored-word 4)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj adt-constructor))
  (with-slots (recognizer generated-by)
    obj
    (let ((*restore-object-parent* obj))
      (when recognizer
        (let ((*restore-object-parent-slot* 'recognizer))
          (restore-object* recognizer)))
      (when generated-by
        (let ((*restore-object-parent-slot* 'generated-by))
          (restore-object* generated-by)))
      obj)))

(defmethod copy ((obj inline-codatatype-with-subtypes) &rest initargs)
  (with-slots (subtypes unique-id place id formals formals-sans-usings
                        theory-formal-decls assuming filename
                        context-path status generated-by tcc-comments
                        info warnings conversion-messages
                        all-declarations all-imported-theories
                        all-imported-names theory-mappings importings
                        constructors adt-type-name positive-types
                        adt-theory adt-map-theory adt-reduce-theory
                        generated-file-date semi decl-formals module
                        generated typechecked?)
    obj
    (make-instance 'inline-codatatype-with-subtypes :subtypes
                   (let* ((get1 (getf initargs 'subtypes '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :subtypes '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) subtypes getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :formals-sans-usings
                   (let* ((get1
                           (getf initargs 'formals-sans-usings
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :formals-sans-usings
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         formals-sans-usings
                       getfv))
                   :theory-formal-decls
                   (let* ((get1
                           (getf initargs 'theory-formal-decls
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :theory-formal-decls
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         theory-formal-decls
                       getfv))
                   :assuming
                   (let* ((get1 (getf initargs 'assuming '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :assuming '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) assuming getfv))
                   :filename
                   (let* ((get1 (getf initargs 'filename '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :filename '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) filename getfv))
                   :context-path
                   (let* ((get1 (getf initargs 'context-path '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :context-path '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) context-path getfv))
                   :status
                   (let* ((get1 (getf initargs 'status '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :status '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) status getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :tcc-comments
                   (let* ((get1 (getf initargs 'tcc-comments '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-comments '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-comments getfv))
                   :info
                   (let* ((get1 (getf initargs 'info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) info getfv))
                   :warnings
                   (let* ((get1 (getf initargs 'warnings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :warnings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) warnings getfv))
                   :conversion-messages
                   (let* ((get1
                           (getf initargs 'conversion-messages
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :conversion-messages
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         conversion-messages
                       getfv))
                   :all-declarations
                   (let* ((get1
                           (getf initargs 'all-declarations '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-declarations
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) all-declarations getfv))
                   :all-imported-theories
                   (let* ((get1
                           (getf initargs 'all-imported-theories
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-imported-theories
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         all-imported-theories
                       getfv))
                   :all-imported-names
                   (let* ((get1
                           (getf initargs 'all-imported-names
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-imported-names
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) all-imported-names getfv))
                   :theory-mappings
                   (let* ((get1
                           (getf initargs 'theory-mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :theory-mappings
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) theory-mappings getfv))
                   :importings
                   (let* ((get1 (getf initargs 'importings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :importings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) importings getfv))
                   :constructors
                   (let* ((get1 (getf initargs 'constructors '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :constructors '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) constructors getfv))
                   :adt-type-name
                   (let* ((get1
                           (getf initargs 'adt-type-name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-type-name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-type-name getfv))
                   :positive-types
                   (let* ((get1
                           (getf initargs 'positive-types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :positive-types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) positive-types getfv))
                   :adt-theory
                   (let* ((get1 (getf initargs 'adt-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-theory '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-theory getfv))
                   :adt-map-theory
                   (let* ((get1
                           (getf initargs 'adt-map-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-map-theory '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-map-theory getfv))
                   :adt-reduce-theory
                   (let* ((get1
                           (getf initargs 'adt-reduce-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :adt-reduce-theory
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-reduce-theory getfv))
                   :generated-file-date
                   (let* ((get1
                           (getf initargs 'generated-file-date
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :generated-file-date
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         generated-file-date
                       getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv)))))

(defmethod store-object* ((obj inline-codatatype-with-subtypes))
  (with-slots (subtypes unique-id place id formals theory-formal-decls
                        assuming filename context-path status
                        generated-by tcc-comments info warnings
                        conversion-messages theory-mappings importings
                        constructors adt-type-name positive-types
                        adt-theory adt-map-theory adt-reduce-theory
                        generated-file-date semi decl-formals module
                        generated typechecked?)
    obj
    (reserve-space 30
                   (push-word (store-obj 'inline-codatatype-with-subtypes))
                   (push-word (store-obj subtypes))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj place))
                   (push-word (store-obj id))
                   (push-word (store-obj formals))
                   (push-word (store-obj theory-formal-decls))
                   (push-word (store-obj assuming))
                   (push-word (store-obj filename))
                   (push-word (store-obj context-path))
                   (push-word (store-obj status))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj tcc-comments))
                   (push-word (store-obj info))
                   (push-word (store-obj warnings))
                   (push-word (store-obj conversion-messages))
                   (push-word (store-obj theory-mappings))
                   (push-word (store-obj importings))
                   (push-word (store-obj constructors))
                   (push-word (store-obj adt-type-name))
                   (push-word (store-obj positive-types))
                   (push-word (store-obj adt-theory))
                   (push-word (store-obj adt-map-theory))
                   (push-word (store-obj adt-reduce-theory))
                   (push-word (store-obj generated-file-date))
                   (push-word (store-obj semi))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj module))
                   (push-word (store-obj generated))
                   (push-word (store-obj typechecked?)))))

(defmethod update-fetched ((obj inline-codatatype-with-subtypes))
  (with-slots (subtypes unique-id place id formals theory-formal-decls
                        assuming filename context-path status
                        generated-by tcc-comments info warnings
                        conversion-messages theory-mappings importings
                        constructors adt-type-name positive-types
                        adt-theory adt-map-theory adt-reduce-theory
                        generated-file-date semi decl-formals module
                        generated typechecked? pvs-sxhash-value
                        formals-sans-usings all-declarations
                        all-imported-theories all-imported-names)
    obj
    (setf subtypes (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf place (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf formals (fetch-obj (stored-word 5)))
    (setf theory-formal-decls (fetch-obj (stored-word 6)))
    (setf assuming (fetch-obj (stored-word 7)))
    (setf filename (fetch-obj (stored-word 8)))
    (setf context-path (fetch-obj (stored-word 9)))
    (setf status (fetch-obj (stored-word 10)))
    (setf generated-by (fetch-obj (stored-word 11)))
    (setf tcc-comments (fetch-obj (stored-word 12)))
    (setf info (fetch-obj (stored-word 13)))
    (setf warnings (fetch-obj (stored-word 14)))
    (setf conversion-messages (fetch-obj (stored-word 15)))
    (setf theory-mappings (fetch-obj (stored-word 16)))
    (setf importings (fetch-obj (stored-word 17)))
    (setf constructors (fetch-obj (stored-word 18)))
    (setf adt-type-name (fetch-obj (stored-word 19)))
    (setf positive-types (fetch-obj (stored-word 20)))
    (setf adt-theory (fetch-obj (stored-word 21)))
    (setf adt-map-theory (fetch-obj (stored-word 22)))
    (setf adt-reduce-theory (fetch-obj (stored-word 23)))
    (setf generated-file-date (fetch-obj (stored-word 24)))
    (setf semi (fetch-obj (stored-word 25)))
    (setf decl-formals (fetch-obj (stored-word 26)))
    (setf module (fetch-obj (stored-word 27)))
    (setf generated (fetch-obj (stored-word 28)))
    (setf typechecked? (fetch-obj (stored-word 29)))
    (setf pvs-sxhash-value nil)
    (setf formals-sans-usings nil)
    (setf all-declarations nil)
    (setf all-imported-theories 'unbound)
    (setf all-imported-names 'unbound)))

(defmethod restore-object* ((obj inline-codatatype-with-subtypes))
  (with-slots (subtypes unique-id formals theory-formal-decls assuming
                        theory-mappings importings constructors
                        decl-formals module)
    obj
    (let ((*restore-object-parent* obj))
      (when subtypes
        (let ((*restore-object-parent-slot* 'subtypes))
          (restore-object* subtypes)))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when theory-formal-decls
        (let ((*restore-object-parent-slot* 'theory-formal-decls))
          (restore-object* theory-formal-decls)))
      (when assuming
        (let ((*restore-object-parent-slot* 'assuming))
          (restore-object* assuming)))
      (when theory-mappings
        (let ((*restore-object-parent-slot* 'theory-mappings))
          (restore-object* theory-mappings)))
      (when importings
        (let ((*restore-object-parent-slot* 'importings))
          (restore-object* importings)))
      (when constructors
        (let ((*restore-object-parent-slot* 'constructors))
          (restore-object* constructors)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when module
        (let ((*restore-object-parent-slot* 'module))
          (restore-object* module)))
      obj)))

(defmethod copy ((obj codatatype-with-subtypes) &rest initargs)
  (with-slots (subtypes place id formals formals-sans-usings
                        theory-formal-decls assuming filename
                        context-path status generated-by tcc-comments
                        info warnings conversion-messages
                        all-declarations all-imported-theories
                        all-imported-names theory-mappings importings
                        constructors adt-type-name positive-types
                        adt-theory adt-map-theory adt-reduce-theory
                        generated-file-date semi)
    obj
    (make-instance 'codatatype-with-subtypes :subtypes
                   (let* ((get1 (getf initargs 'subtypes '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :subtypes '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) subtypes getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :formals-sans-usings
                   (let* ((get1
                           (getf initargs 'formals-sans-usings
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :formals-sans-usings
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         formals-sans-usings
                       getfv))
                   :theory-formal-decls
                   (let* ((get1
                           (getf initargs 'theory-formal-decls
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :theory-formal-decls
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         theory-formal-decls
                       getfv))
                   :assuming
                   (let* ((get1 (getf initargs 'assuming '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :assuming '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) assuming getfv))
                   :filename
                   (let* ((get1 (getf initargs 'filename '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :filename '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) filename getfv))
                   :context-path
                   (let* ((get1 (getf initargs 'context-path '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :context-path '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) context-path getfv))
                   :status
                   (let* ((get1 (getf initargs 'status '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :status '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) status getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :tcc-comments
                   (let* ((get1 (getf initargs 'tcc-comments '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-comments '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-comments getfv))
                   :info
                   (let* ((get1 (getf initargs 'info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) info getfv))
                   :warnings
                   (let* ((get1 (getf initargs 'warnings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :warnings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) warnings getfv))
                   :conversion-messages
                   (let* ((get1
                           (getf initargs 'conversion-messages
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :conversion-messages
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         conversion-messages
                       getfv))
                   :all-declarations
                   (let* ((get1
                           (getf initargs 'all-declarations '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-declarations
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) all-declarations getfv))
                   :all-imported-theories
                   (let* ((get1
                           (getf initargs 'all-imported-theories
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-imported-theories
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         all-imported-theories
                       getfv))
                   :all-imported-names
                   (let* ((get1
                           (getf initargs 'all-imported-names
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-imported-names
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) all-imported-names getfv))
                   :theory-mappings
                   (let* ((get1
                           (getf initargs 'theory-mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :theory-mappings
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) theory-mappings getfv))
                   :importings
                   (let* ((get1 (getf initargs 'importings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :importings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) importings getfv))
                   :constructors
                   (let* ((get1 (getf initargs 'constructors '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :constructors '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) constructors getfv))
                   :adt-type-name
                   (let* ((get1
                           (getf initargs 'adt-type-name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-type-name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-type-name getfv))
                   :positive-types
                   (let* ((get1
                           (getf initargs 'positive-types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :positive-types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) positive-types getfv))
                   :adt-theory
                   (let* ((get1 (getf initargs 'adt-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-theory '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-theory getfv))
                   :adt-map-theory
                   (let* ((get1
                           (getf initargs 'adt-map-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-map-theory '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-map-theory getfv))
                   :adt-reduce-theory
                   (let* ((get1
                           (getf initargs 'adt-reduce-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :adt-reduce-theory
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-reduce-theory getfv))
                   :generated-file-date
                   (let* ((get1
                           (getf initargs 'generated-file-date
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :generated-file-date
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         generated-file-date
                       getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv)))))

(defmethod store-object* ((obj codatatype-with-subtypes))
  (with-slots (subtypes place id formals theory-formal-decls assuming
                        filename context-path status generated-by
                        tcc-comments info warnings conversion-messages
                        theory-mappings importings constructors
                        adt-type-name positive-types adt-theory
                        adt-map-theory adt-reduce-theory
                        generated-file-date semi)
    obj
    (reserve-space 25 (push-word (store-obj 'codatatype-with-subtypes))
                   (push-word (store-obj subtypes))
                   (push-word (store-obj place))
                   (push-word (store-obj id))
                   (push-word (store-obj formals))
                   (push-word (store-obj theory-formal-decls))
                   (push-word (store-obj assuming))
                   (push-word (store-obj filename))
                   (push-word (store-obj context-path))
                   (push-word (store-obj status))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj tcc-comments))
                   (push-word (store-obj info))
                   (push-word (store-obj warnings))
                   (push-word (store-obj conversion-messages))
                   (push-word (store-obj theory-mappings))
                   (push-word (store-obj importings))
                   (push-word (store-obj constructors))
                   (push-word (store-obj adt-type-name))
                   (push-word (store-obj positive-types))
                   (push-word (store-obj adt-theory))
                   (push-word (store-obj adt-map-theory))
                   (push-word (store-obj adt-reduce-theory))
                   (push-word (store-obj generated-file-date))
                   (push-word (store-obj semi)))))

(defmethod update-fetched ((obj codatatype-with-subtypes))
  (with-slots (subtypes place id formals theory-formal-decls assuming
                        filename context-path status generated-by
                        tcc-comments info warnings conversion-messages
                        theory-mappings importings constructors
                        adt-type-name positive-types adt-theory
                        adt-map-theory adt-reduce-theory
                        generated-file-date semi pvs-sxhash-value
                        formals-sans-usings all-declarations
                        all-imported-theories all-imported-names)
    obj
    (setf subtypes (fetch-obj (stored-word 1)))
    (setf place (fetch-obj (stored-word 2)))
    (setf id (fetch-obj (stored-word 3)))
    (setf formals (fetch-obj (stored-word 4)))
    (setf theory-formal-decls (fetch-obj (stored-word 5)))
    (setf assuming (fetch-obj (stored-word 6)))
    (setf filename (fetch-obj (stored-word 7)))
    (setf context-path (fetch-obj (stored-word 8)))
    (setf status (fetch-obj (stored-word 9)))
    (setf generated-by (fetch-obj (stored-word 10)))
    (setf tcc-comments (fetch-obj (stored-word 11)))
    (setf info (fetch-obj (stored-word 12)))
    (setf warnings (fetch-obj (stored-word 13)))
    (setf conversion-messages (fetch-obj (stored-word 14)))
    (setf theory-mappings (fetch-obj (stored-word 15)))
    (setf importings (fetch-obj (stored-word 16)))
    (setf constructors (fetch-obj (stored-word 17)))
    (setf adt-type-name (fetch-obj (stored-word 18)))
    (setf positive-types (fetch-obj (stored-word 19)))
    (setf adt-theory (fetch-obj (stored-word 20)))
    (setf adt-map-theory (fetch-obj (stored-word 21)))
    (setf adt-reduce-theory (fetch-obj (stored-word 22)))
    (setf generated-file-date (fetch-obj (stored-word 23)))
    (setf semi (fetch-obj (stored-word 24)))
    (setf pvs-sxhash-value nil)
    (setf formals-sans-usings nil)
    (setf all-declarations nil)
    (setf all-imported-theories 'unbound)
    (setf all-imported-names 'unbound)))

(defmethod restore-object* ((obj codatatype-with-subtypes))
  (with-slots (subtypes formals theory-formal-decls assuming
                        theory-mappings importings constructors)
    obj
    (let ((*restore-object-parent* obj))
      (when subtypes
        (let ((*restore-object-parent-slot* 'subtypes))
          (restore-object* subtypes)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when theory-formal-decls
        (let ((*restore-object-parent-slot* 'theory-formal-decls))
          (restore-object* theory-formal-decls)))
      (when assuming
        (let ((*restore-object-parent-slot* 'assuming))
          (restore-object* assuming)))
      (when theory-mappings
        (let ((*restore-object-parent-slot* 'theory-mappings))
          (restore-object* theory-mappings)))
      (when importings
        (let ((*restore-object-parent-slot* 'importings))
          (restore-object* importings)))
      (when constructors
        (let ((*restore-object-parent-slot* 'constructors))
          (restore-object* constructors)))
      obj)))

(defmethod copy ((obj inline-codatatype) &rest initargs)
  (with-slots (unique-id place id formals formals-sans-usings
                         theory-formal-decls assuming filename
                         context-path status generated-by tcc-comments
                         info warnings conversion-messages
                         all-declarations all-imported-theories
                         all-imported-names theory-mappings importings
                         constructors adt-type-name positive-types
                         adt-theory adt-map-theory adt-reduce-theory
                         generated-file-date semi decl-formals module
                         generated typechecked?)
    obj
    (make-instance 'inline-codatatype :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :formals-sans-usings
                   (let* ((get1
                           (getf initargs 'formals-sans-usings
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :formals-sans-usings
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         formals-sans-usings
                       getfv))
                   :theory-formal-decls
                   (let* ((get1
                           (getf initargs 'theory-formal-decls
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :theory-formal-decls
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         theory-formal-decls
                       getfv))
                   :assuming
                   (let* ((get1 (getf initargs 'assuming '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :assuming '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) assuming getfv))
                   :filename
                   (let* ((get1 (getf initargs 'filename '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :filename '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) filename getfv))
                   :context-path
                   (let* ((get1 (getf initargs 'context-path '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :context-path '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) context-path getfv))
                   :status
                   (let* ((get1 (getf initargs 'status '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :status '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) status getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :tcc-comments
                   (let* ((get1 (getf initargs 'tcc-comments '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-comments '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-comments getfv))
                   :info
                   (let* ((get1 (getf initargs 'info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) info getfv))
                   :warnings
                   (let* ((get1 (getf initargs 'warnings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :warnings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) warnings getfv))
                   :conversion-messages
                   (let* ((get1
                           (getf initargs 'conversion-messages
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :conversion-messages
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         conversion-messages
                       getfv))
                   :all-declarations
                   (let* ((get1
                           (getf initargs 'all-declarations '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-declarations
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) all-declarations getfv))
                   :all-imported-theories
                   (let* ((get1
                           (getf initargs 'all-imported-theories
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-imported-theories
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         all-imported-theories
                       getfv))
                   :all-imported-names
                   (let* ((get1
                           (getf initargs 'all-imported-names
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-imported-names
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) all-imported-names getfv))
                   :theory-mappings
                   (let* ((get1
                           (getf initargs 'theory-mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :theory-mappings
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) theory-mappings getfv))
                   :importings
                   (let* ((get1 (getf initargs 'importings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :importings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) importings getfv))
                   :constructors
                   (let* ((get1 (getf initargs 'constructors '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :constructors '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) constructors getfv))
                   :adt-type-name
                   (let* ((get1
                           (getf initargs 'adt-type-name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-type-name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-type-name getfv))
                   :positive-types
                   (let* ((get1
                           (getf initargs 'positive-types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :positive-types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) positive-types getfv))
                   :adt-theory
                   (let* ((get1 (getf initargs 'adt-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-theory '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-theory getfv))
                   :adt-map-theory
                   (let* ((get1
                           (getf initargs 'adt-map-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-map-theory '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-map-theory getfv))
                   :adt-reduce-theory
                   (let* ((get1
                           (getf initargs 'adt-reduce-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :adt-reduce-theory
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-reduce-theory getfv))
                   :generated-file-date
                   (let* ((get1
                           (getf initargs 'generated-file-date
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :generated-file-date
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         generated-file-date
                       getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv)))))

(defmethod store-object* ((obj inline-codatatype))
  (with-slots (unique-id place id formals theory-formal-decls assuming
                         filename context-path status generated-by
                         tcc-comments info warnings conversion-messages
                         theory-mappings importings constructors
                         adt-type-name positive-types adt-theory
                         adt-map-theory adt-reduce-theory
                         generated-file-date semi decl-formals module
                         generated typechecked?)
    obj
    (reserve-space 29 (push-word (store-obj 'inline-codatatype))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj place))
                   (push-word (store-obj id))
                   (push-word (store-obj formals))
                   (push-word (store-obj theory-formal-decls))
                   (push-word (store-obj assuming))
                   (push-word (store-obj filename))
                   (push-word (store-obj context-path))
                   (push-word (store-obj status))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj tcc-comments))
                   (push-word (store-obj info))
                   (push-word (store-obj warnings))
                   (push-word (store-obj conversion-messages))
                   (push-word (store-obj theory-mappings))
                   (push-word (store-obj importings))
                   (push-word (store-obj constructors))
                   (push-word (store-obj adt-type-name))
                   (push-word (store-obj positive-types))
                   (push-word (store-obj adt-theory))
                   (push-word (store-obj adt-map-theory))
                   (push-word (store-obj adt-reduce-theory))
                   (push-word (store-obj generated-file-date))
                   (push-word (store-obj semi))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj module))
                   (push-word (store-obj generated))
                   (push-word (store-obj typechecked?)))))

(defmethod update-fetched ((obj inline-codatatype))
  (with-slots (unique-id place id formals theory-formal-decls assuming
                         filename context-path status generated-by
                         tcc-comments info warnings conversion-messages
                         theory-mappings importings constructors
                         adt-type-name positive-types adt-theory
                         adt-map-theory adt-reduce-theory
                         generated-file-date semi decl-formals module
                         generated typechecked? pvs-sxhash-value
                         formals-sans-usings all-declarations
                         all-imported-theories all-imported-names)
    obj
    (setf unique-id (fetch-obj (stored-word 1)))
    (setf place (fetch-obj (stored-word 2)))
    (setf id (fetch-obj (stored-word 3)))
    (setf formals (fetch-obj (stored-word 4)))
    (setf theory-formal-decls (fetch-obj (stored-word 5)))
    (setf assuming (fetch-obj (stored-word 6)))
    (setf filename (fetch-obj (stored-word 7)))
    (setf context-path (fetch-obj (stored-word 8)))
    (setf status (fetch-obj (stored-word 9)))
    (setf generated-by (fetch-obj (stored-word 10)))
    (setf tcc-comments (fetch-obj (stored-word 11)))
    (setf info (fetch-obj (stored-word 12)))
    (setf warnings (fetch-obj (stored-word 13)))
    (setf conversion-messages (fetch-obj (stored-word 14)))
    (setf theory-mappings (fetch-obj (stored-word 15)))
    (setf importings (fetch-obj (stored-word 16)))
    (setf constructors (fetch-obj (stored-word 17)))
    (setf adt-type-name (fetch-obj (stored-word 18)))
    (setf positive-types (fetch-obj (stored-word 19)))
    (setf adt-theory (fetch-obj (stored-word 20)))
    (setf adt-map-theory (fetch-obj (stored-word 21)))
    (setf adt-reduce-theory (fetch-obj (stored-word 22)))
    (setf generated-file-date (fetch-obj (stored-word 23)))
    (setf semi (fetch-obj (stored-word 24)))
    (setf decl-formals (fetch-obj (stored-word 25)))
    (setf module (fetch-obj (stored-word 26)))
    (setf generated (fetch-obj (stored-word 27)))
    (setf typechecked? (fetch-obj (stored-word 28)))
    (setf pvs-sxhash-value nil)
    (setf formals-sans-usings nil)
    (setf all-declarations nil)
    (setf all-imported-theories 'unbound)
    (setf all-imported-names 'unbound)))

(defmethod restore-object* ((obj inline-codatatype))
  (with-slots (unique-id formals theory-formal-decls assuming
                         theory-mappings importings constructors
                         decl-formals module)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when theory-formal-decls
        (let ((*restore-object-parent-slot* 'theory-formal-decls))
          (restore-object* theory-formal-decls)))
      (when assuming
        (let ((*restore-object-parent-slot* 'assuming))
          (restore-object* assuming)))
      (when theory-mappings
        (let ((*restore-object-parent-slot* 'theory-mappings))
          (restore-object* theory-mappings)))
      (when importings
        (let ((*restore-object-parent-slot* 'importings))
          (restore-object* importings)))
      (when constructors
        (let ((*restore-object-parent-slot* 'constructors))
          (restore-object* constructors)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when module
        (let ((*restore-object-parent-slot* 'module))
          (restore-object* module)))
      obj)))

(defmethod copy ((obj codatatype) &rest initargs)
  (with-slots (place id formals formals-sans-usings theory-formal-decls
                     assuming filename context-path status generated-by
                     tcc-comments info warnings conversion-messages
                     all-declarations all-imported-theories
                     all-imported-names theory-mappings importings
                     constructors adt-type-name positive-types
                     adt-theory adt-map-theory adt-reduce-theory
                     generated-file-date semi)
    obj
    (make-instance 'codatatype :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :formals-sans-usings
                   (let* ((get1
                           (getf initargs 'formals-sans-usings
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :formals-sans-usings
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         formals-sans-usings
                       getfv))
                   :theory-formal-decls
                   (let* ((get1
                           (getf initargs 'theory-formal-decls
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :theory-formal-decls
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         theory-formal-decls
                       getfv))
                   :assuming
                   (let* ((get1 (getf initargs 'assuming '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :assuming '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) assuming getfv))
                   :filename
                   (let* ((get1 (getf initargs 'filename '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :filename '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) filename getfv))
                   :context-path
                   (let* ((get1 (getf initargs 'context-path '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :context-path '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) context-path getfv))
                   :status
                   (let* ((get1 (getf initargs 'status '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :status '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) status getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :tcc-comments
                   (let* ((get1 (getf initargs 'tcc-comments '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-comments '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-comments getfv))
                   :info
                   (let* ((get1 (getf initargs 'info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) info getfv))
                   :warnings
                   (let* ((get1 (getf initargs 'warnings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :warnings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) warnings getfv))
                   :conversion-messages
                   (let* ((get1
                           (getf initargs 'conversion-messages
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :conversion-messages
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         conversion-messages
                       getfv))
                   :all-declarations
                   (let* ((get1
                           (getf initargs 'all-declarations '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-declarations
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) all-declarations getfv))
                   :all-imported-theories
                   (let* ((get1
                           (getf initargs 'all-imported-theories
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-imported-theories
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         all-imported-theories
                       getfv))
                   :all-imported-names
                   (let* ((get1
                           (getf initargs 'all-imported-names
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-imported-names
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) all-imported-names getfv))
                   :theory-mappings
                   (let* ((get1
                           (getf initargs 'theory-mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :theory-mappings
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) theory-mappings getfv))
                   :importings
                   (let* ((get1 (getf initargs 'importings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :importings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) importings getfv))
                   :constructors
                   (let* ((get1 (getf initargs 'constructors '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :constructors '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) constructors getfv))
                   :adt-type-name
                   (let* ((get1
                           (getf initargs 'adt-type-name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-type-name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-type-name getfv))
                   :positive-types
                   (let* ((get1
                           (getf initargs 'positive-types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :positive-types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) positive-types getfv))
                   :adt-theory
                   (let* ((get1 (getf initargs 'adt-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-theory '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-theory getfv))
                   :adt-map-theory
                   (let* ((get1
                           (getf initargs 'adt-map-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-map-theory '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-map-theory getfv))
                   :adt-reduce-theory
                   (let* ((get1
                           (getf initargs 'adt-reduce-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :adt-reduce-theory
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-reduce-theory getfv))
                   :generated-file-date
                   (let* ((get1
                           (getf initargs 'generated-file-date
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :generated-file-date
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         generated-file-date
                       getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv)))))

(defmethod store-object* ((obj codatatype))
  (with-slots (place id formals theory-formal-decls assuming filename
                     context-path status generated-by tcc-comments info
                     warnings conversion-messages theory-mappings
                     importings constructors adt-type-name
                     positive-types adt-theory adt-map-theory
                     adt-reduce-theory generated-file-date semi)
    obj
    (reserve-space 24 (push-word (store-obj 'codatatype))
                   (push-word (store-obj place))
                   (push-word (store-obj id))
                   (push-word (store-obj formals))
                   (push-word (store-obj theory-formal-decls))
                   (push-word (store-obj assuming))
                   (push-word (store-obj filename))
                   (push-word (store-obj context-path))
                   (push-word (store-obj status))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj tcc-comments))
                   (push-word (store-obj info))
                   (push-word (store-obj warnings))
                   (push-word (store-obj conversion-messages))
                   (push-word (store-obj theory-mappings))
                   (push-word (store-obj importings))
                   (push-word (store-obj constructors))
                   (push-word (store-obj adt-type-name))
                   (push-word (store-obj positive-types))
                   (push-word (store-obj adt-theory))
                   (push-word (store-obj adt-map-theory))
                   (push-word (store-obj adt-reduce-theory))
                   (push-word (store-obj generated-file-date))
                   (push-word (store-obj semi)))))

(defmethod update-fetched ((obj codatatype))
  (with-slots (place id formals theory-formal-decls assuming filename
                     context-path status generated-by tcc-comments info
                     warnings conversion-messages theory-mappings
                     importings constructors adt-type-name
                     positive-types adt-theory adt-map-theory
                     adt-reduce-theory generated-file-date semi
                     pvs-sxhash-value formals-sans-usings
                     all-declarations all-imported-theories
                     all-imported-names)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf id (fetch-obj (stored-word 2)))
    (setf formals (fetch-obj (stored-word 3)))
    (setf theory-formal-decls (fetch-obj (stored-word 4)))
    (setf assuming (fetch-obj (stored-word 5)))
    (setf filename (fetch-obj (stored-word 6)))
    (setf context-path (fetch-obj (stored-word 7)))
    (setf status (fetch-obj (stored-word 8)))
    (setf generated-by (fetch-obj (stored-word 9)))
    (setf tcc-comments (fetch-obj (stored-word 10)))
    (setf info (fetch-obj (stored-word 11)))
    (setf warnings (fetch-obj (stored-word 12)))
    (setf conversion-messages (fetch-obj (stored-word 13)))
    (setf theory-mappings (fetch-obj (stored-word 14)))
    (setf importings (fetch-obj (stored-word 15)))
    (setf constructors (fetch-obj (stored-word 16)))
    (setf adt-type-name (fetch-obj (stored-word 17)))
    (setf positive-types (fetch-obj (stored-word 18)))
    (setf adt-theory (fetch-obj (stored-word 19)))
    (setf adt-map-theory (fetch-obj (stored-word 20)))
    (setf adt-reduce-theory (fetch-obj (stored-word 21)))
    (setf generated-file-date (fetch-obj (stored-word 22)))
    (setf semi (fetch-obj (stored-word 23)))
    (setf pvs-sxhash-value nil)
    (setf formals-sans-usings nil)
    (setf all-declarations nil)
    (setf all-imported-theories 'unbound)
    (setf all-imported-names 'unbound)))

(defmethod restore-object* ((obj codatatype))
  (with-slots (formals theory-formal-decls assuming theory-mappings
                       importings constructors)
    obj
    (let ((*restore-object-parent* obj))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when theory-formal-decls
        (let ((*restore-object-parent-slot* 'theory-formal-decls))
          (restore-object* theory-formal-decls)))
      (when assuming
        (let ((*restore-object-parent-slot* 'assuming))
          (restore-object* assuming)))
      (when theory-mappings
        (let ((*restore-object-parent-slot* 'theory-mappings))
          (restore-object* theory-mappings)))
      (when importings
        (let ((*restore-object-parent-slot* 'importings))
          (restore-object* importings)))
      (when constructors
        (let ((*restore-object-parent-slot* 'constructors))
          (restore-object* constructors)))
      obj)))

(defmethod copy ((obj inline-datatype-with-subtypes) &rest initargs)
  (with-slots (subtypes unique-id place id formals formals-sans-usings
                        theory-formal-decls assuming filename
                        context-path status generated-by tcc-comments
                        info warnings conversion-messages
                        all-declarations all-imported-theories
                        all-imported-names theory-mappings importings
                        constructors adt-type-name positive-types
                        adt-theory adt-map-theory adt-reduce-theory
                        generated-file-date semi decl-formals module
                        generated typechecked?)
    obj
    (make-instance 'inline-datatype-with-subtypes :subtypes
                   (let* ((get1 (getf initargs 'subtypes '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :subtypes '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) subtypes getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :formals-sans-usings
                   (let* ((get1
                           (getf initargs 'formals-sans-usings
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :formals-sans-usings
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         formals-sans-usings
                       getfv))
                   :theory-formal-decls
                   (let* ((get1
                           (getf initargs 'theory-formal-decls
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :theory-formal-decls
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         theory-formal-decls
                       getfv))
                   :assuming
                   (let* ((get1 (getf initargs 'assuming '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :assuming '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) assuming getfv))
                   :filename
                   (let* ((get1 (getf initargs 'filename '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :filename '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) filename getfv))
                   :context-path
                   (let* ((get1 (getf initargs 'context-path '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :context-path '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) context-path getfv))
                   :status
                   (let* ((get1 (getf initargs 'status '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :status '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) status getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :tcc-comments
                   (let* ((get1 (getf initargs 'tcc-comments '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-comments '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-comments getfv))
                   :info
                   (let* ((get1 (getf initargs 'info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) info getfv))
                   :warnings
                   (let* ((get1 (getf initargs 'warnings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :warnings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) warnings getfv))
                   :conversion-messages
                   (let* ((get1
                           (getf initargs 'conversion-messages
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :conversion-messages
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         conversion-messages
                       getfv))
                   :all-declarations
                   (let* ((get1
                           (getf initargs 'all-declarations '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-declarations
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) all-declarations getfv))
                   :all-imported-theories
                   (let* ((get1
                           (getf initargs 'all-imported-theories
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-imported-theories
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         all-imported-theories
                       getfv))
                   :all-imported-names
                   (let* ((get1
                           (getf initargs 'all-imported-names
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-imported-names
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) all-imported-names getfv))
                   :theory-mappings
                   (let* ((get1
                           (getf initargs 'theory-mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :theory-mappings
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) theory-mappings getfv))
                   :importings
                   (let* ((get1 (getf initargs 'importings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :importings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) importings getfv))
                   :constructors
                   (let* ((get1 (getf initargs 'constructors '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :constructors '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) constructors getfv))
                   :adt-type-name
                   (let* ((get1
                           (getf initargs 'adt-type-name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-type-name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-type-name getfv))
                   :positive-types
                   (let* ((get1
                           (getf initargs 'positive-types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :positive-types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) positive-types getfv))
                   :adt-theory
                   (let* ((get1 (getf initargs 'adt-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-theory '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-theory getfv))
                   :adt-map-theory
                   (let* ((get1
                           (getf initargs 'adt-map-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-map-theory '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-map-theory getfv))
                   :adt-reduce-theory
                   (let* ((get1
                           (getf initargs 'adt-reduce-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :adt-reduce-theory
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-reduce-theory getfv))
                   :generated-file-date
                   (let* ((get1
                           (getf initargs 'generated-file-date
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :generated-file-date
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         generated-file-date
                       getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv)))))

(defmethod store-object* ((obj inline-datatype-with-subtypes))
  (with-slots (subtypes unique-id place id formals theory-formal-decls
                        assuming filename context-path status
                        generated-by tcc-comments info warnings
                        conversion-messages theory-mappings importings
                        constructors adt-type-name positive-types
                        adt-theory adt-map-theory adt-reduce-theory
                        generated-file-date semi decl-formals module
                        generated typechecked?)
    obj
    (reserve-space 30
                   (push-word (store-obj 'inline-datatype-with-subtypes))
                   (push-word (store-obj subtypes))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj place))
                   (push-word (store-obj id))
                   (push-word (store-obj formals))
                   (push-word (store-obj theory-formal-decls))
                   (push-word (store-obj assuming))
                   (push-word (store-obj filename))
                   (push-word (store-obj context-path))
                   (push-word (store-obj status))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj tcc-comments))
                   (push-word (store-obj info))
                   (push-word (store-obj warnings))
                   (push-word (store-obj conversion-messages))
                   (push-word (store-obj theory-mappings))
                   (push-word (store-obj importings))
                   (push-word (store-obj constructors))
                   (push-word (store-obj adt-type-name))
                   (push-word (store-obj positive-types))
                   (push-word (store-obj adt-theory))
                   (push-word (store-obj adt-map-theory))
                   (push-word (store-obj adt-reduce-theory))
                   (push-word (store-obj generated-file-date))
                   (push-word (store-obj semi))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj module))
                   (push-word (store-obj generated))
                   (push-word (store-obj typechecked?)))))

(defmethod update-fetched ((obj inline-datatype-with-subtypes))
  (with-slots (subtypes unique-id place id formals theory-formal-decls
                        assuming filename context-path status
                        generated-by tcc-comments info warnings
                        conversion-messages theory-mappings importings
                        constructors adt-type-name positive-types
                        adt-theory adt-map-theory adt-reduce-theory
                        generated-file-date semi decl-formals module
                        generated typechecked? pvs-sxhash-value
                        formals-sans-usings all-declarations
                        all-imported-theories all-imported-names)
    obj
    (setf subtypes (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf place (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf formals (fetch-obj (stored-word 5)))
    (setf theory-formal-decls (fetch-obj (stored-word 6)))
    (setf assuming (fetch-obj (stored-word 7)))
    (setf filename (fetch-obj (stored-word 8)))
    (setf context-path (fetch-obj (stored-word 9)))
    (setf status (fetch-obj (stored-word 10)))
    (setf generated-by (fetch-obj (stored-word 11)))
    (setf tcc-comments (fetch-obj (stored-word 12)))
    (setf info (fetch-obj (stored-word 13)))
    (setf warnings (fetch-obj (stored-word 14)))
    (setf conversion-messages (fetch-obj (stored-word 15)))
    (setf theory-mappings (fetch-obj (stored-word 16)))
    (setf importings (fetch-obj (stored-word 17)))
    (setf constructors (fetch-obj (stored-word 18)))
    (setf adt-type-name (fetch-obj (stored-word 19)))
    (setf positive-types (fetch-obj (stored-word 20)))
    (setf adt-theory (fetch-obj (stored-word 21)))
    (setf adt-map-theory (fetch-obj (stored-word 22)))
    (setf adt-reduce-theory (fetch-obj (stored-word 23)))
    (setf generated-file-date (fetch-obj (stored-word 24)))
    (setf semi (fetch-obj (stored-word 25)))
    (setf decl-formals (fetch-obj (stored-word 26)))
    (setf module (fetch-obj (stored-word 27)))
    (setf generated (fetch-obj (stored-word 28)))
    (setf typechecked? (fetch-obj (stored-word 29)))
    (setf pvs-sxhash-value nil)
    (setf formals-sans-usings nil)
    (setf all-declarations nil)
    (setf all-imported-theories 'unbound)
    (setf all-imported-names 'unbound)))

(defmethod restore-object* ((obj inline-datatype-with-subtypes))
  (with-slots (subtypes unique-id formals theory-formal-decls assuming
                        theory-mappings importings constructors
                        decl-formals module)
    obj
    (let ((*restore-object-parent* obj))
      (when subtypes
        (let ((*restore-object-parent-slot* 'subtypes))
          (restore-object* subtypes)))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when theory-formal-decls
        (let ((*restore-object-parent-slot* 'theory-formal-decls))
          (restore-object* theory-formal-decls)))
      (when assuming
        (let ((*restore-object-parent-slot* 'assuming))
          (restore-object* assuming)))
      (when theory-mappings
        (let ((*restore-object-parent-slot* 'theory-mappings))
          (restore-object* theory-mappings)))
      (when importings
        (let ((*restore-object-parent-slot* 'importings))
          (restore-object* importings)))
      (when constructors
        (let ((*restore-object-parent-slot* 'constructors))
          (restore-object* constructors)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when module
        (let ((*restore-object-parent-slot* 'module))
          (restore-object* module)))
      obj)))

(defmethod copy ((obj datatype-with-subtypes) &rest initargs)
  (with-slots (place id formals formals-sans-usings theory-formal-decls
                     assuming filename context-path status generated-by
                     tcc-comments info warnings conversion-messages
                     all-declarations all-imported-theories
                     all-imported-names theory-mappings importings
                     constructors adt-type-name positive-types
                     adt-theory adt-map-theory adt-reduce-theory
                     generated-file-date semi subtypes)
    obj
    (make-instance 'datatype-with-subtypes :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :formals-sans-usings
                   (let* ((get1
                           (getf initargs 'formals-sans-usings
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :formals-sans-usings
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         formals-sans-usings
                       getfv))
                   :theory-formal-decls
                   (let* ((get1
                           (getf initargs 'theory-formal-decls
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :theory-formal-decls
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         theory-formal-decls
                       getfv))
                   :assuming
                   (let* ((get1 (getf initargs 'assuming '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :assuming '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) assuming getfv))
                   :filename
                   (let* ((get1 (getf initargs 'filename '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :filename '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) filename getfv))
                   :context-path
                   (let* ((get1 (getf initargs 'context-path '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :context-path '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) context-path getfv))
                   :status
                   (let* ((get1 (getf initargs 'status '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :status '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) status getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :tcc-comments
                   (let* ((get1 (getf initargs 'tcc-comments '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-comments '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-comments getfv))
                   :info
                   (let* ((get1 (getf initargs 'info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) info getfv))
                   :warnings
                   (let* ((get1 (getf initargs 'warnings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :warnings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) warnings getfv))
                   :conversion-messages
                   (let* ((get1
                           (getf initargs 'conversion-messages
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :conversion-messages
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         conversion-messages
                       getfv))
                   :all-declarations
                   (let* ((get1
                           (getf initargs 'all-declarations '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-declarations
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) all-declarations getfv))
                   :all-imported-theories
                   (let* ((get1
                           (getf initargs 'all-imported-theories
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-imported-theories
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         all-imported-theories
                       getfv))
                   :all-imported-names
                   (let* ((get1
                           (getf initargs 'all-imported-names
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-imported-names
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) all-imported-names getfv))
                   :theory-mappings
                   (let* ((get1
                           (getf initargs 'theory-mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :theory-mappings
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) theory-mappings getfv))
                   :importings
                   (let* ((get1 (getf initargs 'importings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :importings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) importings getfv))
                   :constructors
                   (let* ((get1 (getf initargs 'constructors '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :constructors '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) constructors getfv))
                   :adt-type-name
                   (let* ((get1
                           (getf initargs 'adt-type-name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-type-name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-type-name getfv))
                   :positive-types
                   (let* ((get1
                           (getf initargs 'positive-types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :positive-types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) positive-types getfv))
                   :adt-theory
                   (let* ((get1 (getf initargs 'adt-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-theory '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-theory getfv))
                   :adt-map-theory
                   (let* ((get1
                           (getf initargs 'adt-map-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-map-theory '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-map-theory getfv))
                   :adt-reduce-theory
                   (let* ((get1
                           (getf initargs 'adt-reduce-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :adt-reduce-theory
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-reduce-theory getfv))
                   :generated-file-date
                   (let* ((get1
                           (getf initargs 'generated-file-date
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :generated-file-date
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         generated-file-date
                       getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :subtypes
                   (let* ((get1 (getf initargs 'subtypes '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :subtypes '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) subtypes getfv)))))

(defmethod store-object* ((obj datatype-with-subtypes))
  (with-slots (place id formals theory-formal-decls assuming filename
                     context-path status generated-by tcc-comments info
                     warnings conversion-messages theory-mappings
                     importings constructors adt-type-name
                     positive-types adt-theory adt-map-theory
                     adt-reduce-theory generated-file-date semi
                     subtypes)
    obj
    (reserve-space 25 (push-word (store-obj 'datatype-with-subtypes))
                   (push-word (store-obj place))
                   (push-word (store-obj id))
                   (push-word (store-obj formals))
                   (push-word (store-obj theory-formal-decls))
                   (push-word (store-obj assuming))
                   (push-word (store-obj filename))
                   (push-word (store-obj context-path))
                   (push-word (store-obj status))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj tcc-comments))
                   (push-word (store-obj info))
                   (push-word (store-obj warnings))
                   (push-word (store-obj conversion-messages))
                   (push-word (store-obj theory-mappings))
                   (push-word (store-obj importings))
                   (push-word (store-obj constructors))
                   (push-word (store-obj adt-type-name))
                   (push-word (store-obj positive-types))
                   (push-word (store-obj adt-theory))
                   (push-word (store-obj adt-map-theory))
                   (push-word (store-obj adt-reduce-theory))
                   (push-word (store-obj generated-file-date))
                   (push-word (store-obj semi))
                   (push-word (store-obj subtypes)))))

(defmethod update-fetched ((obj datatype-with-subtypes))
  (with-slots (place id formals theory-formal-decls assuming filename
                     context-path status generated-by tcc-comments info
                     warnings conversion-messages theory-mappings
                     importings constructors adt-type-name
                     positive-types adt-theory adt-map-theory
                     adt-reduce-theory generated-file-date semi
                     subtypes pvs-sxhash-value formals-sans-usings
                     all-declarations all-imported-theories
                     all-imported-names)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf id (fetch-obj (stored-word 2)))
    (setf formals (fetch-obj (stored-word 3)))
    (setf theory-formal-decls (fetch-obj (stored-word 4)))
    (setf assuming (fetch-obj (stored-word 5)))
    (setf filename (fetch-obj (stored-word 6)))
    (setf context-path (fetch-obj (stored-word 7)))
    (setf status (fetch-obj (stored-word 8)))
    (setf generated-by (fetch-obj (stored-word 9)))
    (setf tcc-comments (fetch-obj (stored-word 10)))
    (setf info (fetch-obj (stored-word 11)))
    (setf warnings (fetch-obj (stored-word 12)))
    (setf conversion-messages (fetch-obj (stored-word 13)))
    (setf theory-mappings (fetch-obj (stored-word 14)))
    (setf importings (fetch-obj (stored-word 15)))
    (setf constructors (fetch-obj (stored-word 16)))
    (setf adt-type-name (fetch-obj (stored-word 17)))
    (setf positive-types (fetch-obj (stored-word 18)))
    (setf adt-theory (fetch-obj (stored-word 19)))
    (setf adt-map-theory (fetch-obj (stored-word 20)))
    (setf adt-reduce-theory (fetch-obj (stored-word 21)))
    (setf generated-file-date (fetch-obj (stored-word 22)))
    (setf semi (fetch-obj (stored-word 23)))
    (setf subtypes (fetch-obj (stored-word 24)))
    (setf pvs-sxhash-value nil)
    (setf formals-sans-usings nil)
    (setf all-declarations nil)
    (setf all-imported-theories 'unbound)
    (setf all-imported-names 'unbound)))

(defmethod restore-object* ((obj datatype-with-subtypes))
  (with-slots (formals theory-formal-decls assuming theory-mappings
                       importings constructors subtypes)
    obj
    (let ((*restore-object-parent* obj))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when theory-formal-decls
        (let ((*restore-object-parent-slot* 'theory-formal-decls))
          (restore-object* theory-formal-decls)))
      (when assuming
        (let ((*restore-object-parent-slot* 'assuming))
          (restore-object* assuming)))
      (when theory-mappings
        (let ((*restore-object-parent-slot* 'theory-mappings))
          (restore-object* theory-mappings)))
      (when importings
        (let ((*restore-object-parent-slot* 'importings))
          (restore-object* importings)))
      (when constructors
        (let ((*restore-object-parent-slot* 'constructors))
          (restore-object* constructors)))
      (when subtypes
        (let ((*restore-object-parent-slot* 'subtypes))
          (restore-object* subtypes)))
      obj)))

(defmethod copy ((obj inline-datatype) &rest initargs)
  (with-slots (unique-id place id formals formals-sans-usings
                         theory-formal-decls assuming filename
                         context-path status generated-by tcc-comments
                         info warnings conversion-messages
                         all-declarations all-imported-theories
                         all-imported-names theory-mappings importings
                         constructors adt-type-name positive-types
                         adt-theory adt-map-theory adt-reduce-theory
                         generated-file-date semi decl-formals module
                         generated typechecked?)
    obj
    (make-instance 'inline-datatype :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :formals-sans-usings
                   (let* ((get1
                           (getf initargs 'formals-sans-usings
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :formals-sans-usings
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         formals-sans-usings
                       getfv))
                   :theory-formal-decls
                   (let* ((get1
                           (getf initargs 'theory-formal-decls
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :theory-formal-decls
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         theory-formal-decls
                       getfv))
                   :assuming
                   (let* ((get1 (getf initargs 'assuming '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :assuming '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) assuming getfv))
                   :filename
                   (let* ((get1 (getf initargs 'filename '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :filename '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) filename getfv))
                   :context-path
                   (let* ((get1 (getf initargs 'context-path '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :context-path '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) context-path getfv))
                   :status
                   (let* ((get1 (getf initargs 'status '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :status '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) status getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :tcc-comments
                   (let* ((get1 (getf initargs 'tcc-comments '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-comments '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-comments getfv))
                   :info
                   (let* ((get1 (getf initargs 'info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) info getfv))
                   :warnings
                   (let* ((get1 (getf initargs 'warnings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :warnings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) warnings getfv))
                   :conversion-messages
                   (let* ((get1
                           (getf initargs 'conversion-messages
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :conversion-messages
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         conversion-messages
                       getfv))
                   :all-declarations
                   (let* ((get1
                           (getf initargs 'all-declarations '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-declarations
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) all-declarations getfv))
                   :all-imported-theories
                   (let* ((get1
                           (getf initargs 'all-imported-theories
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-imported-theories
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         all-imported-theories
                       getfv))
                   :all-imported-names
                   (let* ((get1
                           (getf initargs 'all-imported-names
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-imported-names
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) all-imported-names getfv))
                   :theory-mappings
                   (let* ((get1
                           (getf initargs 'theory-mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :theory-mappings
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) theory-mappings getfv))
                   :importings
                   (let* ((get1 (getf initargs 'importings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :importings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) importings getfv))
                   :constructors
                   (let* ((get1 (getf initargs 'constructors '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :constructors '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) constructors getfv))
                   :adt-type-name
                   (let* ((get1
                           (getf initargs 'adt-type-name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-type-name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-type-name getfv))
                   :positive-types
                   (let* ((get1
                           (getf initargs 'positive-types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :positive-types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) positive-types getfv))
                   :adt-theory
                   (let* ((get1 (getf initargs 'adt-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-theory '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-theory getfv))
                   :adt-map-theory
                   (let* ((get1
                           (getf initargs 'adt-map-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-map-theory '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-map-theory getfv))
                   :adt-reduce-theory
                   (let* ((get1
                           (getf initargs 'adt-reduce-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :adt-reduce-theory
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-reduce-theory getfv))
                   :generated-file-date
                   (let* ((get1
                           (getf initargs 'generated-file-date
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :generated-file-date
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         generated-file-date
                       getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv)))))

(defmethod store-object* ((obj inline-datatype))
  (with-slots (unique-id place id formals theory-formal-decls assuming
                         filename context-path status generated-by
                         tcc-comments info warnings conversion-messages
                         theory-mappings importings constructors
                         adt-type-name positive-types adt-theory
                         adt-map-theory adt-reduce-theory
                         generated-file-date semi decl-formals module
                         generated typechecked?)
    obj
    (reserve-space 29 (push-word (store-obj 'inline-datatype))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj place))
                   (push-word (store-obj id))
                   (push-word (store-obj formals))
                   (push-word (store-obj theory-formal-decls))
                   (push-word (store-obj assuming))
                   (push-word (store-obj filename))
                   (push-word (store-obj context-path))
                   (push-word (store-obj status))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj tcc-comments))
                   (push-word (store-obj info))
                   (push-word (store-obj warnings))
                   (push-word (store-obj conversion-messages))
                   (push-word (store-obj theory-mappings))
                   (push-word (store-obj importings))
                   (push-word (store-obj constructors))
                   (push-word (store-obj adt-type-name))
                   (push-word (store-obj positive-types))
                   (push-word (store-obj adt-theory))
                   (push-word (store-obj adt-map-theory))
                   (push-word (store-obj adt-reduce-theory))
                   (push-word (store-obj generated-file-date))
                   (push-word (store-obj semi))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj module))
                   (push-word (store-obj generated))
                   (push-word (store-obj typechecked?)))))

(defmethod update-fetched ((obj inline-datatype))
  (with-slots (unique-id place id formals theory-formal-decls assuming
                         filename context-path status generated-by
                         tcc-comments info warnings conversion-messages
                         theory-mappings importings constructors
                         adt-type-name positive-types adt-theory
                         adt-map-theory adt-reduce-theory
                         generated-file-date semi decl-formals module
                         generated typechecked? pvs-sxhash-value
                         formals-sans-usings all-declarations
                         all-imported-theories all-imported-names)
    obj
    (setf unique-id (fetch-obj (stored-word 1)))
    (setf place (fetch-obj (stored-word 2)))
    (setf id (fetch-obj (stored-word 3)))
    (setf formals (fetch-obj (stored-word 4)))
    (setf theory-formal-decls (fetch-obj (stored-word 5)))
    (setf assuming (fetch-obj (stored-word 6)))
    (setf filename (fetch-obj (stored-word 7)))
    (setf context-path (fetch-obj (stored-word 8)))
    (setf status (fetch-obj (stored-word 9)))
    (setf generated-by (fetch-obj (stored-word 10)))
    (setf tcc-comments (fetch-obj (stored-word 11)))
    (setf info (fetch-obj (stored-word 12)))
    (setf warnings (fetch-obj (stored-word 13)))
    (setf conversion-messages (fetch-obj (stored-word 14)))
    (setf theory-mappings (fetch-obj (stored-word 15)))
    (setf importings (fetch-obj (stored-word 16)))
    (setf constructors (fetch-obj (stored-word 17)))
    (setf adt-type-name (fetch-obj (stored-word 18)))
    (setf positive-types (fetch-obj (stored-word 19)))
    (setf adt-theory (fetch-obj (stored-word 20)))
    (setf adt-map-theory (fetch-obj (stored-word 21)))
    (setf adt-reduce-theory (fetch-obj (stored-word 22)))
    (setf generated-file-date (fetch-obj (stored-word 23)))
    (setf semi (fetch-obj (stored-word 24)))
    (setf decl-formals (fetch-obj (stored-word 25)))
    (setf module (fetch-obj (stored-word 26)))
    (setf generated (fetch-obj (stored-word 27)))
    (setf typechecked? (fetch-obj (stored-word 28)))
    (setf pvs-sxhash-value nil)
    (setf formals-sans-usings nil)
    (setf all-declarations nil)
    (setf all-imported-theories 'unbound)
    (setf all-imported-names 'unbound)))

(defmethod restore-object* ((obj inline-datatype))
  (with-slots (unique-id formals theory-formal-decls assuming
                         theory-mappings importings constructors
                         decl-formals module)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when theory-formal-decls
        (let ((*restore-object-parent-slot* 'theory-formal-decls))
          (restore-object* theory-formal-decls)))
      (when assuming
        (let ((*restore-object-parent-slot* 'assuming))
          (restore-object* assuming)))
      (when theory-mappings
        (let ((*restore-object-parent-slot* 'theory-mappings))
          (restore-object* theory-mappings)))
      (when importings
        (let ((*restore-object-parent-slot* 'importings))
          (restore-object* importings)))
      (when constructors
        (let ((*restore-object-parent-slot* 'constructors))
          (restore-object* constructors)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when module
        (let ((*restore-object-parent-slot* 'module))
          (restore-object* module)))
      obj)))

(defmethod copy ((obj datatype) &rest initargs)
  (with-slots (place id formals formals-sans-usings theory-formal-decls
                     assuming filename context-path status generated-by
                     tcc-comments info warnings conversion-messages
                     all-declarations all-imported-theories
                     all-imported-names theory-mappings importings
                     constructors adt-type-name positive-types
                     adt-theory adt-map-theory adt-reduce-theory
                     generated-file-date semi)
    obj
    (make-instance 'datatype :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :formals-sans-usings
                   (let* ((get1
                           (getf initargs 'formals-sans-usings
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :formals-sans-usings
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         formals-sans-usings
                       getfv))
                   :theory-formal-decls
                   (let* ((get1
                           (getf initargs 'theory-formal-decls
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :theory-formal-decls
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         theory-formal-decls
                       getfv))
                   :assuming
                   (let* ((get1 (getf initargs 'assuming '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :assuming '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) assuming getfv))
                   :filename
                   (let* ((get1 (getf initargs 'filename '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :filename '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) filename getfv))
                   :context-path
                   (let* ((get1 (getf initargs 'context-path '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :context-path '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) context-path getfv))
                   :status
                   (let* ((get1 (getf initargs 'status '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :status '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) status getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :tcc-comments
                   (let* ((get1 (getf initargs 'tcc-comments '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-comments '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-comments getfv))
                   :info
                   (let* ((get1 (getf initargs 'info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) info getfv))
                   :warnings
                   (let* ((get1 (getf initargs 'warnings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :warnings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) warnings getfv))
                   :conversion-messages
                   (let* ((get1
                           (getf initargs 'conversion-messages
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :conversion-messages
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         conversion-messages
                       getfv))
                   :all-declarations
                   (let* ((get1
                           (getf initargs 'all-declarations '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-declarations
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) all-declarations getfv))
                   :all-imported-theories
                   (let* ((get1
                           (getf initargs 'all-imported-theories
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-imported-theories
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         all-imported-theories
                       getfv))
                   :all-imported-names
                   (let* ((get1
                           (getf initargs 'all-imported-names
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-imported-names
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) all-imported-names getfv))
                   :theory-mappings
                   (let* ((get1
                           (getf initargs 'theory-mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :theory-mappings
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) theory-mappings getfv))
                   :importings
                   (let* ((get1 (getf initargs 'importings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :importings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) importings getfv))
                   :constructors
                   (let* ((get1 (getf initargs 'constructors '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :constructors '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) constructors getfv))
                   :adt-type-name
                   (let* ((get1
                           (getf initargs 'adt-type-name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-type-name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-type-name getfv))
                   :positive-types
                   (let* ((get1
                           (getf initargs 'positive-types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :positive-types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) positive-types getfv))
                   :adt-theory
                   (let* ((get1 (getf initargs 'adt-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-theory '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-theory getfv))
                   :adt-map-theory
                   (let* ((get1
                           (getf initargs 'adt-map-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-map-theory '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-map-theory getfv))
                   :adt-reduce-theory
                   (let* ((get1
                           (getf initargs 'adt-reduce-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :adt-reduce-theory
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-reduce-theory getfv))
                   :generated-file-date
                   (let* ((get1
                           (getf initargs 'generated-file-date
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :generated-file-date
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         generated-file-date
                       getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv)))))

(defmethod store-object* ((obj datatype))
  (with-slots (place id formals theory-formal-decls assuming filename
                     context-path status generated-by tcc-comments info
                     warnings conversion-messages theory-mappings
                     importings constructors adt-type-name
                     positive-types adt-theory adt-map-theory
                     adt-reduce-theory generated-file-date semi)
    obj
    (reserve-space 24 (push-word (store-obj 'datatype))
                   (push-word (store-obj place))
                   (push-word (store-obj id))
                   (push-word (store-obj formals))
                   (push-word (store-obj theory-formal-decls))
                   (push-word (store-obj assuming))
                   (push-word (store-obj filename))
                   (push-word (store-obj context-path))
                   (push-word (store-obj status))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj tcc-comments))
                   (push-word (store-obj info))
                   (push-word (store-obj warnings))
                   (push-word (store-obj conversion-messages))
                   (push-word (store-obj theory-mappings))
                   (push-word (store-obj importings))
                   (push-word (store-obj constructors))
                   (push-word (store-obj adt-type-name))
                   (push-word (store-obj positive-types))
                   (push-word (store-obj adt-theory))
                   (push-word (store-obj adt-map-theory))
                   (push-word (store-obj adt-reduce-theory))
                   (push-word (store-obj generated-file-date))
                   (push-word (store-obj semi)))))

(defmethod update-fetched ((obj datatype))
  (with-slots (place id formals theory-formal-decls assuming filename
                     context-path status generated-by tcc-comments info
                     warnings conversion-messages theory-mappings
                     importings constructors adt-type-name
                     positive-types adt-theory adt-map-theory
                     adt-reduce-theory generated-file-date semi
                     pvs-sxhash-value formals-sans-usings
                     all-declarations all-imported-theories
                     all-imported-names)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf id (fetch-obj (stored-word 2)))
    (setf formals (fetch-obj (stored-word 3)))
    (setf theory-formal-decls (fetch-obj (stored-word 4)))
    (setf assuming (fetch-obj (stored-word 5)))
    (setf filename (fetch-obj (stored-word 6)))
    (setf context-path (fetch-obj (stored-word 7)))
    (setf status (fetch-obj (stored-word 8)))
    (setf generated-by (fetch-obj (stored-word 9)))
    (setf tcc-comments (fetch-obj (stored-word 10)))
    (setf info (fetch-obj (stored-word 11)))
    (setf warnings (fetch-obj (stored-word 12)))
    (setf conversion-messages (fetch-obj (stored-word 13)))
    (setf theory-mappings (fetch-obj (stored-word 14)))
    (setf importings (fetch-obj (stored-word 15)))
    (setf constructors (fetch-obj (stored-word 16)))
    (setf adt-type-name (fetch-obj (stored-word 17)))
    (setf positive-types (fetch-obj (stored-word 18)))
    (setf adt-theory (fetch-obj (stored-word 19)))
    (setf adt-map-theory (fetch-obj (stored-word 20)))
    (setf adt-reduce-theory (fetch-obj (stored-word 21)))
    (setf generated-file-date (fetch-obj (stored-word 22)))
    (setf semi (fetch-obj (stored-word 23)))
    (setf pvs-sxhash-value nil)
    (setf formals-sans-usings nil)
    (setf all-declarations nil)
    (setf all-imported-theories 'unbound)
    (setf all-imported-names 'unbound)))

(defmethod restore-object* ((obj datatype))
  (with-slots (formals theory-formal-decls assuming theory-mappings
                       importings constructors)
    obj
    (let ((*restore-object-parent* obj))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when theory-formal-decls
        (let ((*restore-object-parent-slot* 'theory-formal-decls))
          (restore-object* theory-formal-decls)))
      (when assuming
        (let ((*restore-object-parent-slot* 'assuming))
          (restore-object* assuming)))
      (when theory-mappings
        (let ((*restore-object-parent-slot* 'theory-mappings))
          (restore-object* theory-mappings)))
      (when importings
        (let ((*restore-object-parent-slot* 'importings))
          (restore-object* importings)))
      (when constructors
        (let ((*restore-object-parent-slot* 'constructors))
          (restore-object* constructors)))
      obj)))

(defmethod copy ((obj inline-recursive-type) &rest initargs)
  (with-slots (unique-id place id formals formals-sans-usings
                         theory-formal-decls assuming filename
                         context-path status generated-by tcc-comments
                         info warnings conversion-messages
                         all-declarations all-imported-theories
                         all-imported-names theory-mappings importings
                         constructors adt-type-name positive-types
                         adt-theory adt-map-theory adt-reduce-theory
                         generated-file-date semi decl-formals module
                         generated typechecked?)
    obj
    (make-instance 'inline-recursive-type :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :formals-sans-usings
                   (let* ((get1
                           (getf initargs 'formals-sans-usings
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :formals-sans-usings
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         formals-sans-usings
                       getfv))
                   :theory-formal-decls
                   (let* ((get1
                           (getf initargs 'theory-formal-decls
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :theory-formal-decls
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         theory-formal-decls
                       getfv))
                   :assuming
                   (let* ((get1 (getf initargs 'assuming '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :assuming '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) assuming getfv))
                   :filename
                   (let* ((get1 (getf initargs 'filename '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :filename '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) filename getfv))
                   :context-path
                   (let* ((get1 (getf initargs 'context-path '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :context-path '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) context-path getfv))
                   :status
                   (let* ((get1 (getf initargs 'status '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :status '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) status getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :tcc-comments
                   (let* ((get1 (getf initargs 'tcc-comments '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-comments '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-comments getfv))
                   :info
                   (let* ((get1 (getf initargs 'info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) info getfv))
                   :warnings
                   (let* ((get1 (getf initargs 'warnings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :warnings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) warnings getfv))
                   :conversion-messages
                   (let* ((get1
                           (getf initargs 'conversion-messages
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :conversion-messages
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         conversion-messages
                       getfv))
                   :all-declarations
                   (let* ((get1
                           (getf initargs 'all-declarations '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-declarations
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) all-declarations getfv))
                   :all-imported-theories
                   (let* ((get1
                           (getf initargs 'all-imported-theories
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-imported-theories
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         all-imported-theories
                       getfv))
                   :all-imported-names
                   (let* ((get1
                           (getf initargs 'all-imported-names
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-imported-names
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) all-imported-names getfv))
                   :theory-mappings
                   (let* ((get1
                           (getf initargs 'theory-mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :theory-mappings
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) theory-mappings getfv))
                   :importings
                   (let* ((get1 (getf initargs 'importings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :importings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) importings getfv))
                   :constructors
                   (let* ((get1 (getf initargs 'constructors '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :constructors '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) constructors getfv))
                   :adt-type-name
                   (let* ((get1
                           (getf initargs 'adt-type-name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-type-name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-type-name getfv))
                   :positive-types
                   (let* ((get1
                           (getf initargs 'positive-types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :positive-types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) positive-types getfv))
                   :adt-theory
                   (let* ((get1 (getf initargs 'adt-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-theory '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-theory getfv))
                   :adt-map-theory
                   (let* ((get1
                           (getf initargs 'adt-map-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-map-theory '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-map-theory getfv))
                   :adt-reduce-theory
                   (let* ((get1
                           (getf initargs 'adt-reduce-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :adt-reduce-theory
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-reduce-theory getfv))
                   :generated-file-date
                   (let* ((get1
                           (getf initargs 'generated-file-date
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :generated-file-date
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         generated-file-date
                       getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv))
                   :typechecked?
                   (let* ((get1 (getf initargs 'typechecked? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :typechecked? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) typechecked? getfv)))))

(defmethod store-object* ((obj inline-recursive-type))
  (with-slots (unique-id place id formals theory-formal-decls assuming
                         filename context-path status generated-by
                         tcc-comments info warnings conversion-messages
                         theory-mappings importings constructors
                         adt-type-name positive-types adt-theory
                         adt-map-theory adt-reduce-theory
                         generated-file-date semi decl-formals module
                         generated typechecked?)
    obj
    (reserve-space 29 (push-word (store-obj 'inline-recursive-type))
                   (push-word (store-obj unique-id))
                   (push-word (store-obj place))
                   (push-word (store-obj id))
                   (push-word (store-obj formals))
                   (push-word (store-obj theory-formal-decls))
                   (push-word (store-obj assuming))
                   (push-word (store-obj filename))
                   (push-word (store-obj context-path))
                   (push-word (store-obj status))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj tcc-comments))
                   (push-word (store-obj info))
                   (push-word (store-obj warnings))
                   (push-word (store-obj conversion-messages))
                   (push-word (store-obj theory-mappings))
                   (push-word (store-obj importings))
                   (push-word (store-obj constructors))
                   (push-word (store-obj adt-type-name))
                   (push-word (store-obj positive-types))
                   (push-word (store-obj adt-theory))
                   (push-word (store-obj adt-map-theory))
                   (push-word (store-obj adt-reduce-theory))
                   (push-word (store-obj generated-file-date))
                   (push-word (store-obj semi))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj module))
                   (push-word (store-obj generated))
                   (push-word (store-obj typechecked?)))))

(defmethod update-fetched ((obj inline-recursive-type))
  (with-slots (unique-id place id formals theory-formal-decls assuming
                         filename context-path status generated-by
                         tcc-comments info warnings conversion-messages
                         theory-mappings importings constructors
                         adt-type-name positive-types adt-theory
                         adt-map-theory adt-reduce-theory
                         generated-file-date semi decl-formals module
                         generated typechecked? pvs-sxhash-value
                         formals-sans-usings all-declarations
                         all-imported-theories all-imported-names)
    obj
    (setf unique-id (fetch-obj (stored-word 1)))
    (setf place (fetch-obj (stored-word 2)))
    (setf id (fetch-obj (stored-word 3)))
    (setf formals (fetch-obj (stored-word 4)))
    (setf theory-formal-decls (fetch-obj (stored-word 5)))
    (setf assuming (fetch-obj (stored-word 6)))
    (setf filename (fetch-obj (stored-word 7)))
    (setf context-path (fetch-obj (stored-word 8)))
    (setf status (fetch-obj (stored-word 9)))
    (setf generated-by (fetch-obj (stored-word 10)))
    (setf tcc-comments (fetch-obj (stored-word 11)))
    (setf info (fetch-obj (stored-word 12)))
    (setf warnings (fetch-obj (stored-word 13)))
    (setf conversion-messages (fetch-obj (stored-word 14)))
    (setf theory-mappings (fetch-obj (stored-word 15)))
    (setf importings (fetch-obj (stored-word 16)))
    (setf constructors (fetch-obj (stored-word 17)))
    (setf adt-type-name (fetch-obj (stored-word 18)))
    (setf positive-types (fetch-obj (stored-word 19)))
    (setf adt-theory (fetch-obj (stored-word 20)))
    (setf adt-map-theory (fetch-obj (stored-word 21)))
    (setf adt-reduce-theory (fetch-obj (stored-word 22)))
    (setf generated-file-date (fetch-obj (stored-word 23)))
    (setf semi (fetch-obj (stored-word 24)))
    (setf decl-formals (fetch-obj (stored-word 25)))
    (setf module (fetch-obj (stored-word 26)))
    (setf generated (fetch-obj (stored-word 27)))
    (setf typechecked? (fetch-obj (stored-word 28)))
    (setf pvs-sxhash-value nil)
    (setf formals-sans-usings nil)
    (setf all-declarations nil)
    (setf all-imported-theories 'unbound)
    (setf all-imported-names 'unbound)))

(defmethod restore-object* ((obj inline-recursive-type))
  (with-slots (unique-id formals theory-formal-decls assuming
                         theory-mappings importings constructors
                         decl-formals module)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when theory-formal-decls
        (let ((*restore-object-parent-slot* 'theory-formal-decls))
          (restore-object* theory-formal-decls)))
      (when assuming
        (let ((*restore-object-parent-slot* 'assuming))
          (restore-object* assuming)))
      (when theory-mappings
        (let ((*restore-object-parent-slot* 'theory-mappings))
          (restore-object* theory-mappings)))
      (when importings
        (let ((*restore-object-parent-slot* 'importings))
          (restore-object* importings)))
      (when constructors
        (let ((*restore-object-parent-slot* 'constructors))
          (restore-object* constructors)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when module
        (let ((*restore-object-parent-slot* 'module))
          (restore-object* module)))
      obj)))

(defmethod copy ((obj recursive-type-with-subtypes) &rest initargs)
  (with-slots (place id formals formals-sans-usings theory-formal-decls
                     assuming filename context-path status generated-by
                     tcc-comments info warnings conversion-messages
                     all-declarations all-imported-theories
                     all-imported-names theory-mappings importings
                     constructors adt-type-name positive-types
                     adt-theory adt-map-theory adt-reduce-theory
                     generated-file-date semi subtypes)
    obj
    (make-instance 'recursive-type-with-subtypes :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :formals-sans-usings
                   (let* ((get1
                           (getf initargs 'formals-sans-usings
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :formals-sans-usings
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         formals-sans-usings
                       getfv))
                   :theory-formal-decls
                   (let* ((get1
                           (getf initargs 'theory-formal-decls
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :theory-formal-decls
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         theory-formal-decls
                       getfv))
                   :assuming
                   (let* ((get1 (getf initargs 'assuming '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :assuming '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) assuming getfv))
                   :filename
                   (let* ((get1 (getf initargs 'filename '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :filename '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) filename getfv))
                   :context-path
                   (let* ((get1 (getf initargs 'context-path '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :context-path '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) context-path getfv))
                   :status
                   (let* ((get1 (getf initargs 'status '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :status '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) status getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :tcc-comments
                   (let* ((get1 (getf initargs 'tcc-comments '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-comments '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-comments getfv))
                   :info
                   (let* ((get1 (getf initargs 'info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) info getfv))
                   :warnings
                   (let* ((get1 (getf initargs 'warnings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :warnings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) warnings getfv))
                   :conversion-messages
                   (let* ((get1
                           (getf initargs 'conversion-messages
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :conversion-messages
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         conversion-messages
                       getfv))
                   :all-declarations
                   (let* ((get1
                           (getf initargs 'all-declarations '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-declarations
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) all-declarations getfv))
                   :all-imported-theories
                   (let* ((get1
                           (getf initargs 'all-imported-theories
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-imported-theories
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         all-imported-theories
                       getfv))
                   :all-imported-names
                   (let* ((get1
                           (getf initargs 'all-imported-names
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-imported-names
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) all-imported-names getfv))
                   :theory-mappings
                   (let* ((get1
                           (getf initargs 'theory-mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :theory-mappings
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) theory-mappings getfv))
                   :importings
                   (let* ((get1 (getf initargs 'importings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :importings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) importings getfv))
                   :constructors
                   (let* ((get1 (getf initargs 'constructors '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :constructors '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) constructors getfv))
                   :adt-type-name
                   (let* ((get1
                           (getf initargs 'adt-type-name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-type-name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-type-name getfv))
                   :positive-types
                   (let* ((get1
                           (getf initargs 'positive-types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :positive-types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) positive-types getfv))
                   :adt-theory
                   (let* ((get1 (getf initargs 'adt-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-theory '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-theory getfv))
                   :adt-map-theory
                   (let* ((get1
                           (getf initargs 'adt-map-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-map-theory '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-map-theory getfv))
                   :adt-reduce-theory
                   (let* ((get1
                           (getf initargs 'adt-reduce-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :adt-reduce-theory
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-reduce-theory getfv))
                   :generated-file-date
                   (let* ((get1
                           (getf initargs 'generated-file-date
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :generated-file-date
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         generated-file-date
                       getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv))
                   :subtypes
                   (let* ((get1 (getf initargs 'subtypes '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :subtypes '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) subtypes getfv)))))

(defmethod store-object* ((obj recursive-type-with-subtypes))
  (with-slots (place id formals theory-formal-decls assuming filename
                     context-path status generated-by tcc-comments info
                     warnings conversion-messages theory-mappings
                     importings constructors adt-type-name
                     positive-types adt-theory adt-map-theory
                     adt-reduce-theory generated-file-date semi
                     subtypes)
    obj
    (reserve-space 25
                   (push-word (store-obj 'recursive-type-with-subtypes))
                   (push-word (store-obj place))
                   (push-word (store-obj id))
                   (push-word (store-obj formals))
                   (push-word (store-obj theory-formal-decls))
                   (push-word (store-obj assuming))
                   (push-word (store-obj filename))
                   (push-word (store-obj context-path))
                   (push-word (store-obj status))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj tcc-comments))
                   (push-word (store-obj info))
                   (push-word (store-obj warnings))
                   (push-word (store-obj conversion-messages))
                   (push-word (store-obj theory-mappings))
                   (push-word (store-obj importings))
                   (push-word (store-obj constructors))
                   (push-word (store-obj adt-type-name))
                   (push-word (store-obj positive-types))
                   (push-word (store-obj adt-theory))
                   (push-word (store-obj adt-map-theory))
                   (push-word (store-obj adt-reduce-theory))
                   (push-word (store-obj generated-file-date))
                   (push-word (store-obj semi))
                   (push-word (store-obj subtypes)))))

(defmethod update-fetched ((obj recursive-type-with-subtypes))
  (with-slots (place id formals theory-formal-decls assuming filename
                     context-path status generated-by tcc-comments info
                     warnings conversion-messages theory-mappings
                     importings constructors adt-type-name
                     positive-types adt-theory adt-map-theory
                     adt-reduce-theory generated-file-date semi
                     subtypes pvs-sxhash-value formals-sans-usings
                     all-declarations all-imported-theories
                     all-imported-names)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf id (fetch-obj (stored-word 2)))
    (setf formals (fetch-obj (stored-word 3)))
    (setf theory-formal-decls (fetch-obj (stored-word 4)))
    (setf assuming (fetch-obj (stored-word 5)))
    (setf filename (fetch-obj (stored-word 6)))
    (setf context-path (fetch-obj (stored-word 7)))
    (setf status (fetch-obj (stored-word 8)))
    (setf generated-by (fetch-obj (stored-word 9)))
    (setf tcc-comments (fetch-obj (stored-word 10)))
    (setf info (fetch-obj (stored-word 11)))
    (setf warnings (fetch-obj (stored-word 12)))
    (setf conversion-messages (fetch-obj (stored-word 13)))
    (setf theory-mappings (fetch-obj (stored-word 14)))
    (setf importings (fetch-obj (stored-word 15)))
    (setf constructors (fetch-obj (stored-word 16)))
    (setf adt-type-name (fetch-obj (stored-word 17)))
    (setf positive-types (fetch-obj (stored-word 18)))
    (setf adt-theory (fetch-obj (stored-word 19)))
    (setf adt-map-theory (fetch-obj (stored-word 20)))
    (setf adt-reduce-theory (fetch-obj (stored-word 21)))
    (setf generated-file-date (fetch-obj (stored-word 22)))
    (setf semi (fetch-obj (stored-word 23)))
    (setf subtypes (fetch-obj (stored-word 24)))
    (setf pvs-sxhash-value nil)
    (setf formals-sans-usings nil)
    (setf all-declarations nil)
    (setf all-imported-theories 'unbound)
    (setf all-imported-names 'unbound)))

(defmethod restore-object* ((obj recursive-type-with-subtypes))
  (with-slots (formals theory-formal-decls assuming theory-mappings
                       importings constructors subtypes)
    obj
    (let ((*restore-object-parent* obj))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when theory-formal-decls
        (let ((*restore-object-parent-slot* 'theory-formal-decls))
          (restore-object* theory-formal-decls)))
      (when assuming
        (let ((*restore-object-parent-slot* 'assuming))
          (restore-object* assuming)))
      (when theory-mappings
        (let ((*restore-object-parent-slot* 'theory-mappings))
          (restore-object* theory-mappings)))
      (when importings
        (let ((*restore-object-parent-slot* 'importings))
          (restore-object* importings)))
      (when constructors
        (let ((*restore-object-parent-slot* 'constructors))
          (restore-object* constructors)))
      (when subtypes
        (let ((*restore-object-parent-slot* 'subtypes))
          (restore-object* subtypes)))
      obj)))

(defmethod copy ((obj recursive-type) &rest initargs)
  (with-slots (place id formals formals-sans-usings theory-formal-decls
                     assuming filename context-path status generated-by
                     tcc-comments info warnings conversion-messages
                     all-declarations all-imported-theories
                     all-imported-names theory-mappings importings
                     constructors adt-type-name positive-types
                     adt-theory adt-map-theory adt-reduce-theory
                     generated-file-date semi)
    obj
    (make-instance 'recursive-type :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :formals-sans-usings
                   (let* ((get1
                           (getf initargs 'formals-sans-usings
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :formals-sans-usings
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         formals-sans-usings
                       getfv))
                   :theory-formal-decls
                   (let* ((get1
                           (getf initargs 'theory-formal-decls
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :theory-formal-decls
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         theory-formal-decls
                       getfv))
                   :assuming
                   (let* ((get1 (getf initargs 'assuming '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :assuming '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) assuming getfv))
                   :filename
                   (let* ((get1 (getf initargs 'filename '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :filename '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) filename getfv))
                   :context-path
                   (let* ((get1 (getf initargs 'context-path '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :context-path '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) context-path getfv))
                   :status
                   (let* ((get1 (getf initargs 'status '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :status '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) status getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :tcc-comments
                   (let* ((get1 (getf initargs 'tcc-comments '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-comments '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-comments getfv))
                   :info
                   (let* ((get1 (getf initargs 'info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) info getfv))
                   :warnings
                   (let* ((get1 (getf initargs 'warnings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :warnings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) warnings getfv))
                   :conversion-messages
                   (let* ((get1
                           (getf initargs 'conversion-messages
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :conversion-messages
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         conversion-messages
                       getfv))
                   :all-declarations
                   (let* ((get1
                           (getf initargs 'all-declarations '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-declarations
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) all-declarations getfv))
                   :all-imported-theories
                   (let* ((get1
                           (getf initargs 'all-imported-theories
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-imported-theories
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         all-imported-theories
                       getfv))
                   :all-imported-names
                   (let* ((get1
                           (getf initargs 'all-imported-names
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-imported-names
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) all-imported-names getfv))
                   :theory-mappings
                   (let* ((get1
                           (getf initargs 'theory-mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :theory-mappings
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) theory-mappings getfv))
                   :importings
                   (let* ((get1 (getf initargs 'importings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :importings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) importings getfv))
                   :constructors
                   (let* ((get1 (getf initargs 'constructors '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :constructors '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) constructors getfv))
                   :adt-type-name
                   (let* ((get1
                           (getf initargs 'adt-type-name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-type-name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-type-name getfv))
                   :positive-types
                   (let* ((get1
                           (getf initargs 'positive-types '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :positive-types '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) positive-types getfv))
                   :adt-theory
                   (let* ((get1 (getf initargs 'adt-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-theory '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-theory getfv))
                   :adt-map-theory
                   (let* ((get1
                           (getf initargs 'adt-map-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-map-theory '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-map-theory getfv))
                   :adt-reduce-theory
                   (let* ((get1
                           (getf initargs 'adt-reduce-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :adt-reduce-theory
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-reduce-theory getfv))
                   :generated-file-date
                   (let* ((get1
                           (getf initargs 'generated-file-date
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :generated-file-date
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         generated-file-date
                       getfv))
                   :semi
                   (let* ((get1 (getf initargs 'semi '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :semi '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) semi getfv)))))

(defmethod store-object* ((obj recursive-type))
  (with-slots (place id formals theory-formal-decls assuming filename
                     context-path status generated-by tcc-comments info
                     warnings conversion-messages theory-mappings
                     importings constructors adt-type-name
                     positive-types adt-theory adt-map-theory
                     adt-reduce-theory generated-file-date semi)
    obj
    (reserve-space 24 (push-word (store-obj 'recursive-type))
                   (push-word (store-obj place))
                   (push-word (store-obj id))
                   (push-word (store-obj formals))
                   (push-word (store-obj theory-formal-decls))
                   (push-word (store-obj assuming))
                   (push-word (store-obj filename))
                   (push-word (store-obj context-path))
                   (push-word (store-obj status))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj tcc-comments))
                   (push-word (store-obj info))
                   (push-word (store-obj warnings))
                   (push-word (store-obj conversion-messages))
                   (push-word (store-obj theory-mappings))
                   (push-word (store-obj importings))
                   (push-word (store-obj constructors))
                   (push-word (store-obj adt-type-name))
                   (push-word (store-obj positive-types))
                   (push-word (store-obj adt-theory))
                   (push-word (store-obj adt-map-theory))
                   (push-word (store-obj adt-reduce-theory))
                   (push-word (store-obj generated-file-date))
                   (push-word (store-obj semi)))))

(defmethod update-fetched ((obj recursive-type))
  (with-slots (place id formals theory-formal-decls assuming filename
                     context-path status generated-by tcc-comments info
                     warnings conversion-messages theory-mappings
                     importings constructors adt-type-name
                     positive-types adt-theory adt-map-theory
                     adt-reduce-theory generated-file-date semi
                     pvs-sxhash-value formals-sans-usings
                     all-declarations all-imported-theories
                     all-imported-names)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf id (fetch-obj (stored-word 2)))
    (setf formals (fetch-obj (stored-word 3)))
    (setf theory-formal-decls (fetch-obj (stored-word 4)))
    (setf assuming (fetch-obj (stored-word 5)))
    (setf filename (fetch-obj (stored-word 6)))
    (setf context-path (fetch-obj (stored-word 7)))
    (setf status (fetch-obj (stored-word 8)))
    (setf generated-by (fetch-obj (stored-word 9)))
    (setf tcc-comments (fetch-obj (stored-word 10)))
    (setf info (fetch-obj (stored-word 11)))
    (setf warnings (fetch-obj (stored-word 12)))
    (setf conversion-messages (fetch-obj (stored-word 13)))
    (setf theory-mappings (fetch-obj (stored-word 14)))
    (setf importings (fetch-obj (stored-word 15)))
    (setf constructors (fetch-obj (stored-word 16)))
    (setf adt-type-name (fetch-obj (stored-word 17)))
    (setf positive-types (fetch-obj (stored-word 18)))
    (setf adt-theory (fetch-obj (stored-word 19)))
    (setf adt-map-theory (fetch-obj (stored-word 20)))
    (setf adt-reduce-theory (fetch-obj (stored-word 21)))
    (setf generated-file-date (fetch-obj (stored-word 22)))
    (setf semi (fetch-obj (stored-word 23)))
    (setf pvs-sxhash-value nil)
    (setf formals-sans-usings nil)
    (setf all-declarations nil)
    (setf all-imported-theories 'unbound)
    (setf all-imported-names 'unbound)))

(defmethod restore-object* ((obj recursive-type))
  (with-slots (formals theory-formal-decls assuming theory-mappings
                       importings constructors)
    obj
    (let ((*restore-object-parent* obj))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when theory-formal-decls
        (let ((*restore-object-parent-slot* 'theory-formal-decls))
          (restore-object* theory-formal-decls)))
      (when assuming
        (let ((*restore-object-parent-slot* 'assuming))
          (restore-object* assuming)))
      (when theory-mappings
        (let ((*restore-object-parent-slot* 'theory-mappings))
          (restore-object* theory-mappings)))
      (when importings
        (let ((*restore-object-parent-slot* 'importings))
          (restore-object* importings)))
      (when constructors
        (let ((*restore-object-parent-slot* 'constructors))
          (restore-object* constructors)))
      obj)))

(defmethod copy ((obj theory-element) &rest initargs)
  (with-slots (place unique-id)
    obj
    (make-instance 'theory-element :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unique-id
                   (let* ((get1 (getf initargs 'unique-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unique-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) unique-id getfv)))))

(defmethod store-object* ((obj theory-element))
  (with-slots (place unique-id)
    obj
    (reserve-space 3 (push-word (store-obj 'theory-element))
                   (push-word (store-obj place))
                   (push-word (store-obj unique-id)))))

(defmethod update-fetched ((obj theory-element))
  (with-slots (place unique-id pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf unique-id (fetch-obj (stored-word 2)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj theory-element))
  (with-slots (unique-id)
    obj
    (let ((*restore-object-parent* obj))
      (when unique-id
        (let ((*restore-object-parent-slot* 'unique-id))
          (restore-object* unique-id)))
      obj)))

(defmethod copy ((obj datatype-or-module) &rest initargs)
  (with-slots (place id formals formals-sans-usings theory-formal-decls
                     assuming filename context-path status generated-by
                     tcc-comments info warnings conversion-messages
                     all-declarations all-imported-theories
                     all-imported-names theory-mappings)
    obj
    (make-instance 'datatype-or-module :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv))
                   :formals-sans-usings
                   (let* ((get1
                           (getf initargs 'formals-sans-usings
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :formals-sans-usings
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         formals-sans-usings
                       getfv))
                   :theory-formal-decls
                   (let* ((get1
                           (getf initargs 'theory-formal-decls
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :theory-formal-decls
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         theory-formal-decls
                       getfv))
                   :assuming
                   (let* ((get1 (getf initargs 'assuming '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :assuming '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) assuming getfv))
                   :filename
                   (let* ((get1 (getf initargs 'filename '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :filename '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) filename getfv))
                   :context-path
                   (let* ((get1 (getf initargs 'context-path '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :context-path '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) context-path getfv))
                   :status
                   (let* ((get1 (getf initargs 'status '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :status '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) status getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :tcc-comments
                   (let* ((get1 (getf initargs 'tcc-comments '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :tcc-comments '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) tcc-comments getfv))
                   :info
                   (let* ((get1 (getf initargs 'info '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :info '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) info getfv))
                   :warnings
                   (let* ((get1 (getf initargs 'warnings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :warnings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) warnings getfv))
                   :conversion-messages
                   (let* ((get1
                           (getf initargs 'conversion-messages
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :conversion-messages
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         conversion-messages
                       getfv))
                   :all-declarations
                   (let* ((get1
                           (getf initargs 'all-declarations '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-declarations
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) all-declarations getfv))
                   :all-imported-theories
                   (let* ((get1
                           (getf initargs 'all-imported-theories
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-imported-theories
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         all-imported-theories
                       getfv))
                   :all-imported-names
                   (let* ((get1
                           (getf initargs 'all-imported-names
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :all-imported-names
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) all-imported-names getfv))
                   :theory-mappings
                   (let* ((get1
                           (getf initargs 'theory-mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :theory-mappings
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) theory-mappings getfv)))))

(defmethod store-object* ((obj datatype-or-module))
  (with-slots (place id formals theory-formal-decls assuming filename
                     context-path status generated-by tcc-comments info
                     warnings conversion-messages theory-mappings)
    obj
    (reserve-space 15 (push-word (store-obj 'datatype-or-module))
                   (push-word (store-obj place))
                   (push-word (store-obj id))
                   (push-word (store-obj formals))
                   (push-word (store-obj theory-formal-decls))
                   (push-word (store-obj assuming))
                   (push-word (store-obj filename))
                   (push-word (store-obj context-path))
                   (push-word (store-obj status))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj tcc-comments))
                   (push-word (store-obj info))
                   (push-word (store-obj warnings))
                   (push-word (store-obj conversion-messages))
                   (push-word (store-obj theory-mappings)))))

(defmethod update-fetched ((obj datatype-or-module))
  (with-slots (place id formals theory-formal-decls assuming filename
                     context-path status generated-by tcc-comments info
                     warnings conversion-messages theory-mappings
                     pvs-sxhash-value formals-sans-usings
                     all-declarations all-imported-theories
                     all-imported-names)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf id (fetch-obj (stored-word 2)))
    (setf formals (fetch-obj (stored-word 3)))
    (setf theory-formal-decls (fetch-obj (stored-word 4)))
    (setf assuming (fetch-obj (stored-word 5)))
    (setf filename (fetch-obj (stored-word 6)))
    (setf context-path (fetch-obj (stored-word 7)))
    (setf status (fetch-obj (stored-word 8)))
    (setf generated-by (fetch-obj (stored-word 9)))
    (setf tcc-comments (fetch-obj (stored-word 10)))
    (setf info (fetch-obj (stored-word 11)))
    (setf warnings (fetch-obj (stored-word 12)))
    (setf conversion-messages (fetch-obj (stored-word 13)))
    (setf theory-mappings (fetch-obj (stored-word 14)))
    (setf pvs-sxhash-value nil)
    (setf formals-sans-usings nil)
    (setf all-declarations nil)
    (setf all-imported-theories 'unbound)
    (setf all-imported-names 'unbound)))

(defmethod restore-object* ((obj datatype-or-module))
  (with-slots (formals theory-formal-decls assuming theory-mappings)
    obj
    (let ((*restore-object-parent* obj))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      (when theory-formal-decls
        (let ((*restore-object-parent-slot* 'theory-formal-decls))
          (restore-object* theory-formal-decls)))
      (when assuming
        (let ((*restore-object-parent-slot* 'assuming))
          (restore-object* assuming)))
      (when theory-mappings
        (let ((*restore-object-parent-slot* 'theory-mappings))
          (restore-object* theory-mappings)))
      obj)))

(defmethod copy ((obj modules) &rest initargs)
  (with-slots (modules)
    obj
    (make-instance 'modules :modules
                   (let* ((get1 (getf initargs 'modules '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :modules '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) modules getfv)))))

(defmethod store-object* ((obj modules))
  (with-slots (modules)
    obj
    (reserve-space 2 (push-word (store-obj 'modules))
                   (push-word (store-obj modules)))))

(defmethod update-fetched ((obj modules))
  (with-slots (modules) obj (setf modules (fetch-obj (stored-word 1)))))

(defmethod restore-object* ((obj modules))
  (with-slots (modules)
    obj
    (let ((*restore-object-parent* obj))
      (when modules
        (let ((*restore-object-parent-slot* 'modules))
          (restore-object* modules)))
      obj)))

(defmethod copy ((obj application-judgements) &rest initargs)
  (with-slots (generic-judgements judgements-graph)
    obj
    (make-instance 'application-judgements :generic-judgements
                   (let* ((get1
                           (getf initargs 'generic-judgements
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :generic-judgements
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generic-judgements getfv))
                   :judgements-graph
                   (let* ((get1
                           (getf initargs 'judgements-graph '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :judgements-graph
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) judgements-graph getfv)))))

(defmethod store-object* ((obj application-judgements))
  (with-slots (generic-judgements judgements-graph)
    obj
    (reserve-space 3 (push-word (store-obj 'application-judgements))
                   (push-word (store-obj generic-judgements))
                   (push-word (store-obj judgements-graph)))))

(defmethod update-fetched ((obj application-judgements))
  (with-slots (generic-judgements judgements-graph)
    obj
    (setf generic-judgements (fetch-obj (stored-word 1)))
    (setf judgements-graph (fetch-obj (stored-word 2)))))

(defmethod restore-object* ((obj application-judgements))
  (with-slots (generic-judgements judgements-graph)
    obj
    (let ((*restore-object-parent* obj))
      (when generic-judgements
        (let ((*restore-object-parent-slot* 'generic-judgements))
          (restore-object* generic-judgements)))
      (when judgements-graph
        (let ((*restore-object-parent-slot* 'judgements-graph))
          (restore-object* judgements-graph)))
      obj)))

(defmethod copy ((obj name-judgements) &rest initargs)
  (with-slots (minimal-judgements generic-judgements)
    obj
    (make-instance 'name-judgements :minimal-judgements
                   (let* ((get1
                           (getf initargs 'minimal-judgements
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :minimal-judgements
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) minimal-judgements getfv))
                   :generic-judgements
                   (let* ((get1
                           (getf initargs 'generic-judgements
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :generic-judgements
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         generic-judgements
                       getfv)))))

(defmethod store-object* ((obj name-judgements))
  (with-slots (minimal-judgements generic-judgements)
    obj
    (reserve-space 3 (push-word (store-obj 'name-judgements))
                   (push-word (store-obj minimal-judgements))
                   (push-word (store-obj generic-judgements)))))

(defmethod update-fetched ((obj name-judgements))
  (with-slots (minimal-judgements generic-judgements)
    obj
    (setf minimal-judgements (fetch-obj (stored-word 1)))
    (setf generic-judgements (fetch-obj (stored-word 2)))))

(defmethod restore-object* ((obj name-judgements))
  (with-slots (minimal-judgements generic-judgements)
    obj
    (let ((*restore-object-parent* obj))
      (when minimal-judgements
        (let ((*restore-object-parent-slot* 'minimal-judgements))
          (restore-object* minimal-judgements)))
      (when generic-judgements
        (let ((*restore-object-parent-slot* 'generic-judgements))
          (restore-object* generic-judgements)))
      obj)))

(defmethod copy ((obj judgements) &rest initargs)
  (with-slots (judgement-types-hash judgement-declarations
                                    number-judgements-alist
                                    name-judgements-alist
                                    application-judgements-alist
                                    expr-judgements-alist)
    obj
    (make-instance 'judgements :judgement-types-hash
                   (let* ((get1
                           (getf initargs 'judgement-types-hash
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :judgement-types-hash
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         judgement-types-hash
                       getfv))
                   :judgement-declarations
                   (let* ((get1
                           (getf initargs 'judgement-declarations
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :judgement-declarations
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         judgement-declarations
                       getfv))
                   :number-judgements-alist
                   (let* ((get1
                           (getf initargs 'number-judgements-alist
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :number-judgements-alist
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         number-judgements-alist
                       getfv))
                   :name-judgements-alist
                   (let* ((get1
                           (getf initargs 'name-judgements-alist
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :name-judgements-alist
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         name-judgements-alist
                       getfv))
                   :application-judgements-alist
                   (let* ((get1
                           (getf initargs 'application-judgements-alist
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :application-judgements-alist
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         application-judgements-alist
                       getfv))
                   :expr-judgements-alist
                   (let* ((get1
                           (getf initargs 'expr-judgements-alist
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :expr-judgements-alist
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         expr-judgements-alist
                       getfv)))))

(defmethod store-object* ((obj judgements))
  (with-slots (judgement-declarations number-judgements-alist
                name-judgements-alist application-judgements-alist
                expr-judgements-alist)
    obj
    (reserve-space 6 (push-word (store-obj 'judgements))
                   (push-word (store-obj judgement-declarations))
                   (push-word (store-obj number-judgements-alist))
                   (push-word (store-obj name-judgements-alist))
                   (push-word (store-obj application-judgements-alist))
                   (push-word (store-obj expr-judgements-alist)))))

(defmethod update-fetched ((obj judgements))
  (with-slots (judgement-declarations number-judgements-alist
                name-judgements-alist application-judgements-alist
                expr-judgements-alist judgement-types-hash)
    obj
    (setf judgement-declarations (fetch-obj (stored-word 1)))
    (setf number-judgements-alist (fetch-obj (stored-word 2)))
    (setf name-judgements-alist (fetch-obj (stored-word 3)))
    (setf application-judgements-alist (fetch-obj (stored-word 4)))
    (setf expr-judgements-alist (fetch-obj (stored-word 5)))
    (setf judgement-types-hash nil)))

(defmethod restore-object* ((obj judgements))
  (with-slots (judgement-declarations number-judgements-alist
                name-judgements-alist application-judgements-alist
                expr-judgements-alist)
    obj
    (let ((*restore-object-parent* obj))
      (when judgement-declarations
        (let ((*restore-object-parent-slot* 'judgement-declarations))
          (restore-object* judgement-declarations)))
      (when number-judgements-alist
        (let ((*restore-object-parent-slot* 'number-judgements-alist))
          (restore-object* number-judgements-alist)))
      (when name-judgements-alist
        (let ((*restore-object-parent-slot* 'name-judgements-alist))
          (restore-object* name-judgements-alist)))
      (when application-judgements-alist
        (let ((*restore-object-parent-slot*
               'application-judgements-alist))
          (restore-object* application-judgements-alist)))
      (when expr-judgements-alist
        (let ((*restore-object-parent-slot* 'expr-judgements-alist))
          (restore-object* expr-judgements-alist)))
      obj)))

(defmethod copy ((obj context) &rest initargs)
  (with-slots (theory theory-name declaration declarations-hash
                      using-hash judgements known-subtypes conversions
                      disabled-conversions auto-rewrites
                      disabled-auto-rewrites)
    obj
    (make-instance 'context :theory
                   (let* ((get1 (getf initargs 'theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :theory '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) theory getfv))
                   :theory-name
                   (let* ((get1 (getf initargs 'theory-name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :theory-name '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) theory-name getfv))
                   :declaration
                   (let* ((get1 (getf initargs 'declaration '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declaration '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declaration getfv))
                   :declarations-hash
                   (let* ((get1
                           (getf initargs 'declarations-hash '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declarations-hash
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declarations-hash getfv))
                   :using-hash
                   (let* ((get1 (getf initargs 'using-hash '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :using-hash '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) using-hash getfv))
                   :judgements
                   (let* ((get1 (getf initargs 'judgements '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :judgements '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) judgements getfv))
                   :known-subtypes
                   (let* ((get1
                           (getf initargs 'known-subtypes '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :known-subtypes '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) known-subtypes getfv))
                   :conversions
                   (let* ((get1 (getf initargs 'conversions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :conversions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) conversions getfv))
                   :disabled-conversions
                   (let* ((get1
                           (getf initargs 'disabled-conversions
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :disabled-conversions
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         disabled-conversions
                       getfv))
                   :auto-rewrites
                   (let* ((get1
                           (getf initargs 'auto-rewrites '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :auto-rewrites '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) auto-rewrites getfv))
                   :disabled-auto-rewrites
                   (let* ((get1
                           (getf initargs 'disabled-auto-rewrites
                                 '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :disabled-auto-rewrites
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         disabled-auto-rewrites
                       getfv)))))

(defmethod store-object* ((obj context))
  (with-slots (theory theory-name declaration declarations-hash
                      using-hash judgements known-subtypes conversions
                      disabled-conversions auto-rewrites
                      disabled-auto-rewrites)
    obj
    (reserve-space 12 (push-word (store-obj 'context))
                   (push-word (store-obj theory))
                   (push-word (store-obj theory-name))
                   (push-word (store-obj declaration))
                   (push-word (store-obj declarations-hash))
                   (push-word (store-obj using-hash))
                   (push-word (store-obj judgements))
                   (push-word (store-obj known-subtypes))
                   (push-word (store-obj conversions))
                   (push-word (store-obj disabled-conversions))
                   (push-word (store-obj auto-rewrites))
                   (push-word (store-obj disabled-auto-rewrites)))))

(defmethod update-fetched ((obj context))
  (with-slots (theory theory-name declaration declarations-hash
                      using-hash judgements known-subtypes conversions
                      disabled-conversions auto-rewrites
                      disabled-auto-rewrites)
    obj
    (setf theory (fetch-obj (stored-word 1)))
    (setf theory-name (fetch-obj (stored-word 2)))
    (setf declaration (fetch-obj (stored-word 3)))
    (setf declarations-hash (fetch-obj (stored-word 4)))
    (setf using-hash (fetch-obj (stored-word 5)))
    (setf judgements (fetch-obj (stored-word 6)))
    (setf known-subtypes (fetch-obj (stored-word 7)))
    (setf conversions (fetch-obj (stored-word 8)))
    (setf disabled-conversions (fetch-obj (stored-word 9)))
    (setf auto-rewrites (fetch-obj (stored-word 10)))
    (setf disabled-auto-rewrites (fetch-obj (stored-word 11)))))

(defmethod restore-object* ((obj context))
  (with-slots (auto-rewrites disabled-auto-rewrites)
    obj
    (let ((*restore-object-parent* obj))
      (when auto-rewrites
        (let ((*restore-object-parent-slot* 'auto-rewrites))
          (restore-object* auto-rewrites)))
      (when disabled-auto-rewrites
        (let ((*restore-object-parent-slot* 'disabled-auto-rewrites))
          (restore-object* disabled-auto-rewrites)))
      obj)))

(defmethod copy ((obj mapping-resolution) &rest initargs)
  (with-slots (declaration module-instance type)
    obj
    (make-instance 'mapping-resolution :declaration
                   (let* ((get1 (getf initargs 'declaration '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declaration '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declaration getfv))
                   :module-instance
                   (let* ((get1
                           (getf initargs 'module-instance '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :module-instance
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module-instance getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv)))))

(defmethod store-object* ((obj mapping-resolution))
  (with-slots (declaration module-instance type)
    obj
    (reserve-space 4 (push-word (store-obj 'mapping-resolution))
                   (push-word (store-obj declaration))
                   (push-word (store-obj module-instance))
                   (push-word (store-obj type)))))

(defmethod update-fetched ((obj mapping-resolution))
  (with-slots (declaration module-instance type)
    obj
    (setf declaration (fetch-obj (stored-word 1)))
    (setf module-instance (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))))

(defmethod restore-object* ((obj mapping-resolution))
  (with-slots (module-instance type)
    obj
    (let ((*restore-object-parent* obj))
      (when module-instance
        (let ((*restore-object-parent-slot* 'module-instance))
          (restore-object* module-instance)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      obj)))

(defmethod copy ((obj recursive-function-resolution) &rest initargs)
  (with-slots (declaration module-instance type conversion)
    obj
    (make-instance 'recursive-function-resolution :declaration
                   (let* ((get1 (getf initargs 'declaration '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declaration '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declaration getfv))
                   :module-instance
                   (let* ((get1
                           (getf initargs 'module-instance '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :module-instance
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module-instance getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :conversion
                   (let* ((get1 (getf initargs 'conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :conversion '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) conversion getfv)))))

(defmethod store-object* ((obj recursive-function-resolution))
  (with-slots (declaration module-instance type conversion)
    obj
    (reserve-space 5
                   (push-word (store-obj 'recursive-function-resolution))
                   (push-word (store-obj declaration))
                   (push-word (store-obj module-instance))
                   (push-word (store-obj type))
                   (push-word (store-obj conversion)))))

(defmethod update-fetched ((obj recursive-function-resolution))
  (with-slots (declaration module-instance type conversion)
    obj
    (setf declaration (fetch-obj (stored-word 1)))
    (setf module-instance (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf conversion (fetch-obj (stored-word 4)))))

(defmethod restore-object* ((obj recursive-function-resolution))
  (with-slots (module-instance type conversion)
    obj
    (let ((*restore-object-parent* obj))
      (when module-instance
        (let ((*restore-object-parent-slot* 'module-instance))
          (restore-object* module-instance)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when conversion
        (let ((*restore-object-parent-slot* 'conversion))
          (restore-object* conversion)))
      obj)))

(defmethod copy ((obj conversion-result) &rest initargs)
  (with-slots (conversion expr)
    obj
    (make-instance 'conversion-result :conversion
                   (let* ((get1 (getf initargs 'conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :conversion '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) conversion getfv))
                   :expr
                   (let* ((get1 (getf initargs 'expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expr getfv)))))

(defmethod store-object* ((obj conversion-result))
  (with-slots (conversion expr)
    obj
    (reserve-space 3 (push-word (store-obj 'conversion-result))
                   (push-word (store-obj conversion))
                   (push-word (store-obj expr)))))

(defmethod update-fetched ((obj conversion-result))
  (with-slots (conversion expr)
    obj
    (setf conversion (fetch-obj (stored-word 1)))
    (setf expr (fetch-obj (stored-word 2)))))

(defmethod restore-object* ((obj conversion-result))
  (with-slots (conversion expr)
    obj
    (let ((*restore-object-parent* obj))
      (when conversion
        (let ((*restore-object-parent-slot* 'conversion))
          (restore-object* conversion)))
      (when expr
        (let ((*restore-object-parent-slot* 'expr))
          (restore-object* expr)))
      obj)))

(defmethod copy ((obj lambda-conversion-resolution) &rest initargs)
  (with-slots (declaration module-instance type k-conv-type)
    obj
    (make-instance 'lambda-conversion-resolution :declaration
                   (let* ((get1 (getf initargs 'declaration '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declaration '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declaration getfv))
                   :module-instance
                   (let* ((get1
                           (getf initargs 'module-instance '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :module-instance
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module-instance getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :k-conv-type
                   (let* ((get1 (getf initargs 'k-conv-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :k-conv-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) k-conv-type getfv)))))

(defmethod store-object* ((obj lambda-conversion-resolution))
  (with-slots (declaration module-instance type k-conv-type)
    obj
    (reserve-space 5
                   (push-word (store-obj 'lambda-conversion-resolution))
                   (push-word (store-obj declaration))
                   (push-word (store-obj module-instance))
                   (push-word (store-obj type))
                   (push-word (store-obj k-conv-type)))))

(defmethod update-fetched ((obj lambda-conversion-resolution))
  (with-slots (declaration module-instance type k-conv-type)
    obj
    (setf declaration (fetch-obj (stored-word 1)))
    (setf module-instance (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf k-conv-type (fetch-obj (stored-word 4)))))

(defmethod restore-object* ((obj lambda-conversion-resolution))
  (with-slots (module-instance type k-conv-type)
    obj
    (let ((*restore-object-parent* obj))
      (when module-instance
        (let ((*restore-object-parent-slot* 'module-instance))
          (restore-object* module-instance)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when k-conv-type
        (let ((*restore-object-parent-slot* 'k-conv-type))
          (restore-object* k-conv-type)))
      obj)))

(defmethod copy ((obj conversion-resolution) &rest initargs)
  (with-slots (declaration module-instance type conversion)
    obj
    (make-instance 'conversion-resolution :declaration
                   (let* ((get1 (getf initargs 'declaration '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declaration '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declaration getfv))
                   :module-instance
                   (let* ((get1
                           (getf initargs 'module-instance '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :module-instance
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module-instance getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :conversion
                   (let* ((get1 (getf initargs 'conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :conversion '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) conversion getfv)))))

(defmethod store-object* ((obj conversion-resolution))
  (with-slots (declaration module-instance type conversion)
    obj
    (reserve-space 5 (push-word (store-obj 'conversion-resolution))
                   (push-word (store-obj declaration))
                   (push-word (store-obj module-instance))
                   (push-word (store-obj type))
                   (push-word (store-obj conversion)))))

(defmethod update-fetched ((obj conversion-resolution))
  (with-slots (declaration module-instance type conversion)
    obj
    (setf declaration (fetch-obj (stored-word 1)))
    (setf module-instance (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf conversion (fetch-obj (stored-word 4)))))

(defmethod restore-object* ((obj conversion-resolution))
  (with-slots (module-instance type conversion)
    obj
    (let ((*restore-object-parent* obj))
      (when module-instance
        (let ((*restore-object-parent-slot* 'module-instance))
          (restore-object* module-instance)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when conversion
        (let ((*restore-object-parent-slot* 'conversion))
          (restore-object* conversion)))
      obj)))

(defmethod copy ((obj recursive-defn-conversion) &rest initargs)
  (with-slots (place parens type op bindings expression commas? chain?
                     from-expr)
    obj
    (make-instance 'recursive-defn-conversion :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :op
                   (let* ((get1 (getf initargs 'op '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :op '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) op getfv))
                   :bindings
                   (let* ((get1 (getf initargs 'bindings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :bindings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) bindings getfv))
                   :expression
                   (let* ((get1 (getf initargs 'expression '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expression '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expression getfv))
                   :commas?
                   (let* ((get1 (getf initargs 'commas? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :commas? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) commas? getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :from-expr
                   (let* ((get1 (getf initargs 'from-expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :from-expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-expr getfv)))))

(defmethod store-object* ((obj recursive-defn-conversion))
  (with-slots (place parens type op bindings expression commas? chain?
                     from-expr)
    obj
    (reserve-space 10
                   (push-word (store-obj 'recursive-defn-conversion))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj op))
                   (push-word (store-obj bindings))
                   (push-word (store-obj expression))
                   (push-word (store-obj commas?))
                   (push-word (store-obj chain?))
                   (push-word (store-obj from-expr)))))

(defmethod update-fetched ((obj recursive-defn-conversion))
  (with-slots (place parens type op bindings expression commas? chain?
                     from-expr pvs-sxhash-value free-variables
                     free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf op (fetch-obj (stored-word 4)))
    (setf bindings (fetch-obj (stored-word 5)))
    (setf expression (fetch-obj (stored-word 6)))
    (setf commas? (fetch-obj (stored-word 7)))
    (setf chain? (fetch-obj (stored-word 8)))
    (setf from-expr (fetch-obj (stored-word 9)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj recursive-defn-conversion))
  (with-slots (type op bindings expression from-expr)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when op
        (let ((*restore-object-parent-slot* 'op))
          (restore-object* op)))
      (when bindings
        (let ((*restore-object-parent-slot* 'bindings))
          (restore-object* bindings)))
      (when expression
        (let ((*restore-object-parent-slot* 'expression))
          (restore-object* expression)))
      (when from-expr
        (let ((*restore-object-parent-slot* 'from-expr))
          (restore-object* from-expr)))
      obj)))

(defmethod copy ((obj resolution) &rest initargs)
  (with-slots (declaration module-instance type)
    obj
    (make-instance 'resolution :declaration
                   (let* ((get1 (getf initargs 'declaration '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declaration '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declaration getfv))
                   :module-instance
                   (let* ((get1
                           (getf initargs 'module-instance '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :module-instance
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module-instance getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv)))))

(defmethod store-object* ((obj resolution))
  (with-slots (declaration module-instance type)
    obj
    (reserve-space 4 (push-word (store-obj 'resolution))
                   (push-word (store-obj declaration))
                   (push-word (store-obj module-instance))
                   (push-word (store-obj type)))))

(defmethod update-fetched ((obj resolution))
  (with-slots (declaration module-instance type)
    obj
    (setf declaration (fetch-obj (stored-word 1)))
    (setf module-instance (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))))

(defmethod restore-object* ((obj resolution))
  (with-slots (module-instance type)
    obj
    (let ((*restore-object-parent* obj))
      (when module-instance
        (let ((*restore-object-parent-slot* 'module-instance))
          (restore-object* module-instance)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      obj)))

(defmethod copy ((obj mapping-rhs-rename) &rest initargs)
  (with-slots (place expr type-value)
    obj
    (make-instance 'mapping-rhs-rename :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :expr
                   (let* ((get1 (getf initargs 'expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expr getfv))
                   :type-value
                   (let* ((get1 (getf initargs 'type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-value getfv)))))

(defmethod store-object* ((obj mapping-rhs-rename))
  (with-slots (place expr type-value)
    obj
    (reserve-space 4 (push-word (store-obj 'mapping-rhs-rename))
                   (push-word (store-obj place))
                   (push-word (store-obj expr))
                   (push-word (store-obj type-value)))))

(defmethod update-fetched ((obj mapping-rhs-rename))
  (with-slots (place expr type-value pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf expr (fetch-obj (stored-word 2)))
    (setf type-value (fetch-obj (stored-word 3)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj mapping-rhs-rename))
  (with-slots (expr type-value)
    obj
    (let ((*restore-object-parent* obj))
      (when expr
        (let ((*restore-object-parent-slot* 'expr))
          (restore-object* expr)))
      (when type-value
        (let ((*restore-object-parent-slot* 'type-value))
          (restore-object* type-value)))
      obj)))

(defmethod copy ((obj mapping-rhs) &rest initargs)
  (with-slots (place expr type-value)
    obj
    (make-instance 'mapping-rhs :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :expr
                   (let* ((get1 (getf initargs 'expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expr getfv))
                   :type-value
                   (let* ((get1 (getf initargs 'type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-value getfv)))))

(defmethod store-object* ((obj mapping-rhs))
  (with-slots (place expr type-value)
    obj
    (reserve-space 4 (push-word (store-obj 'mapping-rhs))
                   (push-word (store-obj place))
                   (push-word (store-obj expr))
                   (push-word (store-obj type-value)))))

(defmethod update-fetched ((obj mapping-rhs))
  (with-slots (place expr type-value pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf expr (fetch-obj (stored-word 2)))
    (setf type-value (fetch-obj (stored-word 3)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj mapping-rhs))
  (with-slots (expr type-value)
    obj
    (let ((*restore-object-parent* obj))
      (when expr
        (let ((*restore-object-parent-slot* 'expr))
          (restore-object* expr)))
      (when type-value
        (let ((*restore-object-parent-slot* 'type-value))
          (restore-object* type-value)))
      obj)))

(defmethod copy ((obj mapping-lhs) &rest initargs)
  (with-slots (place mod-id library actuals dactuals acts-there?
                     dacts-there? id mappings target resolutions
                     decl-formals module refers-to type declared-type
                     generated-by generated)
    obj
    (make-instance 'mapping-lhs :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :decl-formals
                   (let* ((get1 (getf initargs 'decl-formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :decl-formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) decl-formals getfv))
                   :module
                   (let* ((get1 (getf initargs 'module '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :module '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) module getfv))
                   :refers-to
                   (let* ((get1 (getf initargs 'refers-to '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :refers-to '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) refers-to getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :generated-by
                   (let* ((get1 (getf initargs 'generated-by '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated-by '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated-by getfv))
                   :generated
                   (let* ((get1 (getf initargs 'generated '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :generated '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) generated getfv)))))

(defmethod store-object* ((obj mapping-lhs))
  (with-slots (place mod-id library actuals dactuals acts-there?
                     dacts-there? id mappings target resolutions
                     decl-formals module refers-to type declared-type
                     generated-by generated)
    obj
    (reserve-space 19 (push-word (store-obj 'mapping-lhs))
                   (push-word (store-obj place))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj decl-formals))
                   (push-word (store-obj module))
                   (push-word (store-obj refers-to))
                   (push-word (store-obj type))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj generated-by))
                   (push-word (store-obj generated)))))

(defmethod update-fetched ((obj mapping-lhs))
  (with-slots (place mod-id library actuals dactuals acts-there?
                     dacts-there? id mappings target resolutions
                     decl-formals module refers-to type declared-type
                     generated-by generated pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf mod-id (fetch-obj (stored-word 2)))
    (setf library (fetch-obj (stored-word 3)))
    (setf actuals (fetch-obj (stored-word 4)))
    (setf dactuals (fetch-obj (stored-word 5)))
    (setf acts-there? (fetch-obj (stored-word 6)))
    (setf dacts-there? (fetch-obj (stored-word 7)))
    (setf id (fetch-obj (stored-word 8)))
    (setf mappings (fetch-obj (stored-word 9)))
    (setf target (fetch-obj (stored-word 10)))
    (setf resolutions (fetch-obj (stored-word 11)))
    (setf decl-formals (fetch-obj (stored-word 12)))
    (setf module (fetch-obj (stored-word 13)))
    (setf refers-to (fetch-obj (stored-word 14)))
    (setf type (fetch-obj (stored-word 15)))
    (setf declared-type (fetch-obj (stored-word 16)))
    (setf generated-by (fetch-obj (stored-word 17)))
    (setf generated (fetch-obj (stored-word 18)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj mapping-lhs))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions decl-formals module refers-to
                       type declared-type generated-by generated)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      (when decl-formals
        (let ((*restore-object-parent-slot* 'decl-formals))
          (restore-object* decl-formals)))
      (when module
        (let ((*restore-object-parent-slot* 'module))
          (restore-object* module)))
      (when refers-to
        (let ((*restore-object-parent-slot* 'refers-to))
          (restore-object* refers-to)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when generated-by
        (let ((*restore-object-parent-slot* 'generated-by))
          (restore-object* generated-by)))
      (when generated
        (let ((*restore-object-parent-slot* 'generated))
          (restore-object* generated)))
      obj)))

(defmethod copy ((obj mapping-rename-with-formals) &rest initargs)
  (with-slots (place lhs rhs kind declared-type type mapped-decl
                     formals)
    obj
    (make-instance 'mapping-rename-with-formals :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :lhs
                   (let* ((get1 (getf initargs 'lhs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :lhs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) lhs getfv))
                   :rhs
                   (let* ((get1 (getf initargs 'rhs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :rhs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) rhs getfv))
                   :kind
                   (let* ((get1 (getf initargs 'kind '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :kind '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) kind getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :mapped-decl
                   (let* ((get1 (getf initargs 'mapped-decl '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mapped-decl '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mapped-decl getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv)))))

(defmethod store-object* ((obj mapping-rename-with-formals))
  (with-slots (place lhs rhs kind declared-type type mapped-decl
                     formals)
    obj
    (reserve-space 9
                   (push-word (store-obj 'mapping-rename-with-formals))
                   (push-word (store-obj place))
                   (push-word (store-obj lhs))
                   (push-word (store-obj rhs))
                   (push-word (store-obj kind))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj mapped-decl))
                   (push-word (store-obj formals)))))

(defmethod update-fetched ((obj mapping-rename-with-formals))
  (with-slots (place lhs rhs kind declared-type type mapped-decl
                     formals pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf lhs (fetch-obj (stored-word 2)))
    (setf rhs (fetch-obj (stored-word 3)))
    (setf kind (fetch-obj (stored-word 4)))
    (setf declared-type (fetch-obj (stored-word 5)))
    (setf type (fetch-obj (stored-word 6)))
    (setf mapped-decl (fetch-obj (stored-word 7)))
    (setf formals (fetch-obj (stored-word 8)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj mapping-rename-with-formals))
  (with-slots (lhs rhs declared-type type formals)
    obj
    (let ((*restore-object-parent* obj))
      (when lhs
        (let ((*restore-object-parent-slot* 'lhs))
          (restore-object* lhs)))
      (when rhs
        (let ((*restore-object-parent-slot* 'rhs))
          (restore-object* rhs)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      obj)))

(defmethod copy ((obj mapping-subst-with-formals) &rest initargs)
  (with-slots (place lhs rhs kind declared-type type mapped-decl
                     formals)
    obj
    (make-instance 'mapping-subst-with-formals :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :lhs
                   (let* ((get1 (getf initargs 'lhs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :lhs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) lhs getfv))
                   :rhs
                   (let* ((get1 (getf initargs 'rhs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :rhs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) rhs getfv))
                   :kind
                   (let* ((get1 (getf initargs 'kind '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :kind '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) kind getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :mapped-decl
                   (let* ((get1 (getf initargs 'mapped-decl '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mapped-decl '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mapped-decl getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv)))))

(defmethod store-object* ((obj mapping-subst-with-formals))
  (with-slots (place lhs rhs kind declared-type type mapped-decl
                     formals)
    obj
    (reserve-space 9
                   (push-word (store-obj 'mapping-subst-with-formals))
                   (push-word (store-obj place))
                   (push-word (store-obj lhs))
                   (push-word (store-obj rhs))
                   (push-word (store-obj kind))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj mapped-decl))
                   (push-word (store-obj formals)))))

(defmethod update-fetched ((obj mapping-subst-with-formals))
  (with-slots (place lhs rhs kind declared-type type mapped-decl
                     formals pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf lhs (fetch-obj (stored-word 2)))
    (setf rhs (fetch-obj (stored-word 3)))
    (setf kind (fetch-obj (stored-word 4)))
    (setf declared-type (fetch-obj (stored-word 5)))
    (setf type (fetch-obj (stored-word 6)))
    (setf mapped-decl (fetch-obj (stored-word 7)))
    (setf formals (fetch-obj (stored-word 8)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj mapping-subst-with-formals))
  (with-slots (lhs rhs declared-type type formals)
    obj
    (let ((*restore-object-parent* obj))
      (when lhs
        (let ((*restore-object-parent-slot* 'lhs))
          (restore-object* lhs)))
      (when rhs
        (let ((*restore-object-parent-slot* 'rhs))
          (restore-object* rhs)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      obj)))

(defmethod copy ((obj mapping-with-formals) &rest initargs)
  (with-slots (place lhs rhs kind declared-type type mapped-decl
                     formals)
    obj
    (make-instance 'mapping-with-formals :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :lhs
                   (let* ((get1 (getf initargs 'lhs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :lhs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) lhs getfv))
                   :rhs
                   (let* ((get1 (getf initargs 'rhs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :rhs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) rhs getfv))
                   :kind
                   (let* ((get1 (getf initargs 'kind '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :kind '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) kind getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :mapped-decl
                   (let* ((get1 (getf initargs 'mapped-decl '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mapped-decl '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mapped-decl getfv))
                   :formals
                   (let* ((get1 (getf initargs 'formals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :formals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) formals getfv)))))

(defmethod store-object* ((obj mapping-with-formals))
  (with-slots (place lhs rhs kind declared-type type mapped-decl
                     formals)
    obj
    (reserve-space 9 (push-word (store-obj 'mapping-with-formals))
                   (push-word (store-obj place))
                   (push-word (store-obj lhs))
                   (push-word (store-obj rhs))
                   (push-word (store-obj kind))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj mapped-decl))
                   (push-word (store-obj formals)))))

(defmethod update-fetched ((obj mapping-with-formals))
  (with-slots (place lhs rhs kind declared-type type mapped-decl
                     formals pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf lhs (fetch-obj (stored-word 2)))
    (setf rhs (fetch-obj (stored-word 3)))
    (setf kind (fetch-obj (stored-word 4)))
    (setf declared-type (fetch-obj (stored-word 5)))
    (setf type (fetch-obj (stored-word 6)))
    (setf mapped-decl (fetch-obj (stored-word 7)))
    (setf formals (fetch-obj (stored-word 8)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj mapping-with-formals))
  (with-slots (lhs rhs declared-type type formals)
    obj
    (let ((*restore-object-parent* obj))
      (when lhs
        (let ((*restore-object-parent-slot* 'lhs))
          (restore-object* lhs)))
      (when rhs
        (let ((*restore-object-parent-slot* 'rhs))
          (restore-object* rhs)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when formals
        (let ((*restore-object-parent-slot* 'formals))
          (restore-object* formals)))
      obj)))

(defmethod copy ((obj mapping-rename) &rest initargs)
  (with-slots (place lhs rhs kind declared-type type mapped-decl)
    obj
    (make-instance 'mapping-rename :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :lhs
                   (let* ((get1 (getf initargs 'lhs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :lhs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) lhs getfv))
                   :rhs
                   (let* ((get1 (getf initargs 'rhs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :rhs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) rhs getfv))
                   :kind
                   (let* ((get1 (getf initargs 'kind '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :kind '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) kind getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :mapped-decl
                   (let* ((get1 (getf initargs 'mapped-decl '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mapped-decl '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mapped-decl getfv)))))

(defmethod store-object* ((obj mapping-rename))
  (with-slots (place lhs rhs kind declared-type type mapped-decl)
    obj
    (reserve-space 8 (push-word (store-obj 'mapping-rename))
                   (push-word (store-obj place))
                   (push-word (store-obj lhs))
                   (push-word (store-obj rhs))
                   (push-word (store-obj kind))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj mapped-decl)))))

(defmethod update-fetched ((obj mapping-rename))
  (with-slots (place lhs rhs kind declared-type type mapped-decl
                     pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf lhs (fetch-obj (stored-word 2)))
    (setf rhs (fetch-obj (stored-word 3)))
    (setf kind (fetch-obj (stored-word 4)))
    (setf declared-type (fetch-obj (stored-word 5)))
    (setf type (fetch-obj (stored-word 6)))
    (setf mapped-decl (fetch-obj (stored-word 7)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj mapping-rename))
  (with-slots (lhs rhs declared-type type)
    obj
    (let ((*restore-object-parent* obj))
      (when lhs
        (let ((*restore-object-parent-slot* 'lhs))
          (restore-object* lhs)))
      (when rhs
        (let ((*restore-object-parent-slot* 'rhs))
          (restore-object* rhs)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      obj)))

(defmethod copy ((obj mapping-subst) &rest initargs)
  (with-slots (place lhs rhs kind declared-type type mapped-decl)
    obj
    (make-instance 'mapping-subst :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :lhs
                   (let* ((get1 (getf initargs 'lhs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :lhs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) lhs getfv))
                   :rhs
                   (let* ((get1 (getf initargs 'rhs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :rhs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) rhs getfv))
                   :kind
                   (let* ((get1 (getf initargs 'kind '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :kind '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) kind getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :mapped-decl
                   (let* ((get1 (getf initargs 'mapped-decl '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mapped-decl '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mapped-decl getfv)))))

(defmethod store-object* ((obj mapping-subst))
  (with-slots (place lhs rhs kind declared-type type mapped-decl)
    obj
    (reserve-space 8 (push-word (store-obj 'mapping-subst))
                   (push-word (store-obj place))
                   (push-word (store-obj lhs))
                   (push-word (store-obj rhs))
                   (push-word (store-obj kind))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj mapped-decl)))))

(defmethod update-fetched ((obj mapping-subst))
  (with-slots (place lhs rhs kind declared-type type mapped-decl
                     pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf lhs (fetch-obj (stored-word 2)))
    (setf rhs (fetch-obj (stored-word 3)))
    (setf kind (fetch-obj (stored-word 4)))
    (setf declared-type (fetch-obj (stored-word 5)))
    (setf type (fetch-obj (stored-word 6)))
    (setf mapped-decl (fetch-obj (stored-word 7)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj mapping-subst))
  (with-slots (lhs rhs declared-type type)
    obj
    (let ((*restore-object-parent* obj))
      (when lhs
        (let ((*restore-object-parent-slot* 'lhs))
          (restore-object* lhs)))
      (when rhs
        (let ((*restore-object-parent-slot* 'rhs))
          (restore-object* rhs)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      obj)))

(defmethod copy ((obj mapping) &rest initargs)
  (with-slots (place lhs rhs kind declared-type type mapped-decl)
    obj
    (make-instance 'mapping :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :lhs
                   (let* ((get1 (getf initargs 'lhs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :lhs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) lhs getfv))
                   :rhs
                   (let* ((get1 (getf initargs 'rhs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :rhs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) rhs getfv))
                   :kind
                   (let* ((get1 (getf initargs 'kind '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :kind '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) kind getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :mapped-decl
                   (let* ((get1 (getf initargs 'mapped-decl '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mapped-decl '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mapped-decl getfv)))))

(defmethod store-object* ((obj mapping))
  (with-slots (place lhs rhs kind declared-type type mapped-decl)
    obj
    (reserve-space 8 (push-word (store-obj 'mapping))
                   (push-word (store-obj place))
                   (push-word (store-obj lhs))
                   (push-word (store-obj rhs))
                   (push-word (store-obj kind))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj mapped-decl)))))

(defmethod update-fetched ((obj mapping))
  (with-slots (place lhs rhs kind declared-type type mapped-decl
                     pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf lhs (fetch-obj (stored-word 2)))
    (setf rhs (fetch-obj (stored-word 3)))
    (setf kind (fetch-obj (stored-word 4)))
    (setf declared-type (fetch-obj (stored-word 5)))
    (setf type (fetch-obj (stored-word 6)))
    (setf mapped-decl (fetch-obj (stored-word 7)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj mapping))
  (with-slots (lhs rhs declared-type type)
    obj
    (let ((*restore-object-parent* obj))
      (when lhs
        (let ((*restore-object-parent-slot* 'lhs))
          (restore-object* lhs)))
      (when rhs
        (let ((*restore-object-parent-slot* 'rhs))
          (restore-object* rhs)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      obj)))

(defmethod copy ((obj actual) &rest initargs)
  (with-slots (place expr type-value)
    obj
    (make-instance 'actual :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :expr
                   (let* ((get1 (getf initargs 'expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expr getfv))
                   :type-value
                   (let* ((get1 (getf initargs 'type-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type-value getfv)))))

(defmethod store-object* ((obj actual))
  (with-slots (place expr type-value)
    obj
    (reserve-space 4 (push-word (store-obj 'actual))
                   (push-word (store-obj place))
                   (push-word (store-obj expr))
                   (push-word (store-obj type-value)))))

(defmethod update-fetched ((obj actual))
  (with-slots (place expr type-value pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf expr (fetch-obj (stored-word 2)))
    (setf type-value (fetch-obj (stored-word 3)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj actual))
  (with-slots (expr type-value)
    obj
    (let ((*restore-object-parent* obj))
      (when expr
        (let ((*restore-object-parent-slot* 'expr))
          (restore-object* expr)))
      (when type-value
        (let ((*restore-object-parent-slot* 'type-value))
          (restore-object* type-value)))
      obj)))

(defmethod copy ((obj modname-no-tccs) &rest initargs)
  (with-slots (place mod-id library actuals dactuals acts-there?
                     dacts-there? id mappings target resolutions)
    obj
    (make-instance 'modname-no-tccs :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv)))))

(defmethod store-object* ((obj modname-no-tccs))
  (with-slots (place mod-id library actuals dactuals acts-there?
                     dacts-there? id mappings target resolutions)
    obj
    (reserve-space 12 (push-word (store-obj 'modname-no-tccs))
                   (push-word (store-obj place))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions)))))

(defmethod update-fetched ((obj modname-no-tccs))
  (with-slots (place mod-id library actuals dactuals acts-there?
                     dacts-there? id mappings target resolutions
                     pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf mod-id (fetch-obj (stored-word 2)))
    (setf library (fetch-obj (stored-word 3)))
    (setf actuals (fetch-obj (stored-word 4)))
    (setf dactuals (fetch-obj (stored-word 5)))
    (setf acts-there? (fetch-obj (stored-word 6)))
    (setf dacts-there? (fetch-obj (stored-word 7)))
    (setf id (fetch-obj (stored-word 8)))
    (setf mappings (fetch-obj (stored-word 9)))
    (setf target (fetch-obj (stored-word 10)))
    (setf resolutions (fetch-obj (stored-word 11)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj modname-no-tccs))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      obj)))

(defmethod copy ((obj declparam-modname) &rest initargs)
  (with-slots (place mod-id library actuals dactuals acts-there?
                     dacts-there? id mappings target resolutions
                     from-decl)
    obj
    (make-instance 'declparam-modname :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :from-decl
                   (let* ((get1 (getf initargs 'from-decl '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :from-decl '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) from-decl getfv)))))

(defmethod store-object* ((obj declparam-modname))
  (with-slots (place mod-id library actuals dactuals acts-there?
                     dacts-there? id mappings target resolutions
                     from-decl)
    obj
    (reserve-space 13 (push-word (store-obj 'declparam-modname))
                   (push-word (store-obj place))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj from-decl)))))

(defmethod update-fetched ((obj declparam-modname))
  (with-slots (place mod-id library actuals dactuals acts-there?
                     dacts-there? id mappings target resolutions
                     from-decl pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf mod-id (fetch-obj (stored-word 2)))
    (setf library (fetch-obj (stored-word 3)))
    (setf actuals (fetch-obj (stored-word 4)))
    (setf dactuals (fetch-obj (stored-word 5)))
    (setf acts-there? (fetch-obj (stored-word 6)))
    (setf dacts-there? (fetch-obj (stored-word 7)))
    (setf id (fetch-obj (stored-word 8)))
    (setf mappings (fetch-obj (stored-word 9)))
    (setf target (fetch-obj (stored-word 10)))
    (setf resolutions (fetch-obj (stored-word 11)))
    (setf from-decl (fetch-obj (stored-word 12)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj declparam-modname))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions from-decl)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      (when from-decl
        (let ((*restore-object-parent-slot* 'from-decl))
          (restore-object* from-decl)))
      obj)))

(defmethod copy ((obj interpreted-modname) &rest initargs)
  (with-slots (place mod-id library actuals dactuals acts-there?
                     dacts-there? id mappings target resolutions
                     interp-theory)
    obj
    (make-instance 'interpreted-modname :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :interp-theory
                   (let* ((get1
                           (getf initargs 'interp-theory '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :interp-theory '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) interp-theory getfv)))))

(defmethod store-object* ((obj interpreted-modname))
  (with-slots (place mod-id library actuals dactuals acts-there?
                     dacts-there? id mappings target resolutions
                     interp-theory)
    obj
    (reserve-space 13 (push-word (store-obj 'interpreted-modname))
                   (push-word (store-obj place))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj interp-theory)))))

(defmethod update-fetched ((obj interpreted-modname))
  (with-slots (place mod-id library actuals dactuals acts-there?
                     dacts-there? id mappings target resolutions
                     interp-theory pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf mod-id (fetch-obj (stored-word 2)))
    (setf library (fetch-obj (stored-word 3)))
    (setf actuals (fetch-obj (stored-word 4)))
    (setf dactuals (fetch-obj (stored-word 5)))
    (setf acts-there? (fetch-obj (stored-word 6)))
    (setf dacts-there? (fetch-obj (stored-word 7)))
    (setf id (fetch-obj (stored-word 8)))
    (setf mappings (fetch-obj (stored-word 9)))
    (setf target (fetch-obj (stored-word 10)))
    (setf resolutions (fetch-obj (stored-word 11)))
    (setf interp-theory (fetch-obj (stored-word 12)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj interpreted-modname))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions interp-theory)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      (when interp-theory
        (let ((*restore-object-parent-slot* 'interp-theory))
          (restore-object* interp-theory)))
      obj)))

(defmethod copy ((obj datatype-modname) &rest initargs)
  (with-slots (place mod-id library actuals dactuals acts-there?
                     dacts-there? id mappings target resolutions)
    obj
    (make-instance 'datatype-modname :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv)))))

(defmethod store-object* ((obj datatype-modname))
  (with-slots (place mod-id library actuals dactuals acts-there?
                     dacts-there? id mappings target resolutions)
    obj
    (reserve-space 12 (push-word (store-obj 'datatype-modname))
                   (push-word (store-obj place))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions)))))

(defmethod update-fetched ((obj datatype-modname))
  (with-slots (place mod-id library actuals dactuals acts-there?
                     dacts-there? id mappings target resolutions
                     pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf mod-id (fetch-obj (stored-word 2)))
    (setf library (fetch-obj (stored-word 3)))
    (setf actuals (fetch-obj (stored-word 4)))
    (setf dactuals (fetch-obj (stored-word 5)))
    (setf acts-there? (fetch-obj (stored-word 6)))
    (setf dacts-there? (fetch-obj (stored-word 7)))
    (setf id (fetch-obj (stored-word 8)))
    (setf mappings (fetch-obj (stored-word 9)))
    (setf target (fetch-obj (stored-word 10)))
    (setf resolutions (fetch-obj (stored-word 11)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj datatype-modname))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      obj)))

(defmethod copy ((obj full-modname) &rest initargs)
  (with-slots (place mod-id library actuals dactuals acts-there?
                     dacts-there? id mappings target resolutions)
    obj
    (make-instance 'full-modname :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv)))))

(defmethod store-object* ((obj full-modname))
  (with-slots (place mod-id library actuals dactuals acts-there?
                     dacts-there? id mappings target resolutions)
    obj
    (reserve-space 12 (push-word (store-obj 'full-modname))
                   (push-word (store-obj place))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions)))))

(defmethod update-fetched ((obj full-modname))
  (with-slots (place mod-id library actuals dactuals acts-there?
                     dacts-there? id mappings target resolutions
                     pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf mod-id (fetch-obj (stored-word 2)))
    (setf library (fetch-obj (stored-word 3)))
    (setf actuals (fetch-obj (stored-word 4)))
    (setf dactuals (fetch-obj (stored-word 5)))
    (setf acts-there? (fetch-obj (stored-word 6)))
    (setf dacts-there? (fetch-obj (stored-word 7)))
    (setf id (fetch-obj (stored-word 8)))
    (setf mappings (fetch-obj (stored-word 9)))
    (setf target (fetch-obj (stored-word 10)))
    (setf resolutions (fetch-obj (stored-word 11)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj full-modname))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      obj)))

(defmethod copy ((obj modname) &rest initargs)
  (with-slots (place mod-id library actuals dactuals acts-there?
                     dacts-there? id mappings target resolutions)
    obj
    (make-instance 'modname :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv)))))

(defmethod store-object* ((obj modname))
  (with-slots (place mod-id library actuals dactuals acts-there?
                     dacts-there? id mappings target resolutions)
    obj
    (reserve-space 12 (push-word (store-obj 'modname))
                   (push-word (store-obj place))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions)))))

(defmethod update-fetched ((obj modname))
  (with-slots (place mod-id library actuals dactuals acts-there?
                     dacts-there? id mappings target resolutions
                     pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf mod-id (fetch-obj (stored-word 2)))
    (setf library (fetch-obj (stored-word 3)))
    (setf actuals (fetch-obj (stored-word 4)))
    (setf dactuals (fetch-obj (stored-word 5)))
    (setf acts-there? (fetch-obj (stored-word 6)))
    (setf dacts-there? (fetch-obj (stored-word 7)))
    (setf id (fetch-obj (stored-word 8)))
    (setf mappings (fetch-obj (stored-word 9)))
    (setf target (fetch-obj (stored-word 10)))
    (setf resolutions (fetch-obj (stored-word 11)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj modname))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      obj)))

(defmethod copy ((obj untyped-bind-decl) &rest initargs)
  (with-slots (parens mod-id library actuals dactuals acts-there?
                      dacts-there? mappings target resolutions place id
                      declared-type type chain?)
    obj
    (make-instance 'untyped-bind-decl :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv)))))

(defmethod store-object* ((obj untyped-bind-decl))
  (with-slots (parens mod-id library actuals dactuals acts-there?
                      dacts-there? mappings target resolutions place id
                      declared-type type chain?)
    obj
    (reserve-space 16 (push-word (store-obj 'untyped-bind-decl))
                   (push-word (store-obj parens))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj place))
                   (push-word (store-obj id))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj chain?)))))

(defmethod update-fetched ((obj untyped-bind-decl))
  (with-slots (parens mod-id library actuals dactuals acts-there?
                      dacts-there? mappings target resolutions place id
                      declared-type type chain? free-variables
                      free-parameters pvs-sxhash-value)
    obj
    (setf parens (fetch-obj (stored-word 1)))
    (setf mod-id (fetch-obj (stored-word 2)))
    (setf library (fetch-obj (stored-word 3)))
    (setf actuals (fetch-obj (stored-word 4)))
    (setf dactuals (fetch-obj (stored-word 5)))
    (setf acts-there? (fetch-obj (stored-word 6)))
    (setf dacts-there? (fetch-obj (stored-word 7)))
    (setf mappings (fetch-obj (stored-word 8)))
    (setf target (fetch-obj (stored-word 9)))
    (setf resolutions (fetch-obj (stored-word 10)))
    (setf place (fetch-obj (stored-word 11)))
    (setf id (fetch-obj (stored-word 12)))
    (setf declared-type (fetch-obj (stored-word 13)))
    (setf type (fetch-obj (stored-word 14)))
    (setf chain? (fetch-obj (stored-word 15)))
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj untyped-bind-decl))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions declared-type type)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      obj)))

(defmethod copy ((obj pred-bind-decl) &rest initargs)
  (with-slots (parens mod-id library actuals dactuals acts-there?
                      dacts-there? mappings target resolutions place id
                      declared-type type chain?)
    obj
    (make-instance 'pred-bind-decl :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv)))))

(defmethod store-object* ((obj pred-bind-decl))
  (with-slots (parens mod-id library actuals dactuals acts-there?
                      dacts-there? mappings target resolutions place id
                      declared-type type chain?)
    obj
    (reserve-space 16 (push-word (store-obj 'pred-bind-decl))
                   (push-word (store-obj parens))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj place))
                   (push-word (store-obj id))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj chain?)))))

(defmethod update-fetched ((obj pred-bind-decl))
  (with-slots (parens mod-id library actuals dactuals acts-there?
                      dacts-there? mappings target resolutions place id
                      declared-type type chain? free-variables
                      free-parameters pvs-sxhash-value)
    obj
    (setf parens (fetch-obj (stored-word 1)))
    (setf mod-id (fetch-obj (stored-word 2)))
    (setf library (fetch-obj (stored-word 3)))
    (setf actuals (fetch-obj (stored-word 4)))
    (setf dactuals (fetch-obj (stored-word 5)))
    (setf acts-there? (fetch-obj (stored-word 6)))
    (setf dacts-there? (fetch-obj (stored-word 7)))
    (setf mappings (fetch-obj (stored-word 8)))
    (setf target (fetch-obj (stored-word 9)))
    (setf resolutions (fetch-obj (stored-word 10)))
    (setf place (fetch-obj (stored-word 11)))
    (setf id (fetch-obj (stored-word 12)))
    (setf declared-type (fetch-obj (stored-word 13)))
    (setf type (fetch-obj (stored-word 14)))
    (setf chain? (fetch-obj (stored-word 15)))
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj pred-bind-decl))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions declared-type type)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      obj)))

(defmethod copy ((obj arg-bind-decl) &rest initargs)
  (with-slots (parens mod-id library actuals dactuals acts-there?
                      dacts-there? mappings target resolutions place id
                      declared-type type chain?)
    obj
    (make-instance 'arg-bind-decl :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv)))))

(defmethod store-object* ((obj arg-bind-decl))
  (with-slots (parens mod-id library actuals dactuals acts-there?
                      dacts-there? mappings target resolutions place id
                      declared-type type chain?)
    obj
    (reserve-space 16 (push-word (store-obj 'arg-bind-decl))
                   (push-word (store-obj parens))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj place))
                   (push-word (store-obj id))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj chain?)))))

(defmethod update-fetched ((obj arg-bind-decl))
  (with-slots (parens mod-id library actuals dactuals acts-there?
                      dacts-there? mappings target resolutions place id
                      declared-type type chain? free-variables
                      free-parameters pvs-sxhash-value)
    obj
    (setf parens (fetch-obj (stored-word 1)))
    (setf mod-id (fetch-obj (stored-word 2)))
    (setf library (fetch-obj (stored-word 3)))
    (setf actuals (fetch-obj (stored-word 4)))
    (setf dactuals (fetch-obj (stored-word 5)))
    (setf acts-there? (fetch-obj (stored-word 6)))
    (setf dacts-there? (fetch-obj (stored-word 7)))
    (setf mappings (fetch-obj (stored-word 8)))
    (setf target (fetch-obj (stored-word 9)))
    (setf resolutions (fetch-obj (stored-word 10)))
    (setf place (fetch-obj (stored-word 11)))
    (setf id (fetch-obj (stored-word 12)))
    (setf declared-type (fetch-obj (stored-word 13)))
    (setf type (fetch-obj (stored-word 14)))
    (setf chain? (fetch-obj (stored-word 15)))
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj arg-bind-decl))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions declared-type type)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      obj)))

(defmethod copy ((obj bind-decl) &rest initargs)
  (with-slots (parens mod-id library actuals dactuals acts-there?
                      dacts-there? mappings target resolutions place id
                      declared-type type chain?)
    obj
    (make-instance 'bind-decl :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv)))))

(defmethod store-object* ((obj bind-decl))
  (with-slots (parens mod-id library actuals dactuals acts-there?
                      dacts-there? mappings target resolutions place id
                      declared-type type chain?)
    obj
    (reserve-space 16 (push-word (store-obj 'bind-decl))
                   (push-word (store-obj parens))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj place))
                   (push-word (store-obj id))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj chain?)))))

(defmethod update-fetched ((obj bind-decl))
  (with-slots (parens mod-id library actuals dactuals acts-there?
                      dacts-there? mappings target resolutions place id
                      declared-type type chain? free-variables
                      free-parameters pvs-sxhash-value)
    obj
    (setf parens (fetch-obj (stored-word 1)))
    (setf mod-id (fetch-obj (stored-word 2)))
    (setf library (fetch-obj (stored-word 3)))
    (setf actuals (fetch-obj (stored-word 4)))
    (setf dactuals (fetch-obj (stored-word 5)))
    (setf acts-there? (fetch-obj (stored-word 6)))
    (setf dacts-there? (fetch-obj (stored-word 7)))
    (setf mappings (fetch-obj (stored-word 8)))
    (setf target (fetch-obj (stored-word 9)))
    (setf resolutions (fetch-obj (stored-word 10)))
    (setf place (fetch-obj (stored-word 11)))
    (setf id (fetch-obj (stored-word 12)))
    (setf declared-type (fetch-obj (stored-word 13)))
    (setf type (fetch-obj (stored-word 14)))
    (setf chain? (fetch-obj (stored-word 15)))
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj bind-decl))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions declared-type type)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      obj)))

(defmethod copy ((obj field-decl) &rest initargs)
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      mappings target resolutions place id
                      declared-type type chain?)
    obj
    (make-instance 'field-decl :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv)))))

(defmethod store-object* ((obj field-decl))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      mappings target resolutions place id
                      declared-type type chain?)
    obj
    (reserve-space 15 (push-word (store-obj 'field-decl))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj place))
                   (push-word (store-obj id))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj chain?)))))

(defmethod update-fetched ((obj field-decl))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      mappings target resolutions place id
                      declared-type type chain? pvs-sxhash-value)
    obj
    (setf mod-id (fetch-obj (stored-word 1)))
    (setf library (fetch-obj (stored-word 2)))
    (setf actuals (fetch-obj (stored-word 3)))
    (setf dactuals (fetch-obj (stored-word 4)))
    (setf acts-there? (fetch-obj (stored-word 5)))
    (setf dacts-there? (fetch-obj (stored-word 6)))
    (setf mappings (fetch-obj (stored-word 7)))
    (setf target (fetch-obj (stored-word 8)))
    (setf resolutions (fetch-obj (stored-word 9)))
    (setf place (fetch-obj (stored-word 10)))
    (setf id (fetch-obj (stored-word 11)))
    (setf declared-type (fetch-obj (stored-word 12)))
    (setf type (fetch-obj (stored-word 13)))
    (setf chain? (fetch-obj (stored-word 14)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj field-decl))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions declared-type type)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      obj)))

(defmethod copy ((obj dep-binding) &rest initargs)
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      mappings target resolutions place id
                      declared-type type parens)
    obj
    (make-instance 'dep-binding :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv)))))

(defmethod store-object* ((obj dep-binding))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      mappings target resolutions place id
                      declared-type type parens)
    obj
    (reserve-space 15 (push-word (store-obj 'dep-binding))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj place))
                   (push-word (store-obj id))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type))
                   (push-word (store-obj parens)))))

(defmethod update-fetched ((obj dep-binding))
  (with-slots (mod-id library actuals dactuals acts-there? dacts-there?
                      mappings target resolutions place id
                      declared-type type parens pvs-sxhash-value)
    obj
    (setf mod-id (fetch-obj (stored-word 1)))
    (setf library (fetch-obj (stored-word 2)))
    (setf actuals (fetch-obj (stored-word 3)))
    (setf dactuals (fetch-obj (stored-word 4)))
    (setf acts-there? (fetch-obj (stored-word 5)))
    (setf dacts-there? (fetch-obj (stored-word 6)))
    (setf mappings (fetch-obj (stored-word 7)))
    (setf target (fetch-obj (stored-word 8)))
    (setf resolutions (fetch-obj (stored-word 9)))
    (setf place (fetch-obj (stored-word 10)))
    (setf id (fetch-obj (stored-word 11)))
    (setf declared-type (fetch-obj (stored-word 12)))
    (setf type (fetch-obj (stored-word 13)))
    (setf parens (fetch-obj (stored-word 14)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj dep-binding))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions declared-type type)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      obj)))

(defmethod copy ((obj binding) &rest initargs)
  (with-slots (place id declared-type type)
    obj
    (make-instance 'binding :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv)))))

(defmethod store-object* ((obj binding))
  (with-slots (place id declared-type type)
    obj
    (reserve-space 5 (push-word (store-obj 'binding))
                   (push-word (store-obj place))
                   (push-word (store-obj id))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type)))))

(defmethod update-fetched ((obj binding))
  (with-slots (place id declared-type type pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf id (fetch-obj (stored-word 2)))
    (setf declared-type (fetch-obj (stored-word 3)))
    (setf type (fetch-obj (stored-word 4)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj binding))
  (with-slots (declared-type type)
    obj
    (let ((*restore-object-parent* obj))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      obj)))

(defmethod copy ((obj simple-decl) &rest initargs)
  (with-slots (place id declared-type type)
    obj
    (make-instance 'simple-decl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv)))))

(defmethod store-object* ((obj simple-decl))
  (with-slots (place id declared-type type)
    obj
    (reserve-space 5 (push-word (store-obj 'simple-decl))
                   (push-word (store-obj place))
                   (push-word (store-obj id))
                   (push-word (store-obj declared-type))
                   (push-word (store-obj type)))))

(defmethod update-fetched ((obj simple-decl))
  (with-slots (place id declared-type type pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf id (fetch-obj (stored-word 2)))
    (setf declared-type (fetch-obj (stored-word 3)))
    (setf type (fetch-obj (stored-word 4)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj simple-decl))
  (with-slots (declared-type type)
    obj
    (let ((*restore-object-parent* obj))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      obj)))

(defmethod copy ((obj accessor-assign) &rest initargs)
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions adt-type)
    obj
    (make-instance 'accessor-assign :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :adt-type
                   (let* ((get1 (getf initargs 'adt-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-type getfv)))))

(defmethod store-object* ((obj accessor-assign))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions adt-type)
    obj
    (reserve-space 15 (push-word (store-obj 'accessor-assign))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj place))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj adt-type)))))

(defmethod update-fetched ((obj accessor-assign))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions adt-type free-variables
                      free-parameters pvs-sxhash-value)
    obj
    (setf parens (fetch-obj (stored-word 1)))
    (setf type (fetch-obj (stored-word 2)))
    (setf place (fetch-obj (stored-word 3)))
    (setf mod-id (fetch-obj (stored-word 4)))
    (setf library (fetch-obj (stored-word 5)))
    (setf actuals (fetch-obj (stored-word 6)))
    (setf dactuals (fetch-obj (stored-word 7)))
    (setf acts-there? (fetch-obj (stored-word 8)))
    (setf dacts-there? (fetch-obj (stored-word 9)))
    (setf id (fetch-obj (stored-word 10)))
    (setf mappings (fetch-obj (stored-word 11)))
    (setf target (fetch-obj (stored-word 12)))
    (setf resolutions (fetch-obj (stored-word 13)))
    (setf adt-type (fetch-obj (stored-word 14)))
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj accessor-assign))
  (with-slots (type actuals dactuals acts-there? dacts-there? mappings
                    target resolutions adt-type)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      (when adt-type
        (let ((*restore-object-parent-slot* 'adt-type))
          (restore-object* adt-type)))
      obj)))

(defmethod copy ((obj accessor-assignment-arg) &rest initargs)
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions adt-type)
    obj
    (make-instance 'accessor-assignment-arg :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :adt-type
                   (let* ((get1 (getf initargs 'adt-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-type getfv)))))

(defmethod store-object* ((obj accessor-assignment-arg))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions adt-type)
    obj
    (reserve-space 15 (push-word (store-obj 'accessor-assignment-arg))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj place))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj adt-type)))))

(defmethod update-fetched ((obj accessor-assignment-arg))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions adt-type free-variables
                      free-parameters pvs-sxhash-value)
    obj
    (setf parens (fetch-obj (stored-word 1)))
    (setf type (fetch-obj (stored-word 2)))
    (setf place (fetch-obj (stored-word 3)))
    (setf mod-id (fetch-obj (stored-word 4)))
    (setf library (fetch-obj (stored-word 5)))
    (setf actuals (fetch-obj (stored-word 6)))
    (setf dactuals (fetch-obj (stored-word 7)))
    (setf acts-there? (fetch-obj (stored-word 8)))
    (setf dacts-there? (fetch-obj (stored-word 9)))
    (setf id (fetch-obj (stored-word 10)))
    (setf mappings (fetch-obj (stored-word 11)))
    (setf target (fetch-obj (stored-word 12)))
    (setf resolutions (fetch-obj (stored-word 13)))
    (setf adt-type (fetch-obj (stored-word 14)))
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj accessor-assignment-arg))
  (with-slots (type actuals dactuals acts-there? dacts-there? mappings
                    target resolutions adt-type)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      (when adt-type
        (let ((*restore-object-parent-slot* 'adt-type))
          (restore-object* adt-type)))
      obj)))

(defmethod copy ((obj proj-assign) &rest initargs)
  (with-slots (place parens type number)
    obj
    (make-instance 'proj-assign :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :number
                   (let* ((get1 (getf initargs 'number '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :number '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) number getfv)))))

(defmethod store-object* ((obj proj-assign))
  (with-slots (place parens type number)
    obj
    (reserve-space 5 (push-word (store-obj 'proj-assign))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj number)))))

(defmethod update-fetched ((obj proj-assign))
  (with-slots (place parens type number pvs-sxhash-value free-variables
                     free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf number (fetch-obj (stored-word 4)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj proj-assign))
  (with-slots (type)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      obj)))

(defmethod copy ((obj field-assign) &rest initargs)
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions)
    obj
    (make-instance 'field-assign :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv)))))

(defmethod store-object* ((obj field-assign))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions)
    obj
    (reserve-space 14 (push-word (store-obj 'field-assign))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj place))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions)))))

(defmethod update-fetched ((obj field-assign))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions free-variables free-parameters
                      pvs-sxhash-value)
    obj
    (setf parens (fetch-obj (stored-word 1)))
    (setf type (fetch-obj (stored-word 2)))
    (setf place (fetch-obj (stored-word 3)))
    (setf mod-id (fetch-obj (stored-word 4)))
    (setf library (fetch-obj (stored-word 5)))
    (setf actuals (fetch-obj (stored-word 6)))
    (setf dactuals (fetch-obj (stored-word 7)))
    (setf acts-there? (fetch-obj (stored-word 8)))
    (setf dacts-there? (fetch-obj (stored-word 9)))
    (setf id (fetch-obj (stored-word 10)))
    (setf mappings (fetch-obj (stored-word 11)))
    (setf target (fetch-obj (stored-word 12)))
    (setf resolutions (fetch-obj (stored-word 13)))
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj field-assign))
  (with-slots (type actuals dactuals acts-there? dacts-there? mappings
                    target resolutions)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      obj)))

(defmethod copy ((obj id-assign) &rest initargs)
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions)
    obj
    (make-instance 'id-assign :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv)))))

(defmethod store-object* ((obj id-assign))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions)
    obj
    (reserve-space 14 (push-word (store-obj 'id-assign))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj place))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions)))))

(defmethod update-fetched ((obj id-assign))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions free-variables free-parameters
                      pvs-sxhash-value)
    obj
    (setf parens (fetch-obj (stored-word 1)))
    (setf type (fetch-obj (stored-word 2)))
    (setf place (fetch-obj (stored-word 3)))
    (setf mod-id (fetch-obj (stored-word 4)))
    (setf library (fetch-obj (stored-word 5)))
    (setf actuals (fetch-obj (stored-word 6)))
    (setf dactuals (fetch-obj (stored-word 7)))
    (setf acts-there? (fetch-obj (stored-word 8)))
    (setf dacts-there? (fetch-obj (stored-word 9)))
    (setf id (fetch-obj (stored-word 10)))
    (setf mappings (fetch-obj (stored-word 11)))
    (setf target (fetch-obj (stored-word 12)))
    (setf resolutions (fetch-obj (stored-word 13)))
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj id-assign))
  (with-slots (type actuals dactuals acts-there? dacts-there? mappings
                    target resolutions)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      obj)))

(defmethod copy ((obj quoted-assign) &rest initargs)
  (with-slots (place)
    obj
    (make-instance 'quoted-assign :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv)))))

(defmethod store-object* ((obj quoted-assign))
  (with-slots (place)
    obj
    (reserve-space 2 (push-word (store-obj 'quoted-assign))
                   (push-word (store-obj place)))))

(defmethod update-fetched ((obj quoted-assign))
  (with-slots (place pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj quoted-assign))
  (with-slots nil obj (let ((*restore-object-parent* obj)) obj)))

(defmethod copy ((obj field-assignment-arg) &rest initargs)
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions)
    obj
    (make-instance 'field-assignment-arg :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv)))))

(defmethod store-object* ((obj field-assignment-arg))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions)
    obj
    (reserve-space 14 (push-word (store-obj 'field-assignment-arg))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj place))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions)))))

(defmethod update-fetched ((obj field-assignment-arg))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions free-variables free-parameters
                      pvs-sxhash-value)
    obj
    (setf parens (fetch-obj (stored-word 1)))
    (setf type (fetch-obj (stored-word 2)))
    (setf place (fetch-obj (stored-word 3)))
    (setf mod-id (fetch-obj (stored-word 4)))
    (setf library (fetch-obj (stored-word 5)))
    (setf actuals (fetch-obj (stored-word 6)))
    (setf dactuals (fetch-obj (stored-word 7)))
    (setf acts-there? (fetch-obj (stored-word 8)))
    (setf dacts-there? (fetch-obj (stored-word 9)))
    (setf id (fetch-obj (stored-word 10)))
    (setf mappings (fetch-obj (stored-word 11)))
    (setf target (fetch-obj (stored-word 12)))
    (setf resolutions (fetch-obj (stored-word 13)))
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj field-assignment-arg))
  (with-slots (type actuals dactuals acts-there? dacts-there? mappings
                    target resolutions)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      obj)))

(defmethod copy ((obj uni-maplet) &rest initargs)
  (with-slots (place arguments expression)
    obj
    (make-instance 'uni-maplet :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :arguments
                   (let* ((get1 (getf initargs 'arguments '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :arguments '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) arguments getfv))
                   :expression
                   (let* ((get1 (getf initargs 'expression '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expression '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expression getfv)))))

(defmethod store-object* ((obj uni-maplet))
  (with-slots (place arguments expression)
    obj
    (reserve-space 4 (push-word (store-obj 'uni-maplet))
                   (push-word (store-obj place))
                   (push-word (store-obj arguments))
                   (push-word (store-obj expression)))))

(defmethod update-fetched ((obj uni-maplet))
  (with-slots (place arguments expression pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf arguments (fetch-obj (stored-word 2)))
    (setf expression (fetch-obj (stored-word 3)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj uni-maplet))
  (with-slots (arguments expression)
    obj
    (let ((*restore-object-parent* obj))
      (when arguments
        (let ((*restore-object-parent-slot* 'arguments))
          (restore-object* arguments)))
      (when expression
        (let ((*restore-object-parent-slot* 'expression))
          (restore-object* expression)))
      obj)))

(defmethod copy ((obj uni-assignment) &rest initargs)
  (with-slots (place arguments expression)
    obj
    (make-instance 'uni-assignment :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :arguments
                   (let* ((get1 (getf initargs 'arguments '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :arguments '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) arguments getfv))
                   :expression
                   (let* ((get1 (getf initargs 'expression '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expression '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expression getfv)))))

(defmethod store-object* ((obj uni-assignment))
  (with-slots (place arguments expression)
    obj
    (reserve-space 4 (push-word (store-obj 'uni-assignment))
                   (push-word (store-obj place))
                   (push-word (store-obj arguments))
                   (push-word (store-obj expression)))))

(defmethod update-fetched ((obj uni-assignment))
  (with-slots (place arguments expression pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf arguments (fetch-obj (stored-word 2)))
    (setf expression (fetch-obj (stored-word 3)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj uni-assignment))
  (with-slots (arguments expression)
    obj
    (let ((*restore-object-parent* obj))
      (when arguments
        (let ((*restore-object-parent-slot* 'arguments))
          (restore-object* arguments)))
      (when expression
        (let ((*restore-object-parent-slot* 'expression))
          (restore-object* expression)))
      obj)))

(defmethod copy ((obj maplet) &rest initargs)
  (with-slots (place arguments expression)
    obj
    (make-instance 'maplet :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :arguments
                   (let* ((get1 (getf initargs 'arguments '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :arguments '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) arguments getfv))
                   :expression
                   (let* ((get1 (getf initargs 'expression '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expression '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expression getfv)))))

(defmethod store-object* ((obj maplet))
  (with-slots (place arguments expression)
    obj
    (reserve-space 4 (push-word (store-obj 'maplet))
                   (push-word (store-obj place))
                   (push-word (store-obj arguments))
                   (push-word (store-obj expression)))))

(defmethod update-fetched ((obj maplet))
  (with-slots (place arguments expression pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf arguments (fetch-obj (stored-word 2)))
    (setf expression (fetch-obj (stored-word 3)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj maplet))
  (with-slots (arguments expression)
    obj
    (let ((*restore-object-parent* obj))
      (when arguments
        (let ((*restore-object-parent-slot* 'arguments))
          (restore-object* arguments)))
      (when expression
        (let ((*restore-object-parent-slot* 'expression))
          (restore-object* expression)))
      obj)))

(defmethod copy ((obj assignment) &rest initargs)
  (with-slots (place arguments expression)
    obj
    (make-instance 'assignment :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :arguments
                   (let* ((get1 (getf initargs 'arguments '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :arguments '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) arguments getfv))
                   :expression
                   (let* ((get1 (getf initargs 'expression '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expression '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expression getfv)))))

(defmethod store-object* ((obj assignment))
  (with-slots (place arguments expression)
    obj
    (reserve-space 4 (push-word (store-obj 'assignment))
                   (push-word (store-obj place))
                   (push-word (store-obj arguments))
                   (push-word (store-obj expression)))))

(defmethod update-fetched ((obj assignment))
  (with-slots (place arguments expression pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf arguments (fetch-obj (stored-word 2)))
    (setf expression (fetch-obj (stored-word 3)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj assignment))
  (with-slots (arguments expression)
    obj
    (let ((*restore-object-parent* obj))
      (when arguments
        (let ((*restore-object-parent-slot* 'arguments))
          (restore-object* arguments)))
      (when expression
        (let ((*restore-object-parent-slot* 'expression))
          (restore-object* expression)))
      obj)))

(defmethod copy ((obj update-expr) &rest initargs)
  (with-slots (place parens type expression assignments)
    obj
    (make-instance 'update-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :expression
                   (let* ((get1 (getf initargs 'expression '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expression '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expression getfv))
                   :assignments
                   (let* ((get1 (getf initargs 'assignments '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :assignments '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) assignments getfv)))))

(defmethod store-object* ((obj update-expr))
  (with-slots (place parens type expression assignments)
    obj
    (reserve-space 6 (push-word (store-obj 'update-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj expression))
                   (push-word (store-obj assignments)))))

(defmethod update-fetched ((obj update-expr))
  (with-slots (place parens type expression assignments
                     pvs-sxhash-value free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf expression (fetch-obj (stored-word 4)))
    (setf assignments (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj update-expr))
  (with-slots (type expression assignments)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when expression
        (let ((*restore-object-parent-slot* 'expression))
          (restore-object* expression)))
      (when assignments
        (let ((*restore-object-parent-slot* 'assignments))
          (restore-object* assignments)))
      obj)))

(defmethod copy ((obj exists-expr) &rest initargs)
  (with-slots (place parens type op bindings expression commas? chain?)
    obj
    (make-instance 'exists-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :op
                   (let* ((get1 (getf initargs 'op '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :op '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) op getfv))
                   :bindings
                   (let* ((get1 (getf initargs 'bindings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :bindings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) bindings getfv))
                   :expression
                   (let* ((get1 (getf initargs 'expression '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expression '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expression getfv))
                   :commas?
                   (let* ((get1 (getf initargs 'commas? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :commas? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) commas? getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv)))))

(defmethod store-object* ((obj exists-expr))
  (with-slots (place parens type op bindings expression commas? chain?)
    obj
    (reserve-space 9 (push-word (store-obj 'exists-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj op))
                   (push-word (store-obj bindings))
                   (push-word (store-obj expression))
                   (push-word (store-obj commas?))
                   (push-word (store-obj chain?)))))

(defmethod update-fetched ((obj exists-expr))
  (with-slots (place parens type op bindings expression commas? chain?
                     pvs-sxhash-value free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf op (fetch-obj (stored-word 4)))
    (setf bindings (fetch-obj (stored-word 5)))
    (setf expression (fetch-obj (stored-word 6)))
    (setf commas? (fetch-obj (stored-word 7)))
    (setf chain? (fetch-obj (stored-word 8)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj exists-expr))
  (with-slots (type op bindings expression)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when op
        (let ((*restore-object-parent-slot* 'op))
          (restore-object* op)))
      (when bindings
        (let ((*restore-object-parent-slot* 'bindings))
          (restore-object* bindings)))
      (when expression
        (let ((*restore-object-parent-slot* 'expression))
          (restore-object* expression)))
      obj)))

(defmethod copy ((obj forall-expr) &rest initargs)
  (with-slots (place parens type op bindings expression commas? chain?)
    obj
    (make-instance 'forall-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :op
                   (let* ((get1 (getf initargs 'op '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :op '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) op getfv))
                   :bindings
                   (let* ((get1 (getf initargs 'bindings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :bindings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) bindings getfv))
                   :expression
                   (let* ((get1 (getf initargs 'expression '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expression '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expression getfv))
                   :commas?
                   (let* ((get1 (getf initargs 'commas? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :commas? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) commas? getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv)))))

(defmethod store-object* ((obj forall-expr))
  (with-slots (place parens type op bindings expression commas? chain?)
    obj
    (reserve-space 9 (push-word (store-obj 'forall-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj op))
                   (push-word (store-obj bindings))
                   (push-word (store-obj expression))
                   (push-word (store-obj commas?))
                   (push-word (store-obj chain?)))))

(defmethod update-fetched ((obj forall-expr))
  (with-slots (place parens type op bindings expression commas? chain?
                     pvs-sxhash-value free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf op (fetch-obj (stored-word 4)))
    (setf bindings (fetch-obj (stored-word 5)))
    (setf expression (fetch-obj (stored-word 6)))
    (setf commas? (fetch-obj (stored-word 7)))
    (setf chain? (fetch-obj (stored-word 8)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj forall-expr))
  (with-slots (type op bindings expression)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when op
        (let ((*restore-object-parent-slot* 'op))
          (restore-object* op)))
      (when bindings
        (let ((*restore-object-parent-slot* 'bindings))
          (restore-object* bindings)))
      (when expression
        (let ((*restore-object-parent-slot* 'expression))
          (restore-object* expression)))
      obj)))

(defmethod copy ((obj quant-expr) &rest initargs)
  (with-slots (place parens type op bindings expression commas? chain?)
    obj
    (make-instance 'quant-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :op
                   (let* ((get1 (getf initargs 'op '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :op '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) op getfv))
                   :bindings
                   (let* ((get1 (getf initargs 'bindings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :bindings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) bindings getfv))
                   :expression
                   (let* ((get1 (getf initargs 'expression '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expression '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expression getfv))
                   :commas?
                   (let* ((get1 (getf initargs 'commas? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :commas? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) commas? getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv)))))

(defmethod store-object* ((obj quant-expr))
  (with-slots (place parens type op bindings expression commas? chain?)
    obj
    (reserve-space 9 (push-word (store-obj 'quant-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj op))
                   (push-word (store-obj bindings))
                   (push-word (store-obj expression))
                   (push-word (store-obj commas?))
                   (push-word (store-obj chain?)))))

(defmethod update-fetched ((obj quant-expr))
  (with-slots (place parens type op bindings expression commas? chain?
                     pvs-sxhash-value free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf op (fetch-obj (stored-word 4)))
    (setf bindings (fetch-obj (stored-word 5)))
    (setf expression (fetch-obj (stored-word 6)))
    (setf commas? (fetch-obj (stored-word 7)))
    (setf chain? (fetch-obj (stored-word 8)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj quant-expr))
  (with-slots (type op bindings expression)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when op
        (let ((*restore-object-parent-slot* 'op))
          (restore-object* op)))
      (when bindings
        (let ((*restore-object-parent-slot* 'bindings))
          (restore-object* bindings)))
      (when expression
        (let ((*restore-object-parent-slot* 'expression))
          (restore-object* expression)))
      obj)))

(defmethod copy ((obj tuptype-conversion) &rest initargs)
  (with-slots (place parens type op bindings expression commas? chain?
                     conversions)
    obj
    (make-instance 'tuptype-conversion :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :op
                   (let* ((get1 (getf initargs 'op '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :op '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) op getfv))
                   :bindings
                   (let* ((get1 (getf initargs 'bindings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :bindings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) bindings getfv))
                   :expression
                   (let* ((get1 (getf initargs 'expression '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expression '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expression getfv))
                   :commas?
                   (let* ((get1 (getf initargs 'commas? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :commas? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) commas? getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :conversions
                   (let* ((get1 (getf initargs 'conversions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :conversions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) conversions getfv)))))

(defmethod store-object* ((obj tuptype-conversion))
  (with-slots (place parens type op bindings expression commas? chain?
                     conversions)
    obj
    (reserve-space 10 (push-word (store-obj 'tuptype-conversion))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj op))
                   (push-word (store-obj bindings))
                   (push-word (store-obj expression))
                   (push-word (store-obj commas?))
                   (push-word (store-obj chain?))
                   (push-word (store-obj conversions)))))

(defmethod update-fetched ((obj tuptype-conversion))
  (with-slots (place parens type op bindings expression commas? chain?
                     conversions pvs-sxhash-value free-variables
                     free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf op (fetch-obj (stored-word 4)))
    (setf bindings (fetch-obj (stored-word 5)))
    (setf expression (fetch-obj (stored-word 6)))
    (setf commas? (fetch-obj (stored-word 7)))
    (setf chain? (fetch-obj (stored-word 8)))
    (setf conversions (fetch-obj (stored-word 9)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj tuptype-conversion))
  (with-slots (type op bindings expression conversions)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when op
        (let ((*restore-object-parent-slot* 'op))
          (restore-object* op)))
      (when bindings
        (let ((*restore-object-parent-slot* 'bindings))
          (restore-object* bindings)))
      (when expression
        (let ((*restore-object-parent-slot* 'expression))
          (restore-object* expression)))
      (when conversions
        (let ((*restore-object-parent-slot* 'conversions))
          (restore-object* conversions)))
      obj)))

(defmethod copy ((obj rectype-conversion) &rest initargs)
  (with-slots (place parens type op bindings expression commas? chain?
                     conversions)
    obj
    (make-instance 'rectype-conversion :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :op
                   (let* ((get1 (getf initargs 'op '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :op '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) op getfv))
                   :bindings
                   (let* ((get1 (getf initargs 'bindings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :bindings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) bindings getfv))
                   :expression
                   (let* ((get1 (getf initargs 'expression '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expression '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expression getfv))
                   :commas?
                   (let* ((get1 (getf initargs 'commas? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :commas? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) commas? getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :conversions
                   (let* ((get1 (getf initargs 'conversions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :conversions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) conversions getfv)))))

(defmethod store-object* ((obj rectype-conversion))
  (with-slots (place parens type op bindings expression commas? chain?
                     conversions)
    obj
    (reserve-space 10 (push-word (store-obj 'rectype-conversion))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj op))
                   (push-word (store-obj bindings))
                   (push-word (store-obj expression))
                   (push-word (store-obj commas?))
                   (push-word (store-obj chain?))
                   (push-word (store-obj conversions)))))

(defmethod update-fetched ((obj rectype-conversion))
  (with-slots (place parens type op bindings expression commas? chain?
                     conversions pvs-sxhash-value free-variables
                     free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf op (fetch-obj (stored-word 4)))
    (setf bindings (fetch-obj (stored-word 5)))
    (setf expression (fetch-obj (stored-word 6)))
    (setf commas? (fetch-obj (stored-word 7)))
    (setf chain? (fetch-obj (stored-word 8)))
    (setf conversions (fetch-obj (stored-word 9)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj rectype-conversion))
  (with-slots (type op bindings expression conversions)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when op
        (let ((*restore-object-parent-slot* 'op))
          (restore-object* op)))
      (when bindings
        (let ((*restore-object-parent-slot* 'bindings))
          (restore-object* bindings)))
      (when expression
        (let ((*restore-object-parent-slot* 'expression))
          (restore-object* expression)))
      (when conversions
        (let ((*restore-object-parent-slot* 'conversions))
          (restore-object* conversions)))
      obj)))

(defmethod copy ((obj funtype-conversion) &rest initargs)
  (with-slots (place parens type op bindings expression commas? chain?
                     domain-conversion range-conversion)
    obj
    (make-instance 'funtype-conversion :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :op
                   (let* ((get1 (getf initargs 'op '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :op '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) op getfv))
                   :bindings
                   (let* ((get1 (getf initargs 'bindings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :bindings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) bindings getfv))
                   :expression
                   (let* ((get1 (getf initargs 'expression '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expression '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expression getfv))
                   :commas?
                   (let* ((get1 (getf initargs 'commas? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :commas? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) commas? getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :domain-conversion
                   (let* ((get1
                           (getf initargs 'domain-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :domain-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) domain-conversion getfv))
                   :range-conversion
                   (let* ((get1
                           (getf initargs 'range-conversion '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :range-conversion
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) range-conversion getfv)))))

(defmethod store-object* ((obj funtype-conversion))
  (with-slots (place parens type op bindings expression commas? chain?
                     domain-conversion range-conversion)
    obj
    (reserve-space 11 (push-word (store-obj 'funtype-conversion))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj op))
                   (push-word (store-obj bindings))
                   (push-word (store-obj expression))
                   (push-word (store-obj commas?))
                   (push-word (store-obj chain?))
                   (push-word (store-obj domain-conversion))
                   (push-word (store-obj range-conversion)))))

(defmethod update-fetched ((obj funtype-conversion))
  (with-slots (place parens type op bindings expression commas? chain?
                     domain-conversion range-conversion
                     pvs-sxhash-value free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf op (fetch-obj (stored-word 4)))
    (setf bindings (fetch-obj (stored-word 5)))
    (setf expression (fetch-obj (stored-word 6)))
    (setf commas? (fetch-obj (stored-word 7)))
    (setf chain? (fetch-obj (stored-word 8)))
    (setf domain-conversion (fetch-obj (stored-word 9)))
    (setf range-conversion (fetch-obj (stored-word 10)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj funtype-conversion))
  (with-slots (type op bindings expression domain-conversion
                    range-conversion)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when op
        (let ((*restore-object-parent-slot* 'op))
          (restore-object* op)))
      (when bindings
        (let ((*restore-object-parent-slot* 'bindings))
          (restore-object* bindings)))
      (when expression
        (let ((*restore-object-parent-slot* 'expression))
          (restore-object* expression)))
      (when domain-conversion
        (let ((*restore-object-parent-slot* 'domain-conversion))
          (restore-object* domain-conversion)))
      (when range-conversion
        (let ((*restore-object-parent-slot* 'range-conversion))
          (restore-object* range-conversion)))
      obj)))

(defmethod copy ((obj fieldex-lambda-expr) &rest initargs)
  (with-slots (place parens type op bindings expression commas? chain?
                     actuals dactuals)
    obj
    (make-instance 'fieldex-lambda-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :op
                   (let* ((get1 (getf initargs 'op '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :op '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) op getfv))
                   :bindings
                   (let* ((get1 (getf initargs 'bindings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :bindings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) bindings getfv))
                   :expression
                   (let* ((get1 (getf initargs 'expression '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expression '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expression getfv))
                   :commas?
                   (let* ((get1 (getf initargs 'commas? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :commas? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) commas? getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv)))))

(defmethod store-object* ((obj fieldex-lambda-expr))
  (with-slots (place parens type op bindings expression commas? chain?
                     actuals dactuals)
    obj
    (reserve-space 11 (push-word (store-obj 'fieldex-lambda-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj op))
                   (push-word (store-obj bindings))
                   (push-word (store-obj expression))
                   (push-word (store-obj commas?))
                   (push-word (store-obj chain?))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals)))))

(defmethod update-fetched ((obj fieldex-lambda-expr))
  (with-slots (place parens type op bindings expression commas? chain?
                     actuals dactuals pvs-sxhash-value free-variables
                     free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf op (fetch-obj (stored-word 4)))
    (setf bindings (fetch-obj (stored-word 5)))
    (setf expression (fetch-obj (stored-word 6)))
    (setf commas? (fetch-obj (stored-word 7)))
    (setf chain? (fetch-obj (stored-word 8)))
    (setf actuals (fetch-obj (stored-word 9)))
    (setf dactuals (fetch-obj (stored-word 10)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj fieldex-lambda-expr))
  (with-slots (type op bindings expression actuals dactuals)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when op
        (let ((*restore-object-parent-slot* 'op))
          (restore-object* op)))
      (when bindings
        (let ((*restore-object-parent-slot* 'bindings))
          (restore-object* bindings)))
      (when expression
        (let ((*restore-object-parent-slot* 'expression))
          (restore-object* expression)))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      obj)))

(defmethod copy ((obj let-lambda-expr) &rest initargs)
  (with-slots (place parens type op bindings expression commas? chain?)
    obj
    (make-instance 'let-lambda-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :op
                   (let* ((get1 (getf initargs 'op '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :op '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) op getfv))
                   :bindings
                   (let* ((get1 (getf initargs 'bindings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :bindings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) bindings getfv))
                   :expression
                   (let* ((get1 (getf initargs 'expression '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expression '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expression getfv))
                   :commas?
                   (let* ((get1 (getf initargs 'commas? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :commas? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) commas? getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv)))))

(defmethod store-object* ((obj let-lambda-expr))
  (with-slots (place parens type op bindings expression commas? chain?)
    obj
    (reserve-space 9 (push-word (store-obj 'let-lambda-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj op))
                   (push-word (store-obj bindings))
                   (push-word (store-obj expression))
                   (push-word (store-obj commas?))
                   (push-word (store-obj chain?)))))

(defmethod update-fetched ((obj let-lambda-expr))
  (with-slots (place parens type op bindings expression commas? chain?
                     pvs-sxhash-value free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf op (fetch-obj (stored-word 4)))
    (setf bindings (fetch-obj (stored-word 5)))
    (setf expression (fetch-obj (stored-word 6)))
    (setf commas? (fetch-obj (stored-word 7)))
    (setf chain? (fetch-obj (stored-word 8)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj let-lambda-expr))
  (with-slots (type op bindings expression)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when op
        (let ((*restore-object-parent-slot* 'op))
          (restore-object* op)))
      (when bindings
        (let ((*restore-object-parent-slot* 'bindings))
          (restore-object* bindings)))
      (when expression
        (let ((*restore-object-parent-slot* 'expression))
          (restore-object* expression)))
      obj)))

(defmethod copy ((obj set-list-expr) &rest initargs)
  (with-slots (place parens type op bindings expression commas? chain?
                     exprs)
    obj
    (make-instance 'set-list-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :op
                   (let* ((get1 (getf initargs 'op '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :op '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) op getfv))
                   :bindings
                   (let* ((get1 (getf initargs 'bindings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :bindings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) bindings getfv))
                   :expression
                   (let* ((get1 (getf initargs 'expression '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expression '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expression getfv))
                   :commas?
                   (let* ((get1 (getf initargs 'commas? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :commas? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) commas? getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :exprs
                   (let* ((get1 (getf initargs 'exprs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :exprs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) exprs getfv)))))

(defmethod store-object* ((obj set-list-expr))
  (with-slots (place parens type op bindings expression commas? chain?
                     exprs)
    obj
    (reserve-space 10 (push-word (store-obj 'set-list-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj op))
                   (push-word (store-obj bindings))
                   (push-word (store-obj expression))
                   (push-word (store-obj commas?))
                   (push-word (store-obj chain?))
                   (push-word (store-obj exprs)))))

(defmethod update-fetched ((obj set-list-expr))
  (with-slots (place parens type op bindings expression commas? chain?
                     exprs pvs-sxhash-value free-variables
                     free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf op (fetch-obj (stored-word 4)))
    (setf bindings (fetch-obj (stored-word 5)))
    (setf expression (fetch-obj (stored-word 6)))
    (setf commas? (fetch-obj (stored-word 7)))
    (setf chain? (fetch-obj (stored-word 8)))
    (setf exprs (fetch-obj (stored-word 9)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj set-list-expr))
  (with-slots (type op bindings expression exprs)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when op
        (let ((*restore-object-parent-slot* 'op))
          (restore-object* op)))
      (when bindings
        (let ((*restore-object-parent-slot* 'bindings))
          (restore-object* bindings)))
      (when expression
        (let ((*restore-object-parent-slot* 'expression))
          (restore-object* expression)))
      (when exprs
        (let ((*restore-object-parent-slot* 'exprs))
          (restore-object* exprs)))
      obj)))

(defmethod copy ((obj set-expr-with-type) &rest initargs)
  (with-slots (declared-ret-type return-type place parens type op
                                 bindings expression commas? chain?)
    obj
    (make-instance 'set-expr-with-type :declared-ret-type
                   (let* ((get1
                           (getf initargs 'declared-ret-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-ret-type
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-ret-type getfv))
                   :return-type
                   (let* ((get1 (getf initargs 'return-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :return-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) return-type getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :op
                   (let* ((get1 (getf initargs 'op '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :op '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) op getfv))
                   :bindings
                   (let* ((get1 (getf initargs 'bindings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :bindings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) bindings getfv))
                   :expression
                   (let* ((get1 (getf initargs 'expression '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expression '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expression getfv))
                   :commas?
                   (let* ((get1 (getf initargs 'commas? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :commas? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) commas? getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv)))))

(defmethod store-object* ((obj set-expr-with-type))
  (with-slots (declared-ret-type return-type place parens type op
                                 bindings expression commas? chain?)
    obj
    (reserve-space 11 (push-word (store-obj 'set-expr-with-type))
                   (push-word (store-obj declared-ret-type))
                   (push-word (store-obj return-type))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj op))
                   (push-word (store-obj bindings))
                   (push-word (store-obj expression))
                   (push-word (store-obj commas?))
                   (push-word (store-obj chain?)))))

(defmethod update-fetched ((obj set-expr-with-type))
  (with-slots (declared-ret-type return-type place parens type op
                                 bindings expression commas? chain?
                                 pvs-sxhash-value free-variables
                                 free-parameters)
    obj
    (setf declared-ret-type (fetch-obj (stored-word 1)))
    (setf return-type (fetch-obj (stored-word 2)))
    (setf place (fetch-obj (stored-word 3)))
    (setf parens (fetch-obj (stored-word 4)))
    (setf type (fetch-obj (stored-word 5)))
    (setf op (fetch-obj (stored-word 6)))
    (setf bindings (fetch-obj (stored-word 7)))
    (setf expression (fetch-obj (stored-word 8)))
    (setf commas? (fetch-obj (stored-word 9)))
    (setf chain? (fetch-obj (stored-word 10)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj set-expr-with-type))
  (with-slots (declared-ret-type return-type type op bindings
                                 expression)
    obj
    (let ((*restore-object-parent* obj))
      (when declared-ret-type
        (let ((*restore-object-parent-slot* 'declared-ret-type))
          (restore-object* declared-ret-type)))
      (when return-type
        (let ((*restore-object-parent-slot* 'return-type))
          (restore-object* return-type)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when op
        (let ((*restore-object-parent-slot* 'op))
          (restore-object* op)))
      (when bindings
        (let ((*restore-object-parent-slot* 'bindings))
          (restore-object* bindings)))
      (when expression
        (let ((*restore-object-parent-slot* 'expression))
          (restore-object* expression)))
      obj)))

(defmethod copy ((obj set-expr) &rest initargs)
  (with-slots (place parens type op bindings expression commas? chain?)
    obj
    (make-instance 'set-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :op
                   (let* ((get1 (getf initargs 'op '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :op '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) op getfv))
                   :bindings
                   (let* ((get1 (getf initargs 'bindings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :bindings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) bindings getfv))
                   :expression
                   (let* ((get1 (getf initargs 'expression '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expression '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expression getfv))
                   :commas?
                   (let* ((get1 (getf initargs 'commas? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :commas? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) commas? getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv)))))

(defmethod store-object* ((obj set-expr))
  (with-slots (place parens type op bindings expression commas? chain?)
    obj
    (reserve-space 9 (push-word (store-obj 'set-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj op))
                   (push-word (store-obj bindings))
                   (push-word (store-obj expression))
                   (push-word (store-obj commas?))
                   (push-word (store-obj chain?)))))

(defmethod update-fetched ((obj set-expr))
  (with-slots (place parens type op bindings expression commas? chain?
                     pvs-sxhash-value free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf op (fetch-obj (stored-word 4)))
    (setf bindings (fetch-obj (stored-word 5)))
    (setf expression (fetch-obj (stored-word 6)))
    (setf commas? (fetch-obj (stored-word 7)))
    (setf chain? (fetch-obj (stored-word 8)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj set-expr))
  (with-slots (type op bindings expression)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when op
        (let ((*restore-object-parent-slot* 'op))
          (restore-object* op)))
      (when bindings
        (let ((*restore-object-parent-slot* 'bindings))
          (restore-object* bindings)))
      (when expression
        (let ((*restore-object-parent-slot* 'expression))
          (restore-object* expression)))
      obj)))

(defmethod copy ((obj lambda-conversion) &rest initargs)
  (with-slots (place parens type op bindings expression commas? chain?)
    obj
    (make-instance 'lambda-conversion :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :op
                   (let* ((get1 (getf initargs 'op '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :op '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) op getfv))
                   :bindings
                   (let* ((get1 (getf initargs 'bindings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :bindings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) bindings getfv))
                   :expression
                   (let* ((get1 (getf initargs 'expression '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expression '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expression getfv))
                   :commas?
                   (let* ((get1 (getf initargs 'commas? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :commas? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) commas? getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv)))))

(defmethod store-object* ((obj lambda-conversion))
  (with-slots (place parens type op bindings expression commas? chain?)
    obj
    (reserve-space 9 (push-word (store-obj 'lambda-conversion))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj op))
                   (push-word (store-obj bindings))
                   (push-word (store-obj expression))
                   (push-word (store-obj commas?))
                   (push-word (store-obj chain?)))))

(defmethod update-fetched ((obj lambda-conversion))
  (with-slots (place parens type op bindings expression commas? chain?
                     pvs-sxhash-value free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf op (fetch-obj (stored-word 4)))
    (setf bindings (fetch-obj (stored-word 5)))
    (setf expression (fetch-obj (stored-word 6)))
    (setf commas? (fetch-obj (stored-word 7)))
    (setf chain? (fetch-obj (stored-word 8)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj lambda-conversion))
  (with-slots (type op bindings expression)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when op
        (let ((*restore-object-parent-slot* 'op))
          (restore-object* op)))
      (when bindings
        (let ((*restore-object-parent-slot* 'bindings))
          (restore-object* bindings)))
      (when expression
        (let ((*restore-object-parent-slot* 'expression))
          (restore-object* expression)))
      obj)))

(defmethod copy ((obj lambda-expr-with-type) &rest initargs)
  (with-slots (place parens type op bindings expression commas? chain?
                     declared-ret-type return-type)
    obj
    (make-instance 'lambda-expr-with-type :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :op
                   (let* ((get1 (getf initargs 'op '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :op '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) op getfv))
                   :bindings
                   (let* ((get1 (getf initargs 'bindings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :bindings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) bindings getfv))
                   :expression
                   (let* ((get1 (getf initargs 'expression '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expression '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expression getfv))
                   :commas?
                   (let* ((get1 (getf initargs 'commas? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :commas? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) commas? getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv))
                   :declared-ret-type
                   (let* ((get1
                           (getf initargs 'declared-ret-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :declared-ret-type
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-ret-type getfv))
                   :return-type
                   (let* ((get1 (getf initargs 'return-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :return-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) return-type getfv)))))

(defmethod store-object* ((obj lambda-expr-with-type))
  (with-slots (place parens type op bindings expression commas? chain?
                     declared-ret-type return-type)
    obj
    (reserve-space 11 (push-word (store-obj 'lambda-expr-with-type))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj op))
                   (push-word (store-obj bindings))
                   (push-word (store-obj expression))
                   (push-word (store-obj commas?))
                   (push-word (store-obj chain?))
                   (push-word (store-obj declared-ret-type))
                   (push-word (store-obj return-type)))))

(defmethod update-fetched ((obj lambda-expr-with-type))
  (with-slots (place parens type op bindings expression commas? chain?
                     declared-ret-type return-type pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf op (fetch-obj (stored-word 4)))
    (setf bindings (fetch-obj (stored-word 5)))
    (setf expression (fetch-obj (stored-word 6)))
    (setf commas? (fetch-obj (stored-word 7)))
    (setf chain? (fetch-obj (stored-word 8)))
    (setf declared-ret-type (fetch-obj (stored-word 9)))
    (setf return-type (fetch-obj (stored-word 10)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj lambda-expr-with-type))
  (with-slots (type op bindings expression declared-ret-type
                    return-type)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when op
        (let ((*restore-object-parent-slot* 'op))
          (restore-object* op)))
      (when bindings
        (let ((*restore-object-parent-slot* 'bindings))
          (restore-object* bindings)))
      (when expression
        (let ((*restore-object-parent-slot* 'expression))
          (restore-object* expression)))
      (when declared-ret-type
        (let ((*restore-object-parent-slot* 'declared-ret-type))
          (restore-object* declared-ret-type)))
      (when return-type
        (let ((*restore-object-parent-slot* 'return-type))
          (restore-object* return-type)))
      obj)))

(defmethod copy ((obj lambda-expr) &rest initargs)
  (with-slots (place parens type op bindings expression commas? chain?)
    obj
    (make-instance 'lambda-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :op
                   (let* ((get1 (getf initargs 'op '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :op '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) op getfv))
                   :bindings
                   (let* ((get1 (getf initargs 'bindings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :bindings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) bindings getfv))
                   :expression
                   (let* ((get1 (getf initargs 'expression '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expression '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expression getfv))
                   :commas?
                   (let* ((get1 (getf initargs 'commas? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :commas? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) commas? getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv)))))

(defmethod store-object* ((obj lambda-expr))
  (with-slots (place parens type op bindings expression commas? chain?)
    obj
    (reserve-space 9 (push-word (store-obj 'lambda-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj op))
                   (push-word (store-obj bindings))
                   (push-word (store-obj expression))
                   (push-word (store-obj commas?))
                   (push-word (store-obj chain?)))))

(defmethod update-fetched ((obj lambda-expr))
  (with-slots (place parens type op bindings expression commas? chain?
                     pvs-sxhash-value free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf op (fetch-obj (stored-word 4)))
    (setf bindings (fetch-obj (stored-word 5)))
    (setf expression (fetch-obj (stored-word 6)))
    (setf commas? (fetch-obj (stored-word 7)))
    (setf chain? (fetch-obj (stored-word 8)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj lambda-expr))
  (with-slots (type op bindings expression)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when op
        (let ((*restore-object-parent-slot* 'op))
          (restore-object* op)))
      (when bindings
        (let ((*restore-object-parent-slot* 'bindings))
          (restore-object* bindings)))
      (when expression
        (let ((*restore-object-parent-slot* 'expression))
          (restore-object* expression)))
      obj)))

(defmethod copy ((obj binding-expr) &rest initargs)
  (with-slots (place parens type op bindings expression commas? chain?)
    obj
    (make-instance 'binding-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :op
                   (let* ((get1 (getf initargs 'op '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :op '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) op getfv))
                   :bindings
                   (let* ((get1 (getf initargs 'bindings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :bindings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) bindings getfv))
                   :expression
                   (let* ((get1 (getf initargs 'expression '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expression '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expression getfv))
                   :commas?
                   (let* ((get1 (getf initargs 'commas? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :commas? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) commas? getfv))
                   :chain?
                   (let* ((get1 (getf initargs 'chain? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :chain? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) chain? getfv)))))

(defmethod store-object* ((obj binding-expr))
  (with-slots (place parens type op bindings expression commas? chain?)
    obj
    (reserve-space 9 (push-word (store-obj 'binding-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj op))
                   (push-word (store-obj bindings))
                   (push-word (store-obj expression))
                   (push-word (store-obj commas?))
                   (push-word (store-obj chain?)))))

(defmethod update-fetched ((obj binding-expr))
  (with-slots (place parens type op bindings expression commas? chain?
                     pvs-sxhash-value free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf op (fetch-obj (stored-word 4)))
    (setf bindings (fetch-obj (stored-word 5)))
    (setf expression (fetch-obj (stored-word 6)))
    (setf commas? (fetch-obj (stored-word 7)))
    (setf chain? (fetch-obj (stored-word 8)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj binding-expr))
  (with-slots (type op bindings expression)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when op
        (let ((*restore-object-parent-slot* 'op))
          (restore-object* op)))
      (when bindings
        (let ((*restore-object-parent-slot* 'bindings))
          (restore-object* bindings)))
      (when expression
        (let ((*restore-object-parent-slot* 'expression))
          (restore-object* expression)))
      obj)))

(defmethod copy ((obj implicit-conversion) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'implicit-conversion :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj implicit-conversion))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'implicit-conversion))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj implicit-conversion))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj implicit-conversion))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj argument-conversion) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'argument-conversion :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj argument-conversion))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'argument-conversion))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj argument-conversion))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj argument-conversion))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj let-table-expr) &rest initargs)
  (with-slots (row-expr col-expr row-headings col-headings
                        table-entries place parens type operator
                        argument)
    obj
    (make-instance 'let-table-expr :row-expr
                   (let* ((get1 (getf initargs 'row-expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :row-expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) row-expr getfv))
                   :col-expr
                   (let* ((get1 (getf initargs 'col-expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :col-expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) col-expr getfv))
                   :row-headings
                   (let* ((get1 (getf initargs 'row-headings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :row-headings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) row-headings getfv))
                   :col-headings
                   (let* ((get1 (getf initargs 'col-headings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :col-headings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) col-headings getfv))
                   :table-entries
                   (let* ((get1
                           (getf initargs 'table-entries '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :table-entries '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) table-entries getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj let-table-expr))
  (with-slots (row-expr col-expr row-headings col-headings
                        table-entries place parens type operator
                        argument)
    obj
    (reserve-space 11 (push-word (store-obj 'let-table-expr))
                   (push-word (store-obj row-expr))
                   (push-word (store-obj col-expr))
                   (push-word (store-obj row-headings))
                   (push-word (store-obj col-headings))
                   (push-word (store-obj table-entries))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj let-table-expr))
  (with-slots (row-expr col-expr row-headings col-headings
                        table-entries place parens type operator
                        argument pvs-sxhash-value free-variables
                        free-parameters)
    obj
    (setf row-expr (fetch-obj (stored-word 1)))
    (setf col-expr (fetch-obj (stored-word 2)))
    (setf row-headings (fetch-obj (stored-word 3)))
    (setf col-headings (fetch-obj (stored-word 4)))
    (setf table-entries (fetch-obj (stored-word 5)))
    (setf place (fetch-obj (stored-word 6)))
    (setf parens (fetch-obj (stored-word 7)))
    (setf type (fetch-obj (stored-word 8)))
    (setf operator (fetch-obj (stored-word 9)))
    (setf argument (fetch-obj (stored-word 10)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj let-table-expr))
  (with-slots (row-expr col-expr row-headings col-headings
                        table-entries type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when row-expr
        (let ((*restore-object-parent-slot* 'row-expr))
          (restore-object* row-expr)))
      (when col-expr
        (let ((*restore-object-parent-slot* 'col-expr))
          (restore-object* col-expr)))
      (when row-headings
        (let ((*restore-object-parent-slot* 'row-headings))
          (restore-object* row-headings)))
      (when col-headings
        (let ((*restore-object-parent-slot* 'col-headings))
          (restore-object* col-headings)))
      (when table-entries
        (let ((*restore-object-parent-slot* 'table-entries))
          (restore-object* table-entries)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj single-cond-table-expr) &rest initargs)
  (with-slots (row-expr col-expr row-headings col-headings
                        table-entries place parens type operator
                        argument)
    obj
    (make-instance 'single-cond-table-expr :row-expr
                   (let* ((get1 (getf initargs 'row-expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :row-expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) row-expr getfv))
                   :col-expr
                   (let* ((get1 (getf initargs 'col-expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :col-expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) col-expr getfv))
                   :row-headings
                   (let* ((get1 (getf initargs 'row-headings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :row-headings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) row-headings getfv))
                   :col-headings
                   (let* ((get1 (getf initargs 'col-headings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :col-headings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) col-headings getfv))
                   :table-entries
                   (let* ((get1
                           (getf initargs 'table-entries '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :table-entries '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) table-entries getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj single-cond-table-expr))
  (with-slots (row-expr col-expr row-headings col-headings
                        table-entries place parens type operator
                        argument)
    obj
    (reserve-space 11 (push-word (store-obj 'single-cond-table-expr))
                   (push-word (store-obj row-expr))
                   (push-word (store-obj col-expr))
                   (push-word (store-obj row-headings))
                   (push-word (store-obj col-headings))
                   (push-word (store-obj table-entries))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj single-cond-table-expr))
  (with-slots (row-expr col-expr row-headings col-headings
                        table-entries place parens type operator
                        argument pvs-sxhash-value free-variables
                        free-parameters)
    obj
    (setf row-expr (fetch-obj (stored-word 1)))
    (setf col-expr (fetch-obj (stored-word 2)))
    (setf row-headings (fetch-obj (stored-word 3)))
    (setf col-headings (fetch-obj (stored-word 4)))
    (setf table-entries (fetch-obj (stored-word 5)))
    (setf place (fetch-obj (stored-word 6)))
    (setf parens (fetch-obj (stored-word 7)))
    (setf type (fetch-obj (stored-word 8)))
    (setf operator (fetch-obj (stored-word 9)))
    (setf argument (fetch-obj (stored-word 10)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj single-cond-table-expr))
  (with-slots (row-expr col-expr row-headings col-headings
                        table-entries type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when row-expr
        (let ((*restore-object-parent-slot* 'row-expr))
          (restore-object* row-expr)))
      (when col-expr
        (let ((*restore-object-parent-slot* 'col-expr))
          (restore-object* col-expr)))
      (when row-headings
        (let ((*restore-object-parent-slot* 'row-headings))
          (restore-object* row-headings)))
      (when col-headings
        (let ((*restore-object-parent-slot* 'col-headings))
          (restore-object* col-headings)))
      (when table-entries
        (let ((*restore-object-parent-slot* 'table-entries))
          (restore-object* table-entries)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj cond-table-expr) &rest initargs)
  (with-slots (row-expr col-expr row-headings col-headings
                        table-entries place parens type operator
                        argument)
    obj
    (make-instance 'cond-table-expr :row-expr
                   (let* ((get1 (getf initargs 'row-expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :row-expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) row-expr getfv))
                   :col-expr
                   (let* ((get1 (getf initargs 'col-expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :col-expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) col-expr getfv))
                   :row-headings
                   (let* ((get1 (getf initargs 'row-headings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :row-headings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) row-headings getfv))
                   :col-headings
                   (let* ((get1 (getf initargs 'col-headings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :col-headings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) col-headings getfv))
                   :table-entries
                   (let* ((get1
                           (getf initargs 'table-entries '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :table-entries '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) table-entries getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj cond-table-expr))
  (with-slots (row-expr col-expr row-headings col-headings
                        table-entries place parens type operator
                        argument)
    obj
    (reserve-space 11 (push-word (store-obj 'cond-table-expr))
                   (push-word (store-obj row-expr))
                   (push-word (store-obj col-expr))
                   (push-word (store-obj row-headings))
                   (push-word (store-obj col-headings))
                   (push-word (store-obj table-entries))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj cond-table-expr))
  (with-slots (row-expr col-expr row-headings col-headings
                        table-entries place parens type operator
                        argument pvs-sxhash-value free-variables
                        free-parameters)
    obj
    (setf row-expr (fetch-obj (stored-word 1)))
    (setf col-expr (fetch-obj (stored-word 2)))
    (setf row-headings (fetch-obj (stored-word 3)))
    (setf col-headings (fetch-obj (stored-word 4)))
    (setf table-entries (fetch-obj (stored-word 5)))
    (setf place (fetch-obj (stored-word 6)))
    (setf parens (fetch-obj (stored-word 7)))
    (setf type (fetch-obj (stored-word 8)))
    (setf operator (fetch-obj (stored-word 9)))
    (setf argument (fetch-obj (stored-word 10)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj cond-table-expr))
  (with-slots (row-expr col-expr row-headings col-headings
                        table-entries type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when row-expr
        (let ((*restore-object-parent-slot* 'row-expr))
          (restore-object* row-expr)))
      (when col-expr
        (let ((*restore-object-parent-slot* 'col-expr))
          (restore-object* col-expr)))
      (when row-headings
        (let ((*restore-object-parent-slot* 'row-headings))
          (restore-object* row-headings)))
      (when col-headings
        (let ((*restore-object-parent-slot* 'col-headings))
          (restore-object* col-headings)))
      (when table-entries
        (let ((*restore-object-parent-slot* 'table-entries))
          (restore-object* table-entries)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj cases-table-expr) &rest initargs)
  (with-slots (row-expr col-expr row-headings col-headings
                        table-entries place parens type expression
                        selections else-part)
    obj
    (make-instance 'cases-table-expr :row-expr
                   (let* ((get1 (getf initargs 'row-expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :row-expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) row-expr getfv))
                   :col-expr
                   (let* ((get1 (getf initargs 'col-expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :col-expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) col-expr getfv))
                   :row-headings
                   (let* ((get1 (getf initargs 'row-headings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :row-headings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) row-headings getfv))
                   :col-headings
                   (let* ((get1 (getf initargs 'col-headings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :col-headings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) col-headings getfv))
                   :table-entries
                   (let* ((get1
                           (getf initargs 'table-entries '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :table-entries '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) table-entries getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :expression
                   (let* ((get1 (getf initargs 'expression '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expression '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expression getfv))
                   :selections
                   (let* ((get1 (getf initargs 'selections '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :selections '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) selections getfv))
                   :else-part
                   (let* ((get1 (getf initargs 'else-part '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :else-part '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) else-part getfv)))))

(defmethod store-object* ((obj cases-table-expr))
  (with-slots (row-expr col-expr row-headings col-headings
                        table-entries place parens type expression
                        selections else-part)
    obj
    (reserve-space 12 (push-word (store-obj 'cases-table-expr))
                   (push-word (store-obj row-expr))
                   (push-word (store-obj col-expr))
                   (push-word (store-obj row-headings))
                   (push-word (store-obj col-headings))
                   (push-word (store-obj table-entries))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj expression))
                   (push-word (store-obj selections))
                   (push-word (store-obj else-part)))))

(defmethod update-fetched ((obj cases-table-expr))
  (with-slots (row-expr col-expr row-headings col-headings
                        table-entries place parens type expression
                        selections else-part pvs-sxhash-value
                        free-variables free-parameters)
    obj
    (setf row-expr (fetch-obj (stored-word 1)))
    (setf col-expr (fetch-obj (stored-word 2)))
    (setf row-headings (fetch-obj (stored-word 3)))
    (setf col-headings (fetch-obj (stored-word 4)))
    (setf table-entries (fetch-obj (stored-word 5)))
    (setf place (fetch-obj (stored-word 6)))
    (setf parens (fetch-obj (stored-word 7)))
    (setf type (fetch-obj (stored-word 8)))
    (setf expression (fetch-obj (stored-word 9)))
    (setf selections (fetch-obj (stored-word 10)))
    (setf else-part (fetch-obj (stored-word 11)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj cases-table-expr))
  (with-slots (row-expr col-expr row-headings col-headings
                        table-entries type expression selections
                        else-part)
    obj
    (let ((*restore-object-parent* obj))
      (when row-expr
        (let ((*restore-object-parent-slot* 'row-expr))
          (restore-object* row-expr)))
      (when col-expr
        (let ((*restore-object-parent-slot* 'col-expr))
          (restore-object* col-expr)))
      (when row-headings
        (let ((*restore-object-parent-slot* 'row-headings))
          (restore-object* row-headings)))
      (when col-headings
        (let ((*restore-object-parent-slot* 'col-headings))
          (restore-object* col-headings)))
      (when table-entries
        (let ((*restore-object-parent-slot* 'table-entries))
          (restore-object* table-entries)))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when expression
        (let ((*restore-object-parent-slot* 'expression))
          (restore-object* expression)))
      (when selections
        (let ((*restore-object-parent-slot* 'selections))
          (restore-object* selections)))
      (when else-part
        (let ((*restore-object-parent-slot* 'else-part))
          (restore-object* else-part)))
      obj)))

(defmethod copy ((obj table-expr) &rest initargs)
  (with-slots (place parens type row-expr col-expr row-headings
                     col-headings table-entries)
    obj
    (make-instance 'table-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :row-expr
                   (let* ((get1 (getf initargs 'row-expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :row-expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) row-expr getfv))
                   :col-expr
                   (let* ((get1 (getf initargs 'col-expr '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :col-expr '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) col-expr getfv))
                   :row-headings
                   (let* ((get1 (getf initargs 'row-headings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :row-headings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) row-headings getfv))
                   :col-headings
                   (let* ((get1 (getf initargs 'col-headings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :col-headings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) col-headings getfv))
                   :table-entries
                   (let* ((get1
                           (getf initargs 'table-entries '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :table-entries '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) table-entries getfv)))))

(defmethod store-object* ((obj table-expr))
  (with-slots (place parens type row-expr col-expr row-headings
                     col-headings table-entries)
    obj
    (reserve-space 9 (push-word (store-obj 'table-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj row-expr))
                   (push-word (store-obj col-expr))
                   (push-word (store-obj row-headings))
                   (push-word (store-obj col-headings))
                   (push-word (store-obj table-entries)))))

(defmethod update-fetched ((obj table-expr))
  (with-slots (place parens type row-expr col-expr row-headings
                     col-headings table-entries pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf row-expr (fetch-obj (stored-word 4)))
    (setf col-expr (fetch-obj (stored-word 5)))
    (setf row-headings (fetch-obj (stored-word 6)))
    (setf col-headings (fetch-obj (stored-word 7)))
    (setf table-entries (fetch-obj (stored-word 8)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj table-expr))
  (with-slots (type row-expr col-expr row-headings col-headings
                    table-entries)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when row-expr
        (let ((*restore-object-parent-slot* 'row-expr))
          (restore-object* row-expr)))
      (when col-expr
        (let ((*restore-object-parent-slot* 'col-expr))
          (restore-object* col-expr)))
      (when row-headings
        (let ((*restore-object-parent-slot* 'row-headings))
          (restore-object* row-headings)))
      (when col-headings
        (let ((*restore-object-parent-slot* 'col-headings))
          (restore-object* col-headings)))
      (when table-entries
        (let ((*restore-object-parent-slot* 'table-entries))
          (restore-object* table-entries)))
      obj)))

(defmethod copy ((obj else-condition) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'else-condition :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj else-condition))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'else-condition))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj else-condition))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj else-condition))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj last-cond-expr) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'last-cond-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj last-cond-expr))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'last-cond-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj last-cond-expr))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj last-cond-expr))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj cond-expr) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'cond-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj cond-expr))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'cond-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj cond-expr))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj cond-expr))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj single-cond-expr) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'single-cond-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj single-cond-expr))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'single-cond-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj single-cond-expr))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj single-cond-expr))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj first-cond-expr) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'first-cond-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj first-cond-expr))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'first-cond-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj first-cond-expr))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj first-cond-expr))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj coercion) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'coercion :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj coercion))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'coercion))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj coercion))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj coercion))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj chained-where-expr) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'chained-where-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj chained-where-expr))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'chained-where-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj chained-where-expr))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj chained-where-expr))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj where-expr) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'where-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj where-expr))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'where-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj where-expr))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj where-expr))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj chained-let-expr) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'chained-let-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj chained-let-expr))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'chained-let-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj chained-let-expr))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj chained-let-expr))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj let-expr) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'let-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj let-expr))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'let-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj let-expr))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj let-expr))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj chained-branch) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'chained-branch :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj chained-branch))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'chained-branch))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj chained-branch))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj chained-branch))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj mixfix-branch) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'mixfix-branch :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj mixfix-branch))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'mixfix-branch))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj mixfix-branch))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj mixfix-branch))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj branch) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'branch :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj branch))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'branch))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj branch))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj branch))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj chained-if-expr) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'chained-if-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj chained-if-expr))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'chained-if-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj chained-if-expr))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj chained-if-expr))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj if-expr) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'if-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj if-expr))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'if-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj if-expr))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj if-expr))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj bitvector-conversion) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'bitvector-conversion :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj bitvector-conversion))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'bitvector-conversion))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj bitvector-conversion))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj bitvector-conversion))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj bitvector) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'bitvector :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj bitvector))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'bitvector))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj bitvector))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj bitvector))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj decimal) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'decimal :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj decimal))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'decimal))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj decimal))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj decimal))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj infix-disequation) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'infix-disequation :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj infix-disequation))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'infix-disequation))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj infix-disequation))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj infix-disequation))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj disequation) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'disequation :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj disequation))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'disequation))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj disequation))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj disequation))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj infix-boolean-equation) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'infix-boolean-equation :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj infix-boolean-equation))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'infix-boolean-equation))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj infix-boolean-equation))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj infix-boolean-equation))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj boolean-equation) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'boolean-equation :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj boolean-equation))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'boolean-equation))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj boolean-equation))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj boolean-equation))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj infix-equation) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'infix-equation :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj infix-equation))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'infix-equation))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj infix-equation))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj infix-equation))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj equation) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'equation :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj equation))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'equation))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj equation))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj equation))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj infix-iff) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'infix-iff :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj infix-iff))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'infix-iff))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj infix-iff))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj infix-iff))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj iff) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'iff :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj iff))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'iff))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj iff))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj iff))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj iff-or-boolean-equation) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'iff-or-boolean-equation :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj iff-or-boolean-equation))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'iff-or-boolean-equation))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj iff-or-boolean-equation))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj iff-or-boolean-equation))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj infix-when-expr) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'infix-when-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj infix-when-expr))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'infix-when-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj infix-when-expr))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj infix-when-expr))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj when-expr) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'when-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj when-expr))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'when-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj when-expr))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj when-expr))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj infix-implication) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'infix-implication :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj infix-implication))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'infix-implication))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj infix-implication))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj infix-implication))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj implication) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'implication :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj implication))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'implication))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj implication))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj implication))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj infix-disjunction) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'infix-disjunction :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj infix-disjunction))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'infix-disjunction))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj infix-disjunction))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj infix-disjunction))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj disjunction) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'disjunction :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj disjunction))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'disjunction))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj disjunction))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj disjunction))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj chained-relation) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'chained-relation :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj chained-relation))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'chained-relation))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj chained-relation))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj chained-relation))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj infix-conjunction) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'infix-conjunction :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj infix-conjunction))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'infix-conjunction))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj infix-conjunction))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj infix-conjunction))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj conjunction) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'conjunction :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj conjunction))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'conjunction))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj conjunction))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj conjunction))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj unary-negation) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'unary-negation :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj unary-negation))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'unary-negation))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj unary-negation))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj unary-negation))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj negation) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'negation :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj negation))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'negation))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj negation))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj negation))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj propositional-application) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'propositional-application :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj propositional-application))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'propositional-application))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj propositional-application))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj propositional-application))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj unary-application) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'unary-application :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj unary-application))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'unary-application))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj unary-application))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj unary-application))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj infix-application) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'infix-application :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj infix-application))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'infix-application))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj infix-application))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj infix-application))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj bracket-expr) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'bracket-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj bracket-expr))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'bracket-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj bracket-expr))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj bracket-expr))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj string-expr) &rest initargs)
  (with-slots (place parens type operator argument string-value)
    obj
    (make-instance 'string-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv))
                   :string-value
                   (let* ((get1 (getf initargs 'string-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :string-value '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) string-value getfv)))))

(defmethod store-object* ((obj string-expr))
  (with-slots (place parens type operator argument string-value)
    obj
    (reserve-space 7 (push-word (store-obj 'string-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument))
                   (push-word (store-obj string-value)))))

(defmethod update-fetched ((obj string-expr))
  (with-slots (place parens type operator argument string-value
                     pvs-sxhash-value free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf string-value (fetch-obj (stored-word 6)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj string-expr))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj null-expr) &rest initargs)
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions adt-type)
    obj
    (make-instance 'null-expr :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :adt-type
                   (let* ((get1 (getf initargs 'adt-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-type getfv))
                   :recognizer-name
                   (let* ((get1
                           (getf initargs 'recognizer-name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :recognizer-name
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :accessor-names
                   (let* ((get1
                           (getf initargs 'accessor-names '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :accessor-names '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv)))))

(defmethod store-object* ((obj null-expr))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions adt-type accessor-names)
    obj
    (reserve-space 16 (push-word (store-obj 'null-expr))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj place))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj adt-type))
                   (push-word (store-obj accessor-names)))))

(defmethod update-fetched ((obj null-expr))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions adt-type accessor-names
                      free-variables free-parameters pvs-sxhash-value
                      recognizer-name)
    obj
    (setf parens (fetch-obj (stored-word 1)))
    (setf type (fetch-obj (stored-word 2)))
    (setf place (fetch-obj (stored-word 3)))
    (setf mod-id (fetch-obj (stored-word 4)))
    (setf library (fetch-obj (stored-word 5)))
    (setf actuals (fetch-obj (stored-word 6)))
    (setf dactuals (fetch-obj (stored-word 7)))
    (setf acts-there? (fetch-obj (stored-word 8)))
    (setf dacts-there? (fetch-obj (stored-word 9)))
    (setf id (fetch-obj (stored-word 10)))
    (setf mappings (fetch-obj (stored-word 11)))
    (setf target (fetch-obj (stored-word 12)))
    (setf resolutions (fetch-obj (stored-word 13)))
    (setf adt-type (fetch-obj (stored-word 14)))
    (setf accessor-names (fetch-obj (stored-word 15)))
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)
    (setf pvs-sxhash-value nil)
    (setf recognizer-name nil)))

(defmethod restore-object* ((obj null-expr))
  (with-slots (type actuals dactuals acts-there? dacts-there? mappings
                    target resolutions adt-type accessor-names)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      (when adt-type
        (let ((*restore-object-parent-slot* 'adt-type))
          (restore-object* adt-type)))
      (when accessor-names
        (let ((*restore-object-parent-slot* 'accessor-names))
          (restore-object* accessor-names)))
      obj)))

(defmethod copy ((obj list-expr) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'list-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj list-expr))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'list-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj list-expr))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj list-expr))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj binding-application) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'binding-application :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj binding-application))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'binding-application))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj binding-application))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj binding-application))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj application) &rest initargs)
  (with-slots (place parens type operator argument)
    obj
    (make-instance 'application :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :operator
                   (let* ((get1 (getf initargs 'operator '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :operator '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) operator getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj application))
  (with-slots (place parens type operator argument)
    obj
    (reserve-space 6 (push-word (store-obj 'application))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj operator))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj application))
  (with-slots (place parens type operator argument pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf operator (fetch-obj (stored-word 4)))
    (setf argument (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj application))
  (with-slots (type operator argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when operator
        (let ((*restore-object-parent-slot* 'operator))
          (restore-object* operator)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj in-selection) &rest initargs)
  (with-slots (place constructor args expression index)
    obj
    (make-instance 'in-selection :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :constructor
                   (let* ((get1 (getf initargs 'constructor '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :constructor '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) constructor getfv))
                   :args
                   (let* ((get1 (getf initargs 'args '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :args '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) args getfv))
                   :expression
                   (let* ((get1 (getf initargs 'expression '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expression '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expression getfv))
                   :index
                   (let* ((get1 (getf initargs 'index '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :index '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) index getfv)))))

(defmethod store-object* ((obj in-selection))
  (with-slots (place constructor args expression index)
    obj
    (reserve-space 6 (push-word (store-obj 'in-selection))
                   (push-word (store-obj place))
                   (push-word (store-obj constructor))
                   (push-word (store-obj args))
                   (push-word (store-obj expression))
                   (push-word (store-obj index)))))

(defmethod update-fetched ((obj in-selection))
  (with-slots (place constructor args expression index
                     pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf constructor (fetch-obj (stored-word 2)))
    (setf args (fetch-obj (stored-word 3)))
    (setf expression (fetch-obj (stored-word 4)))
    (setf index (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj in-selection))
  (with-slots (constructor args expression)
    obj
    (let ((*restore-object-parent* obj))
      (when constructor
        (let ((*restore-object-parent-slot* 'constructor))
          (restore-object* constructor)))
      (when args
        (let ((*restore-object-parent-slot* 'args))
          (restore-object* args)))
      (when expression
        (let ((*restore-object-parent-slot* 'expression))
          (restore-object* expression)))
      obj)))

(defmethod copy ((obj unpack-expr) &rest initargs)
  (with-slots (place parens type expression selections else-part)
    obj
    (make-instance 'unpack-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :expression
                   (let* ((get1 (getf initargs 'expression '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expression '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expression getfv))
                   :selections
                   (let* ((get1 (getf initargs 'selections '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :selections '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) selections getfv))
                   :else-part
                   (let* ((get1 (getf initargs 'else-part '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :else-part '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) else-part getfv)))))

(defmethod store-object* ((obj unpack-expr))
  (with-slots (place parens type expression selections else-part)
    obj
    (reserve-space 7 (push-word (store-obj 'unpack-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj expression))
                   (push-word (store-obj selections))
                   (push-word (store-obj else-part)))))

(defmethod update-fetched ((obj unpack-expr))
  (with-slots (place parens type expression selections else-part
                     pvs-sxhash-value free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf expression (fetch-obj (stored-word 4)))
    (setf selections (fetch-obj (stored-word 5)))
    (setf else-part (fetch-obj (stored-word 6)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj unpack-expr))
  (with-slots (type expression selections else-part)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when expression
        (let ((*restore-object-parent-slot* 'expression))
          (restore-object* expression)))
      (when selections
        (let ((*restore-object-parent-slot* 'selections))
          (restore-object* selections)))
      (when else-part
        (let ((*restore-object-parent-slot* 'else-part))
          (restore-object* else-part)))
      obj)))

(defmethod copy ((obj selection) &rest initargs)
  (with-slots (place constructor args expression)
    obj
    (make-instance 'selection :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :constructor
                   (let* ((get1 (getf initargs 'constructor '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :constructor '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) constructor getfv))
                   :args
                   (let* ((get1 (getf initargs 'args '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :args '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) args getfv))
                   :expression
                   (let* ((get1 (getf initargs 'expression '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expression '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expression getfv)))))

(defmethod store-object* ((obj selection))
  (with-slots (place constructor args expression)
    obj
    (reserve-space 5 (push-word (store-obj 'selection))
                   (push-word (store-obj place))
                   (push-word (store-obj constructor))
                   (push-word (store-obj args))
                   (push-word (store-obj expression)))))

(defmethod update-fetched ((obj selection))
  (with-slots (place constructor args expression pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf constructor (fetch-obj (stored-word 2)))
    (setf args (fetch-obj (stored-word 3)))
    (setf expression (fetch-obj (stored-word 4)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj selection))
  (with-slots (constructor args expression)
    obj
    (let ((*restore-object-parent* obj))
      (when constructor
        (let ((*restore-object-parent-slot* 'constructor))
          (restore-object* constructor)))
      (when args
        (let ((*restore-object-parent-slot* 'args))
          (restore-object* args)))
      (when expression
        (let ((*restore-object-parent-slot* 'expression))
          (restore-object* expression)))
      obj)))

(defmethod copy ((obj cases-expr) &rest initargs)
  (with-slots (place parens type expression selections else-part)
    obj
    (make-instance 'cases-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :expression
                   (let* ((get1 (getf initargs 'expression '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :expression '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) expression getfv))
                   :selections
                   (let* ((get1 (getf initargs 'selections '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :selections '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) selections getfv))
                   :else-part
                   (let* ((get1 (getf initargs 'else-part '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :else-part '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) else-part getfv)))))

(defmethod store-object* ((obj cases-expr))
  (with-slots (place parens type expression selections else-part)
    obj
    (reserve-space 7 (push-word (store-obj 'cases-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj expression))
                   (push-word (store-obj selections))
                   (push-word (store-obj else-part)))))

(defmethod update-fetched ((obj cases-expr))
  (with-slots (place parens type expression selections else-part
                     pvs-sxhash-value free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf expression (fetch-obj (stored-word 4)))
    (setf selections (fetch-obj (stored-word 5)))
    (setf else-part (fetch-obj (stored-word 6)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj cases-expr))
  (with-slots (type expression selections else-part)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when expression
        (let ((*restore-object-parent-slot* 'expression))
          (restore-object* expression)))
      (when selections
        (let ((*restore-object-parent-slot* 'selections))
          (restore-object* selections)))
      (when else-part
        (let ((*restore-object-parent-slot* 'else-part))
          (restore-object* else-part)))
      obj)))

(defmethod copy ((obj record-expr) &rest initargs)
  (with-slots (place parens type assignments)
    obj
    (make-instance 'record-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :assignments
                   (let* ((get1 (getf initargs 'assignments '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :assignments '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) assignments getfv)))))

(defmethod store-object* ((obj record-expr))
  (with-slots (place parens type assignments)
    obj
    (reserve-space 5 (push-word (store-obj 'record-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj assignments)))))

(defmethod update-fetched ((obj record-expr))
  (with-slots (place parens type assignments pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf assignments (fetch-obj (stored-word 4)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj record-expr))
  (with-slots (type assignments)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when assignments
        (let ((*restore-object-parent-slot* 'assignments))
          (restore-object* assignments)))
      obj)))

(defmethod copy ((obj projected-arg-tuple-expr) &rest initargs)
  (with-slots (place parens type exprs)
    obj
    (make-instance 'projected-arg-tuple-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :exprs
                   (let* ((get1 (getf initargs 'exprs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :exprs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) exprs getfv)))))

(defmethod store-object* ((obj projected-arg-tuple-expr))
  (with-slots (place parens type exprs)
    obj
    (reserve-space 5 (push-word (store-obj 'projected-arg-tuple-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj exprs)))))

(defmethod update-fetched ((obj projected-arg-tuple-expr))
  (with-slots (place parens type exprs pvs-sxhash-value free-variables
                     free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf exprs (fetch-obj (stored-word 4)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj projected-arg-tuple-expr))
  (with-slots (type exprs)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when exprs
        (let ((*restore-object-parent-slot* 'exprs))
          (restore-object* exprs)))
      obj)))

(defmethod copy ((obj arg-tuple-expr) &rest initargs)
  (with-slots (place parens type exprs)
    obj
    (make-instance 'arg-tuple-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :exprs
                   (let* ((get1 (getf initargs 'exprs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :exprs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) exprs getfv)))))

(defmethod store-object* ((obj arg-tuple-expr))
  (with-slots (place parens type exprs)
    obj
    (reserve-space 5 (push-word (store-obj 'arg-tuple-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj exprs)))))

(defmethod update-fetched ((obj arg-tuple-expr))
  (with-slots (place parens type exprs pvs-sxhash-value free-variables
                     free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf exprs (fetch-obj (stored-word 4)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj arg-tuple-expr))
  (with-slots (type exprs)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when exprs
        (let ((*restore-object-parent-slot* 'exprs))
          (restore-object* exprs)))
      obj)))

(defmethod copy ((obj tuple-expr) &rest initargs)
  (with-slots (place parens type exprs)
    obj
    (make-instance 'tuple-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :exprs
                   (let* ((get1 (getf initargs 'exprs '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :exprs '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) exprs getfv)))))

(defmethod store-object* ((obj tuple-expr))
  (with-slots (place parens type exprs)
    obj
    (reserve-space 5 (push-word (store-obj 'tuple-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj exprs)))))

(defmethod update-fetched ((obj tuple-expr))
  (with-slots (place parens type exprs pvs-sxhash-value free-variables
                     free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf exprs (fetch-obj (stored-word 4)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj tuple-expr))
  (with-slots (type exprs)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when exprs
        (let ((*restore-object-parent-slot* 'exprs))
          (restore-object* exprs)))
      obj)))

(defmethod copy ((obj decimal-integer) &rest initargs)
  (with-slots (place parens type number fractional-length)
    obj
    (make-instance 'decimal-integer :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :number
                   (let* ((get1 (getf initargs 'number '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :number '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) number getfv))
                   :fractional-length
                   (let* ((get1
                           (getf initargs 'fractional-length '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :fractional-length
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf)
                         fractional-length
                       getfv)))))

(defmethod store-object* ((obj decimal-integer))
  (with-slots (place parens type number fractional-length)
    obj
    (reserve-space 6 (push-word (store-obj 'decimal-integer))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj number))
                   (push-word (store-obj fractional-length)))))

(defmethod update-fetched ((obj decimal-integer))
  (with-slots (place parens type number fractional-length
                     pvs-sxhash-value free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf number (fetch-obj (stored-word 4)))
    (setf fractional-length (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj decimal-integer))
  (with-slots (type)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      obj)))

(defmethod copy ((obj name-expr-from-number) &rest initargs)
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions number)
    obj
    (make-instance 'name-expr-from-number :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :number
                   (let* ((get1 (getf initargs 'number '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :number '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) number getfv)))))

(defmethod store-object* ((obj name-expr-from-number))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions number)
    obj
    (reserve-space 15 (push-word (store-obj 'name-expr-from-number))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj place))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj number)))))

(defmethod update-fetched ((obj name-expr-from-number))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions number free-variables free-parameters
                      pvs-sxhash-value)
    obj
    (setf parens (fetch-obj (stored-word 1)))
    (setf type (fetch-obj (stored-word 2)))
    (setf place (fetch-obj (stored-word 3)))
    (setf mod-id (fetch-obj (stored-word 4)))
    (setf library (fetch-obj (stored-word 5)))
    (setf actuals (fetch-obj (stored-word 6)))
    (setf dactuals (fetch-obj (stored-word 7)))
    (setf acts-there? (fetch-obj (stored-word 8)))
    (setf dacts-there? (fetch-obj (stored-word 9)))
    (setf id (fetch-obj (stored-word 10)))
    (setf mappings (fetch-obj (stored-word 11)))
    (setf target (fetch-obj (stored-word 12)))
    (setf resolutions (fetch-obj (stored-word 13)))
    (setf number (fetch-obj (stored-word 14)))
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj name-expr-from-number))
  (with-slots (type actuals dactuals acts-there? dacts-there? mappings
                    target resolutions number)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      (when number
        (let ((*restore-object-parent-slot* 'number))
          (restore-object* number)))
      obj)))

(defmethod copy ((obj number-expr-with-radix) &rest initargs)
  (with-slots (place parens type number radix)
    obj
    (make-instance 'number-expr-with-radix :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :number
                   (let* ((get1 (getf initargs 'number '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :number '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) number getfv))
                   :radix
                   (let* ((get1 (getf initargs 'radix '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :radix '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) radix getfv)))))

(defmethod store-object* ((obj number-expr-with-radix))
  (with-slots (place parens type number radix)
    obj
    (reserve-space 6 (push-word (store-obj 'number-expr-with-radix))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj number))
                   (push-word (store-obj radix)))))

(defmethod update-fetched ((obj number-expr-with-radix))
  (with-slots (place parens type number radix pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf number (fetch-obj (stored-word 4)))
    (setf radix (fetch-obj (stored-word 5)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj number-expr-with-radix))
  (with-slots (type radix)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when radix
        (let ((*restore-object-parent-slot* 'radix))
          (restore-object* radix)))
      obj)))

(defmethod copy ((obj number-expr) &rest initargs)
  (with-slots (place parens type number)
    obj
    (make-instance 'number-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :number
                   (let* ((get1 (getf initargs 'number '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :number '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) number getfv)))))

(defmethod store-object* ((obj number-expr))
  (with-slots (place parens type number)
    obj
    (reserve-space 5 (push-word (store-obj 'number-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj number)))))

(defmethod update-fetched ((obj number-expr))
  (with-slots (place parens type number pvs-sxhash-value free-variables
                     free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf number (fetch-obj (stored-word 4)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj number-expr))
  (with-slots (type)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      obj)))

(defmethod copy ((obj floatp-expr) &rest initargs)
  (with-slots (place parens type number)
    obj
    (make-instance 'floatp-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :number
                   (let* ((get1 (getf initargs 'number '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :number '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) number getfv)))))

(defmethod store-object* ((obj floatp-expr))
  (with-slots (place parens type number)
    obj
    (reserve-space 5 (push-word (store-obj 'floatp-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj number)))))

(defmethod update-fetched ((obj floatp-expr))
  (with-slots (place parens type number pvs-sxhash-value free-variables
                     free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf number (fetch-obj (stored-word 4)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj floatp-expr))
  (with-slots (type number)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when number
        (let ((*restore-object-parent-slot* 'number))
          (restore-object* number)))
      obj)))

(defmethod copy ((obj rational-expr) &rest initargs)
  (with-slots (place parens type number)
    obj
    (make-instance 'rational-expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :number
                   (let* ((get1 (getf initargs 'number '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :number '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) number getfv)))))

(defmethod store-object* ((obj rational-expr))
  (with-slots (place parens type number)
    obj
    (reserve-space 5 (push-word (store-obj 'rational-expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj number)))))

(defmethod update-fetched ((obj rational-expr))
  (with-slots (place parens type number pvs-sxhash-value free-variables
                     free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf number (fetch-obj (stored-word 4)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj rational-expr))
  (with-slots (type number)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when number
        (let ((*restore-object-parent-slot* 'number))
          (restore-object* number)))
      obj)))

(defmethod copy ((obj extraction-conversion) &rest initargs)
  (with-slots (place parens type id actuals dactuals index argument)
    obj
    (make-instance 'extraction-conversion :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :index
                   (let* ((get1 (getf initargs 'index '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :index '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) index getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj extraction-conversion))
  (with-slots (place parens type id actuals dactuals index argument)
    obj
    (reserve-space 9 (push-word (store-obj 'extraction-conversion))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj id))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj index))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj extraction-conversion))
  (with-slots (place parens type id actuals dactuals index argument
                     pvs-sxhash-value free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf actuals (fetch-obj (stored-word 5)))
    (setf dactuals (fetch-obj (stored-word 6)))
    (setf index (fetch-obj (stored-word 7)))
    (setf argument (fetch-obj (stored-word 8)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj extraction-conversion))
  (with-slots (type actuals dactuals argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj extraction-application) &rest initargs)
  (with-slots (place parens type id actuals dactuals index argument)
    obj
    (make-instance 'extraction-application :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :index
                   (let* ((get1 (getf initargs 'index '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :index '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) index getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj extraction-application))
  (with-slots (place parens type id actuals dactuals index argument)
    obj
    (reserve-space 9 (push-word (store-obj 'extraction-application))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj id))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj index))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj extraction-application))
  (with-slots (place parens type id actuals dactuals index argument
                     pvs-sxhash-value free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf actuals (fetch-obj (stored-word 5)))
    (setf dactuals (fetch-obj (stored-word 6)))
    (setf index (fetch-obj (stored-word 7)))
    (setf argument (fetch-obj (stored-word 8)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj extraction-application))
  (with-slots (type actuals dactuals argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj injection?-application) &rest initargs)
  (with-slots (place parens type id actuals dactuals index argument)
    obj
    (make-instance 'injection?-application :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :index
                   (let* ((get1 (getf initargs 'index '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :index '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) index getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj injection?-application))
  (with-slots (place parens type id actuals dactuals index argument)
    obj
    (reserve-space 9 (push-word (store-obj 'injection?-application))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj id))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj index))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj injection?-application))
  (with-slots (place parens type id actuals dactuals index argument
                     pvs-sxhash-value free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf actuals (fetch-obj (stored-word 5)))
    (setf dactuals (fetch-obj (stored-word 6)))
    (setf index (fetch-obj (stored-word 7)))
    (setf argument (fetch-obj (stored-word 8)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj injection?-application))
  (with-slots (type actuals dactuals argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj injection-conversion) &rest initargs)
  (with-slots (place parens type id actuals dactuals index argument)
    obj
    (make-instance 'injection-conversion :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :index
                   (let* ((get1 (getf initargs 'index '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :index '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) index getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj injection-conversion))
  (with-slots (place parens type id actuals dactuals index argument)
    obj
    (reserve-space 9 (push-word (store-obj 'injection-conversion))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj id))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj index))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj injection-conversion))
  (with-slots (place parens type id actuals dactuals index argument
                     pvs-sxhash-value free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf actuals (fetch-obj (stored-word 5)))
    (setf dactuals (fetch-obj (stored-word 6)))
    (setf index (fetch-obj (stored-word 7)))
    (setf argument (fetch-obj (stored-word 8)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj injection-conversion))
  (with-slots (type actuals dactuals argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj injection-application) &rest initargs)
  (with-slots (place parens type id actuals dactuals index argument)
    obj
    (make-instance 'injection-application :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :index
                   (let* ((get1 (getf initargs 'index '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :index '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) index getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj injection-application))
  (with-slots (place parens type id actuals dactuals index argument)
    obj
    (reserve-space 9 (push-word (store-obj 'injection-application))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj id))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj index))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj injection-application))
  (with-slots (place parens type id actuals dactuals index argument
                     pvs-sxhash-value free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf actuals (fetch-obj (stored-word 5)))
    (setf dactuals (fetch-obj (stored-word 6)))
    (setf index (fetch-obj (stored-word 7)))
    (setf argument (fetch-obj (stored-word 8)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj injection-application))
  (with-slots (type actuals dactuals argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj extraction-expr) &rest initargs)
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions adt-type index)
    obj
    (make-instance 'extraction-expr :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :adt-type
                   (let* ((get1 (getf initargs 'adt-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-type getfv))
                   :index
                   (let* ((get1 (getf initargs 'index '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :index '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) index getfv)))))

(defmethod store-object* ((obj extraction-expr))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions adt-type index)
    obj
    (reserve-space 16 (push-word (store-obj 'extraction-expr))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj place))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj adt-type))
                   (push-word (store-obj index)))))

(defmethod update-fetched ((obj extraction-expr))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions adt-type index free-variables
                      free-parameters pvs-sxhash-value)
    obj
    (setf parens (fetch-obj (stored-word 1)))
    (setf type (fetch-obj (stored-word 2)))
    (setf place (fetch-obj (stored-word 3)))
    (setf mod-id (fetch-obj (stored-word 4)))
    (setf library (fetch-obj (stored-word 5)))
    (setf actuals (fetch-obj (stored-word 6)))
    (setf dactuals (fetch-obj (stored-word 7)))
    (setf acts-there? (fetch-obj (stored-word 8)))
    (setf dacts-there? (fetch-obj (stored-word 9)))
    (setf id (fetch-obj (stored-word 10)))
    (setf mappings (fetch-obj (stored-word 11)))
    (setf target (fetch-obj (stored-word 12)))
    (setf resolutions (fetch-obj (stored-word 13)))
    (setf adt-type (fetch-obj (stored-word 14)))
    (setf index (fetch-obj (stored-word 15)))
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj extraction-expr))
  (with-slots (type actuals dactuals acts-there? dacts-there? mappings
                    target resolutions adt-type)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      (when adt-type
        (let ((*restore-object-parent-slot* 'adt-type))
          (restore-object* adt-type)))
      obj)))

(defmethod copy ((obj injection?-expr) &rest initargs)
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions adt-type index)
    obj
    (make-instance 'injection?-expr :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :adt-type
                   (let* ((get1 (getf initargs 'adt-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-type getfv))
                   :constructor-name
                   (let* ((get1
                           (getf initargs 'constructor-name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :constructor-name
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unit?
                   (let* ((get1 (getf initargs 'unit? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unit? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :index
                   (let* ((get1 (getf initargs 'index '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :index '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) index getfv)))))

(defmethod store-object* ((obj injection?-expr))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions adt-type index)
    obj
    (reserve-space 16 (push-word (store-obj 'injection?-expr))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj place))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj adt-type))
                   (push-word (store-obj index)))))

(defmethod update-fetched ((obj injection?-expr))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions adt-type index free-variables
                      free-parameters pvs-sxhash-value constructor-name
                      unit?)
    obj
    (setf parens (fetch-obj (stored-word 1)))
    (setf type (fetch-obj (stored-word 2)))
    (setf place (fetch-obj (stored-word 3)))
    (setf mod-id (fetch-obj (stored-word 4)))
    (setf library (fetch-obj (stored-word 5)))
    (setf actuals (fetch-obj (stored-word 6)))
    (setf dactuals (fetch-obj (stored-word 7)))
    (setf acts-there? (fetch-obj (stored-word 8)))
    (setf dacts-there? (fetch-obj (stored-word 9)))
    (setf id (fetch-obj (stored-word 10)))
    (setf mappings (fetch-obj (stored-word 11)))
    (setf target (fetch-obj (stored-word 12)))
    (setf resolutions (fetch-obj (stored-word 13)))
    (setf adt-type (fetch-obj (stored-word 14)))
    (setf index (fetch-obj (stored-word 15)))
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)
    (setf pvs-sxhash-value nil)
    (setf constructor-name nil)
    (setf unit? 'unbound)))

(defmethod restore-object* ((obj injection?-expr))
  (with-slots (type actuals dactuals acts-there? dacts-there? mappings
                    target resolutions adt-type)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      (when adt-type
        (let ((*restore-object-parent-slot* 'adt-type))
          (restore-object* adt-type)))
      obj)))

(defmethod copy ((obj injection-expr) &rest initargs)
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions adt-type index)
    obj
    (make-instance 'injection-expr :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :adt-type
                   (let* ((get1 (getf initargs 'adt-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-type getfv))
                   :recognizer-name
                   (let* ((get1
                           (getf initargs 'recognizer-name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :recognizer-name
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :accessor-names
                   (let* ((get1
                           (getf initargs 'accessor-names '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :accessor-names '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :index
                   (let* ((get1 (getf initargs 'index '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :index '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) index getfv)))))

(defmethod store-object* ((obj injection-expr))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions adt-type accessor-names index)
    obj
    (reserve-space 17 (push-word (store-obj 'injection-expr))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj place))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj adt-type))
                   (push-word (store-obj accessor-names))
                   (push-word (store-obj index)))))

(defmethod update-fetched ((obj injection-expr))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions adt-type accessor-names index
                      free-variables free-parameters pvs-sxhash-value
                      recognizer-name)
    obj
    (setf parens (fetch-obj (stored-word 1)))
    (setf type (fetch-obj (stored-word 2)))
    (setf place (fetch-obj (stored-word 3)))
    (setf mod-id (fetch-obj (stored-word 4)))
    (setf library (fetch-obj (stored-word 5)))
    (setf actuals (fetch-obj (stored-word 6)))
    (setf dactuals (fetch-obj (stored-word 7)))
    (setf acts-there? (fetch-obj (stored-word 8)))
    (setf dacts-there? (fetch-obj (stored-word 9)))
    (setf id (fetch-obj (stored-word 10)))
    (setf mappings (fetch-obj (stored-word 11)))
    (setf target (fetch-obj (stored-word 12)))
    (setf resolutions (fetch-obj (stored-word 13)))
    (setf adt-type (fetch-obj (stored-word 14)))
    (setf accessor-names (fetch-obj (stored-word 15)))
    (setf index (fetch-obj (stored-word 16)))
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)
    (setf pvs-sxhash-value nil)
    (setf recognizer-name nil)))

(defmethod restore-object* ((obj injection-expr))
  (with-slots (type actuals dactuals acts-there? dacts-there? mappings
                    target resolutions adt-type accessor-names)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      (when adt-type
        (let ((*restore-object-parent-slot* 'adt-type))
          (restore-object* adt-type)))
      (when accessor-names
        (let ((*restore-object-parent-slot* 'accessor-names))
          (restore-object* accessor-names)))
      obj)))

(defmethod copy ((obj projection-conversion) &rest initargs)
  (with-slots (place parens type id actuals dactuals index argument)
    obj
    (make-instance 'projection-conversion :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :index
                   (let* ((get1 (getf initargs 'index '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :index '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) index getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj projection-conversion))
  (with-slots (place parens type id actuals dactuals index argument)
    obj
    (reserve-space 9 (push-word (store-obj 'projection-conversion))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj id))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj index))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj projection-conversion))
  (with-slots (place parens type id actuals dactuals index argument
                     pvs-sxhash-value free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf actuals (fetch-obj (stored-word 5)))
    (setf dactuals (fetch-obj (stored-word 6)))
    (setf index (fetch-obj (stored-word 7)))
    (setf argument (fetch-obj (stored-word 8)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj projection-conversion))
  (with-slots (type actuals dactuals argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj projappl) &rest initargs)
  (with-slots (place parens type id actuals dactuals index argument)
    obj
    (make-instance 'projappl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :index
                   (let* ((get1 (getf initargs 'index '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :index '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) index getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj projappl))
  (with-slots (place parens type id actuals dactuals index argument)
    obj
    (reserve-space 9 (push-word (store-obj 'projappl))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj id))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj index))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj projappl))
  (with-slots (place parens type id actuals dactuals index argument
                     pvs-sxhash-value free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf actuals (fetch-obj (stored-word 5)))
    (setf dactuals (fetch-obj (stored-word 6)))
    (setf index (fetch-obj (stored-word 7)))
    (setf argument (fetch-obj (stored-word 8)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj projappl))
  (with-slots (type actuals dactuals argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj projection-application) &rest initargs)
  (with-slots (place parens type id actuals dactuals index argument)
    obj
    (make-instance 'projection-application :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :index
                   (let* ((get1 (getf initargs 'index '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :index '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) index getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj projection-application))
  (with-slots (place parens type id actuals dactuals index argument)
    obj
    (reserve-space 9 (push-word (store-obj 'projection-application))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj id))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj index))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj projection-application))
  (with-slots (place parens type id actuals dactuals index argument
                     pvs-sxhash-value free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf actuals (fetch-obj (stored-word 5)))
    (setf dactuals (fetch-obj (stored-word 6)))
    (setf index (fetch-obj (stored-word 7)))
    (setf argument (fetch-obj (stored-word 8)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj projection-application))
  (with-slots (type actuals dactuals argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj projex) &rest initargs)
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions index)
    obj
    (make-instance 'projex :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :index
                   (let* ((get1 (getf initargs 'index '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :index '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) index getfv)))))

(defmethod store-object* ((obj projex))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions index)
    obj
    (reserve-space 15 (push-word (store-obj 'projex))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj place))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj index)))))

(defmethod update-fetched ((obj projex))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions index free-variables free-parameters
                      pvs-sxhash-value)
    obj
    (setf parens (fetch-obj (stored-word 1)))
    (setf type (fetch-obj (stored-word 2)))
    (setf place (fetch-obj (stored-word 3)))
    (setf mod-id (fetch-obj (stored-word 4)))
    (setf library (fetch-obj (stored-word 5)))
    (setf actuals (fetch-obj (stored-word 6)))
    (setf dactuals (fetch-obj (stored-word 7)))
    (setf acts-there? (fetch-obj (stored-word 8)))
    (setf dacts-there? (fetch-obj (stored-word 9)))
    (setf id (fetch-obj (stored-word 10)))
    (setf mappings (fetch-obj (stored-word 11)))
    (setf target (fetch-obj (stored-word 12)))
    (setf resolutions (fetch-obj (stored-word 13)))
    (setf index (fetch-obj (stored-word 14)))
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj projex))
  (with-slots (type actuals dactuals acts-there? dacts-there? mappings
                    target resolutions)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      obj)))

(defmethod copy ((obj projection-expr) &rest initargs)
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions index)
    obj
    (make-instance 'projection-expr :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :index
                   (let* ((get1 (getf initargs 'index '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :index '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) index getfv)))))

(defmethod store-object* ((obj projection-expr))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions index)
    obj
    (reserve-space 15 (push-word (store-obj 'projection-expr))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj place))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj index)))))

(defmethod update-fetched ((obj projection-expr))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions index free-variables free-parameters
                      pvs-sxhash-value)
    obj
    (setf parens (fetch-obj (stored-word 1)))
    (setf type (fetch-obj (stored-word 2)))
    (setf place (fetch-obj (stored-word 3)))
    (setf mod-id (fetch-obj (stored-word 4)))
    (setf library (fetch-obj (stored-word 5)))
    (setf actuals (fetch-obj (stored-word 6)))
    (setf dactuals (fetch-obj (stored-word 7)))
    (setf acts-there? (fetch-obj (stored-word 8)))
    (setf dacts-there? (fetch-obj (stored-word 9)))
    (setf id (fetch-obj (stored-word 10)))
    (setf mappings (fetch-obj (stored-word 11)))
    (setf target (fetch-obj (stored-word 12)))
    (setf resolutions (fetch-obj (stored-word 13)))
    (setf index (fetch-obj (stored-word 14)))
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj projection-expr))
  (with-slots (type actuals dactuals acts-there? dacts-there? mappings
                    target resolutions)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      obj)))

(defmethod copy ((obj field-conversion) &rest initargs)
  (with-slots (place parens type id actuals dactuals argument)
    obj
    (make-instance 'field-conversion :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj field-conversion))
  (with-slots (place parens type id actuals dactuals argument)
    obj
    (reserve-space 8 (push-word (store-obj 'field-conversion))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj id))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj field-conversion))
  (with-slots (place parens type id actuals dactuals argument
                     pvs-sxhash-value free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf actuals (fetch-obj (stored-word 5)))
    (setf dactuals (fetch-obj (stored-word 6)))
    (setf argument (fetch-obj (stored-word 7)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj field-conversion))
  (with-slots (type actuals dactuals argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj fieldappl) &rest initargs)
  (with-slots (place parens type id actuals dactuals argument)
    obj
    (make-instance 'fieldappl :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj fieldappl))
  (with-slots (place parens type id actuals dactuals argument)
    obj
    (reserve-space 8 (push-word (store-obj 'fieldappl))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj id))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj fieldappl))
  (with-slots (place parens type id actuals dactuals argument
                     pvs-sxhash-value free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf actuals (fetch-obj (stored-word 5)))
    (setf dactuals (fetch-obj (stored-word 6)))
    (setf argument (fetch-obj (stored-word 7)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj fieldappl))
  (with-slots (type actuals dactuals argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj field-application) &rest initargs)
  (with-slots (place parens type id actuals dactuals argument)
    obj
    (make-instance 'field-application :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :argument
                   (let* ((get1 (getf initargs 'argument '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :argument '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) argument getfv)))))

(defmethod store-object* ((obj field-application))
  (with-slots (place parens type id actuals dactuals argument)
    obj
    (reserve-space 8 (push-word (store-obj 'field-application))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj id))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj argument)))))

(defmethod update-fetched ((obj field-application))
  (with-slots (place parens type id actuals dactuals argument
                     pvs-sxhash-value free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf actuals (fetch-obj (stored-word 5)))
    (setf dactuals (fetch-obj (stored-word 6)))
    (setf argument (fetch-obj (stored-word 7)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj field-application))
  (with-slots (type actuals dactuals argument)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when argument
        (let ((*restore-object-parent-slot* 'argument))
          (restore-object* argument)))
      obj)))

(defmethod copy ((obj accessor-name-expr) &rest initargs)
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions adt-type)
    obj
    (make-instance 'accessor-name-expr :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :adt-type
                   (let* ((get1 (getf initargs 'adt-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-type getfv)))))

(defmethod store-object* ((obj accessor-name-expr))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions adt-type)
    obj
    (reserve-space 15 (push-word (store-obj 'accessor-name-expr))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj place))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj adt-type)))))

(defmethod update-fetched ((obj accessor-name-expr))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions adt-type free-variables
                      free-parameters pvs-sxhash-value)
    obj
    (setf parens (fetch-obj (stored-word 1)))
    (setf type (fetch-obj (stored-word 2)))
    (setf place (fetch-obj (stored-word 3)))
    (setf mod-id (fetch-obj (stored-word 4)))
    (setf library (fetch-obj (stored-word 5)))
    (setf actuals (fetch-obj (stored-word 6)))
    (setf dactuals (fetch-obj (stored-word 7)))
    (setf acts-there? (fetch-obj (stored-word 8)))
    (setf dacts-there? (fetch-obj (stored-word 9)))
    (setf id (fetch-obj (stored-word 10)))
    (setf mappings (fetch-obj (stored-word 11)))
    (setf target (fetch-obj (stored-word 12)))
    (setf resolutions (fetch-obj (stored-word 13)))
    (setf adt-type (fetch-obj (stored-word 14)))
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj accessor-name-expr))
  (with-slots (type actuals dactuals acts-there? dacts-there? mappings
                    target resolutions adt-type)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      (when adt-type
        (let ((*restore-object-parent-slot* 'adt-type))
          (restore-object* adt-type)))
      obj)))

(defmethod copy ((obj recognizer-name-expr) &rest initargs)
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions adt-type)
    obj
    (make-instance 'recognizer-name-expr :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :adt-type
                   (let* ((get1 (getf initargs 'adt-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-type getfv))
                   :constructor-name
                   (let* ((get1
                           (getf initargs 'constructor-name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :constructor-name
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :unit?
                   (let* ((get1 (getf initargs 'unit? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :unit? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv)))))

(defmethod store-object* ((obj recognizer-name-expr))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions adt-type)
    obj
    (reserve-space 15 (push-word (store-obj 'recognizer-name-expr))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj place))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj adt-type)))))

(defmethod update-fetched ((obj recognizer-name-expr))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions adt-type free-variables
                      free-parameters pvs-sxhash-value constructor-name
                      unit?)
    obj
    (setf parens (fetch-obj (stored-word 1)))
    (setf type (fetch-obj (stored-word 2)))
    (setf place (fetch-obj (stored-word 3)))
    (setf mod-id (fetch-obj (stored-word 4)))
    (setf library (fetch-obj (stored-word 5)))
    (setf actuals (fetch-obj (stored-word 6)))
    (setf dactuals (fetch-obj (stored-word 7)))
    (setf acts-there? (fetch-obj (stored-word 8)))
    (setf dacts-there? (fetch-obj (stored-word 9)))
    (setf id (fetch-obj (stored-word 10)))
    (setf mappings (fetch-obj (stored-word 11)))
    (setf target (fetch-obj (stored-word 12)))
    (setf resolutions (fetch-obj (stored-word 13)))
    (setf adt-type (fetch-obj (stored-word 14)))
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)
    (setf pvs-sxhash-value nil)
    (setf constructor-name nil)
    (setf unit? 'unbound)))

(defmethod restore-object* ((obj recognizer-name-expr))
  (with-slots (type actuals dactuals acts-there? dacts-there? mappings
                    target resolutions adt-type)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      (when adt-type
        (let ((*restore-object-parent-slot* 'adt-type))
          (restore-object* adt-type)))
      obj)))

(defmethod copy ((obj constructor-name-expr) &rest initargs)
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions adt-type)
    obj
    (make-instance 'constructor-name-expr :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :adt-type
                   (let* ((get1 (getf initargs 'adt-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-type getfv))
                   :recognizer-name
                   (let* ((get1
                           (getf initargs 'recognizer-name '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :recognizer-name
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :accessor-names
                   (let* ((get1
                           (getf initargs 'accessor-names '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :accessor-names '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv)))))

(defmethod store-object* ((obj constructor-name-expr))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions adt-type accessor-names)
    obj
    (reserve-space 16 (push-word (store-obj 'constructor-name-expr))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj place))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj adt-type))
                   (push-word (store-obj accessor-names)))))

(defmethod update-fetched ((obj constructor-name-expr))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions adt-type accessor-names
                      free-variables free-parameters pvs-sxhash-value
                      recognizer-name)
    obj
    (setf parens (fetch-obj (stored-word 1)))
    (setf type (fetch-obj (stored-word 2)))
    (setf place (fetch-obj (stored-word 3)))
    (setf mod-id (fetch-obj (stored-word 4)))
    (setf library (fetch-obj (stored-word 5)))
    (setf actuals (fetch-obj (stored-word 6)))
    (setf dactuals (fetch-obj (stored-word 7)))
    (setf acts-there? (fetch-obj (stored-word 8)))
    (setf dacts-there? (fetch-obj (stored-word 9)))
    (setf id (fetch-obj (stored-word 10)))
    (setf mappings (fetch-obj (stored-word 11)))
    (setf target (fetch-obj (stored-word 12)))
    (setf resolutions (fetch-obj (stored-word 13)))
    (setf adt-type (fetch-obj (stored-word 14)))
    (setf accessor-names (fetch-obj (stored-word 15)))
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)
    (setf pvs-sxhash-value nil)
    (setf recognizer-name nil)))

(defmethod restore-object* ((obj constructor-name-expr))
  (with-slots (type actuals dactuals acts-there? dacts-there? mappings
                    target resolutions adt-type accessor-names)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      (when adt-type
        (let ((*restore-object-parent-slot* 'adt-type))
          (restore-object* adt-type)))
      (when accessor-names
        (let ((*restore-object-parent-slot* 'accessor-names))
          (restore-object* accessor-names)))
      obj)))

(defmethod copy ((obj adt-name-expr) &rest initargs)
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions adt-type)
    obj
    (make-instance 'adt-name-expr :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :adt-type
                   (let* ((get1 (getf initargs 'adt-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :adt-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) adt-type getfv)))))

(defmethod store-object* ((obj adt-name-expr))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions adt-type)
    obj
    (reserve-space 15 (push-word (store-obj 'adt-name-expr))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj place))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj adt-type)))))

(defmethod update-fetched ((obj adt-name-expr))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions adt-type free-variables
                      free-parameters pvs-sxhash-value)
    obj
    (setf parens (fetch-obj (stored-word 1)))
    (setf type (fetch-obj (stored-word 2)))
    (setf place (fetch-obj (stored-word 3)))
    (setf mod-id (fetch-obj (stored-word 4)))
    (setf library (fetch-obj (stored-word 5)))
    (setf actuals (fetch-obj (stored-word 6)))
    (setf dactuals (fetch-obj (stored-word 7)))
    (setf acts-there? (fetch-obj (stored-word 8)))
    (setf dacts-there? (fetch-obj (stored-word 9)))
    (setf id (fetch-obj (stored-word 10)))
    (setf mappings (fetch-obj (stored-word 11)))
    (setf target (fetch-obj (stored-word 12)))
    (setf resolutions (fetch-obj (stored-word 13)))
    (setf adt-type (fetch-obj (stored-word 14)))
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj adt-name-expr))
  (with-slots (type actuals dactuals acts-there? dacts-there? mappings
                    target resolutions adt-type)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      (when adt-type
        (let ((*restore-object-parent-slot* 'adt-type))
          (restore-object* adt-type)))
      obj)))

(defmethod copy ((obj fieldex) &rest initargs)
  (with-slots (place parens type id actuals dactuals)
    obj
    (make-instance 'fieldex :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv)))))

(defmethod store-object* ((obj fieldex))
  (with-slots (place parens type id actuals dactuals)
    obj
    (reserve-space 7 (push-word (store-obj 'fieldex))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj id))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals)))))

(defmethod update-fetched ((obj fieldex))
  (with-slots (place parens type id actuals dactuals pvs-sxhash-value
                     free-variables free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf id (fetch-obj (stored-word 4)))
    (setf actuals (fetch-obj (stored-word 5)))
    (setf dactuals (fetch-obj (stored-word 6)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj fieldex))
  (with-slots (type id actuals dactuals)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when id
        (let ((*restore-object-parent-slot* 'id))
          (restore-object* id)))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      obj)))

(defmethod copy ((obj field-name-expr) &rest initargs)
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions)
    obj
    (make-instance 'field-name-expr :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv)))))

(defmethod store-object* ((obj field-name-expr))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions)
    obj
    (reserve-space 14 (push-word (store-obj 'field-name-expr))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj place))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions)))))

(defmethod update-fetched ((obj field-name-expr))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions free-variables free-parameters
                      pvs-sxhash-value)
    obj
    (setf parens (fetch-obj (stored-word 1)))
    (setf type (fetch-obj (stored-word 2)))
    (setf place (fetch-obj (stored-word 3)))
    (setf mod-id (fetch-obj (stored-word 4)))
    (setf library (fetch-obj (stored-word 5)))
    (setf actuals (fetch-obj (stored-word 6)))
    (setf dactuals (fetch-obj (stored-word 7)))
    (setf acts-there? (fetch-obj (stored-word 8)))
    (setf dacts-there? (fetch-obj (stored-word 9)))
    (setf id (fetch-obj (stored-word 10)))
    (setf mappings (fetch-obj (stored-word 11)))
    (setf target (fetch-obj (stored-word 12)))
    (setf resolutions (fetch-obj (stored-word 13)))
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj field-name-expr))
  (with-slots (type actuals dactuals acts-there? dacts-there? mappings
                    target resolutions)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      obj)))

(defmethod copy ((obj typed-name-expr) &rest initargs)
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions declared-type)
    obj
    (make-instance 'typed-name-expr :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :declared-type
                   (let* ((get1
                           (getf initargs 'declared-type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :declared-type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) declared-type getfv)))))

(defmethod store-object* ((obj typed-name-expr))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions declared-type)
    obj
    (reserve-space 15 (push-word (store-obj 'typed-name-expr))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj place))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj declared-type)))))

(defmethod update-fetched ((obj typed-name-expr))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions declared-type free-variables
                      free-parameters pvs-sxhash-value)
    obj
    (setf parens (fetch-obj (stored-word 1)))
    (setf type (fetch-obj (stored-word 2)))
    (setf place (fetch-obj (stored-word 3)))
    (setf mod-id (fetch-obj (stored-word 4)))
    (setf library (fetch-obj (stored-word 5)))
    (setf actuals (fetch-obj (stored-word 6)))
    (setf dactuals (fetch-obj (stored-word 7)))
    (setf acts-there? (fetch-obj (stored-word 8)))
    (setf dacts-there? (fetch-obj (stored-word 9)))
    (setf id (fetch-obj (stored-word 10)))
    (setf mappings (fetch-obj (stored-word 11)))
    (setf target (fetch-obj (stored-word 12)))
    (setf resolutions (fetch-obj (stored-word 13)))
    (setf declared-type (fetch-obj (stored-word 14)))
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj typed-name-expr))
  (with-slots (type actuals dactuals acts-there? dacts-there? mappings
                    target resolutions declared-type)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      (when declared-type
        (let ((*restore-object-parent-slot* 'declared-type))
          (restore-object* declared-type)))
      obj)))

(defmethod copy ((obj theory-name-expr) &rest initargs)
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions)
    obj
    (make-instance 'theory-name-expr :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv)))))

(defmethod store-object* ((obj theory-name-expr))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions)
    obj
    (reserve-space 14 (push-word (store-obj 'theory-name-expr))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj place))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions)))))

(defmethod update-fetched ((obj theory-name-expr))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions free-variables free-parameters
                      pvs-sxhash-value)
    obj
    (setf parens (fetch-obj (stored-word 1)))
    (setf type (fetch-obj (stored-word 2)))
    (setf place (fetch-obj (stored-word 3)))
    (setf mod-id (fetch-obj (stored-word 4)))
    (setf library (fetch-obj (stored-word 5)))
    (setf actuals (fetch-obj (stored-word 6)))
    (setf dactuals (fetch-obj (stored-word 7)))
    (setf acts-there? (fetch-obj (stored-word 8)))
    (setf dacts-there? (fetch-obj (stored-word 9)))
    (setf id (fetch-obj (stored-word 10)))
    (setf mappings (fetch-obj (stored-word 11)))
    (setf target (fetch-obj (stored-word 12)))
    (setf resolutions (fetch-obj (stored-word 13)))
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj theory-name-expr))
  (with-slots (type actuals dactuals acts-there? dacts-there? mappings
                    target resolutions)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      obj)))

(defmethod copy ((obj name-expr) &rest initargs)
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions)
    obj
    (make-instance 'name-expr :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv)))))

(defmethod store-object* ((obj name-expr))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions)
    obj
    (reserve-space 14 (push-word (store-obj 'name-expr))
                   (push-word (store-obj parens))
                   (push-word (store-obj type))
                   (push-word (store-obj place))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions)))))

(defmethod update-fetched ((obj name-expr))
  (with-slots (parens type place mod-id library actuals dactuals
                      acts-there? dacts-there? id mappings target
                      resolutions free-variables free-parameters
                      pvs-sxhash-value)
    obj
    (setf parens (fetch-obj (stored-word 1)))
    (setf type (fetch-obj (stored-word 2)))
    (setf place (fetch-obj (stored-word 3)))
    (setf mod-id (fetch-obj (stored-word 4)))
    (setf library (fetch-obj (stored-word 5)))
    (setf actuals (fetch-obj (stored-word 6)))
    (setf dactuals (fetch-obj (stored-word 7)))
    (setf acts-there? (fetch-obj (stored-word 8)))
    (setf dacts-there? (fetch-obj (stored-word 9)))
    (setf id (fetch-obj (stored-word 10)))
    (setf mappings (fetch-obj (stored-word 11)))
    (setf target (fetch-obj (stored-word 12)))
    (setf resolutions (fetch-obj (stored-word 13)))
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj name-expr))
  (with-slots (type actuals dactuals acts-there? dacts-there? mappings
                    target resolutions)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      obj)))

(defmethod copy ((obj formula-name) &rest initargs)
  (with-slots (place library actuals dactuals acts-there? dacts-there?
                     id mappings target resolutions mod-id)
    obj
    (make-instance 'formula-name :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv))
                   :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv)))))

(defmethod store-object* ((obj formula-name))
  (with-slots (place library actuals dactuals acts-there? dacts-there?
                     id mappings target resolutions mod-id)
    obj
    (reserve-space 12 (push-word (store-obj 'formula-name))
                   (push-word (store-obj place))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions))
                   (push-word (store-obj mod-id)))))

(defmethod update-fetched ((obj formula-name))
  (with-slots (place library actuals dactuals acts-there? dacts-there?
                     id mappings target resolutions mod-id
                     pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf library (fetch-obj (stored-word 2)))
    (setf actuals (fetch-obj (stored-word 3)))
    (setf dactuals (fetch-obj (stored-word 4)))
    (setf acts-there? (fetch-obj (stored-word 5)))
    (setf dacts-there? (fetch-obj (stored-word 6)))
    (setf id (fetch-obj (stored-word 7)))
    (setf mappings (fetch-obj (stored-word 8)))
    (setf target (fetch-obj (stored-word 9)))
    (setf resolutions (fetch-obj (stored-word 10)))
    (setf mod-id (fetch-obj (stored-word 11)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj formula-name))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      obj)))

(defmethod copy ((obj name) &rest initargs)
  (with-slots (place mod-id library actuals dactuals acts-there?
                     dacts-there? id mappings target resolutions)
    obj
    (make-instance 'name :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :mod-id
                   (let* ((get1 (getf initargs 'mod-id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mod-id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mod-id getfv))
                   :library
                   (let* ((get1 (getf initargs 'library '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :library '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) library getfv))
                   :actuals
                   (let* ((get1 (getf initargs 'actuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :actuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) actuals getfv))
                   :dactuals
                   (let* ((get1 (getf initargs 'dactuals '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dactuals '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dactuals getfv))
                   :acts-there?
                   (let* ((get1 (getf initargs 'acts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :acts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) acts-there? getfv))
                   :dacts-there?
                   (let* ((get1 (getf initargs 'dacts-there? '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :dacts-there? '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) dacts-there? getfv))
                   :id
                   (let* ((get1 (getf initargs 'id '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :id '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) id getfv))
                   :mappings
                   (let* ((get1 (getf initargs 'mappings '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :mappings '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) mappings getfv))
                   :target
                   (let* ((get1 (getf initargs 'target '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :target '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) target getfv))
                   :resolutions
                   (let* ((get1 (getf initargs 'resolutions '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :resolutions '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) resolutions getfv)))))

(defmethod store-object* ((obj name))
  (with-slots (place mod-id library actuals dactuals acts-there?
                     dacts-there? id mappings target resolutions)
    obj
    (reserve-space 12 (push-word (store-obj 'name))
                   (push-word (store-obj place))
                   (push-word (store-obj mod-id))
                   (push-word (store-obj library))
                   (push-word (store-obj actuals))
                   (push-word (store-obj dactuals))
                   (push-word (store-obj acts-there?))
                   (push-word (store-obj dacts-there?))
                   (push-word (store-obj id))
                   (push-word (store-obj mappings))
                   (push-word (store-obj target))
                   (push-word (store-obj resolutions)))))

(defmethod update-fetched ((obj name))
  (with-slots (place mod-id library actuals dactuals acts-there?
                     dacts-there? id mappings target resolutions
                     pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf mod-id (fetch-obj (stored-word 2)))
    (setf library (fetch-obj (stored-word 3)))
    (setf actuals (fetch-obj (stored-word 4)))
    (setf dactuals (fetch-obj (stored-word 5)))
    (setf acts-there? (fetch-obj (stored-word 6)))
    (setf dacts-there? (fetch-obj (stored-word 7)))
    (setf id (fetch-obj (stored-word 8)))
    (setf mappings (fetch-obj (stored-word 9)))
    (setf target (fetch-obj (stored-word 10)))
    (setf resolutions (fetch-obj (stored-word 11)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj name))
  (with-slots (actuals dactuals acts-there? dacts-there? mappings
                       target resolutions)
    obj
    (let ((*restore-object-parent* obj))
      (when actuals
        (let ((*restore-object-parent-slot* 'actuals))
          (restore-object* actuals)))
      (when dactuals
        (let ((*restore-object-parent-slot* 'dactuals))
          (restore-object* dactuals)))
      (when acts-there?
        (let ((*restore-object-parent-slot* 'acts-there?))
          (restore-object* acts-there?)))
      (when dacts-there?
        (let ((*restore-object-parent-slot* 'dacts-there?))
          (restore-object* dacts-there?)))
      (when mappings
        (let ((*restore-object-parent-slot* 'mappings))
          (restore-object* mappings)))
      (when target
        (let ((*restore-object-parent-slot* 'target))
          (restore-object* target)))
      (when resolutions
        (let ((*restore-object-parent-slot* 'resolutions))
          (restore-object* resolutions)))
      obj)))

(defmethod copy ((obj expr) &rest initargs)
  (with-slots (place parens type)
    obj
    (make-instance 'expr :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv))
                   :parens
                   (let* ((get1 (getf initargs 'parens '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :parens '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) parens getfv))
                   :type
                   (let* ((get1 (getf initargs 'type '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :type '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) type getfv))
                   :free-variables
                   (let* ((get1
                           (getf initargs 'free-variables '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :free-variables '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv))
                   :free-parameters
                   (let* ((get1
                           (getf initargs 'free-parameters '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :free-parameters
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) 'unbound getfv)))))

(defmethod store-object* ((obj expr))
  (with-slots (place parens type)
    obj
    (reserve-space 4 (push-word (store-obj 'expr))
                   (push-word (store-obj place))
                   (push-word (store-obj parens))
                   (push-word (store-obj type)))))

(defmethod update-fetched ((obj expr))
  (with-slots (place parens type pvs-sxhash-value free-variables
                     free-parameters)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf parens (fetch-obj (stored-word 2)))
    (setf type (fetch-obj (stored-word 3)))
    (setf pvs-sxhash-value nil)
    (setf free-variables 'unbound)
    (setf free-parameters 'unbound)))

(defmethod restore-object* ((obj expr))
  (with-slots (type)
    obj
    (let ((*restore-object-parent* obj))
      (when type
        (let ((*restore-object-parent-slot* 'type))
          (restore-object* type)))
      obj)))

(defmethod copy ((obj syntax) &rest initargs)
  (with-slots (place)
    obj
    (make-instance 'syntax :place
                   (let* ((get1 (getf initargs 'place '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf initargs :place '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) place getfv))
                   :pvs-sxhash-value
                   (let* ((get1
                           (getf initargs 'pvs-sxhash-value '%nogetf))
                          (getfv
                           (if (eq get1 '%nogetf)
                               (getf
                                initargs
                                :pvs-sxhash-value
                                '%nogetf)
                             get1)))
                     (if (eq getfv '%nogetf) nil getfv)))))

(defmethod store-object* ((obj syntax))
  (with-slots (place)
    obj
    (reserve-space 2 (push-word (store-obj 'syntax))
                   (push-word (store-obj place)))))

(defmethod update-fetched ((obj syntax))
  (with-slots (place pvs-sxhash-value)
    obj
    (setf place (fetch-obj (stored-word 1)))
    (setf pvs-sxhash-value nil)))

(defmethod restore-object* ((obj syntax))
  (with-slots nil obj (let ((*restore-object-parent* obj)) obj)))